LIB "tst.lib";
tst_init();
// crash in syzygies over Z (finalReduceByMon)
option(noredefine);option(redSB);LIB "matrix.lib";LIB "primdec.lib";LIB "primdecint.lib";LIB "involut.lib";LIB "finvar.lib";
int h_variable_i; int h_variable_j; int h_variable_k; list h_variable_l; string h_variable_s;
proc IsDiagonalMatrix (matrix m)
{
  int min=nrows(m);
  if (min>ncols(m))
  {
    min=ncols(m);
  }
  matrix z[nrows(m)][ncols(m)];
  matrix c = m;
  for (int i=1; i<=min; i++)
  {
    c[i,i]=0;
  }
  return(c==z);
}
proc ZeroRows (module m)
{
  list l;
  int s = 1;
  for (int i=1;i<=ncols(m);i++)
  {
    if (m[i]==0)
    {
      l[s]=i; s++;
    }
  }
  if (size(l)==0)
  {
    return("[]"));
  }
  return(string(l));
}
proc ZeroColumns (matrix n)
{
  matrix m=module(transpose(n));
  list l;
  int s = 1;
  for (int i=1;i<=ncols(m);i++)
  {
    if (m[i]==0)
    {
      l[s]=i; s++;
    }
  }
  if (size(l)==0)
  {
    return("[]"));
  }
  return(string(l));
}
proc PositionOfFirstNonZeroEntryPerRow (matrix M)
{
  int b = 1;
  intmat m[1][ncols(M)];
  for (int i=1; i<=ncols(M); i++)
  {
    for (int j=1; j<=nrows(M); j++)
    {
      if ( M[j,i] <> 0 ) { m[1,i] = j; break; }
    }
    if ( b && i > 1 ) { if ( m[1,i] <> m[1,i-1] ) { b = 0; } } // Singular is strange
  }
  if ( b ) { return(m[1,1]); } else { return(m); }
}
proc PositionOfFirstNonZeroEntryPerColumn (matrix M)
{
  int b = 1;
  intmat m[1][nrows(M)];
  for (int j=1; j<=nrows(M); j++)
  {
    for (int i=1; i<=ncols(M); i++)
    {
      if ( M[j,i] <> 0 ) { m[1,j] = i; break; }
    }
    if ( b && j > 1 ) { if ( m[1,j] <> m[1,j-1] ) { b = 0; } } // Singular is strange
  }
  if ( b ) { return(m[1,1]); } else { return(m); }
}
proc IndicatorMatrixOfNonZeroEntries(matrix M)
{
  intmat m[ncols(M)][nrows(M)];
  for (int i=1; i<=ncols(M); i++)
  {
    for (int j=1; j<=nrows(M); j++)
    {
      m[i,j] = ( M[j,i] <> 0 );
    }
  }
  return(m);
}
proc MatrixOfSymbols (matrix m)
{
  int i; int j; poly e;
  int r=nrows(m);
  int c=ncols(m);
  matrix n[r][c]=0;
  for(i=1;i<=r;i++)
  {
    for(j=1;j<=c;j++)
    {
      e=m[i,j];
      if(e!=0)
      { n[i,j]=e-jet(e,deg(e)-1); }
    }
  }
  return(n);
}
proc BasisOfRowModule (matrix M)
{
  return(std(M));
}
proc BasisOfColumnModule (matrix M)
{
  return(Involution(BasisOfRowModule(Involution(M))));
}
proc SyzygiesGeneratorsOfRows (matrix M)
{
  return(SyzForHomalg(M));
}
proc SyzygiesGeneratorsOfColumns (matrix M)
{
  return(Involution(SyzForHomalg(Involution(M))));
}
proc ReducedSyzygiesGeneratorsOfRows (matrix M)
{
  return(ReducedSyzForHomalg(M));
}
proc ReducedSyzygiesGeneratorsOfColumns (matrix M)
{
  return(Involution(ReducedSyzForHomalg(Involution(M))));
}
proc BasisOfRowsCoeff (matrix M)
{
  matrix B = BasisOfRowModule(M);
  matrix T = lift(M,B);
  list l = B,T;
  return(l)
}
proc BasisOfColumnsCoeff (matrix M)
{
  list l = BasisOfRowsCoeff(Involution(M));
  matrix B = l[1];
  matrix T = l[2];
  l = Involution(B),Involution(T);
  return(l);
}
proc DecideZeroRows (matrix A, module B)
{
  attrib(B,"isSB",1);
  return(reduce(A,B));
}
proc DecideZeroColumns (matrix A, matrix B)
{
  return(Involution(DecideZeroRows(Involution(A),Involution(B))));
}
proc DecideZeroRowsEffectively (matrix A, module B)
{
  attrib(B,"isSB",1);
  matrix M = reduce(A,B);
  matrix T = lift(B,M-A);
  list l = M,T;
  return(l);
}
proc DecideZeroColumnsEffectively (matrix A, matrix B)
{
  list l = DecideZeroRowsEffectively(Involution(A),Involution(B));
  matrix B = l[1];
  matrix T = l[2];
  l = Involution(B),Involution(T);
  return(l);
}
proc RelativeSyzygiesGeneratorsOfRows (matrix M1, matrix M2)
{
  return(BasisOfRowModule(modulo(M1, M2)));
}
proc RelativeSyzygiesGeneratorsOfColumns (matrix M1, matrix M2)
{
  return(Involution(RelativeSyzygiesGeneratorsOfRows(Involution(M1),Involution(M2))));
}
proc PartiallyReducedBasisOfRowModule (matrix M)
{
  return(mstd(M)[2]);
}
proc PartiallyReducedBasisOfColumnModule (matrix M)
{
  return(Involution(PartiallyReducedBasisOfRowModule(Involution(M))));
}
proc IsZeroMatrix (matrix m)
{
  matrix z[nrows(m)][ncols(m)];
  return(m==z);
}
proc IsIdentityMatrix (matrix m)
{
  return(m==unitmat(nrows(m)));
}
proc GetColumnIndependentUnitPositions (matrix M, list pos_list)
{
  int m = nrows(M);
  int n = ncols(M);
  list rest;
  intvec tmp = 1..m;
  rest = tmp[1..m];
  int r = m;
  list rest2;
  list pos;
  int i; int k; int a; int s = 1; int s2;
  for (int j=1; j<=n; j++)
  {
    for (i=r; i>0; i--)
    {
      k = rest[i];
      if (deg(M[k,j]) == 0) //IsUnit
      {
        rest2 = list();
        s2 = 1;
        pos[s] = list(j,k); s++;
        for (a=1; a<=r; a++)
        {
          if (M[rest[a],j] == 0)
          {
            rest2[s2] = rest[a]; s2++;
          }
        }
        rest = rest2;
        r = size(rest);
        break;
      }
    }
  }
  return(string(pos));
}
proc GetRowIndependentUnitPositions (matrix M, list pos_list)
{
  int m = nrows(M);
  int n = ncols(M);
  list rest;
  for (int o=n; o>=1; o--)
  {
    rest[o] = o;
  }
  int r = n;
  list e;
  list rest2;
  list pos;
  int j; int k; int a; int s = 1;
  for (int i=1; i<=m; i++)
  {
    for (j=1; j<=r; j++)
    {
      k = rest[r-j+1];
      if (deg(M[i,k]) == 0) //IsUnit
      {
        rest2 = e;
        pos[s] = list(i,k); s++;
        for (a=1; a<=r; a++)
        {
          if (M[i,rest[a]] == 0)
          {
            rest2[size(rest2)+1] = rest[a];
          }
        }
        rest = rest2;
        r = size(rest);
        break;
      }
    }
  }
  return(string(pos));
}
proc GetUnitPosition (matrix M, list pos_list)
{
  int m = nrows(M);
  int n = ncols(M);
  int r;
  list rest;
  for (int o=m; o>=1; o--)
  {
    rest[o] = o;
  }
  rest=Difference(rest,pos_list);
  r=size(rest);
  for (int j=1; j<=n; j++)
  {
    for (int i=1; i<=r; i++)
    {
      if (deg(M[rest[i],j]) == 0) //IsUnit
      {
        return(string(j,",",rest[i])); // this is not a mistake
      }
    }
  }
  return("fail");
}
proc GetCleanRowsPositions (matrix m, list l)
{
  list rows;
  int s = 1;
  for (int i=1;i<=size(l);i++)
  {
    for (int j=1;j<=ncols(m);j++)
    {
      if (m[l[i],j]==1)
      {
        rows[s] = j; s++;
        break;
      }
    }
  }
  if (s==0)
  {
    return("[]"));
  }
  return(string(rows));
}
proc EvaluateMatrix( matrix M, list l )
{
    int r, c, i, j;
    r = nrows( M );
    c = ncols( M );
    matrix N[ r ][ c ];
    for ( i = 1; i <= r; i++ ){
        for ( j = 1; j <= c; j++ ){
            N[ i, j ] = subst( M[ i, j ], l[ 1 .. size( l ) ] );}}
    return ( N );
}
proc NumeratorAndDenominatorOfPolynomial( poly f )
{
    poly numer, denom;
    denom = coeffs( cleardenom ( var(1)*f+1 ), var(1) )[ 1, 1 ];
    numer = f * denom;
    return( numer, denom );
}
proc Diff (matrix m, matrix n) // following the Macaulay2 convention
{
  int f = nrows(m);
  int p = ncols(m);
  int g = nrows(n);
  int q = ncols(n);
  matrix h[f*g][p*q]=0;
  for (int i=1; i<=f; i=i+1)
    {
    for (int j=1; j<=g; j=j+1)
      {
      for (int k=1; k<=p; k=k+1)
        {
        for (int l=1; l<=q; l=l+1)
          {
            h[g*(i-1)+j,q*(k-1)+l] = diff( ideal(m[i,k]), ideal(n[j,l]) )[1,1];
          }
        }
      }
    }
  return(h)
}
proc GetSparseListOfHomalgMatrixAsString (M)
{
  list l;int k;
  k = 1;
  for(int i=1; i<=ncols(M); i++){
    for(int j=1; j<=nrows(M); j++){
      def p=M[j,i]; // remark: matrices are saved transposed in Singular
      if(p!=0){l[k]=list(i,j,p); k++;};
    };
  };
  return(string(l));
}
proc PrimaryDecomposition (matrix m)
{
  return(primdecSY(m))
}
proc IsMemberOfList (int i, list l)
{
  int k = size(l);
  for (int p=1; p<=k; p++)
  {
    if (l[p]==i)
    {
      return(1); // this is not a mistake
    }
  }
  return(0);
}
proc Difference (list a, list b)
{
  list c;
  int s=size(a);
  int l = 1;
  for (int p=1; p<=s; p++)
  {
    if (IsMemberOfList(a[p],b)==0)
    {
      c[l] = a[p]; l++;
    }
  }
  return(c);
}
proc CreateListListOfIntegers (degrees,m,n)
{
  list l;
  for (int i=m; i>=1; i--)
  {
    l[i]=intvec(degrees[(i-1)*n+1..i*n]);
  }
  return(l);
}
proc GetColumnIndependentUnitPositions_Z (matrix M, list pos_list)
{
  int m = nrows(M);
  int n = ncols(M);
  list rest;
  for (int o=m; o>=1; o--)
  {
    rest[o] = o;
  }
  int r = m;
  list e;
  list rest2;
  list pos;
  int i; int k; int a; int s = 1;
  for (int j=1; j<=n; j++)
  {
    for (i=1; i<=r; i++)
    {
      k = rest[r-i+1];
      if (M[k,j] == 1 || M[k,j] == -1) //IsUnit
      {
        rest2 = e;
        pos[s] = list(j,k); s++;
        for (a=1; a<=r; a++)
        {
          if (M[rest[a],j] == 0)
          {
            rest2[size(rest2)+1] = rest[a];
          }
        }
        rest = rest2;
        r = size(rest);
        break;
      }
    }
  }
  return(string(pos));
}
proc GetRowIndependentUnitPositions_Z (matrix M, list pos_list)
{
  int m = nrows(M);
  int n = ncols(M);
  list rest;
  for (int o=n; o>=1; o--)
  {
    rest[o] = o;
  }
  int r = n;
  list e;
  list rest2;
  list pos;
  int j; int k; int a; int s = 1;
  for (int i=1; i<=m; i++)
  {
    for (j=1; j<=r; j++)
    {
      k = rest[r-j+1];
      if (M[i,k] == 1 || M[i,k] == -1) //IsUnit
      {
        rest2 = e;
        pos[s] = list(i,k); s++;
        for (a=1; a<=r; a++)
        {
          if (M[i,rest[a]] == 0)
          {
            rest2[size(rest2)+1] = rest[a];
          }
        }
        rest = rest2;
        r = size(rest);
        break;
      }
    }
  }
  return(string(pos));
}
proc GetUnitPosition_Z (matrix M, list pos_list)
{
  int m = nrows(M);
  int n = ncols(M);
  int r;
  list rest;
  for (int o=m; o>=1; o--)
  {
    rest[o] = o;
  }
  rest=Difference(rest,pos_list);
  r=size(rest);
  for (int j=1; j<=n; j++)
  {
    for (int i=1; i<=r; i++)
    {
      if (M[rest[i],j] == 1 || M[rest[i],j] == -1) //IsUnit
      {
        return(string(j,",",rest[i])); // this is not a mistake
      }
    }
  }
  return("fail");
}
proc SyzForHomalg (matrix M)
{
  return(syz(M));
}
proc ReducedSyzForHomalg (matrix M)
{
  return(matrix(nres(M,2)[2]));
}
if ( defined(superCommutative) == 1 ) // the new name of the SCA constructor
{ proc superCommutative_ForHomalg = superCommutative; }
else
{
  if ( defined(SuperCommutative) == 1 ) // the old name of the SCA constructor
  { proc superCommutative_ForHomalg = SuperCommutative; }
}
proc CoefficientsOfUnreducedNumeratorOfWeightedHilbertPoincareSeries (module m,weights,degrees)
{
  module M = std(m);
  attrib(M,"isHomog",degrees);
  return(hilb(M,1,weights));
}
proc PrimaryDecomposition_Z (matrix m)
{
  return(primdecZ(m))
}
// start: a workaround for a bug in the 64 bit versions of Singular 3-0-4
if ( defined( basering ) != 0 )
{
  def h_variable_basering = basering;
}
ring r;
if ( deg(0,(1,1,1)) > 0 )
{ proc Deg (pol,weights)
  {
    if ( pol == 0 )
    {
      return(deg(0));
    }
    return(deg(pol,weights));
  }
}
else
{ proc Deg (pol,weights)
  {
    return(deg(pol,weights));
  }
}
kill r;
if ( defined( h_variable_basering ) != 0 )
{
  setring h_variable_basering;
}
// end: a workaround for a bug in the 64 bit versions of Singular 3-0-4
// deg(lead()) instead of deg() below works around a bug
proc h_Symbol (poly e)
{
  if(e==0) {return(e);}
  poly l=lead(e);
  int d=deg(l);
  poly s=l;
  poly r=e-l;
  l=lead(r);
  while(deg(l)==d)
  {
    s=s+l;
    r=r-l;
    l=lead(r);
  }
  return(s);
}
proc MatrixOfSymbols_workaround (matrix m)
{
  int i; int j; poly e;
  int r=nrows(m);
  int c=ncols(m);
  matrix n[r][c]=0;
  for(i=1;i<=r;i++)
  {
    for(j=1;j<=c;j++)
    {
      e=m[i,j];
      if(e!=0)
      { n[i,j]=h_Symbol(e); }
    }
  }
  return(n);
}
proc NumeratorAndDenominatorOfRational( poly f )
{
    number r = number(f);
    return( numerator(r), denominator(r) );
}
proc PolynomialExponentsAndCoefficients (poly p)
{
  int len = size( p );
  list ret_array = list();
  list exponents = list();
  list coefficients = list();
  for(int i = 1; i <= len; i=i+1 )
  {
    exponents[ i ] = leadexp( p[ i ] );
    coefficients[ i ] = leadcoef( p[ i ] );
  }
  ret_array[ 1 ] = exponents;
  ret_array[ 2 ] = coefficients;
  return(ret_array);
}
proc DegreesOfEntries (matrix M)
{
  intmat m[ncols(M)][nrows(M)];
  for (int i=1; i<=ncols(M); i++)
  {
    for (int j=1; j<=nrows(M); j++)
    {
      m[i,j] = deg(M[j,i]);
    }
  }
  return(m);
}
proc LinearSyzygiesGeneratorsOfRows(m)
{
  return(LinSyzForHomalg(m))
}
proc LinearSyzygiesGeneratorsOfColumns(m)
{
  return(Involution(LinSyzForHomalg(Involution(m))));
}
proc WeightedDegreesOfEntries (matrix M, weights)
{
  intmat m[ncols(M)][nrows(M)];
  for (int i=1; i<=ncols(M); i++)
  {
    for (int j=1; j<=nrows(M); j++)
    {
      m[i,j] = Deg(M[j,i],weights);
    }
  }
  return(m);
}
proc NonTrivialDegreePerRowWithColPosition(matrix M)
{
  intmat m[2][ncols(M)];
  poly e;
  for (int i=1; i<=ncols(M); i++)
  {
    for (int j=1; j<=nrows(M); j++)
    {
      e = M[j,i];
      if ( e <> 0 ) { m[1,i] = deg(e); m[2,i] = j; break; }
    }
  }
  return(m);
}
proc NonTrivialWeightedDegreePerRowWithColPosition(matrix M, weights)
{
  intmat m[2][ncols(M)];
  poly e;
  for (int i=1; i<=ncols(M); i++)
  {
    for (int j=1; j<=nrows(M); j++)
    {
      e = M[j,i];
      if ( e <> 0 ) { m[1,i] = Deg(e,weights); m[2,i] = j; break; }
    }
  }
  return(m);
}
proc NonTrivialDegreePerColumnWithRowPosition (matrix M)
{
  intmat m[2][nrows(M)];
  poly e;
  for (int j=1; j<=nrows(M); j++)
  {
    for (int i=1; i<=ncols(M); i++)
    {
      e = M[j,i];
      if ( e <> 0 ) { m[1,j] = deg(e); m[2,j] = i; break; }
    }
  }
  return(m);
}
proc NonTrivialWeightedDegreePerColumnWithRowPosition (matrix M, weights)
{
  intmat m[2][nrows(M)];
  poly e;
  for (int j=1; j<=nrows(M); j++)
  {
    for (int i=1; i<=ncols(M); i++)
    {
      e = M[j,i];
      if ( e <> 0 ) { m[1,j] = Deg(e,weights); m[2,j] = i; break; }
    }
  }
  return(m);
}
proc MultiDeg (pol,weights)
{
  int mul=size(weights);
  intmat m[1][mul];
  for (int i=1; i<=mul; i++)
  {
    m[1,i]=Deg(pol,weights[i]);
  }
  return(m);
}
proc MultiDegOfMatrixEntry (matrix M,weights,row,col)
{
  int mul=size(weights);
  intmat m[1][mul];
  for (int i=1; i<=mul; i++)
  {
    m[1,i]=Deg(M[row,col],weights[i]);
  }
  return(m);
}
proc LinSyzForHomalg(matrix m)
{
  def save=degBound;
  degBound=1; // it will be a disaster if degBound=0 below is not reached
  def r = res(m,2);
  degBound=save; // puh ...
  return(r[2]);
}
// start: check degBound in SCA:
if ( defined( basering ) != 0 )
{
  def h_variable_basering = basering;
}
ring h_Exterior_1 = 0,(e0,e1),dp;
def h_Exterior_2 = superCommutative_ForHomalg(1);
setring h_Exterior_2;
option(redTail);short=0;
matrix h_Exterior_3[3][2] = e0,0,e1,e0,0,e1;
matrix h_Exterior_4=LinSyzForHomalg(h_Exterior_3);
if (ncols(h_Exterior_4) == 1 && h_Exterior_4[1,1] <> 0 && h_Exterior_4[2,1] <> 0)
{
  def LinSyzForHomalgExterior = 1;
}
kill h_Exterior_4; kill h_Exterior_3; kill h_Exterior_2; kill h_Exterior_1;
if ( defined( h_variable_basering ) != 0 )
{
  setring h_variable_basering;
}
// end: check degBound in SCA.
ring h_variable_1 = (integer),dummy_variable,dp;
number h_variable_2 = 0;
number h_variable_3 = 1;
number h_variable_4 = -1;
setring h_variable_1;
short=0;option(redTail);
proc Involution (matrix m)
{
  return(transpose(m));
}
ring h_variable_5 = (integer),(a7),dp;
setring h_variable_5;
short=0;option(redTail);
number h_variable_6 = 0;
number h_variable_7 = 1;
number h_variable_8 = -1;
poly h_variable_9 = a7;
h_variable_9;
proc Involution (matrix m)
{
  return(transpose(m));
}
poly h_variable_10 = 6;
poly h_variable_11 = a7^2-a7+1;
h_variable_10;
h_variable_11;
matrix h_variable_12[2][1] = 6,a7^2-a7+1;
h_variable_12 = transpose(h_variable_12);
def h_variable_13 = h_variable_12[1,1];
def h_variable_14 = h_variable_12[1,2];
h_variable_13;
h_variable_14;
matrix h_variable_15[9][3] = 1,0,0,0,1,0,1,1,0,0,0,1,1,0,1,0,1,a7-1,1,-a7+1,a7,1,-a7+1,1,1,1,a7;
h_variable_15 = transpose(h_variable_15);
ring h_variable_16 = (integer),(a7,x1,x2,x3),dp;
setring h_variable_16;
short=0;option(redTail);
number h_variable_17 = 0;
number h_variable_18 = 1;
number h_variable_19 = -1;
poly h_variable_20 = a7;
poly h_variable_21 = x1;
poly h_variable_22 = x2;
poly h_variable_23 = x3;
h_variable_20;
h_variable_21;
h_variable_22;
h_variable_23;
setring h_variable_5;
short=0;option(redTail);
proc Involution (matrix m)
{
  return(transpose(m));
}
ring h_variable_24 = (integer),(x1,x2,x3,a7),(dp(3),dp);
setring h_variable_24;
short=0;option(redTail);
number h_variable_25 = 0;
number h_variable_26 = 1;
number h_variable_27 = -1;
poly h_variable_28 = a7;
poly h_variable_29 = x1;
poly h_variable_30 = x2;
poly h_variable_31 = x3;
h_variable_28;
h_variable_29;
h_variable_30;
h_variable_31;
proc Involution (matrix m)
{
  return(transpose(m));
}
setring h_variable_5;
short=0;option(redTail);
proc Involution (matrix m)
{
  return(transpose(m));
}
ring h_variable_32 = (integer),(x1,x2,x3,a7),lp;
setring h_variable_32;
short=0;option(redTail);
number h_variable_33 = 0;
number h_variable_34 = 1;
number h_variable_35 = -1;
poly h_variable_36 = a7;
poly h_variable_37 = x1;
poly h_variable_38 = x2;
poly h_variable_39 = x3;
h_variable_36;
h_variable_37;
h_variable_38;
h_variable_39;
proc Involution (matrix m)
{
  return(transpose(m));
}
setring h_variable_5;
short=0;option(redTail);
proc Involution (matrix m)
{
  return(transpose(m));
}
ring h_variable_40 = (integer),(a7,x1,x2,x3),wp( 0, 1, 1, 1 );
setring h_variable_40;
short=0;option(redTail);
number h_variable_41 = 0;
number h_variable_42 = 1;
number h_variable_43 = -1;
poly h_variable_44 = a7;
poly h_variable_45 = x1;
poly h_variable_46 = x2;
poly h_variable_47 = x3;
h_variable_44;
h_variable_45;
h_variable_46;
h_variable_47;
proc Involution (matrix m)
{
  return(transpose(m));
}
setring h_variable_16;
short=0;option(redTail);
proc Involution (matrix m)
{
  return(transpose(m));
}
proc Involution (matrix m)
{
  return(transpose(m));
}
matrix h_variable_48 = imap(h_variable_5,h_variable_12);
setring h_variable_5;
short=0;option(redTail);
proc Involution (matrix m)
{
  return(transpose(m));
}
matrix h_variable_49 = BasisOfRowModule(h_variable_12);
ncols(h_variable_49);
matrix h_variable_51 = Involution(h_variable_15);
matrix h_variable_52[9][18] = dsum(h_variable_49,h_variable_49,h_variable_49,h_variable_49,h_variable_49,h_variable_49,h_variable_49,h_variable_49,h_variable_49);
matrix h_variable_50 = DecideZeroRows(h_variable_51,h_variable_52);
IsZeroMatrix(h_variable_50);
setring h_variable_16;
short=0;option(redTail);
proc Involution (matrix m)
{
  return(transpose(m));
}
matrix h_variable_53 = imap(h_variable_5,h_variable_50);
poly h_variable_54 = x1;
poly h_variable_55 = x2;
poly h_variable_56 = x3;
h_variable_54;
h_variable_55;
h_variable_56;
matrix h_variable_57[1][3] = x1,x2,x3;
h_variable_57 = transpose(h_variable_57);
matrix h_variable_58 = BasisOfRowModule(h_variable_48);
ncols(h_variable_58);
matrix h_variable_60 = submat(h_variable_53,intvec( 1 ),1..3);
matrix h_variable_59 = DecideZeroRows(h_variable_60,h_variable_58);
IsZeroMatrix(h_variable_59);
matrix h_variable_62 = h_variable_59*h_variable_57;
matrix h_variable_61 = DecideZeroRows(h_variable_62,h_variable_58);
IsZeroMatrix(h_variable_61);
def h_variable_63 = h_variable_61[1,1];
matrix h_variable_65 = submat(h_variable_53,intvec( 2 ),1..3);
matrix h_variable_64 = DecideZeroRows(h_variable_65,h_variable_58);
IsZeroMatrix(h_variable_64);
matrix h_variable_67 = h_variable_64*h_variable_57;
matrix h_variable_66 = DecideZeroRows(h_variable_67,h_variable_58);
IsZeroMatrix(h_variable_66);
def h_variable_68 = h_variable_66[1,1];
matrix h_variable_70 = submat(h_variable_53,intvec( 3 ),1..3);
matrix h_variable_69 = DecideZeroRows(h_variable_70,h_variable_58);
IsZeroMatrix(h_variable_69);
matrix h_variable_72 = h_variable_69*h_variable_57;
matrix h_variable_71 = DecideZeroRows(h_variable_72,h_variable_58);
IsZeroMatrix(h_variable_71);
def h_variable_73 = h_variable_71[1,1];
matrix h_variable_75 = submat(h_variable_53,intvec( 4 ),1..3);
matrix h_variable_74 = DecideZeroRows(h_variable_75,h_variable_58);
IsZeroMatrix(h_variable_74);
matrix h_variable_77 = h_variable_74*h_variable_57;
matrix h_variable_76 = DecideZeroRows(h_variable_77,h_variable_58);
IsZeroMatrix(h_variable_76);
def h_variable_78 = h_variable_76[1,1];
matrix h_variable_80 = submat(h_variable_53,intvec( 5 ),1..3);
matrix h_variable_79 = DecideZeroRows(h_variable_80,h_variable_58);
IsZeroMatrix(h_variable_79);
matrix h_variable_82 = h_variable_79*h_variable_57;
matrix h_variable_81 = DecideZeroRows(h_variable_82,h_variable_58);
IsZeroMatrix(h_variable_81);
def h_variable_83 = h_variable_81[1,1];
matrix h_variable_85 = submat(h_variable_53,intvec( 6 ),1..3);
matrix h_variable_84 = DecideZeroRows(h_variable_85,h_variable_58);
IsZeroMatrix(h_variable_84);
matrix h_variable_87 = h_variable_84*h_variable_57;
matrix h_variable_86 = DecideZeroRows(h_variable_87,h_variable_58);
IsZeroMatrix(h_variable_86);
def h_variable_88 = h_variable_86[1,1];
matrix h_variable_90 = submat(h_variable_53,intvec( 7 ),1..3);
matrix h_variable_89 = DecideZeroRows(h_variable_90,h_variable_58);
IsZeroMatrix(h_variable_89);
matrix h_variable_92 = h_variable_89*h_variable_57;
matrix h_variable_91 = DecideZeroRows(h_variable_92,h_variable_58);
IsZeroMatrix(h_variable_91);
def h_variable_93 = h_variable_91[1,1];
matrix h_variable_95 = submat(h_variable_53,intvec( 8 ),1..3);
matrix h_variable_94 = DecideZeroRows(h_variable_95,h_variable_58);
IsZeroMatrix(h_variable_94);
matrix h_variable_97 = h_variable_94*h_variable_57;
matrix h_variable_96 = DecideZeroRows(h_variable_97,h_variable_58);
IsZeroMatrix(h_variable_96);
def h_variable_98 = h_variable_96[1,1];
matrix h_variable_100 = submat(h_variable_53,intvec( 9 ),1..3);
matrix h_variable_99 = DecideZeroRows(h_variable_100,h_variable_58);
IsZeroMatrix(h_variable_99);
matrix h_variable_102 = h_variable_99*h_variable_57;
matrix h_variable_101 = DecideZeroRows(h_variable_102,h_variable_58);
IsZeroMatrix(h_variable_101);
def h_variable_103 = h_variable_101[1,1];
def h_variable_104 = (h_variable_63)*(h_variable_68);
h_variable_104;
matrix h_variable_105[1][1] = x1*x2;
matrix h_variable_106 = DecideZeroRows(h_variable_105,h_variable_58);
IsZeroMatrix(h_variable_106);
def h_variable_107 = h_variable_106[1,1];
def h_variable_108 = (h_variable_107)*(h_variable_73);
h_variable_108;
matrix h_variable_109[1][1] = x1^2*x2+x1*x2^2;
matrix h_variable_110 = DecideZeroRows(h_variable_109,h_variable_58);
IsZeroMatrix(h_variable_110);
def h_variable_111 = h_variable_110[1,1];
def h_variable_112 = (h_variable_111)*(h_variable_78);
h_variable_112;
matrix h_variable_113[1][1] = x1^2*x2*x3+x1*x2^2*x3;
matrix h_variable_114 = DecideZeroRows(h_variable_113,h_variable_58);
IsZeroMatrix(h_variable_114);
def h_variable_115 = h_variable_114[1,1];
def h_variable_116 = (h_variable_115)*(h_variable_83);
h_variable_116;
matrix h_variable_117[1][1] = x1^3*x2*x3+x1^2*x2^2*x3+x1^2*x2*x3^2+x1*x2^2*x3^2;
matrix h_variable_118 = DecideZeroRows(h_variable_117,h_variable_58);
IsZeroMatrix(h_variable_118);
def h_variable_119 = h_variable_118[1,1];
def h_variable_120 = (h_variable_119)*(h_variable_88);
h_variable_120;
matrix h_variable_121[1][1] = a7*x1^3*x2*x3^2+a7*x1^2*x2^2*x3^2+a7*x1^2*x2*x3^3+a7*x1*x2^2*x3^3+x1^3*x2^2*x3+x1^2*x2^3*x3-x1^3*x2*x3^2+x1*x2^3*x3^2-x1^2*x2*x3^3-x1*x2^2*x3^3;
matrix h_variable_122 = DecideZeroRows(h_variable_121,h_variable_58);
IsZeroMatrix(h_variable_122);
def h_variable_123 = h_variable_122[1,1];
def h_variable_124 = (h_variable_123)*(h_variable_93);
h_variable_124;
matrix h_variable_125[1][1] = -a7^2*x1^3*x2^2*x3^2-a7^2*x1^2*x2^3*x3^2+a7^2*x1^3*x2*x3^3-a7^2*x1*x2^3*x3^3+a7^2*x1^2*x2*x3^4+a7^2*x1*x2^2*x3^4-a7*x1^3*x2^3*x3-a7*x1^2*x2^4*x3+a7*x1^4*x2*x3^2+4*a7*x1^3*x2^2*x3^2+2*a7*x1^2*x2^3*x3^2-a7*x1*x2^4*x3^2+3*a7*x1^2*x2^2*x3^3+3*a7*x1*x2^3*x3^3-a7*x1^2*x2*x3^4-a7*x1*x2^2*x3^4+x1^4*x2^2*x3+2*x1^3*x2^3*x3+x1^2*x2^4*x3-x1^4*x2*x3^2-x1^3*x2^2*x3^2+x1^2*x2^3*x3^2+x1*x2^4*x3^2-x1^3*x2*x3^3-2*x1^2*x2^2*x3^3-x1*x2^3*x3^3;
matrix h_variable_126 = DecideZeroRows(h_variable_125,h_variable_58);
IsZeroMatrix(h_variable_126);
def h_variable_127 = h_variable_126[1,1];
def h_variable_128 = (h_variable_127)*(h_variable_98);
h_variable_128;
matrix h_variable_129[1][1] = a7^2*x1^3*x2^4*x3+a7^2*x1^2*x2^5*x3-a7^2*x1^4*x2^2*x3^2-3*a7^2*x1^3*x2^3*x3^2-a7^2*x1^2*x2^4*x3^2+a7^2*x1*x2^5*x3^2-a7^2*x1^3*x2^2*x3^3-3*a7^2*x1^2*x2^3*x3^3-2*a7^2*x1*x2^4*x3^3-2*a7*x1^4*x2^3*x3-4*a7*x1^3*x2^4*x3-2*a7*x1^2*x2^5*x3+a7*x1^5*x2*x3^2+5*a7*x1^4*x2^2*x3^2+3*a7*x1^3*x2^3*x3^2-3*a7*x1^2*x2^4*x3^2-2*a7*x1*x2^5*x3^2+2*a7*x1^4*x2*x3^3+9*a7*x1^3*x2^2*x3^3+8*a7*x1^2*x2^3*x3^3+a7*x1*x2^4*x3^3+a7*x1^3*x2*x3^4+4*a7*x1^2*x2^2*x3^4+3*a7*x1*x2^3*x3^4+x1^5*x2^2*x3+3*x1^4*x2^3*x3+3*x1^3*x2^4*x3+x1^2*x2^5*x3-x1^5*x2*x3^2+4*x1^3*x2^3*x3^2+4*x1^2*x2^4*x3^2+x1*x2^5*x3^2-3*x1^4*x2*x3^3-4*x1^3*x2^2*x3^3+x1*x2^4*x3^3-3*x1^3*x2*x3^4-4*x1^2*x2^2*x3^4-x1*x2^3*x3^4-x1^2*x2*x3^5-x1*x2^2*x3^5;
matrix h_variable_130 = DecideZeroRows(h_variable_129,h_variable_58);
IsZeroMatrix(h_variable_130);
def h_variable_131 = h_variable_130[1,1];
def h_variable_132 = (h_variable_131)*(h_variable_103);
h_variable_132;
matrix h_variable_133[1][1] = -2*a7^2*x1^4*x2^3*x3^2-3*a7^2*x1^3*x2^4*x3^2-a7^2*x1^2*x2^5*x3^2+a7^2*x1^5*x2*x3^3+4*a7^2*x1^4*x2^2*x3^3-4*a7^2*x1^2*x2^4*x3^3-a7^2*x1*x2^5*x3^3+2*a7^2*x1^4*x2*x3^4+8*a7^2*x1^3*x2^2*x3^4+5*a7^2*x1^2*x2^3*x3^4-a7^2*x1*x2^4*x3^4+a7^2*x1^3*x2*x3^5+4*a7^2*x1^2*x2^2*x3^5+3*a7^2*x1*x2^3*x3^5-2*a7*x1^5*x2^3*x3-5*a7*x1^4*x2^4*x3-4*a7*x1^3*x2^5*x3-a7*x1^2*x2^6*x3+a7*x1^6*x2*x3^2+6*a7*x1^5*x2^2*x3^2+7*a7*x1^4*x2^3*x3^2-2*a7*x1^3*x2^4*x3^2-5*a7*x1^2*x2^5*x3^2-a7*x1*x2^6*x3^2+a7*x1^5*x2*x3^3+11*a7*x1^4*x2^2*x3^3+20*a7*x1^3*x2^3*x3^3+9*a7*x1^2*x2^4*x3^3-a7*x1*x2^5*x3^3-2*a7*x1^4*x2*x3^4+2*a7*x1^3*x2^2*x3^4+10*a7*x1^2*x2^3*x3^4+6*a7*x1*x2^4*x3^4-3*a7*x1^3*x2*x3^5-4*a7*x1^2*x2^2*x3^5-a7*x1*x2^3*x3^5-a7*x1^2*x2*x3^6-a7*x1*x2^2*x3^6+x1^6*x2^2*x3+4*x1^5*x2^3*x3+5*x1^4*x2^4*x3+2*x1^3*x2^5*x3-x1^6*x2*x3^2+8*x1^4*x2^3*x3^2+12*x1^3*x2^4*x3^2+5*x1^2*x2^5*x3^2-3*x1^5*x2*x3^3-6*x1^4*x2^2*x3^3+6*x1^2*x2^4*x3^3+3*x1*x2^5*x3^3-3*x1^4*x2*x3^4-7*x1^3*x2^2*x3^4-5*x1^2*x2^3*x3^4-x1*x2^4*x3^4-x1^3*x2*x3^5-2*x1^2*x2^2*x3^5-x1*x2^3*x3^5;
matrix h_variable_134 = DecideZeroRows(h_variable_133,h_variable_58);
IsZeroMatrix(h_variable_134);
def h_variable_135 = h_variable_134[1,1];
h_variable_135;
matrix h_variable_136[1][1] = -2*a7*x1^5*x2^3*x3-5*a7*x1^4*x2^4*x3-4*a7*x1^3*x2^5*x3-a7*x1^2*x2^6*x3+a7*x1^6*x2*x3^2+5*a7*x1^4*x2^3*x3^2-5*a7*x1^3*x2^4*x3^2-a7*x1*x2^6*x3^2+2*a7*x1^5*x2*x3^3+15*a7*x1^4*x2^2*x3^3+20*a7*x1^3*x2^3*x3^3+5*a7*x1^2*x2^4*x3^3-2*a7*x1*x2^5*x3^3+10*a7*x1^3*x2^2*x3^4+15*a7*x1^2*x2^3*x3^4+5*a7*x1*x2^4*x3^4-2*a7*x1^3*x2*x3^5+2*a7*x1*x2^3*x3^5-a7*x1^2*x2*x3^6-a7*x1*x2^2*x3^6+x1^6*x2^2*x3+4*x1^5*x2^3*x3+5*x1^4*x2^4*x3+2*x1^3*x2^5*x3-x1^6*x2*x3^2+10*x1^4*x2^3*x3^2+15*x1^3*x2^4*x3^2-4*x1^5*x2*x3^3-10*x1^4*x2^2*x3^3+10*x1^2*x2^4*x3^3+4*x1*x2^5*x3^3-5*x1^4*x2*x3^4-15*x1^3*x2^2*x3^4-10*x1^2*x2^3*x3^4-2*x1^3*x2*x3^5-4*x1*x2^3*x3^5;
matrix h_variable_137 = DecideZeroRows(h_variable_136,h_variable_58);
IsZeroMatrix(h_variable_137);
def h_variable_138 = h_variable_137[1,1];
h_variable_138==0;
h_variable_63;
matrix h_variable_139[1][1] = x1;
matrix h_variable_140 = DecideZeroRows(h_variable_139,h_variable_58);
IsZeroMatrix(h_variable_140);
def h_variable_141 = h_variable_140[1,1];
h_variable_141==0;
h_variable_68;
matrix h_variable_142[1][1] = x2;
matrix h_variable_143 = DecideZeroRows(h_variable_142,h_variable_58);
IsZeroMatrix(h_variable_143);
def h_variable_144 = h_variable_143[1,1];
h_variable_144==0;
h_variable_73;
matrix h_variable_145[1][1] = x1+x2;
matrix h_variable_146 = DecideZeroRows(h_variable_145,h_variable_58);
IsZeroMatrix(h_variable_146);
def h_variable_147 = h_variable_146[1,1];
h_variable_147==0;
h_variable_78;
matrix h_variable_148[1][1] = x3;
matrix h_variable_149 = DecideZeroRows(h_variable_148,h_variable_58);
IsZeroMatrix(h_variable_149);
def h_variable_150 = h_variable_149[1,1];
h_variable_150==0;
h_variable_83;
matrix h_variable_151[1][1] = x1+x3;
matrix h_variable_152 = DecideZeroRows(h_variable_151,h_variable_58);
IsZeroMatrix(h_variable_152);
def h_variable_153 = h_variable_152[1,1];
h_variable_153==0;
h_variable_88;
matrix h_variable_154[1][1] = a7*x3+x2-x3;
matrix h_variable_155 = DecideZeroRows(h_variable_154,h_variable_58);
IsZeroMatrix(h_variable_155);
def h_variable_156 = h_variable_155[1,1];
h_variable_156==0;
h_variable_93;
matrix h_variable_157[1][1] = -a7*x2+a7*x3+x1+x2;
matrix h_variable_158 = DecideZeroRows(h_variable_157,h_variable_58);
IsZeroMatrix(h_variable_158);
def h_variable_159 = h_variable_158[1,1];
h_variable_159==0;
h_variable_98;
matrix h_variable_160[1][1] = -a7*x2+x1+x2+x3;
matrix h_variable_161 = DecideZeroRows(h_variable_160,h_variable_58);
IsZeroMatrix(h_variable_161);
def h_variable_162 = h_variable_161[1,1];
h_variable_162==0;
h_variable_103;
matrix h_variable_163[1][1] = a7*x3+x1+x2;
matrix h_variable_164 = DecideZeroRows(h_variable_163,h_variable_58);
IsZeroMatrix(h_variable_164);
def h_variable_165 = h_variable_164[1,1];
h_variable_165==0;
def h_variable_166 = h_variable_58[1,1];
def h_variable_167 = h_variable_58[1,2];
h_variable_166;
h_variable_167;
matrix h_variable_168[1][3] = x1,x2,x3;
h_variable_168 = transpose(h_variable_168);
matrix h_variable_169[1][1] = x1;
matrix h_variable_171 = Involution(h_variable_168);
matrix h_variable_170 = DecideZeroRows(h_variable_171,h_variable_58);
IsZeroMatrix(h_variable_170);
matrix h_variable_172 = Diff(h_variable_170,h_variable_169);
matrix h_variable_173 = h_variable_172;
matrix h_variable_174[1][3] = x1,x2,x3;
h_variable_174 = transpose(h_variable_174);
matrix h_variable_175[1][1] = x2;
matrix h_variable_177 = Involution(h_variable_174);
matrix h_variable_176 = DecideZeroRows(h_variable_177,h_variable_58);
IsZeroMatrix(h_variable_176);
matrix h_variable_178 = Diff(h_variable_176,h_variable_175);
matrix h_variable_179 = h_variable_178;
matrix h_variable_180[1][3] = x1,x2,x3;
h_variable_180 = transpose(h_variable_180);
matrix h_variable_181[1][1] = x1+x2;
matrix h_variable_183 = Involution(h_variable_180);
matrix h_variable_182 = DecideZeroRows(h_variable_183,h_variable_58);
IsZeroMatrix(h_variable_182);
matrix h_variable_184 = Diff(h_variable_182,h_variable_181);
matrix h_variable_185 = h_variable_184;
matrix h_variable_186[1][3] = x1,x2,x3;
h_variable_186 = transpose(h_variable_186);
matrix h_variable_187[1][1] = x3;
matrix h_variable_189 = Involution(h_variable_186);
matrix h_variable_188 = DecideZeroRows(h_variable_189,h_variable_58);
IsZeroMatrix(h_variable_188);
matrix h_variable_190 = Diff(h_variable_188,h_variable_187);
matrix h_variable_191 = h_variable_190;
matrix h_variable_192[1][3] = x1,x2,x3;
h_variable_192 = transpose(h_variable_192);
matrix h_variable_193[1][1] = x1+x3;
matrix h_variable_195 = Involution(h_variable_192);
matrix h_variable_194 = DecideZeroRows(h_variable_195,h_variable_58);
IsZeroMatrix(h_variable_194);
matrix h_variable_196 = Diff(h_variable_194,h_variable_193);
matrix h_variable_197 = h_variable_196;
matrix h_variable_198[1][3] = x1,x2,x3;
h_variable_198 = transpose(h_variable_198);
matrix h_variable_199[1][1] = a7*x3+x2-x3;
matrix h_variable_201 = Involution(h_variable_198);
matrix h_variable_200 = DecideZeroRows(h_variable_201,h_variable_58);
IsZeroMatrix(h_variable_200);
matrix h_variable_202 = Diff(h_variable_200,h_variable_199);
matrix h_variable_203 = h_variable_202;
matrix h_variable_204[1][3] = x1,x2,x3;
h_variable_204 = transpose(h_variable_204);
matrix h_variable_205[1][1] = -a7*x2+a7*x3+x1+x2;
matrix h_variable_207 = Involution(h_variable_204);
matrix h_variable_206 = DecideZeroRows(h_variable_207,h_variable_58);
IsZeroMatrix(h_variable_206);
matrix h_variable_208 = Diff(h_variable_206,h_variable_205);
matrix h_variable_209 = h_variable_208;
matrix h_variable_210[1][3] = x1,x2,x3;
h_variable_210 = transpose(h_variable_210);
matrix h_variable_211[1][1] = -a7*x2+x1+x2+x3;
matrix h_variable_213 = Involution(h_variable_210);
matrix h_variable_212 = DecideZeroRows(h_variable_213,h_variable_58);
IsZeroMatrix(h_variable_212);
matrix h_variable_214 = Diff(h_variable_212,h_variable_211);
matrix h_variable_215 = h_variable_214;
matrix h_variable_216[1][3] = x1,x2,x3;
h_variable_216 = transpose(h_variable_216);
matrix h_variable_217[1][1] = a7*x3+x1+x2;
matrix h_variable_219 = Involution(h_variable_216);
matrix h_variable_218 = DecideZeroRows(h_variable_219,h_variable_58);
IsZeroMatrix(h_variable_218);
matrix h_variable_220 = Diff(h_variable_218,h_variable_217);
matrix h_variable_221 = h_variable_220;
matrix h_variable_223[2][2] = dsum(h_variable_169,h_variable_175);
matrix h_variable_224[2][4] = dsum(h_variable_58,h_variable_58);
matrix h_variable_222 = DecideZeroRows(h_variable_223,h_variable_224);
IsZeroMatrix(h_variable_222);
matrix h_variable_226[3][3] = dsum(h_variable_222,h_variable_181);
matrix h_variable_227[3][6] = dsum(h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_225 = DecideZeroRows(h_variable_226,h_variable_227);
IsZeroMatrix(h_variable_225);
matrix h_variable_229[4][4] = dsum(h_variable_225,h_variable_187);
matrix h_variable_230[4][8] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_228 = DecideZeroRows(h_variable_229,h_variable_230);
IsZeroMatrix(h_variable_228);
matrix h_variable_232[5][5] = dsum(h_variable_228,h_variable_193);
matrix h_variable_233[5][10] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_231 = DecideZeroRows(h_variable_232,h_variable_233);
IsZeroMatrix(h_variable_231);
matrix h_variable_235[6][6] = dsum(h_variable_231,h_variable_199);
matrix h_variable_236[6][12] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_234 = DecideZeroRows(h_variable_235,h_variable_236);
IsZeroMatrix(h_variable_234);
matrix h_variable_238[7][7] = dsum(h_variable_234,h_variable_205);
matrix h_variable_239[7][14] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_237 = DecideZeroRows(h_variable_238,h_variable_239);
IsZeroMatrix(h_variable_237);
matrix h_variable_241[8][8] = dsum(h_variable_237,h_variable_211);
matrix h_variable_242[8][16] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_240 = DecideZeroRows(h_variable_241,h_variable_242);
IsZeroMatrix(h_variable_240);
matrix h_variable_244[9][9] = dsum(h_variable_240,h_variable_217);
matrix h_variable_245[9][18] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_243 = DecideZeroRows(h_variable_244,h_variable_245);
IsZeroMatrix(h_variable_243);
matrix h_variable_247[2][3] = h_variable_173,h_variable_179;
matrix h_variable_248[2][4] = dsum(h_variable_58,h_variable_58);
matrix h_variable_246 = DecideZeroRows(h_variable_247,h_variable_248);
IsZeroMatrix(h_variable_246);
matrix h_variable_250[3][3] = h_variable_246,h_variable_185;
matrix h_variable_251[3][6] = dsum(h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_249 = DecideZeroRows(h_variable_250,h_variable_251);
IsZeroMatrix(h_variable_249);
matrix h_variable_253[4][3] = h_variable_249,h_variable_191;
matrix h_variable_254[4][8] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_252 = DecideZeroRows(h_variable_253,h_variable_254);
IsZeroMatrix(h_variable_252);
matrix h_variable_256[5][3] = h_variable_252,h_variable_197;
matrix h_variable_257[5][10] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_255 = DecideZeroRows(h_variable_256,h_variable_257);
IsZeroMatrix(h_variable_255);
matrix h_variable_259[6][3] = h_variable_255,h_variable_203;
matrix h_variable_260[6][12] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_258 = DecideZeroRows(h_variable_259,h_variable_260);
IsZeroMatrix(h_variable_258);
matrix h_variable_262[7][3] = h_variable_258,h_variable_209;
matrix h_variable_263[7][14] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_261 = DecideZeroRows(h_variable_262,h_variable_263);
IsZeroMatrix(h_variable_261);
matrix h_variable_265[8][3] = h_variable_261,h_variable_215;
matrix h_variable_266[8][16] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_264 = DecideZeroRows(h_variable_265,h_variable_266);
IsZeroMatrix(h_variable_264);
matrix h_variable_268[9][3] = h_variable_264,h_variable_221;
matrix h_variable_269[9][18] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_267 = DecideZeroRows(h_variable_268,h_variable_269);
IsZeroMatrix(h_variable_267);
matrix h_variable_271[9][18] = dsum(h_variable_48,h_variable_48,h_variable_48,h_variable_48,h_variable_48,h_variable_48,h_variable_48,h_variable_48,h_variable_48);
matrix h_variable_272[9][27] = concat(h_variable_243,h_variable_271);
matrix h_variable_270 = RelativeSyzygiesGeneratorsOfRows(h_variable_267,h_variable_272);
IsZeroMatrix(h_variable_270);
ncols(h_variable_270);
matrix h_variable_274[3][6] = dsum(h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_273 = DecideZeroRows(h_variable_270,h_variable_274);
IsZeroMatrix(h_variable_273);
ZeroRows(h_variable_273);
matrix h_variable_276 = submat(h_variable_270,1..3,intvec( 4, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28 ));
matrix h_variable_277[3][6] = dsum(h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_275 = DecideZeroRows(h_variable_276,h_variable_277);
IsZeroMatrix(h_variable_275);
matrix h_variable_279[3][6] = dsum(h_variable_48,h_variable_48,h_variable_48);
matrix h_variable_278 = RelativeSyzygiesGeneratorsOfRows(h_variable_275,h_variable_279);
IsZeroMatrix(h_variable_278);
ncols(h_variable_278);
matrix h_variable_281[22][44] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_280 = DecideZeroRows(h_variable_278,h_variable_281);
IsZeroMatrix(h_variable_280);
ZeroRows(h_variable_280);
matrix h_variable_283 = submat(h_variable_278,1..22,intvec( 2, 3, 4, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208 ));
matrix h_variable_284[22][44] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_282 = DecideZeroRows(h_variable_283,h_variable_284);
IsZeroMatrix(h_variable_282);
def h_variable_285 = h_variable_282[22,1];
h_variable_285;
matrix h_variable_286[1][1] = 0;
matrix h_variable_287[1][3] = concat(h_variable_286,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_287); matrix h_variable_288 = h_variable_l[1]; matrix h_variable_289 = h_variable_l[2];
ncols(h_variable_288);
matrix h_variable_290 = DecideZeroRows(h_variable_288,h_variable_58);
IsZeroMatrix(h_variable_290);
nrows(h_variable_289);
def h_variable_291 = h_variable_282[21,1];
h_variable_291;
matrix h_variable_292[1][1] = 0;
matrix h_variable_293[1][3] = concat(h_variable_292,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_293); matrix h_variable_294 = h_variable_l[1]; matrix h_variable_295 = h_variable_l[2];
ncols(h_variable_294);
matrix h_variable_296 = DecideZeroRows(h_variable_294,h_variable_58);
IsZeroMatrix(h_variable_296);
nrows(h_variable_295);
def h_variable_297 = h_variable_282[20,1];
h_variable_297;
matrix h_variable_298[1][1] = 0;
matrix h_variable_299[1][3] = concat(h_variable_298,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_299); matrix h_variable_300 = h_variable_l[1]; matrix h_variable_301 = h_variable_l[2];
ncols(h_variable_300);
matrix h_variable_302 = DecideZeroRows(h_variable_300,h_variable_58);
IsZeroMatrix(h_variable_302);
nrows(h_variable_301);
def h_variable_303 = h_variable_282[19,1];
h_variable_303;
matrix h_variable_304[1][1] = 0;
matrix h_variable_305[1][3] = concat(h_variable_304,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_305); matrix h_variable_306 = h_variable_l[1]; matrix h_variable_307 = h_variable_l[2];
ncols(h_variable_306);
matrix h_variable_308 = DecideZeroRows(h_variable_306,h_variable_58);
IsZeroMatrix(h_variable_308);
nrows(h_variable_307);
def h_variable_309 = h_variable_282[18,1];
h_variable_309;
matrix h_variable_310[1][1] = 0;
matrix h_variable_311[1][3] = concat(h_variable_310,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_311); matrix h_variable_312 = h_variable_l[1]; matrix h_variable_313 = h_variable_l[2];
ncols(h_variable_312);
matrix h_variable_314 = DecideZeroRows(h_variable_312,h_variable_58);
IsZeroMatrix(h_variable_314);
nrows(h_variable_313);
def h_variable_315 = h_variable_282[17,1];
h_variable_315;
matrix h_variable_316[1][1] = 0;
matrix h_variable_317[1][3] = concat(h_variable_316,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_317); matrix h_variable_318 = h_variable_l[1]; matrix h_variable_319 = h_variable_l[2];
ncols(h_variable_318);
matrix h_variable_320 = DecideZeroRows(h_variable_318,h_variable_58);
IsZeroMatrix(h_variable_320);
nrows(h_variable_319);
def h_variable_321 = h_variable_282[16,1];
h_variable_321;
matrix h_variable_322[1][1] = 0;
matrix h_variable_323[1][3] = concat(h_variable_322,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_323); matrix h_variable_324 = h_variable_l[1]; matrix h_variable_325 = h_variable_l[2];
ncols(h_variable_324);
matrix h_variable_326 = DecideZeroRows(h_variable_324,h_variable_58);
IsZeroMatrix(h_variable_326);
nrows(h_variable_325);
def h_variable_327 = h_variable_282[15,1];
h_variable_327;
matrix h_variable_328[1][1] = 0;
matrix h_variable_329[1][3] = concat(h_variable_328,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_329); matrix h_variable_330 = h_variable_l[1]; matrix h_variable_331 = h_variable_l[2];
ncols(h_variable_330);
matrix h_variable_332 = DecideZeroRows(h_variable_330,h_variable_58);
IsZeroMatrix(h_variable_332);
nrows(h_variable_331);
def h_variable_333 = h_variable_282[14,1];
h_variable_333;
matrix h_variable_334[1][1] = 0;
matrix h_variable_335[1][3] = concat(h_variable_334,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_335); matrix h_variable_336 = h_variable_l[1]; matrix h_variable_337 = h_variable_l[2];
ncols(h_variable_336);
matrix h_variable_338 = DecideZeroRows(h_variable_336,h_variable_58);
IsZeroMatrix(h_variable_338);
nrows(h_variable_337);
def h_variable_339 = h_variable_282[13,1];
h_variable_339;
matrix h_variable_340[1][1] = 0;
matrix h_variable_341[1][3] = concat(h_variable_340,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_341); matrix h_variable_342 = h_variable_l[1]; matrix h_variable_343 = h_variable_l[2];
ncols(h_variable_342);
matrix h_variable_344 = DecideZeroRows(h_variable_342,h_variable_58);
IsZeroMatrix(h_variable_344);
nrows(h_variable_343);
def h_variable_345 = h_variable_282[12,1];
h_variable_345;
matrix h_variable_346[1][1] = 0;
matrix h_variable_347[1][3] = concat(h_variable_346,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_347); matrix h_variable_348 = h_variable_l[1]; matrix h_variable_349 = h_variable_l[2];
ncols(h_variable_348);
matrix h_variable_350 = DecideZeroRows(h_variable_348,h_variable_58);
IsZeroMatrix(h_variable_350);
nrows(h_variable_349);
def h_variable_351 = h_variable_282[11,1];
h_variable_351;
matrix h_variable_352[1][1] = 0;
matrix h_variable_353[1][3] = concat(h_variable_352,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_353); matrix h_variable_354 = h_variable_l[1]; matrix h_variable_355 = h_variable_l[2];
ncols(h_variable_354);
matrix h_variable_356 = DecideZeroRows(h_variable_354,h_variable_58);
IsZeroMatrix(h_variable_356);
nrows(h_variable_355);
def h_variable_357 = h_variable_282[10,1];
h_variable_357;
matrix h_variable_358[1][1] = 0;
matrix h_variable_359[1][3] = concat(h_variable_358,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_359); matrix h_variable_360 = h_variable_l[1]; matrix h_variable_361 = h_variable_l[2];
ncols(h_variable_360);
matrix h_variable_362 = DecideZeroRows(h_variable_360,h_variable_58);
IsZeroMatrix(h_variable_362);
nrows(h_variable_361);
def h_variable_363 = h_variable_282[9,1];
h_variable_363;
matrix h_variable_364[1][1] = 0;
matrix h_variable_365[1][3] = concat(h_variable_364,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_365); matrix h_variable_366 = h_variable_l[1]; matrix h_variable_367 = h_variable_l[2];
ncols(h_variable_366);
matrix h_variable_368 = DecideZeroRows(h_variable_366,h_variable_58);
IsZeroMatrix(h_variable_368);
nrows(h_variable_367);
def h_variable_369 = h_variable_282[8,1];
h_variable_369;
matrix h_variable_370[1][1] = 0;
matrix h_variable_371[1][3] = concat(h_variable_370,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_371); matrix h_variable_372 = h_variable_l[1]; matrix h_variable_373 = h_variable_l[2];
ncols(h_variable_372);
matrix h_variable_374 = DecideZeroRows(h_variable_372,h_variable_58);
IsZeroMatrix(h_variable_374);
nrows(h_variable_373);
def h_variable_375 = h_variable_282[7,1];
h_variable_375;
matrix h_variable_376[1][1] = 0;
matrix h_variable_377[1][3] = concat(h_variable_376,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_377); matrix h_variable_378 = h_variable_l[1]; matrix h_variable_379 = h_variable_l[2];
ncols(h_variable_378);
matrix h_variable_380 = DecideZeroRows(h_variable_378,h_variable_58);
IsZeroMatrix(h_variable_380);
nrows(h_variable_379);
def h_variable_381 = h_variable_282[6,1];
h_variable_381;
matrix h_variable_382[1][1] = 0;
matrix h_variable_383[1][3] = concat(h_variable_382,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_383); matrix h_variable_384 = h_variable_l[1]; matrix h_variable_385 = h_variable_l[2];
ncols(h_variable_384);
matrix h_variable_386 = DecideZeroRows(h_variable_384,h_variable_58);
IsZeroMatrix(h_variable_386);
nrows(h_variable_385);
def h_variable_387 = h_variable_282[5,1];
h_variable_387;
matrix h_variable_388[1][1] = 0;
matrix h_variable_389[1][3] = concat(h_variable_388,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_389); matrix h_variable_390 = h_variable_l[1]; matrix h_variable_391 = h_variable_l[2];
ncols(h_variable_390);
matrix h_variable_392 = DecideZeroRows(h_variable_390,h_variable_58);
IsZeroMatrix(h_variable_392);
nrows(h_variable_391);
def h_variable_393 = h_variable_282[4,1];
h_variable_393;
matrix h_variable_394[1][1] = 0;
matrix h_variable_395[1][3] = concat(h_variable_394,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_395); matrix h_variable_396 = h_variable_l[1]; matrix h_variable_397 = h_variable_l[2];
ncols(h_variable_396);
matrix h_variable_398 = DecideZeroRows(h_variable_396,h_variable_58);
IsZeroMatrix(h_variable_398);
nrows(h_variable_397);
def h_variable_399 = h_variable_282[3,1];
h_variable_399;
matrix h_variable_400[1][1] = 0;
matrix h_variable_401[1][3] = concat(h_variable_400,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_401); matrix h_variable_402 = h_variable_l[1]; matrix h_variable_403 = h_variable_l[2];
ncols(h_variable_402);
matrix h_variable_404 = DecideZeroRows(h_variable_402,h_variable_58);
IsZeroMatrix(h_variable_404);
nrows(h_variable_403);
def h_variable_405 = h_variable_282[2,1];
h_variable_405;
matrix h_variable_406[1][1] = 2;
matrix h_variable_407[1][3] = concat(h_variable_406,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_407); matrix h_variable_408 = h_variable_l[1]; matrix h_variable_409 = h_variable_l[2];
ncols(h_variable_408);
matrix h_variable_410 = DecideZeroRows(h_variable_408,h_variable_58);
IsZeroMatrix(h_variable_410);
ZeroRows(h_variable_410);
nrows(h_variable_409);
matrix h_variable_412 = submat(h_variable_408,1..1,intvec( 1 ));
matrix h_variable_411 = DecideZeroRows(h_variable_412,h_variable_58);
IsZeroMatrix(h_variable_411);
IsIdentityMatrix(h_variable_411);
matrix h_variable_413[1][1] = unitmat(1);
matrix h_variable_414[1][3] = concat(h_variable_411,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_413,h_variable_414); matrix h_variable_415 = h_variable_l[1]; matrix h_variable_416 = h_variable_l[2];
IsZeroMatrix(h_variable_415);
matrix h_variable_417 = DecideZeroRows(h_variable_415,h_variable_58);
IsZeroMatrix(h_variable_417);
def h_variable_418 = h_variable_282[1,1];
h_variable_418;
matrix h_variable_419[1][1] = 0;
matrix h_variable_420[1][3] = concat(h_variable_419,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_420); matrix h_variable_421 = h_variable_l[1]; matrix h_variable_422 = h_variable_l[2];
ncols(h_variable_421);
matrix h_variable_423 = DecideZeroRows(h_variable_421,h_variable_58);
IsZeroMatrix(h_variable_423);
nrows(h_variable_422);
def h_variable_424 = h_variable_282[22,2];
h_variable_424;
matrix h_variable_425[1][1] = 0;
matrix h_variable_426[1][3] = concat(h_variable_425,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_426); matrix h_variable_427 = h_variable_l[1]; matrix h_variable_428 = h_variable_l[2];
ncols(h_variable_427);
matrix h_variable_429 = DecideZeroRows(h_variable_427,h_variable_58);
IsZeroMatrix(h_variable_429);
nrows(h_variable_428);
def h_variable_430 = h_variable_282[21,2];
h_variable_430;
matrix h_variable_431[1][1] = 0;
matrix h_variable_432[1][3] = concat(h_variable_431,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_432); matrix h_variable_433 = h_variable_l[1]; matrix h_variable_434 = h_variable_l[2];
ncols(h_variable_433);
matrix h_variable_435 = DecideZeroRows(h_variable_433,h_variable_58);
IsZeroMatrix(h_variable_435);
nrows(h_variable_434);
def h_variable_436 = h_variable_282[20,2];
h_variable_436;
matrix h_variable_437[1][1] = 0;
matrix h_variable_438[1][3] = concat(h_variable_437,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_438); matrix h_variable_439 = h_variable_l[1]; matrix h_variable_440 = h_variable_l[2];
ncols(h_variable_439);
matrix h_variable_441 = DecideZeroRows(h_variable_439,h_variable_58);
IsZeroMatrix(h_variable_441);
nrows(h_variable_440);
def h_variable_442 = h_variable_282[19,2];
h_variable_442;
matrix h_variable_443[1][1] = 0;
matrix h_variable_444[1][3] = concat(h_variable_443,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_444); matrix h_variable_445 = h_variable_l[1]; matrix h_variable_446 = h_variable_l[2];
ncols(h_variable_445);
matrix h_variable_447 = DecideZeroRows(h_variable_445,h_variable_58);
IsZeroMatrix(h_variable_447);
nrows(h_variable_446);
def h_variable_448 = h_variable_282[18,2];
h_variable_448;
matrix h_variable_449[1][1] = 0;
matrix h_variable_450[1][3] = concat(h_variable_449,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_450); matrix h_variable_451 = h_variable_l[1]; matrix h_variable_452 = h_variable_l[2];
ncols(h_variable_451);
matrix h_variable_453 = DecideZeroRows(h_variable_451,h_variable_58);
IsZeroMatrix(h_variable_453);
nrows(h_variable_452);
def h_variable_454 = h_variable_282[17,2];
h_variable_454;
matrix h_variable_455[1][1] = 0;
matrix h_variable_456[1][3] = concat(h_variable_455,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_456); matrix h_variable_457 = h_variable_l[1]; matrix h_variable_458 = h_variable_l[2];
ncols(h_variable_457);
matrix h_variable_459 = DecideZeroRows(h_variable_457,h_variable_58);
IsZeroMatrix(h_variable_459);
nrows(h_variable_458);
def h_variable_460 = h_variable_282[16,2];
h_variable_460;
matrix h_variable_461[1][1] = 0;
matrix h_variable_462[1][3] = concat(h_variable_461,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_462); matrix h_variable_463 = h_variable_l[1]; matrix h_variable_464 = h_variable_l[2];
ncols(h_variable_463);
matrix h_variable_465 = DecideZeroRows(h_variable_463,h_variable_58);
IsZeroMatrix(h_variable_465);
nrows(h_variable_464);
def h_variable_466 = h_variable_282[15,2];
h_variable_466;
matrix h_variable_467[1][1] = 0;
matrix h_variable_468[1][3] = concat(h_variable_467,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_468); matrix h_variable_469 = h_variable_l[1]; matrix h_variable_470 = h_variable_l[2];
ncols(h_variable_469);
matrix h_variable_471 = DecideZeroRows(h_variable_469,h_variable_58);
IsZeroMatrix(h_variable_471);
nrows(h_variable_470);
def h_variable_472 = h_variable_282[14,2];
h_variable_472;
matrix h_variable_473[1][1] = 0;
matrix h_variable_474[1][3] = concat(h_variable_473,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_474); matrix h_variable_475 = h_variable_l[1]; matrix h_variable_476 = h_variable_l[2];
ncols(h_variable_475);
matrix h_variable_477 = DecideZeroRows(h_variable_475,h_variable_58);
IsZeroMatrix(h_variable_477);
nrows(h_variable_476);
def h_variable_478 = h_variable_282[13,2];
h_variable_478;
matrix h_variable_479[1][1] = 0;
matrix h_variable_480[1][3] = concat(h_variable_479,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_480); matrix h_variable_481 = h_variable_l[1]; matrix h_variable_482 = h_variable_l[2];
ncols(h_variable_481);
matrix h_variable_483 = DecideZeroRows(h_variable_481,h_variable_58);
IsZeroMatrix(h_variable_483);
nrows(h_variable_482);
def h_variable_484 = h_variable_282[12,2];
h_variable_484;
matrix h_variable_485[1][1] = 0;
matrix h_variable_486[1][3] = concat(h_variable_485,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_486); matrix h_variable_487 = h_variable_l[1]; matrix h_variable_488 = h_variable_l[2];
ncols(h_variable_487);
matrix h_variable_489 = DecideZeroRows(h_variable_487,h_variable_58);
IsZeroMatrix(h_variable_489);
nrows(h_variable_488);
def h_variable_490 = h_variable_282[11,2];
h_variable_490;
matrix h_variable_491[1][1] = 0;
matrix h_variable_492[1][3] = concat(h_variable_491,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_492); matrix h_variable_493 = h_variable_l[1]; matrix h_variable_494 = h_variable_l[2];
ncols(h_variable_493);
matrix h_variable_495 = DecideZeroRows(h_variable_493,h_variable_58);
IsZeroMatrix(h_variable_495);
nrows(h_variable_494);
def h_variable_496 = h_variable_282[10,2];
h_variable_496;
matrix h_variable_497[1][1] = 0;
matrix h_variable_498[1][3] = concat(h_variable_497,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_498); matrix h_variable_499 = h_variable_l[1]; matrix h_variable_500 = h_variable_l[2];
ncols(h_variable_499);
kill h_variable_53;kill h_variable_57;kill h_variable_59;kill h_variable_60;kill h_variable_61;kill h_variable_62;kill h_variable_64;kill h_variable_65;kill h_variable_66;kill h_variable_67;kill h_variable_69;kill h_variable_70;kill h_variable_71;kill h_variable_72;kill h_variable_74;kill h_variable_75;kill h_variable_76;kill h_variable_77;kill h_variable_79;kill h_variable_80;kill h_variable_81;kill h_variable_82;kill h_variable_84;kill h_variable_85;kill h_variable_86;kill h_variable_87;kill h_variable_89;kill h_variable_90;kill h_variable_91;kill h_variable_92;kill h_variable_94;kill h_variable_95;kill h_variable_96;kill h_variable_97;kill h_variable_99;kill h_variable_100;kill h_variable_101;kill h_variable_102;kill h_variable_104;kill h_variable_105;kill h_variable_106;kill h_variable_107;kill h_variable_108;kill h_variable_109;kill h_variable_110;kill h_variable_111;kill h_variable_112;kill h_variable_113;kill h_variable_114;kill h_variable_115;kill h_variable_116;kill h_variable_117;kill h_variable_118;kill h_variable_119;kill h_variable_120;kill h_variable_121;kill h_variable_122;kill h_variable_123;kill h_variable_124;kill h_variable_125;kill h_variable_126;kill h_variable_127;kill h_variable_128;kill h_variable_129;kill h_variable_130;kill h_variable_131;kill h_variable_132;kill h_variable_133;kill h_variable_134;kill h_variable_136;kill h_variable_137;kill h_variable_138;kill h_variable_139;kill h_variable_140;kill h_variable_141;kill h_variable_142;kill h_variable_143;kill h_variable_144;kill h_variable_145;kill h_variable_146;kill h_variable_147;kill h_variable_148;kill h_variable_149;kill h_variable_150;kill h_variable_151;kill h_variable_152;kill h_variable_153;kill h_variable_154;kill h_variable_155;kill h_variable_156;kill h_variable_157;kill h_variable_158;kill h_variable_159;kill h_variable_160;kill h_variable_161;kill h_variable_162;kill h_variable_163;kill h_variable_164;kill h_variable_165;kill h_variable_166;kill h_variable_167;kill h_variable_168;kill h_variable_170;kill h_variable_171;kill h_variable_172;kill h_variable_174;kill h_variable_176;kill h_variable_177;kill h_variable_178;kill h_variable_180;kill h_variable_182;kill h_variable_183;kill h_variable_184;kill h_variable_186;kill h_variable_188;kill h_variable_189;kill h_variable_190;kill h_variable_192;kill h_variable_194;kill h_variable_195;kill h_variable_196;kill h_variable_198;kill h_variable_200;kill h_variable_201;kill h_variable_202;kill h_variable_204;kill h_variable_206;kill h_variable_207;kill h_variable_208;kill h_variable_216;kill h_variable_218;kill h_variable_219;kill h_variable_220;kill h_variable_223;kill h_variable_226;kill h_variable_229;kill h_variable_232;kill h_variable_235;kill h_variable_238;kill h_variable_241;kill h_variable_244;kill h_variable_247;kill h_variable_250;kill h_variable_253;kill h_variable_256;kill h_variable_259;kill h_variable_262;kill h_variable_265;kill h_variable_268;kill h_variable_270;kill h_variable_271;kill h_variable_272;kill h_variable_273;kill h_variable_274;kill h_variable_276;kill h_variable_278;kill h_variable_279;kill h_variable_280;kill h_variable_281;kill h_variable_283;kill h_variable_285;kill h_variable_286;kill h_variable_287;kill h_variable_288;kill h_variable_289;kill h_variable_290;kill h_variable_291;kill h_variable_292;kill h_variable_293;kill h_variable_294;kill h_variable_295;kill h_variable_296;kill h_variable_297;kill h_variable_298;kill h_variable_299;kill h_variable_300;kill h_variable_301;kill h_variable_302;kill h_variable_303;kill h_variable_304;kill h_variable_305;kill h_variable_306;kill h_variable_307;kill h_variable_308;kill h_variable_309;kill h_variable_310;kill h_variable_311;kill h_variable_312;kill h_variable_313;kill h_variable_314;kill h_variable_315;kill h_variable_316;kill h_variable_317;kill h_variable_318;kill h_variable_319;kill h_variable_320;kill h_variable_321;kill h_variable_322;kill h_variable_323;kill h_variable_324;kill h_variable_325;kill h_variable_326;kill h_variable_327;kill h_variable_328;kill h_variable_329;kill h_variable_330;kill h_variable_331;kill h_variable_332;kill h_variable_333;kill h_variable_334;kill h_variable_335;kill h_variable_336;kill h_variable_337;kill h_variable_338;kill h_variable_339;kill h_variable_340;kill h_variable_341;kill h_variable_342;kill h_variable_343;kill h_variable_344;kill h_variable_345;kill h_variable_346;kill h_variable_347;kill h_variable_348;kill h_variable_349;kill h_variable_350;kill h_variable_351;kill h_variable_352;kill h_variable_353;kill h_variable_354;kill h_variable_355;kill h_variable_356;kill h_variable_357;kill h_variable_358;kill h_variable_359;kill h_variable_360;kill h_variable_361;kill h_variable_362;kill h_variable_365;kill h_variable_366;kill h_variable_367;kill h_variable_368;
matrix h_variable_501 = DecideZeroRows(h_variable_499,h_variable_58);
IsZeroMatrix(h_variable_501);
nrows(h_variable_500);
def h_variable_502 = h_variable_282[9,2];
h_variable_502;
matrix h_variable_503[1][1] = 0;
matrix h_variable_504[1][3] = concat(h_variable_503,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_504); matrix h_variable_505 = h_variable_l[1]; matrix h_variable_506 = h_variable_l[2];
ncols(h_variable_505);
matrix h_variable_507 = DecideZeroRows(h_variable_505,h_variable_58);
IsZeroMatrix(h_variable_507);
nrows(h_variable_506);
def h_variable_508 = h_variable_282[8,2];
h_variable_508;
matrix h_variable_509[1][1] = 0;
matrix h_variable_510[1][3] = concat(h_variable_509,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_510); matrix h_variable_511 = h_variable_l[1]; matrix h_variable_512 = h_variable_l[2];
ncols(h_variable_511);
matrix h_variable_513 = DecideZeroRows(h_variable_511,h_variable_58);
IsZeroMatrix(h_variable_513);
nrows(h_variable_512);
def h_variable_514 = h_variable_282[7,2];
h_variable_514;
matrix h_variable_515[1][1] = 0;
matrix h_variable_516[1][3] = concat(h_variable_515,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_516); matrix h_variable_517 = h_variable_l[1]; matrix h_variable_518 = h_variable_l[2];
ncols(h_variable_517);
matrix h_variable_519 = DecideZeroRows(h_variable_517,h_variable_58);
IsZeroMatrix(h_variable_519);
nrows(h_variable_518);
def h_variable_520 = h_variable_282[6,2];
h_variable_520;
matrix h_variable_521[1][1] = 0;
matrix h_variable_522[1][3] = concat(h_variable_521,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_522); matrix h_variable_523 = h_variable_l[1]; matrix h_variable_524 = h_variable_l[2];
ncols(h_variable_523);
matrix h_variable_525 = DecideZeroRows(h_variable_523,h_variable_58);
IsZeroMatrix(h_variable_525);
nrows(h_variable_524);
def h_variable_526 = h_variable_282[5,2];
h_variable_526;
matrix h_variable_527[1][1] = 0;
matrix h_variable_528[1][3] = concat(h_variable_527,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_528); matrix h_variable_529 = h_variable_l[1]; matrix h_variable_530 = h_variable_l[2];
ncols(h_variable_529);
matrix h_variable_531 = DecideZeroRows(h_variable_529,h_variable_58);
IsZeroMatrix(h_variable_531);
nrows(h_variable_530);
def h_variable_532 = h_variable_282[4,2];
h_variable_532;
matrix h_variable_533[1][1] = 0;
matrix h_variable_534[1][3] = concat(h_variable_533,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_534); matrix h_variable_535 = h_variable_l[1]; matrix h_variable_536 = h_variable_l[2];
ncols(h_variable_535);
matrix h_variable_537 = DecideZeroRows(h_variable_535,h_variable_58);
IsZeroMatrix(h_variable_537);
nrows(h_variable_536);
def h_variable_538 = h_variable_282[3,2];
h_variable_538;
matrix h_variable_539[1][1] = 3;
matrix h_variable_540[1][3] = concat(h_variable_539,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_540); matrix h_variable_541 = h_variable_l[1]; matrix h_variable_542 = h_variable_l[2];
ncols(h_variable_541);
matrix h_variable_543 = DecideZeroRows(h_variable_541,h_variable_58);
IsZeroMatrix(h_variable_543);
ZeroRows(h_variable_543);
nrows(h_variable_542);
matrix h_variable_545 = submat(h_variable_541,1..1,intvec( 1 ));
matrix h_variable_544 = DecideZeroRows(h_variable_545,h_variable_58);
IsZeroMatrix(h_variable_544);
IsIdentityMatrix(h_variable_544);
matrix h_variable_546[1][3] = concat(h_variable_544,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_413,h_variable_546); matrix h_variable_547 = h_variable_l[1]; matrix h_variable_548 = h_variable_l[2];
IsZeroMatrix(h_variable_547);
matrix h_variable_549 = DecideZeroRows(h_variable_547,h_variable_58);
IsZeroMatrix(h_variable_549);
def h_variable_550 = h_variable_282[2,2];
h_variable_550;
matrix h_variable_551[1][1] = 0;
matrix h_variable_552[1][3] = concat(h_variable_551,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_552); matrix h_variable_553 = h_variable_l[1]; matrix h_variable_554 = h_variable_l[2];
ncols(h_variable_553);
matrix h_variable_555 = DecideZeroRows(h_variable_553,h_variable_58);
IsZeroMatrix(h_variable_555);
nrows(h_variable_554);
def h_variable_556 = h_variable_282[1,2];
h_variable_556;
matrix h_variable_557[1][1] = 0;
matrix h_variable_558[1][3] = concat(h_variable_557,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_558); matrix h_variable_559 = h_variable_l[1]; matrix h_variable_560 = h_variable_l[2];
ncols(h_variable_559);
matrix h_variable_561 = DecideZeroRows(h_variable_559,h_variable_58);
IsZeroMatrix(h_variable_561);
nrows(h_variable_560);
def h_variable_562 = h_variable_282[22,3];
h_variable_562;
matrix h_variable_563[1][1] = 0;
matrix h_variable_564[1][3] = concat(h_variable_563,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_564); matrix h_variable_565 = h_variable_l[1]; matrix h_variable_566 = h_variable_l[2];
ncols(h_variable_565);
matrix h_variable_567 = DecideZeroRows(h_variable_565,h_variable_58);
IsZeroMatrix(h_variable_567);
nrows(h_variable_566);
def h_variable_568 = h_variable_282[21,3];
h_variable_568;
matrix h_variable_569[1][1] = 0;
matrix h_variable_570[1][3] = concat(h_variable_569,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_570); matrix h_variable_571 = h_variable_l[1]; matrix h_variable_572 = h_variable_l[2];
ncols(h_variable_571);
matrix h_variable_573 = DecideZeroRows(h_variable_571,h_variable_58);
IsZeroMatrix(h_variable_573);
nrows(h_variable_572);
def h_variable_574 = h_variable_282[20,3];
h_variable_574;
matrix h_variable_575[1][1] = 0;
matrix h_variable_576[1][3] = concat(h_variable_575,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_576); matrix h_variable_577 = h_variable_l[1]; matrix h_variable_578 = h_variable_l[2];
ncols(h_variable_577);
matrix h_variable_579 = DecideZeroRows(h_variable_577,h_variable_58);
IsZeroMatrix(h_variable_579);
nrows(h_variable_578);
def h_variable_580 = h_variable_282[19,3];
h_variable_580;
matrix h_variable_581[1][1] = 0;
matrix h_variable_582[1][3] = concat(h_variable_581,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_582); matrix h_variable_583 = h_variable_l[1]; matrix h_variable_584 = h_variable_l[2];
ncols(h_variable_583);
matrix h_variable_585 = DecideZeroRows(h_variable_583,h_variable_58);
IsZeroMatrix(h_variable_585);
nrows(h_variable_584);
def h_variable_586 = h_variable_282[18,3];
h_variable_586;
matrix h_variable_587[1][1] = 0;
matrix h_variable_588[1][3] = concat(h_variable_587,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_588); matrix h_variable_589 = h_variable_l[1]; matrix h_variable_590 = h_variable_l[2];
ncols(h_variable_589);
matrix h_variable_591 = DecideZeroRows(h_variable_589,h_variable_58);
IsZeroMatrix(h_variable_591);
nrows(h_variable_590);
def h_variable_592 = h_variable_282[17,3];
h_variable_592;
matrix h_variable_593[1][1] = 0;
matrix h_variable_594[1][3] = concat(h_variable_593,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_594); matrix h_variable_595 = h_variable_l[1]; matrix h_variable_596 = h_variable_l[2];
ncols(h_variable_595);
matrix h_variable_597 = DecideZeroRows(h_variable_595,h_variable_58);
IsZeroMatrix(h_variable_597);
nrows(h_variable_596);
def h_variable_598 = h_variable_282[16,3];
h_variable_598;
matrix h_variable_599[1][1] = 0;
matrix h_variable_600[1][3] = concat(h_variable_599,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_600); matrix h_variable_601 = h_variable_l[1]; matrix h_variable_602 = h_variable_l[2];
ncols(h_variable_601);
matrix h_variable_603 = DecideZeroRows(h_variable_601,h_variable_58);
IsZeroMatrix(h_variable_603);
nrows(h_variable_602);
def h_variable_604 = h_variable_282[15,3];
h_variable_604;
matrix h_variable_605[1][1] = 0;
matrix h_variable_606[1][3] = concat(h_variable_605,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_606); matrix h_variable_607 = h_variable_l[1]; matrix h_variable_608 = h_variable_l[2];
ncols(h_variable_607);
matrix h_variable_609 = DecideZeroRows(h_variable_607,h_variable_58);
IsZeroMatrix(h_variable_609);
nrows(h_variable_608);
def h_variable_610 = h_variable_282[14,3];
h_variable_610;
matrix h_variable_611[1][1] = 0;
matrix h_variable_612[1][3] = concat(h_variable_611,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_612); matrix h_variable_613 = h_variable_l[1]; matrix h_variable_614 = h_variable_l[2];
ncols(h_variable_613);
matrix h_variable_615 = DecideZeroRows(h_variable_613,h_variable_58);
IsZeroMatrix(h_variable_615);
nrows(h_variable_614);
def h_variable_616 = h_variable_282[13,3];
h_variable_616;
matrix h_variable_617[1][1] = 0;
matrix h_variable_618[1][3] = concat(h_variable_617,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_618); matrix h_variable_619 = h_variable_l[1]; matrix h_variable_620 = h_variable_l[2];
ncols(h_variable_619);
matrix h_variable_621 = DecideZeroRows(h_variable_619,h_variable_58);
IsZeroMatrix(h_variable_621);
nrows(h_variable_620);
def h_variable_622 = h_variable_282[12,3];
h_variable_622;
matrix h_variable_623[1][1] = 0;
matrix h_variable_624[1][3] = concat(h_variable_623,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_624); matrix h_variable_625 = h_variable_l[1]; matrix h_variable_626 = h_variable_l[2];
ncols(h_variable_625);
matrix h_variable_627 = DecideZeroRows(h_variable_625,h_variable_58);
IsZeroMatrix(h_variable_627);
nrows(h_variable_626);
def h_variable_628 = h_variable_282[11,3];
h_variable_628;
matrix h_variable_629[1][1] = 0;
matrix h_variable_630[1][3] = concat(h_variable_629,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_630); matrix h_variable_631 = h_variable_l[1]; matrix h_variable_632 = h_variable_l[2];
ncols(h_variable_631);
matrix h_variable_633 = DecideZeroRows(h_variable_631,h_variable_58);
IsZeroMatrix(h_variable_633);
nrows(h_variable_632);
def h_variable_634 = h_variable_282[10,3];
h_variable_634;
matrix h_variable_635[1][1] = 0;
matrix h_variable_636[1][3] = concat(h_variable_635,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_636); matrix h_variable_637 = h_variable_l[1]; matrix h_variable_638 = h_variable_l[2];
ncols(h_variable_637);
matrix h_variable_639 = DecideZeroRows(h_variable_637,h_variable_58);
IsZeroMatrix(h_variable_639);
nrows(h_variable_638);
def h_variable_640 = h_variable_282[9,3];
h_variable_640;
matrix h_variable_641[1][1] = 0;
matrix h_variable_642[1][3] = concat(h_variable_641,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_642); matrix h_variable_643 = h_variable_l[1]; matrix h_variable_644 = h_variable_l[2];
ncols(h_variable_643);
matrix h_variable_645 = DecideZeroRows(h_variable_643,h_variable_58);
IsZeroMatrix(h_variable_645);
nrows(h_variable_644);
def h_variable_646 = h_variable_282[8,3];
h_variable_646;
matrix h_variable_647[1][1] = 0;
matrix h_variable_648[1][3] = concat(h_variable_647,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_648); matrix h_variable_649 = h_variable_l[1]; matrix h_variable_650 = h_variable_l[2];
ncols(h_variable_649);
matrix h_variable_651 = DecideZeroRows(h_variable_649,h_variable_58);
IsZeroMatrix(h_variable_651);
nrows(h_variable_650);
def h_variable_652 = h_variable_282[7,3];
h_variable_652;
matrix h_variable_653[1][1] = 0;
matrix h_variable_654[1][3] = concat(h_variable_653,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_654); matrix h_variable_655 = h_variable_l[1]; matrix h_variable_656 = h_variable_l[2];
ncols(h_variable_655);
matrix h_variable_657 = DecideZeroRows(h_variable_655,h_variable_58);
IsZeroMatrix(h_variable_657);
nrows(h_variable_656);
def h_variable_658 = h_variable_282[6,3];
h_variable_658;
matrix h_variable_659[1][1] = 0;
matrix h_variable_660[1][3] = concat(h_variable_659,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_660); matrix h_variable_661 = h_variable_l[1]; matrix h_variable_662 = h_variable_l[2];
ncols(h_variable_661);
matrix h_variable_663 = DecideZeroRows(h_variable_661,h_variable_58);
IsZeroMatrix(h_variable_663);
nrows(h_variable_662);
def h_variable_664 = h_variable_282[5,3];
h_variable_664;
matrix h_variable_665[1][1] = 0;
matrix h_variable_666[1][3] = concat(h_variable_665,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_666); matrix h_variable_667 = h_variable_l[1]; matrix h_variable_668 = h_variable_l[2];
ncols(h_variable_667);
matrix h_variable_669 = DecideZeroRows(h_variable_667,h_variable_58);
IsZeroMatrix(h_variable_669);
nrows(h_variable_668);
def h_variable_670 = h_variable_282[4,3];
h_variable_670;
matrix h_variable_671[1][1] = 3;
matrix h_variable_672[1][3] = concat(h_variable_671,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_672); matrix h_variable_673 = h_variable_l[1]; matrix h_variable_674 = h_variable_l[2];
ncols(h_variable_673);
matrix h_variable_675 = DecideZeroRows(h_variable_673,h_variable_58);
IsZeroMatrix(h_variable_675);
ZeroRows(h_variable_675);
nrows(h_variable_674);
matrix h_variable_677 = submat(h_variable_673,1..1,intvec( 1 ));
matrix h_variable_676 = DecideZeroRows(h_variable_677,h_variable_58);
IsZeroMatrix(h_variable_676);
IsIdentityMatrix(h_variable_676);
matrix h_variable_678[1][1] = unitmat(1);
matrix h_variable_679[1][3] = concat(h_variable_676,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_678,h_variable_679); matrix h_variable_680 = h_variable_l[1]; matrix h_variable_681 = h_variable_l[2];
IsZeroMatrix(h_variable_680);
matrix h_variable_682 = DecideZeroRows(h_variable_680,h_variable_58);
IsZeroMatrix(h_variable_682);
def h_variable_683 = h_variable_282[3,3];
h_variable_683;
matrix h_variable_684[1][1] = 0;
matrix h_variable_685[1][3] = concat(h_variable_684,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_685); matrix h_variable_686 = h_variable_l[1]; matrix h_variable_687 = h_variable_l[2];
ncols(h_variable_686);
matrix h_variable_688 = DecideZeroRows(h_variable_686,h_variable_58);
IsZeroMatrix(h_variable_688);
nrows(h_variable_687);
def h_variable_689 = h_variable_282[2,3];
h_variable_689;
matrix h_variable_690[1][1] = -1;
matrix h_variable_691[1][3] = concat(h_variable_690,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_691); matrix h_variable_692 = h_variable_l[1]; matrix h_variable_693 = h_variable_l[2];
ncols(h_variable_692);
matrix h_variable_694 = DecideZeroRows(h_variable_692,h_variable_58);
IsZeroMatrix(h_variable_694);
nrows(h_variable_693);
IsIdentityMatrix(h_variable_694);
def h_variable_695 = h_variable_282[1,3];
h_variable_695;
matrix h_variable_696[1][1] = 0;
matrix h_variable_697 = DecideZeroRows(h_variable_696,h_variable_58);
IsZeroMatrix(h_variable_697);
def h_variable_698 = h_variable_697[1,1];
h_variable_698==0;
def h_variable_699 = h_variable_282[2,3];
h_variable_699;
matrix h_variable_700[1][1] = -1;
matrix h_variable_701 = DecideZeroRows(h_variable_700,h_variable_58);
IsZeroMatrix(h_variable_701);
def h_variable_702 = h_variable_701[1,1];
h_variable_702==0;
def h_variable_703 = h_variable_282[3,3];
h_variable_703;
matrix h_variable_704[1][1] = 0;
matrix h_variable_705 = DecideZeroRows(h_variable_704,h_variable_58);
IsZeroMatrix(h_variable_705);
def h_variable_706 = h_variable_705[1,1];
h_variable_706==0;
def h_variable_707 = h_variable_282[4,3];
h_variable_707;
matrix h_variable_708[1][1] = 3;
matrix h_variable_709 = DecideZeroRows(h_variable_708,h_variable_58);
IsZeroMatrix(h_variable_709);
def h_variable_710 = h_variable_709[1,1];
h_variable_710==0;
def h_variable_711 = h_variable_282[5,3];
h_variable_711;
matrix h_variable_712[1][1] = 0;
matrix h_variable_713 = DecideZeroRows(h_variable_712,h_variable_58);
IsZeroMatrix(h_variable_713);
def h_variable_714 = h_variable_713[1,1];
h_variable_714==0;
def h_variable_715 = h_variable_282[6,3];
h_variable_715;
matrix h_variable_716[1][1] = 0;
matrix h_variable_717 = DecideZeroRows(h_variable_716,h_variable_58);
IsZeroMatrix(h_variable_717);
def h_variable_718 = h_variable_717[1,1];
h_variable_718==0;
def h_variable_719 = h_variable_282[7,3];
h_variable_719;
matrix h_variable_720[1][1] = 0;
matrix h_variable_721 = DecideZeroRows(h_variable_720,h_variable_58);
IsZeroMatrix(h_variable_721);
def h_variable_722 = h_variable_721[1,1];
h_variable_722==0;
def h_variable_723 = h_variable_282[8,3];
h_variable_723;
matrix h_variable_724[1][1] = 0;
matrix h_variable_725 = DecideZeroRows(h_variable_724,h_variable_58);
IsZeroMatrix(h_variable_725);
def h_variable_726 = h_variable_725[1,1];
h_variable_726==0;
def h_variable_727 = h_variable_282[9,3];
h_variable_727;
matrix h_variable_728[1][1] = 0;
matrix h_variable_729 = DecideZeroRows(h_variable_728,h_variable_58);
IsZeroMatrix(h_variable_729);
def h_variable_730 = h_variable_729[1,1];
h_variable_730==0;
def h_variable_731 = h_variable_282[10,3];
h_variable_731;
matrix h_variable_732[1][1] = 0;
matrix h_variable_733 = DecideZeroRows(h_variable_732,h_variable_58);
IsZeroMatrix(h_variable_733);
def h_variable_734 = h_variable_733[1,1];
h_variable_734==0;
def h_variable_735 = h_variable_282[11,3];
h_variable_735;
matrix h_variable_736[1][1] = 0;
matrix h_variable_737 = DecideZeroRows(h_variable_736,h_variable_58);
IsZeroMatrix(h_variable_737);
def h_variable_738 = h_variable_737[1,1];
h_variable_738==0;
def h_variable_739 = h_variable_282[12,3];
h_variable_739;
matrix h_variable_740[1][1] = 0;
matrix h_variable_741 = DecideZeroRows(h_variable_740,h_variable_58);
IsZeroMatrix(h_variable_741);
def h_variable_742 = h_variable_741[1,1];
h_variable_742==0;
def h_variable_743 = h_variable_282[13,3];
h_variable_743;
matrix h_variable_744[1][1] = 0;
matrix h_variable_745 = DecideZeroRows(h_variable_744,h_variable_58);
IsZeroMatrix(h_variable_745);
def h_variable_746 = h_variable_745[1,1];
h_variable_746==0;
def h_variable_747 = h_variable_282[14,3];
h_variable_747;
matrix h_variable_748[1][1] = 0;
matrix h_variable_749 = DecideZeroRows(h_variable_748,h_variable_58);
IsZeroMatrix(h_variable_749);
def h_variable_750 = h_variable_749[1,1];
h_variable_750==0;
def h_variable_751 = h_variable_282[15,3];
h_variable_751;
matrix h_variable_752[1][1] = 0;
matrix h_variable_753 = DecideZeroRows(h_variable_752,h_variable_58);
IsZeroMatrix(h_variable_753);
def h_variable_754 = h_variable_753[1,1];
h_variable_754==0;
def h_variable_755 = h_variable_282[16,3];
h_variable_755;
matrix h_variable_756[1][1] = 0;
matrix h_variable_757 = DecideZeroRows(h_variable_756,h_variable_58);
IsZeroMatrix(h_variable_757);
def h_variable_758 = h_variable_757[1,1];
h_variable_758==0;
def h_variable_759 = h_variable_282[17,3];
h_variable_759;
matrix h_variable_760[1][1] = 0;
matrix h_variable_761 = DecideZeroRows(h_variable_760,h_variable_58);
IsZeroMatrix(h_variable_761);
def h_variable_762 = h_variable_761[1,1];
h_variable_762==0;
def h_variable_763 = h_variable_282[18,3];
h_variable_763;
matrix h_variable_764[1][1] = 0;
matrix h_variable_765 = DecideZeroRows(h_variable_764,h_variable_58);
IsZeroMatrix(h_variable_765);
def h_variable_766 = h_variable_765[1,1];
h_variable_766==0;
def h_variable_767 = h_variable_282[19,3];
h_variable_767;
matrix h_variable_768[1][1] = 0;
matrix h_variable_769 = DecideZeroRows(h_variable_768,h_variable_58);
IsZeroMatrix(h_variable_769);
def h_variable_770 = h_variable_769[1,1];
h_variable_770==0;
def h_variable_771 = h_variable_282[20,3];
h_variable_771;
matrix h_variable_772[1][1] = 0;
matrix h_variable_773 = DecideZeroRows(h_variable_772,h_variable_58);
IsZeroMatrix(h_variable_773);
def h_variable_774 = h_variable_773[1,1];
h_variable_774==0;
def h_variable_775 = h_variable_282[21,3];
h_variable_775;
matrix h_variable_776[1][1] = 0;
matrix h_variable_777 = DecideZeroRows(h_variable_776,h_variable_58);
IsZeroMatrix(h_variable_777);
def h_variable_778 = h_variable_777[1,1];
h_variable_778==0;
def h_variable_779 = h_variable_282[22,3];
h_variable_779;
matrix h_variable_780[1][1] = 0;
matrix h_variable_781 = DecideZeroRows(h_variable_780,h_variable_58);
IsZeroMatrix(h_variable_781);
def h_variable_782 = h_variable_781[1,1];
h_variable_782==0;
def h_variable_783 = h_variable_282[22,4];
h_variable_783;
matrix h_variable_784[1][1] = 0;
matrix h_variable_785[1][3] = concat(h_variable_784,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_785); matrix h_variable_786 = h_variable_l[1]; matrix h_variable_787 = h_variable_l[2];
ncols(h_variable_786);
matrix h_variable_788 = DecideZeroRows(h_variable_786,h_variable_58);
IsZeroMatrix(h_variable_788);
nrows(h_variable_787);
def h_variable_789 = h_variable_282[21,4];
h_variable_789;
matrix h_variable_790[1][1] = 0;
matrix h_variable_791[1][3] = concat(h_variable_790,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_791); matrix h_variable_792 = h_variable_l[1]; matrix h_variable_793 = h_variable_l[2];
ncols(h_variable_792);
matrix h_variable_794 = DecideZeroRows(h_variable_792,h_variable_58);
IsZeroMatrix(h_variable_794);
nrows(h_variable_793);
def h_variable_795 = h_variable_282[20,4];
h_variable_795;
matrix h_variable_796[1][1] = 0;
matrix h_variable_797[1][3] = concat(h_variable_796,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_797); matrix h_variable_798 = h_variable_l[1]; matrix h_variable_799 = h_variable_l[2];
ncols(h_variable_798);
matrix h_variable_800 = DecideZeroRows(h_variable_798,h_variable_58);
IsZeroMatrix(h_variable_800);
nrows(h_variable_799);
def h_variable_801 = h_variable_282[19,4];
h_variable_801;
matrix h_variable_802[1][1] = 0;
matrix h_variable_803[1][3] = concat(h_variable_802,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_803); matrix h_variable_804 = h_variable_l[1]; matrix h_variable_805 = h_variable_l[2];
ncols(h_variable_804);
matrix h_variable_806 = DecideZeroRows(h_variable_804,h_variable_58);
IsZeroMatrix(h_variable_806);
nrows(h_variable_805);
def h_variable_807 = h_variable_282[18,4];
h_variable_807;
matrix h_variable_808[1][1] = 0;
matrix h_variable_809[1][3] = concat(h_variable_808,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_809); matrix h_variable_810 = h_variable_l[1]; matrix h_variable_811 = h_variable_l[2];
ncols(h_variable_810);
matrix h_variable_812 = DecideZeroRows(h_variable_810,h_variable_58);
IsZeroMatrix(h_variable_812);
nrows(h_variable_811);
def h_variable_813 = h_variable_282[17,4];
h_variable_813;
matrix h_variable_814[1][1] = 0;
matrix h_variable_815[1][3] = concat(h_variable_814,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_815); matrix h_variable_816 = h_variable_l[1]; matrix h_variable_817 = h_variable_l[2];
ncols(h_variable_816);
matrix h_variable_818 = DecideZeroRows(h_variable_816,h_variable_58);
IsZeroMatrix(h_variable_818);
nrows(h_variable_817);
def h_variable_819 = h_variable_282[16,4];
h_variable_819;
matrix h_variable_820[1][1] = 0;
matrix h_variable_821[1][3] = concat(h_variable_820,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_821); matrix h_variable_822 = h_variable_l[1]; matrix h_variable_823 = h_variable_l[2];
ncols(h_variable_822);
matrix h_variable_824 = DecideZeroRows(h_variable_822,h_variable_58);
IsZeroMatrix(h_variable_824);
nrows(h_variable_823);
def h_variable_825 = h_variable_282[15,4];
h_variable_825;
matrix h_variable_826[1][1] = 0;
matrix h_variable_827[1][3] = concat(h_variable_826,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_827); matrix h_variable_828 = h_variable_l[1]; matrix h_variable_829 = h_variable_l[2];
ncols(h_variable_828);
matrix h_variable_830 = DecideZeroRows(h_variable_828,h_variable_58);
IsZeroMatrix(h_variable_830);
nrows(h_variable_829);
def h_variable_831 = h_variable_282[14,4];
h_variable_831;
matrix h_variable_832[1][1] = 0;
matrix h_variable_833[1][3] = concat(h_variable_832,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_833); matrix h_variable_834 = h_variable_l[1]; matrix h_variable_835 = h_variable_l[2];
ncols(h_variable_834);
matrix h_variable_836 = DecideZeroRows(h_variable_834,h_variable_58);
IsZeroMatrix(h_variable_836);
nrows(h_variable_835);
def h_variable_837 = h_variable_282[13,4];
h_variable_837;
matrix h_variable_838[1][1] = 0;
matrix h_variable_839[1][3] = concat(h_variable_838,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_839); matrix h_variable_840 = h_variable_l[1]; matrix h_variable_841 = h_variable_l[2];
ncols(h_variable_840);
matrix h_variable_842 = DecideZeroRows(h_variable_840,h_variable_58);
IsZeroMatrix(h_variable_842);
nrows(h_variable_841);
def h_variable_843 = h_variable_282[12,4];
h_variable_843;
matrix h_variable_844[1][1] = 0;
matrix h_variable_845[1][3] = concat(h_variable_844,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_845); matrix h_variable_846 = h_variable_l[1]; matrix h_variable_847 = h_variable_l[2];
ncols(h_variable_846);
matrix h_variable_848 = DecideZeroRows(h_variable_846,h_variable_58);
IsZeroMatrix(h_variable_848);
nrows(h_variable_847);
def h_variable_849 = h_variable_282[11,4];
h_variable_849;
matrix h_variable_850[1][1] = 0;
matrix h_variable_851[1][3] = concat(h_variable_850,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_851); matrix h_variable_852 = h_variable_l[1]; matrix h_variable_853 = h_variable_l[2];
ncols(h_variable_852);
matrix h_variable_854 = DecideZeroRows(h_variable_852,h_variable_58);
IsZeroMatrix(h_variable_854);
nrows(h_variable_853);
def h_variable_855 = h_variable_282[10,4];
h_variable_855;
matrix h_variable_856[1][1] = 0;
matrix h_variable_857[1][3] = concat(h_variable_856,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_857); matrix h_variable_858 = h_variable_l[1]; matrix h_variable_859 = h_variable_l[2];
ncols(h_variable_858);
matrix h_variable_860 = DecideZeroRows(h_variable_858,h_variable_58);
IsZeroMatrix(h_variable_860);
nrows(h_variable_859);
def h_variable_861 = h_variable_282[9,4];
h_variable_861;
matrix h_variable_862[1][1] = 0;
matrix h_variable_863[1][3] = concat(h_variable_862,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_863); matrix h_variable_864 = h_variable_l[1]; matrix h_variable_865 = h_variable_l[2];
ncols(h_variable_864);
matrix h_variable_866 = DecideZeroRows(h_variable_864,h_variable_58);
IsZeroMatrix(h_variable_866);
nrows(h_variable_865);
def h_variable_867 = h_variable_282[8,4];
h_variable_867;
matrix h_variable_868[1][1] = 0;
matrix h_variable_869[1][3] = concat(h_variable_868,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_869); matrix h_variable_870 = h_variable_l[1]; matrix h_variable_871 = h_variable_l[2];
ncols(h_variable_870);
matrix h_variable_872 = DecideZeroRows(h_variable_870,h_variable_58);
IsZeroMatrix(h_variable_872);
nrows(h_variable_871);
def h_variable_873 = h_variable_282[7,4];
h_variable_873;
matrix h_variable_874[1][1] = 0;
matrix h_variable_875[1][3] = concat(h_variable_874,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_875); matrix h_variable_876 = h_variable_l[1]; matrix h_variable_877 = h_variable_l[2];
ncols(h_variable_876);
matrix h_variable_878 = DecideZeroRows(h_variable_876,h_variable_58);
IsZeroMatrix(h_variable_878);
nrows(h_variable_877);
def h_variable_879 = h_variable_282[6,4];
h_variable_879;
matrix h_variable_880[1][1] = -2;
matrix h_variable_881[1][3] = concat(h_variable_880,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_881); matrix h_variable_882 = h_variable_l[1]; matrix h_variable_883 = h_variable_l[2];
ncols(h_variable_882);
matrix h_variable_884 = DecideZeroRows(h_variable_882,h_variable_58);
IsZeroMatrix(h_variable_884);
ZeroRows(h_variable_884);
nrows(h_variable_883);
matrix h_variable_886 = submat(h_variable_882,1..1,intvec( 1 ));
matrix h_variable_885 = DecideZeroRows(h_variable_886,h_variable_58);
IsZeroMatrix(h_variable_885);
IsIdentityMatrix(h_variable_885);
matrix h_variable_887[1][1] = unitmat(1);
matrix h_variable_888[1][3] = concat(h_variable_885,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_887,h_variable_888); matrix h_variable_889 = h_variable_l[1]; matrix h_variable_890 = h_variable_l[2];
IsZeroMatrix(h_variable_889);
matrix h_variable_891 = DecideZeroRows(h_variable_889,h_variable_58);
IsZeroMatrix(h_variable_891);
def h_variable_892 = h_variable_282[5,4];
h_variable_892;
matrix h_variable_893[1][1] = 0;
matrix h_variable_894[1][3] = concat(h_variable_893,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_894); matrix h_variable_895 = h_variable_l[1]; matrix h_variable_896 = h_variable_l[2];
ncols(h_variable_895);
matrix h_variable_897 = DecideZeroRows(h_variable_895,h_variable_58);
IsZeroMatrix(h_variable_897);
nrows(h_variable_896);
def h_variable_898 = h_variable_282[3,4];
h_variable_898;
matrix h_variable_899[1][1] = x2;
matrix h_variable_900[1][3] = concat(h_variable_899,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_900); matrix h_variable_901 = h_variable_l[1]; matrix h_variable_902 = h_variable_l[2];
ncols(h_variable_901);
matrix h_variable_903 = DecideZeroRows(h_variable_901,h_variable_58);
IsZeroMatrix(h_variable_903);
ZeroRows(h_variable_903);
nrows(h_variable_902);
matrix h_variable_905 = submat(h_variable_901,1..1,intvec( 2 ));
matrix h_variable_904 = DecideZeroRows(h_variable_905,h_variable_58);
IsZeroMatrix(h_variable_904);
IsIdentityMatrix(h_variable_904);
matrix h_variable_906[1][3] = concat(h_variable_904,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_887,h_variable_906); matrix h_variable_907 = h_variable_l[1]; matrix h_variable_908 = h_variable_l[2];
IsZeroMatrix(h_variable_907);
matrix h_variable_909 = DecideZeroRows(h_variable_907,h_variable_58);
IsZeroMatrix(h_variable_909);
def h_variable_910 = h_variable_282[1,4];
h_variable_910;
matrix h_variable_911[1][1] = 0;
matrix h_variable_912[1][3] = concat(h_variable_911,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_912); matrix h_variable_913 = h_variable_l[1]; matrix h_variable_914 = h_variable_l[2];
ncols(h_variable_913);
matrix h_variable_915 = DecideZeroRows(h_variable_913,h_variable_58);
IsZeroMatrix(h_variable_915);
nrows(h_variable_914);
def h_variable_916 = h_variable_282[22,5];
h_variable_916;
matrix h_variable_917[1][1] = 0;
matrix h_variable_918[1][3] = concat(h_variable_917,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_918); matrix h_variable_919 = h_variable_l[1]; matrix h_variable_920 = h_variable_l[2];
ncols(h_variable_919);
matrix h_variable_921 = DecideZeroRows(h_variable_919,h_variable_58);
IsZeroMatrix(h_variable_921);
nrows(h_variable_920);
def h_variable_922 = h_variable_282[21,5];
h_variable_922;
matrix h_variable_923[1][1] = 0;
matrix h_variable_924[1][3] = concat(h_variable_923,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_924); matrix h_variable_925 = h_variable_l[1]; matrix h_variable_926 = h_variable_l[2];
ncols(h_variable_925);
matrix h_variable_927 = DecideZeroRows(h_variable_925,h_variable_58);
IsZeroMatrix(h_variable_927);
nrows(h_variable_926);
def h_variable_928 = h_variable_282[20,5];
h_variable_928;
matrix h_variable_929[1][1] = 0;
matrix h_variable_930[1][3] = concat(h_variable_929,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_930); matrix h_variable_931 = h_variable_l[1]; matrix h_variable_932 = h_variable_l[2];
ncols(h_variable_931);
matrix h_variable_933 = DecideZeroRows(h_variable_931,h_variable_58);
IsZeroMatrix(h_variable_933);
nrows(h_variable_932);
def h_variable_934 = h_variable_282[19,5];
h_variable_934;
matrix h_variable_935[1][1] = 0;
matrix h_variable_936[1][3] = concat(h_variable_935,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_936); matrix h_variable_937 = h_variable_l[1]; matrix h_variable_938 = h_variable_l[2];
ncols(h_variable_937);
matrix h_variable_939 = DecideZeroRows(h_variable_937,h_variable_58);
IsZeroMatrix(h_variable_939);
nrows(h_variable_938);
def h_variable_940 = h_variable_282[18,5];
h_variable_940;
matrix h_variable_941[1][1] = -3;
matrix h_variable_942[1][3] = concat(h_variable_941,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_942); matrix h_variable_943 = h_variable_l[1]; matrix h_variable_944 = h_variable_l[2];
ncols(h_variable_943);
matrix h_variable_945 = DecideZeroRows(h_variable_943,h_variable_58);
IsZeroMatrix(h_variable_945);
ZeroRows(h_variable_945);
nrows(h_variable_944);
matrix h_variable_947 = submat(h_variable_943,1..1,intvec( 1 ));
matrix h_variable_946 = DecideZeroRows(h_variable_947,h_variable_58);
IsZeroMatrix(h_variable_946);
IsIdentityMatrix(h_variable_946);
matrix h_variable_948[1][3] = concat(h_variable_946,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_887,h_variable_948); matrix h_variable_949 = h_variable_l[1]; matrix h_variable_950 = h_variable_l[2];
IsZeroMatrix(h_variable_949);
matrix h_variable_951 = DecideZeroRows(h_variable_949,h_variable_58);
IsZeroMatrix(h_variable_951);
def h_variable_952 = h_variable_282[17,5];
h_variable_952;
matrix h_variable_953[1][1] = -3;
matrix h_variable_954[1][3] = concat(h_variable_953,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_954); matrix h_variable_955 = h_variable_l[1]; matrix h_variable_956 = h_variable_l[2];
ncols(h_variable_955);
matrix h_variable_957 = DecideZeroRows(h_variable_955,h_variable_58);
IsZeroMatrix(h_variable_957);
ZeroRows(h_variable_957);
nrows(h_variable_956);
matrix h_variable_959 = submat(h_variable_955,1..1,intvec( 1 ));
matrix h_variable_958 = DecideZeroRows(h_variable_959,h_variable_58);
IsZeroMatrix(h_variable_958);
IsIdentityMatrix(h_variable_958);
matrix h_variable_960[1][3] = concat(h_variable_958,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_887,h_variable_960); matrix h_variable_961 = h_variable_l[1]; matrix h_variable_962 = h_variable_l[2];
IsZeroMatrix(h_variable_961);
matrix h_variable_963 = DecideZeroRows(h_variable_961,h_variable_58);
IsZeroMatrix(h_variable_963);
def h_variable_964 = h_variable_282[16,5];
h_variable_964;
matrix h_variable_965[1][1] = 0;
matrix h_variable_966[1][3] = concat(h_variable_965,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_966); matrix h_variable_967 = h_variable_l[1]; matrix h_variable_968 = h_variable_l[2];
ncols(h_variable_967);
matrix h_variable_969 = DecideZeroRows(h_variable_967,h_variable_58);
IsZeroMatrix(h_variable_969);
nrows(h_variable_968);
def h_variable_970 = h_variable_282[15,5];
h_variable_970;
matrix h_variable_971[1][1] = 0;
matrix h_variable_972[1][3] = concat(h_variable_971,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_972); matrix h_variable_973 = h_variable_l[1]; matrix h_variable_974 = h_variable_l[2];
ncols(h_variable_973);
matrix h_variable_975 = DecideZeroRows(h_variable_973,h_variable_58);
IsZeroMatrix(h_variable_975);
nrows(h_variable_974);
def h_variable_976 = h_variable_282[14,5];
h_variable_976;
matrix h_variable_977[1][1] = 0;
matrix h_variable_978[1][3] = concat(h_variable_977,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_978); matrix h_variable_979 = h_variable_l[1]; matrix h_variable_980 = h_variable_l[2];
ncols(h_variable_979);
matrix h_variable_981 = DecideZeroRows(h_variable_979,h_variable_58);
IsZeroMatrix(h_variable_981);
nrows(h_variable_980);
def h_variable_982 = h_variable_282[13,5];
h_variable_982;
matrix h_variable_983[1][1] = 0;
matrix h_variable_984[1][3] = concat(h_variable_983,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_984); matrix h_variable_985 = h_variable_l[1]; matrix h_variable_986 = h_variable_l[2];
ncols(h_variable_985);
matrix h_variable_987 = DecideZeroRows(h_variable_985,h_variable_58);
IsZeroMatrix(h_variable_987);
nrows(h_variable_986);
def h_variable_988 = h_variable_282[12,5];
h_variable_988;
matrix h_variable_989[1][1] = 0;
matrix h_variable_990[1][3] = concat(h_variable_989,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_990); matrix h_variable_991 = h_variable_l[1]; matrix h_variable_992 = h_variable_l[2];
ncols(h_variable_991);
matrix h_variable_993 = DecideZeroRows(h_variable_991,h_variable_58);
IsZeroMatrix(h_variable_993);
nrows(h_variable_992);
def h_variable_994 = h_variable_282[11,5];
h_variable_994;
matrix h_variable_995[1][1] = 3*x2;
matrix h_variable_996[1][3] = concat(h_variable_995,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_996); matrix h_variable_997 = h_variable_l[1]; matrix h_variable_998 = h_variable_l[2];
ncols(h_variable_997);
matrix h_variable_999 = DecideZeroRows(h_variable_997,h_variable_58);
IsZeroMatrix(h_variable_999);
ZeroRows(h_variable_999);
nrows(h_variable_998);
kill h_variable_371;kill h_variable_372;kill h_variable_373;kill h_variable_374;kill h_variable_376;kill h_variable_377;kill h_variable_378;kill h_variable_379;kill h_variable_380;kill h_variable_382;kill h_variable_383;kill h_variable_384;kill h_variable_385;kill h_variable_386;kill h_variable_387;kill h_variable_388;kill h_variable_389;kill h_variable_390;kill h_variable_391;kill h_variable_392;kill h_variable_393;kill h_variable_394;kill h_variable_395;kill h_variable_396;kill h_variable_397;kill h_variable_398;kill h_variable_399;kill h_variable_400;kill h_variable_401;kill h_variable_402;kill h_variable_403;kill h_variable_404;kill h_variable_405;kill h_variable_406;kill h_variable_407;kill h_variable_408;kill h_variable_409;kill h_variable_410;kill h_variable_411;kill h_variable_412;kill h_variable_413;kill h_variable_414;kill h_variable_415;kill h_variable_416;kill h_variable_417;kill h_variable_418;kill h_variable_419;kill h_variable_420;kill h_variable_421;kill h_variable_422;kill h_variable_423;kill h_variable_424;kill h_variable_425;kill h_variable_426;kill h_variable_427;kill h_variable_428;kill h_variable_429;kill h_variable_430;kill h_variable_431;kill h_variable_432;kill h_variable_433;kill h_variable_434;kill h_variable_435;kill h_variable_436;kill h_variable_437;kill h_variable_438;kill h_variable_439;kill h_variable_440;kill h_variable_441;kill h_variable_442;kill h_variable_443;kill h_variable_444;kill h_variable_445;kill h_variable_446;kill h_variable_447;kill h_variable_448;kill h_variable_449;kill h_variable_450;kill h_variable_451;kill h_variable_452;kill h_variable_453;kill h_variable_454;kill h_variable_455;kill h_variable_456;kill h_variable_457;kill h_variable_458;kill h_variable_459;kill h_variable_460;kill h_variable_461;kill h_variable_462;kill h_variable_463;kill h_variable_464;kill h_variable_465;kill h_variable_466;kill h_variable_467;kill h_variable_468;kill h_variable_469;kill h_variable_470;kill h_variable_471;kill h_variable_472;kill h_variable_473;kill h_variable_474;kill h_variable_475;kill h_variable_476;kill h_variable_477;kill h_variable_478;kill h_variable_479;kill h_variable_480;kill h_variable_481;kill h_variable_482;kill h_variable_483;kill h_variable_484;kill h_variable_485;kill h_variable_486;kill h_variable_487;kill h_variable_488;kill h_variable_489;kill h_variable_490;kill h_variable_491;kill h_variable_492;kill h_variable_493;kill h_variable_494;kill h_variable_495;kill h_variable_496;kill h_variable_497;kill h_variable_498;kill h_variable_499;kill h_variable_500;kill h_variable_501;kill h_variable_502;kill h_variable_503;kill h_variable_504;kill h_variable_505;kill h_variable_506;kill h_variable_507;kill h_variable_508;kill h_variable_509;kill h_variable_510;kill h_variable_511;kill h_variable_512;kill h_variable_513;kill h_variable_514;kill h_variable_515;kill h_variable_516;kill h_variable_517;kill h_variable_518;kill h_variable_519;kill h_variable_520;kill h_variable_521;kill h_variable_522;kill h_variable_523;kill h_variable_524;kill h_variable_525;kill h_variable_526;kill h_variable_527;kill h_variable_528;kill h_variable_529;kill h_variable_530;kill h_variable_531;kill h_variable_532;kill h_variable_533;kill h_variable_534;kill h_variable_535;kill h_variable_536;kill h_variable_537;kill h_variable_538;kill h_variable_539;kill h_variable_540;kill h_variable_541;kill h_variable_542;kill h_variable_543;kill h_variable_544;kill h_variable_545;kill h_variable_546;kill h_variable_547;kill h_variable_548;kill h_variable_549;kill h_variable_550;kill h_variable_551;kill h_variable_552;kill h_variable_553;kill h_variable_554;kill h_variable_555;kill h_variable_564;kill h_variable_565;kill h_variable_566;kill h_variable_567;kill h_variable_569;kill h_variable_570;kill h_variable_571;kill h_variable_572;kill h_variable_573;kill h_variable_575;kill h_variable_576;kill h_variable_577;kill h_variable_578;kill h_variable_579;kill h_variable_580;kill h_variable_581;kill h_variable_582;kill h_variable_583;kill h_variable_584;kill h_variable_585;kill h_variable_586;kill h_variable_587;kill h_variable_588;kill h_variable_589;kill h_variable_590;kill h_variable_591;kill h_variable_592;kill h_variable_593;kill h_variable_594;kill h_variable_595;kill h_variable_596;kill h_variable_597;kill h_variable_598;kill h_variable_599;kill h_variable_600;kill h_variable_601;kill h_variable_602;kill h_variable_603;kill h_variable_604;kill h_variable_605;kill h_variable_606;kill h_variable_607;kill h_variable_608;kill h_variable_609;kill h_variable_610;kill h_variable_611;kill h_variable_612;kill h_variable_613;kill h_variable_614;kill h_variable_615;kill h_variable_616;kill h_variable_617;kill h_variable_618;kill h_variable_619;kill h_variable_620;kill h_variable_621;kill h_variable_622;kill h_variable_623;kill h_variable_624;kill h_variable_625;kill h_variable_626;kill h_variable_627;kill h_variable_628;kill h_variable_629;kill h_variable_630;kill h_variable_631;kill h_variable_632;kill h_variable_633;kill h_variable_634;kill h_variable_635;kill h_variable_636;kill h_variable_637;kill h_variable_638;kill h_variable_639;kill h_variable_640;kill h_variable_641;kill h_variable_642;kill h_variable_643;kill h_variable_644;kill h_variable_645;kill h_variable_646;kill h_variable_647;kill h_variable_648;kill h_variable_649;kill h_variable_650;kill h_variable_651;kill h_variable_652;kill h_variable_653;kill h_variable_654;kill h_variable_655;kill h_variable_656;kill h_variable_657;kill h_variable_658;kill h_variable_659;kill h_variable_660;kill h_variable_661;kill h_variable_662;kill h_variable_663;kill h_variable_664;kill h_variable_665;kill h_variable_666;kill h_variable_667;kill h_variable_668;kill h_variable_669;kill h_variable_670;kill h_variable_671;kill h_variable_672;kill h_variable_673;kill h_variable_674;kill h_variable_675;kill h_variable_676;kill h_variable_677;kill h_variable_678;kill h_variable_679;kill h_variable_680;kill h_variable_681;kill h_variable_682;kill h_variable_683;kill h_variable_684;kill h_variable_685;kill h_variable_686;kill h_variable_687;kill h_variable_688;kill h_variable_689;kill h_variable_690;kill h_variable_691;kill h_variable_692;kill h_variable_693;kill h_variable_694;kill h_variable_695;kill h_variable_696;kill h_variable_697;kill h_variable_698;kill h_variable_699;kill h_variable_700;kill h_variable_701;kill h_variable_702;kill h_variable_703;kill h_variable_704;kill h_variable_705;kill h_variable_706;kill h_variable_707;kill h_variable_708;kill h_variable_709;kill h_variable_710;kill h_variable_711;kill h_variable_712;kill h_variable_713;kill h_variable_714;kill h_variable_715;kill h_variable_716;kill h_variable_717;kill h_variable_718;kill h_variable_719;kill h_variable_720;kill h_variable_721;kill h_variable_722;kill h_variable_723;kill h_variable_724;kill h_variable_725;kill h_variable_726;kill h_variable_727;kill h_variable_728;kill h_variable_729;kill h_variable_730;kill h_variable_731;kill h_variable_732;kill h_variable_733;kill h_variable_734;kill h_variable_735;kill h_variable_736;kill h_variable_737;kill h_variable_738;kill h_variable_739;kill h_variable_740;kill h_variable_741;kill h_variable_742;kill h_variable_743;kill h_variable_744;kill h_variable_745;kill h_variable_746;kill h_variable_747;kill h_variable_748;kill h_variable_749;kill h_variable_750;kill h_variable_751;kill h_variable_752;kill h_variable_753;kill h_variable_754;kill h_variable_755;kill h_variable_756;kill h_variable_757;kill h_variable_758;kill h_variable_759;kill h_variable_760;kill h_variable_761;kill h_variable_762;kill h_variable_763;kill h_variable_764;kill h_variable_765;kill h_variable_766;kill h_variable_767;kill h_variable_768;kill h_variable_769;kill h_variable_770;kill h_variable_771;kill h_variable_772;kill h_variable_773;kill h_variable_774;kill h_variable_775;kill h_variable_776;kill h_variable_777;kill h_variable_778;kill h_variable_779;kill h_variable_780;kill h_variable_781;kill h_variable_782;kill h_variable_783;kill h_variable_784;kill h_variable_785;kill h_variable_786;kill h_variable_787;kill h_variable_788;kill h_variable_789;kill h_variable_790;kill h_variable_791;kill h_variable_792;kill h_variable_793;kill h_variable_794;kill h_variable_795;kill h_variable_796;kill h_variable_797;kill h_variable_798;kill h_variable_799;kill h_variable_800;kill h_variable_803;kill h_variable_804;kill h_variable_805;kill h_variable_806;
matrix h_variable_1001 = submat(h_variable_997,1..1,intvec( 2 ));
matrix h_variable_1000 = DecideZeroRows(h_variable_1001,h_variable_58);
IsZeroMatrix(h_variable_1000);
IsIdentityMatrix(h_variable_1000);
matrix h_variable_1002[1][1] = unitmat(1);
matrix h_variable_1003[1][3] = concat(h_variable_1000,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1003); matrix h_variable_1004 = h_variable_l[1]; matrix h_variable_1005 = h_variable_l[2];
IsZeroMatrix(h_variable_1004);
matrix h_variable_1006 = DecideZeroRows(h_variable_1004,h_variable_58);
IsZeroMatrix(h_variable_1006);
def h_variable_1007 = h_variable_282[10,5];
h_variable_1007;
matrix h_variable_1008[1][1] = 0;
matrix h_variable_1009[1][3] = concat(h_variable_1008,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1009); matrix h_variable_1010 = h_variable_l[1]; matrix h_variable_1011 = h_variable_l[2];
ncols(h_variable_1010);
matrix h_variable_1012 = DecideZeroRows(h_variable_1010,h_variable_58);
IsZeroMatrix(h_variable_1012);
nrows(h_variable_1011);
def h_variable_1013 = h_variable_282[9,5];
h_variable_1013;
matrix h_variable_1014[1][1] = 0;
matrix h_variable_1015[1][3] = concat(h_variable_1014,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1015); matrix h_variable_1016 = h_variable_l[1]; matrix h_variable_1017 = h_variable_l[2];
ncols(h_variable_1016);
matrix h_variable_1018 = DecideZeroRows(h_variable_1016,h_variable_58);
IsZeroMatrix(h_variable_1018);
nrows(h_variable_1017);
def h_variable_1019 = h_variable_282[8,5];
h_variable_1019;
matrix h_variable_1020[1][1] = 0;
matrix h_variable_1021[1][3] = concat(h_variable_1020,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1021); matrix h_variable_1022 = h_variable_l[1]; matrix h_variable_1023 = h_variable_l[2];
ncols(h_variable_1022);
matrix h_variable_1024 = DecideZeroRows(h_variable_1022,h_variable_58);
IsZeroMatrix(h_variable_1024);
nrows(h_variable_1023);
def h_variable_1025 = h_variable_282[7,5];
h_variable_1025;
matrix h_variable_1026[1][1] = 0;
matrix h_variable_1027[1][3] = concat(h_variable_1026,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1027); matrix h_variable_1028 = h_variable_l[1]; matrix h_variable_1029 = h_variable_l[2];
ncols(h_variable_1028);
matrix h_variable_1030 = DecideZeroRows(h_variable_1028,h_variable_58);
IsZeroMatrix(h_variable_1030);
nrows(h_variable_1029);
def h_variable_1031 = h_variable_282[6,5];
h_variable_1031;
matrix h_variable_1032[1][1] = 0;
matrix h_variable_1033[1][3] = concat(h_variable_1032,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1033); matrix h_variable_1034 = h_variable_l[1]; matrix h_variable_1035 = h_variable_l[2];
ncols(h_variable_1034);
matrix h_variable_1036 = DecideZeroRows(h_variable_1034,h_variable_58);
IsZeroMatrix(h_variable_1036);
nrows(h_variable_1035);
def h_variable_1037 = h_variable_282[5,5];
h_variable_1037;
matrix h_variable_1038[1][1] = 0;
matrix h_variable_1039[1][3] = concat(h_variable_1038,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1039); matrix h_variable_1040 = h_variable_l[1]; matrix h_variable_1041 = h_variable_l[2];
ncols(h_variable_1040);
matrix h_variable_1042 = DecideZeroRows(h_variable_1040,h_variable_58);
IsZeroMatrix(h_variable_1042);
nrows(h_variable_1041);
def h_variable_1043 = h_variable_282[3,5];
h_variable_1043;
matrix h_variable_1044[1][1] = 0;
matrix h_variable_1045[1][3] = concat(h_variable_1044,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1045); matrix h_variable_1046 = h_variable_l[1]; matrix h_variable_1047 = h_variable_l[2];
ncols(h_variable_1046);
matrix h_variable_1048 = DecideZeroRows(h_variable_1046,h_variable_58);
IsZeroMatrix(h_variable_1048);
nrows(h_variable_1047);
def h_variable_1049 = h_variable_282[1,5];
h_variable_1049;
matrix h_variable_1050[1][1] = 0;
matrix h_variable_1051[1][3] = concat(h_variable_1050,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1051); matrix h_variable_1052 = h_variable_l[1]; matrix h_variable_1053 = h_variable_l[2];
ncols(h_variable_1052);
matrix h_variable_1054 = DecideZeroRows(h_variable_1052,h_variable_58);
IsZeroMatrix(h_variable_1054);
nrows(h_variable_1053);
def h_variable_1055 = h_variable_282[22,6];
h_variable_1055;
matrix h_variable_1056[1][1] = 0;
matrix h_variable_1057[1][3] = concat(h_variable_1056,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1057); matrix h_variable_1058 = h_variable_l[1]; matrix h_variable_1059 = h_variable_l[2];
ncols(h_variable_1058);
matrix h_variable_1060 = DecideZeroRows(h_variable_1058,h_variable_58);
IsZeroMatrix(h_variable_1060);
nrows(h_variable_1059);
def h_variable_1061 = h_variable_282[21,6];
h_variable_1061;
matrix h_variable_1062[1][1] = 0;
matrix h_variable_1063[1][3] = concat(h_variable_1062,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1063); matrix h_variable_1064 = h_variable_l[1]; matrix h_variable_1065 = h_variable_l[2];
ncols(h_variable_1064);
matrix h_variable_1066 = DecideZeroRows(h_variable_1064,h_variable_58);
IsZeroMatrix(h_variable_1066);
nrows(h_variable_1065);
def h_variable_1067 = h_variable_282[20,6];
h_variable_1067;
matrix h_variable_1068[1][1] = 0;
matrix h_variable_1069[1][3] = concat(h_variable_1068,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1069); matrix h_variable_1070 = h_variable_l[1]; matrix h_variable_1071 = h_variable_l[2];
ncols(h_variable_1070);
matrix h_variable_1072 = DecideZeroRows(h_variable_1070,h_variable_58);
IsZeroMatrix(h_variable_1072);
nrows(h_variable_1071);
def h_variable_1073 = h_variable_282[19,6];
h_variable_1073;
matrix h_variable_1074[1][1] = 0;
matrix h_variable_1075[1][3] = concat(h_variable_1074,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1075); matrix h_variable_1076 = h_variable_l[1]; matrix h_variable_1077 = h_variable_l[2];
ncols(h_variable_1076);
matrix h_variable_1078 = DecideZeroRows(h_variable_1076,h_variable_58);
IsZeroMatrix(h_variable_1078);
nrows(h_variable_1077);
def h_variable_1079 = h_variable_282[18,6];
h_variable_1079;
matrix h_variable_1080[1][1] = 0;
matrix h_variable_1081[1][3] = concat(h_variable_1080,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1081); matrix h_variable_1082 = h_variable_l[1]; matrix h_variable_1083 = h_variable_l[2];
ncols(h_variable_1082);
matrix h_variable_1084 = DecideZeroRows(h_variable_1082,h_variable_58);
IsZeroMatrix(h_variable_1084);
nrows(h_variable_1083);
def h_variable_1085 = h_variable_282[17,6];
h_variable_1085;
matrix h_variable_1086[1][1] = 0;
matrix h_variable_1087[1][3] = concat(h_variable_1086,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1087); matrix h_variable_1088 = h_variable_l[1]; matrix h_variable_1089 = h_variable_l[2];
ncols(h_variable_1088);
matrix h_variable_1090 = DecideZeroRows(h_variable_1088,h_variable_58);
IsZeroMatrix(h_variable_1090);
nrows(h_variable_1089);
def h_variable_1091 = h_variable_282[16,6];
h_variable_1091;
matrix h_variable_1092[1][1] = 0;
matrix h_variable_1093[1][3] = concat(h_variable_1092,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1093); matrix h_variable_1094 = h_variable_l[1]; matrix h_variable_1095 = h_variable_l[2];
ncols(h_variable_1094);
matrix h_variable_1096 = DecideZeroRows(h_variable_1094,h_variable_58);
IsZeroMatrix(h_variable_1096);
nrows(h_variable_1095);
def h_variable_1097 = h_variable_282[15,6];
h_variable_1097;
matrix h_variable_1098[1][1] = 0;
matrix h_variable_1099[1][3] = concat(h_variable_1098,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1099); matrix h_variable_1100 = h_variable_l[1]; matrix h_variable_1101 = h_variable_l[2];
ncols(h_variable_1100);
matrix h_variable_1102 = DecideZeroRows(h_variable_1100,h_variable_58);
IsZeroMatrix(h_variable_1102);
nrows(h_variable_1101);
def h_variable_1103 = h_variable_282[14,6];
h_variable_1103;
matrix h_variable_1104[1][1] = 0;
matrix h_variable_1105[1][3] = concat(h_variable_1104,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1105); matrix h_variable_1106 = h_variable_l[1]; matrix h_variable_1107 = h_variable_l[2];
ncols(h_variable_1106);
matrix h_variable_1108 = DecideZeroRows(h_variable_1106,h_variable_58);
IsZeroMatrix(h_variable_1108);
nrows(h_variable_1107);
def h_variable_1109 = h_variable_282[13,6];
h_variable_1109;
matrix h_variable_1110[1][1] = 0;
matrix h_variable_1111[1][3] = concat(h_variable_1110,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1111); matrix h_variable_1112 = h_variable_l[1]; matrix h_variable_1113 = h_variable_l[2];
ncols(h_variable_1112);
matrix h_variable_1114 = DecideZeroRows(h_variable_1112,h_variable_58);
IsZeroMatrix(h_variable_1114);
nrows(h_variable_1113);
def h_variable_1115 = h_variable_282[12,6];
h_variable_1115;
matrix h_variable_1116[1][1] = 0;
matrix h_variable_1117[1][3] = concat(h_variable_1116,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1117); matrix h_variable_1118 = h_variable_l[1]; matrix h_variable_1119 = h_variable_l[2];
ncols(h_variable_1118);
matrix h_variable_1120 = DecideZeroRows(h_variable_1118,h_variable_58);
IsZeroMatrix(h_variable_1120);
nrows(h_variable_1119);
def h_variable_1121 = h_variable_282[11,6];
h_variable_1121;
matrix h_variable_1122[1][1] = 0;
matrix h_variable_1123[1][3] = concat(h_variable_1122,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1123); matrix h_variable_1124 = h_variable_l[1]; matrix h_variable_1125 = h_variable_l[2];
ncols(h_variable_1124);
matrix h_variable_1126 = DecideZeroRows(h_variable_1124,h_variable_58);
IsZeroMatrix(h_variable_1126);
nrows(h_variable_1125);
def h_variable_1127 = h_variable_282[10,6];
h_variable_1127;
matrix h_variable_1128[1][1] = 0;
matrix h_variable_1129[1][3] = concat(h_variable_1128,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1129); matrix h_variable_1130 = h_variable_l[1]; matrix h_variable_1131 = h_variable_l[2];
ncols(h_variable_1130);
matrix h_variable_1132 = DecideZeroRows(h_variable_1130,h_variable_58);
IsZeroMatrix(h_variable_1132);
nrows(h_variable_1131);
def h_variable_1133 = h_variable_282[9,6];
h_variable_1133;
matrix h_variable_1134[1][1] = 0;
matrix h_variable_1135[1][3] = concat(h_variable_1134,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1135); matrix h_variable_1136 = h_variable_l[1]; matrix h_variable_1137 = h_variable_l[2];
ncols(h_variable_1136);
matrix h_variable_1138 = DecideZeroRows(h_variable_1136,h_variable_58);
IsZeroMatrix(h_variable_1138);
nrows(h_variable_1137);
def h_variable_1139 = h_variable_282[8,6];
h_variable_1139;
matrix h_variable_1140[1][1] = -3;
matrix h_variable_1141[1][3] = concat(h_variable_1140,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1141); matrix h_variable_1142 = h_variable_l[1]; matrix h_variable_1143 = h_variable_l[2];
ncols(h_variable_1142);
matrix h_variable_1144 = DecideZeroRows(h_variable_1142,h_variable_58);
IsZeroMatrix(h_variable_1144);
ZeroRows(h_variable_1144);
nrows(h_variable_1143);
matrix h_variable_1146 = submat(h_variable_1142,1..1,intvec( 1 ));
matrix h_variable_1145 = DecideZeroRows(h_variable_1146,h_variable_58);
IsZeroMatrix(h_variable_1145);
IsIdentityMatrix(h_variable_1145);
matrix h_variable_1147[1][3] = concat(h_variable_1145,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1147); matrix h_variable_1148 = h_variable_l[1]; matrix h_variable_1149 = h_variable_l[2];
IsZeroMatrix(h_variable_1148);
matrix h_variable_1150 = DecideZeroRows(h_variable_1148,h_variable_58);
IsZeroMatrix(h_variable_1150);
def h_variable_1151 = h_variable_282[7,6];
h_variable_1151;
matrix h_variable_1152[1][1] = 0;
matrix h_variable_1153[1][3] = concat(h_variable_1152,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1153); matrix h_variable_1154 = h_variable_l[1]; matrix h_variable_1155 = h_variable_l[2];
ncols(h_variable_1154);
matrix h_variable_1156 = DecideZeroRows(h_variable_1154,h_variable_58);
IsZeroMatrix(h_variable_1156);
nrows(h_variable_1155);
def h_variable_1157 = h_variable_282[6,6];
h_variable_1157;
matrix h_variable_1158[1][1] = 0;
matrix h_variable_1159[1][3] = concat(h_variable_1158,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1159); matrix h_variable_1160 = h_variable_l[1]; matrix h_variable_1161 = h_variable_l[2];
ncols(h_variable_1160);
matrix h_variable_1162 = DecideZeroRows(h_variable_1160,h_variable_58);
IsZeroMatrix(h_variable_1162);
nrows(h_variable_1161);
def h_variable_1163 = h_variable_282[5,6];
h_variable_1163;
matrix h_variable_1164[1][1] = 0;
matrix h_variable_1165[1][3] = concat(h_variable_1164,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1165); matrix h_variable_1166 = h_variable_l[1]; matrix h_variable_1167 = h_variable_l[2];
ncols(h_variable_1166);
matrix h_variable_1168 = DecideZeroRows(h_variable_1166,h_variable_58);
IsZeroMatrix(h_variable_1168);
nrows(h_variable_1167);
def h_variable_1169 = h_variable_282[3,6];
h_variable_1169;
matrix h_variable_1170[1][1] = 0;
matrix h_variable_1171[1][3] = concat(h_variable_1170,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1171); matrix h_variable_1172 = h_variable_l[1]; matrix h_variable_1173 = h_variable_l[2];
ncols(h_variable_1172);
matrix h_variable_1174 = DecideZeroRows(h_variable_1172,h_variable_58);
IsZeroMatrix(h_variable_1174);
nrows(h_variable_1173);
def h_variable_1175 = h_variable_282[1,6];
h_variable_1175;
matrix h_variable_1176[1][1] = 0;
matrix h_variable_1177[1][3] = concat(h_variable_1176,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1177); matrix h_variable_1178 = h_variable_l[1]; matrix h_variable_1179 = h_variable_l[2];
ncols(h_variable_1178);
matrix h_variable_1180 = DecideZeroRows(h_variable_1178,h_variable_58);
IsZeroMatrix(h_variable_1180);
nrows(h_variable_1179);
def h_variable_1181 = h_variable_282[22,7];
h_variable_1181;
matrix h_variable_1182[1][1] = 0;
matrix h_variable_1183[1][3] = concat(h_variable_1182,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1183); matrix h_variable_1184 = h_variable_l[1]; matrix h_variable_1185 = h_variable_l[2];
ncols(h_variable_1184);
matrix h_variable_1186 = DecideZeroRows(h_variable_1184,h_variable_58);
IsZeroMatrix(h_variable_1186);
nrows(h_variable_1185);
def h_variable_1187 = h_variable_282[21,7];
h_variable_1187;
matrix h_variable_1188[1][1] = 0;
matrix h_variable_1189[1][3] = concat(h_variable_1188,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1189); matrix h_variable_1190 = h_variable_l[1]; matrix h_variable_1191 = h_variable_l[2];
ncols(h_variable_1190);
matrix h_variable_1192 = DecideZeroRows(h_variable_1190,h_variable_58);
IsZeroMatrix(h_variable_1192);
nrows(h_variable_1191);
def h_variable_1193 = h_variable_282[20,7];
h_variable_1193;
matrix h_variable_1194[1][1] = 0;
matrix h_variable_1195[1][3] = concat(h_variable_1194,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1195); matrix h_variable_1196 = h_variable_l[1]; matrix h_variable_1197 = h_variable_l[2];
ncols(h_variable_1196);
matrix h_variable_1198 = DecideZeroRows(h_variable_1196,h_variable_58);
IsZeroMatrix(h_variable_1198);
nrows(h_variable_1197);
def h_variable_1199 = h_variable_282[19,7];
h_variable_1199;
matrix h_variable_1200[1][1] = 0;
matrix h_variable_1201[1][3] = concat(h_variable_1200,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1201); matrix h_variable_1202 = h_variable_l[1]; matrix h_variable_1203 = h_variable_l[2];
ncols(h_variable_1202);
matrix h_variable_1204 = DecideZeroRows(h_variable_1202,h_variable_58);
IsZeroMatrix(h_variable_1204);
nrows(h_variable_1203);
def h_variable_1205 = h_variable_282[18,7];
h_variable_1205;
matrix h_variable_1206[1][1] = 0;
matrix h_variable_1207[1][3] = concat(h_variable_1206,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1207); matrix h_variable_1208 = h_variable_l[1]; matrix h_variable_1209 = h_variable_l[2];
ncols(h_variable_1208);
matrix h_variable_1210 = DecideZeroRows(h_variable_1208,h_variable_58);
IsZeroMatrix(h_variable_1210);
nrows(h_variable_1209);
def h_variable_1211 = h_variable_282[17,7];
h_variable_1211;
matrix h_variable_1212[1][1] = 0;
matrix h_variable_1213[1][3] = concat(h_variable_1212,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1213); matrix h_variable_1214 = h_variable_l[1]; matrix h_variable_1215 = h_variable_l[2];
ncols(h_variable_1214);
matrix h_variable_1216 = DecideZeroRows(h_variable_1214,h_variable_58);
IsZeroMatrix(h_variable_1216);
nrows(h_variable_1215);
def h_variable_1217 = h_variable_282[16,7];
h_variable_1217;
matrix h_variable_1218[1][1] = 0;
matrix h_variable_1219[1][3] = concat(h_variable_1218,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1219); matrix h_variable_1220 = h_variable_l[1]; matrix h_variable_1221 = h_variable_l[2];
ncols(h_variable_1220);
matrix h_variable_1222 = DecideZeroRows(h_variable_1220,h_variable_58);
IsZeroMatrix(h_variable_1222);
nrows(h_variable_1221);
def h_variable_1223 = h_variable_282[15,7];
h_variable_1223;
matrix h_variable_1224[1][1] = 0;
matrix h_variable_1225[1][3] = concat(h_variable_1224,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1225); matrix h_variable_1226 = h_variable_l[1]; matrix h_variable_1227 = h_variable_l[2];
ncols(h_variable_1226);
matrix h_variable_1228 = DecideZeroRows(h_variable_1226,h_variable_58);
IsZeroMatrix(h_variable_1228);
nrows(h_variable_1227);
def h_variable_1229 = h_variable_282[14,7];
h_variable_1229;
matrix h_variable_1230[1][1] = 0;
matrix h_variable_1231[1][3] = concat(h_variable_1230,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1231); matrix h_variable_1232 = h_variable_l[1]; matrix h_variable_1233 = h_variable_l[2];
ncols(h_variable_1232);
matrix h_variable_1234 = DecideZeroRows(h_variable_1232,h_variable_58);
IsZeroMatrix(h_variable_1234);
nrows(h_variable_1233);
def h_variable_1235 = h_variable_282[13,7];
h_variable_1235;
matrix h_variable_1236[1][1] = 0;
matrix h_variable_1237[1][3] = concat(h_variable_1236,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1237); matrix h_variable_1238 = h_variable_l[1]; matrix h_variable_1239 = h_variable_l[2];
ncols(h_variable_1238);
matrix h_variable_1240 = DecideZeroRows(h_variable_1238,h_variable_58);
IsZeroMatrix(h_variable_1240);
nrows(h_variable_1239);
def h_variable_1241 = h_variable_282[12,7];
h_variable_1241;
matrix h_variable_1242[1][1] = 0;
matrix h_variable_1243[1][3] = concat(h_variable_1242,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1243); matrix h_variable_1244 = h_variable_l[1]; matrix h_variable_1245 = h_variable_l[2];
ncols(h_variable_1244);
matrix h_variable_1246 = DecideZeroRows(h_variable_1244,h_variable_58);
IsZeroMatrix(h_variable_1246);
nrows(h_variable_1245);
def h_variable_1247 = h_variable_282[11,7];
h_variable_1247;
matrix h_variable_1248[1][1] = 0;
matrix h_variable_1249[1][3] = concat(h_variable_1248,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1249); matrix h_variable_1250 = h_variable_l[1]; matrix h_variable_1251 = h_variable_l[2];
ncols(h_variable_1250);
matrix h_variable_1252 = DecideZeroRows(h_variable_1250,h_variable_58);
IsZeroMatrix(h_variable_1252);
nrows(h_variable_1251);
def h_variable_1253 = h_variable_282[10,7];
h_variable_1253;
matrix h_variable_1254[1][1] = 0;
matrix h_variable_1255[1][3] = concat(h_variable_1254,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1255); matrix h_variable_1256 = h_variable_l[1]; matrix h_variable_1257 = h_variable_l[2];
ncols(h_variable_1256);
matrix h_variable_1258 = DecideZeroRows(h_variable_1256,h_variable_58);
IsZeroMatrix(h_variable_1258);
nrows(h_variable_1257);
def h_variable_1259 = h_variable_282[9,7];
h_variable_1259;
matrix h_variable_1260[1][1] = 0;
matrix h_variable_1261[1][3] = concat(h_variable_1260,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1261); matrix h_variable_1262 = h_variable_l[1]; matrix h_variable_1263 = h_variable_l[2];
ncols(h_variable_1262);
matrix h_variable_1264 = DecideZeroRows(h_variable_1262,h_variable_58);
IsZeroMatrix(h_variable_1264);
nrows(h_variable_1263);
def h_variable_1265 = h_variable_282[8,7];
h_variable_1265;
matrix h_variable_1266[1][1] = 0;
matrix h_variable_1267[1][3] = concat(h_variable_1266,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1267); matrix h_variable_1268 = h_variable_l[1]; matrix h_variable_1269 = h_variable_l[2];
ncols(h_variable_1268);
matrix h_variable_1270 = DecideZeroRows(h_variable_1268,h_variable_58);
IsZeroMatrix(h_variable_1270);
nrows(h_variable_1269);
def h_variable_1271 = h_variable_282[7,7];
h_variable_1271;
matrix h_variable_1272[1][1] = -2;
matrix h_variable_1273[1][3] = concat(h_variable_1272,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1273); matrix h_variable_1274 = h_variable_l[1]; matrix h_variable_1275 = h_variable_l[2];
ncols(h_variable_1274);
matrix h_variable_1276 = DecideZeroRows(h_variable_1274,h_variable_58);
IsZeroMatrix(h_variable_1276);
ZeroRows(h_variable_1276);
nrows(h_variable_1275);
matrix h_variable_1278 = submat(h_variable_1274,1..1,intvec( 1 ));
matrix h_variable_1277 = DecideZeroRows(h_variable_1278,h_variable_58);
IsZeroMatrix(h_variable_1277);
IsIdentityMatrix(h_variable_1277);
matrix h_variable_1279[1][3] = concat(h_variable_1277,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1279); matrix h_variable_1280 = h_variable_l[1]; matrix h_variable_1281 = h_variable_l[2];
IsZeroMatrix(h_variable_1280);
matrix h_variable_1282 = DecideZeroRows(h_variable_1280,h_variable_58);
IsZeroMatrix(h_variable_1282);
def h_variable_1283 = h_variable_282[6,7];
h_variable_1283;
matrix h_variable_1284[1][1] = 0;
matrix h_variable_1285[1][3] = concat(h_variable_1284,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1285); matrix h_variable_1286 = h_variable_l[1]; matrix h_variable_1287 = h_variable_l[2];
ncols(h_variable_1286);
matrix h_variable_1288 = DecideZeroRows(h_variable_1286,h_variable_58);
IsZeroMatrix(h_variable_1288);
nrows(h_variable_1287);
def h_variable_1289 = h_variable_282[5,7];
h_variable_1289;
matrix h_variable_1290[1][1] = 2;
matrix h_variable_1291[1][3] = concat(h_variable_1290,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1291); matrix h_variable_1292 = h_variable_l[1]; matrix h_variable_1293 = h_variable_l[2];
ncols(h_variable_1292);
matrix h_variable_1294 = DecideZeroRows(h_variable_1292,h_variable_58);
IsZeroMatrix(h_variable_1294);
ZeroRows(h_variable_1294);
nrows(h_variable_1293);
matrix h_variable_1296 = submat(h_variable_1292,1..1,intvec( 1 ));
matrix h_variable_1295 = DecideZeroRows(h_variable_1296,h_variable_58);
IsZeroMatrix(h_variable_1295);
IsIdentityMatrix(h_variable_1295);
matrix h_variable_1297[1][3] = concat(h_variable_1295,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1297); matrix h_variable_1298 = h_variable_l[1]; matrix h_variable_1299 = h_variable_l[2];
IsZeroMatrix(h_variable_1298);
matrix h_variable_1300 = DecideZeroRows(h_variable_1298,h_variable_58);
IsZeroMatrix(h_variable_1300);
def h_variable_1301 = h_variable_282[3,7];
h_variable_1301;
matrix h_variable_1302[1][1] = x1;
matrix h_variable_1303[1][3] = concat(h_variable_1302,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1303); matrix h_variable_1304 = h_variable_l[1]; matrix h_variable_1305 = h_variable_l[2];
ncols(h_variable_1304);
matrix h_variable_1306 = DecideZeroRows(h_variable_1304,h_variable_58);
IsZeroMatrix(h_variable_1306);
ZeroRows(h_variable_1306);
nrows(h_variable_1305);
matrix h_variable_1308 = submat(h_variable_1304,1..1,intvec( 2 ));
matrix h_variable_1307 = DecideZeroRows(h_variable_1308,h_variable_58);
IsZeroMatrix(h_variable_1307);
IsIdentityMatrix(h_variable_1307);
matrix h_variable_1309[1][3] = concat(h_variable_1307,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1309); matrix h_variable_1310 = h_variable_l[1]; matrix h_variable_1311 = h_variable_l[2];
IsZeroMatrix(h_variable_1310);
matrix h_variable_1312 = DecideZeroRows(h_variable_1310,h_variable_58);
IsZeroMatrix(h_variable_1312);
def h_variable_1313 = h_variable_282[1,7];
h_variable_1313;
matrix h_variable_1314[1][1] = 0;
matrix h_variable_1315[1][3] = concat(h_variable_1314,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1315); matrix h_variable_1316 = h_variable_l[1]; matrix h_variable_1317 = h_variable_l[2];
ncols(h_variable_1316);
matrix h_variable_1318 = DecideZeroRows(h_variable_1316,h_variable_58);
IsZeroMatrix(h_variable_1318);
nrows(h_variable_1317);
def h_variable_1319 = h_variable_282[22,8];
h_variable_1319;
matrix h_variable_1320[1][1] = 0;
matrix h_variable_1321[1][3] = concat(h_variable_1320,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1321); matrix h_variable_1322 = h_variable_l[1]; matrix h_variable_1323 = h_variable_l[2];
ncols(h_variable_1322);
matrix h_variable_1324 = DecideZeroRows(h_variable_1322,h_variable_58);
IsZeroMatrix(h_variable_1324);
nrows(h_variable_1323);
def h_variable_1325 = h_variable_282[21,8];
h_variable_1325;
matrix h_variable_1326[1][1] = 0;
matrix h_variable_1327[1][3] = concat(h_variable_1326,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1327); matrix h_variable_1328 = h_variable_l[1]; matrix h_variable_1329 = h_variable_l[2];
ncols(h_variable_1328);
matrix h_variable_1330 = DecideZeroRows(h_variable_1328,h_variable_58);
IsZeroMatrix(h_variable_1330);
nrows(h_variable_1329);
def h_variable_1331 = h_variable_282[20,8];
h_variable_1331;
matrix h_variable_1332[1][1] = 0;
matrix h_variable_1333[1][3] = concat(h_variable_1332,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1333); matrix h_variable_1334 = h_variable_l[1]; matrix h_variable_1335 = h_variable_l[2];
ncols(h_variable_1334);
matrix h_variable_1336 = DecideZeroRows(h_variable_1334,h_variable_58);
IsZeroMatrix(h_variable_1336);
nrows(h_variable_1335);
def h_variable_1337 = h_variable_282[19,8];
h_variable_1337;
matrix h_variable_1338[1][1] = 0;
matrix h_variable_1339[1][3] = concat(h_variable_1338,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1339); matrix h_variable_1340 = h_variable_l[1]; matrix h_variable_1341 = h_variable_l[2];
ncols(h_variable_1340);
matrix h_variable_1342 = DecideZeroRows(h_variable_1340,h_variable_58);
IsZeroMatrix(h_variable_1342);
nrows(h_variable_1341);
def h_variable_1343 = h_variable_282[18,8];
h_variable_1343;
matrix h_variable_1344[1][1] = 0;
matrix h_variable_1345[1][3] = concat(h_variable_1344,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1345); matrix h_variable_1346 = h_variable_l[1]; matrix h_variable_1347 = h_variable_l[2];
ncols(h_variable_1346);
matrix h_variable_1348 = DecideZeroRows(h_variable_1346,h_variable_58);
IsZeroMatrix(h_variable_1348);
nrows(h_variable_1347);
def h_variable_1349 = h_variable_282[17,8];
h_variable_1349;
matrix h_variable_1350[1][1] = 0;
matrix h_variable_1351[1][3] = concat(h_variable_1350,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1351); matrix h_variable_1352 = h_variable_l[1]; matrix h_variable_1353 = h_variable_l[2];
ncols(h_variable_1352);
matrix h_variable_1354 = DecideZeroRows(h_variable_1352,h_variable_58);
IsZeroMatrix(h_variable_1354);
nrows(h_variable_1353);
def h_variable_1355 = h_variable_282[16,8];
h_variable_1355;
matrix h_variable_1356[1][1] = 0;
matrix h_variable_1357[1][3] = concat(h_variable_1356,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1357); matrix h_variable_1358 = h_variable_l[1]; matrix h_variable_1359 = h_variable_l[2];
ncols(h_variable_1358);
matrix h_variable_1360 = DecideZeroRows(h_variable_1358,h_variable_58);
IsZeroMatrix(h_variable_1360);
nrows(h_variable_1359);
def h_variable_1361 = h_variable_282[15,8];
h_variable_1361;
matrix h_variable_1362[1][1] = 0;
matrix h_variable_1363[1][3] = concat(h_variable_1362,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1363); matrix h_variable_1364 = h_variable_l[1]; matrix h_variable_1365 = h_variable_l[2];
ncols(h_variable_1364);
matrix h_variable_1366 = DecideZeroRows(h_variable_1364,h_variable_58);
IsZeroMatrix(h_variable_1366);
nrows(h_variable_1365);
def h_variable_1367 = h_variable_282[14,8];
h_variable_1367;
matrix h_variable_1368[1][1] = 0;
matrix h_variable_1369[1][3] = concat(h_variable_1368,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1369); matrix h_variable_1370 = h_variable_l[1]; matrix h_variable_1371 = h_variable_l[2];
ncols(h_variable_1370);
matrix h_variable_1372 = DecideZeroRows(h_variable_1370,h_variable_58);
IsZeroMatrix(h_variable_1372);
nrows(h_variable_1371);
def h_variable_1373 = h_variable_282[13,8];
h_variable_1373;
matrix h_variable_1374[1][1] = 0;
matrix h_variable_1375[1][3] = concat(h_variable_1374,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1375); matrix h_variable_1376 = h_variable_l[1]; matrix h_variable_1377 = h_variable_l[2];
ncols(h_variable_1376);
matrix h_variable_1378 = DecideZeroRows(h_variable_1376,h_variable_58);
IsZeroMatrix(h_variable_1378);
nrows(h_variable_1377);
def h_variable_1379 = h_variable_282[12,8];
h_variable_1379;
matrix h_variable_1380[1][1] = 0;
matrix h_variable_1381[1][3] = concat(h_variable_1380,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1381); matrix h_variable_1382 = h_variable_l[1]; matrix h_variable_1383 = h_variable_l[2];
ncols(h_variable_1382);
matrix h_variable_1384 = DecideZeroRows(h_variable_1382,h_variable_58);
IsZeroMatrix(h_variable_1384);
nrows(h_variable_1383);
def h_variable_1385 = h_variable_282[11,8];
h_variable_1385;
matrix h_variable_1386[1][1] = 0;
matrix h_variable_1387[1][3] = concat(h_variable_1386,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1387); matrix h_variable_1388 = h_variable_l[1]; matrix h_variable_1389 = h_variable_l[2];
ncols(h_variable_1388);
matrix h_variable_1390 = DecideZeroRows(h_variable_1388,h_variable_58);
IsZeroMatrix(h_variable_1390);
nrows(h_variable_1389);
def h_variable_1391 = h_variable_282[10,8];
h_variable_1391;
matrix h_variable_1392[1][1] = -2;
matrix h_variable_1393[1][3] = concat(h_variable_1392,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1393); matrix h_variable_1394 = h_variable_l[1]; matrix h_variable_1395 = h_variable_l[2];
ncols(h_variable_1394);
matrix h_variable_1396 = DecideZeroRows(h_variable_1394,h_variable_58);
IsZeroMatrix(h_variable_1396);
ZeroRows(h_variable_1396);
nrows(h_variable_1395);
matrix h_variable_1398 = submat(h_variable_1394,1..1,intvec( 1 ));
matrix h_variable_1397 = DecideZeroRows(h_variable_1398,h_variable_58);
IsZeroMatrix(h_variable_1397);
IsIdentityMatrix(h_variable_1397);
matrix h_variable_1399[1][3] = concat(h_variable_1397,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1399); matrix h_variable_1400 = h_variable_l[1]; matrix h_variable_1401 = h_variable_l[2];
IsZeroMatrix(h_variable_1400);
matrix h_variable_1402 = DecideZeroRows(h_variable_1400,h_variable_58);
IsZeroMatrix(h_variable_1402);
def h_variable_1403 = h_variable_282[9,8];
h_variable_1403;
matrix h_variable_1404[1][1] = 0;
matrix h_variable_1405[1][3] = concat(h_variable_1404,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1405); matrix h_variable_1406 = h_variable_l[1]; matrix h_variable_1407 = h_variable_l[2];
ncols(h_variable_1406);
matrix h_variable_1408 = DecideZeroRows(h_variable_1406,h_variable_58);
IsZeroMatrix(h_variable_1408);
nrows(h_variable_1407);
def h_variable_1409 = h_variable_282[8,8];
h_variable_1409;
matrix h_variable_1410[1][1] = -3;
matrix h_variable_1411[1][3] = concat(h_variable_1410,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1411); matrix h_variable_1412 = h_variable_l[1]; matrix h_variable_1413 = h_variable_l[2];
ncols(h_variable_1412);
matrix h_variable_1414 = DecideZeroRows(h_variable_1412,h_variable_58);
IsZeroMatrix(h_variable_1414);
ZeroRows(h_variable_1414);
nrows(h_variable_1413);
matrix h_variable_1416 = submat(h_variable_1412,1..1,intvec( 1 ));
matrix h_variable_1415 = DecideZeroRows(h_variable_1416,h_variable_58);
IsZeroMatrix(h_variable_1415);
IsIdentityMatrix(h_variable_1415);
matrix h_variable_1417[1][3] = concat(h_variable_1415,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1417); matrix h_variable_1418 = h_variable_l[1]; matrix h_variable_1419 = h_variable_l[2];
IsZeroMatrix(h_variable_1418);
matrix h_variable_1420 = DecideZeroRows(h_variable_1418,h_variable_58);
IsZeroMatrix(h_variable_1420);
def h_variable_1421 = h_variable_282[7,8];
h_variable_1421;
matrix h_variable_1422[1][1] = 0;
matrix h_variable_1423[1][3] = concat(h_variable_1422,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1423); matrix h_variable_1424 = h_variable_l[1]; matrix h_variable_1425 = h_variable_l[2];
ncols(h_variable_1424);
matrix h_variable_1426 = DecideZeroRows(h_variable_1424,h_variable_58);
IsZeroMatrix(h_variable_1426);
nrows(h_variable_1425);
def h_variable_1427 = h_variable_282[6,8];
h_variable_1427;
matrix h_variable_1428[1][1] = 0;
matrix h_variable_1429[1][3] = concat(h_variable_1428,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1429); matrix h_variable_1430 = h_variable_l[1]; matrix h_variable_1431 = h_variable_l[2];
ncols(h_variable_1430);
matrix h_variable_1432 = DecideZeroRows(h_variable_1430,h_variable_58);
IsZeroMatrix(h_variable_1432);
nrows(h_variable_1431);
def h_variable_1433 = h_variable_282[5,8];
h_variable_1433;
matrix h_variable_1434[1][1] = 0;
matrix h_variable_1435[1][3] = concat(h_variable_1434,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1435); matrix h_variable_1436 = h_variable_l[1]; matrix h_variable_1437 = h_variable_l[2];
ncols(h_variable_1436);
matrix h_variable_1438 = DecideZeroRows(h_variable_1436,h_variable_58);
IsZeroMatrix(h_variable_1438);
nrows(h_variable_1437);
def h_variable_1439 = h_variable_282[3,8];
h_variable_1439;
matrix h_variable_1440[1][1] = 0;
matrix h_variable_1441[1][3] = concat(h_variable_1440,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1441); matrix h_variable_1442 = h_variable_l[1]; matrix h_variable_1443 = h_variable_l[2];
ncols(h_variable_1442);
matrix h_variable_1444 = DecideZeroRows(h_variable_1442,h_variable_58);
IsZeroMatrix(h_variable_1444);
nrows(h_variable_1443);
def h_variable_1445 = h_variable_282[1,8];
h_variable_1445;
matrix h_variable_1446[1][1] = 0;
matrix h_variable_1447[1][3] = concat(h_variable_1446,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1447); matrix h_variable_1448 = h_variable_l[1]; matrix h_variable_1449 = h_variable_l[2];
ncols(h_variable_1448);
matrix h_variable_1450 = DecideZeroRows(h_variable_1448,h_variable_58);
IsZeroMatrix(h_variable_1450);
nrows(h_variable_1449);
def h_variable_1451 = h_variable_282[22,9];
h_variable_1451;
matrix h_variable_1452[1][1] = 0;
matrix h_variable_1453[1][3] = concat(h_variable_1452,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1453); matrix h_variable_1454 = h_variable_l[1]; matrix h_variable_1455 = h_variable_l[2];
ncols(h_variable_1454);
matrix h_variable_1456 = DecideZeroRows(h_variable_1454,h_variable_58);
IsZeroMatrix(h_variable_1456);
nrows(h_variable_1455);
def h_variable_1457 = h_variable_282[21,9];
h_variable_1457;
matrix h_variable_1458[1][1] = 0;
matrix h_variable_1459[1][3] = concat(h_variable_1458,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1459); matrix h_variable_1460 = h_variable_l[1]; matrix h_variable_1461 = h_variable_l[2];
ncols(h_variable_1460);
matrix h_variable_1462 = DecideZeroRows(h_variable_1460,h_variable_58);
IsZeroMatrix(h_variable_1462);
nrows(h_variable_1461);
def h_variable_1463 = h_variable_282[20,9];
h_variable_1463;
matrix h_variable_1464[1][1] = 0;
matrix h_variable_1465[1][3] = concat(h_variable_1464,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1465); matrix h_variable_1466 = h_variable_l[1]; matrix h_variable_1467 = h_variable_l[2];
ncols(h_variable_1466);
matrix h_variable_1468 = DecideZeroRows(h_variable_1466,h_variable_58);
IsZeroMatrix(h_variable_1468);
nrows(h_variable_1467);
def h_variable_1469 = h_variable_282[19,9];
h_variable_1469;
matrix h_variable_1470[1][1] = 0;
matrix h_variable_1471[1][3] = concat(h_variable_1470,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1471); matrix h_variable_1472 = h_variable_l[1]; matrix h_variable_1473 = h_variable_l[2];
ncols(h_variable_1472);
matrix h_variable_1474 = DecideZeroRows(h_variable_1472,h_variable_58);
IsZeroMatrix(h_variable_1474);
nrows(h_variable_1473);
def h_variable_1475 = h_variable_282[18,9];
h_variable_1475;
matrix h_variable_1476[1][1] = 0;
matrix h_variable_1477[1][3] = concat(h_variable_1476,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1477); matrix h_variable_1478 = h_variable_l[1]; matrix h_variable_1479 = h_variable_l[2];
ncols(h_variable_1478);
matrix h_variable_1480 = DecideZeroRows(h_variable_1478,h_variable_58);
IsZeroMatrix(h_variable_1480);
nrows(h_variable_1479);
def h_variable_1481 = h_variable_282[17,9];
h_variable_1481;
matrix h_variable_1482[1][1] = 0;
matrix h_variable_1483[1][3] = concat(h_variable_1482,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1483); matrix h_variable_1484 = h_variable_l[1]; matrix h_variable_1485 = h_variable_l[2];
ncols(h_variable_1484);
matrix h_variable_1486 = DecideZeroRows(h_variable_1484,h_variable_58);
IsZeroMatrix(h_variable_1486);
nrows(h_variable_1485);
def h_variable_1487 = h_variable_282[16,9];
h_variable_1487;
matrix h_variable_1488[1][1] = 0;
matrix h_variable_1489[1][3] = concat(h_variable_1488,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1489); matrix h_variable_1490 = h_variable_l[1]; matrix h_variable_1491 = h_variable_l[2];
ncols(h_variable_1490);
matrix h_variable_1492 = DecideZeroRows(h_variable_1490,h_variable_58);
IsZeroMatrix(h_variable_1492);
nrows(h_variable_1491);
def h_variable_1493 = h_variable_282[15,9];
h_variable_1493;
matrix h_variable_1494[1][1] = 0;
matrix h_variable_1495[1][3] = concat(h_variable_1494,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1495); matrix h_variable_1496 = h_variable_l[1]; matrix h_variable_1497 = h_variable_l[2];
ncols(h_variable_1496);
matrix h_variable_1498 = DecideZeroRows(h_variable_1496,h_variable_58);
IsZeroMatrix(h_variable_1498);
nrows(h_variable_1497);
def h_variable_1499 = h_variable_282[14,9];
h_variable_1499;
matrix h_variable_1500[1][1] = 0;
kill h_variable_809;kill h_variable_810;kill h_variable_811;kill h_variable_812;kill h_variable_814;kill h_variable_815;kill h_variable_816;kill h_variable_817;kill h_variable_818;kill h_variable_820;kill h_variable_821;kill h_variable_822;kill h_variable_823;kill h_variable_824;kill h_variable_825;kill h_variable_826;kill h_variable_827;kill h_variable_828;kill h_variable_829;kill h_variable_830;kill h_variable_831;kill h_variable_832;kill h_variable_833;kill h_variable_834;kill h_variable_835;kill h_variable_836;kill h_variable_837;kill h_variable_838;kill h_variable_839;kill h_variable_840;kill h_variable_841;kill h_variable_842;kill h_variable_843;kill h_variable_844;kill h_variable_845;kill h_variable_846;kill h_variable_847;kill h_variable_848;kill h_variable_849;kill h_variable_850;kill h_variable_851;kill h_variable_852;kill h_variable_853;kill h_variable_854;kill h_variable_855;kill h_variable_856;kill h_variable_857;kill h_variable_858;kill h_variable_859;kill h_variable_860;kill h_variable_861;kill h_variable_862;kill h_variable_863;kill h_variable_864;kill h_variable_865;kill h_variable_866;kill h_variable_867;kill h_variable_868;kill h_variable_869;kill h_variable_870;kill h_variable_871;kill h_variable_872;kill h_variable_873;kill h_variable_874;kill h_variable_875;kill h_variable_876;kill h_variable_877;kill h_variable_878;kill h_variable_879;kill h_variable_880;kill h_variable_881;kill h_variable_882;kill h_variable_883;kill h_variable_884;kill h_variable_885;kill h_variable_886;kill h_variable_887;kill h_variable_888;kill h_variable_889;kill h_variable_890;kill h_variable_891;kill h_variable_892;kill h_variable_893;kill h_variable_894;kill h_variable_895;kill h_variable_896;kill h_variable_897;kill h_variable_898;kill h_variable_899;kill h_variable_900;kill h_variable_901;kill h_variable_902;kill h_variable_903;kill h_variable_904;kill h_variable_905;kill h_variable_906;kill h_variable_907;kill h_variable_908;kill h_variable_909;kill h_variable_910;kill h_variable_911;kill h_variable_912;kill h_variable_913;kill h_variable_914;kill h_variable_915;kill h_variable_916;kill h_variable_917;kill h_variable_918;kill h_variable_919;kill h_variable_920;kill h_variable_921;kill h_variable_922;kill h_variable_923;kill h_variable_924;kill h_variable_925;kill h_variable_926;kill h_variable_927;kill h_variable_928;kill h_variable_929;kill h_variable_930;kill h_variable_931;kill h_variable_932;kill h_variable_933;kill h_variable_934;kill h_variable_935;kill h_variable_936;kill h_variable_937;kill h_variable_938;kill h_variable_939;kill h_variable_940;kill h_variable_941;kill h_variable_942;kill h_variable_943;kill h_variable_944;kill h_variable_945;kill h_variable_946;kill h_variable_947;kill h_variable_948;kill h_variable_949;kill h_variable_950;kill h_variable_951;kill h_variable_952;kill h_variable_953;kill h_variable_954;kill h_variable_955;kill h_variable_956;kill h_variable_957;kill h_variable_958;kill h_variable_959;kill h_variable_960;kill h_variable_961;kill h_variable_962;kill h_variable_963;kill h_variable_964;kill h_variable_965;kill h_variable_966;kill h_variable_967;kill h_variable_968;kill h_variable_969;kill h_variable_970;kill h_variable_971;kill h_variable_972;kill h_variable_973;kill h_variable_974;kill h_variable_975;kill h_variable_976;kill h_variable_977;kill h_variable_978;kill h_variable_979;kill h_variable_980;kill h_variable_981;kill h_variable_982;kill h_variable_983;kill h_variable_984;kill h_variable_985;kill h_variable_986;kill h_variable_987;kill h_variable_988;kill h_variable_989;kill h_variable_990;kill h_variable_991;kill h_variable_992;kill h_variable_993;kill h_variable_996;kill h_variable_999;kill h_variable_1006;kill h_variable_1008;kill h_variable_1009;kill h_variable_1010;kill h_variable_1011;kill h_variable_1012;kill h_variable_1014;kill h_variable_1015;kill h_variable_1016;kill h_variable_1017;kill h_variable_1018;kill h_variable_1020;kill h_variable_1021;kill h_variable_1022;kill h_variable_1023;kill h_variable_1024;kill h_variable_1025;kill h_variable_1026;kill h_variable_1027;kill h_variable_1028;kill h_variable_1029;kill h_variable_1030;kill h_variable_1031;kill h_variable_1032;kill h_variable_1033;kill h_variable_1034;kill h_variable_1035;kill h_variable_1036;kill h_variable_1037;kill h_variable_1038;kill h_variable_1039;kill h_variable_1040;kill h_variable_1041;kill h_variable_1042;kill h_variable_1043;kill h_variable_1044;kill h_variable_1045;kill h_variable_1046;kill h_variable_1047;kill h_variable_1048;kill h_variable_1049;kill h_variable_1050;kill h_variable_1051;kill h_variable_1052;kill h_variable_1053;kill h_variable_1054;kill h_variable_1055;kill h_variable_1056;kill h_variable_1057;kill h_variable_1058;kill h_variable_1059;kill h_variable_1060;kill h_variable_1061;kill h_variable_1062;kill h_variable_1063;kill h_variable_1064;kill h_variable_1065;kill h_variable_1066;kill h_variable_1067;kill h_variable_1068;kill h_variable_1069;kill h_variable_1070;kill h_variable_1071;kill h_variable_1072;kill h_variable_1073;kill h_variable_1074;kill h_variable_1075;kill h_variable_1076;kill h_variable_1077;kill h_variable_1078;kill h_variable_1079;kill h_variable_1080;kill h_variable_1081;kill h_variable_1082;kill h_variable_1083;kill h_variable_1084;kill h_variable_1085;kill h_variable_1086;kill h_variable_1087;kill h_variable_1088;kill h_variable_1089;kill h_variable_1090;kill h_variable_1091;kill h_variable_1092;kill h_variable_1093;kill h_variable_1094;kill h_variable_1095;kill h_variable_1096;kill h_variable_1097;kill h_variable_1098;kill h_variable_1099;kill h_variable_1100;kill h_variable_1101;kill h_variable_1102;kill h_variable_1103;kill h_variable_1104;kill h_variable_1105;kill h_variable_1106;kill h_variable_1107;kill h_variable_1108;kill h_variable_1109;kill h_variable_1110;kill h_variable_1111;kill h_variable_1112;kill h_variable_1113;kill h_variable_1114;kill h_variable_1115;kill h_variable_1116;kill h_variable_1117;kill h_variable_1118;kill h_variable_1119;kill h_variable_1120;kill h_variable_1121;kill h_variable_1122;kill h_variable_1123;kill h_variable_1124;kill h_variable_1125;kill h_variable_1126;kill h_variable_1127;kill h_variable_1128;kill h_variable_1129;kill h_variable_1130;kill h_variable_1131;kill h_variable_1132;kill h_variable_1133;kill h_variable_1134;kill h_variable_1135;kill h_variable_1136;kill h_variable_1137;kill h_variable_1138;kill h_variable_1139;kill h_variable_1140;kill h_variable_1141;kill h_variable_1142;kill h_variable_1143;kill h_variable_1144;kill h_variable_1145;kill h_variable_1146;kill h_variable_1147;kill h_variable_1148;kill h_variable_1149;kill h_variable_1150;kill h_variable_1151;kill h_variable_1152;kill h_variable_1153;kill h_variable_1154;kill h_variable_1155;kill h_variable_1156;kill h_variable_1157;kill h_variable_1158;kill h_variable_1159;kill h_variable_1160;kill h_variable_1161;kill h_variable_1162;kill h_variable_1163;kill h_variable_1164;kill h_variable_1165;kill h_variable_1166;kill h_variable_1167;kill h_variable_1168;kill h_variable_1169;kill h_variable_1170;kill h_variable_1171;kill h_variable_1172;kill h_variable_1173;kill h_variable_1174;kill h_variable_1183;kill h_variable_1184;kill h_variable_1185;kill h_variable_1186;kill h_variable_1188;kill h_variable_1189;kill h_variable_1190;kill h_variable_1191;kill h_variable_1192;kill h_variable_1194;kill h_variable_1195;kill h_variable_1196;kill h_variable_1197;kill h_variable_1198;kill h_variable_1199;kill h_variable_1200;kill h_variable_1201;kill h_variable_1202;kill h_variable_1203;kill h_variable_1204;kill h_variable_1205;kill h_variable_1206;kill h_variable_1207;kill h_variable_1208;kill h_variable_1209;kill h_variable_1210;kill h_variable_1211;kill h_variable_1212;kill h_variable_1213;kill h_variable_1214;kill h_variable_1215;kill h_variable_1216;kill h_variable_1217;kill h_variable_1218;kill h_variable_1219;kill h_variable_1220;kill h_variable_1221;kill h_variable_1222;kill h_variable_1223;kill h_variable_1224;kill h_variable_1225;kill h_variable_1226;kill h_variable_1227;kill h_variable_1228;kill h_variable_1229;kill h_variable_1230;kill h_variable_1231;kill h_variable_1232;kill h_variable_1233;kill h_variable_1234;kill h_variable_1235;kill h_variable_1236;kill h_variable_1237;kill h_variable_1238;kill h_variable_1239;kill h_variable_1240;kill h_variable_1241;kill h_variable_1242;kill h_variable_1243;kill h_variable_1244;kill h_variable_1245;kill h_variable_1246;kill h_variable_1247;kill h_variable_1248;kill h_variable_1249;kill h_variable_1250;kill h_variable_1251;kill h_variable_1252;kill h_variable_1253;kill h_variable_1254;kill h_variable_1255;kill h_variable_1256;kill h_variable_1257;kill h_variable_1258;kill h_variable_1259;kill h_variable_1260;kill h_variable_1261;kill h_variable_1262;kill h_variable_1263;kill h_variable_1264;kill h_variable_1265;kill h_variable_1266;kill h_variable_1267;kill h_variable_1268;kill h_variable_1269;kill h_variable_1270;kill h_variable_1271;kill h_variable_1272;kill h_variable_1273;kill h_variable_1274;kill h_variable_1275;kill h_variable_1276;kill h_variable_1277;kill h_variable_1278;kill h_variable_1279;kill h_variable_1280;kill h_variable_1281;kill h_variable_1282;kill h_variable_1283;kill h_variable_1284;kill h_variable_1285;kill h_variable_1286;kill h_variable_1287;kill h_variable_1288;kill h_variable_1289;kill h_variable_1290;kill h_variable_1291;kill h_variable_1292;kill h_variable_1293;kill h_variable_1294;kill h_variable_1295;kill h_variable_1296;kill h_variable_1297;kill h_variable_1298;kill h_variable_1299;kill h_variable_1300;kill h_variable_1301;kill h_variable_1302;kill h_variable_1303;kill h_variable_1304;kill h_variable_1305;kill h_variable_1306;kill h_variable_1307;kill h_variable_1308;kill h_variable_1309;kill h_variable_1310;kill h_variable_1311;kill h_variable_1312;kill h_variable_1313;kill h_variable_1314;kill h_variable_1315;kill h_variable_1316;kill h_variable_1317;kill h_variable_1318;kill h_variable_1319;kill h_variable_1320;kill h_variable_1321;kill h_variable_1322;kill h_variable_1323;kill h_variable_1324;kill h_variable_1325;kill h_variable_1326;kill h_variable_1327;kill h_variable_1328;kill h_variable_1329;kill h_variable_1330;kill h_variable_1331;kill h_variable_1332;kill h_variable_1333;kill h_variable_1334;kill h_variable_1335;kill h_variable_1336;kill h_variable_1337;kill h_variable_1338;kill h_variable_1339;kill h_variable_1340;kill h_variable_1341;kill h_variable_1342;kill h_variable_1343;kill h_variable_1344;kill h_variable_1345;kill h_variable_1346;kill h_variable_1347;kill h_variable_1348;kill h_variable_1349;kill h_variable_1350;kill h_variable_1351;kill h_variable_1352;kill h_variable_1353;kill h_variable_1354;kill h_variable_1355;kill h_variable_1356;kill h_variable_1357;kill h_variable_1358;kill h_variable_1359;kill h_variable_1360;kill h_variable_1361;kill h_variable_1362;kill h_variable_1363;kill h_variable_1364;kill h_variable_1365;kill h_variable_1366;kill h_variable_1367;kill h_variable_1368;kill h_variable_1369;kill h_variable_1370;kill h_variable_1371;kill h_variable_1372;kill h_variable_1373;kill h_variable_1374;kill h_variable_1375;kill h_variable_1376;kill h_variable_1377;kill h_variable_1378;kill h_variable_1384;
matrix h_variable_1501[1][3] = concat(h_variable_1500,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1501); matrix h_variable_1502 = h_variable_l[1]; matrix h_variable_1503 = h_variable_l[2];
ncols(h_variable_1502);
matrix h_variable_1504 = DecideZeroRows(h_variable_1502,h_variable_58);
IsZeroMatrix(h_variable_1504);
nrows(h_variable_1503);
def h_variable_1505 = h_variable_282[13,9];
h_variable_1505;
matrix h_variable_1506[1][1] = 0;
matrix h_variable_1507[1][3] = concat(h_variable_1506,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1507); matrix h_variable_1508 = h_variable_l[1]; matrix h_variable_1509 = h_variable_l[2];
ncols(h_variable_1508);
matrix h_variable_1510 = DecideZeroRows(h_variable_1508,h_variable_58);
IsZeroMatrix(h_variable_1510);
nrows(h_variable_1509);
def h_variable_1511 = h_variable_282[12,9];
h_variable_1511;
matrix h_variable_1512[1][1] = 0;
matrix h_variable_1513[1][3] = concat(h_variable_1512,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1513); matrix h_variable_1514 = h_variable_l[1]; matrix h_variable_1515 = h_variable_l[2];
ncols(h_variable_1514);
matrix h_variable_1516 = DecideZeroRows(h_variable_1514,h_variable_58);
IsZeroMatrix(h_variable_1516);
nrows(h_variable_1515);
def h_variable_1517 = h_variable_282[11,9];
h_variable_1517;
matrix h_variable_1518[1][1] = 0;
matrix h_variable_1519[1][3] = concat(h_variable_1518,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1519); matrix h_variable_1520 = h_variable_l[1]; matrix h_variable_1521 = h_variable_l[2];
ncols(h_variable_1520);
matrix h_variable_1522 = DecideZeroRows(h_variable_1520,h_variable_58);
IsZeroMatrix(h_variable_1522);
nrows(h_variable_1521);
def h_variable_1523 = h_variable_282[10,9];
h_variable_1523;
matrix h_variable_1524[1][1] = 0;
matrix h_variable_1525[1][3] = concat(h_variable_1524,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1525); matrix h_variable_1526 = h_variable_l[1]; matrix h_variable_1527 = h_variable_l[2];
ncols(h_variable_1526);
matrix h_variable_1528 = DecideZeroRows(h_variable_1526,h_variable_58);
IsZeroMatrix(h_variable_1528);
nrows(h_variable_1527);
def h_variable_1529 = h_variable_282[9,9];
h_variable_1529;
matrix h_variable_1530[1][1] = -1;
matrix h_variable_1531[1][3] = concat(h_variable_1530,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1531); matrix h_variable_1532 = h_variable_l[1]; matrix h_variable_1533 = h_variable_l[2];
ncols(h_variable_1532);
matrix h_variable_1534 = DecideZeroRows(h_variable_1532,h_variable_58);
IsZeroMatrix(h_variable_1534);
nrows(h_variable_1533);
IsIdentityMatrix(h_variable_1534);
def h_variable_1535 = h_variable_282[1,9];
h_variable_1535;
matrix h_variable_1536[1][1] = 0;
matrix h_variable_1537 = DecideZeroRows(h_variable_1536,h_variable_58);
IsZeroMatrix(h_variable_1537);
def h_variable_1538 = h_variable_1537[1,1];
h_variable_1538==0;
def h_variable_1539 = h_variable_282[3,9];
h_variable_1539;
matrix h_variable_1540[1][1] = 0;
matrix h_variable_1541 = DecideZeroRows(h_variable_1540,h_variable_58);
IsZeroMatrix(h_variable_1541);
def h_variable_1542 = h_variable_1541[1,1];
h_variable_1542==0;
def h_variable_1543 = h_variable_282[5,9];
h_variable_1543;
matrix h_variable_1544[1][1] = x1+5*x2;
matrix h_variable_1545 = DecideZeroRows(h_variable_1544,h_variable_58);
IsZeroMatrix(h_variable_1545);
def h_variable_1546 = h_variable_1545[1,1];
h_variable_1546==0;
def h_variable_1547 = h_variable_282[6,9];
h_variable_1547;
matrix h_variable_1548[1][1] = -x2-2*x3;
matrix h_variable_1549 = DecideZeroRows(h_variable_1548,h_variable_58);
IsZeroMatrix(h_variable_1549);
def h_variable_1550 = h_variable_1549[1,1];
h_variable_1550==0;
def h_variable_1551 = h_variable_282[7,9];
h_variable_1551;
matrix h_variable_1552[1][1] = 0;
matrix h_variable_1553 = DecideZeroRows(h_variable_1552,h_variable_58);
IsZeroMatrix(h_variable_1553);
def h_variable_1554 = h_variable_1553[1,1];
h_variable_1554==0;
def h_variable_1555 = h_variable_282[8,9];
h_variable_1555;
matrix h_variable_1556[1][1] = 0;
matrix h_variable_1557 = DecideZeroRows(h_variable_1556,h_variable_58);
IsZeroMatrix(h_variable_1557);
def h_variable_1558 = h_variable_1557[1,1];
h_variable_1558==0;
def h_variable_1559 = h_variable_282[9,9];
h_variable_1559;
matrix h_variable_1560[1][1] = -1;
matrix h_variable_1561 = DecideZeroRows(h_variable_1560,h_variable_58);
IsZeroMatrix(h_variable_1561);
def h_variable_1562 = h_variable_1561[1,1];
h_variable_1562==0;
def h_variable_1563 = h_variable_282[10,9];
h_variable_1563;
matrix h_variable_1564[1][1] = 0;
matrix h_variable_1565 = DecideZeroRows(h_variable_1564,h_variable_58);
IsZeroMatrix(h_variable_1565);
def h_variable_1566 = h_variable_1565[1,1];
h_variable_1566==0;
def h_variable_1567 = h_variable_282[11,9];
h_variable_1567;
matrix h_variable_1568[1][1] = 0;
matrix h_variable_1569 = DecideZeroRows(h_variable_1568,h_variable_58);
IsZeroMatrix(h_variable_1569);
def h_variable_1570 = h_variable_1569[1,1];
h_variable_1570==0;
def h_variable_1571 = h_variable_282[12,9];
h_variable_1571;
matrix h_variable_1572[1][1] = 0;
matrix h_variable_1573 = DecideZeroRows(h_variable_1572,h_variable_58);
IsZeroMatrix(h_variable_1573);
def h_variable_1574 = h_variable_1573[1,1];
h_variable_1574==0;
def h_variable_1575 = h_variable_282[13,9];
h_variable_1575;
matrix h_variable_1576[1][1] = 0;
matrix h_variable_1577 = DecideZeroRows(h_variable_1576,h_variable_58);
IsZeroMatrix(h_variable_1577);
def h_variable_1578 = h_variable_1577[1,1];
h_variable_1578==0;
def h_variable_1579 = h_variable_282[14,9];
h_variable_1579;
matrix h_variable_1580[1][1] = 0;
matrix h_variable_1581 = DecideZeroRows(h_variable_1580,h_variable_58);
IsZeroMatrix(h_variable_1581);
def h_variable_1582 = h_variable_1581[1,1];
h_variable_1582==0;
def h_variable_1583 = h_variable_282[15,9];
h_variable_1583;
matrix h_variable_1584[1][1] = 0;
matrix h_variable_1585 = DecideZeroRows(h_variable_1584,h_variable_58);
IsZeroMatrix(h_variable_1585);
def h_variable_1586 = h_variable_1585[1,1];
h_variable_1586==0;
def h_variable_1587 = h_variable_282[16,9];
h_variable_1587;
matrix h_variable_1588[1][1] = 0;
matrix h_variable_1589 = DecideZeroRows(h_variable_1588,h_variable_58);
IsZeroMatrix(h_variable_1589);
def h_variable_1590 = h_variable_1589[1,1];
h_variable_1590==0;
def h_variable_1591 = h_variable_282[17,9];
h_variable_1591;
matrix h_variable_1592[1][1] = 0;
matrix h_variable_1593 = DecideZeroRows(h_variable_1592,h_variable_58);
IsZeroMatrix(h_variable_1593);
def h_variable_1594 = h_variable_1593[1,1];
h_variable_1594==0;
def h_variable_1595 = h_variable_282[18,9];
h_variable_1595;
matrix h_variable_1596[1][1] = 0;
matrix h_variable_1597 = DecideZeroRows(h_variable_1596,h_variable_58);
IsZeroMatrix(h_variable_1597);
def h_variable_1598 = h_variable_1597[1,1];
h_variable_1598==0;
def h_variable_1599 = h_variable_282[19,9];
h_variable_1599;
matrix h_variable_1600[1][1] = 0;
matrix h_variable_1601 = DecideZeroRows(h_variable_1600,h_variable_58);
IsZeroMatrix(h_variable_1601);
def h_variable_1602 = h_variable_1601[1,1];
h_variable_1602==0;
def h_variable_1603 = h_variable_282[20,9];
h_variable_1603;
matrix h_variable_1604[1][1] = 0;
matrix h_variable_1605 = DecideZeroRows(h_variable_1604,h_variable_58);
IsZeroMatrix(h_variable_1605);
def h_variable_1606 = h_variable_1605[1,1];
h_variable_1606==0;
def h_variable_1607 = h_variable_282[21,9];
h_variable_1607;
matrix h_variable_1608[1][1] = 0;
matrix h_variable_1609 = DecideZeroRows(h_variable_1608,h_variable_58);
IsZeroMatrix(h_variable_1609);
def h_variable_1610 = h_variable_1609[1,1];
h_variable_1610==0;
def h_variable_1611 = h_variable_282[22,9];
h_variable_1611;
matrix h_variable_1612[1][1] = 0;
matrix h_variable_1613 = DecideZeroRows(h_variable_1612,h_variable_58);
IsZeroMatrix(h_variable_1613);
def h_variable_1614 = h_variable_1613[1,1];
h_variable_1614==0;
def h_variable_1615 = h_variable_282[22,10];
h_variable_1615;
matrix h_variable_1616[1][1] = 0;
matrix h_variable_1617[1][3] = concat(h_variable_1616,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1617); matrix h_variable_1618 = h_variable_l[1]; matrix h_variable_1619 = h_variable_l[2];
ncols(h_variable_1618);
matrix h_variable_1620 = DecideZeroRows(h_variable_1618,h_variable_58);
IsZeroMatrix(h_variable_1620);
nrows(h_variable_1619);
def h_variable_1621 = h_variable_282[21,10];
h_variable_1621;
matrix h_variable_1622[1][1] = 0;
matrix h_variable_1623[1][3] = concat(h_variable_1622,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1623); matrix h_variable_1624 = h_variable_l[1]; matrix h_variable_1625 = h_variable_l[2];
ncols(h_variable_1624);
matrix h_variable_1626 = DecideZeroRows(h_variable_1624,h_variable_58);
IsZeroMatrix(h_variable_1626);
nrows(h_variable_1625);
def h_variable_1627 = h_variable_282[20,10];
h_variable_1627;
matrix h_variable_1628[1][1] = 0;
matrix h_variable_1629[1][3] = concat(h_variable_1628,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1629); matrix h_variable_1630 = h_variable_l[1]; matrix h_variable_1631 = h_variable_l[2];
ncols(h_variable_1630);
matrix h_variable_1632 = DecideZeroRows(h_variable_1630,h_variable_58);
IsZeroMatrix(h_variable_1632);
nrows(h_variable_1631);
def h_variable_1633 = h_variable_282[19,10];
h_variable_1633;
matrix h_variable_1634[1][1] = 0;
matrix h_variable_1635[1][3] = concat(h_variable_1634,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1635); matrix h_variable_1636 = h_variable_l[1]; matrix h_variable_1637 = h_variable_l[2];
ncols(h_variable_1636);
matrix h_variable_1638 = DecideZeroRows(h_variable_1636,h_variable_58);
IsZeroMatrix(h_variable_1638);
nrows(h_variable_1637);
def h_variable_1639 = h_variable_282[18,10];
h_variable_1639;
matrix h_variable_1640[1][1] = 0;
matrix h_variable_1641[1][3] = concat(h_variable_1640,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1641); matrix h_variable_1642 = h_variable_l[1]; matrix h_variable_1643 = h_variable_l[2];
ncols(h_variable_1642);
matrix h_variable_1644 = DecideZeroRows(h_variable_1642,h_variable_58);
IsZeroMatrix(h_variable_1644);
nrows(h_variable_1643);
def h_variable_1645 = h_variable_282[17,10];
h_variable_1645;
matrix h_variable_1646[1][1] = 0;
matrix h_variable_1647[1][3] = concat(h_variable_1646,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1647); matrix h_variable_1648 = h_variable_l[1]; matrix h_variable_1649 = h_variable_l[2];
ncols(h_variable_1648);
matrix h_variable_1650 = DecideZeroRows(h_variable_1648,h_variable_58);
IsZeroMatrix(h_variable_1650);
nrows(h_variable_1649);
def h_variable_1651 = h_variable_282[16,10];
h_variable_1651;
matrix h_variable_1652[1][1] = 0;
matrix h_variable_1653[1][3] = concat(h_variable_1652,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1653); matrix h_variable_1654 = h_variable_l[1]; matrix h_variable_1655 = h_variable_l[2];
ncols(h_variable_1654);
matrix h_variable_1656 = DecideZeroRows(h_variable_1654,h_variable_58);
IsZeroMatrix(h_variable_1656);
nrows(h_variable_1655);
def h_variable_1657 = h_variable_282[15,10];
h_variable_1657;
matrix h_variable_1658[1][1] = 0;
matrix h_variable_1659[1][3] = concat(h_variable_1658,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1659); matrix h_variable_1660 = h_variable_l[1]; matrix h_variable_1661 = h_variable_l[2];
ncols(h_variable_1660);
matrix h_variable_1662 = DecideZeroRows(h_variable_1660,h_variable_58);
IsZeroMatrix(h_variable_1662);
nrows(h_variable_1661);
def h_variable_1663 = h_variable_282[14,10];
h_variable_1663;
matrix h_variable_1664[1][1] = 0;
matrix h_variable_1665[1][3] = concat(h_variable_1664,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1665); matrix h_variable_1666 = h_variable_l[1]; matrix h_variable_1667 = h_variable_l[2];
ncols(h_variable_1666);
matrix h_variable_1668 = DecideZeroRows(h_variable_1666,h_variable_58);
IsZeroMatrix(h_variable_1668);
nrows(h_variable_1667);
def h_variable_1669 = h_variable_282[13,10];
h_variable_1669;
matrix h_variable_1670[1][1] = 0;
matrix h_variable_1671[1][3] = concat(h_variable_1670,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1671); matrix h_variable_1672 = h_variable_l[1]; matrix h_variable_1673 = h_variable_l[2];
ncols(h_variable_1672);
matrix h_variable_1674 = DecideZeroRows(h_variable_1672,h_variable_58);
IsZeroMatrix(h_variable_1674);
nrows(h_variable_1673);
def h_variable_1675 = h_variable_282[12,10];
h_variable_1675;
matrix h_variable_1676[1][1] = 0;
matrix h_variable_1677[1][3] = concat(h_variable_1676,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1677); matrix h_variable_1678 = h_variable_l[1]; matrix h_variable_1679 = h_variable_l[2];
ncols(h_variable_1678);
matrix h_variable_1680 = DecideZeroRows(h_variable_1678,h_variable_58);
IsZeroMatrix(h_variable_1680);
nrows(h_variable_1679);
def h_variable_1681 = h_variable_282[11,10];
h_variable_1681;
matrix h_variable_1682[1][1] = 0;
matrix h_variable_1683[1][3] = concat(h_variable_1682,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1683); matrix h_variable_1684 = h_variable_l[1]; matrix h_variable_1685 = h_variable_l[2];
ncols(h_variable_1684);
matrix h_variable_1686 = DecideZeroRows(h_variable_1684,h_variable_58);
IsZeroMatrix(h_variable_1686);
nrows(h_variable_1685);
def h_variable_1687 = h_variable_282[10,10];
h_variable_1687;
matrix h_variable_1688[1][1] = 1;
matrix h_variable_1689[1][3] = concat(h_variable_1688,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1689); matrix h_variable_1690 = h_variable_l[1]; matrix h_variable_1691 = h_variable_l[2];
ncols(h_variable_1690);
matrix h_variable_1692 = DecideZeroRows(h_variable_1690,h_variable_58);
IsZeroMatrix(h_variable_1692);
nrows(h_variable_1691);
IsIdentityMatrix(h_variable_1692);
def h_variable_1693 = h_variable_282[1,10];
h_variable_1693;
matrix h_variable_1694[1][1] = 0;
matrix h_variable_1695 = DecideZeroRows(h_variable_1694,h_variable_58);
IsZeroMatrix(h_variable_1695);
def h_variable_1696 = h_variable_1695[1,1];
h_variable_1696==0;
def h_variable_1697 = h_variable_282[3,10];
h_variable_1697;
matrix h_variable_1698[1][1] = 0;
matrix h_variable_1699 = DecideZeroRows(h_variable_1698,h_variable_58);
IsZeroMatrix(h_variable_1699);
def h_variable_1700 = h_variable_1699[1,1];
h_variable_1700==0;
def h_variable_1701 = h_variable_282[7,10];
h_variable_1701;
matrix h_variable_1702[1][1] = -x2;
matrix h_variable_1703 = DecideZeroRows(h_variable_1702,h_variable_58);
IsZeroMatrix(h_variable_1703);
def h_variable_1704 = h_variable_1703[1,1];
h_variable_1704==0;
def h_variable_1705 = h_variable_282[8,10];
h_variable_1705;
matrix h_variable_1706[1][1] = 3;
matrix h_variable_1707 = DecideZeroRows(h_variable_1706,h_variable_58);
IsZeroMatrix(h_variable_1707);
def h_variable_1708 = h_variable_1707[1,1];
h_variable_1708==0;
def h_variable_1709 = h_variable_282[10,10];
h_variable_1709;
matrix h_variable_1710[1][1] = 1;
matrix h_variable_1711 = DecideZeroRows(h_variable_1710,h_variable_58);
IsZeroMatrix(h_variable_1711);
def h_variable_1712 = h_variable_1711[1,1];
h_variable_1712==0;
def h_variable_1713 = h_variable_282[11,10];
h_variable_1713;
matrix h_variable_1714[1][1] = 0;
matrix h_variable_1715 = DecideZeroRows(h_variable_1714,h_variable_58);
IsZeroMatrix(h_variable_1715);
def h_variable_1716 = h_variable_1715[1,1];
h_variable_1716==0;
def h_variable_1717 = h_variable_282[12,10];
h_variable_1717;
matrix h_variable_1718[1][1] = 0;
matrix h_variable_1719 = DecideZeroRows(h_variable_1718,h_variable_58);
IsZeroMatrix(h_variable_1719);
def h_variable_1720 = h_variable_1719[1,1];
h_variable_1720==0;
def h_variable_1721 = h_variable_282[13,10];
h_variable_1721;
matrix h_variable_1722[1][1] = 0;
matrix h_variable_1723 = DecideZeroRows(h_variable_1722,h_variable_58);
IsZeroMatrix(h_variable_1723);
def h_variable_1724 = h_variable_1723[1,1];
h_variable_1724==0;
def h_variable_1725 = h_variable_282[14,10];
h_variable_1725;
matrix h_variable_1726[1][1] = 0;
matrix h_variable_1727 = DecideZeroRows(h_variable_1726,h_variable_58);
IsZeroMatrix(h_variable_1727);
def h_variable_1728 = h_variable_1727[1,1];
h_variable_1728==0;
def h_variable_1729 = h_variable_282[15,10];
h_variable_1729;
matrix h_variable_1730[1][1] = 0;
matrix h_variable_1731 = DecideZeroRows(h_variable_1730,h_variable_58);
IsZeroMatrix(h_variable_1731);
def h_variable_1732 = h_variable_1731[1,1];
h_variable_1732==0;
def h_variable_1733 = h_variable_282[16,10];
h_variable_1733;
matrix h_variable_1734[1][1] = 0;
matrix h_variable_1735 = DecideZeroRows(h_variable_1734,h_variable_58);
IsZeroMatrix(h_variable_1735);
def h_variable_1736 = h_variable_1735[1,1];
h_variable_1736==0;
def h_variable_1737 = h_variable_282[17,10];
h_variable_1737;
matrix h_variable_1738[1][1] = 0;
matrix h_variable_1739 = DecideZeroRows(h_variable_1738,h_variable_58);
IsZeroMatrix(h_variable_1739);
def h_variable_1740 = h_variable_1739[1,1];
h_variable_1740==0;
def h_variable_1741 = h_variable_282[18,10];
h_variable_1741;
matrix h_variable_1742[1][1] = 0;
matrix h_variable_1743 = DecideZeroRows(h_variable_1742,h_variable_58);
IsZeroMatrix(h_variable_1743);
def h_variable_1744 = h_variable_1743[1,1];
h_variable_1744==0;
def h_variable_1745 = h_variable_282[19,10];
h_variable_1745;
matrix h_variable_1746[1][1] = 0;
matrix h_variable_1747 = DecideZeroRows(h_variable_1746,h_variable_58);
IsZeroMatrix(h_variable_1747);
def h_variable_1748 = h_variable_1747[1,1];
h_variable_1748==0;
def h_variable_1749 = h_variable_282[20,10];
h_variable_1749;
matrix h_variable_1750[1][1] = 0;
matrix h_variable_1751 = DecideZeroRows(h_variable_1750,h_variable_58);
IsZeroMatrix(h_variable_1751);
def h_variable_1752 = h_variable_1751[1,1];
h_variable_1752==0;
def h_variable_1753 = h_variable_282[21,10];
h_variable_1753;
matrix h_variable_1754[1][1] = 0;
matrix h_variable_1755 = DecideZeroRows(h_variable_1754,h_variable_58);
IsZeroMatrix(h_variable_1755);
def h_variable_1756 = h_variable_1755[1,1];
h_variable_1756==0;
def h_variable_1757 = h_variable_282[22,10];
h_variable_1757;
matrix h_variable_1758[1][1] = 0;
matrix h_variable_1759 = DecideZeroRows(h_variable_1758,h_variable_58);
IsZeroMatrix(h_variable_1759);
def h_variable_1760 = h_variable_1759[1,1];
h_variable_1760==0;
def h_variable_1761 = h_variable_282[22,11];
h_variable_1761;
matrix h_variable_1762[1][1] = 0;
matrix h_variable_1763[1][3] = concat(h_variable_1762,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1763); matrix h_variable_1764 = h_variable_l[1]; matrix h_variable_1765 = h_variable_l[2];
ncols(h_variable_1764);
matrix h_variable_1766 = DecideZeroRows(h_variable_1764,h_variable_58);
IsZeroMatrix(h_variable_1766);
nrows(h_variable_1765);
def h_variable_1767 = h_variable_282[21,11];
h_variable_1767;
matrix h_variable_1768[1][1] = 0;
matrix h_variable_1769[1][3] = concat(h_variable_1768,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1769); matrix h_variable_1770 = h_variable_l[1]; matrix h_variable_1771 = h_variable_l[2];
ncols(h_variable_1770);
matrix h_variable_1772 = DecideZeroRows(h_variable_1770,h_variable_58);
IsZeroMatrix(h_variable_1772);
nrows(h_variable_1771);
def h_variable_1773 = h_variable_282[20,11];
h_variable_1773;
matrix h_variable_1774[1][1] = 0;
matrix h_variable_1775[1][3] = concat(h_variable_1774,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1775); matrix h_variable_1776 = h_variable_l[1]; matrix h_variable_1777 = h_variable_l[2];
ncols(h_variable_1776);
matrix h_variable_1778 = DecideZeroRows(h_variable_1776,h_variable_58);
IsZeroMatrix(h_variable_1778);
nrows(h_variable_1777);
def h_variable_1779 = h_variable_282[19,11];
h_variable_1779;
matrix h_variable_1780[1][1] = 0;
matrix h_variable_1781[1][3] = concat(h_variable_1780,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1781); matrix h_variable_1782 = h_variable_l[1]; matrix h_variable_1783 = h_variable_l[2];
ncols(h_variable_1782);
matrix h_variable_1784 = DecideZeroRows(h_variable_1782,h_variable_58);
IsZeroMatrix(h_variable_1784);
nrows(h_variable_1783);
def h_variable_1785 = h_variable_282[18,11];
h_variable_1785;
matrix h_variable_1786[1][1] = 0;
matrix h_variable_1787[1][3] = concat(h_variable_1786,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1787); matrix h_variable_1788 = h_variable_l[1]; matrix h_variable_1789 = h_variable_l[2];
ncols(h_variable_1788);
matrix h_variable_1790 = DecideZeroRows(h_variable_1788,h_variable_58);
IsZeroMatrix(h_variable_1790);
nrows(h_variable_1789);
def h_variable_1791 = h_variable_282[17,11];
h_variable_1791;
matrix h_variable_1792[1][1] = 0;
matrix h_variable_1793[1][3] = concat(h_variable_1792,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1793); matrix h_variable_1794 = h_variable_l[1]; matrix h_variable_1795 = h_variable_l[2];
ncols(h_variable_1794);
matrix h_variable_1796 = DecideZeroRows(h_variable_1794,h_variable_58);
IsZeroMatrix(h_variable_1796);
nrows(h_variable_1795);
def h_variable_1797 = h_variable_282[16,11];
h_variable_1797;
matrix h_variable_1798[1][1] = 0;
matrix h_variable_1799[1][3] = concat(h_variable_1798,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1799); matrix h_variable_1800 = h_variable_l[1]; matrix h_variable_1801 = h_variable_l[2];
ncols(h_variable_1800);
matrix h_variable_1802 = DecideZeroRows(h_variable_1800,h_variable_58);
IsZeroMatrix(h_variable_1802);
nrows(h_variable_1801);
def h_variable_1803 = h_variable_282[15,11];
h_variable_1803;
matrix h_variable_1804[1][1] = 0;
matrix h_variable_1805[1][3] = concat(h_variable_1804,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1805); matrix h_variable_1806 = h_variable_l[1]; matrix h_variable_1807 = h_variable_l[2];
ncols(h_variable_1806);
matrix h_variable_1808 = DecideZeroRows(h_variable_1806,h_variable_58);
IsZeroMatrix(h_variable_1808);
nrows(h_variable_1807);
def h_variable_1809 = h_variable_282[14,11];
h_variable_1809;
matrix h_variable_1810[1][1] = 0;
matrix h_variable_1811[1][3] = concat(h_variable_1810,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1811); matrix h_variable_1812 = h_variable_l[1]; matrix h_variable_1813 = h_variable_l[2];
ncols(h_variable_1812);
matrix h_variable_1814 = DecideZeroRows(h_variable_1812,h_variable_58);
IsZeroMatrix(h_variable_1814);
nrows(h_variable_1813);
def h_variable_1815 = h_variable_282[13,11];
h_variable_1815;
matrix h_variable_1816[1][1] = 0;
matrix h_variable_1817[1][3] = concat(h_variable_1816,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1817); matrix h_variable_1818 = h_variable_l[1]; matrix h_variable_1819 = h_variable_l[2];
ncols(h_variable_1818);
matrix h_variable_1820 = DecideZeroRows(h_variable_1818,h_variable_58);
IsZeroMatrix(h_variable_1820);
nrows(h_variable_1819);
def h_variable_1821 = h_variable_282[12,11];
h_variable_1821;
matrix h_variable_1822[1][1] = -3;
matrix h_variable_1823[1][3] = concat(h_variable_1822,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1823); matrix h_variable_1824 = h_variable_l[1]; matrix h_variable_1825 = h_variable_l[2];
ncols(h_variable_1824);
matrix h_variable_1826 = DecideZeroRows(h_variable_1824,h_variable_58);
IsZeroMatrix(h_variable_1826);
ZeroRows(h_variable_1826);
nrows(h_variable_1825);
matrix h_variable_1828 = submat(h_variable_1824,1..1,intvec( 1 ));
matrix h_variable_1827 = DecideZeroRows(h_variable_1828,h_variable_58);
IsZeroMatrix(h_variable_1827);
IsIdentityMatrix(h_variable_1827);
matrix h_variable_1829[1][3] = concat(h_variable_1827,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1829); matrix h_variable_1830 = h_variable_l[1]; matrix h_variable_1831 = h_variable_l[2];
IsZeroMatrix(h_variable_1830);
matrix h_variable_1832 = DecideZeroRows(h_variable_1830,h_variable_58);
IsZeroMatrix(h_variable_1832);
def h_variable_1833 = h_variable_282[11,11];
h_variable_1833;
matrix h_variable_1834[1][1] = 0;
matrix h_variable_1835[1][3] = concat(h_variable_1834,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1835); matrix h_variable_1836 = h_variable_l[1]; matrix h_variable_1837 = h_variable_l[2];
ncols(h_variable_1836);
matrix h_variable_1838 = DecideZeroRows(h_variable_1836,h_variable_58);
IsZeroMatrix(h_variable_1838);
nrows(h_variable_1837);
def h_variable_1839 = h_variable_282[3,11];
h_variable_1839;
matrix h_variable_1840[1][1] = 0;
matrix h_variable_1841[1][3] = concat(h_variable_1840,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1841); matrix h_variable_1842 = h_variable_l[1]; matrix h_variable_1843 = h_variable_l[2];
ncols(h_variable_1842);
matrix h_variable_1844 = DecideZeroRows(h_variable_1842,h_variable_58);
IsZeroMatrix(h_variable_1844);
nrows(h_variable_1843);
def h_variable_1845 = h_variable_282[1,11];
h_variable_1845;
matrix h_variable_1846[1][1] = 0;
matrix h_variable_1847[1][3] = concat(h_variable_1846,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1847); matrix h_variable_1848 = h_variable_l[1]; matrix h_variable_1849 = h_variable_l[2];
ncols(h_variable_1848);
matrix h_variable_1850 = DecideZeroRows(h_variable_1848,h_variable_58);
IsZeroMatrix(h_variable_1850);
nrows(h_variable_1849);
def h_variable_1851 = h_variable_282[22,12];
h_variable_1851;
matrix h_variable_1852[1][1] = 0;
matrix h_variable_1853[1][3] = concat(h_variable_1852,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1853); matrix h_variable_1854 = h_variable_l[1]; matrix h_variable_1855 = h_variable_l[2];
ncols(h_variable_1854);
matrix h_variable_1856 = DecideZeroRows(h_variable_1854,h_variable_58);
IsZeroMatrix(h_variable_1856);
nrows(h_variable_1855);
def h_variable_1857 = h_variable_282[21,12];
h_variable_1857;
matrix h_variable_1858[1][1] = 0;
matrix h_variable_1859[1][3] = concat(h_variable_1858,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1859); matrix h_variable_1860 = h_variable_l[1]; matrix h_variable_1861 = h_variable_l[2];
ncols(h_variable_1860);
matrix h_variable_1862 = DecideZeroRows(h_variable_1860,h_variable_58);
IsZeroMatrix(h_variable_1862);
nrows(h_variable_1861);
def h_variable_1863 = h_variable_282[20,12];
h_variable_1863;
matrix h_variable_1864[1][1] = 0;
matrix h_variable_1865[1][3] = concat(h_variable_1864,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1865); matrix h_variable_1866 = h_variable_l[1]; matrix h_variable_1867 = h_variable_l[2];
ncols(h_variable_1866);
matrix h_variable_1868 = DecideZeroRows(h_variable_1866,h_variable_58);
IsZeroMatrix(h_variable_1868);
nrows(h_variable_1867);
def h_variable_1869 = h_variable_282[19,12];
h_variable_1869;
matrix h_variable_1870[1][1] = 0;
matrix h_variable_1871[1][3] = concat(h_variable_1870,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1871); matrix h_variable_1872 = h_variable_l[1]; matrix h_variable_1873 = h_variable_l[2];
ncols(h_variable_1872);
matrix h_variable_1874 = DecideZeroRows(h_variable_1872,h_variable_58);
IsZeroMatrix(h_variable_1874);
nrows(h_variable_1873);
def h_variable_1875 = h_variable_282[18,12];
h_variable_1875;
matrix h_variable_1876[1][1] = -2;
matrix h_variable_1877[1][3] = concat(h_variable_1876,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1877); matrix h_variable_1878 = h_variable_l[1]; matrix h_variable_1879 = h_variable_l[2];
ncols(h_variable_1878);
matrix h_variable_1880 = DecideZeroRows(h_variable_1878,h_variable_58);
IsZeroMatrix(h_variable_1880);
ZeroRows(h_variable_1880);
nrows(h_variable_1879);
matrix h_variable_1882 = submat(h_variable_1878,1..1,intvec( 1 ));
matrix h_variable_1881 = DecideZeroRows(h_variable_1882,h_variable_58);
IsZeroMatrix(h_variable_1881);
IsIdentityMatrix(h_variable_1881);
matrix h_variable_1883[1][3] = concat(h_variable_1881,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1883); matrix h_variable_1884 = h_variable_l[1]; matrix h_variable_1885 = h_variable_l[2];
IsZeroMatrix(h_variable_1884);
matrix h_variable_1886 = DecideZeroRows(h_variable_1884,h_variable_58);
IsZeroMatrix(h_variable_1886);
def h_variable_1887 = h_variable_282[17,12];
h_variable_1887;
matrix h_variable_1888[1][1] = 3;
matrix h_variable_1889[1][3] = concat(h_variable_1888,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1889); matrix h_variable_1890 = h_variable_l[1]; matrix h_variable_1891 = h_variable_l[2];
ncols(h_variable_1890);
matrix h_variable_1892 = DecideZeroRows(h_variable_1890,h_variable_58);
IsZeroMatrix(h_variable_1892);
ZeroRows(h_variable_1892);
nrows(h_variable_1891);
matrix h_variable_1894 = submat(h_variable_1890,1..1,intvec( 1 ));
matrix h_variable_1893 = DecideZeroRows(h_variable_1894,h_variable_58);
IsZeroMatrix(h_variable_1893);
IsIdentityMatrix(h_variable_1893);
matrix h_variable_1895[1][3] = concat(h_variable_1893,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1895); matrix h_variable_1896 = h_variable_l[1]; matrix h_variable_1897 = h_variable_l[2];
IsZeroMatrix(h_variable_1896);
matrix h_variable_1898 = DecideZeroRows(h_variable_1896,h_variable_58);
IsZeroMatrix(h_variable_1898);
def h_variable_1899 = h_variable_282[16,12];
h_variable_1899;
matrix h_variable_1900[1][1] = -5;
matrix h_variable_1901[1][3] = concat(h_variable_1900,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1901); matrix h_variable_1902 = h_variable_l[1]; matrix h_variable_1903 = h_variable_l[2];
ncols(h_variable_1902);
matrix h_variable_1904 = DecideZeroRows(h_variable_1902,h_variable_58);
IsZeroMatrix(h_variable_1904);
nrows(h_variable_1903);
IsIdentityMatrix(h_variable_1904);
def h_variable_1905 = h_variable_282[1,12];
h_variable_1905;
matrix h_variable_1906[1][1] = 0;
matrix h_variable_1907 = DecideZeroRows(h_variable_1906,h_variable_58);
IsZeroMatrix(h_variable_1907);
def h_variable_1908 = h_variable_1907[1,1];
h_variable_1908==0;
def h_variable_1909 = h_variable_282[3,12];
h_variable_1909;
matrix h_variable_1910[1][1] = 0;
matrix h_variable_1911 = DecideZeroRows(h_variable_1910,h_variable_58);
IsZeroMatrix(h_variable_1911);
def h_variable_1912 = h_variable_1911[1,1];
h_variable_1912==0;
def h_variable_1913 = h_variable_282[11,12];
h_variable_1913;
matrix h_variable_1914[1][1] = 3*x1;
matrix h_variable_1915 = DecideZeroRows(h_variable_1914,h_variable_58);
IsZeroMatrix(h_variable_1915);
def h_variable_1916 = h_variable_1915[1,1];
h_variable_1916==0;
def h_variable_1917 = h_variable_282[12,12];
h_variable_1917;
matrix h_variable_1918[1][1] = x1+3*x2;
matrix h_variable_1919 = DecideZeroRows(h_variable_1918,h_variable_58);
IsZeroMatrix(h_variable_1919);
def h_variable_1920 = h_variable_1919[1,1];
h_variable_1920==0;
def h_variable_1921 = h_variable_282[13,12];
h_variable_1921;
matrix h_variable_1922[1][1] = 3*x3;
matrix h_variable_1923 = DecideZeroRows(h_variable_1922,h_variable_58);
IsZeroMatrix(h_variable_1923);
def h_variable_1924 = h_variable_1923[1,1];
h_variable_1924==0;
def h_variable_1925 = h_variable_282[14,12];
h_variable_1925;
matrix h_variable_1926[1][1] = -2*x3;
matrix h_variable_1927 = DecideZeroRows(h_variable_1926,h_variable_58);
IsZeroMatrix(h_variable_1927);
def h_variable_1928 = h_variable_1927[1,1];
h_variable_1928==0;
def h_variable_1929 = h_variable_282[15,12];
h_variable_1929;
matrix h_variable_1930[1][1] = 0;
matrix h_variable_1931 = DecideZeroRows(h_variable_1930,h_variable_58);
IsZeroMatrix(h_variable_1931);
def h_variable_1932 = h_variable_1931[1,1];
h_variable_1932==0;
def h_variable_1933 = h_variable_282[16,12];
h_variable_1933;
matrix h_variable_1934[1][1] = -5;
matrix h_variable_1935 = DecideZeroRows(h_variable_1934,h_variable_58);
IsZeroMatrix(h_variable_1935);
def h_variable_1936 = h_variable_1935[1,1];
h_variable_1936==0;
def h_variable_1937 = h_variable_282[17,12];
h_variable_1937;
matrix h_variable_1938[1][1] = 3;
matrix h_variable_1939 = DecideZeroRows(h_variable_1938,h_variable_58);
IsZeroMatrix(h_variable_1939);
def h_variable_1940 = h_variable_1939[1,1];
h_variable_1940==0;
def h_variable_1941 = h_variable_282[18,12];
h_variable_1941;
matrix h_variable_1942[1][1] = -2;
matrix h_variable_1943 = DecideZeroRows(h_variable_1942,h_variable_58);
IsZeroMatrix(h_variable_1943);
def h_variable_1944 = h_variable_1943[1,1];
h_variable_1944==0;
def h_variable_1945 = h_variable_282[19,12];
h_variable_1945;
matrix h_variable_1946[1][1] = 0;
matrix h_variable_1947 = DecideZeroRows(h_variable_1946,h_variable_58);
IsZeroMatrix(h_variable_1947);
def h_variable_1948 = h_variable_1947[1,1];
h_variable_1948==0;
def h_variable_1949 = h_variable_282[20,12];
h_variable_1949;
matrix h_variable_1950[1][1] = 0;
matrix h_variable_1951 = DecideZeroRows(h_variable_1950,h_variable_58);
IsZeroMatrix(h_variable_1951);
def h_variable_1952 = h_variable_1951[1,1];
h_variable_1952==0;
def h_variable_1953 = h_variable_282[21,12];
h_variable_1953;
matrix h_variable_1954[1][1] = 0;
matrix h_variable_1955 = DecideZeroRows(h_variable_1954,h_variable_58);
IsZeroMatrix(h_variable_1955);
def h_variable_1956 = h_variable_1955[1,1];
h_variable_1956==0;
def h_variable_1957 = h_variable_282[22,12];
h_variable_1957;
matrix h_variable_1958[1][1] = 0;
matrix h_variable_1959 = DecideZeroRows(h_variable_1958,h_variable_58);
IsZeroMatrix(h_variable_1959);
def h_variable_1960 = h_variable_1959[1,1];
h_variable_1960==0;
def h_variable_1961 = h_variable_282[22,13];
h_variable_1961;
matrix h_variable_1962[1][1] = 0;
matrix h_variable_1963[1][3] = concat(h_variable_1962,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1963); matrix h_variable_1964 = h_variable_l[1]; matrix h_variable_1965 = h_variable_l[2];
ncols(h_variable_1964);
matrix h_variable_1966 = DecideZeroRows(h_variable_1964,h_variable_58);
IsZeroMatrix(h_variable_1966);
nrows(h_variable_1965);
def h_variable_1967 = h_variable_282[21,13];
h_variable_1967;
matrix h_variable_1968[1][1] = 0;
matrix h_variable_1969[1][3] = concat(h_variable_1968,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1969); matrix h_variable_1970 = h_variable_l[1]; matrix h_variable_1971 = h_variable_l[2];
ncols(h_variable_1970);
matrix h_variable_1972 = DecideZeroRows(h_variable_1970,h_variable_58);
IsZeroMatrix(h_variable_1972);
nrows(h_variable_1971);
def h_variable_1973 = h_variable_282[20,13];
h_variable_1973;
matrix h_variable_1974[1][1] = 0;
matrix h_variable_1975[1][3] = concat(h_variable_1974,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1975); matrix h_variable_1976 = h_variable_l[1]; matrix h_variable_1977 = h_variable_l[2];
ncols(h_variable_1976);
matrix h_variable_1978 = DecideZeroRows(h_variable_1976,h_variable_58);
IsZeroMatrix(h_variable_1978);
nrows(h_variable_1977);
def h_variable_1979 = h_variable_282[19,13];
h_variable_1979;
matrix h_variable_1980[1][1] = 0;
matrix h_variable_1981[1][3] = concat(h_variable_1980,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1981); matrix h_variable_1982 = h_variable_l[1]; matrix h_variable_1983 = h_variable_l[2];
ncols(h_variable_1982);
matrix h_variable_1984 = DecideZeroRows(h_variable_1982,h_variable_58);
IsZeroMatrix(h_variable_1984);
nrows(h_variable_1983);
def h_variable_1985 = h_variable_282[15,13];
h_variable_1985;
matrix h_variable_1986[1][1] = -3;
matrix h_variable_1987[1][3] = concat(h_variable_1986,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_1987); matrix h_variable_1988 = h_variable_l[1]; matrix h_variable_1989 = h_variable_l[2];
ncols(h_variable_1988);
matrix h_variable_1990 = DecideZeroRows(h_variable_1988,h_variable_58);
IsZeroMatrix(h_variable_1990);
ZeroRows(h_variable_1990);
nrows(h_variable_1989);
matrix h_variable_1992 = submat(h_variable_1988,1..1,intvec( 1 ));
matrix h_variable_1991 = DecideZeroRows(h_variable_1992,h_variable_58);
IsZeroMatrix(h_variable_1991);
IsIdentityMatrix(h_variable_1991);
matrix h_variable_1993[1][3] = concat(h_variable_1991,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_1993); matrix h_variable_1994 = h_variable_l[1]; matrix h_variable_1995 = h_variable_l[2];
IsZeroMatrix(h_variable_1994);
matrix h_variable_1996 = DecideZeroRows(h_variable_1994,h_variable_58);
IsZeroMatrix(h_variable_1996);
def h_variable_1997 = h_variable_282[3,13];
h_variable_1997;
matrix h_variable_1998[1][1] = 0;
matrix h_variable_1999[1][3] = concat(h_variable_1998,h_variable_48);
kill h_variable_1387;kill h_variable_1388;kill h_variable_1389;kill h_variable_1390;kill h_variable_1392;kill h_variable_1393;kill h_variable_1394;kill h_variable_1395;kill h_variable_1396;kill h_variable_1398;kill h_variable_1402;kill h_variable_1404;kill h_variable_1405;kill h_variable_1406;kill h_variable_1407;kill h_variable_1408;kill h_variable_1409;kill h_variable_1410;kill h_variable_1411;kill h_variable_1412;kill h_variable_1413;kill h_variable_1414;kill h_variable_1415;kill h_variable_1416;kill h_variable_1417;kill h_variable_1418;kill h_variable_1419;kill h_variable_1420;kill h_variable_1421;kill h_variable_1422;kill h_variable_1423;kill h_variable_1424;kill h_variable_1425;kill h_variable_1426;kill h_variable_1427;kill h_variable_1428;kill h_variable_1429;kill h_variable_1430;kill h_variable_1431;kill h_variable_1432;kill h_variable_1433;kill h_variable_1434;kill h_variable_1435;kill h_variable_1436;kill h_variable_1437;kill h_variable_1438;kill h_variable_1439;kill h_variable_1440;kill h_variable_1441;kill h_variable_1442;kill h_variable_1443;kill h_variable_1444;kill h_variable_1445;kill h_variable_1446;kill h_variable_1447;kill h_variable_1448;kill h_variable_1449;kill h_variable_1450;kill h_variable_1451;kill h_variable_1452;kill h_variable_1453;kill h_variable_1454;kill h_variable_1455;kill h_variable_1456;kill h_variable_1457;kill h_variable_1458;kill h_variable_1459;kill h_variable_1460;kill h_variable_1461;kill h_variable_1462;kill h_variable_1463;kill h_variable_1464;kill h_variable_1465;kill h_variable_1466;kill h_variable_1467;kill h_variable_1468;kill h_variable_1469;kill h_variable_1470;kill h_variable_1471;kill h_variable_1472;kill h_variable_1473;kill h_variable_1474;kill h_variable_1475;kill h_variable_1476;kill h_variable_1477;kill h_variable_1478;kill h_variable_1479;kill h_variable_1480;kill h_variable_1481;kill h_variable_1482;kill h_variable_1483;kill h_variable_1484;kill h_variable_1485;kill h_variable_1486;kill h_variable_1487;kill h_variable_1488;kill h_variable_1489;kill h_variable_1490;kill h_variable_1491;kill h_variable_1492;kill h_variable_1493;kill h_variable_1494;kill h_variable_1495;kill h_variable_1496;kill h_variable_1497;kill h_variable_1498;kill h_variable_1499;kill h_variable_1500;kill h_variable_1501;kill h_variable_1502;kill h_variable_1503;kill h_variable_1504;kill h_variable_1507;kill h_variable_1508;kill h_variable_1509;kill h_variable_1510;kill h_variable_1513;kill h_variable_1514;kill h_variable_1515;kill h_variable_1516;kill h_variable_1518;kill h_variable_1519;kill h_variable_1520;kill h_variable_1521;kill h_variable_1522;kill h_variable_1524;kill h_variable_1525;kill h_variable_1526;kill h_variable_1527;kill h_variable_1528;kill h_variable_1529;kill h_variable_1530;kill h_variable_1531;kill h_variable_1532;kill h_variable_1533;kill h_variable_1534;kill h_variable_1535;kill h_variable_1536;kill h_variable_1537;kill h_variable_1538;kill h_variable_1539;kill h_variable_1540;kill h_variable_1541;kill h_variable_1542;kill h_variable_1543;kill h_variable_1544;kill h_variable_1545;kill h_variable_1546;kill h_variable_1547;kill h_variable_1548;kill h_variable_1549;kill h_variable_1550;kill h_variable_1551;kill h_variable_1552;kill h_variable_1553;kill h_variable_1554;kill h_variable_1555;kill h_variable_1556;kill h_variable_1557;kill h_variable_1558;kill h_variable_1559;kill h_variable_1560;kill h_variable_1561;kill h_variable_1562;kill h_variable_1563;kill h_variable_1564;kill h_variable_1565;kill h_variable_1566;kill h_variable_1567;kill h_variable_1568;kill h_variable_1569;kill h_variable_1570;kill h_variable_1571;kill h_variable_1572;kill h_variable_1573;kill h_variable_1574;kill h_variable_1575;kill h_variable_1576;kill h_variable_1577;kill h_variable_1578;kill h_variable_1579;kill h_variable_1580;kill h_variable_1581;kill h_variable_1582;kill h_variable_1583;kill h_variable_1584;kill h_variable_1585;kill h_variable_1586;kill h_variable_1587;kill h_variable_1588;kill h_variable_1589;kill h_variable_1590;kill h_variable_1591;kill h_variable_1592;kill h_variable_1593;kill h_variable_1594;kill h_variable_1595;kill h_variable_1596;kill h_variable_1597;kill h_variable_1598;kill h_variable_1599;kill h_variable_1600;kill h_variable_1601;kill h_variable_1602;kill h_variable_1603;kill h_variable_1604;kill h_variable_1605;kill h_variable_1606;kill h_variable_1607;kill h_variable_1608;kill h_variable_1609;kill h_variable_1610;kill h_variable_1611;kill h_variable_1612;kill h_variable_1613;kill h_variable_1614;kill h_variable_1615;kill h_variable_1616;kill h_variable_1617;kill h_variable_1618;kill h_variable_1619;kill h_variable_1620;kill h_variable_1621;kill h_variable_1622;kill h_variable_1623;kill h_variable_1624;kill h_variable_1625;kill h_variable_1626;kill h_variable_1627;kill h_variable_1628;kill h_variable_1629;kill h_variable_1630;kill h_variable_1631;kill h_variable_1632;kill h_variable_1633;kill h_variable_1634;kill h_variable_1635;kill h_variable_1636;kill h_variable_1637;kill h_variable_1638;kill h_variable_1639;kill h_variable_1640;kill h_variable_1641;kill h_variable_1642;kill h_variable_1643;kill h_variable_1644;kill h_variable_1645;kill h_variable_1646;kill h_variable_1647;kill h_variable_1648;kill h_variable_1649;kill h_variable_1650;kill h_variable_1651;kill h_variable_1652;kill h_variable_1653;kill h_variable_1654;kill h_variable_1655;kill h_variable_1656;kill h_variable_1657;kill h_variable_1658;kill h_variable_1659;kill h_variable_1660;kill h_variable_1661;kill h_variable_1662;kill h_variable_1663;kill h_variable_1664;kill h_variable_1665;kill h_variable_1666;kill h_variable_1667;kill h_variable_1668;kill h_variable_1669;kill h_variable_1670;kill h_variable_1671;kill h_variable_1672;kill h_variable_1673;kill h_variable_1674;kill h_variable_1675;kill h_variable_1676;kill h_variable_1677;kill h_variable_1678;kill h_variable_1679;kill h_variable_1680;kill h_variable_1681;kill h_variable_1682;kill h_variable_1683;kill h_variable_1684;kill h_variable_1685;kill h_variable_1686;kill h_variable_1687;kill h_variable_1688;kill h_variable_1689;kill h_variable_1690;kill h_variable_1691;kill h_variable_1692;kill h_variable_1693;kill h_variable_1694;kill h_variable_1695;kill h_variable_1696;kill h_variable_1697;kill h_variable_1698;kill h_variable_1699;kill h_variable_1700;kill h_variable_1701;kill h_variable_1702;kill h_variable_1703;kill h_variable_1704;kill h_variable_1705;kill h_variable_1706;kill h_variable_1707;kill h_variable_1708;kill h_variable_1709;kill h_variable_1710;kill h_variable_1711;kill h_variable_1712;kill h_variable_1713;kill h_variable_1714;kill h_variable_1715;kill h_variable_1716;kill h_variable_1717;kill h_variable_1718;kill h_variable_1719;kill h_variable_1720;kill h_variable_1721;kill h_variable_1722;kill h_variable_1723;kill h_variable_1724;kill h_variable_1725;kill h_variable_1726;kill h_variable_1727;kill h_variable_1728;kill h_variable_1729;kill h_variable_1730;kill h_variable_1731;kill h_variable_1732;kill h_variable_1733;kill h_variable_1734;kill h_variable_1735;kill h_variable_1736;kill h_variable_1737;kill h_variable_1738;kill h_variable_1739;kill h_variable_1740;kill h_variable_1741;kill h_variable_1742;kill h_variable_1743;kill h_variable_1744;kill h_variable_1745;kill h_variable_1746;kill h_variable_1747;kill h_variable_1748;kill h_variable_1749;kill h_variable_1750;kill h_variable_1751;kill h_variable_1752;kill h_variable_1753;kill h_variable_1754;kill h_variable_1755;kill h_variable_1756;kill h_variable_1757;kill h_variable_1758;kill h_variable_1759;kill h_variable_1760;kill h_variable_1761;kill h_variable_1762;kill h_variable_1763;kill h_variable_1764;kill h_variable_1765;kill h_variable_1766;kill h_variable_1767;kill h_variable_1768;kill h_variable_1769;kill h_variable_1770;kill h_variable_1771;kill h_variable_1772;kill h_variable_1773;kill h_variable_1774;kill h_variable_1775;kill h_variable_1776;kill h_variable_1777;kill h_variable_1778;
list h_variable_l=BasisOfRowsCoeff(h_variable_1999); matrix h_variable_2000 = h_variable_l[1]; matrix h_variable_2001 = h_variable_l[2];
ncols(h_variable_2000);
matrix h_variable_2002 = DecideZeroRows(h_variable_2000,h_variable_58);
IsZeroMatrix(h_variable_2002);
nrows(h_variable_2001);
def h_variable_2003 = h_variable_282[1,13];
h_variable_2003;
matrix h_variable_2004[1][1] = 0;
matrix h_variable_2005[1][3] = concat(h_variable_2004,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2005); matrix h_variable_2006 = h_variable_l[1]; matrix h_variable_2007 = h_variable_l[2];
ncols(h_variable_2006);
matrix h_variable_2008 = DecideZeroRows(h_variable_2006,h_variable_58);
IsZeroMatrix(h_variable_2008);
nrows(h_variable_2007);
def h_variable_2009 = h_variable_282[22,14];
h_variable_2009;
matrix h_variable_2010[1][1] = 0;
matrix h_variable_2011[1][3] = concat(h_variable_2010,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2011); matrix h_variable_2012 = h_variable_l[1]; matrix h_variable_2013 = h_variable_l[2];
ncols(h_variable_2012);
matrix h_variable_2014 = DecideZeroRows(h_variable_2012,h_variable_58);
IsZeroMatrix(h_variable_2014);
nrows(h_variable_2013);
def h_variable_2015 = h_variable_282[21,14];
h_variable_2015;
matrix h_variable_2016[1][1] = 4;
matrix h_variable_2017[1][3] = concat(h_variable_2016,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2017); matrix h_variable_2018 = h_variable_l[1]; matrix h_variable_2019 = h_variable_l[2];
ncols(h_variable_2018);
matrix h_variable_2020 = DecideZeroRows(h_variable_2018,h_variable_58);
IsZeroMatrix(h_variable_2020);
ZeroRows(h_variable_2020);
nrows(h_variable_2019);
matrix h_variable_2022 = submat(h_variable_2018,1..1,intvec( 1 ));
matrix h_variable_2021 = DecideZeroRows(h_variable_2022,h_variable_58);
IsZeroMatrix(h_variable_2021);
IsIdentityMatrix(h_variable_2021);
matrix h_variable_2023[1][3] = concat(h_variable_2021,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2023); matrix h_variable_2024 = h_variable_l[1]; matrix h_variable_2025 = h_variable_l[2];
IsZeroMatrix(h_variable_2024);
matrix h_variable_2026 = DecideZeroRows(h_variable_2024,h_variable_58);
IsZeroMatrix(h_variable_2026);
def h_variable_2027 = h_variable_282[20,14];
h_variable_2027;
matrix h_variable_2028[1][1] = 0;
matrix h_variable_2029[1][3] = concat(h_variable_2028,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2029); matrix h_variable_2030 = h_variable_l[1]; matrix h_variable_2031 = h_variable_l[2];
ncols(h_variable_2030);
matrix h_variable_2032 = DecideZeroRows(h_variable_2030,h_variable_58);
IsZeroMatrix(h_variable_2032);
nrows(h_variable_2031);
def h_variable_2033 = h_variable_282[19,14];
h_variable_2033;
matrix h_variable_2034[1][1] = 0;
matrix h_variable_2035[1][3] = concat(h_variable_2034,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2035); matrix h_variable_2036 = h_variable_l[1]; matrix h_variable_2037 = h_variable_l[2];
ncols(h_variable_2036);
matrix h_variable_2038 = DecideZeroRows(h_variable_2036,h_variable_58);
IsZeroMatrix(h_variable_2038);
nrows(h_variable_2037);
def h_variable_2039 = h_variable_282[15,14];
h_variable_2039;
matrix h_variable_2040[1][1] = 2*x1-4*x2+2*x3;
matrix h_variable_2041[1][3] = concat(h_variable_2040,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2041); matrix h_variable_2042 = h_variable_l[1]; matrix h_variable_2043 = h_variable_l[2];
ncols(h_variable_2042);
matrix h_variable_2044 = DecideZeroRows(h_variable_2042,h_variable_58);
IsZeroMatrix(h_variable_2044);
ZeroRows(h_variable_2044);
nrows(h_variable_2043);
matrix h_variable_2046 = submat(h_variable_2042,1..1,intvec( 2 ));
matrix h_variable_2045 = DecideZeroRows(h_variable_2046,h_variable_58);
IsZeroMatrix(h_variable_2045);
IsIdentityMatrix(h_variable_2045);
matrix h_variable_2047[1][3] = concat(h_variable_2045,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2047); matrix h_variable_2048 = h_variable_l[1]; matrix h_variable_2049 = h_variable_l[2];
IsZeroMatrix(h_variable_2048);
matrix h_variable_2050 = DecideZeroRows(h_variable_2048,h_variable_58);
IsZeroMatrix(h_variable_2050);
def h_variable_2051 = h_variable_282[3,14];
h_variable_2051;
matrix h_variable_2052[1][1] = 0;
matrix h_variable_2053[1][3] = concat(h_variable_2052,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2053); matrix h_variable_2054 = h_variable_l[1]; matrix h_variable_2055 = h_variable_l[2];
ncols(h_variable_2054);
matrix h_variable_2056 = DecideZeroRows(h_variable_2054,h_variable_58);
IsZeroMatrix(h_variable_2056);
nrows(h_variable_2055);
def h_variable_2057 = h_variable_282[1,14];
h_variable_2057;
matrix h_variable_2058[1][1] = 0;
matrix h_variable_2059[1][3] = concat(h_variable_2058,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2059); matrix h_variable_2060 = h_variable_l[1]; matrix h_variable_2061 = h_variable_l[2];
ncols(h_variable_2060);
matrix h_variable_2062 = DecideZeroRows(h_variable_2060,h_variable_58);
IsZeroMatrix(h_variable_2062);
nrows(h_variable_2061);
def h_variable_2063 = h_variable_282[22,15];
h_variable_2063;
matrix h_variable_2064[1][1] = 0;
matrix h_variable_2065[1][3] = concat(h_variable_2064,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2065); matrix h_variable_2066 = h_variable_l[1]; matrix h_variable_2067 = h_variable_l[2];
ncols(h_variable_2066);
matrix h_variable_2068 = DecideZeroRows(h_variable_2066,h_variable_58);
IsZeroMatrix(h_variable_2068);
nrows(h_variable_2067);
def h_variable_2069 = h_variable_282[21,15];
h_variable_2069;
matrix h_variable_2070[1][1] = 0;
matrix h_variable_2071[1][3] = concat(h_variable_2070,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2071); matrix h_variable_2072 = h_variable_l[1]; matrix h_variable_2073 = h_variable_l[2];
ncols(h_variable_2072);
matrix h_variable_2074 = DecideZeroRows(h_variable_2072,h_variable_58);
IsZeroMatrix(h_variable_2074);
nrows(h_variable_2073);
def h_variable_2075 = h_variable_282[20,15];
h_variable_2075;
matrix h_variable_2076[1][1] = 0;
matrix h_variable_2077[1][3] = concat(h_variable_2076,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2077); matrix h_variable_2078 = h_variable_l[1]; matrix h_variable_2079 = h_variable_l[2];
ncols(h_variable_2078);
matrix h_variable_2080 = DecideZeroRows(h_variable_2078,h_variable_58);
IsZeroMatrix(h_variable_2080);
nrows(h_variable_2079);
def h_variable_2081 = h_variable_282[19,15];
h_variable_2081;
matrix h_variable_2082[1][1] = 0;
matrix h_variable_2083[1][3] = concat(h_variable_2082,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2083); matrix h_variable_2084 = h_variable_l[1]; matrix h_variable_2085 = h_variable_l[2];
ncols(h_variable_2084);
matrix h_variable_2086 = DecideZeroRows(h_variable_2084,h_variable_58);
IsZeroMatrix(h_variable_2086);
nrows(h_variable_2085);
def h_variable_2087 = h_variable_282[15,15];
h_variable_2087;
matrix h_variable_2088[1][1] = 0;
matrix h_variable_2089[1][3] = concat(h_variable_2088,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2089); matrix h_variable_2090 = h_variable_l[1]; matrix h_variable_2091 = h_variable_l[2];
ncols(h_variable_2090);
matrix h_variable_2092 = DecideZeroRows(h_variable_2090,h_variable_58);
IsZeroMatrix(h_variable_2092);
nrows(h_variable_2091);
def h_variable_2093 = h_variable_282[3,15];
h_variable_2093;
matrix h_variable_2094[1][1] = 0;
matrix h_variable_2095[1][3] = concat(h_variable_2094,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2095); matrix h_variable_2096 = h_variable_l[1]; matrix h_variable_2097 = h_variable_l[2];
ncols(h_variable_2096);
matrix h_variable_2098 = DecideZeroRows(h_variable_2096,h_variable_58);
IsZeroMatrix(h_variable_2098);
nrows(h_variable_2097);
def h_variable_2099 = h_variable_282[1,15];
h_variable_2099;
matrix h_variable_2100[1][1] = 0;
matrix h_variable_2101[1][3] = concat(h_variable_2100,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2101); matrix h_variable_2102 = h_variable_l[1]; matrix h_variable_2103 = h_variable_l[2];
ncols(h_variable_2102);
matrix h_variable_2104 = DecideZeroRows(h_variable_2102,h_variable_58);
IsZeroMatrix(h_variable_2104);
nrows(h_variable_2103);
def h_variable_2105 = h_variable_282[22,16];
h_variable_2105;
matrix h_variable_2106[1][1] = 0;
matrix h_variable_2107[1][3] = concat(h_variable_2106,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2107); matrix h_variable_2108 = h_variable_l[1]; matrix h_variable_2109 = h_variable_l[2];
ncols(h_variable_2108);
matrix h_variable_2110 = DecideZeroRows(h_variable_2108,h_variable_58);
IsZeroMatrix(h_variable_2110);
nrows(h_variable_2109);
def h_variable_2111 = h_variable_282[21,16];
h_variable_2111;
matrix h_variable_2112[1][1] = 0;
matrix h_variable_2113[1][3] = concat(h_variable_2112,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2113); matrix h_variable_2114 = h_variable_l[1]; matrix h_variable_2115 = h_variable_l[2];
ncols(h_variable_2114);
matrix h_variable_2116 = DecideZeroRows(h_variable_2114,h_variable_58);
IsZeroMatrix(h_variable_2116);
nrows(h_variable_2115);
def h_variable_2117 = h_variable_282[20,16];
h_variable_2117;
matrix h_variable_2118[1][1] = 0;
matrix h_variable_2119[1][3] = concat(h_variable_2118,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2119); matrix h_variable_2120 = h_variable_l[1]; matrix h_variable_2121 = h_variable_l[2];
ncols(h_variable_2120);
matrix h_variable_2122 = DecideZeroRows(h_variable_2120,h_variable_58);
IsZeroMatrix(h_variable_2122);
nrows(h_variable_2121);
def h_variable_2123 = h_variable_282[19,16];
h_variable_2123;
matrix h_variable_2124[1][1] = 0;
matrix h_variable_2125[1][3] = concat(h_variable_2124,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2125); matrix h_variable_2126 = h_variable_l[1]; matrix h_variable_2127 = h_variable_l[2];
ncols(h_variable_2126);
matrix h_variable_2128 = DecideZeroRows(h_variable_2126,h_variable_58);
IsZeroMatrix(h_variable_2128);
nrows(h_variable_2127);
def h_variable_2129 = h_variable_282[15,16];
h_variable_2129;
matrix h_variable_2130[1][1] = 0;
matrix h_variable_2131[1][3] = concat(h_variable_2130,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2131); matrix h_variable_2132 = h_variable_l[1]; matrix h_variable_2133 = h_variable_l[2];
ncols(h_variable_2132);
matrix h_variable_2134 = DecideZeroRows(h_variable_2132,h_variable_58);
IsZeroMatrix(h_variable_2134);
nrows(h_variable_2133);
def h_variable_2135 = h_variable_282[3,16];
h_variable_2135;
matrix h_variable_2136[1][1] = a7+1;
matrix h_variable_2137[1][3] = concat(h_variable_2136,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2137); matrix h_variable_2138 = h_variable_l[1]; matrix h_variable_2139 = h_variable_l[2];
ncols(h_variable_2138);
matrix h_variable_2140 = DecideZeroRows(h_variable_2138,h_variable_58);
IsZeroMatrix(h_variable_2140);
ZeroRows(h_variable_2140);
nrows(h_variable_2139);
matrix h_variable_2141[1][4] = concat(h_variable_2138,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2141); matrix h_variable_2142 = h_variable_l[1]; matrix h_variable_2143 = h_variable_l[2];
IsZeroMatrix(h_variable_2142);
matrix h_variable_2144 = DecideZeroRows(h_variable_2142,h_variable_58);
IsZeroMatrix(h_variable_2144);
def h_variable_2145 = h_variable_282[1,16];
h_variable_2145;
matrix h_variable_2146[1][1] = 0;
matrix h_variable_2147[1][3] = concat(h_variable_2146,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2147); matrix h_variable_2148 = h_variable_l[1]; matrix h_variable_2149 = h_variable_l[2];
ncols(h_variable_2148);
matrix h_variable_2150 = DecideZeroRows(h_variable_2148,h_variable_58);
IsZeroMatrix(h_variable_2150);
nrows(h_variable_2149);
def h_variable_2151 = h_variable_282[22,17];
h_variable_2151;
matrix h_variable_2152[1][1] = 0;
matrix h_variable_2153[1][3] = concat(h_variable_2152,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2153); matrix h_variable_2154 = h_variable_l[1]; matrix h_variable_2155 = h_variable_l[2];
ncols(h_variable_2154);
matrix h_variable_2156 = DecideZeroRows(h_variable_2154,h_variable_58);
IsZeroMatrix(h_variable_2156);
nrows(h_variable_2155);
def h_variable_2157 = h_variable_282[21,17];
h_variable_2157;
matrix h_variable_2158[1][1] = 0;
matrix h_variable_2159[1][3] = concat(h_variable_2158,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2159); matrix h_variable_2160 = h_variable_l[1]; matrix h_variable_2161 = h_variable_l[2];
ncols(h_variable_2160);
matrix h_variable_2162 = DecideZeroRows(h_variable_2160,h_variable_58);
IsZeroMatrix(h_variable_2162);
nrows(h_variable_2161);
def h_variable_2163 = h_variable_282[20,17];
h_variable_2163;
matrix h_variable_2164[1][1] = 0;
matrix h_variable_2165[1][3] = concat(h_variable_2164,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2165); matrix h_variable_2166 = h_variable_l[1]; matrix h_variable_2167 = h_variable_l[2];
ncols(h_variable_2166);
matrix h_variable_2168 = DecideZeroRows(h_variable_2166,h_variable_58);
IsZeroMatrix(h_variable_2168);
nrows(h_variable_2167);
def h_variable_2169 = h_variable_282[19,17];
h_variable_2169;
matrix h_variable_2170[1][1] = 0;
matrix h_variable_2171[1][3] = concat(h_variable_2170,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2171); matrix h_variable_2172 = h_variable_l[1]; matrix h_variable_2173 = h_variable_l[2];
ncols(h_variable_2172);
matrix h_variable_2174 = DecideZeroRows(h_variable_2172,h_variable_58);
IsZeroMatrix(h_variable_2174);
nrows(h_variable_2173);
def h_variable_2175 = h_variable_282[15,17];
h_variable_2175;
matrix h_variable_2176[1][1] = 0;
matrix h_variable_2177[1][3] = concat(h_variable_2176,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2177); matrix h_variable_2178 = h_variable_l[1]; matrix h_variable_2179 = h_variable_l[2];
ncols(h_variable_2178);
matrix h_variable_2180 = DecideZeroRows(h_variable_2178,h_variable_58);
IsZeroMatrix(h_variable_2180);
nrows(h_variable_2179);
def h_variable_2181 = h_variable_282[3,17];
h_variable_2181;
matrix h_variable_2182[1][1] = 0;
matrix h_variable_2183[1][3] = concat(h_variable_2182,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2183); matrix h_variable_2184 = h_variable_l[1]; matrix h_variable_2185 = h_variable_l[2];
ncols(h_variable_2184);
matrix h_variable_2186 = DecideZeroRows(h_variable_2184,h_variable_58);
IsZeroMatrix(h_variable_2186);
nrows(h_variable_2185);
def h_variable_2187 = h_variable_282[1,17];
h_variable_2187;
matrix h_variable_2188[1][1] = 0;
matrix h_variable_2189[1][3] = concat(h_variable_2188,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2189); matrix h_variable_2190 = h_variable_l[1]; matrix h_variable_2191 = h_variable_l[2];
ncols(h_variable_2190);
matrix h_variable_2192 = DecideZeroRows(h_variable_2190,h_variable_58);
IsZeroMatrix(h_variable_2192);
nrows(h_variable_2191);
def h_variable_2193 = h_variable_282[22,18];
h_variable_2193;
matrix h_variable_2194[1][1] = 0;
matrix h_variable_2195[1][3] = concat(h_variable_2194,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2195); matrix h_variable_2196 = h_variable_l[1]; matrix h_variable_2197 = h_variable_l[2];
ncols(h_variable_2196);
matrix h_variable_2198 = DecideZeroRows(h_variable_2196,h_variable_58);
IsZeroMatrix(h_variable_2198);
nrows(h_variable_2197);
def h_variable_2199 = h_variable_282[21,18];
h_variable_2199;
matrix h_variable_2200[1][1] = 0;
matrix h_variable_2201[1][3] = concat(h_variable_2200,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2201); matrix h_variable_2202 = h_variable_l[1]; matrix h_variable_2203 = h_variable_l[2];
ncols(h_variable_2202);
matrix h_variable_2204 = DecideZeroRows(h_variable_2202,h_variable_58);
IsZeroMatrix(h_variable_2204);
nrows(h_variable_2203);
def h_variable_2205 = h_variable_282[20,18];
h_variable_2205;
matrix h_variable_2206[1][1] = 0;
matrix h_variable_2207[1][3] = concat(h_variable_2206,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2207); matrix h_variable_2208 = h_variable_l[1]; matrix h_variable_2209 = h_variable_l[2];
ncols(h_variable_2208);
matrix h_variable_2210 = DecideZeroRows(h_variable_2208,h_variable_58);
IsZeroMatrix(h_variable_2210);
nrows(h_variable_2209);
def h_variable_2211 = h_variable_282[19,18];
h_variable_2211;
matrix h_variable_2212[1][1] = 0;
matrix h_variable_2213[1][3] = concat(h_variable_2212,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2213); matrix h_variable_2214 = h_variable_l[1]; matrix h_variable_2215 = h_variable_l[2];
ncols(h_variable_2214);
matrix h_variable_2216 = DecideZeroRows(h_variable_2214,h_variable_58);
IsZeroMatrix(h_variable_2216);
nrows(h_variable_2215);
def h_variable_2217 = h_variable_282[15,18];
h_variable_2217;
matrix h_variable_2218[1][1] = 0;
matrix h_variable_2219[1][3] = concat(h_variable_2218,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2219); matrix h_variable_2220 = h_variable_l[1]; matrix h_variable_2221 = h_variable_l[2];
ncols(h_variable_2220);
matrix h_variable_2222 = DecideZeroRows(h_variable_2220,h_variable_58);
IsZeroMatrix(h_variable_2222);
nrows(h_variable_2221);
def h_variable_2223 = h_variable_282[3,18];
h_variable_2223;
matrix h_variable_2224[1][1] = x3;
matrix h_variable_2225[1][3] = concat(h_variable_2224,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2225); matrix h_variable_2226 = h_variable_l[1]; matrix h_variable_2227 = h_variable_l[2];
ncols(h_variable_2226);
matrix h_variable_2228 = DecideZeroRows(h_variable_2226,h_variable_58);
IsZeroMatrix(h_variable_2228);
ZeroRows(h_variable_2228);
nrows(h_variable_2227);
matrix h_variable_2230 = submat(h_variable_2226,1..1,intvec( 2 ));
matrix h_variable_2229 = DecideZeroRows(h_variable_2230,h_variable_58);
IsZeroMatrix(h_variable_2229);
IsIdentityMatrix(h_variable_2229);
matrix h_variable_2231[1][3] = concat(h_variable_2229,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2231); matrix h_variable_2232 = h_variable_l[1]; matrix h_variable_2233 = h_variable_l[2];
IsZeroMatrix(h_variable_2232);
matrix h_variable_2234 = DecideZeroRows(h_variable_2232,h_variable_58);
IsZeroMatrix(h_variable_2234);
def h_variable_2235 = h_variable_282[1,18];
h_variable_2235;
matrix h_variable_2236[1][1] = 0;
matrix h_variable_2237[1][3] = concat(h_variable_2236,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2237); matrix h_variable_2238 = h_variable_l[1]; matrix h_variable_2239 = h_variable_l[2];
ncols(h_variable_2238);
matrix h_variable_2240 = DecideZeroRows(h_variable_2238,h_variable_58);
IsZeroMatrix(h_variable_2240);
nrows(h_variable_2239);
def h_variable_2241 = h_variable_282[22,19];
h_variable_2241;
matrix h_variable_2242[1][1] = 0;
matrix h_variable_2243[1][3] = concat(h_variable_2242,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2243); matrix h_variable_2244 = h_variable_l[1]; matrix h_variable_2245 = h_variable_l[2];
ncols(h_variable_2244);
matrix h_variable_2246 = DecideZeroRows(h_variable_2244,h_variable_58);
IsZeroMatrix(h_variable_2246);
nrows(h_variable_2245);
def h_variable_2247 = h_variable_282[21,19];
h_variable_2247;
matrix h_variable_2248[1][1] = 0;
matrix h_variable_2249[1][3] = concat(h_variable_2248,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2249); matrix h_variable_2250 = h_variable_l[1]; matrix h_variable_2251 = h_variable_l[2];
ncols(h_variable_2250);
matrix h_variable_2252 = DecideZeroRows(h_variable_2250,h_variable_58);
IsZeroMatrix(h_variable_2252);
nrows(h_variable_2251);
def h_variable_2253 = h_variable_282[20,19];
h_variable_2253;
matrix h_variable_2254[1][1] = 0;
matrix h_variable_2255[1][3] = concat(h_variable_2254,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2255); matrix h_variable_2256 = h_variable_l[1]; matrix h_variable_2257 = h_variable_l[2];
ncols(h_variable_2256);
matrix h_variable_2258 = DecideZeroRows(h_variable_2256,h_variable_58);
IsZeroMatrix(h_variable_2258);
nrows(h_variable_2257);
def h_variable_2259 = h_variable_282[19,19];
h_variable_2259;
matrix h_variable_2260[1][1] = 0;
matrix h_variable_2261[1][3] = concat(h_variable_2260,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2261); matrix h_variable_2262 = h_variable_l[1]; matrix h_variable_2263 = h_variable_l[2];
ncols(h_variable_2262);
matrix h_variable_2264 = DecideZeroRows(h_variable_2262,h_variable_58);
IsZeroMatrix(h_variable_2264);
nrows(h_variable_2263);
def h_variable_2265 = h_variable_282[15,19];
h_variable_2265;
matrix h_variable_2266[1][1] = 0;
matrix h_variable_2267[1][3] = concat(h_variable_2266,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2267); matrix h_variable_2268 = h_variable_l[1]; matrix h_variable_2269 = h_variable_l[2];
ncols(h_variable_2268);
matrix h_variable_2270 = DecideZeroRows(h_variable_2268,h_variable_58);
IsZeroMatrix(h_variable_2270);
nrows(h_variable_2269);
def h_variable_2271 = h_variable_282[3,19];
h_variable_2271;
matrix h_variable_2272[1][1] = 0;
matrix h_variable_2273[1][3] = concat(h_variable_2272,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2273); matrix h_variable_2274 = h_variable_l[1]; matrix h_variable_2275 = h_variable_l[2];
ncols(h_variable_2274);
matrix h_variable_2276 = DecideZeroRows(h_variable_2274,h_variable_58);
IsZeroMatrix(h_variable_2276);
nrows(h_variable_2275);
def h_variable_2277 = h_variable_282[1,19];
h_variable_2277;
matrix h_variable_2278[1][1] = 0;
matrix h_variable_2279[1][3] = concat(h_variable_2278,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2279); matrix h_variable_2280 = h_variable_l[1]; matrix h_variable_2281 = h_variable_l[2];
ncols(h_variable_2280);
matrix h_variable_2282 = DecideZeroRows(h_variable_2280,h_variable_58);
IsZeroMatrix(h_variable_2282);
nrows(h_variable_2281);
def h_variable_2283 = h_variable_282[22,20];
h_variable_2283;
matrix h_variable_2284[1][1] = 0;
matrix h_variable_2285[1][3] = concat(h_variable_2284,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2285); matrix h_variable_2286 = h_variable_l[1]; matrix h_variable_2287 = h_variable_l[2];
ncols(h_variable_2286);
matrix h_variable_2288 = DecideZeroRows(h_variable_2286,h_variable_58);
IsZeroMatrix(h_variable_2288);
nrows(h_variable_2287);
def h_variable_2289 = h_variable_282[21,20];
h_variable_2289;
matrix h_variable_2290[1][1] = 0;
matrix h_variable_2291[1][3] = concat(h_variable_2290,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2291); matrix h_variable_2292 = h_variable_l[1]; matrix h_variable_2293 = h_variable_l[2];
ncols(h_variable_2292);
matrix h_variable_2294 = DecideZeroRows(h_variable_2292,h_variable_58);
IsZeroMatrix(h_variable_2294);
nrows(h_variable_2293);
def h_variable_2295 = h_variable_282[20,20];
h_variable_2295;
matrix h_variable_2296[1][1] = 0;
matrix h_variable_2297[1][3] = concat(h_variable_2296,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2297); matrix h_variable_2298 = h_variable_l[1]; matrix h_variable_2299 = h_variable_l[2];
ncols(h_variable_2298);
matrix h_variable_2300 = DecideZeroRows(h_variable_2298,h_variable_58);
IsZeroMatrix(h_variable_2300);
nrows(h_variable_2299);
def h_variable_2301 = h_variable_282[19,20];
h_variable_2301;
matrix h_variable_2302[1][1] = 0;
matrix h_variable_2303[1][3] = concat(h_variable_2302,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2303); matrix h_variable_2304 = h_variable_l[1]; matrix h_variable_2305 = h_variable_l[2];
ncols(h_variable_2304);
matrix h_variable_2306 = DecideZeroRows(h_variable_2304,h_variable_58);
IsZeroMatrix(h_variable_2306);
nrows(h_variable_2305);
def h_variable_2307 = h_variable_282[15,20];
h_variable_2307;
matrix h_variable_2308[1][1] = 0;
matrix h_variable_2309[1][3] = concat(h_variable_2308,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2309); matrix h_variable_2310 = h_variable_l[1]; matrix h_variable_2311 = h_variable_l[2];
ncols(h_variable_2310);
matrix h_variable_2312 = DecideZeroRows(h_variable_2310,h_variable_58);
IsZeroMatrix(h_variable_2312);
nrows(h_variable_2311);
def h_variable_2313 = h_variable_282[3,20];
h_variable_2313;
matrix h_variable_2314[1][1] = -2*x3;
matrix h_variable_2315[1][3] = concat(h_variable_2314,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2315); matrix h_variable_2316 = h_variable_l[1]; matrix h_variable_2317 = h_variable_l[2];
ncols(h_variable_2316);
matrix h_variable_2318 = DecideZeroRows(h_variable_2316,h_variable_58);
IsZeroMatrix(h_variable_2318);
ZeroRows(h_variable_2318);
nrows(h_variable_2317);
matrix h_variable_2320 = submat(h_variable_2316,1..1,intvec( 2 ));
matrix h_variable_2319 = DecideZeroRows(h_variable_2320,h_variable_58);
IsZeroMatrix(h_variable_2319);
IsIdentityMatrix(h_variable_2319);
matrix h_variable_2321[1][3] = concat(h_variable_2319,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2321); matrix h_variable_2322 = h_variable_l[1]; matrix h_variable_2323 = h_variable_l[2];
IsZeroMatrix(h_variable_2322);
matrix h_variable_2324 = DecideZeroRows(h_variable_2322,h_variable_58);
IsZeroMatrix(h_variable_2324);
def h_variable_2325 = h_variable_282[1,20];
h_variable_2325;
matrix h_variable_2326[1][1] = 0;
matrix h_variable_2327[1][3] = concat(h_variable_2326,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2327); matrix h_variable_2328 = h_variable_l[1]; matrix h_variable_2329 = h_variable_l[2];
ncols(h_variable_2328);
matrix h_variable_2330 = DecideZeroRows(h_variable_2328,h_variable_58);
IsZeroMatrix(h_variable_2330);
nrows(h_variable_2329);
def h_variable_2331 = h_variable_282[22,21];
h_variable_2331;
matrix h_variable_2332[1][1] = 0;
matrix h_variable_2333[1][3] = concat(h_variable_2332,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2333); matrix h_variable_2334 = h_variable_l[1]; matrix h_variable_2335 = h_variable_l[2];
ncols(h_variable_2334);
matrix h_variable_2336 = DecideZeroRows(h_variable_2334,h_variable_58);
IsZeroMatrix(h_variable_2336);
nrows(h_variable_2335);
def h_variable_2337 = h_variable_282[21,21];
h_variable_2337;
matrix h_variable_2338[1][1] = 0;
matrix h_variable_2339[1][3] = concat(h_variable_2338,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2339); matrix h_variable_2340 = h_variable_l[1]; matrix h_variable_2341 = h_variable_l[2];
ncols(h_variable_2340);
matrix h_variable_2342 = DecideZeroRows(h_variable_2340,h_variable_58);
IsZeroMatrix(h_variable_2342);
nrows(h_variable_2341);
def h_variable_2343 = h_variable_282[20,21];
h_variable_2343;
matrix h_variable_2344[1][1] = 0;
matrix h_variable_2345[1][3] = concat(h_variable_2344,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2345); matrix h_variable_2346 = h_variable_l[1]; matrix h_variable_2347 = h_variable_l[2];
ncols(h_variable_2346);
matrix h_variable_2348 = DecideZeroRows(h_variable_2346,h_variable_58);
IsZeroMatrix(h_variable_2348);
nrows(h_variable_2347);
def h_variable_2349 = h_variable_282[19,21];
h_variable_2349;
matrix h_variable_2350[1][1] = 0;
matrix h_variable_2351[1][3] = concat(h_variable_2350,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2351); matrix h_variable_2352 = h_variable_l[1]; matrix h_variable_2353 = h_variable_l[2];
ncols(h_variable_2352);
matrix h_variable_2354 = DecideZeroRows(h_variable_2352,h_variable_58);
IsZeroMatrix(h_variable_2354);
nrows(h_variable_2353);
def h_variable_2355 = h_variable_282[15,21];
h_variable_2355;
matrix h_variable_2356[1][1] = 0;
matrix h_variable_2357[1][3] = concat(h_variable_2356,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2357); matrix h_variable_2358 = h_variable_l[1]; matrix h_variable_2359 = h_variable_l[2];
ncols(h_variable_2358);
matrix h_variable_2360 = DecideZeroRows(h_variable_2358,h_variable_58);
IsZeroMatrix(h_variable_2360);
nrows(h_variable_2359);
def h_variable_2361 = h_variable_282[3,21];
h_variable_2361;
matrix h_variable_2362[1][1] = 0;
matrix h_variable_2363[1][3] = concat(h_variable_2362,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2363); matrix h_variable_2364 = h_variable_l[1]; matrix h_variable_2365 = h_variable_l[2];
ncols(h_variable_2364);
matrix h_variable_2366 = DecideZeroRows(h_variable_2364,h_variable_58);
IsZeroMatrix(h_variable_2366);
nrows(h_variable_2365);
def h_variable_2367 = h_variable_282[1,21];
h_variable_2367;
matrix h_variable_2368[1][1] = 0;
matrix h_variable_2369[1][3] = concat(h_variable_2368,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2369); matrix h_variable_2370 = h_variable_l[1]; matrix h_variable_2371 = h_variable_l[2];
ncols(h_variable_2370);
matrix h_variable_2372 = DecideZeroRows(h_variable_2370,h_variable_58);
IsZeroMatrix(h_variable_2372);
nrows(h_variable_2371);
def h_variable_2373 = h_variable_282[22,22];
h_variable_2373;
matrix h_variable_2374[1][1] = 0;
matrix h_variable_2375[1][3] = concat(h_variable_2374,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2375); matrix h_variable_2376 = h_variable_l[1]; matrix h_variable_2377 = h_variable_l[2];
ncols(h_variable_2376);
matrix h_variable_2378 = DecideZeroRows(h_variable_2376,h_variable_58);
IsZeroMatrix(h_variable_2378);
nrows(h_variable_2377);
def h_variable_2379 = h_variable_282[21,22];
h_variable_2379;
matrix h_variable_2380[1][1] = 0;
matrix h_variable_2381[1][3] = concat(h_variable_2380,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2381); matrix h_variable_2382 = h_variable_l[1]; matrix h_variable_2383 = h_variable_l[2];
ncols(h_variable_2382);
matrix h_variable_2384 = DecideZeroRows(h_variable_2382,h_variable_58);
IsZeroMatrix(h_variable_2384);
nrows(h_variable_2383);
def h_variable_2385 = h_variable_282[20,22];
h_variable_2385;
matrix h_variable_2386[1][1] = 0;
matrix h_variable_2387[1][3] = concat(h_variable_2386,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2387); matrix h_variable_2388 = h_variable_l[1]; matrix h_variable_2389 = h_variable_l[2];
ncols(h_variable_2388);
matrix h_variable_2390 = DecideZeroRows(h_variable_2388,h_variable_58);
IsZeroMatrix(h_variable_2390);
nrows(h_variable_2389);
def h_variable_2391 = h_variable_282[19,22];
h_variable_2391;
matrix h_variable_2392[1][1] = 0;
matrix h_variable_2393[1][3] = concat(h_variable_2392,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2393); matrix h_variable_2394 = h_variable_l[1]; matrix h_variable_2395 = h_variable_l[2];
ncols(h_variable_2394);
matrix h_variable_2396 = DecideZeroRows(h_variable_2394,h_variable_58);
IsZeroMatrix(h_variable_2396);
nrows(h_variable_2395);
def h_variable_2397 = h_variable_282[15,22];
h_variable_2397;
matrix h_variable_2398[1][1] = 0;
matrix h_variable_2399[1][3] = concat(h_variable_2398,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2399); matrix h_variable_2400 = h_variable_l[1]; matrix h_variable_2401 = h_variable_l[2];
ncols(h_variable_2400);
matrix h_variable_2402 = DecideZeroRows(h_variable_2400,h_variable_58);
IsZeroMatrix(h_variable_2402);
nrows(h_variable_2401);
def h_variable_2403 = h_variable_282[3,22];
h_variable_2403;
matrix h_variable_2404[1][1] = 0;
matrix h_variable_2405[1][3] = concat(h_variable_2404,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2405); matrix h_variable_2406 = h_variable_l[1]; matrix h_variable_2407 = h_variable_l[2];
ncols(h_variable_2406);
matrix h_variable_2408 = DecideZeroRows(h_variable_2406,h_variable_58);
IsZeroMatrix(h_variable_2408);
nrows(h_variable_2407);
def h_variable_2409 = h_variable_282[1,22];
h_variable_2409;
matrix h_variable_2410[1][1] = 0;
matrix h_variable_2411[1][3] = concat(h_variable_2410,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2411); matrix h_variable_2412 = h_variable_l[1]; matrix h_variable_2413 = h_variable_l[2];
ncols(h_variable_2412);
matrix h_variable_2414 = DecideZeroRows(h_variable_2412,h_variable_58);
IsZeroMatrix(h_variable_2414);
nrows(h_variable_2413);
def h_variable_2415 = h_variable_282[22,23];
h_variable_2415;
matrix h_variable_2416[1][1] = 0;
matrix h_variable_2417[1][3] = concat(h_variable_2416,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2417); matrix h_variable_2418 = h_variable_l[1]; matrix h_variable_2419 = h_variable_l[2];
ncols(h_variable_2418);
matrix h_variable_2420 = DecideZeroRows(h_variable_2418,h_variable_58);
IsZeroMatrix(h_variable_2420);
nrows(h_variable_2419);
def h_variable_2421 = h_variable_282[21,23];
h_variable_2421;
matrix h_variable_2422[1][1] = 0;
matrix h_variable_2423[1][3] = concat(h_variable_2422,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2423); matrix h_variable_2424 = h_variable_l[1]; matrix h_variable_2425 = h_variable_l[2];
ncols(h_variable_2424);
matrix h_variable_2426 = DecideZeroRows(h_variable_2424,h_variable_58);
IsZeroMatrix(h_variable_2426);
nrows(h_variable_2425);
def h_variable_2427 = h_variable_282[20,23];
h_variable_2427;
matrix h_variable_2428[1][1] = 0;
matrix h_variable_2429[1][3] = concat(h_variable_2428,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2429); matrix h_variable_2430 = h_variable_l[1]; matrix h_variable_2431 = h_variable_l[2];
ncols(h_variable_2430);
matrix h_variable_2432 = DecideZeroRows(h_variable_2430,h_variable_58);
IsZeroMatrix(h_variable_2432);
nrows(h_variable_2431);
def h_variable_2433 = h_variable_282[19,23];
h_variable_2433;
matrix h_variable_2434[1][1] = 0;
matrix h_variable_2435[1][3] = concat(h_variable_2434,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2435); matrix h_variable_2436 = h_variable_l[1]; matrix h_variable_2437 = h_variable_l[2];
ncols(h_variable_2436);
matrix h_variable_2438 = DecideZeroRows(h_variable_2436,h_variable_58);
IsZeroMatrix(h_variable_2438);
nrows(h_variable_2437);
def h_variable_2439 = h_variable_282[15,23];
h_variable_2439;
matrix h_variable_2440[1][1] = 0;
matrix h_variable_2441[1][3] = concat(h_variable_2440,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2441); matrix h_variable_2442 = h_variable_l[1]; matrix h_variable_2443 = h_variable_l[2];
ncols(h_variable_2442);
matrix h_variable_2444 = DecideZeroRows(h_variable_2442,h_variable_58);
IsZeroMatrix(h_variable_2444);
nrows(h_variable_2443);
def h_variable_2445 = h_variable_282[3,23];
h_variable_2445;
matrix h_variable_2446[1][1] = 0;
matrix h_variable_2447[1][3] = concat(h_variable_2446,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2447); matrix h_variable_2448 = h_variable_l[1]; matrix h_variable_2449 = h_variable_l[2];
ncols(h_variable_2448);
matrix h_variable_2450 = DecideZeroRows(h_variable_2448,h_variable_58);
IsZeroMatrix(h_variable_2450);
nrows(h_variable_2449);
def h_variable_2451 = h_variable_282[1,23];
h_variable_2451;
matrix h_variable_2452[1][1] = 0;
matrix h_variable_2453[1][3] = concat(h_variable_2452,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2453); matrix h_variable_2454 = h_variable_l[1]; matrix h_variable_2455 = h_variable_l[2];
ncols(h_variable_2454);
matrix h_variable_2456 = DecideZeroRows(h_variable_2454,h_variable_58);
IsZeroMatrix(h_variable_2456);
nrows(h_variable_2455);
def h_variable_2457 = h_variable_282[22,24];
h_variable_2457;
matrix h_variable_2458[1][1] = 0;
matrix h_variable_2459[1][3] = concat(h_variable_2458,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2459); matrix h_variable_2460 = h_variable_l[1]; matrix h_variable_2461 = h_variable_l[2];
ncols(h_variable_2460);
matrix h_variable_2462 = DecideZeroRows(h_variable_2460,h_variable_58);
IsZeroMatrix(h_variable_2462);
nrows(h_variable_2461);
def h_variable_2463 = h_variable_282[21,24];
h_variable_2463;
matrix h_variable_2464[1][1] = 0;
matrix h_variable_2465[1][3] = concat(h_variable_2464,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2465); matrix h_variable_2466 = h_variable_l[1]; matrix h_variable_2467 = h_variable_l[2];
ncols(h_variable_2466);
matrix h_variable_2468 = DecideZeroRows(h_variable_2466,h_variable_58);
IsZeroMatrix(h_variable_2468);
nrows(h_variable_2467);
def h_variable_2469 = h_variable_282[20,24];
h_variable_2469;
matrix h_variable_2470[1][1] = 0;
matrix h_variable_2471[1][3] = concat(h_variable_2470,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2471); matrix h_variable_2472 = h_variable_l[1]; matrix h_variable_2473 = h_variable_l[2];
ncols(h_variable_2472);
matrix h_variable_2474 = DecideZeroRows(h_variable_2472,h_variable_58);
IsZeroMatrix(h_variable_2474);
nrows(h_variable_2473);
def h_variable_2475 = h_variable_282[19,24];
h_variable_2475;
matrix h_variable_2476[1][1] = 0;
matrix h_variable_2477[1][3] = concat(h_variable_2476,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2477); matrix h_variable_2478 = h_variable_l[1]; matrix h_variable_2479 = h_variable_l[2];
ncols(h_variable_2478);
matrix h_variable_2480 = DecideZeroRows(h_variable_2478,h_variable_58);
IsZeroMatrix(h_variable_2480);
nrows(h_variable_2479);
def h_variable_2481 = h_variable_282[15,24];
h_variable_2481;
matrix h_variable_2482[1][1] = 0;
matrix h_variable_2483[1][3] = concat(h_variable_2482,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2483); matrix h_variable_2484 = h_variable_l[1]; matrix h_variable_2485 = h_variable_l[2];
ncols(h_variable_2484);
matrix h_variable_2486 = DecideZeroRows(h_variable_2484,h_variable_58);
IsZeroMatrix(h_variable_2486);
nrows(h_variable_2485);
def h_variable_2487 = h_variable_282[3,24];
h_variable_2487;
matrix h_variable_2488[1][1] = 0;
matrix h_variable_2489[1][3] = concat(h_variable_2488,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2489); matrix h_variable_2490 = h_variable_l[1]; matrix h_variable_2491 = h_variable_l[2];
ncols(h_variable_2490);
matrix h_variable_2492 = DecideZeroRows(h_variable_2490,h_variable_58);
IsZeroMatrix(h_variable_2492);
nrows(h_variable_2491);
def h_variable_2493 = h_variable_282[1,24];
h_variable_2493;
matrix h_variable_2494[1][1] = 0;
matrix h_variable_2495[1][3] = concat(h_variable_2494,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2495); matrix h_variable_2496 = h_variable_l[1]; matrix h_variable_2497 = h_variable_l[2];
ncols(h_variable_2496);
matrix h_variable_2498 = DecideZeroRows(h_variable_2496,h_variable_58);
IsZeroMatrix(h_variable_2498);
nrows(h_variable_2497);
def h_variable_2499 = h_variable_282[22,25];
h_variable_2499;
matrix h_variable_2500[1][1] = 0;
kill h_variable_1787;kill h_variable_1788;kill h_variable_1789;kill h_variable_1790;kill h_variable_1792;kill h_variable_1793;kill h_variable_1794;kill h_variable_1795;kill h_variable_1796;kill h_variable_1798;kill h_variable_1799;kill h_variable_1800;kill h_variable_1801;kill h_variable_1802;kill h_variable_1803;kill h_variable_1804;kill h_variable_1805;kill h_variable_1806;kill h_variable_1807;kill h_variable_1808;kill h_variable_1809;kill h_variable_1810;kill h_variable_1811;kill h_variable_1812;kill h_variable_1813;kill h_variable_1814;kill h_variable_1815;kill h_variable_1816;kill h_variable_1817;kill h_variable_1818;kill h_variable_1819;kill h_variable_1820;kill h_variable_1821;kill h_variable_1822;kill h_variable_1823;kill h_variable_1824;kill h_variable_1825;kill h_variable_1826;kill h_variable_1827;kill h_variable_1828;kill h_variable_1829;kill h_variable_1830;kill h_variable_1831;kill h_variable_1832;kill h_variable_1833;kill h_variable_1834;kill h_variable_1835;kill h_variable_1836;kill h_variable_1837;kill h_variable_1838;kill h_variable_1839;kill h_variable_1840;kill h_variable_1841;kill h_variable_1842;kill h_variable_1843;kill h_variable_1844;kill h_variable_1845;kill h_variable_1846;kill h_variable_1847;kill h_variable_1848;kill h_variable_1849;kill h_variable_1850;kill h_variable_1851;kill h_variable_1852;kill h_variable_1853;kill h_variable_1854;kill h_variable_1855;kill h_variable_1856;kill h_variable_1857;kill h_variable_1858;kill h_variable_1859;kill h_variable_1860;kill h_variable_1861;kill h_variable_1862;kill h_variable_1863;kill h_variable_1864;kill h_variable_1865;kill h_variable_1866;kill h_variable_1867;kill h_variable_1868;kill h_variable_1869;kill h_variable_1870;kill h_variable_1871;kill h_variable_1872;kill h_variable_1873;kill h_variable_1874;kill h_variable_1875;kill h_variable_1876;kill h_variable_1877;kill h_variable_1878;kill h_variable_1879;kill h_variable_1880;kill h_variable_1881;kill h_variable_1882;kill h_variable_1883;kill h_variable_1884;kill h_variable_1885;kill h_variable_1886;kill h_variable_1887;kill h_variable_1888;kill h_variable_1889;kill h_variable_1890;kill h_variable_1891;kill h_variable_1892;kill h_variable_1893;kill h_variable_1894;kill h_variable_1895;kill h_variable_1896;kill h_variable_1897;kill h_variable_1898;kill h_variable_1899;kill h_variable_1900;kill h_variable_1901;kill h_variable_1902;kill h_variable_1903;kill h_variable_1904;kill h_variable_1905;kill h_variable_1906;kill h_variable_1907;kill h_variable_1908;kill h_variable_1909;kill h_variable_1910;kill h_variable_1911;kill h_variable_1912;kill h_variable_1913;kill h_variable_1914;kill h_variable_1915;kill h_variable_1916;kill h_variable_1917;kill h_variable_1918;kill h_variable_1919;kill h_variable_1920;kill h_variable_1921;kill h_variable_1922;kill h_variable_1923;kill h_variable_1924;kill h_variable_1925;kill h_variable_1926;kill h_variable_1927;kill h_variable_1928;kill h_variable_1929;kill h_variable_1930;kill h_variable_1931;kill h_variable_1932;kill h_variable_1933;kill h_variable_1934;kill h_variable_1935;kill h_variable_1936;kill h_variable_1937;kill h_variable_1938;kill h_variable_1939;kill h_variable_1940;kill h_variable_1941;kill h_variable_1942;kill h_variable_1943;kill h_variable_1944;kill h_variable_1945;kill h_variable_1946;kill h_variable_1947;kill h_variable_1948;kill h_variable_1949;kill h_variable_1950;kill h_variable_1951;kill h_variable_1952;kill h_variable_1953;kill h_variable_1954;kill h_variable_1955;kill h_variable_1956;kill h_variable_1957;kill h_variable_1958;kill h_variable_1959;kill h_variable_1960;kill h_variable_1961;kill h_variable_1962;kill h_variable_1963;kill h_variable_1964;kill h_variable_1965;kill h_variable_1966;kill h_variable_1967;kill h_variable_1968;kill h_variable_1969;kill h_variable_1970;kill h_variable_1971;kill h_variable_1972;kill h_variable_1973;kill h_variable_1974;kill h_variable_1975;kill h_variable_1976;kill h_variable_1977;kill h_variable_1978;kill h_variable_1979;kill h_variable_1980;kill h_variable_1981;kill h_variable_1982;kill h_variable_1983;kill h_variable_1984;kill h_variable_1985;kill h_variable_1986;kill h_variable_1987;kill h_variable_1988;kill h_variable_1989;kill h_variable_1990;kill h_variable_1991;kill h_variable_1992;kill h_variable_1993;kill h_variable_1994;kill h_variable_1995;kill h_variable_1996;kill h_variable_2005;kill h_variable_2006;kill h_variable_2007;kill h_variable_2008;kill h_variable_2010;kill h_variable_2011;kill h_variable_2012;kill h_variable_2013;kill h_variable_2014;kill h_variable_2016;kill h_variable_2017;kill h_variable_2018;kill h_variable_2019;kill h_variable_2020;kill h_variable_2021;kill h_variable_2022;kill h_variable_2023;kill h_variable_2024;kill h_variable_2025;kill h_variable_2026;kill h_variable_2027;kill h_variable_2028;kill h_variable_2029;kill h_variable_2030;kill h_variable_2031;kill h_variable_2032;kill h_variable_2033;kill h_variable_2034;kill h_variable_2035;kill h_variable_2036;kill h_variable_2037;kill h_variable_2038;kill h_variable_2039;kill h_variable_2040;kill h_variable_2041;kill h_variable_2042;kill h_variable_2043;kill h_variable_2044;kill h_variable_2045;kill h_variable_2046;kill h_variable_2047;kill h_variable_2048;kill h_variable_2049;kill h_variable_2050;kill h_variable_2051;kill h_variable_2052;kill h_variable_2053;kill h_variable_2054;kill h_variable_2055;kill h_variable_2056;kill h_variable_2057;kill h_variable_2058;kill h_variable_2059;kill h_variable_2060;kill h_variable_2061;kill h_variable_2062;kill h_variable_2063;kill h_variable_2064;kill h_variable_2065;kill h_variable_2066;kill h_variable_2067;kill h_variable_2068;kill h_variable_2069;kill h_variable_2070;kill h_variable_2071;kill h_variable_2072;kill h_variable_2073;kill h_variable_2074;kill h_variable_2075;kill h_variable_2076;kill h_variable_2077;kill h_variable_2078;kill h_variable_2079;kill h_variable_2080;kill h_variable_2081;kill h_variable_2082;kill h_variable_2083;kill h_variable_2084;kill h_variable_2085;kill h_variable_2086;kill h_variable_2087;kill h_variable_2088;kill h_variable_2089;kill h_variable_2090;kill h_variable_2091;kill h_variable_2092;kill h_variable_2093;kill h_variable_2094;kill h_variable_2095;kill h_variable_2096;kill h_variable_2097;kill h_variable_2098;kill h_variable_2099;kill h_variable_2100;kill h_variable_2101;kill h_variable_2102;kill h_variable_2103;kill h_variable_2104;kill h_variable_2105;kill h_variable_2106;kill h_variable_2107;kill h_variable_2108;kill h_variable_2109;kill h_variable_2110;kill h_variable_2111;kill h_variable_2112;kill h_variable_2113;kill h_variable_2114;kill h_variable_2115;kill h_variable_2116;kill h_variable_2117;kill h_variable_2118;kill h_variable_2119;kill h_variable_2120;kill h_variable_2121;kill h_variable_2122;kill h_variable_2123;kill h_variable_2124;kill h_variable_2125;kill h_variable_2126;kill h_variable_2127;kill h_variable_2128;kill h_variable_2129;kill h_variable_2130;kill h_variable_2131;kill h_variable_2132;kill h_variable_2133;kill h_variable_2134;kill h_variable_2135;kill h_variable_2136;kill h_variable_2137;kill h_variable_2138;kill h_variable_2139;kill h_variable_2140;kill h_variable_2141;kill h_variable_2142;kill h_variable_2143;kill h_variable_2144;kill h_variable_2145;kill h_variable_2146;kill h_variable_2147;kill h_variable_2148;kill h_variable_2149;kill h_variable_2150;kill h_variable_2151;kill h_variable_2152;kill h_variable_2153;kill h_variable_2154;kill h_variable_2155;kill h_variable_2156;kill h_variable_2157;kill h_variable_2158;kill h_variable_2159;kill h_variable_2160;kill h_variable_2161;kill h_variable_2162;kill h_variable_2163;kill h_variable_2164;kill h_variable_2165;kill h_variable_2166;kill h_variable_2167;kill h_variable_2168;kill h_variable_2169;kill h_variable_2170;kill h_variable_2171;kill h_variable_2172;kill h_variable_2173;kill h_variable_2174;kill h_variable_2177;kill h_variable_2178;kill h_variable_2179;kill h_variable_2180;kill h_variable_2183;kill h_variable_2184;kill h_variable_2185;kill h_variable_2186;kill h_variable_2188;kill h_variable_2189;kill h_variable_2190;kill h_variable_2191;kill h_variable_2192;kill h_variable_2194;kill h_variable_2195;kill h_variable_2196;kill h_variable_2197;kill h_variable_2198;kill h_variable_2199;kill h_variable_2200;kill h_variable_2201;kill h_variable_2202;kill h_variable_2203;kill h_variable_2204;kill h_variable_2205;kill h_variable_2206;kill h_variable_2207;kill h_variable_2208;kill h_variable_2209;kill h_variable_2210;kill h_variable_2211;kill h_variable_2212;kill h_variable_2213;kill h_variable_2214;kill h_variable_2215;kill h_variable_2216;kill h_variable_2217;kill h_variable_2218;kill h_variable_2219;kill h_variable_2220;kill h_variable_2221;kill h_variable_2222;kill h_variable_2223;kill h_variable_2224;kill h_variable_2225;kill h_variable_2226;kill h_variable_2227;kill h_variable_2228;kill h_variable_2229;kill h_variable_2230;kill h_variable_2231;kill h_variable_2232;kill h_variable_2233;kill h_variable_2234;kill h_variable_2235;kill h_variable_2236;kill h_variable_2237;kill h_variable_2238;kill h_variable_2239;kill h_variable_2240;kill h_variable_2241;kill h_variable_2242;kill h_variable_2243;kill h_variable_2244;kill h_variable_2245;kill h_variable_2246;kill h_variable_2247;kill h_variable_2248;kill h_variable_2249;kill h_variable_2250;kill h_variable_2251;kill h_variable_2252;kill h_variable_2253;kill h_variable_2254;kill h_variable_2255;kill h_variable_2256;kill h_variable_2257;kill h_variable_2258;kill h_variable_2259;kill h_variable_2260;kill h_variable_2261;kill h_variable_2262;kill h_variable_2263;kill h_variable_2264;kill h_variable_2265;kill h_variable_2266;kill h_variable_2267;kill h_variable_2268;kill h_variable_2269;kill h_variable_2270;kill h_variable_2271;kill h_variable_2272;kill h_variable_2273;kill h_variable_2274;kill h_variable_2275;kill h_variable_2276;kill h_variable_2277;kill h_variable_2278;kill h_variable_2279;kill h_variable_2280;kill h_variable_2281;kill h_variable_2282;kill h_variable_2283;kill h_variable_2284;kill h_variable_2285;kill h_variable_2286;kill h_variable_2287;kill h_variable_2288;kill h_variable_2289;kill h_variable_2290;kill h_variable_2291;kill h_variable_2292;kill h_variable_2293;kill h_variable_2294;kill h_variable_2295;kill h_variable_2296;kill h_variable_2297;kill h_variable_2298;kill h_variable_2299;kill h_variable_2300;kill h_variable_2301;kill h_variable_2302;kill h_variable_2303;kill h_variable_2304;kill h_variable_2305;kill h_variable_2306;kill h_variable_2307;kill h_variable_2308;kill h_variable_2309;kill h_variable_2310;kill h_variable_2311;kill h_variable_2312;kill h_variable_2313;kill h_variable_2314;kill h_variable_2315;kill h_variable_2316;kill h_variable_2317;kill h_variable_2318;kill h_variable_2319;kill h_variable_2320;kill h_variable_2321;kill h_variable_2322;kill h_variable_2323;kill h_variable_2324;kill h_variable_2325;kill h_variable_2326;kill h_variable_2327;kill h_variable_2328;kill h_variable_2329;kill h_variable_2330;kill h_variable_2331;kill h_variable_2332;kill h_variable_2333;kill h_variable_2334;kill h_variable_2335;kill h_variable_2336;kill h_variable_2337;kill h_variable_2338;kill h_variable_2339;kill h_variable_2340;kill h_variable_2341;kill h_variable_2342;kill h_variable_2343;kill h_variable_2344;kill h_variable_2345;kill h_variable_2346;kill h_variable_2347;kill h_variable_2348;kill h_variable_2349;kill h_variable_2350;kill h_variable_2351;kill h_variable_2352;kill h_variable_2353;kill h_variable_2354;kill h_variable_2355;kill h_variable_2356;kill h_variable_2357;kill h_variable_2358;kill h_variable_2359;kill h_variable_2360;kill h_variable_2361;kill h_variable_2362;kill h_variable_2363;kill h_variable_2364;kill h_variable_2365;kill h_variable_2366;kill h_variable_2367;kill h_variable_2368;kill h_variable_2369;kill h_variable_2370;kill h_variable_2371;kill h_variable_2372;kill h_variable_2373;kill h_variable_2374;kill h_variable_2375;kill h_variable_2376;kill h_variable_2377;kill h_variable_2378;
matrix h_variable_2501[1][3] = concat(h_variable_2500,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2501); matrix h_variable_2502 = h_variable_l[1]; matrix h_variable_2503 = h_variable_l[2];
ncols(h_variable_2502);
matrix h_variable_2504 = DecideZeroRows(h_variable_2502,h_variable_58);
IsZeroMatrix(h_variable_2504);
nrows(h_variable_2503);
def h_variable_2505 = h_variable_282[21,25];
h_variable_2505;
matrix h_variable_2506[1][1] = 0;
matrix h_variable_2507[1][3] = concat(h_variable_2506,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2507); matrix h_variable_2508 = h_variable_l[1]; matrix h_variable_2509 = h_variable_l[2];
ncols(h_variable_2508);
matrix h_variable_2510 = DecideZeroRows(h_variable_2508,h_variable_58);
IsZeroMatrix(h_variable_2510);
nrows(h_variable_2509);
def h_variable_2511 = h_variable_282[20,25];
h_variable_2511;
matrix h_variable_2512[1][1] = 0;
matrix h_variable_2513[1][3] = concat(h_variable_2512,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2513); matrix h_variable_2514 = h_variable_l[1]; matrix h_variable_2515 = h_variable_l[2];
ncols(h_variable_2514);
matrix h_variable_2516 = DecideZeroRows(h_variable_2514,h_variable_58);
IsZeroMatrix(h_variable_2516);
nrows(h_variable_2515);
def h_variable_2517 = h_variable_282[19,25];
h_variable_2517;
matrix h_variable_2518[1][1] = 0;
matrix h_variable_2519[1][3] = concat(h_variable_2518,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2519); matrix h_variable_2520 = h_variable_l[1]; matrix h_variable_2521 = h_variable_l[2];
ncols(h_variable_2520);
matrix h_variable_2522 = DecideZeroRows(h_variable_2520,h_variable_58);
IsZeroMatrix(h_variable_2522);
nrows(h_variable_2521);
def h_variable_2523 = h_variable_282[15,25];
h_variable_2523;
matrix h_variable_2524[1][1] = 0;
matrix h_variable_2525[1][3] = concat(h_variable_2524,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2525); matrix h_variable_2526 = h_variable_l[1]; matrix h_variable_2527 = h_variable_l[2];
ncols(h_variable_2526);
matrix h_variable_2528 = DecideZeroRows(h_variable_2526,h_variable_58);
IsZeroMatrix(h_variable_2528);
nrows(h_variable_2527);
def h_variable_2529 = h_variable_282[3,25];
h_variable_2529;
matrix h_variable_2530[1][1] = x3^2;
matrix h_variable_2531[1][3] = concat(h_variable_2530,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2531); matrix h_variable_2532 = h_variable_l[1]; matrix h_variable_2533 = h_variable_l[2];
ncols(h_variable_2532);
matrix h_variable_2534 = DecideZeroRows(h_variable_2532,h_variable_58);
IsZeroMatrix(h_variable_2534);
ZeroRows(h_variable_2534);
nrows(h_variable_2533);
matrix h_variable_2536 = submat(h_variable_2532,1..1,intvec( 2 ));
matrix h_variable_2535 = DecideZeroRows(h_variable_2536,h_variable_58);
IsZeroMatrix(h_variable_2535);
IsIdentityMatrix(h_variable_2535);
matrix h_variable_2537[1][3] = concat(h_variable_2535,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2537); matrix h_variable_2538 = h_variable_l[1]; matrix h_variable_2539 = h_variable_l[2];
IsZeroMatrix(h_variable_2538);
matrix h_variable_2540 = DecideZeroRows(h_variable_2538,h_variable_58);
IsZeroMatrix(h_variable_2540);
def h_variable_2541 = h_variable_282[1,25];
h_variable_2541;
matrix h_variable_2542[1][1] = 0;
matrix h_variable_2543[1][3] = concat(h_variable_2542,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2543); matrix h_variable_2544 = h_variable_l[1]; matrix h_variable_2545 = h_variable_l[2];
ncols(h_variable_2544);
matrix h_variable_2546 = DecideZeroRows(h_variable_2544,h_variable_58);
IsZeroMatrix(h_variable_2546);
nrows(h_variable_2545);
def h_variable_2547 = h_variable_282[22,26];
h_variable_2547;
matrix h_variable_2548[1][1] = 0;
matrix h_variable_2549[1][3] = concat(h_variable_2548,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2549); matrix h_variable_2550 = h_variable_l[1]; matrix h_variable_2551 = h_variable_l[2];
ncols(h_variable_2550);
matrix h_variable_2552 = DecideZeroRows(h_variable_2550,h_variable_58);
IsZeroMatrix(h_variable_2552);
nrows(h_variable_2551);
def h_variable_2553 = h_variable_282[21,26];
h_variable_2553;
matrix h_variable_2554[1][1] = 0;
matrix h_variable_2555[1][3] = concat(h_variable_2554,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2555); matrix h_variable_2556 = h_variable_l[1]; matrix h_variable_2557 = h_variable_l[2];
ncols(h_variable_2556);
matrix h_variable_2558 = DecideZeroRows(h_variable_2556,h_variable_58);
IsZeroMatrix(h_variable_2558);
nrows(h_variable_2557);
def h_variable_2559 = h_variable_282[20,26];
h_variable_2559;
matrix h_variable_2560[1][1] = 0;
matrix h_variable_2561[1][3] = concat(h_variable_2560,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2561); matrix h_variable_2562 = h_variable_l[1]; matrix h_variable_2563 = h_variable_l[2];
ncols(h_variable_2562);
matrix h_variable_2564 = DecideZeroRows(h_variable_2562,h_variable_58);
IsZeroMatrix(h_variable_2564);
nrows(h_variable_2563);
def h_variable_2565 = h_variable_282[19,26];
h_variable_2565;
matrix h_variable_2566[1][1] = 0;
matrix h_variable_2567[1][3] = concat(h_variable_2566,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2567); matrix h_variable_2568 = h_variable_l[1]; matrix h_variable_2569 = h_variable_l[2];
ncols(h_variable_2568);
matrix h_variable_2570 = DecideZeroRows(h_variable_2568,h_variable_58);
IsZeroMatrix(h_variable_2570);
nrows(h_variable_2569);
def h_variable_2571 = h_variable_282[15,26];
h_variable_2571;
matrix h_variable_2572[1][1] = 0;
matrix h_variable_2573[1][3] = concat(h_variable_2572,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2573); matrix h_variable_2574 = h_variable_l[1]; matrix h_variable_2575 = h_variable_l[2];
ncols(h_variable_2574);
matrix h_variable_2576 = DecideZeroRows(h_variable_2574,h_variable_58);
IsZeroMatrix(h_variable_2576);
nrows(h_variable_2575);
def h_variable_2577 = h_variable_282[3,26];
h_variable_2577;
matrix h_variable_2578[1][1] = 0;
matrix h_variable_2579[1][3] = concat(h_variable_2578,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2579); matrix h_variable_2580 = h_variable_l[1]; matrix h_variable_2581 = h_variable_l[2];
ncols(h_variable_2580);
matrix h_variable_2582 = DecideZeroRows(h_variable_2580,h_variable_58);
IsZeroMatrix(h_variable_2582);
nrows(h_variable_2581);
def h_variable_2583 = h_variable_282[1,26];
h_variable_2583;
matrix h_variable_2584[1][1] = 0;
matrix h_variable_2585[1][3] = concat(h_variable_2584,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2585); matrix h_variable_2586 = h_variable_l[1]; matrix h_variable_2587 = h_variable_l[2];
ncols(h_variable_2586);
matrix h_variable_2588 = DecideZeroRows(h_variable_2586,h_variable_58);
IsZeroMatrix(h_variable_2588);
nrows(h_variable_2587);
def h_variable_2589 = h_variable_282[22,27];
h_variable_2589;
matrix h_variable_2590[1][1] = 0;
matrix h_variable_2591[1][3] = concat(h_variable_2590,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2591); matrix h_variable_2592 = h_variable_l[1]; matrix h_variable_2593 = h_variable_l[2];
ncols(h_variable_2592);
matrix h_variable_2594 = DecideZeroRows(h_variable_2592,h_variable_58);
IsZeroMatrix(h_variable_2594);
nrows(h_variable_2593);
def h_variable_2595 = h_variable_282[21,27];
h_variable_2595;
matrix h_variable_2596[1][1] = 0;
matrix h_variable_2597[1][3] = concat(h_variable_2596,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2597); matrix h_variable_2598 = h_variable_l[1]; matrix h_variable_2599 = h_variable_l[2];
ncols(h_variable_2598);
matrix h_variable_2600 = DecideZeroRows(h_variable_2598,h_variable_58);
IsZeroMatrix(h_variable_2600);
nrows(h_variable_2599);
def h_variable_2601 = h_variable_282[20,27];
h_variable_2601;
matrix h_variable_2602[1][1] = 0;
matrix h_variable_2603[1][3] = concat(h_variable_2602,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2603); matrix h_variable_2604 = h_variable_l[1]; matrix h_variable_2605 = h_variable_l[2];
ncols(h_variable_2604);
matrix h_variable_2606 = DecideZeroRows(h_variable_2604,h_variable_58);
IsZeroMatrix(h_variable_2606);
nrows(h_variable_2605);
def h_variable_2607 = h_variable_282[19,27];
h_variable_2607;
matrix h_variable_2608[1][1] = 0;
matrix h_variable_2609[1][3] = concat(h_variable_2608,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2609); matrix h_variable_2610 = h_variable_l[1]; matrix h_variable_2611 = h_variable_l[2];
ncols(h_variable_2610);
matrix h_variable_2612 = DecideZeroRows(h_variable_2610,h_variable_58);
IsZeroMatrix(h_variable_2612);
nrows(h_variable_2611);
def h_variable_2613 = h_variable_282[15,27];
h_variable_2613;
matrix h_variable_2614[1][1] = 0;
matrix h_variable_2615[1][3] = concat(h_variable_2614,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2615); matrix h_variable_2616 = h_variable_l[1]; matrix h_variable_2617 = h_variable_l[2];
ncols(h_variable_2616);
matrix h_variable_2618 = DecideZeroRows(h_variable_2616,h_variable_58);
IsZeroMatrix(h_variable_2618);
nrows(h_variable_2617);
def h_variable_2619 = h_variable_282[3,27];
h_variable_2619;
matrix h_variable_2620[1][1] = 0;
matrix h_variable_2621[1][3] = concat(h_variable_2620,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2621); matrix h_variable_2622 = h_variable_l[1]; matrix h_variable_2623 = h_variable_l[2];
ncols(h_variable_2622);
matrix h_variable_2624 = DecideZeroRows(h_variable_2622,h_variable_58);
IsZeroMatrix(h_variable_2624);
nrows(h_variable_2623);
def h_variable_2625 = h_variable_282[1,27];
h_variable_2625;
matrix h_variable_2626[1][1] = 0;
matrix h_variable_2627[1][3] = concat(h_variable_2626,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2627); matrix h_variable_2628 = h_variable_l[1]; matrix h_variable_2629 = h_variable_l[2];
ncols(h_variable_2628);
matrix h_variable_2630 = DecideZeroRows(h_variable_2628,h_variable_58);
IsZeroMatrix(h_variable_2630);
nrows(h_variable_2629);
def h_variable_2631 = h_variable_282[22,28];
h_variable_2631;
matrix h_variable_2632[1][1] = 0;
matrix h_variable_2633[1][3] = concat(h_variable_2632,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2633); matrix h_variable_2634 = h_variable_l[1]; matrix h_variable_2635 = h_variable_l[2];
ncols(h_variable_2634);
matrix h_variable_2636 = DecideZeroRows(h_variable_2634,h_variable_58);
IsZeroMatrix(h_variable_2636);
nrows(h_variable_2635);
def h_variable_2637 = h_variable_282[21,28];
h_variable_2637;
matrix h_variable_2638[1][1] = 0;
matrix h_variable_2639[1][3] = concat(h_variable_2638,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2639); matrix h_variable_2640 = h_variable_l[1]; matrix h_variable_2641 = h_variable_l[2];
ncols(h_variable_2640);
matrix h_variable_2642 = DecideZeroRows(h_variable_2640,h_variable_58);
IsZeroMatrix(h_variable_2642);
nrows(h_variable_2641);
def h_variable_2643 = h_variable_282[20,28];
h_variable_2643;
matrix h_variable_2644[1][1] = 0;
matrix h_variable_2645[1][3] = concat(h_variable_2644,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2645); matrix h_variable_2646 = h_variable_l[1]; matrix h_variable_2647 = h_variable_l[2];
ncols(h_variable_2646);
matrix h_variable_2648 = DecideZeroRows(h_variable_2646,h_variable_58);
IsZeroMatrix(h_variable_2648);
nrows(h_variable_2647);
def h_variable_2649 = h_variable_282[19,28];
h_variable_2649;
matrix h_variable_2650[1][1] = 0;
matrix h_variable_2651[1][3] = concat(h_variable_2650,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2651); matrix h_variable_2652 = h_variable_l[1]; matrix h_variable_2653 = h_variable_l[2];
ncols(h_variable_2652);
matrix h_variable_2654 = DecideZeroRows(h_variable_2652,h_variable_58);
IsZeroMatrix(h_variable_2654);
nrows(h_variable_2653);
def h_variable_2655 = h_variable_282[15,28];
h_variable_2655;
matrix h_variable_2656[1][1] = 0;
matrix h_variable_2657[1][3] = concat(h_variable_2656,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2657); matrix h_variable_2658 = h_variable_l[1]; matrix h_variable_2659 = h_variable_l[2];
ncols(h_variable_2658);
matrix h_variable_2660 = DecideZeroRows(h_variable_2658,h_variable_58);
IsZeroMatrix(h_variable_2660);
nrows(h_variable_2659);
def h_variable_2661 = h_variable_282[3,28];
h_variable_2661;
matrix h_variable_2662[1][1] = 0;
matrix h_variable_2663[1][3] = concat(h_variable_2662,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2663); matrix h_variable_2664 = h_variable_l[1]; matrix h_variable_2665 = h_variable_l[2];
ncols(h_variable_2664);
matrix h_variable_2666 = DecideZeroRows(h_variable_2664,h_variable_58);
IsZeroMatrix(h_variable_2666);
nrows(h_variable_2665);
def h_variable_2667 = h_variable_282[1,28];
h_variable_2667;
matrix h_variable_2668[1][1] = 0;
matrix h_variable_2669[1][3] = concat(h_variable_2668,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2669); matrix h_variable_2670 = h_variable_l[1]; matrix h_variable_2671 = h_variable_l[2];
ncols(h_variable_2670);
matrix h_variable_2672 = DecideZeroRows(h_variable_2670,h_variable_58);
IsZeroMatrix(h_variable_2672);
nrows(h_variable_2671);
def h_variable_2673 = h_variable_282[22,29];
h_variable_2673;
matrix h_variable_2674[1][1] = 0;
matrix h_variable_2675[1][3] = concat(h_variable_2674,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2675); matrix h_variable_2676 = h_variable_l[1]; matrix h_variable_2677 = h_variable_l[2];
ncols(h_variable_2676);
matrix h_variable_2678 = DecideZeroRows(h_variable_2676,h_variable_58);
IsZeroMatrix(h_variable_2678);
nrows(h_variable_2677);
def h_variable_2679 = h_variable_282[21,29];
h_variable_2679;
matrix h_variable_2680[1][1] = 0;
matrix h_variable_2681[1][3] = concat(h_variable_2680,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2681); matrix h_variable_2682 = h_variable_l[1]; matrix h_variable_2683 = h_variable_l[2];
ncols(h_variable_2682);
matrix h_variable_2684 = DecideZeroRows(h_variable_2682,h_variable_58);
IsZeroMatrix(h_variable_2684);
nrows(h_variable_2683);
def h_variable_2685 = h_variable_282[20,29];
h_variable_2685;
matrix h_variable_2686[1][1] = 0;
matrix h_variable_2687[1][3] = concat(h_variable_2686,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2687); matrix h_variable_2688 = h_variable_l[1]; matrix h_variable_2689 = h_variable_l[2];
ncols(h_variable_2688);
matrix h_variable_2690 = DecideZeroRows(h_variable_2688,h_variable_58);
IsZeroMatrix(h_variable_2690);
nrows(h_variable_2689);
def h_variable_2691 = h_variable_282[19,29];
h_variable_2691;
matrix h_variable_2692[1][1] = 2;
matrix h_variable_2693[1][3] = concat(h_variable_2692,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2693); matrix h_variable_2694 = h_variable_l[1]; matrix h_variable_2695 = h_variable_l[2];
ncols(h_variable_2694);
matrix h_variable_2696 = DecideZeroRows(h_variable_2694,h_variable_58);
IsZeroMatrix(h_variable_2696);
ZeroRows(h_variable_2696);
nrows(h_variable_2695);
matrix h_variable_2698 = submat(h_variable_2694,1..1,intvec( 1 ));
matrix h_variable_2697 = DecideZeroRows(h_variable_2698,h_variable_58);
IsZeroMatrix(h_variable_2697);
IsIdentityMatrix(h_variable_2697);
matrix h_variable_2699[1][3] = concat(h_variable_2697,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2699); matrix h_variable_2700 = h_variable_l[1]; matrix h_variable_2701 = h_variable_l[2];
IsZeroMatrix(h_variable_2700);
matrix h_variable_2702 = DecideZeroRows(h_variable_2700,h_variable_58);
IsZeroMatrix(h_variable_2702);
def h_variable_2703 = h_variable_282[15,29];
h_variable_2703;
matrix h_variable_2704[1][1] = -2;
matrix h_variable_2705[1][3] = concat(h_variable_2704,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2705); matrix h_variable_2706 = h_variable_l[1]; matrix h_variable_2707 = h_variable_l[2];
ncols(h_variable_2706);
matrix h_variable_2708 = DecideZeroRows(h_variable_2706,h_variable_58);
IsZeroMatrix(h_variable_2708);
ZeroRows(h_variable_2708);
nrows(h_variable_2707);
matrix h_variable_2710 = submat(h_variable_2706,1..1,intvec( 1 ));
matrix h_variable_2709 = DecideZeroRows(h_variable_2710,h_variable_58);
IsZeroMatrix(h_variable_2709);
IsIdentityMatrix(h_variable_2709);
matrix h_variable_2711[1][3] = concat(h_variable_2709,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2711); matrix h_variable_2712 = h_variable_l[1]; matrix h_variable_2713 = h_variable_l[2];
IsZeroMatrix(h_variable_2712);
matrix h_variable_2714 = DecideZeroRows(h_variable_2712,h_variable_58);
IsZeroMatrix(h_variable_2714);
def h_variable_2715 = h_variable_282[3,29];
h_variable_2715;
matrix h_variable_2716[1][1] = 0;
matrix h_variable_2717[1][3] = concat(h_variable_2716,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2717); matrix h_variable_2718 = h_variable_l[1]; matrix h_variable_2719 = h_variable_l[2];
ncols(h_variable_2718);
matrix h_variable_2720 = DecideZeroRows(h_variable_2718,h_variable_58);
IsZeroMatrix(h_variable_2720);
nrows(h_variable_2719);
def h_variable_2721 = h_variable_282[1,29];
h_variable_2721;
matrix h_variable_2722[1][1] = 0;
matrix h_variable_2723[1][3] = concat(h_variable_2722,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2723); matrix h_variable_2724 = h_variable_l[1]; matrix h_variable_2725 = h_variable_l[2];
ncols(h_variable_2724);
matrix h_variable_2726 = DecideZeroRows(h_variable_2724,h_variable_58);
IsZeroMatrix(h_variable_2726);
nrows(h_variable_2725);
def h_variable_2727 = h_variable_282[22,30];
h_variable_2727;
matrix h_variable_2728[1][1] = 0;
matrix h_variable_2729[1][3] = concat(h_variable_2728,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2729); matrix h_variable_2730 = h_variable_l[1]; matrix h_variable_2731 = h_variable_l[2];
ncols(h_variable_2730);
matrix h_variable_2732 = DecideZeroRows(h_variable_2730,h_variable_58);
IsZeroMatrix(h_variable_2732);
nrows(h_variable_2731);
def h_variable_2733 = h_variable_282[21,30];
h_variable_2733;
matrix h_variable_2734[1][1] = 0;
matrix h_variable_2735[1][3] = concat(h_variable_2734,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2735); matrix h_variable_2736 = h_variable_l[1]; matrix h_variable_2737 = h_variable_l[2];
ncols(h_variable_2736);
matrix h_variable_2738 = DecideZeroRows(h_variable_2736,h_variable_58);
IsZeroMatrix(h_variable_2738);
nrows(h_variable_2737);
def h_variable_2739 = h_variable_282[20,30];
h_variable_2739;
matrix h_variable_2740[1][1] = 0;
matrix h_variable_2741[1][3] = concat(h_variable_2740,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2741); matrix h_variable_2742 = h_variable_l[1]; matrix h_variable_2743 = h_variable_l[2];
ncols(h_variable_2742);
matrix h_variable_2744 = DecideZeroRows(h_variable_2742,h_variable_58);
IsZeroMatrix(h_variable_2744);
nrows(h_variable_2743);
def h_variable_2745 = h_variable_282[19,30];
h_variable_2745;
matrix h_variable_2746[1][1] = 0;
matrix h_variable_2747[1][3] = concat(h_variable_2746,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2747); matrix h_variable_2748 = h_variable_l[1]; matrix h_variable_2749 = h_variable_l[2];
ncols(h_variable_2748);
matrix h_variable_2750 = DecideZeroRows(h_variable_2748,h_variable_58);
IsZeroMatrix(h_variable_2750);
nrows(h_variable_2749);
def h_variable_2751 = h_variable_282[15,30];
h_variable_2751;
matrix h_variable_2752[1][1] = -4;
matrix h_variable_2753[1][3] = concat(h_variable_2752,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2753); matrix h_variable_2754 = h_variable_l[1]; matrix h_variable_2755 = h_variable_l[2];
ncols(h_variable_2754);
matrix h_variable_2756 = DecideZeroRows(h_variable_2754,h_variable_58);
IsZeroMatrix(h_variable_2756);
ZeroRows(h_variable_2756);
nrows(h_variable_2755);
matrix h_variable_2758 = submat(h_variable_2754,1..1,intvec( 1 ));
matrix h_variable_2757 = DecideZeroRows(h_variable_2758,h_variable_58);
IsZeroMatrix(h_variable_2757);
IsIdentityMatrix(h_variable_2757);
matrix h_variable_2759[1][3] = concat(h_variable_2757,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2759); matrix h_variable_2760 = h_variable_l[1]; matrix h_variable_2761 = h_variable_l[2];
IsZeroMatrix(h_variable_2760);
matrix h_variable_2762 = DecideZeroRows(h_variable_2760,h_variable_58);
IsZeroMatrix(h_variable_2762);
def h_variable_2763 = h_variable_282[3,30];
h_variable_2763;
matrix h_variable_2764[1][1] = 0;
matrix h_variable_2765[1][3] = concat(h_variable_2764,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2765); matrix h_variable_2766 = h_variable_l[1]; matrix h_variable_2767 = h_variable_l[2];
ncols(h_variable_2766);
matrix h_variable_2768 = DecideZeroRows(h_variable_2766,h_variable_58);
IsZeroMatrix(h_variable_2768);
nrows(h_variable_2767);
def h_variable_2769 = h_variable_282[1,30];
h_variable_2769;
matrix h_variable_2770[1][1] = 0;
matrix h_variable_2771[1][3] = concat(h_variable_2770,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2771); matrix h_variable_2772 = h_variable_l[1]; matrix h_variable_2773 = h_variable_l[2];
ncols(h_variable_2772);
matrix h_variable_2774 = DecideZeroRows(h_variable_2772,h_variable_58);
IsZeroMatrix(h_variable_2774);
nrows(h_variable_2773);
def h_variable_2775 = h_variable_282[22,31];
h_variable_2775;
matrix h_variable_2776[1][1] = 0;
matrix h_variable_2777[1][3] = concat(h_variable_2776,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2777); matrix h_variable_2778 = h_variable_l[1]; matrix h_variable_2779 = h_variable_l[2];
ncols(h_variable_2778);
matrix h_variable_2780 = DecideZeroRows(h_variable_2778,h_variable_58);
IsZeroMatrix(h_variable_2780);
nrows(h_variable_2779);
def h_variable_2781 = h_variable_282[21,31];
h_variable_2781;
matrix h_variable_2782[1][1] = -3;
matrix h_variable_2783[1][3] = concat(h_variable_2782,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2783); matrix h_variable_2784 = h_variable_l[1]; matrix h_variable_2785 = h_variable_l[2];
ncols(h_variable_2784);
matrix h_variable_2786 = DecideZeroRows(h_variable_2784,h_variable_58);
IsZeroMatrix(h_variable_2786);
ZeroRows(h_variable_2786);
nrows(h_variable_2785);
matrix h_variable_2788 = submat(h_variable_2784,1..1,intvec( 1 ));
matrix h_variable_2787 = DecideZeroRows(h_variable_2788,h_variable_58);
IsZeroMatrix(h_variable_2787);
IsIdentityMatrix(h_variable_2787);
matrix h_variable_2789[1][3] = concat(h_variable_2787,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2789); matrix h_variable_2790 = h_variable_l[1]; matrix h_variable_2791 = h_variable_l[2];
IsZeroMatrix(h_variable_2790);
matrix h_variable_2792 = DecideZeroRows(h_variable_2790,h_variable_58);
IsZeroMatrix(h_variable_2792);
def h_variable_2793 = h_variable_282[20,31];
h_variable_2793;
matrix h_variable_2794[1][1] = 0;
matrix h_variable_2795[1][3] = concat(h_variable_2794,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2795); matrix h_variable_2796 = h_variable_l[1]; matrix h_variable_2797 = h_variable_l[2];
ncols(h_variable_2796);
matrix h_variable_2798 = DecideZeroRows(h_variable_2796,h_variable_58);
IsZeroMatrix(h_variable_2798);
nrows(h_variable_2797);
def h_variable_2799 = h_variable_282[19,31];
h_variable_2799;
matrix h_variable_2800[1][1] = 0;
matrix h_variable_2801[1][3] = concat(h_variable_2800,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2801); matrix h_variable_2802 = h_variable_l[1]; matrix h_variable_2803 = h_variable_l[2];
ncols(h_variable_2802);
matrix h_variable_2804 = DecideZeroRows(h_variable_2802,h_variable_58);
IsZeroMatrix(h_variable_2804);
nrows(h_variable_2803);
def h_variable_2805 = h_variable_282[15,31];
h_variable_2805;
matrix h_variable_2806[1][1] = 3*x1;
matrix h_variable_2807[1][3] = concat(h_variable_2806,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2807); matrix h_variable_2808 = h_variable_l[1]; matrix h_variable_2809 = h_variable_l[2];
ncols(h_variable_2808);
matrix h_variable_2810 = DecideZeroRows(h_variable_2808,h_variable_58);
IsZeroMatrix(h_variable_2810);
ZeroRows(h_variable_2810);
nrows(h_variable_2809);
matrix h_variable_2812 = submat(h_variable_2808,1..1,intvec( 2 ));
matrix h_variable_2811 = DecideZeroRows(h_variable_2812,h_variable_58);
IsZeroMatrix(h_variable_2811);
IsIdentityMatrix(h_variable_2811);
matrix h_variable_2813[1][3] = concat(h_variable_2811,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2813); matrix h_variable_2814 = h_variable_l[1]; matrix h_variable_2815 = h_variable_l[2];
IsZeroMatrix(h_variable_2814);
matrix h_variable_2816 = DecideZeroRows(h_variable_2814,h_variable_58);
IsZeroMatrix(h_variable_2816);
def h_variable_2817 = h_variable_282[3,31];
h_variable_2817;
matrix h_variable_2818[1][1] = 0;
matrix h_variable_2819[1][3] = concat(h_variable_2818,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2819); matrix h_variable_2820 = h_variable_l[1]; matrix h_variable_2821 = h_variable_l[2];
ncols(h_variable_2820);
matrix h_variable_2822 = DecideZeroRows(h_variable_2820,h_variable_58);
IsZeroMatrix(h_variable_2822);
nrows(h_variable_2821);
def h_variable_2823 = h_variable_282[1,31];
h_variable_2823;
matrix h_variable_2824[1][1] = 0;
matrix h_variable_2825[1][3] = concat(h_variable_2824,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2825); matrix h_variable_2826 = h_variable_l[1]; matrix h_variable_2827 = h_variable_l[2];
ncols(h_variable_2826);
matrix h_variable_2828 = DecideZeroRows(h_variable_2826,h_variable_58);
IsZeroMatrix(h_variable_2828);
nrows(h_variable_2827);
def h_variable_2829 = h_variable_282[22,32];
h_variable_2829;
matrix h_variable_2830[1][1] = 2;
matrix h_variable_2831[1][3] = concat(h_variable_2830,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2831); matrix h_variable_2832 = h_variable_l[1]; matrix h_variable_2833 = h_variable_l[2];
ncols(h_variable_2832);
matrix h_variable_2834 = DecideZeroRows(h_variable_2832,h_variable_58);
IsZeroMatrix(h_variable_2834);
ZeroRows(h_variable_2834);
nrows(h_variable_2833);
matrix h_variable_2836 = submat(h_variable_2832,1..1,intvec( 1 ));
matrix h_variable_2835 = DecideZeroRows(h_variable_2836,h_variable_58);
IsZeroMatrix(h_variable_2835);
IsIdentityMatrix(h_variable_2835);
matrix h_variable_2837[1][3] = concat(h_variable_2835,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2837); matrix h_variable_2838 = h_variable_l[1]; matrix h_variable_2839 = h_variable_l[2];
IsZeroMatrix(h_variable_2838);
matrix h_variable_2840 = DecideZeroRows(h_variable_2838,h_variable_58);
IsZeroMatrix(h_variable_2840);
def h_variable_2841 = h_variable_282[21,32];
h_variable_2841;
matrix h_variable_2842[1][1] = -1;
matrix h_variable_2843[1][3] = concat(h_variable_2842,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2843); matrix h_variable_2844 = h_variable_l[1]; matrix h_variable_2845 = h_variable_l[2];
ncols(h_variable_2844);
matrix h_variable_2846 = DecideZeroRows(h_variable_2844,h_variable_58);
IsZeroMatrix(h_variable_2846);
nrows(h_variable_2845);
IsIdentityMatrix(h_variable_2846);
def h_variable_2847 = h_variable_282[1,32];
h_variable_2847;
matrix h_variable_2848[1][1] = 0;
matrix h_variable_2849 = DecideZeroRows(h_variable_2848,h_variable_58);
IsZeroMatrix(h_variable_2849);
def h_variable_2850 = h_variable_2849[1,1];
h_variable_2850==0;
def h_variable_2851 = h_variable_282[3,32];
h_variable_2851;
matrix h_variable_2852[1][1] = 0;
matrix h_variable_2853 = DecideZeroRows(h_variable_2852,h_variable_58);
IsZeroMatrix(h_variable_2853);
def h_variable_2854 = h_variable_2853[1,1];
h_variable_2854==0;
def h_variable_2855 = h_variable_282[15,32];
h_variable_2855;
matrix h_variable_2856[1][1] = -5*x1-3*x2+5*x3;
matrix h_variable_2857 = DecideZeroRows(h_variable_2856,h_variable_58);
IsZeroMatrix(h_variable_2857);
def h_variable_2858 = h_variable_2857[1,1];
h_variable_2858==0;
def h_variable_2859 = h_variable_282[19,32];
h_variable_2859;
matrix h_variable_2860[1][1] = 0;
matrix h_variable_2861 = DecideZeroRows(h_variable_2860,h_variable_58);
IsZeroMatrix(h_variable_2861);
def h_variable_2862 = h_variable_2861[1,1];
h_variable_2862==0;
def h_variable_2863 = h_variable_282[20,32];
h_variable_2863;
matrix h_variable_2864[1][1] = 4;
matrix h_variable_2865 = DecideZeroRows(h_variable_2864,h_variable_58);
IsZeroMatrix(h_variable_2865);
def h_variable_2866 = h_variable_2865[1,1];
h_variable_2866==0;
def h_variable_2867 = h_variable_282[21,32];
h_variable_2867;
matrix h_variable_2868[1][1] = -1;
matrix h_variable_2869 = DecideZeroRows(h_variable_2868,h_variable_58);
IsZeroMatrix(h_variable_2869);
def h_variable_2870 = h_variable_2869[1,1];
h_variable_2870==0;
def h_variable_2871 = h_variable_282[22,32];
h_variable_2871;
matrix h_variable_2872[1][1] = 2;
matrix h_variable_2873 = DecideZeroRows(h_variable_2872,h_variable_58);
IsZeroMatrix(h_variable_2873);
def h_variable_2874 = h_variable_2873[1,1];
h_variable_2874==0;
def h_variable_2875 = h_variable_282[19,33];
h_variable_2875;
matrix h_variable_2876[1][1] = 0;
matrix h_variable_2877[1][3] = concat(h_variable_2876,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2877); matrix h_variable_2878 = h_variable_l[1]; matrix h_variable_2879 = h_variable_l[2];
ncols(h_variable_2878);
matrix h_variable_2880 = DecideZeroRows(h_variable_2878,h_variable_58);
IsZeroMatrix(h_variable_2880);
nrows(h_variable_2879);
def h_variable_2881 = h_variable_282[3,33];
h_variable_2881;
matrix h_variable_2882[1][1] = 0;
matrix h_variable_2883[1][3] = concat(h_variable_2882,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2883); matrix h_variable_2884 = h_variable_l[1]; matrix h_variable_2885 = h_variable_l[2];
ncols(h_variable_2884);
matrix h_variable_2886 = DecideZeroRows(h_variable_2884,h_variable_58);
IsZeroMatrix(h_variable_2886);
nrows(h_variable_2885);
def h_variable_2887 = h_variable_282[1,33];
h_variable_2887;
matrix h_variable_2888[1][1] = 0;
matrix h_variable_2889[1][3] = concat(h_variable_2888,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2889); matrix h_variable_2890 = h_variable_l[1]; matrix h_variable_2891 = h_variable_l[2];
ncols(h_variable_2890);
matrix h_variable_2892 = DecideZeroRows(h_variable_2890,h_variable_58);
IsZeroMatrix(h_variable_2892);
nrows(h_variable_2891);
def h_variable_2893 = h_variable_282[19,34];
h_variable_2893;
matrix h_variable_2894[1][1] = 0;
matrix h_variable_2895[1][3] = concat(h_variable_2894,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2895); matrix h_variable_2896 = h_variable_l[1]; matrix h_variable_2897 = h_variable_l[2];
ncols(h_variable_2896);
matrix h_variable_2898 = DecideZeroRows(h_variable_2896,h_variable_58);
IsZeroMatrix(h_variable_2898);
nrows(h_variable_2897);
def h_variable_2899 = h_variable_282[3,34];
h_variable_2899;
matrix h_variable_2900[1][1] = 0;
matrix h_variable_2901[1][3] = concat(h_variable_2900,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2901); matrix h_variable_2902 = h_variable_l[1]; matrix h_variable_2903 = h_variable_l[2];
ncols(h_variable_2902);
matrix h_variable_2904 = DecideZeroRows(h_variable_2902,h_variable_58);
IsZeroMatrix(h_variable_2904);
nrows(h_variable_2903);
def h_variable_2905 = h_variable_282[1,34];
h_variable_2905;
matrix h_variable_2906[1][1] = 0;
matrix h_variable_2907[1][3] = concat(h_variable_2906,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2907); matrix h_variable_2908 = h_variable_l[1]; matrix h_variable_2909 = h_variable_l[2];
ncols(h_variable_2908);
matrix h_variable_2910 = DecideZeroRows(h_variable_2908,h_variable_58);
IsZeroMatrix(h_variable_2910);
nrows(h_variable_2909);
def h_variable_2911 = h_variable_282[19,35];
h_variable_2911;
matrix h_variable_2912[1][1] = 0;
matrix h_variable_2913[1][3] = concat(h_variable_2912,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2913); matrix h_variable_2914 = h_variable_l[1]; matrix h_variable_2915 = h_variable_l[2];
ncols(h_variable_2914);
matrix h_variable_2916 = DecideZeroRows(h_variable_2914,h_variable_58);
IsZeroMatrix(h_variable_2916);
nrows(h_variable_2915);
def h_variable_2917 = h_variable_282[3,35];
h_variable_2917;
matrix h_variable_2918[1][1] = 0;
matrix h_variable_2919[1][3] = concat(h_variable_2918,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2919); matrix h_variable_2920 = h_variable_l[1]; matrix h_variable_2921 = h_variable_l[2];
ncols(h_variable_2920);
matrix h_variable_2922 = DecideZeroRows(h_variable_2920,h_variable_58);
IsZeroMatrix(h_variable_2922);
nrows(h_variable_2921);
def h_variable_2923 = h_variable_282[1,35];
h_variable_2923;
matrix h_variable_2924[1][1] = 0;
matrix h_variable_2925[1][3] = concat(h_variable_2924,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2925); matrix h_variable_2926 = h_variable_l[1]; matrix h_variable_2927 = h_variable_l[2];
ncols(h_variable_2926);
matrix h_variable_2928 = DecideZeroRows(h_variable_2926,h_variable_58);
IsZeroMatrix(h_variable_2928);
nrows(h_variable_2927);
def h_variable_2929 = h_variable_282[19,36];
h_variable_2929;
matrix h_variable_2930[1][1] = 4*x3;
matrix h_variable_2931[1][3] = concat(h_variable_2930,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2931); matrix h_variable_2932 = h_variable_l[1]; matrix h_variable_2933 = h_variable_l[2];
ncols(h_variable_2932);
matrix h_variable_2934 = DecideZeroRows(h_variable_2932,h_variable_58);
IsZeroMatrix(h_variable_2934);
ZeroRows(h_variable_2934);
nrows(h_variable_2933);
matrix h_variable_2936 = submat(h_variable_2932,1..1,intvec( 2 ));
matrix h_variable_2935 = DecideZeroRows(h_variable_2936,h_variable_58);
IsZeroMatrix(h_variable_2935);
IsIdentityMatrix(h_variable_2935);
matrix h_variable_2937[1][3] = concat(h_variable_2935,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2937); matrix h_variable_2938 = h_variable_l[1]; matrix h_variable_2939 = h_variable_l[2];
IsZeroMatrix(h_variable_2938);
matrix h_variable_2940 = DecideZeroRows(h_variable_2938,h_variable_58);
IsZeroMatrix(h_variable_2940);
def h_variable_2941 = h_variable_282[3,36];
h_variable_2941;
matrix h_variable_2942[1][1] = 0;
matrix h_variable_2943[1][3] = concat(h_variable_2942,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2943); matrix h_variable_2944 = h_variable_l[1]; matrix h_variable_2945 = h_variable_l[2];
ncols(h_variable_2944);
matrix h_variable_2946 = DecideZeroRows(h_variable_2944,h_variable_58);
IsZeroMatrix(h_variable_2946);
nrows(h_variable_2945);
def h_variable_2947 = h_variable_282[1,36];
h_variable_2947;
matrix h_variable_2948[1][1] = 0;
matrix h_variable_2949[1][3] = concat(h_variable_2948,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2949); matrix h_variable_2950 = h_variable_l[1]; matrix h_variable_2951 = h_variable_l[2];
ncols(h_variable_2950);
matrix h_variable_2952 = DecideZeroRows(h_variable_2950,h_variable_58);
IsZeroMatrix(h_variable_2952);
nrows(h_variable_2951);
def h_variable_2953 = h_variable_282[19,37];
h_variable_2953;
matrix h_variable_2954[1][1] = 0;
matrix h_variable_2955[1][3] = concat(h_variable_2954,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2955); matrix h_variable_2956 = h_variable_l[1]; matrix h_variable_2957 = h_variable_l[2];
ncols(h_variable_2956);
matrix h_variable_2958 = DecideZeroRows(h_variable_2956,h_variable_58);
IsZeroMatrix(h_variable_2958);
nrows(h_variable_2957);
def h_variable_2959 = h_variable_282[3,37];
h_variable_2959;
matrix h_variable_2960[1][1] = 0;
matrix h_variable_2961[1][3] = concat(h_variable_2960,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2961); matrix h_variable_2962 = h_variable_l[1]; matrix h_variable_2963 = h_variable_l[2];
ncols(h_variable_2962);
matrix h_variable_2964 = DecideZeroRows(h_variable_2962,h_variable_58);
IsZeroMatrix(h_variable_2964);
nrows(h_variable_2963);
def h_variable_2965 = h_variable_282[1,37];
h_variable_2965;
matrix h_variable_2966[1][1] = 0;
matrix h_variable_2967[1][3] = concat(h_variable_2966,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2967); matrix h_variable_2968 = h_variable_l[1]; matrix h_variable_2969 = h_variable_l[2];
ncols(h_variable_2968);
matrix h_variable_2970 = DecideZeroRows(h_variable_2968,h_variable_58);
IsZeroMatrix(h_variable_2970);
nrows(h_variable_2969);
def h_variable_2971 = h_variable_282[19,38];
h_variable_2971;
matrix h_variable_2972[1][1] = 0;
matrix h_variable_2973[1][3] = concat(h_variable_2972,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2973); matrix h_variable_2974 = h_variable_l[1]; matrix h_variable_2975 = h_variable_l[2];
ncols(h_variable_2974);
matrix h_variable_2976 = DecideZeroRows(h_variable_2974,h_variable_58);
IsZeroMatrix(h_variable_2976);
nrows(h_variable_2975);
def h_variable_2977 = h_variable_282[3,38];
h_variable_2977;
matrix h_variable_2978[1][1] = 0;
matrix h_variable_2979[1][3] = concat(h_variable_2978,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2979); matrix h_variable_2980 = h_variable_l[1]; matrix h_variable_2981 = h_variable_l[2];
ncols(h_variable_2980);
matrix h_variable_2982 = DecideZeroRows(h_variable_2980,h_variable_58);
IsZeroMatrix(h_variable_2982);
nrows(h_variable_2981);
def h_variable_2983 = h_variable_282[1,38];
h_variable_2983;
matrix h_variable_2984[1][1] = 0;
matrix h_variable_2985[1][3] = concat(h_variable_2984,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2985); matrix h_variable_2986 = h_variable_l[1]; matrix h_variable_2987 = h_variable_l[2];
ncols(h_variable_2986);
matrix h_variable_2988 = DecideZeroRows(h_variable_2986,h_variable_58);
IsZeroMatrix(h_variable_2988);
nrows(h_variable_2987);
def h_variable_2989 = h_variable_282[19,39];
h_variable_2989;
matrix h_variable_2990[1][1] = 2;
matrix h_variable_2991[1][3] = concat(h_variable_2990,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_2991); matrix h_variable_2992 = h_variable_l[1]; matrix h_variable_2993 = h_variable_l[2];
ncols(h_variable_2992);
matrix h_variable_2994 = DecideZeroRows(h_variable_2992,h_variable_58);
IsZeroMatrix(h_variable_2994);
ZeroRows(h_variable_2994);
nrows(h_variable_2993);
matrix h_variable_2996 = submat(h_variable_2992,1..1,intvec( 1 ));
matrix h_variable_2995 = DecideZeroRows(h_variable_2996,h_variable_58);
IsZeroMatrix(h_variable_2995);
IsIdentityMatrix(h_variable_2995);
matrix h_variable_2997[1][3] = concat(h_variable_2995,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_2997); matrix h_variable_2998 = h_variable_l[1]; matrix h_variable_2999 = h_variable_l[2];
IsZeroMatrix(h_variable_2998);
matrix h_variable_3000 = DecideZeroRows(h_variable_2998,h_variable_58);
IsZeroMatrix(h_variable_3000);
kill h_variable_2384;kill h_variable_2386;kill h_variable_2387;kill h_variable_2388;kill h_variable_2389;kill h_variable_2390;kill h_variable_2392;kill h_variable_2393;kill h_variable_2394;kill h_variable_2395;kill h_variable_2396;kill h_variable_2397;kill h_variable_2398;kill h_variable_2399;kill h_variable_2400;kill h_variable_2401;kill h_variable_2402;kill h_variable_2403;kill h_variable_2404;kill h_variable_2405;kill h_variable_2406;kill h_variable_2407;kill h_variable_2408;kill h_variable_2409;kill h_variable_2410;kill h_variable_2411;kill h_variable_2412;kill h_variable_2413;kill h_variable_2414;kill h_variable_2415;kill h_variable_2416;kill h_variable_2417;kill h_variable_2418;kill h_variable_2419;kill h_variable_2420;kill h_variable_2421;kill h_variable_2422;kill h_variable_2423;kill h_variable_2424;kill h_variable_2425;kill h_variable_2426;kill h_variable_2427;kill h_variable_2428;kill h_variable_2429;kill h_variable_2430;kill h_variable_2431;kill h_variable_2432;kill h_variable_2433;kill h_variable_2434;kill h_variable_2435;kill h_variable_2436;kill h_variable_2437;kill h_variable_2438;kill h_variable_2439;kill h_variable_2440;kill h_variable_2441;kill h_variable_2442;kill h_variable_2443;kill h_variable_2444;kill h_variable_2445;kill h_variable_2446;kill h_variable_2447;kill h_variable_2448;kill h_variable_2449;kill h_variable_2450;kill h_variable_2451;kill h_variable_2452;kill h_variable_2453;kill h_variable_2454;kill h_variable_2455;kill h_variable_2456;kill h_variable_2457;kill h_variable_2458;kill h_variable_2459;kill h_variable_2460;kill h_variable_2461;kill h_variable_2462;kill h_variable_2463;kill h_variable_2464;kill h_variable_2465;kill h_variable_2466;kill h_variable_2467;kill h_variable_2468;kill h_variable_2469;kill h_variable_2470;kill h_variable_2471;kill h_variable_2472;kill h_variable_2473;kill h_variable_2474;kill h_variable_2475;kill h_variable_2476;kill h_variable_2477;kill h_variable_2478;kill h_variable_2479;kill h_variable_2480;kill h_variable_2481;kill h_variable_2482;kill h_variable_2483;kill h_variable_2484;kill h_variable_2485;kill h_variable_2486;kill h_variable_2487;kill h_variable_2488;kill h_variable_2489;kill h_variable_2490;kill h_variable_2491;kill h_variable_2492;kill h_variable_2493;kill h_variable_2494;kill h_variable_2495;kill h_variable_2496;kill h_variable_2497;kill h_variable_2498;kill h_variable_2507;kill h_variable_2508;kill h_variable_2509;kill h_variable_2510;kill h_variable_2512;kill h_variable_2513;kill h_variable_2514;kill h_variable_2515;kill h_variable_2516;kill h_variable_2518;kill h_variable_2519;kill h_variable_2520;kill h_variable_2521;kill h_variable_2522;kill h_variable_2523;kill h_variable_2524;kill h_variable_2525;kill h_variable_2526;kill h_variable_2527;kill h_variable_2528;kill h_variable_2529;kill h_variable_2530;kill h_variable_2531;kill h_variable_2532;kill h_variable_2533;kill h_variable_2534;kill h_variable_2535;kill h_variable_2536;kill h_variable_2537;kill h_variable_2538;kill h_variable_2539;kill h_variable_2540;kill h_variable_2541;kill h_variable_2542;kill h_variable_2543;kill h_variable_2544;kill h_variable_2545;kill h_variable_2546;kill h_variable_2547;kill h_variable_2548;kill h_variable_2549;kill h_variable_2550;kill h_variable_2551;kill h_variable_2552;kill h_variable_2553;kill h_variable_2554;kill h_variable_2555;kill h_variable_2556;kill h_variable_2557;kill h_variable_2558;kill h_variable_2559;kill h_variable_2560;kill h_variable_2561;kill h_variable_2562;kill h_variable_2563;kill h_variable_2564;kill h_variable_2565;kill h_variable_2566;kill h_variable_2567;kill h_variable_2568;kill h_variable_2569;kill h_variable_2570;kill h_variable_2571;kill h_variable_2572;kill h_variable_2573;kill h_variable_2574;kill h_variable_2575;kill h_variable_2576;kill h_variable_2577;kill h_variable_2578;kill h_variable_2579;kill h_variable_2580;kill h_variable_2581;kill h_variable_2582;kill h_variable_2583;kill h_variable_2584;kill h_variable_2585;kill h_variable_2586;kill h_variable_2587;kill h_variable_2588;kill h_variable_2589;kill h_variable_2590;kill h_variable_2591;kill h_variable_2592;kill h_variable_2593;kill h_variable_2594;kill h_variable_2595;kill h_variable_2596;kill h_variable_2597;kill h_variable_2598;kill h_variable_2599;kill h_variable_2600;kill h_variable_2601;kill h_variable_2602;kill h_variable_2603;kill h_variable_2604;kill h_variable_2605;kill h_variable_2606;kill h_variable_2607;kill h_variable_2608;kill h_variable_2609;kill h_variable_2610;kill h_variable_2611;kill h_variable_2612;kill h_variable_2613;kill h_variable_2614;kill h_variable_2615;kill h_variable_2616;kill h_variable_2617;kill h_variable_2618;kill h_variable_2619;kill h_variable_2620;kill h_variable_2621;kill h_variable_2622;kill h_variable_2623;kill h_variable_2624;kill h_variable_2625;kill h_variable_2626;kill h_variable_2627;kill h_variable_2628;kill h_variable_2629;kill h_variable_2630;kill h_variable_2631;kill h_variable_2632;kill h_variable_2633;kill h_variable_2634;kill h_variable_2635;kill h_variable_2636;kill h_variable_2637;kill h_variable_2638;kill h_variable_2639;kill h_variable_2640;kill h_variable_2641;kill h_variable_2642;kill h_variable_2643;kill h_variable_2644;kill h_variable_2645;kill h_variable_2646;kill h_variable_2647;kill h_variable_2648;kill h_variable_2649;kill h_variable_2650;kill h_variable_2651;kill h_variable_2652;kill h_variable_2653;kill h_variable_2654;kill h_variable_2655;kill h_variable_2656;kill h_variable_2657;kill h_variable_2658;kill h_variable_2659;kill h_variable_2660;kill h_variable_2661;kill h_variable_2662;kill h_variable_2663;kill h_variable_2664;kill h_variable_2665;kill h_variable_2666;kill h_variable_2667;kill h_variable_2668;kill h_variable_2669;kill h_variable_2670;kill h_variable_2671;kill h_variable_2672;kill h_variable_2673;kill h_variable_2674;kill h_variable_2675;kill h_variable_2676;kill h_variable_2677;kill h_variable_2678;kill h_variable_2681;kill h_variable_2682;kill h_variable_2683;kill h_variable_2684;kill h_variable_2687;kill h_variable_2688;kill h_variable_2689;kill h_variable_2690;kill h_variable_2692;kill h_variable_2693;kill h_variable_2694;kill h_variable_2695;kill h_variable_2696;kill h_variable_2698;kill h_variable_2702;kill h_variable_2704;kill h_variable_2705;kill h_variable_2706;kill h_variable_2707;kill h_variable_2708;kill h_variable_2709;kill h_variable_2710;kill h_variable_2711;kill h_variable_2712;kill h_variable_2713;kill h_variable_2714;kill h_variable_2715;kill h_variable_2716;kill h_variable_2717;kill h_variable_2718;kill h_variable_2719;kill h_variable_2720;kill h_variable_2721;kill h_variable_2722;kill h_variable_2723;kill h_variable_2724;kill h_variable_2725;kill h_variable_2726;kill h_variable_2727;kill h_variable_2728;kill h_variable_2729;kill h_variable_2730;kill h_variable_2731;kill h_variable_2732;kill h_variable_2733;kill h_variable_2734;kill h_variable_2735;kill h_variable_2736;kill h_variable_2737;kill h_variable_2738;kill h_variable_2739;kill h_variable_2740;kill h_variable_2741;kill h_variable_2742;kill h_variable_2743;kill h_variable_2744;kill h_variable_2745;kill h_variable_2746;kill h_variable_2747;kill h_variable_2748;kill h_variable_2749;kill h_variable_2750;kill h_variable_2751;kill h_variable_2752;kill h_variable_2753;kill h_variable_2754;kill h_variable_2755;kill h_variable_2756;kill h_variable_2757;kill h_variable_2758;kill h_variable_2759;kill h_variable_2760;kill h_variable_2761;kill h_variable_2762;kill h_variable_2763;kill h_variable_2764;kill h_variable_2765;kill h_variable_2766;kill h_variable_2767;kill h_variable_2768;kill h_variable_2769;kill h_variable_2770;kill h_variable_2771;kill h_variable_2772;kill h_variable_2773;kill h_variable_2774;kill h_variable_2775;kill h_variable_2776;kill h_variable_2777;kill h_variable_2778;kill h_variable_2779;kill h_variable_2780;kill h_variable_2781;kill h_variable_2782;kill h_variable_2783;kill h_variable_2784;kill h_variable_2785;kill h_variable_2786;kill h_variable_2787;kill h_variable_2788;kill h_variable_2789;kill h_variable_2790;kill h_variable_2791;kill h_variable_2792;kill h_variable_2793;kill h_variable_2794;kill h_variable_2795;kill h_variable_2796;kill h_variable_2797;kill h_variable_2798;kill h_variable_2799;kill h_variable_2800;kill h_variable_2801;kill h_variable_2802;kill h_variable_2803;kill h_variable_2804;kill h_variable_2805;kill h_variable_2806;kill h_variable_2807;kill h_variable_2808;kill h_variable_2809;kill h_variable_2810;kill h_variable_2811;kill h_variable_2812;kill h_variable_2813;kill h_variable_2814;kill h_variable_2815;kill h_variable_2816;kill h_variable_2817;kill h_variable_2818;kill h_variable_2819;kill h_variable_2820;kill h_variable_2821;kill h_variable_2822;kill h_variable_2823;kill h_variable_2824;kill h_variable_2825;kill h_variable_2826;kill h_variable_2827;kill h_variable_2828;kill h_variable_2829;kill h_variable_2830;kill h_variable_2831;kill h_variable_2832;kill h_variable_2833;kill h_variable_2834;kill h_variable_2835;kill h_variable_2836;kill h_variable_2837;kill h_variable_2838;kill h_variable_2839;kill h_variable_2840;kill h_variable_2841;kill h_variable_2842;kill h_variable_2843;kill h_variable_2844;kill h_variable_2845;kill h_variable_2846;kill h_variable_2847;kill h_variable_2848;kill h_variable_2849;kill h_variable_2850;kill h_variable_2851;kill h_variable_2852;kill h_variable_2853;kill h_variable_2854;kill h_variable_2855;kill h_variable_2856;kill h_variable_2857;kill h_variable_2858;kill h_variable_2859;kill h_variable_2860;kill h_variable_2861;kill h_variable_2862;kill h_variable_2863;kill h_variable_2864;kill h_variable_2865;kill h_variable_2866;kill h_variable_2867;kill h_variable_2868;kill h_variable_2869;kill h_variable_2870;kill h_variable_2871;kill h_variable_2872;kill h_variable_2873;kill h_variable_2874;kill h_variable_2875;kill h_variable_2876;kill h_variable_2877;kill h_variable_2878;kill h_variable_2879;kill h_variable_2880;kill h_variable_2881;kill h_variable_2882;kill h_variable_2883;kill h_variable_2884;kill h_variable_2885;kill h_variable_2886;kill h_variable_2887;kill h_variable_2888;kill h_variable_2889;kill h_variable_2890;kill h_variable_2891;kill h_variable_2892;kill h_variable_2893;kill h_variable_2894;kill h_variable_2895;kill h_variable_2896;kill h_variable_2897;kill h_variable_2898;kill h_variable_2899;kill h_variable_2900;kill h_variable_2901;kill h_variable_2902;kill h_variable_2903;kill h_variable_2904;
def h_variable_3001 = h_variable_282[3,39];
h_variable_3001;
matrix h_variable_3002[1][1] = 0;
matrix h_variable_3003[1][3] = concat(h_variable_3002,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3003); matrix h_variable_3004 = h_variable_l[1]; matrix h_variable_3005 = h_variable_l[2];
ncols(h_variable_3004);
matrix h_variable_3006 = DecideZeroRows(h_variable_3004,h_variable_58);
IsZeroMatrix(h_variable_3006);
nrows(h_variable_3005);
def h_variable_3007 = h_variable_282[1,39];
h_variable_3007;
matrix h_variable_3008[1][1] = 0;
matrix h_variable_3009[1][3] = concat(h_variable_3008,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3009); matrix h_variable_3010 = h_variable_l[1]; matrix h_variable_3011 = h_variable_l[2];
ncols(h_variable_3010);
matrix h_variable_3012 = DecideZeroRows(h_variable_3010,h_variable_58);
IsZeroMatrix(h_variable_3012);
nrows(h_variable_3011);
def h_variable_3013 = h_variable_282[19,40];
h_variable_3013;
matrix h_variable_3014[1][1] = 0;
matrix h_variable_3015[1][3] = concat(h_variable_3014,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3015); matrix h_variable_3016 = h_variable_l[1]; matrix h_variable_3017 = h_variable_l[2];
ncols(h_variable_3016);
matrix h_variable_3018 = DecideZeroRows(h_variable_3016,h_variable_58);
IsZeroMatrix(h_variable_3018);
nrows(h_variable_3017);
def h_variable_3019 = h_variable_282[3,40];
h_variable_3019;
matrix h_variable_3020[1][1] = 0;
matrix h_variable_3021[1][3] = concat(h_variable_3020,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3021); matrix h_variable_3022 = h_variable_l[1]; matrix h_variable_3023 = h_variable_l[2];
ncols(h_variable_3022);
matrix h_variable_3024 = DecideZeroRows(h_variable_3022,h_variable_58);
IsZeroMatrix(h_variable_3024);
nrows(h_variable_3023);
def h_variable_3025 = h_variable_282[1,40];
h_variable_3025;
matrix h_variable_3026[1][1] = 0;
matrix h_variable_3027[1][3] = concat(h_variable_3026,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3027); matrix h_variable_3028 = h_variable_l[1]; matrix h_variable_3029 = h_variable_l[2];
ncols(h_variable_3028);
matrix h_variable_3030 = DecideZeroRows(h_variable_3028,h_variable_58);
IsZeroMatrix(h_variable_3030);
nrows(h_variable_3029);
def h_variable_3031 = h_variable_282[19,41];
h_variable_3031;
matrix h_variable_3032[1][1] = 0;
matrix h_variable_3033[1][3] = concat(h_variable_3032,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3033); matrix h_variable_3034 = h_variable_l[1]; matrix h_variable_3035 = h_variable_l[2];
ncols(h_variable_3034);
matrix h_variable_3036 = DecideZeroRows(h_variable_3034,h_variable_58);
IsZeroMatrix(h_variable_3036);
nrows(h_variable_3035);
def h_variable_3037 = h_variable_282[3,41];
h_variable_3037;
matrix h_variable_3038[1][1] = 0;
matrix h_variable_3039[1][3] = concat(h_variable_3038,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3039); matrix h_variable_3040 = h_variable_l[1]; matrix h_variable_3041 = h_variable_l[2];
ncols(h_variable_3040);
matrix h_variable_3042 = DecideZeroRows(h_variable_3040,h_variable_58);
IsZeroMatrix(h_variable_3042);
nrows(h_variable_3041);
def h_variable_3043 = h_variable_282[1,41];
h_variable_3043;
matrix h_variable_3044[1][1] = 0;
matrix h_variable_3045[1][3] = concat(h_variable_3044,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3045); matrix h_variable_3046 = h_variable_l[1]; matrix h_variable_3047 = h_variable_l[2];
ncols(h_variable_3046);
matrix h_variable_3048 = DecideZeroRows(h_variable_3046,h_variable_58);
IsZeroMatrix(h_variable_3048);
nrows(h_variable_3047);
def h_variable_3049 = h_variable_282[19,42];
h_variable_3049;
matrix h_variable_3050[1][1] = 0;
matrix h_variable_3051[1][3] = concat(h_variable_3050,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3051); matrix h_variable_3052 = h_variable_l[1]; matrix h_variable_3053 = h_variable_l[2];
ncols(h_variable_3052);
matrix h_variable_3054 = DecideZeroRows(h_variable_3052,h_variable_58);
IsZeroMatrix(h_variable_3054);
nrows(h_variable_3053);
def h_variable_3055 = h_variable_282[3,42];
h_variable_3055;
matrix h_variable_3056[1][1] = 0;
matrix h_variable_3057[1][3] = concat(h_variable_3056,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3057); matrix h_variable_3058 = h_variable_l[1]; matrix h_variable_3059 = h_variable_l[2];
ncols(h_variable_3058);
matrix h_variable_3060 = DecideZeroRows(h_variable_3058,h_variable_58);
IsZeroMatrix(h_variable_3060);
nrows(h_variable_3059);
def h_variable_3061 = h_variable_282[1,42];
h_variable_3061;
matrix h_variable_3062[1][1] = 0;
matrix h_variable_3063[1][3] = concat(h_variable_3062,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3063); matrix h_variable_3064 = h_variable_l[1]; matrix h_variable_3065 = h_variable_l[2];
ncols(h_variable_3064);
matrix h_variable_3066 = DecideZeroRows(h_variable_3064,h_variable_58);
IsZeroMatrix(h_variable_3066);
nrows(h_variable_3065);
def h_variable_3067 = h_variable_282[19,43];
h_variable_3067;
matrix h_variable_3068[1][1] = 0;
matrix h_variable_3069[1][3] = concat(h_variable_3068,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3069); matrix h_variable_3070 = h_variable_l[1]; matrix h_variable_3071 = h_variable_l[2];
ncols(h_variable_3070);
matrix h_variable_3072 = DecideZeroRows(h_variable_3070,h_variable_58);
IsZeroMatrix(h_variable_3072);
nrows(h_variable_3071);
def h_variable_3073 = h_variable_282[3,43];
h_variable_3073;
matrix h_variable_3074[1][1] = 0;
matrix h_variable_3075[1][3] = concat(h_variable_3074,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3075); matrix h_variable_3076 = h_variable_l[1]; matrix h_variable_3077 = h_variable_l[2];
ncols(h_variable_3076);
matrix h_variable_3078 = DecideZeroRows(h_variable_3076,h_variable_58);
IsZeroMatrix(h_variable_3078);
nrows(h_variable_3077);
def h_variable_3079 = h_variable_282[1,43];
h_variable_3079;
matrix h_variable_3080[1][1] = 0;
matrix h_variable_3081[1][3] = concat(h_variable_3080,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3081); matrix h_variable_3082 = h_variable_l[1]; matrix h_variable_3083 = h_variable_l[2];
ncols(h_variable_3082);
matrix h_variable_3084 = DecideZeroRows(h_variable_3082,h_variable_58);
IsZeroMatrix(h_variable_3084);
nrows(h_variable_3083);
def h_variable_3085 = h_variable_282[19,44];
h_variable_3085;
matrix h_variable_3086[1][1] = 0;
matrix h_variable_3087[1][3] = concat(h_variable_3086,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3087); matrix h_variable_3088 = h_variable_l[1]; matrix h_variable_3089 = h_variable_l[2];
ncols(h_variable_3088);
matrix h_variable_3090 = DecideZeroRows(h_variable_3088,h_variable_58);
IsZeroMatrix(h_variable_3090);
nrows(h_variable_3089);
def h_variable_3091 = h_variable_282[3,44];
h_variable_3091;
matrix h_variable_3092[1][1] = 0;
matrix h_variable_3093[1][3] = concat(h_variable_3092,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3093); matrix h_variable_3094 = h_variable_l[1]; matrix h_variable_3095 = h_variable_l[2];
ncols(h_variable_3094);
matrix h_variable_3096 = DecideZeroRows(h_variable_3094,h_variable_58);
IsZeroMatrix(h_variable_3096);
nrows(h_variable_3095);
def h_variable_3097 = h_variable_282[1,44];
h_variable_3097;
matrix h_variable_3098[1][1] = 0;
matrix h_variable_3099[1][3] = concat(h_variable_3098,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3099); matrix h_variable_3100 = h_variable_l[1]; matrix h_variable_3101 = h_variable_l[2];
ncols(h_variable_3100);
matrix h_variable_3102 = DecideZeroRows(h_variable_3100,h_variable_58);
IsZeroMatrix(h_variable_3102);
nrows(h_variable_3101);
def h_variable_3103 = h_variable_282[19,45];
h_variable_3103;
matrix h_variable_3104[1][1] = 0;
matrix h_variable_3105[1][3] = concat(h_variable_3104,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3105); matrix h_variable_3106 = h_variable_l[1]; matrix h_variable_3107 = h_variable_l[2];
ncols(h_variable_3106);
matrix h_variable_3108 = DecideZeroRows(h_variable_3106,h_variable_58);
IsZeroMatrix(h_variable_3108);
nrows(h_variable_3107);
def h_variable_3109 = h_variable_282[3,45];
h_variable_3109;
matrix h_variable_3110[1][1] = 0;
matrix h_variable_3111[1][3] = concat(h_variable_3110,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3111); matrix h_variable_3112 = h_variable_l[1]; matrix h_variable_3113 = h_variable_l[2];
ncols(h_variable_3112);
matrix h_variable_3114 = DecideZeroRows(h_variable_3112,h_variable_58);
IsZeroMatrix(h_variable_3114);
nrows(h_variable_3113);
def h_variable_3115 = h_variable_282[1,45];
h_variable_3115;
matrix h_variable_3116[1][1] = 0;
matrix h_variable_3117[1][3] = concat(h_variable_3116,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3117); matrix h_variable_3118 = h_variable_l[1]; matrix h_variable_3119 = h_variable_l[2];
ncols(h_variable_3118);
matrix h_variable_3120 = DecideZeroRows(h_variable_3118,h_variable_58);
IsZeroMatrix(h_variable_3120);
nrows(h_variable_3119);
def h_variable_3121 = h_variable_282[19,46];
h_variable_3121;
matrix h_variable_3122[1][1] = 0;
matrix h_variable_3123[1][3] = concat(h_variable_3122,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3123); matrix h_variable_3124 = h_variable_l[1]; matrix h_variable_3125 = h_variable_l[2];
ncols(h_variable_3124);
matrix h_variable_3126 = DecideZeroRows(h_variable_3124,h_variable_58);
IsZeroMatrix(h_variable_3126);
nrows(h_variable_3125);
def h_variable_3127 = h_variable_282[3,46];
h_variable_3127;
matrix h_variable_3128[1][1] = 0;
matrix h_variable_3129[1][3] = concat(h_variable_3128,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3129); matrix h_variable_3130 = h_variable_l[1]; matrix h_variable_3131 = h_variable_l[2];
ncols(h_variable_3130);
matrix h_variable_3132 = DecideZeroRows(h_variable_3130,h_variable_58);
IsZeroMatrix(h_variable_3132);
nrows(h_variable_3131);
def h_variable_3133 = h_variable_282[1,46];
h_variable_3133;
matrix h_variable_3134[1][1] = 0;
matrix h_variable_3135[1][3] = concat(h_variable_3134,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3135); matrix h_variable_3136 = h_variable_l[1]; matrix h_variable_3137 = h_variable_l[2];
ncols(h_variable_3136);
matrix h_variable_3138 = DecideZeroRows(h_variable_3136,h_variable_58);
IsZeroMatrix(h_variable_3138);
nrows(h_variable_3137);
def h_variable_3139 = h_variable_282[19,47];
h_variable_3139;
matrix h_variable_3140[1][1] = -2*x2+2*x3;
matrix h_variable_3141[1][3] = concat(h_variable_3140,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3141); matrix h_variable_3142 = h_variable_l[1]; matrix h_variable_3143 = h_variable_l[2];
ncols(h_variable_3142);
matrix h_variable_3144 = DecideZeroRows(h_variable_3142,h_variable_58);
IsZeroMatrix(h_variable_3144);
ZeroRows(h_variable_3144);
nrows(h_variable_3143);
matrix h_variable_3146 = submat(h_variable_3142,1..1,intvec( 2 ));
matrix h_variable_3145 = DecideZeroRows(h_variable_3146,h_variable_58);
IsZeroMatrix(h_variable_3145);
IsIdentityMatrix(h_variable_3145);
matrix h_variable_3147[1][3] = concat(h_variable_3145,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_3147); matrix h_variable_3148 = h_variable_l[1]; matrix h_variable_3149 = h_variable_l[2];
IsZeroMatrix(h_variable_3148);
matrix h_variable_3150 = DecideZeroRows(h_variable_3148,h_variable_58);
IsZeroMatrix(h_variable_3150);
def h_variable_3151 = h_variable_282[3,47];
h_variable_3151;
matrix h_variable_3152[1][1] = 0;
matrix h_variable_3153[1][3] = concat(h_variable_3152,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3153); matrix h_variable_3154 = h_variable_l[1]; matrix h_variable_3155 = h_variable_l[2];
ncols(h_variable_3154);
matrix h_variable_3156 = DecideZeroRows(h_variable_3154,h_variable_58);
IsZeroMatrix(h_variable_3156);
nrows(h_variable_3155);
def h_variable_3157 = h_variable_282[1,47];
h_variable_3157;
matrix h_variable_3158[1][1] = 0;
matrix h_variable_3159[1][3] = concat(h_variable_3158,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3159); matrix h_variable_3160 = h_variable_l[1]; matrix h_variable_3161 = h_variable_l[2];
ncols(h_variable_3160);
matrix h_variable_3162 = DecideZeroRows(h_variable_3160,h_variable_58);
IsZeroMatrix(h_variable_3162);
nrows(h_variable_3161);
def h_variable_3163 = h_variable_282[19,48];
h_variable_3163;
matrix h_variable_3164[1][1] = 0;
matrix h_variable_3165[1][3] = concat(h_variable_3164,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3165); matrix h_variable_3166 = h_variable_l[1]; matrix h_variable_3167 = h_variable_l[2];
ncols(h_variable_3166);
matrix h_variable_3168 = DecideZeroRows(h_variable_3166,h_variable_58);
IsZeroMatrix(h_variable_3168);
nrows(h_variable_3167);
def h_variable_3169 = h_variable_282[3,48];
h_variable_3169;
matrix h_variable_3170[1][1] = 0;
matrix h_variable_3171[1][3] = concat(h_variable_3170,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3171); matrix h_variable_3172 = h_variable_l[1]; matrix h_variable_3173 = h_variable_l[2];
ncols(h_variable_3172);
matrix h_variable_3174 = DecideZeroRows(h_variable_3172,h_variable_58);
IsZeroMatrix(h_variable_3174);
nrows(h_variable_3173);
def h_variable_3175 = h_variable_282[1,48];
h_variable_3175;
matrix h_variable_3176[1][1] = 0;
matrix h_variable_3177[1][3] = concat(h_variable_3176,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3177); matrix h_variable_3178 = h_variable_l[1]; matrix h_variable_3179 = h_variable_l[2];
ncols(h_variable_3178);
matrix h_variable_3180 = DecideZeroRows(h_variable_3178,h_variable_58);
IsZeroMatrix(h_variable_3180);
nrows(h_variable_3179);
def h_variable_3181 = h_variable_282[19,49];
h_variable_3181;
matrix h_variable_3182[1][1] = 0;
matrix h_variable_3183[1][3] = concat(h_variable_3182,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3183); matrix h_variable_3184 = h_variable_l[1]; matrix h_variable_3185 = h_variable_l[2];
ncols(h_variable_3184);
matrix h_variable_3186 = DecideZeroRows(h_variable_3184,h_variable_58);
IsZeroMatrix(h_variable_3186);
nrows(h_variable_3185);
def h_variable_3187 = h_variable_282[3,49];
h_variable_3187;
matrix h_variable_3188[1][1] = 0;
matrix h_variable_3189[1][3] = concat(h_variable_3188,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3189); matrix h_variable_3190 = h_variable_l[1]; matrix h_variable_3191 = h_variable_l[2];
ncols(h_variable_3190);
matrix h_variable_3192 = DecideZeroRows(h_variable_3190,h_variable_58);
IsZeroMatrix(h_variable_3192);
nrows(h_variable_3191);
def h_variable_3193 = h_variable_282[1,49];
h_variable_3193;
matrix h_variable_3194[1][1] = 0;
matrix h_variable_3195[1][3] = concat(h_variable_3194,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3195); matrix h_variable_3196 = h_variable_l[1]; matrix h_variable_3197 = h_variable_l[2];
ncols(h_variable_3196);
matrix h_variable_3198 = DecideZeroRows(h_variable_3196,h_variable_58);
IsZeroMatrix(h_variable_3198);
nrows(h_variable_3197);
def h_variable_3199 = h_variable_282[19,50];
h_variable_3199;
matrix h_variable_3200[1][1] = 0;
matrix h_variable_3201[1][3] = concat(h_variable_3200,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3201); matrix h_variable_3202 = h_variable_l[1]; matrix h_variable_3203 = h_variable_l[2];
ncols(h_variable_3202);
matrix h_variable_3204 = DecideZeroRows(h_variable_3202,h_variable_58);
IsZeroMatrix(h_variable_3204);
nrows(h_variable_3203);
def h_variable_3205 = h_variable_282[3,50];
h_variable_3205;
matrix h_variable_3206[1][1] = 0;
matrix h_variable_3207[1][3] = concat(h_variable_3206,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3207); matrix h_variable_3208 = h_variable_l[1]; matrix h_variable_3209 = h_variable_l[2];
ncols(h_variable_3208);
matrix h_variable_3210 = DecideZeroRows(h_variable_3208,h_variable_58);
IsZeroMatrix(h_variable_3210);
nrows(h_variable_3209);
def h_variable_3211 = h_variable_282[1,50];
h_variable_3211;
matrix h_variable_3212[1][1] = 0;
matrix h_variable_3213[1][3] = concat(h_variable_3212,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3213); matrix h_variable_3214 = h_variable_l[1]; matrix h_variable_3215 = h_variable_l[2];
ncols(h_variable_3214);
matrix h_variable_3216 = DecideZeroRows(h_variable_3214,h_variable_58);
IsZeroMatrix(h_variable_3216);
nrows(h_variable_3215);
def h_variable_3217 = h_variable_282[19,51];
h_variable_3217;
matrix h_variable_3218[1][1] = 0;
matrix h_variable_3219[1][3] = concat(h_variable_3218,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3219); matrix h_variable_3220 = h_variable_l[1]; matrix h_variable_3221 = h_variable_l[2];
ncols(h_variable_3220);
matrix h_variable_3222 = DecideZeroRows(h_variable_3220,h_variable_58);
IsZeroMatrix(h_variable_3222);
nrows(h_variable_3221);
def h_variable_3223 = h_variable_282[3,51];
h_variable_3223;
matrix h_variable_3224[1][1] = 0;
matrix h_variable_3225[1][3] = concat(h_variable_3224,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3225); matrix h_variable_3226 = h_variable_l[1]; matrix h_variable_3227 = h_variable_l[2];
ncols(h_variable_3226);
matrix h_variable_3228 = DecideZeroRows(h_variable_3226,h_variable_58);
IsZeroMatrix(h_variable_3228);
nrows(h_variable_3227);
def h_variable_3229 = h_variable_282[1,51];
h_variable_3229;
matrix h_variable_3230[1][1] = 0;
matrix h_variable_3231[1][3] = concat(h_variable_3230,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3231); matrix h_variable_3232 = h_variable_l[1]; matrix h_variable_3233 = h_variable_l[2];
ncols(h_variable_3232);
matrix h_variable_3234 = DecideZeroRows(h_variable_3232,h_variable_58);
IsZeroMatrix(h_variable_3234);
nrows(h_variable_3233);
def h_variable_3235 = h_variable_282[19,52];
h_variable_3235;
matrix h_variable_3236[1][1] = 4*a7-4;
matrix h_variable_3237[1][3] = concat(h_variable_3236,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3237); matrix h_variable_3238 = h_variable_l[1]; matrix h_variable_3239 = h_variable_l[2];
ncols(h_variable_3238);
matrix h_variable_3240 = DecideZeroRows(h_variable_3238,h_variable_58);
IsZeroMatrix(h_variable_3240);
ZeroRows(h_variable_3240);
nrows(h_variable_3239);
matrix h_variable_3242 = submat(h_variable_3238,1..1,intvec( 1 ));
matrix h_variable_3241 = DecideZeroRows(h_variable_3242,h_variable_58);
IsZeroMatrix(h_variable_3241);
IsIdentityMatrix(h_variable_3241);
matrix h_variable_3243[1][3] = concat(h_variable_3241,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_3243); matrix h_variable_3244 = h_variable_l[1]; matrix h_variable_3245 = h_variable_l[2];
IsZeroMatrix(h_variable_3244);
matrix h_variable_3246 = DecideZeroRows(h_variable_3244,h_variable_58);
IsZeroMatrix(h_variable_3246);
def h_variable_3247 = h_variable_282[3,52];
h_variable_3247;
matrix h_variable_3248[1][1] = 0;
matrix h_variable_3249[1][3] = concat(h_variable_3248,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3249); matrix h_variable_3250 = h_variable_l[1]; matrix h_variable_3251 = h_variable_l[2];
ncols(h_variable_3250);
matrix h_variable_3252 = DecideZeroRows(h_variable_3250,h_variable_58);
IsZeroMatrix(h_variable_3252);
nrows(h_variable_3251);
def h_variable_3253 = h_variable_282[1,52];
h_variable_3253;
matrix h_variable_3254[1][1] = 0;
matrix h_variable_3255[1][3] = concat(h_variable_3254,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3255); matrix h_variable_3256 = h_variable_l[1]; matrix h_variable_3257 = h_variable_l[2];
ncols(h_variable_3256);
matrix h_variable_3258 = DecideZeroRows(h_variable_3256,h_variable_58);
IsZeroMatrix(h_variable_3258);
nrows(h_variable_3257);
def h_variable_3259 = h_variable_282[19,53];
h_variable_3259;
matrix h_variable_3260[1][1] = -2*x1;
matrix h_variable_3261[1][3] = concat(h_variable_3260,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3261); matrix h_variable_3262 = h_variable_l[1]; matrix h_variable_3263 = h_variable_l[2];
ncols(h_variable_3262);
matrix h_variable_3264 = DecideZeroRows(h_variable_3262,h_variable_58);
IsZeroMatrix(h_variable_3264);
ZeroRows(h_variable_3264);
nrows(h_variable_3263);
matrix h_variable_3266 = submat(h_variable_3262,1..1,intvec( 2 ));
matrix h_variable_3265 = DecideZeroRows(h_variable_3266,h_variable_58);
IsZeroMatrix(h_variable_3265);
IsIdentityMatrix(h_variable_3265);
matrix h_variable_3267[1][3] = concat(h_variable_3265,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_3267); matrix h_variable_3268 = h_variable_l[1]; matrix h_variable_3269 = h_variable_l[2];
IsZeroMatrix(h_variable_3268);
matrix h_variable_3270 = DecideZeroRows(h_variable_3268,h_variable_58);
IsZeroMatrix(h_variable_3270);
def h_variable_3271 = h_variable_282[3,53];
h_variable_3271;
matrix h_variable_3272[1][1] = 0;
matrix h_variable_3273[1][3] = concat(h_variable_3272,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3273); matrix h_variable_3274 = h_variable_l[1]; matrix h_variable_3275 = h_variable_l[2];
ncols(h_variable_3274);
matrix h_variable_3276 = DecideZeroRows(h_variable_3274,h_variable_58);
IsZeroMatrix(h_variable_3276);
nrows(h_variable_3275);
def h_variable_3277 = h_variable_282[1,53];
h_variable_3277;
matrix h_variable_3278[1][1] = 0;
matrix h_variable_3279[1][3] = concat(h_variable_3278,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3279); matrix h_variable_3280 = h_variable_l[1]; matrix h_variable_3281 = h_variable_l[2];
ncols(h_variable_3280);
matrix h_variable_3282 = DecideZeroRows(h_variable_3280,h_variable_58);
IsZeroMatrix(h_variable_3282);
nrows(h_variable_3281);
def h_variable_3283 = h_variable_282[19,54];
h_variable_3283;
matrix h_variable_3284[1][1] = 0;
matrix h_variable_3285[1][3] = concat(h_variable_3284,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3285); matrix h_variable_3286 = h_variable_l[1]; matrix h_variable_3287 = h_variable_l[2];
ncols(h_variable_3286);
matrix h_variable_3288 = DecideZeroRows(h_variable_3286,h_variable_58);
IsZeroMatrix(h_variable_3288);
nrows(h_variable_3287);
def h_variable_3289 = h_variable_282[3,54];
h_variable_3289;
matrix h_variable_3290[1][1] = 0;
matrix h_variable_3291[1][3] = concat(h_variable_3290,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3291); matrix h_variable_3292 = h_variable_l[1]; matrix h_variable_3293 = h_variable_l[2];
ncols(h_variable_3292);
matrix h_variable_3294 = DecideZeroRows(h_variable_3292,h_variable_58);
IsZeroMatrix(h_variable_3294);
nrows(h_variable_3293);
def h_variable_3295 = h_variable_282[1,54];
h_variable_3295;
matrix h_variable_3296[1][1] = 0;
matrix h_variable_3297[1][3] = concat(h_variable_3296,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3297); matrix h_variable_3298 = h_variable_l[1]; matrix h_variable_3299 = h_variable_l[2];
ncols(h_variable_3298);
matrix h_variable_3300 = DecideZeroRows(h_variable_3298,h_variable_58);
IsZeroMatrix(h_variable_3300);
nrows(h_variable_3299);
def h_variable_3301 = h_variable_282[19,55];
h_variable_3301;
matrix h_variable_3302[1][1] = 0;
matrix h_variable_3303[1][3] = concat(h_variable_3302,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3303); matrix h_variable_3304 = h_variable_l[1]; matrix h_variable_3305 = h_variable_l[2];
ncols(h_variable_3304);
matrix h_variable_3306 = DecideZeroRows(h_variable_3304,h_variable_58);
IsZeroMatrix(h_variable_3306);
nrows(h_variable_3305);
def h_variable_3307 = h_variable_282[3,55];
h_variable_3307;
matrix h_variable_3308[1][1] = 0;
matrix h_variable_3309[1][3] = concat(h_variable_3308,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3309); matrix h_variable_3310 = h_variable_l[1]; matrix h_variable_3311 = h_variable_l[2];
ncols(h_variable_3310);
matrix h_variable_3312 = DecideZeroRows(h_variable_3310,h_variable_58);
IsZeroMatrix(h_variable_3312);
nrows(h_variable_3311);
def h_variable_3313 = h_variable_282[1,55];
h_variable_3313;
matrix h_variable_3314[1][1] = 0;
matrix h_variable_3315[1][3] = concat(h_variable_3314,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3315); matrix h_variable_3316 = h_variable_l[1]; matrix h_variable_3317 = h_variable_l[2];
ncols(h_variable_3316);
matrix h_variable_3318 = DecideZeroRows(h_variable_3316,h_variable_58);
IsZeroMatrix(h_variable_3318);
nrows(h_variable_3317);
def h_variable_3319 = h_variable_282[19,56];
h_variable_3319;
matrix h_variable_3320[1][1] = 0;
matrix h_variable_3321[1][3] = concat(h_variable_3320,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3321); matrix h_variable_3322 = h_variable_l[1]; matrix h_variable_3323 = h_variable_l[2];
ncols(h_variable_3322);
matrix h_variable_3324 = DecideZeroRows(h_variable_3322,h_variable_58);
IsZeroMatrix(h_variable_3324);
nrows(h_variable_3323);
def h_variable_3325 = h_variable_282[3,56];
h_variable_3325;
matrix h_variable_3326[1][1] = 0;
matrix h_variable_3327[1][3] = concat(h_variable_3326,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3327); matrix h_variable_3328 = h_variable_l[1]; matrix h_variable_3329 = h_variable_l[2];
ncols(h_variable_3328);
matrix h_variable_3330 = DecideZeroRows(h_variable_3328,h_variable_58);
IsZeroMatrix(h_variable_3330);
nrows(h_variable_3329);
def h_variable_3331 = h_variable_282[1,56];
h_variable_3331;
matrix h_variable_3332[1][1] = 0;
matrix h_variable_3333[1][3] = concat(h_variable_3332,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3333); matrix h_variable_3334 = h_variable_l[1]; matrix h_variable_3335 = h_variable_l[2];
ncols(h_variable_3334);
matrix h_variable_3336 = DecideZeroRows(h_variable_3334,h_variable_58);
IsZeroMatrix(h_variable_3336);
nrows(h_variable_3335);
def h_variable_3337 = h_variable_282[19,57];
h_variable_3337;
matrix h_variable_3338[1][1] = 0;
matrix h_variable_3339[1][3] = concat(h_variable_3338,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3339); matrix h_variable_3340 = h_variable_l[1]; matrix h_variable_3341 = h_variable_l[2];
ncols(h_variable_3340);
matrix h_variable_3342 = DecideZeroRows(h_variable_3340,h_variable_58);
IsZeroMatrix(h_variable_3342);
nrows(h_variable_3341);
def h_variable_3343 = h_variable_282[3,57];
h_variable_3343;
matrix h_variable_3344[1][1] = 0;
matrix h_variable_3345[1][3] = concat(h_variable_3344,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3345); matrix h_variable_3346 = h_variable_l[1]; matrix h_variable_3347 = h_variable_l[2];
ncols(h_variable_3346);
matrix h_variable_3348 = DecideZeroRows(h_variable_3346,h_variable_58);
IsZeroMatrix(h_variable_3348);
nrows(h_variable_3347);
def h_variable_3349 = h_variable_282[1,57];
h_variable_3349;
matrix h_variable_3350[1][1] = 0;
matrix h_variable_3351[1][3] = concat(h_variable_3350,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3351); matrix h_variable_3352 = h_variable_l[1]; matrix h_variable_3353 = h_variable_l[2];
ncols(h_variable_3352);
matrix h_variable_3354 = DecideZeroRows(h_variable_3352,h_variable_58);
IsZeroMatrix(h_variable_3354);
nrows(h_variable_3353);
def h_variable_3355 = h_variable_282[19,58];
h_variable_3355;
matrix h_variable_3356[1][1] = 0;
matrix h_variable_3357[1][3] = concat(h_variable_3356,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3357); matrix h_variable_3358 = h_variable_l[1]; matrix h_variable_3359 = h_variable_l[2];
ncols(h_variable_3358);
matrix h_variable_3360 = DecideZeroRows(h_variable_3358,h_variable_58);
IsZeroMatrix(h_variable_3360);
nrows(h_variable_3359);
def h_variable_3361 = h_variable_282[3,58];
h_variable_3361;
matrix h_variable_3362[1][1] = 0;
matrix h_variable_3363[1][3] = concat(h_variable_3362,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3363); matrix h_variable_3364 = h_variable_l[1]; matrix h_variable_3365 = h_variable_l[2];
ncols(h_variable_3364);
matrix h_variable_3366 = DecideZeroRows(h_variable_3364,h_variable_58);
IsZeroMatrix(h_variable_3366);
nrows(h_variable_3365);
def h_variable_3367 = h_variable_282[1,58];
h_variable_3367;
matrix h_variable_3368[1][1] = 0;
matrix h_variable_3369[1][3] = concat(h_variable_3368,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3369); matrix h_variable_3370 = h_variable_l[1]; matrix h_variable_3371 = h_variable_l[2];
ncols(h_variable_3370);
matrix h_variable_3372 = DecideZeroRows(h_variable_3370,h_variable_58);
IsZeroMatrix(h_variable_3372);
nrows(h_variable_3371);
def h_variable_3373 = h_variable_282[19,59];
h_variable_3373;
matrix h_variable_3374[1][1] = 2*a7-4;
matrix h_variable_3375[1][3] = concat(h_variable_3374,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3375); matrix h_variable_3376 = h_variable_l[1]; matrix h_variable_3377 = h_variable_l[2];
ncols(h_variable_3376);
matrix h_variable_3378 = DecideZeroRows(h_variable_3376,h_variable_58);
IsZeroMatrix(h_variable_3378);
ZeroRows(h_variable_3378);
nrows(h_variable_3377);
matrix h_variable_3380 = submat(h_variable_3376,1..1,intvec( 2 ));
matrix h_variable_3379 = DecideZeroRows(h_variable_3380,h_variable_58);
IsZeroMatrix(h_variable_3379);
IsIdentityMatrix(h_variable_3379);
matrix h_variable_3381[1][3] = concat(h_variable_3379,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_3381); matrix h_variable_3382 = h_variable_l[1]; matrix h_variable_3383 = h_variable_l[2];
IsZeroMatrix(h_variable_3382);
matrix h_variable_3384 = DecideZeroRows(h_variable_3382,h_variable_58);
IsZeroMatrix(h_variable_3384);
def h_variable_3385 = h_variable_282[3,59];
h_variable_3385;
matrix h_variable_3386[1][1] = 0;
matrix h_variable_3387[1][3] = concat(h_variable_3386,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3387); matrix h_variable_3388 = h_variable_l[1]; matrix h_variable_3389 = h_variable_l[2];
ncols(h_variable_3388);
matrix h_variable_3390 = DecideZeroRows(h_variable_3388,h_variable_58);
IsZeroMatrix(h_variable_3390);
nrows(h_variable_3389);
def h_variable_3391 = h_variable_282[1,59];
h_variable_3391;
matrix h_variable_3392[1][1] = 0;
matrix h_variable_3393[1][3] = concat(h_variable_3392,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3393); matrix h_variable_3394 = h_variable_l[1]; matrix h_variable_3395 = h_variable_l[2];
ncols(h_variable_3394);
matrix h_variable_3396 = DecideZeroRows(h_variable_3394,h_variable_58);
IsZeroMatrix(h_variable_3396);
nrows(h_variable_3395);
def h_variable_3397 = h_variable_282[19,60];
h_variable_3397;
matrix h_variable_3398[1][1] = -5*a7+2;
matrix h_variable_3399[1][3] = concat(h_variable_3398,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3399); matrix h_variable_3400 = h_variable_l[1]; matrix h_variable_3401 = h_variable_l[2];
ncols(h_variable_3400);
matrix h_variable_3402 = DecideZeroRows(h_variable_3400,h_variable_58);
IsZeroMatrix(h_variable_3402);
nrows(h_variable_3401);
IsIdentityMatrix(h_variable_3402);
def h_variable_3403 = h_variable_282[1,60];
h_variable_3403;
matrix h_variable_3404[1][1] = 0;
matrix h_variable_3405 = DecideZeroRows(h_variable_3404,h_variable_58);
IsZeroMatrix(h_variable_3405);
def h_variable_3406 = h_variable_3405[1,1];
h_variable_3406==0;
def h_variable_3407 = h_variable_282[3,60];
h_variable_3407;
matrix h_variable_3408[1][1] = 0;
matrix h_variable_3409 = DecideZeroRows(h_variable_3408,h_variable_58);
IsZeroMatrix(h_variable_3409);
def h_variable_3410 = h_variable_3409[1,1];
h_variable_3410==0;
def h_variable_3411 = h_variable_282[19,60];
h_variable_3411;
matrix h_variable_3412[1][1] = -5*a7+2;
matrix h_variable_3413 = DecideZeroRows(h_variable_3412,h_variable_58);
IsZeroMatrix(h_variable_3413);
def h_variable_3414 = h_variable_3413[1,1];
h_variable_3414==0;
def h_variable_3415 = h_variable_282[3,61];
h_variable_3415;
matrix h_variable_3416[1][1] = 0;
matrix h_variable_3417[1][3] = concat(h_variable_3416,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3417); matrix h_variable_3418 = h_variable_l[1]; matrix h_variable_3419 = h_variable_l[2];
ncols(h_variable_3418);
matrix h_variable_3420 = DecideZeroRows(h_variable_3418,h_variable_58);
IsZeroMatrix(h_variable_3420);
nrows(h_variable_3419);
def h_variable_3421 = h_variable_282[1,61];
h_variable_3421;
matrix h_variable_3422[1][1] = 0;
matrix h_variable_3423[1][3] = concat(h_variable_3422,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3423); matrix h_variable_3424 = h_variable_l[1]; matrix h_variable_3425 = h_variable_l[2];
ncols(h_variable_3424);
matrix h_variable_3426 = DecideZeroRows(h_variable_3424,h_variable_58);
IsZeroMatrix(h_variable_3426);
nrows(h_variable_3425);
def h_variable_3427 = h_variable_282[3,62];
h_variable_3427;
matrix h_variable_3428[1][1] = 0;
matrix h_variable_3429[1][3] = concat(h_variable_3428,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3429); matrix h_variable_3430 = h_variable_l[1]; matrix h_variable_3431 = h_variable_l[2];
ncols(h_variable_3430);
matrix h_variable_3432 = DecideZeroRows(h_variable_3430,h_variable_58);
IsZeroMatrix(h_variable_3432);
nrows(h_variable_3431);
def h_variable_3433 = h_variable_282[1,62];
h_variable_3433;
matrix h_variable_3434[1][1] = 0;
matrix h_variable_3435[1][3] = concat(h_variable_3434,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3435); matrix h_variable_3436 = h_variable_l[1]; matrix h_variable_3437 = h_variable_l[2];
ncols(h_variable_3436);
matrix h_variable_3438 = DecideZeroRows(h_variable_3436,h_variable_58);
IsZeroMatrix(h_variable_3438);
nrows(h_variable_3437);
def h_variable_3439 = h_variable_282[3,63];
h_variable_3439;
matrix h_variable_3440[1][1] = 0;
matrix h_variable_3441[1][3] = concat(h_variable_3440,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3441); matrix h_variable_3442 = h_variable_l[1]; matrix h_variable_3443 = h_variable_l[2];
ncols(h_variable_3442);
matrix h_variable_3444 = DecideZeroRows(h_variable_3442,h_variable_58);
IsZeroMatrix(h_variable_3444);
nrows(h_variable_3443);
def h_variable_3445 = h_variable_282[1,63];
h_variable_3445;
matrix h_variable_3446[1][1] = 0;
matrix h_variable_3447[1][3] = concat(h_variable_3446,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3447); matrix h_variable_3448 = h_variable_l[1]; matrix h_variable_3449 = h_variable_l[2];
ncols(h_variable_3448);
matrix h_variable_3450 = DecideZeroRows(h_variable_3448,h_variable_58);
IsZeroMatrix(h_variable_3450);
nrows(h_variable_3449);
def h_variable_3451 = h_variable_282[3,64];
h_variable_3451;
matrix h_variable_3452[1][1] = 0;
matrix h_variable_3453[1][3] = concat(h_variable_3452,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3453); matrix h_variable_3454 = h_variable_l[1]; matrix h_variable_3455 = h_variable_l[2];
ncols(h_variable_3454);
matrix h_variable_3456 = DecideZeroRows(h_variable_3454,h_variable_58);
IsZeroMatrix(h_variable_3456);
nrows(h_variable_3455);
def h_variable_3457 = h_variable_282[1,64];
h_variable_3457;
matrix h_variable_3458[1][1] = 0;
matrix h_variable_3459[1][3] = concat(h_variable_3458,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3459); matrix h_variable_3460 = h_variable_l[1]; matrix h_variable_3461 = h_variable_l[2];
ncols(h_variable_3460);
matrix h_variable_3462 = DecideZeroRows(h_variable_3460,h_variable_58);
IsZeroMatrix(h_variable_3462);
nrows(h_variable_3461);
def h_variable_3463 = h_variable_282[3,65];
h_variable_3463;
matrix h_variable_3464[1][1] = 0;
matrix h_variable_3465[1][3] = concat(h_variable_3464,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3465); matrix h_variable_3466 = h_variable_l[1]; matrix h_variable_3467 = h_variable_l[2];
ncols(h_variable_3466);
matrix h_variable_3468 = DecideZeroRows(h_variable_3466,h_variable_58);
IsZeroMatrix(h_variable_3468);
nrows(h_variable_3467);
def h_variable_3469 = h_variable_282[1,65];
h_variable_3469;
matrix h_variable_3470[1][1] = 0;
matrix h_variable_3471[1][3] = concat(h_variable_3470,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3471); matrix h_variable_3472 = h_variable_l[1]; matrix h_variable_3473 = h_variable_l[2];
ncols(h_variable_3472);
matrix h_variable_3474 = DecideZeroRows(h_variable_3472,h_variable_58);
IsZeroMatrix(h_variable_3474);
nrows(h_variable_3473);
def h_variable_3475 = h_variable_282[3,66];
h_variable_3475;
matrix h_variable_3476[1][1] = 0;
matrix h_variable_3477[1][3] = concat(h_variable_3476,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3477); matrix h_variable_3478 = h_variable_l[1]; matrix h_variable_3479 = h_variable_l[2];
ncols(h_variable_3478);
matrix h_variable_3480 = DecideZeroRows(h_variable_3478,h_variable_58);
IsZeroMatrix(h_variable_3480);
nrows(h_variable_3479);
def h_variable_3481 = h_variable_282[1,66];
h_variable_3481;
matrix h_variable_3482[1][1] = 0;
matrix h_variable_3483[1][3] = concat(h_variable_3482,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3483); matrix h_variable_3484 = h_variable_l[1]; matrix h_variable_3485 = h_variable_l[2];
ncols(h_variable_3484);
matrix h_variable_3486 = DecideZeroRows(h_variable_3484,h_variable_58);
IsZeroMatrix(h_variable_3486);
nrows(h_variable_3485);
def h_variable_3487 = h_variable_282[3,67];
h_variable_3487;
matrix h_variable_3488[1][1] = 0;
matrix h_variable_3489[1][3] = concat(h_variable_3488,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3489); matrix h_variable_3490 = h_variable_l[1]; matrix h_variable_3491 = h_variable_l[2];
ncols(h_variable_3490);
matrix h_variable_3492 = DecideZeroRows(h_variable_3490,h_variable_58);
IsZeroMatrix(h_variable_3492);
nrows(h_variable_3491);
def h_variable_3493 = h_variable_282[1,67];
h_variable_3493;
matrix h_variable_3494[1][1] = 0;
matrix h_variable_3495[1][3] = concat(h_variable_3494,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3495); matrix h_variable_3496 = h_variable_l[1]; matrix h_variable_3497 = h_variable_l[2];
ncols(h_variable_3496);
matrix h_variable_3498 = DecideZeroRows(h_variable_3496,h_variable_58);
IsZeroMatrix(h_variable_3498);
nrows(h_variable_3497);
def h_variable_3499 = h_variable_282[3,68];
h_variable_3499;
matrix h_variable_3500[1][1] = 0;
kill h_variable_2910;kill h_variable_2912;kill h_variable_2913;kill h_variable_2914;kill h_variable_2915;kill h_variable_2916;kill h_variable_2918;kill h_variable_2919;kill h_variable_2920;kill h_variable_2921;kill h_variable_2922;kill h_variable_2923;kill h_variable_2924;kill h_variable_2925;kill h_variable_2926;kill h_variable_2927;kill h_variable_2928;kill h_variable_2929;kill h_variable_2930;kill h_variable_2931;kill h_variable_2932;kill h_variable_2933;kill h_variable_2934;kill h_variable_2935;kill h_variable_2936;kill h_variable_2937;kill h_variable_2938;kill h_variable_2939;kill h_variable_2940;kill h_variable_2941;kill h_variable_2942;kill h_variable_2943;kill h_variable_2944;kill h_variable_2945;kill h_variable_2946;kill h_variable_2947;kill h_variable_2948;kill h_variable_2949;kill h_variable_2950;kill h_variable_2951;kill h_variable_2952;kill h_variable_2953;kill h_variable_2954;kill h_variable_2955;kill h_variable_2956;kill h_variable_2957;kill h_variable_2958;kill h_variable_2959;kill h_variable_2960;kill h_variable_2961;kill h_variable_2962;kill h_variable_2963;kill h_variable_2964;kill h_variable_2965;kill h_variable_2966;kill h_variable_2967;kill h_variable_2968;kill h_variable_2969;kill h_variable_2970;kill h_variable_2971;kill h_variable_2972;kill h_variable_2973;kill h_variable_2974;kill h_variable_2975;kill h_variable_2976;kill h_variable_2977;kill h_variable_2978;kill h_variable_2979;kill h_variable_2980;kill h_variable_2981;kill h_variable_2982;kill h_variable_2983;kill h_variable_2984;kill h_variable_2985;kill h_variable_2986;kill h_variable_2987;kill h_variable_2988;kill h_variable_2989;kill h_variable_2990;kill h_variable_2991;kill h_variable_2992;kill h_variable_2993;kill h_variable_2994;kill h_variable_2995;kill h_variable_2996;kill h_variable_2997;kill h_variable_2998;kill h_variable_2999;kill h_variable_3000;kill h_variable_3001;kill h_variable_3002;kill h_variable_3003;kill h_variable_3004;kill h_variable_3005;kill h_variable_3006;kill h_variable_3007;kill h_variable_3008;kill h_variable_3009;kill h_variable_3010;kill h_variable_3011;kill h_variable_3012;kill h_variable_3013;kill h_variable_3014;kill h_variable_3015;kill h_variable_3016;kill h_variable_3017;kill h_variable_3018;kill h_variable_3019;kill h_variable_3020;kill h_variable_3021;kill h_variable_3022;kill h_variable_3023;kill h_variable_3024;kill h_variable_3025;kill h_variable_3026;kill h_variable_3027;kill h_variable_3028;kill h_variable_3029;kill h_variable_3030;kill h_variable_3036;kill h_variable_3039;kill h_variable_3040;kill h_variable_3041;kill h_variable_3042;kill h_variable_3044;kill h_variable_3045;kill h_variable_3046;kill h_variable_3047;kill h_variable_3048;kill h_variable_3050;kill h_variable_3051;kill h_variable_3052;kill h_variable_3053;kill h_variable_3054;kill h_variable_3055;kill h_variable_3056;kill h_variable_3057;kill h_variable_3058;kill h_variable_3059;kill h_variable_3060;kill h_variable_3061;kill h_variable_3062;kill h_variable_3063;kill h_variable_3064;kill h_variable_3065;kill h_variable_3066;kill h_variable_3067;kill h_variable_3068;kill h_variable_3069;kill h_variable_3070;kill h_variable_3071;kill h_variable_3072;kill h_variable_3073;kill h_variable_3074;kill h_variable_3075;kill h_variable_3076;kill h_variable_3077;kill h_variable_3078;kill h_variable_3079;kill h_variable_3080;kill h_variable_3081;kill h_variable_3082;kill h_variable_3083;kill h_variable_3084;kill h_variable_3085;kill h_variable_3086;kill h_variable_3087;kill h_variable_3088;kill h_variable_3089;kill h_variable_3090;kill h_variable_3091;kill h_variable_3092;kill h_variable_3093;kill h_variable_3094;kill h_variable_3095;kill h_variable_3096;kill h_variable_3097;kill h_variable_3098;kill h_variable_3099;kill h_variable_3100;kill h_variable_3101;kill h_variable_3102;kill h_variable_3103;kill h_variable_3104;kill h_variable_3105;kill h_variable_3106;kill h_variable_3107;kill h_variable_3108;kill h_variable_3109;kill h_variable_3110;kill h_variable_3111;kill h_variable_3112;kill h_variable_3113;kill h_variable_3114;kill h_variable_3115;kill h_variable_3116;kill h_variable_3117;kill h_variable_3118;kill h_variable_3119;kill h_variable_3120;kill h_variable_3121;kill h_variable_3122;kill h_variable_3123;kill h_variable_3124;kill h_variable_3125;kill h_variable_3126;kill h_variable_3127;kill h_variable_3128;kill h_variable_3129;kill h_variable_3130;kill h_variable_3131;kill h_variable_3132;kill h_variable_3133;kill h_variable_3134;kill h_variable_3135;kill h_variable_3136;kill h_variable_3137;kill h_variable_3138;kill h_variable_3139;kill h_variable_3140;kill h_variable_3141;kill h_variable_3142;kill h_variable_3143;kill h_variable_3144;kill h_variable_3145;kill h_variable_3146;kill h_variable_3147;kill h_variable_3148;kill h_variable_3149;kill h_variable_3150;kill h_variable_3151;kill h_variable_3152;kill h_variable_3153;kill h_variable_3154;kill h_variable_3155;kill h_variable_3156;kill h_variable_3157;kill h_variable_3158;kill h_variable_3159;kill h_variable_3160;kill h_variable_3161;kill h_variable_3162;kill h_variable_3163;kill h_variable_3164;kill h_variable_3165;kill h_variable_3166;kill h_variable_3167;kill h_variable_3168;kill h_variable_3169;kill h_variable_3170;kill h_variable_3171;kill h_variable_3172;kill h_variable_3173;kill h_variable_3174;kill h_variable_3175;kill h_variable_3176;kill h_variable_3177;kill h_variable_3178;kill h_variable_3179;kill h_variable_3180;kill h_variable_3181;kill h_variable_3182;kill h_variable_3183;kill h_variable_3184;kill h_variable_3185;kill h_variable_3186;kill h_variable_3187;kill h_variable_3188;kill h_variable_3189;kill h_variable_3190;kill h_variable_3191;kill h_variable_3192;kill h_variable_3193;kill h_variable_3194;kill h_variable_3195;kill h_variable_3196;kill h_variable_3197;kill h_variable_3198;kill h_variable_3199;kill h_variable_3200;kill h_variable_3201;kill h_variable_3202;kill h_variable_3203;kill h_variable_3204;kill h_variable_3205;kill h_variable_3206;kill h_variable_3207;kill h_variable_3208;kill h_variable_3209;kill h_variable_3210;kill h_variable_3211;kill h_variable_3212;kill h_variable_3213;kill h_variable_3214;kill h_variable_3215;kill h_variable_3216;kill h_variable_3217;kill h_variable_3218;kill h_variable_3219;kill h_variable_3220;kill h_variable_3221;kill h_variable_3222;kill h_variable_3225;kill h_variable_3226;kill h_variable_3227;kill h_variable_3228;kill h_variable_3231;kill h_variable_3232;kill h_variable_3233;kill h_variable_3234;kill h_variable_3236;kill h_variable_3237;kill h_variable_3238;kill h_variable_3239;kill h_variable_3240;kill h_variable_3242;kill h_variable_3246;kill h_variable_3248;kill h_variable_3249;kill h_variable_3250;kill h_variable_3251;kill h_variable_3252;kill h_variable_3253;kill h_variable_3254;kill h_variable_3255;kill h_variable_3256;kill h_variable_3257;kill h_variable_3258;kill h_variable_3259;kill h_variable_3260;kill h_variable_3261;kill h_variable_3262;kill h_variable_3263;kill h_variable_3264;kill h_variable_3265;kill h_variable_3266;kill h_variable_3267;kill h_variable_3268;kill h_variable_3269;kill h_variable_3270;kill h_variable_3271;kill h_variable_3272;kill h_variable_3273;kill h_variable_3274;kill h_variable_3275;kill h_variable_3276;kill h_variable_3277;kill h_variable_3278;kill h_variable_3279;kill h_variable_3280;kill h_variable_3281;kill h_variable_3282;kill h_variable_3283;kill h_variable_3284;kill h_variable_3285;kill h_variable_3286;kill h_variable_3287;kill h_variable_3288;kill h_variable_3289;kill h_variable_3290;kill h_variable_3291;kill h_variable_3292;kill h_variable_3293;kill h_variable_3294;kill h_variable_3295;kill h_variable_3296;kill h_variable_3297;kill h_variable_3298;kill h_variable_3299;kill h_variable_3300;kill h_variable_3301;kill h_variable_3302;kill h_variable_3303;kill h_variable_3304;kill h_variable_3305;kill h_variable_3306;kill h_variable_3307;kill h_variable_3308;kill h_variable_3309;kill h_variable_3310;kill h_variable_3311;kill h_variable_3312;kill h_variable_3313;kill h_variable_3314;kill h_variable_3315;kill h_variable_3316;kill h_variable_3317;kill h_variable_3318;kill h_variable_3319;kill h_variable_3320;kill h_variable_3321;kill h_variable_3322;kill h_variable_3323;kill h_variable_3324;kill h_variable_3325;kill h_variable_3326;kill h_variable_3327;kill h_variable_3328;kill h_variable_3329;kill h_variable_3330;kill h_variable_3331;kill h_variable_3332;kill h_variable_3333;kill h_variable_3334;kill h_variable_3335;kill h_variable_3336;kill h_variable_3337;kill h_variable_3338;kill h_variable_3339;kill h_variable_3340;kill h_variable_3341;kill h_variable_3342;kill h_variable_3343;kill h_variable_3344;kill h_variable_3345;kill h_variable_3346;kill h_variable_3347;kill h_variable_3348;kill h_variable_3349;kill h_variable_3350;kill h_variable_3351;kill h_variable_3352;kill h_variable_3353;kill h_variable_3354;kill h_variable_3355;kill h_variable_3356;kill h_variable_3357;kill h_variable_3358;kill h_variable_3359;kill h_variable_3360;kill h_variable_3361;kill h_variable_3362;kill h_variable_3363;kill h_variable_3364;kill h_variable_3365;kill h_variable_3366;kill h_variable_3367;kill h_variable_3368;kill h_variable_3369;kill h_variable_3370;kill h_variable_3371;kill h_variable_3372;kill h_variable_3373;kill h_variable_3374;kill h_variable_3375;kill h_variable_3376;kill h_variable_3377;kill h_variable_3378;kill h_variable_3379;kill h_variable_3380;kill h_variable_3381;kill h_variable_3382;kill h_variable_3383;kill h_variable_3384;kill h_variable_3385;kill h_variable_3386;kill h_variable_3387;kill h_variable_3388;kill h_variable_3389;kill h_variable_3390;kill h_variable_3391;kill h_variable_3392;kill h_variable_3393;kill h_variable_3394;kill h_variable_3395;kill h_variable_3396;kill h_variable_3397;kill h_variable_3398;kill h_variable_3399;kill h_variable_3400;kill h_variable_3401;kill h_variable_3402;kill h_variable_3403;kill h_variable_3404;kill h_variable_3405;kill h_variable_3406;kill h_variable_3407;kill h_variable_3408;kill h_variable_3409;kill h_variable_3410;kill h_variable_3411;kill h_variable_3412;kill h_variable_3413;kill h_variable_3414;kill h_variable_3415;kill h_variable_3416;kill h_variable_3417;kill h_variable_3418;kill h_variable_3419;kill h_variable_3420;kill h_variable_3421;kill h_variable_3422;kill h_variable_3423;kill h_variable_3424;kill h_variable_3425;kill h_variable_3426;kill h_variable_3429;kill h_variable_3430;kill h_variable_3431;kill h_variable_3432;
matrix h_variable_3501[1][3] = concat(h_variable_3500,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3501); matrix h_variable_3502 = h_variable_l[1]; matrix h_variable_3503 = h_variable_l[2];
ncols(h_variable_3502);
matrix h_variable_3504 = DecideZeroRows(h_variable_3502,h_variable_58);
IsZeroMatrix(h_variable_3504);
nrows(h_variable_3503);
def h_variable_3505 = h_variable_282[1,68];
h_variable_3505;
matrix h_variable_3506[1][1] = 0;
matrix h_variable_3507[1][3] = concat(h_variable_3506,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3507); matrix h_variable_3508 = h_variable_l[1]; matrix h_variable_3509 = h_variable_l[2];
ncols(h_variable_3508);
matrix h_variable_3510 = DecideZeroRows(h_variable_3508,h_variable_58);
IsZeroMatrix(h_variable_3510);
nrows(h_variable_3509);
def h_variable_3511 = h_variable_282[3,69];
h_variable_3511;
matrix h_variable_3512[1][1] = 0;
matrix h_variable_3513[1][3] = concat(h_variable_3512,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3513); matrix h_variable_3514 = h_variable_l[1]; matrix h_variable_3515 = h_variable_l[2];
ncols(h_variable_3514);
matrix h_variable_3516 = DecideZeroRows(h_variable_3514,h_variable_58);
IsZeroMatrix(h_variable_3516);
nrows(h_variable_3515);
def h_variable_3517 = h_variable_282[1,69];
h_variable_3517;
matrix h_variable_3518[1][1] = 0;
matrix h_variable_3519[1][3] = concat(h_variable_3518,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3519); matrix h_variable_3520 = h_variable_l[1]; matrix h_variable_3521 = h_variable_l[2];
ncols(h_variable_3520);
matrix h_variable_3522 = DecideZeroRows(h_variable_3520,h_variable_58);
IsZeroMatrix(h_variable_3522);
nrows(h_variable_3521);
def h_variable_3523 = h_variable_282[3,70];
h_variable_3523;
matrix h_variable_3524[1][1] = 0;
matrix h_variable_3525[1][3] = concat(h_variable_3524,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3525); matrix h_variable_3526 = h_variable_l[1]; matrix h_variable_3527 = h_variable_l[2];
ncols(h_variable_3526);
matrix h_variable_3528 = DecideZeroRows(h_variable_3526,h_variable_58);
IsZeroMatrix(h_variable_3528);
nrows(h_variable_3527);
def h_variable_3529 = h_variable_282[1,70];
h_variable_3529;
matrix h_variable_3530[1][1] = 0;
matrix h_variable_3531[1][3] = concat(h_variable_3530,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3531); matrix h_variable_3532 = h_variable_l[1]; matrix h_variable_3533 = h_variable_l[2];
ncols(h_variable_3532);
matrix h_variable_3534 = DecideZeroRows(h_variable_3532,h_variable_58);
IsZeroMatrix(h_variable_3534);
nrows(h_variable_3533);
def h_variable_3535 = h_variable_282[3,71];
h_variable_3535;
matrix h_variable_3536[1][1] = 0;
matrix h_variable_3537[1][3] = concat(h_variable_3536,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3537); matrix h_variable_3538 = h_variable_l[1]; matrix h_variable_3539 = h_variable_l[2];
ncols(h_variable_3538);
matrix h_variable_3540 = DecideZeroRows(h_variable_3538,h_variable_58);
IsZeroMatrix(h_variable_3540);
nrows(h_variable_3539);
def h_variable_3541 = h_variable_282[1,71];
h_variable_3541;
matrix h_variable_3542[1][1] = 0;
matrix h_variable_3543[1][3] = concat(h_variable_3542,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3543); matrix h_variable_3544 = h_variable_l[1]; matrix h_variable_3545 = h_variable_l[2];
ncols(h_variable_3544);
matrix h_variable_3546 = DecideZeroRows(h_variable_3544,h_variable_58);
IsZeroMatrix(h_variable_3546);
nrows(h_variable_3545);
def h_variable_3547 = h_variable_282[3,72];
h_variable_3547;
matrix h_variable_3548[1][1] = 0;
matrix h_variable_3549[1][3] = concat(h_variable_3548,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3549); matrix h_variable_3550 = h_variable_l[1]; matrix h_variable_3551 = h_variable_l[2];
ncols(h_variable_3550);
matrix h_variable_3552 = DecideZeroRows(h_variable_3550,h_variable_58);
IsZeroMatrix(h_variable_3552);
nrows(h_variable_3551);
def h_variable_3553 = h_variable_282[1,72];
h_variable_3553;
matrix h_variable_3554[1][1] = 0;
matrix h_variable_3555[1][3] = concat(h_variable_3554,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3555); matrix h_variable_3556 = h_variable_l[1]; matrix h_variable_3557 = h_variable_l[2];
ncols(h_variable_3556);
matrix h_variable_3558 = DecideZeroRows(h_variable_3556,h_variable_58);
IsZeroMatrix(h_variable_3558);
nrows(h_variable_3557);
def h_variable_3559 = h_variable_282[3,73];
h_variable_3559;
matrix h_variable_3560[1][1] = 0;
matrix h_variable_3561[1][3] = concat(h_variable_3560,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3561); matrix h_variable_3562 = h_variable_l[1]; matrix h_variable_3563 = h_variable_l[2];
ncols(h_variable_3562);
matrix h_variable_3564 = DecideZeroRows(h_variable_3562,h_variable_58);
IsZeroMatrix(h_variable_3564);
nrows(h_variable_3563);
def h_variable_3565 = h_variable_282[1,73];
h_variable_3565;
matrix h_variable_3566[1][1] = 0;
matrix h_variable_3567[1][3] = concat(h_variable_3566,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3567); matrix h_variable_3568 = h_variable_l[1]; matrix h_variable_3569 = h_variable_l[2];
ncols(h_variable_3568);
matrix h_variable_3570 = DecideZeroRows(h_variable_3568,h_variable_58);
IsZeroMatrix(h_variable_3570);
nrows(h_variable_3569);
def h_variable_3571 = h_variable_282[3,74];
h_variable_3571;
matrix h_variable_3572[1][1] = 0;
matrix h_variable_3573[1][3] = concat(h_variable_3572,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3573); matrix h_variable_3574 = h_variable_l[1]; matrix h_variable_3575 = h_variable_l[2];
ncols(h_variable_3574);
matrix h_variable_3576 = DecideZeroRows(h_variable_3574,h_variable_58);
IsZeroMatrix(h_variable_3576);
nrows(h_variable_3575);
def h_variable_3577 = h_variable_282[1,74];
h_variable_3577;
matrix h_variable_3578[1][1] = 0;
matrix h_variable_3579[1][3] = concat(h_variable_3578,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3579); matrix h_variable_3580 = h_variable_l[1]; matrix h_variable_3581 = h_variable_l[2];
ncols(h_variable_3580);
matrix h_variable_3582 = DecideZeroRows(h_variable_3580,h_variable_58);
IsZeroMatrix(h_variable_3582);
nrows(h_variable_3581);
def h_variable_3583 = h_variable_282[3,75];
h_variable_3583;
matrix h_variable_3584[1][1] = 0;
matrix h_variable_3585[1][3] = concat(h_variable_3584,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3585); matrix h_variable_3586 = h_variable_l[1]; matrix h_variable_3587 = h_variable_l[2];
ncols(h_variable_3586);
matrix h_variable_3588 = DecideZeroRows(h_variable_3586,h_variable_58);
IsZeroMatrix(h_variable_3588);
nrows(h_variable_3587);
def h_variable_3589 = h_variable_282[1,75];
h_variable_3589;
matrix h_variable_3590[1][1] = 0;
matrix h_variable_3591[1][3] = concat(h_variable_3590,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3591); matrix h_variable_3592 = h_variable_l[1]; matrix h_variable_3593 = h_variable_l[2];
ncols(h_variable_3592);
matrix h_variable_3594 = DecideZeroRows(h_variable_3592,h_variable_58);
IsZeroMatrix(h_variable_3594);
nrows(h_variable_3593);
def h_variable_3595 = h_variable_282[3,76];
h_variable_3595;
matrix h_variable_3596[1][1] = 0;
matrix h_variable_3597[1][3] = concat(h_variable_3596,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3597); matrix h_variable_3598 = h_variable_l[1]; matrix h_variable_3599 = h_variable_l[2];
ncols(h_variable_3598);
matrix h_variable_3600 = DecideZeroRows(h_variable_3598,h_variable_58);
IsZeroMatrix(h_variable_3600);
nrows(h_variable_3599);
def h_variable_3601 = h_variable_282[1,76];
h_variable_3601;
matrix h_variable_3602[1][1] = 0;
matrix h_variable_3603[1][3] = concat(h_variable_3602,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3603); matrix h_variable_3604 = h_variable_l[1]; matrix h_variable_3605 = h_variable_l[2];
ncols(h_variable_3604);
matrix h_variable_3606 = DecideZeroRows(h_variable_3604,h_variable_58);
IsZeroMatrix(h_variable_3606);
nrows(h_variable_3605);
def h_variable_3607 = h_variable_282[3,77];
h_variable_3607;
matrix h_variable_3608[1][1] = 0;
matrix h_variable_3609[1][3] = concat(h_variable_3608,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3609); matrix h_variable_3610 = h_variable_l[1]; matrix h_variable_3611 = h_variable_l[2];
ncols(h_variable_3610);
matrix h_variable_3612 = DecideZeroRows(h_variable_3610,h_variable_58);
IsZeroMatrix(h_variable_3612);
nrows(h_variable_3611);
def h_variable_3613 = h_variable_282[1,77];
h_variable_3613;
matrix h_variable_3614[1][1] = 0;
matrix h_variable_3615[1][3] = concat(h_variable_3614,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3615); matrix h_variable_3616 = h_variable_l[1]; matrix h_variable_3617 = h_variable_l[2];
ncols(h_variable_3616);
matrix h_variable_3618 = DecideZeroRows(h_variable_3616,h_variable_58);
IsZeroMatrix(h_variable_3618);
nrows(h_variable_3617);
def h_variable_3619 = h_variable_282[3,78];
h_variable_3619;
matrix h_variable_3620[1][1] = 0;
matrix h_variable_3621[1][3] = concat(h_variable_3620,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3621); matrix h_variable_3622 = h_variable_l[1]; matrix h_variable_3623 = h_variable_l[2];
ncols(h_variable_3622);
matrix h_variable_3624 = DecideZeroRows(h_variable_3622,h_variable_58);
IsZeroMatrix(h_variable_3624);
nrows(h_variable_3623);
def h_variable_3625 = h_variable_282[1,78];
h_variable_3625;
matrix h_variable_3626[1][1] = 0;
matrix h_variable_3627[1][3] = concat(h_variable_3626,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3627); matrix h_variable_3628 = h_variable_l[1]; matrix h_variable_3629 = h_variable_l[2];
ncols(h_variable_3628);
matrix h_variable_3630 = DecideZeroRows(h_variable_3628,h_variable_58);
IsZeroMatrix(h_variable_3630);
nrows(h_variable_3629);
def h_variable_3631 = h_variable_282[3,79];
h_variable_3631;
matrix h_variable_3632[1][1] = 0;
matrix h_variable_3633[1][3] = concat(h_variable_3632,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3633); matrix h_variable_3634 = h_variable_l[1]; matrix h_variable_3635 = h_variable_l[2];
ncols(h_variable_3634);
matrix h_variable_3636 = DecideZeroRows(h_variable_3634,h_variable_58);
IsZeroMatrix(h_variable_3636);
nrows(h_variable_3635);
def h_variable_3637 = h_variable_282[1,79];
h_variable_3637;
matrix h_variable_3638[1][1] = 0;
matrix h_variable_3639[1][3] = concat(h_variable_3638,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3639); matrix h_variable_3640 = h_variable_l[1]; matrix h_variable_3641 = h_variable_l[2];
ncols(h_variable_3640);
matrix h_variable_3642 = DecideZeroRows(h_variable_3640,h_variable_58);
IsZeroMatrix(h_variable_3642);
nrows(h_variable_3641);
def h_variable_3643 = h_variable_282[3,80];
h_variable_3643;
matrix h_variable_3644[1][1] = 0;
matrix h_variable_3645[1][3] = concat(h_variable_3644,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3645); matrix h_variable_3646 = h_variable_l[1]; matrix h_variable_3647 = h_variable_l[2];
ncols(h_variable_3646);
matrix h_variable_3648 = DecideZeroRows(h_variable_3646,h_variable_58);
IsZeroMatrix(h_variable_3648);
nrows(h_variable_3647);
def h_variable_3649 = h_variable_282[1,80];
h_variable_3649;
matrix h_variable_3650[1][1] = 0;
matrix h_variable_3651[1][3] = concat(h_variable_3650,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3651); matrix h_variable_3652 = h_variable_l[1]; matrix h_variable_3653 = h_variable_l[2];
ncols(h_variable_3652);
matrix h_variable_3654 = DecideZeroRows(h_variable_3652,h_variable_58);
IsZeroMatrix(h_variable_3654);
nrows(h_variable_3653);
def h_variable_3655 = h_variable_282[3,81];
h_variable_3655;
matrix h_variable_3656[1][1] = 0;
matrix h_variable_3657[1][3] = concat(h_variable_3656,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3657); matrix h_variable_3658 = h_variable_l[1]; matrix h_variable_3659 = h_variable_l[2];
ncols(h_variable_3658);
matrix h_variable_3660 = DecideZeroRows(h_variable_3658,h_variable_58);
IsZeroMatrix(h_variable_3660);
nrows(h_variable_3659);
def h_variable_3661 = h_variable_282[1,81];
h_variable_3661;
matrix h_variable_3662[1][1] = 0;
matrix h_variable_3663[1][3] = concat(h_variable_3662,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3663); matrix h_variable_3664 = h_variable_l[1]; matrix h_variable_3665 = h_variable_l[2];
ncols(h_variable_3664);
matrix h_variable_3666 = DecideZeroRows(h_variable_3664,h_variable_58);
IsZeroMatrix(h_variable_3666);
nrows(h_variable_3665);
def h_variable_3667 = h_variable_282[3,82];
h_variable_3667;
matrix h_variable_3668[1][1] = 0;
matrix h_variable_3669[1][3] = concat(h_variable_3668,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3669); matrix h_variable_3670 = h_variable_l[1]; matrix h_variable_3671 = h_variable_l[2];
ncols(h_variable_3670);
matrix h_variable_3672 = DecideZeroRows(h_variable_3670,h_variable_58);
IsZeroMatrix(h_variable_3672);
nrows(h_variable_3671);
def h_variable_3673 = h_variable_282[1,82];
h_variable_3673;
matrix h_variable_3674[1][1] = 0;
matrix h_variable_3675[1][3] = concat(h_variable_3674,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3675); matrix h_variable_3676 = h_variable_l[1]; matrix h_variable_3677 = h_variable_l[2];
ncols(h_variable_3676);
matrix h_variable_3678 = DecideZeroRows(h_variable_3676,h_variable_58);
IsZeroMatrix(h_variable_3678);
nrows(h_variable_3677);
def h_variable_3679 = h_variable_282[3,83];
h_variable_3679;
matrix h_variable_3680[1][1] = 0;
matrix h_variable_3681[1][3] = concat(h_variable_3680,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3681); matrix h_variable_3682 = h_variable_l[1]; matrix h_variable_3683 = h_variable_l[2];
ncols(h_variable_3682);
matrix h_variable_3684 = DecideZeroRows(h_variable_3682,h_variable_58);
IsZeroMatrix(h_variable_3684);
nrows(h_variable_3683);
def h_variable_3685 = h_variable_282[1,83];
h_variable_3685;
matrix h_variable_3686[1][1] = 0;
matrix h_variable_3687[1][3] = concat(h_variable_3686,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3687); matrix h_variable_3688 = h_variable_l[1]; matrix h_variable_3689 = h_variable_l[2];
ncols(h_variable_3688);
matrix h_variable_3690 = DecideZeroRows(h_variable_3688,h_variable_58);
IsZeroMatrix(h_variable_3690);
nrows(h_variable_3689);
def h_variable_3691 = h_variable_282[3,84];
h_variable_3691;
matrix h_variable_3692[1][1] = 0;
matrix h_variable_3693[1][3] = concat(h_variable_3692,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3693); matrix h_variable_3694 = h_variable_l[1]; matrix h_variable_3695 = h_variable_l[2];
ncols(h_variable_3694);
matrix h_variable_3696 = DecideZeroRows(h_variable_3694,h_variable_58);
IsZeroMatrix(h_variable_3696);
nrows(h_variable_3695);
def h_variable_3697 = h_variable_282[1,84];
h_variable_3697;
matrix h_variable_3698[1][1] = 0;
matrix h_variable_3699[1][3] = concat(h_variable_3698,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3699); matrix h_variable_3700 = h_variable_l[1]; matrix h_variable_3701 = h_variable_l[2];
ncols(h_variable_3700);
matrix h_variable_3702 = DecideZeroRows(h_variable_3700,h_variable_58);
IsZeroMatrix(h_variable_3702);
nrows(h_variable_3701);
def h_variable_3703 = h_variable_282[3,85];
h_variable_3703;
matrix h_variable_3704[1][1] = 0;
matrix h_variable_3705[1][3] = concat(h_variable_3704,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3705); matrix h_variable_3706 = h_variable_l[1]; matrix h_variable_3707 = h_variable_l[2];
ncols(h_variable_3706);
matrix h_variable_3708 = DecideZeroRows(h_variable_3706,h_variable_58);
IsZeroMatrix(h_variable_3708);
nrows(h_variable_3707);
def h_variable_3709 = h_variable_282[1,85];
h_variable_3709;
matrix h_variable_3710[1][1] = 0;
matrix h_variable_3711[1][3] = concat(h_variable_3710,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3711); matrix h_variable_3712 = h_variable_l[1]; matrix h_variable_3713 = h_variable_l[2];
ncols(h_variable_3712);
matrix h_variable_3714 = DecideZeroRows(h_variable_3712,h_variable_58);
IsZeroMatrix(h_variable_3714);
nrows(h_variable_3713);
def h_variable_3715 = h_variable_282[3,86];
h_variable_3715;
matrix h_variable_3716[1][1] = 0;
matrix h_variable_3717[1][3] = concat(h_variable_3716,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3717); matrix h_variable_3718 = h_variable_l[1]; matrix h_variable_3719 = h_variable_l[2];
ncols(h_variable_3718);
matrix h_variable_3720 = DecideZeroRows(h_variable_3718,h_variable_58);
IsZeroMatrix(h_variable_3720);
nrows(h_variable_3719);
def h_variable_3721 = h_variable_282[1,86];
h_variable_3721;
matrix h_variable_3722[1][1] = 0;
matrix h_variable_3723[1][3] = concat(h_variable_3722,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3723); matrix h_variable_3724 = h_variable_l[1]; matrix h_variable_3725 = h_variable_l[2];
ncols(h_variable_3724);
matrix h_variable_3726 = DecideZeroRows(h_variable_3724,h_variable_58);
IsZeroMatrix(h_variable_3726);
nrows(h_variable_3725);
def h_variable_3727 = h_variable_282[3,87];
h_variable_3727;
matrix h_variable_3728[1][1] = 0;
matrix h_variable_3729[1][3] = concat(h_variable_3728,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3729); matrix h_variable_3730 = h_variable_l[1]; matrix h_variable_3731 = h_variable_l[2];
ncols(h_variable_3730);
matrix h_variable_3732 = DecideZeroRows(h_variable_3730,h_variable_58);
IsZeroMatrix(h_variable_3732);
nrows(h_variable_3731);
def h_variable_3733 = h_variable_282[1,87];
h_variable_3733;
matrix h_variable_3734[1][1] = 0;
matrix h_variable_3735[1][3] = concat(h_variable_3734,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3735); matrix h_variable_3736 = h_variable_l[1]; matrix h_variable_3737 = h_variable_l[2];
ncols(h_variable_3736);
matrix h_variable_3738 = DecideZeroRows(h_variable_3736,h_variable_58);
IsZeroMatrix(h_variable_3738);
nrows(h_variable_3737);
def h_variable_3739 = h_variable_282[3,88];
h_variable_3739;
matrix h_variable_3740[1][1] = 0;
matrix h_variable_3741[1][3] = concat(h_variable_3740,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3741); matrix h_variable_3742 = h_variable_l[1]; matrix h_variable_3743 = h_variable_l[2];
ncols(h_variable_3742);
matrix h_variable_3744 = DecideZeroRows(h_variable_3742,h_variable_58);
IsZeroMatrix(h_variable_3744);
nrows(h_variable_3743);
def h_variable_3745 = h_variable_282[1,88];
h_variable_3745;
matrix h_variable_3746[1][1] = 0;
matrix h_variable_3747[1][3] = concat(h_variable_3746,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3747); matrix h_variable_3748 = h_variable_l[1]; matrix h_variable_3749 = h_variable_l[2];
ncols(h_variable_3748);
matrix h_variable_3750 = DecideZeroRows(h_variable_3748,h_variable_58);
IsZeroMatrix(h_variable_3750);
nrows(h_variable_3749);
def h_variable_3751 = h_variable_282[3,89];
h_variable_3751;
matrix h_variable_3752[1][1] = 0;
matrix h_variable_3753[1][3] = concat(h_variable_3752,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3753); matrix h_variable_3754 = h_variable_l[1]; matrix h_variable_3755 = h_variable_l[2];
ncols(h_variable_3754);
matrix h_variable_3756 = DecideZeroRows(h_variable_3754,h_variable_58);
IsZeroMatrix(h_variable_3756);
nrows(h_variable_3755);
def h_variable_3757 = h_variable_282[1,89];
h_variable_3757;
matrix h_variable_3758[1][1] = 0;
matrix h_variable_3759[1][3] = concat(h_variable_3758,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3759); matrix h_variable_3760 = h_variable_l[1]; matrix h_variable_3761 = h_variable_l[2];
ncols(h_variable_3760);
matrix h_variable_3762 = DecideZeroRows(h_variable_3760,h_variable_58);
IsZeroMatrix(h_variable_3762);
nrows(h_variable_3761);
def h_variable_3763 = h_variable_282[3,90];
h_variable_3763;
matrix h_variable_3764[1][1] = 0;
matrix h_variable_3765[1][3] = concat(h_variable_3764,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3765); matrix h_variable_3766 = h_variable_l[1]; matrix h_variable_3767 = h_variable_l[2];
ncols(h_variable_3766);
matrix h_variable_3768 = DecideZeroRows(h_variable_3766,h_variable_58);
IsZeroMatrix(h_variable_3768);
nrows(h_variable_3767);
def h_variable_3769 = h_variable_282[1,90];
h_variable_3769;
matrix h_variable_3770[1][1] = 0;
matrix h_variable_3771[1][3] = concat(h_variable_3770,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3771); matrix h_variable_3772 = h_variable_l[1]; matrix h_variable_3773 = h_variable_l[2];
ncols(h_variable_3772);
matrix h_variable_3774 = DecideZeroRows(h_variable_3772,h_variable_58);
IsZeroMatrix(h_variable_3774);
nrows(h_variable_3773);
def h_variable_3775 = h_variable_282[3,91];
h_variable_3775;
matrix h_variable_3776[1][1] = 0;
matrix h_variable_3777[1][3] = concat(h_variable_3776,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3777); matrix h_variable_3778 = h_variable_l[1]; matrix h_variable_3779 = h_variable_l[2];
ncols(h_variable_3778);
matrix h_variable_3780 = DecideZeroRows(h_variable_3778,h_variable_58);
IsZeroMatrix(h_variable_3780);
nrows(h_variable_3779);
def h_variable_3781 = h_variable_282[1,91];
h_variable_3781;
matrix h_variable_3782[1][1] = 0;
matrix h_variable_3783[1][3] = concat(h_variable_3782,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3783); matrix h_variable_3784 = h_variable_l[1]; matrix h_variable_3785 = h_variable_l[2];
ncols(h_variable_3784);
matrix h_variable_3786 = DecideZeroRows(h_variable_3784,h_variable_58);
IsZeroMatrix(h_variable_3786);
nrows(h_variable_3785);
def h_variable_3787 = h_variable_282[3,92];
h_variable_3787;
matrix h_variable_3788[1][1] = 0;
matrix h_variable_3789[1][3] = concat(h_variable_3788,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3789); matrix h_variable_3790 = h_variable_l[1]; matrix h_variable_3791 = h_variable_l[2];
ncols(h_variable_3790);
matrix h_variable_3792 = DecideZeroRows(h_variable_3790,h_variable_58);
IsZeroMatrix(h_variable_3792);
nrows(h_variable_3791);
def h_variable_3793 = h_variable_282[1,92];
h_variable_3793;
matrix h_variable_3794[1][1] = 0;
matrix h_variable_3795[1][3] = concat(h_variable_3794,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3795); matrix h_variable_3796 = h_variable_l[1]; matrix h_variable_3797 = h_variable_l[2];
ncols(h_variable_3796);
matrix h_variable_3798 = DecideZeroRows(h_variable_3796,h_variable_58);
IsZeroMatrix(h_variable_3798);
nrows(h_variable_3797);
def h_variable_3799 = h_variable_282[3,93];
h_variable_3799;
matrix h_variable_3800[1][1] = 0;
matrix h_variable_3801[1][3] = concat(h_variable_3800,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3801); matrix h_variable_3802 = h_variable_l[1]; matrix h_variable_3803 = h_variable_l[2];
ncols(h_variable_3802);
matrix h_variable_3804 = DecideZeroRows(h_variable_3802,h_variable_58);
IsZeroMatrix(h_variable_3804);
nrows(h_variable_3803);
def h_variable_3805 = h_variable_282[1,93];
h_variable_3805;
matrix h_variable_3806[1][1] = 0;
matrix h_variable_3807[1][3] = concat(h_variable_3806,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3807); matrix h_variable_3808 = h_variable_l[1]; matrix h_variable_3809 = h_variable_l[2];
ncols(h_variable_3808);
matrix h_variable_3810 = DecideZeroRows(h_variable_3808,h_variable_58);
IsZeroMatrix(h_variable_3810);
nrows(h_variable_3809);
def h_variable_3811 = h_variable_282[3,94];
h_variable_3811;
matrix h_variable_3812[1][1] = 0;
matrix h_variable_3813[1][3] = concat(h_variable_3812,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3813); matrix h_variable_3814 = h_variable_l[1]; matrix h_variable_3815 = h_variable_l[2];
ncols(h_variable_3814);
matrix h_variable_3816 = DecideZeroRows(h_variable_3814,h_variable_58);
IsZeroMatrix(h_variable_3816);
nrows(h_variable_3815);
def h_variable_3817 = h_variable_282[1,94];
h_variable_3817;
matrix h_variable_3818[1][1] = 0;
matrix h_variable_3819[1][3] = concat(h_variable_3818,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3819); matrix h_variable_3820 = h_variable_l[1]; matrix h_variable_3821 = h_variable_l[2];
ncols(h_variable_3820);
matrix h_variable_3822 = DecideZeroRows(h_variable_3820,h_variable_58);
IsZeroMatrix(h_variable_3822);
nrows(h_variable_3821);
def h_variable_3823 = h_variable_282[3,95];
h_variable_3823;
matrix h_variable_3824[1][1] = 0;
matrix h_variable_3825[1][3] = concat(h_variable_3824,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3825); matrix h_variable_3826 = h_variable_l[1]; matrix h_variable_3827 = h_variable_l[2];
ncols(h_variable_3826);
matrix h_variable_3828 = DecideZeroRows(h_variable_3826,h_variable_58);
IsZeroMatrix(h_variable_3828);
nrows(h_variable_3827);
def h_variable_3829 = h_variable_282[1,95];
h_variable_3829;
matrix h_variable_3830[1][1] = 0;
matrix h_variable_3831[1][3] = concat(h_variable_3830,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3831); matrix h_variable_3832 = h_variable_l[1]; matrix h_variable_3833 = h_variable_l[2];
ncols(h_variable_3832);
matrix h_variable_3834 = DecideZeroRows(h_variable_3832,h_variable_58);
IsZeroMatrix(h_variable_3834);
nrows(h_variable_3833);
def h_variable_3835 = h_variable_282[3,96];
h_variable_3835;
matrix h_variable_3836[1][1] = 0;
matrix h_variable_3837[1][3] = concat(h_variable_3836,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3837); matrix h_variable_3838 = h_variable_l[1]; matrix h_variable_3839 = h_variable_l[2];
ncols(h_variable_3838);
matrix h_variable_3840 = DecideZeroRows(h_variable_3838,h_variable_58);
IsZeroMatrix(h_variable_3840);
nrows(h_variable_3839);
def h_variable_3841 = h_variable_282[1,96];
h_variable_3841;
matrix h_variable_3842[1][1] = 0;
matrix h_variable_3843[1][3] = concat(h_variable_3842,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3843); matrix h_variable_3844 = h_variable_l[1]; matrix h_variable_3845 = h_variable_l[2];
ncols(h_variable_3844);
matrix h_variable_3846 = DecideZeroRows(h_variable_3844,h_variable_58);
IsZeroMatrix(h_variable_3846);
nrows(h_variable_3845);
def h_variable_3847 = h_variable_282[3,97];
h_variable_3847;
matrix h_variable_3848[1][1] = 0;
matrix h_variable_3849[1][3] = concat(h_variable_3848,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3849); matrix h_variable_3850 = h_variable_l[1]; matrix h_variable_3851 = h_variable_l[2];
ncols(h_variable_3850);
matrix h_variable_3852 = DecideZeroRows(h_variable_3850,h_variable_58);
IsZeroMatrix(h_variable_3852);
nrows(h_variable_3851);
def h_variable_3853 = h_variable_282[1,97];
h_variable_3853;
matrix h_variable_3854[1][1] = 0;
matrix h_variable_3855[1][3] = concat(h_variable_3854,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3855); matrix h_variable_3856 = h_variable_l[1]; matrix h_variable_3857 = h_variable_l[2];
ncols(h_variable_3856);
matrix h_variable_3858 = DecideZeroRows(h_variable_3856,h_variable_58);
IsZeroMatrix(h_variable_3858);
nrows(h_variable_3857);
def h_variable_3859 = h_variable_282[3,98];
h_variable_3859;
matrix h_variable_3860[1][1] = 0;
matrix h_variable_3861[1][3] = concat(h_variable_3860,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3861); matrix h_variable_3862 = h_variable_l[1]; matrix h_variable_3863 = h_variable_l[2];
ncols(h_variable_3862);
matrix h_variable_3864 = DecideZeroRows(h_variable_3862,h_variable_58);
IsZeroMatrix(h_variable_3864);
nrows(h_variable_3863);
def h_variable_3865 = h_variable_282[1,98];
h_variable_3865;
matrix h_variable_3866[1][1] = 0;
matrix h_variable_3867[1][3] = concat(h_variable_3866,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3867); matrix h_variable_3868 = h_variable_l[1]; matrix h_variable_3869 = h_variable_l[2];
ncols(h_variable_3868);
matrix h_variable_3870 = DecideZeroRows(h_variable_3868,h_variable_58);
IsZeroMatrix(h_variable_3870);
nrows(h_variable_3869);
def h_variable_3871 = h_variable_282[3,99];
h_variable_3871;
matrix h_variable_3872[1][1] = 0;
matrix h_variable_3873[1][3] = concat(h_variable_3872,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3873); matrix h_variable_3874 = h_variable_l[1]; matrix h_variable_3875 = h_variable_l[2];
ncols(h_variable_3874);
matrix h_variable_3876 = DecideZeroRows(h_variable_3874,h_variable_58);
IsZeroMatrix(h_variable_3876);
nrows(h_variable_3875);
def h_variable_3877 = h_variable_282[1,99];
h_variable_3877;
matrix h_variable_3878[1][1] = 0;
matrix h_variable_3879[1][3] = concat(h_variable_3878,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3879); matrix h_variable_3880 = h_variable_l[1]; matrix h_variable_3881 = h_variable_l[2];
ncols(h_variable_3880);
matrix h_variable_3882 = DecideZeroRows(h_variable_3880,h_variable_58);
IsZeroMatrix(h_variable_3882);
nrows(h_variable_3881);
def h_variable_3883 = h_variable_282[3,100];
h_variable_3883;
matrix h_variable_3884[1][1] = 0;
matrix h_variable_3885[1][3] = concat(h_variable_3884,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3885); matrix h_variable_3886 = h_variable_l[1]; matrix h_variable_3887 = h_variable_l[2];
ncols(h_variable_3886);
matrix h_variable_3888 = DecideZeroRows(h_variable_3886,h_variable_58);
IsZeroMatrix(h_variable_3888);
nrows(h_variable_3887);
def h_variable_3889 = h_variable_282[1,100];
h_variable_3889;
matrix h_variable_3890[1][1] = 0;
matrix h_variable_3891[1][3] = concat(h_variable_3890,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3891); matrix h_variable_3892 = h_variable_l[1]; matrix h_variable_3893 = h_variable_l[2];
ncols(h_variable_3892);
matrix h_variable_3894 = DecideZeroRows(h_variable_3892,h_variable_58);
IsZeroMatrix(h_variable_3894);
nrows(h_variable_3893);
def h_variable_3895 = h_variable_282[3,101];
h_variable_3895;
matrix h_variable_3896[1][1] = 0;
matrix h_variable_3897[1][3] = concat(h_variable_3896,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3897); matrix h_variable_3898 = h_variable_l[1]; matrix h_variable_3899 = h_variable_l[2];
ncols(h_variable_3898);
matrix h_variable_3900 = DecideZeroRows(h_variable_3898,h_variable_58);
IsZeroMatrix(h_variable_3900);
nrows(h_variable_3899);
def h_variable_3901 = h_variable_282[1,101];
h_variable_3901;
matrix h_variable_3902[1][1] = 0;
matrix h_variable_3903[1][3] = concat(h_variable_3902,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3903); matrix h_variable_3904 = h_variable_l[1]; matrix h_variable_3905 = h_variable_l[2];
ncols(h_variable_3904);
matrix h_variable_3906 = DecideZeroRows(h_variable_3904,h_variable_58);
IsZeroMatrix(h_variable_3906);
nrows(h_variable_3905);
def h_variable_3907 = h_variable_282[3,102];
h_variable_3907;
matrix h_variable_3908[1][1] = 0;
matrix h_variable_3909[1][3] = concat(h_variable_3908,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3909); matrix h_variable_3910 = h_variable_l[1]; matrix h_variable_3911 = h_variable_l[2];
ncols(h_variable_3910);
matrix h_variable_3912 = DecideZeroRows(h_variable_3910,h_variable_58);
IsZeroMatrix(h_variable_3912);
nrows(h_variable_3911);
def h_variable_3913 = h_variable_282[1,102];
h_variable_3913;
matrix h_variable_3914[1][1] = 0;
matrix h_variable_3915[1][3] = concat(h_variable_3914,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3915); matrix h_variable_3916 = h_variable_l[1]; matrix h_variable_3917 = h_variable_l[2];
ncols(h_variable_3916);
matrix h_variable_3918 = DecideZeroRows(h_variable_3916,h_variable_58);
IsZeroMatrix(h_variable_3918);
nrows(h_variable_3917);
def h_variable_3919 = h_variable_282[3,103];
h_variable_3919;
matrix h_variable_3920[1][1] = 0;
matrix h_variable_3921[1][3] = concat(h_variable_3920,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3921); matrix h_variable_3922 = h_variable_l[1]; matrix h_variable_3923 = h_variable_l[2];
ncols(h_variable_3922);
matrix h_variable_3924 = DecideZeroRows(h_variable_3922,h_variable_58);
IsZeroMatrix(h_variable_3924);
nrows(h_variable_3923);
def h_variable_3925 = h_variable_282[1,103];
h_variable_3925;
matrix h_variable_3926[1][1] = 0;
matrix h_variable_3927[1][3] = concat(h_variable_3926,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3927); matrix h_variable_3928 = h_variable_l[1]; matrix h_variable_3929 = h_variable_l[2];
ncols(h_variable_3928);
matrix h_variable_3930 = DecideZeroRows(h_variable_3928,h_variable_58);
IsZeroMatrix(h_variable_3930);
nrows(h_variable_3929);
def h_variable_3931 = h_variable_282[3,104];
h_variable_3931;
matrix h_variable_3932[1][1] = 0;
matrix h_variable_3933[1][3] = concat(h_variable_3932,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3933); matrix h_variable_3934 = h_variable_l[1]; matrix h_variable_3935 = h_variable_l[2];
ncols(h_variable_3934);
matrix h_variable_3936 = DecideZeroRows(h_variable_3934,h_variable_58);
IsZeroMatrix(h_variable_3936);
nrows(h_variable_3935);
def h_variable_3937 = h_variable_282[1,104];
h_variable_3937;
matrix h_variable_3938[1][1] = 0;
matrix h_variable_3939[1][3] = concat(h_variable_3938,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3939); matrix h_variable_3940 = h_variable_l[1]; matrix h_variable_3941 = h_variable_l[2];
ncols(h_variable_3940);
matrix h_variable_3942 = DecideZeroRows(h_variable_3940,h_variable_58);
IsZeroMatrix(h_variable_3942);
nrows(h_variable_3941);
def h_variable_3943 = h_variable_282[3,105];
h_variable_3943;
matrix h_variable_3944[1][1] = 0;
matrix h_variable_3945[1][3] = concat(h_variable_3944,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3945); matrix h_variable_3946 = h_variable_l[1]; matrix h_variable_3947 = h_variable_l[2];
ncols(h_variable_3946);
matrix h_variable_3948 = DecideZeroRows(h_variable_3946,h_variable_58);
IsZeroMatrix(h_variable_3948);
nrows(h_variable_3947);
def h_variable_3949 = h_variable_282[1,105];
h_variable_3949;
matrix h_variable_3950[1][1] = 0;
matrix h_variable_3951[1][3] = concat(h_variable_3950,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3951); matrix h_variable_3952 = h_variable_l[1]; matrix h_variable_3953 = h_variable_l[2];
ncols(h_variable_3952);
matrix h_variable_3954 = DecideZeroRows(h_variable_3952,h_variable_58);
IsZeroMatrix(h_variable_3954);
nrows(h_variable_3953);
def h_variable_3955 = h_variable_282[3,106];
h_variable_3955;
matrix h_variable_3956[1][1] = 0;
matrix h_variable_3957[1][3] = concat(h_variable_3956,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3957); matrix h_variable_3958 = h_variable_l[1]; matrix h_variable_3959 = h_variable_l[2];
ncols(h_variable_3958);
matrix h_variable_3960 = DecideZeroRows(h_variable_3958,h_variable_58);
IsZeroMatrix(h_variable_3960);
nrows(h_variable_3959);
def h_variable_3961 = h_variable_282[1,106];
h_variable_3961;
matrix h_variable_3962[1][1] = 0;
matrix h_variable_3963[1][3] = concat(h_variable_3962,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3963); matrix h_variable_3964 = h_variable_l[1]; matrix h_variable_3965 = h_variable_l[2];
ncols(h_variable_3964);
matrix h_variable_3966 = DecideZeroRows(h_variable_3964,h_variable_58);
IsZeroMatrix(h_variable_3966);
nrows(h_variable_3965);
def h_variable_3967 = h_variable_282[3,107];
h_variable_3967;
matrix h_variable_3968[1][1] = 0;
matrix h_variable_3969[1][3] = concat(h_variable_3968,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3969); matrix h_variable_3970 = h_variable_l[1]; matrix h_variable_3971 = h_variable_l[2];
ncols(h_variable_3970);
matrix h_variable_3972 = DecideZeroRows(h_variable_3970,h_variable_58);
IsZeroMatrix(h_variable_3972);
nrows(h_variable_3971);
def h_variable_3973 = h_variable_282[1,107];
h_variable_3973;
matrix h_variable_3974[1][1] = 0;
matrix h_variable_3975[1][3] = concat(h_variable_3974,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3975); matrix h_variable_3976 = h_variable_l[1]; matrix h_variable_3977 = h_variable_l[2];
ncols(h_variable_3976);
matrix h_variable_3978 = DecideZeroRows(h_variable_3976,h_variable_58);
IsZeroMatrix(h_variable_3978);
nrows(h_variable_3977);
def h_variable_3979 = h_variable_282[3,108];
h_variable_3979;
matrix h_variable_3980[1][1] = 0;
matrix h_variable_3981[1][3] = concat(h_variable_3980,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3981); matrix h_variable_3982 = h_variable_l[1]; matrix h_variable_3983 = h_variable_l[2];
ncols(h_variable_3982);
matrix h_variable_3984 = DecideZeroRows(h_variable_3982,h_variable_58);
IsZeroMatrix(h_variable_3984);
nrows(h_variable_3983);
def h_variable_3985 = h_variable_282[1,108];
h_variable_3985;
matrix h_variable_3986[1][1] = 0;
matrix h_variable_3987[1][3] = concat(h_variable_3986,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3987); matrix h_variable_3988 = h_variable_l[1]; matrix h_variable_3989 = h_variable_l[2];
ncols(h_variable_3988);
matrix h_variable_3990 = DecideZeroRows(h_variable_3988,h_variable_58);
IsZeroMatrix(h_variable_3990);
nrows(h_variable_3989);
def h_variable_3991 = h_variable_282[3,109];
h_variable_3991;
matrix h_variable_3992[1][1] = 0;
matrix h_variable_3993[1][3] = concat(h_variable_3992,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_3993); matrix h_variable_3994 = h_variable_l[1]; matrix h_variable_3995 = h_variable_l[2];
ncols(h_variable_3994);
matrix h_variable_3996 = DecideZeroRows(h_variable_3994,h_variable_58);
IsZeroMatrix(h_variable_3996);
nrows(h_variable_3995);
def h_variable_3997 = h_variable_282[1,109];
h_variable_3997;
matrix h_variable_3998[1][1] = 0;
matrix h_variable_3999[1][3] = concat(h_variable_3998,h_variable_48);
kill h_variable_3435;kill h_variable_3436;kill h_variable_3437;kill h_variable_3438;kill h_variable_3440;kill h_variable_3441;kill h_variable_3442;kill h_variable_3443;kill h_variable_3444;kill h_variable_3446;kill h_variable_3447;kill h_variable_3448;kill h_variable_3449;kill h_variable_3450;kill h_variable_3451;kill h_variable_3452;kill h_variable_3453;kill h_variable_3454;kill h_variable_3455;kill h_variable_3456;kill h_variable_3457;kill h_variable_3458;kill h_variable_3459;kill h_variable_3460;kill h_variable_3461;kill h_variable_3462;kill h_variable_3463;kill h_variable_3464;kill h_variable_3465;kill h_variable_3466;kill h_variable_3467;kill h_variable_3468;kill h_variable_3469;kill h_variable_3470;kill h_variable_3471;kill h_variable_3472;kill h_variable_3473;kill h_variable_3474;kill h_variable_3475;kill h_variable_3476;kill h_variable_3477;kill h_variable_3478;kill h_variable_3479;kill h_variable_3480;kill h_variable_3481;kill h_variable_3482;kill h_variable_3483;kill h_variable_3484;kill h_variable_3485;kill h_variable_3486;kill h_variable_3487;kill h_variable_3488;kill h_variable_3489;kill h_variable_3490;kill h_variable_3491;kill h_variable_3492;kill h_variable_3493;kill h_variable_3494;kill h_variable_3495;kill h_variable_3496;kill h_variable_3497;kill h_variable_3498;kill h_variable_3499;kill h_variable_3500;kill h_variable_3501;kill h_variable_3502;kill h_variable_3503;kill h_variable_3504;kill h_variable_3505;kill h_variable_3506;kill h_variable_3507;kill h_variable_3508;kill h_variable_3509;kill h_variable_3510;kill h_variable_3511;kill h_variable_3512;kill h_variable_3513;kill h_variable_3514;kill h_variable_3515;kill h_variable_3516;kill h_variable_3517;kill h_variable_3518;kill h_variable_3519;kill h_variable_3520;kill h_variable_3521;kill h_variable_3522;kill h_variable_3523;kill h_variable_3524;kill h_variable_3525;kill h_variable_3526;kill h_variable_3527;kill h_variable_3528;kill h_variable_3529;kill h_variable_3530;kill h_variable_3531;kill h_variable_3532;kill h_variable_3533;kill h_variable_3534;kill h_variable_3535;kill h_variable_3536;kill h_variable_3537;kill h_variable_3538;kill h_variable_3539;kill h_variable_3540;kill h_variable_3541;kill h_variable_3542;kill h_variable_3543;kill h_variable_3544;kill h_variable_3545;kill h_variable_3546;kill h_variable_3552;kill h_variable_3555;kill h_variable_3556;kill h_variable_3557;kill h_variable_3558;kill h_variable_3560;kill h_variable_3561;kill h_variable_3562;kill h_variable_3563;kill h_variable_3564;kill h_variable_3566;kill h_variable_3567;kill h_variable_3568;kill h_variable_3569;kill h_variable_3570;kill h_variable_3571;kill h_variable_3572;kill h_variable_3573;kill h_variable_3574;kill h_variable_3575;kill h_variable_3576;kill h_variable_3577;kill h_variable_3578;kill h_variable_3579;kill h_variable_3580;kill h_variable_3581;kill h_variable_3582;kill h_variable_3583;kill h_variable_3584;kill h_variable_3585;kill h_variable_3586;kill h_variable_3587;kill h_variable_3588;kill h_variable_3589;kill h_variable_3590;kill h_variable_3591;kill h_variable_3592;kill h_variable_3593;kill h_variable_3594;kill h_variable_3595;kill h_variable_3596;kill h_variable_3597;kill h_variable_3598;kill h_variable_3599;kill h_variable_3600;kill h_variable_3601;kill h_variable_3602;kill h_variable_3603;kill h_variable_3604;kill h_variable_3605;kill h_variable_3606;kill h_variable_3607;kill h_variable_3608;kill h_variable_3609;kill h_variable_3610;kill h_variable_3611;kill h_variable_3612;kill h_variable_3613;kill h_variable_3614;kill h_variable_3615;kill h_variable_3616;kill h_variable_3617;kill h_variable_3618;kill h_variable_3619;kill h_variable_3620;kill h_variable_3621;kill h_variable_3622;kill h_variable_3623;kill h_variable_3624;kill h_variable_3625;kill h_variable_3626;kill h_variable_3627;kill h_variable_3628;kill h_variable_3629;kill h_variable_3630;kill h_variable_3631;kill h_variable_3632;kill h_variable_3633;kill h_variable_3634;kill h_variable_3635;kill h_variable_3636;kill h_variable_3637;kill h_variable_3638;kill h_variable_3639;kill h_variable_3640;kill h_variable_3641;kill h_variable_3642;kill h_variable_3643;kill h_variable_3644;kill h_variable_3645;kill h_variable_3646;kill h_variable_3647;kill h_variable_3648;kill h_variable_3649;kill h_variable_3650;kill h_variable_3651;kill h_variable_3652;kill h_variable_3653;kill h_variable_3654;kill h_variable_3655;kill h_variable_3656;kill h_variable_3657;kill h_variable_3658;kill h_variable_3659;kill h_variable_3660;kill h_variable_3661;kill h_variable_3662;kill h_variable_3663;kill h_variable_3664;kill h_variable_3665;kill h_variable_3666;kill h_variable_3667;kill h_variable_3668;kill h_variable_3669;kill h_variable_3670;kill h_variable_3671;kill h_variable_3672;kill h_variable_3673;kill h_variable_3674;kill h_variable_3675;kill h_variable_3676;kill h_variable_3677;kill h_variable_3678;kill h_variable_3679;kill h_variable_3680;kill h_variable_3681;kill h_variable_3682;kill h_variable_3683;kill h_variable_3684;kill h_variable_3685;kill h_variable_3686;kill h_variable_3687;kill h_variable_3688;kill h_variable_3689;kill h_variable_3690;kill h_variable_3691;kill h_variable_3692;kill h_variable_3693;kill h_variable_3694;kill h_variable_3695;kill h_variable_3696;kill h_variable_3697;kill h_variable_3698;kill h_variable_3699;kill h_variable_3700;kill h_variable_3701;kill h_variable_3702;kill h_variable_3703;kill h_variable_3704;kill h_variable_3705;kill h_variable_3706;kill h_variable_3707;kill h_variable_3708;kill h_variable_3709;kill h_variable_3710;kill h_variable_3711;kill h_variable_3712;kill h_variable_3713;kill h_variable_3714;kill h_variable_3715;kill h_variable_3716;kill h_variable_3717;kill h_variable_3718;kill h_variable_3719;kill h_variable_3720;kill h_variable_3721;kill h_variable_3722;kill h_variable_3723;kill h_variable_3724;kill h_variable_3725;kill h_variable_3726;kill h_variable_3727;kill h_variable_3728;kill h_variable_3729;kill h_variable_3730;kill h_variable_3731;kill h_variable_3732;kill h_variable_3738;kill h_variable_3741;kill h_variable_3742;kill h_variable_3743;kill h_variable_3744;kill h_variable_3746;kill h_variable_3747;kill h_variable_3748;kill h_variable_3749;kill h_variable_3750;kill h_variable_3752;kill h_variable_3753;kill h_variable_3754;kill h_variable_3755;kill h_variable_3756;kill h_variable_3757;kill h_variable_3758;kill h_variable_3759;kill h_variable_3760;kill h_variable_3761;kill h_variable_3762;kill h_variable_3763;kill h_variable_3764;kill h_variable_3765;kill h_variable_3766;kill h_variable_3767;kill h_variable_3768;kill h_variable_3769;kill h_variable_3770;kill h_variable_3771;kill h_variable_3772;kill h_variable_3773;kill h_variable_3774;kill h_variable_3775;kill h_variable_3776;kill h_variable_3777;kill h_variable_3778;kill h_variable_3779;kill h_variable_3780;kill h_variable_3781;kill h_variable_3782;kill h_variable_3783;kill h_variable_3784;kill h_variable_3785;kill h_variable_3786;kill h_variable_3787;kill h_variable_3788;kill h_variable_3789;kill h_variable_3790;kill h_variable_3791;kill h_variable_3792;kill h_variable_3793;kill h_variable_3794;kill h_variable_3795;kill h_variable_3796;kill h_variable_3797;kill h_variable_3798;kill h_variable_3799;kill h_variable_3800;kill h_variable_3801;kill h_variable_3802;kill h_variable_3803;kill h_variable_3804;kill h_variable_3805;kill h_variable_3806;kill h_variable_3807;kill h_variable_3808;kill h_variable_3809;kill h_variable_3810;kill h_variable_3811;kill h_variable_3812;kill h_variable_3813;kill h_variable_3814;kill h_variable_3815;kill h_variable_3816;kill h_variable_3817;kill h_variable_3818;kill h_variable_3819;kill h_variable_3820;kill h_variable_3821;kill h_variable_3822;kill h_variable_3823;kill h_variable_3824;kill h_variable_3825;kill h_variable_3826;kill h_variable_3827;kill h_variable_3828;kill h_variable_3829;kill h_variable_3830;kill h_variable_3831;kill h_variable_3832;kill h_variable_3833;kill h_variable_3834;kill h_variable_3835;kill h_variable_3836;kill h_variable_3837;kill h_variable_3838;kill h_variable_3839;kill h_variable_3840;kill h_variable_3841;kill h_variable_3842;kill h_variable_3843;kill h_variable_3844;kill h_variable_3845;kill h_variable_3846;kill h_variable_3847;kill h_variable_3848;kill h_variable_3849;kill h_variable_3850;kill h_variable_3851;kill h_variable_3852;kill h_variable_3853;kill h_variable_3854;kill h_variable_3855;kill h_variable_3856;kill h_variable_3857;kill h_variable_3858;kill h_variable_3859;kill h_variable_3860;kill h_variable_3861;kill h_variable_3862;kill h_variable_3863;kill h_variable_3864;kill h_variable_3865;kill h_variable_3866;kill h_variable_3867;kill h_variable_3868;kill h_variable_3869;kill h_variable_3870;kill h_variable_3871;kill h_variable_3872;kill h_variable_3873;kill h_variable_3874;kill h_variable_3875;kill h_variable_3876;kill h_variable_3877;kill h_variable_3878;kill h_variable_3879;kill h_variable_3880;kill h_variable_3881;kill h_variable_3882;kill h_variable_3883;kill h_variable_3884;kill h_variable_3885;kill h_variable_3886;kill h_variable_3887;kill h_variable_3888;kill h_variable_3889;kill h_variable_3890;kill h_variable_3891;kill h_variable_3892;kill h_variable_3893;kill h_variable_3894;kill h_variable_3895;kill h_variable_3896;kill h_variable_3897;kill h_variable_3898;kill h_variable_3899;kill h_variable_3900;kill h_variable_3901;kill h_variable_3902;kill h_variable_3903;kill h_variable_3904;kill h_variable_3905;kill h_variable_3906;kill h_variable_3907;kill h_variable_3908;kill h_variable_3909;kill h_variable_3910;kill h_variable_3911;kill h_variable_3912;kill h_variable_3913;kill h_variable_3914;kill h_variable_3915;kill h_variable_3916;kill h_variable_3917;kill h_variable_3918;
list h_variable_l=BasisOfRowsCoeff(h_variable_3999); matrix h_variable_4000 = h_variable_l[1]; matrix h_variable_4001 = h_variable_l[2];
ncols(h_variable_4000);
matrix h_variable_4002 = DecideZeroRows(h_variable_4000,h_variable_58);
IsZeroMatrix(h_variable_4002);
nrows(h_variable_4001);
def h_variable_4003 = h_variable_282[3,110];
h_variable_4003;
matrix h_variable_4004[1][1] = 0;
matrix h_variable_4005[1][3] = concat(h_variable_4004,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4005); matrix h_variable_4006 = h_variable_l[1]; matrix h_variable_4007 = h_variable_l[2];
ncols(h_variable_4006);
matrix h_variable_4008 = DecideZeroRows(h_variable_4006,h_variable_58);
IsZeroMatrix(h_variable_4008);
nrows(h_variable_4007);
def h_variable_4009 = h_variable_282[1,110];
h_variable_4009;
matrix h_variable_4010[1][1] = 0;
matrix h_variable_4011[1][3] = concat(h_variable_4010,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4011); matrix h_variable_4012 = h_variable_l[1]; matrix h_variable_4013 = h_variable_l[2];
ncols(h_variable_4012);
matrix h_variable_4014 = DecideZeroRows(h_variable_4012,h_variable_58);
IsZeroMatrix(h_variable_4014);
nrows(h_variable_4013);
def h_variable_4015 = h_variable_282[3,111];
h_variable_4015;
matrix h_variable_4016[1][1] = 0;
matrix h_variable_4017[1][3] = concat(h_variable_4016,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4017); matrix h_variable_4018 = h_variable_l[1]; matrix h_variable_4019 = h_variable_l[2];
ncols(h_variable_4018);
matrix h_variable_4020 = DecideZeroRows(h_variable_4018,h_variable_58);
IsZeroMatrix(h_variable_4020);
nrows(h_variable_4019);
def h_variable_4021 = h_variable_282[1,111];
h_variable_4021;
matrix h_variable_4022[1][1] = 0;
matrix h_variable_4023[1][3] = concat(h_variable_4022,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4023); matrix h_variable_4024 = h_variable_l[1]; matrix h_variable_4025 = h_variable_l[2];
ncols(h_variable_4024);
matrix h_variable_4026 = DecideZeroRows(h_variable_4024,h_variable_58);
IsZeroMatrix(h_variable_4026);
nrows(h_variable_4025);
def h_variable_4027 = h_variable_282[3,112];
h_variable_4027;
matrix h_variable_4028[1][1] = 0;
matrix h_variable_4029[1][3] = concat(h_variable_4028,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4029); matrix h_variable_4030 = h_variable_l[1]; matrix h_variable_4031 = h_variable_l[2];
ncols(h_variable_4030);
matrix h_variable_4032 = DecideZeroRows(h_variable_4030,h_variable_58);
IsZeroMatrix(h_variable_4032);
nrows(h_variable_4031);
def h_variable_4033 = h_variable_282[1,112];
h_variable_4033;
matrix h_variable_4034[1][1] = 0;
matrix h_variable_4035[1][3] = concat(h_variable_4034,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4035); matrix h_variable_4036 = h_variable_l[1]; matrix h_variable_4037 = h_variable_l[2];
ncols(h_variable_4036);
matrix h_variable_4038 = DecideZeroRows(h_variable_4036,h_variable_58);
IsZeroMatrix(h_variable_4038);
nrows(h_variable_4037);
def h_variable_4039 = h_variable_282[3,113];
h_variable_4039;
matrix h_variable_4040[1][1] = 0;
matrix h_variable_4041[1][3] = concat(h_variable_4040,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4041); matrix h_variable_4042 = h_variable_l[1]; matrix h_variable_4043 = h_variable_l[2];
ncols(h_variable_4042);
matrix h_variable_4044 = DecideZeroRows(h_variable_4042,h_variable_58);
IsZeroMatrix(h_variable_4044);
nrows(h_variable_4043);
def h_variable_4045 = h_variable_282[1,113];
h_variable_4045;
matrix h_variable_4046[1][1] = 0;
matrix h_variable_4047[1][3] = concat(h_variable_4046,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4047); matrix h_variable_4048 = h_variable_l[1]; matrix h_variable_4049 = h_variable_l[2];
ncols(h_variable_4048);
matrix h_variable_4050 = DecideZeroRows(h_variable_4048,h_variable_58);
IsZeroMatrix(h_variable_4050);
nrows(h_variable_4049);
def h_variable_4051 = h_variable_282[3,114];
h_variable_4051;
matrix h_variable_4052[1][1] = 0;
matrix h_variable_4053[1][3] = concat(h_variable_4052,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4053); matrix h_variable_4054 = h_variable_l[1]; matrix h_variable_4055 = h_variable_l[2];
ncols(h_variable_4054);
matrix h_variable_4056 = DecideZeroRows(h_variable_4054,h_variable_58);
IsZeroMatrix(h_variable_4056);
nrows(h_variable_4055);
def h_variable_4057 = h_variable_282[1,114];
h_variable_4057;
matrix h_variable_4058[1][1] = 0;
matrix h_variable_4059[1][3] = concat(h_variable_4058,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4059); matrix h_variable_4060 = h_variable_l[1]; matrix h_variable_4061 = h_variable_l[2];
ncols(h_variable_4060);
matrix h_variable_4062 = DecideZeroRows(h_variable_4060,h_variable_58);
IsZeroMatrix(h_variable_4062);
nrows(h_variable_4061);
def h_variable_4063 = h_variable_282[3,115];
h_variable_4063;
matrix h_variable_4064[1][1] = 0;
matrix h_variable_4065[1][3] = concat(h_variable_4064,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4065); matrix h_variable_4066 = h_variable_l[1]; matrix h_variable_4067 = h_variable_l[2];
ncols(h_variable_4066);
matrix h_variable_4068 = DecideZeroRows(h_variable_4066,h_variable_58);
IsZeroMatrix(h_variable_4068);
nrows(h_variable_4067);
def h_variable_4069 = h_variable_282[1,115];
h_variable_4069;
matrix h_variable_4070[1][1] = 0;
matrix h_variable_4071[1][3] = concat(h_variable_4070,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4071); matrix h_variable_4072 = h_variable_l[1]; matrix h_variable_4073 = h_variable_l[2];
ncols(h_variable_4072);
matrix h_variable_4074 = DecideZeroRows(h_variable_4072,h_variable_58);
IsZeroMatrix(h_variable_4074);
nrows(h_variable_4073);
def h_variable_4075 = h_variable_282[3,116];
h_variable_4075;
matrix h_variable_4076[1][1] = 0;
matrix h_variable_4077[1][3] = concat(h_variable_4076,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4077); matrix h_variable_4078 = h_variable_l[1]; matrix h_variable_4079 = h_variable_l[2];
ncols(h_variable_4078);
matrix h_variable_4080 = DecideZeroRows(h_variable_4078,h_variable_58);
IsZeroMatrix(h_variable_4080);
nrows(h_variable_4079);
def h_variable_4081 = h_variable_282[1,116];
h_variable_4081;
matrix h_variable_4082[1][1] = 0;
matrix h_variable_4083[1][3] = concat(h_variable_4082,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4083); matrix h_variable_4084 = h_variable_l[1]; matrix h_variable_4085 = h_variable_l[2];
ncols(h_variable_4084);
matrix h_variable_4086 = DecideZeroRows(h_variable_4084,h_variable_58);
IsZeroMatrix(h_variable_4086);
nrows(h_variable_4085);
def h_variable_4087 = h_variable_282[3,117];
h_variable_4087;
matrix h_variable_4088[1][1] = 0;
matrix h_variable_4089[1][3] = concat(h_variable_4088,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4089); matrix h_variable_4090 = h_variable_l[1]; matrix h_variable_4091 = h_variable_l[2];
ncols(h_variable_4090);
matrix h_variable_4092 = DecideZeroRows(h_variable_4090,h_variable_58);
IsZeroMatrix(h_variable_4092);
nrows(h_variable_4091);
def h_variable_4093 = h_variable_282[1,117];
h_variable_4093;
matrix h_variable_4094[1][1] = 0;
matrix h_variable_4095[1][3] = concat(h_variable_4094,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4095); matrix h_variable_4096 = h_variable_l[1]; matrix h_variable_4097 = h_variable_l[2];
ncols(h_variable_4096);
matrix h_variable_4098 = DecideZeroRows(h_variable_4096,h_variable_58);
IsZeroMatrix(h_variable_4098);
nrows(h_variable_4097);
def h_variable_4099 = h_variable_282[3,118];
h_variable_4099;
matrix h_variable_4100[1][1] = 0;
matrix h_variable_4101[1][3] = concat(h_variable_4100,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4101); matrix h_variable_4102 = h_variable_l[1]; matrix h_variable_4103 = h_variable_l[2];
ncols(h_variable_4102);
matrix h_variable_4104 = DecideZeroRows(h_variable_4102,h_variable_58);
IsZeroMatrix(h_variable_4104);
nrows(h_variable_4103);
def h_variable_4105 = h_variable_282[1,118];
h_variable_4105;
matrix h_variable_4106[1][1] = 0;
matrix h_variable_4107[1][3] = concat(h_variable_4106,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4107); matrix h_variable_4108 = h_variable_l[1]; matrix h_variable_4109 = h_variable_l[2];
ncols(h_variable_4108);
matrix h_variable_4110 = DecideZeroRows(h_variable_4108,h_variable_58);
IsZeroMatrix(h_variable_4110);
nrows(h_variable_4109);
def h_variable_4111 = h_variable_282[3,119];
h_variable_4111;
matrix h_variable_4112[1][1] = 0;
matrix h_variable_4113[1][3] = concat(h_variable_4112,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4113); matrix h_variable_4114 = h_variable_l[1]; matrix h_variable_4115 = h_variable_l[2];
ncols(h_variable_4114);
matrix h_variable_4116 = DecideZeroRows(h_variable_4114,h_variable_58);
IsZeroMatrix(h_variable_4116);
nrows(h_variable_4115);
def h_variable_4117 = h_variable_282[1,119];
h_variable_4117;
matrix h_variable_4118[1][1] = 0;
matrix h_variable_4119[1][3] = concat(h_variable_4118,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4119); matrix h_variable_4120 = h_variable_l[1]; matrix h_variable_4121 = h_variable_l[2];
ncols(h_variable_4120);
matrix h_variable_4122 = DecideZeroRows(h_variable_4120,h_variable_58);
IsZeroMatrix(h_variable_4122);
nrows(h_variable_4121);
def h_variable_4123 = h_variable_282[3,120];
h_variable_4123;
matrix h_variable_4124[1][1] = 0;
matrix h_variable_4125[1][3] = concat(h_variable_4124,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4125); matrix h_variable_4126 = h_variable_l[1]; matrix h_variable_4127 = h_variable_l[2];
ncols(h_variable_4126);
matrix h_variable_4128 = DecideZeroRows(h_variable_4126,h_variable_58);
IsZeroMatrix(h_variable_4128);
nrows(h_variable_4127);
def h_variable_4129 = h_variable_282[1,120];
h_variable_4129;
matrix h_variable_4130[1][1] = 0;
matrix h_variable_4131[1][3] = concat(h_variable_4130,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4131); matrix h_variable_4132 = h_variable_l[1]; matrix h_variable_4133 = h_variable_l[2];
ncols(h_variable_4132);
matrix h_variable_4134 = DecideZeroRows(h_variable_4132,h_variable_58);
IsZeroMatrix(h_variable_4134);
nrows(h_variable_4133);
def h_variable_4135 = h_variable_282[3,121];
h_variable_4135;
matrix h_variable_4136[1][1] = 0;
matrix h_variable_4137[1][3] = concat(h_variable_4136,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4137); matrix h_variable_4138 = h_variable_l[1]; matrix h_variable_4139 = h_variable_l[2];
ncols(h_variable_4138);
matrix h_variable_4140 = DecideZeroRows(h_variable_4138,h_variable_58);
IsZeroMatrix(h_variable_4140);
nrows(h_variable_4139);
def h_variable_4141 = h_variable_282[1,121];
h_variable_4141;
matrix h_variable_4142[1][1] = 0;
matrix h_variable_4143[1][3] = concat(h_variable_4142,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4143); matrix h_variable_4144 = h_variable_l[1]; matrix h_variable_4145 = h_variable_l[2];
ncols(h_variable_4144);
matrix h_variable_4146 = DecideZeroRows(h_variable_4144,h_variable_58);
IsZeroMatrix(h_variable_4146);
nrows(h_variable_4145);
def h_variable_4147 = h_variable_282[3,122];
h_variable_4147;
matrix h_variable_4148[1][1] = 0;
matrix h_variable_4149[1][3] = concat(h_variable_4148,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4149); matrix h_variable_4150 = h_variable_l[1]; matrix h_variable_4151 = h_variable_l[2];
ncols(h_variable_4150);
matrix h_variable_4152 = DecideZeroRows(h_variable_4150,h_variable_58);
IsZeroMatrix(h_variable_4152);
nrows(h_variable_4151);
def h_variable_4153 = h_variable_282[1,122];
h_variable_4153;
matrix h_variable_4154[1][1] = 0;
matrix h_variable_4155[1][3] = concat(h_variable_4154,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4155); matrix h_variable_4156 = h_variable_l[1]; matrix h_variable_4157 = h_variable_l[2];
ncols(h_variable_4156);
matrix h_variable_4158 = DecideZeroRows(h_variable_4156,h_variable_58);
IsZeroMatrix(h_variable_4158);
nrows(h_variable_4157);
def h_variable_4159 = h_variable_282[3,123];
h_variable_4159;
matrix h_variable_4160[1][1] = 0;
matrix h_variable_4161[1][3] = concat(h_variable_4160,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4161); matrix h_variable_4162 = h_variable_l[1]; matrix h_variable_4163 = h_variable_l[2];
ncols(h_variable_4162);
matrix h_variable_4164 = DecideZeroRows(h_variable_4162,h_variable_58);
IsZeroMatrix(h_variable_4164);
nrows(h_variable_4163);
def h_variable_4165 = h_variable_282[1,123];
h_variable_4165;
matrix h_variable_4166[1][1] = 0;
matrix h_variable_4167[1][3] = concat(h_variable_4166,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4167); matrix h_variable_4168 = h_variable_l[1]; matrix h_variable_4169 = h_variable_l[2];
ncols(h_variable_4168);
matrix h_variable_4170 = DecideZeroRows(h_variable_4168,h_variable_58);
IsZeroMatrix(h_variable_4170);
nrows(h_variable_4169);
def h_variable_4171 = h_variable_282[3,124];
h_variable_4171;
matrix h_variable_4172[1][1] = 0;
matrix h_variable_4173[1][3] = concat(h_variable_4172,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4173); matrix h_variable_4174 = h_variable_l[1]; matrix h_variable_4175 = h_variable_l[2];
ncols(h_variable_4174);
matrix h_variable_4176 = DecideZeroRows(h_variable_4174,h_variable_58);
IsZeroMatrix(h_variable_4176);
nrows(h_variable_4175);
def h_variable_4177 = h_variable_282[1,124];
h_variable_4177;
matrix h_variable_4178[1][1] = 0;
matrix h_variable_4179[1][3] = concat(h_variable_4178,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4179); matrix h_variable_4180 = h_variable_l[1]; matrix h_variable_4181 = h_variable_l[2];
ncols(h_variable_4180);
matrix h_variable_4182 = DecideZeroRows(h_variable_4180,h_variable_58);
IsZeroMatrix(h_variable_4182);
nrows(h_variable_4181);
def h_variable_4183 = h_variable_282[3,125];
h_variable_4183;
matrix h_variable_4184[1][1] = 0;
matrix h_variable_4185[1][3] = concat(h_variable_4184,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4185); matrix h_variable_4186 = h_variable_l[1]; matrix h_variable_4187 = h_variable_l[2];
ncols(h_variable_4186);
matrix h_variable_4188 = DecideZeroRows(h_variable_4186,h_variable_58);
IsZeroMatrix(h_variable_4188);
nrows(h_variable_4187);
def h_variable_4189 = h_variable_282[1,125];
h_variable_4189;
matrix h_variable_4190[1][1] = 0;
matrix h_variable_4191[1][3] = concat(h_variable_4190,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4191); matrix h_variable_4192 = h_variable_l[1]; matrix h_variable_4193 = h_variable_l[2];
ncols(h_variable_4192);
matrix h_variable_4194 = DecideZeroRows(h_variable_4192,h_variable_58);
IsZeroMatrix(h_variable_4194);
nrows(h_variable_4193);
def h_variable_4195 = h_variable_282[3,126];
h_variable_4195;
matrix h_variable_4196[1][1] = 0;
matrix h_variable_4197[1][3] = concat(h_variable_4196,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4197); matrix h_variable_4198 = h_variable_l[1]; matrix h_variable_4199 = h_variable_l[2];
ncols(h_variable_4198);
matrix h_variable_4200 = DecideZeroRows(h_variable_4198,h_variable_58);
IsZeroMatrix(h_variable_4200);
nrows(h_variable_4199);
def h_variable_4201 = h_variable_282[1,126];
h_variable_4201;
matrix h_variable_4202[1][1] = 0;
matrix h_variable_4203[1][3] = concat(h_variable_4202,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4203); matrix h_variable_4204 = h_variable_l[1]; matrix h_variable_4205 = h_variable_l[2];
ncols(h_variable_4204);
matrix h_variable_4206 = DecideZeroRows(h_variable_4204,h_variable_58);
IsZeroMatrix(h_variable_4206);
nrows(h_variable_4205);
def h_variable_4207 = h_variable_282[3,127];
h_variable_4207;
matrix h_variable_4208[1][1] = 0;
matrix h_variable_4209[1][3] = concat(h_variable_4208,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4209); matrix h_variable_4210 = h_variable_l[1]; matrix h_variable_4211 = h_variable_l[2];
ncols(h_variable_4210);
matrix h_variable_4212 = DecideZeroRows(h_variable_4210,h_variable_58);
IsZeroMatrix(h_variable_4212);
nrows(h_variable_4211);
def h_variable_4213 = h_variable_282[1,127];
h_variable_4213;
matrix h_variable_4214[1][1] = 0;
matrix h_variable_4215[1][3] = concat(h_variable_4214,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4215); matrix h_variable_4216 = h_variable_l[1]; matrix h_variable_4217 = h_variable_l[2];
ncols(h_variable_4216);
matrix h_variable_4218 = DecideZeroRows(h_variable_4216,h_variable_58);
IsZeroMatrix(h_variable_4218);
nrows(h_variable_4217);
def h_variable_4219 = h_variable_282[3,128];
h_variable_4219;
matrix h_variable_4220[1][1] = 0;
matrix h_variable_4221[1][3] = concat(h_variable_4220,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4221); matrix h_variable_4222 = h_variable_l[1]; matrix h_variable_4223 = h_variable_l[2];
ncols(h_variable_4222);
matrix h_variable_4224 = DecideZeroRows(h_variable_4222,h_variable_58);
IsZeroMatrix(h_variable_4224);
nrows(h_variable_4223);
def h_variable_4225 = h_variable_282[1,128];
h_variable_4225;
matrix h_variable_4226[1][1] = 0;
matrix h_variable_4227[1][3] = concat(h_variable_4226,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4227); matrix h_variable_4228 = h_variable_l[1]; matrix h_variable_4229 = h_variable_l[2];
ncols(h_variable_4228);
matrix h_variable_4230 = DecideZeroRows(h_variable_4228,h_variable_58);
IsZeroMatrix(h_variable_4230);
nrows(h_variable_4229);
def h_variable_4231 = h_variable_282[3,129];
h_variable_4231;
matrix h_variable_4232[1][1] = 0;
matrix h_variable_4233[1][3] = concat(h_variable_4232,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4233); matrix h_variable_4234 = h_variable_l[1]; matrix h_variable_4235 = h_variable_l[2];
ncols(h_variable_4234);
matrix h_variable_4236 = DecideZeroRows(h_variable_4234,h_variable_58);
IsZeroMatrix(h_variable_4236);
nrows(h_variable_4235);
def h_variable_4237 = h_variable_282[1,129];
h_variable_4237;
matrix h_variable_4238[1][1] = 0;
matrix h_variable_4239[1][3] = concat(h_variable_4238,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4239); matrix h_variable_4240 = h_variable_l[1]; matrix h_variable_4241 = h_variable_l[2];
ncols(h_variable_4240);
matrix h_variable_4242 = DecideZeroRows(h_variable_4240,h_variable_58);
IsZeroMatrix(h_variable_4242);
nrows(h_variable_4241);
def h_variable_4243 = h_variable_282[3,130];
h_variable_4243;
matrix h_variable_4244[1][1] = 0;
matrix h_variable_4245[1][3] = concat(h_variable_4244,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4245); matrix h_variable_4246 = h_variable_l[1]; matrix h_variable_4247 = h_variable_l[2];
ncols(h_variable_4246);
matrix h_variable_4248 = DecideZeroRows(h_variable_4246,h_variable_58);
IsZeroMatrix(h_variable_4248);
nrows(h_variable_4247);
def h_variable_4249 = h_variable_282[1,130];
h_variable_4249;
matrix h_variable_4250[1][1] = 0;
matrix h_variable_4251[1][3] = concat(h_variable_4250,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4251); matrix h_variable_4252 = h_variable_l[1]; matrix h_variable_4253 = h_variable_l[2];
ncols(h_variable_4252);
matrix h_variable_4254 = DecideZeroRows(h_variable_4252,h_variable_58);
IsZeroMatrix(h_variable_4254);
nrows(h_variable_4253);
def h_variable_4255 = h_variable_282[3,131];
h_variable_4255;
matrix h_variable_4256[1][1] = 0;
matrix h_variable_4257[1][3] = concat(h_variable_4256,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4257); matrix h_variable_4258 = h_variable_l[1]; matrix h_variable_4259 = h_variable_l[2];
ncols(h_variable_4258);
matrix h_variable_4260 = DecideZeroRows(h_variable_4258,h_variable_58);
IsZeroMatrix(h_variable_4260);
nrows(h_variable_4259);
def h_variable_4261 = h_variable_282[1,131];
h_variable_4261;
matrix h_variable_4262[1][1] = 0;
matrix h_variable_4263[1][3] = concat(h_variable_4262,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4263); matrix h_variable_4264 = h_variable_l[1]; matrix h_variable_4265 = h_variable_l[2];
ncols(h_variable_4264);
matrix h_variable_4266 = DecideZeroRows(h_variable_4264,h_variable_58);
IsZeroMatrix(h_variable_4266);
nrows(h_variable_4265);
def h_variable_4267 = h_variable_282[3,132];
h_variable_4267;
matrix h_variable_4268[1][1] = 0;
matrix h_variable_4269[1][3] = concat(h_variable_4268,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4269); matrix h_variable_4270 = h_variable_l[1]; matrix h_variable_4271 = h_variable_l[2];
ncols(h_variable_4270);
matrix h_variable_4272 = DecideZeroRows(h_variable_4270,h_variable_58);
IsZeroMatrix(h_variable_4272);
nrows(h_variable_4271);
def h_variable_4273 = h_variable_282[1,132];
h_variable_4273;
matrix h_variable_4274[1][1] = 0;
matrix h_variable_4275[1][3] = concat(h_variable_4274,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4275); matrix h_variable_4276 = h_variable_l[1]; matrix h_variable_4277 = h_variable_l[2];
ncols(h_variable_4276);
matrix h_variable_4278 = DecideZeroRows(h_variable_4276,h_variable_58);
IsZeroMatrix(h_variable_4278);
nrows(h_variable_4277);
def h_variable_4279 = h_variable_282[3,133];
h_variable_4279;
matrix h_variable_4280[1][1] = 0;
matrix h_variable_4281[1][3] = concat(h_variable_4280,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4281); matrix h_variable_4282 = h_variable_l[1]; matrix h_variable_4283 = h_variable_l[2];
ncols(h_variable_4282);
matrix h_variable_4284 = DecideZeroRows(h_variable_4282,h_variable_58);
IsZeroMatrix(h_variable_4284);
nrows(h_variable_4283);
def h_variable_4285 = h_variable_282[1,133];
h_variable_4285;
matrix h_variable_4286[1][1] = 0;
matrix h_variable_4287[1][3] = concat(h_variable_4286,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4287); matrix h_variable_4288 = h_variable_l[1]; matrix h_variable_4289 = h_variable_l[2];
ncols(h_variable_4288);
matrix h_variable_4290 = DecideZeroRows(h_variable_4288,h_variable_58);
IsZeroMatrix(h_variable_4290);
nrows(h_variable_4289);
def h_variable_4291 = h_variable_282[3,134];
h_variable_4291;
matrix h_variable_4292[1][1] = 0;
matrix h_variable_4293[1][3] = concat(h_variable_4292,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4293); matrix h_variable_4294 = h_variable_l[1]; matrix h_variable_4295 = h_variable_l[2];
ncols(h_variable_4294);
matrix h_variable_4296 = DecideZeroRows(h_variable_4294,h_variable_58);
IsZeroMatrix(h_variable_4296);
nrows(h_variable_4295);
def h_variable_4297 = h_variable_282[1,134];
h_variable_4297;
matrix h_variable_4298[1][1] = 0;
matrix h_variable_4299[1][3] = concat(h_variable_4298,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4299); matrix h_variable_4300 = h_variable_l[1]; matrix h_variable_4301 = h_variable_l[2];
ncols(h_variable_4300);
matrix h_variable_4302 = DecideZeroRows(h_variable_4300,h_variable_58);
IsZeroMatrix(h_variable_4302);
nrows(h_variable_4301);
def h_variable_4303 = h_variable_282[3,135];
h_variable_4303;
matrix h_variable_4304[1][1] = 0;
matrix h_variable_4305[1][3] = concat(h_variable_4304,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4305); matrix h_variable_4306 = h_variable_l[1]; matrix h_variable_4307 = h_variable_l[2];
ncols(h_variable_4306);
matrix h_variable_4308 = DecideZeroRows(h_variable_4306,h_variable_58);
IsZeroMatrix(h_variable_4308);
nrows(h_variable_4307);
def h_variable_4309 = h_variable_282[1,135];
h_variable_4309;
matrix h_variable_4310[1][1] = 0;
matrix h_variable_4311[1][3] = concat(h_variable_4310,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4311); matrix h_variable_4312 = h_variable_l[1]; matrix h_variable_4313 = h_variable_l[2];
ncols(h_variable_4312);
matrix h_variable_4314 = DecideZeroRows(h_variable_4312,h_variable_58);
IsZeroMatrix(h_variable_4314);
nrows(h_variable_4313);
def h_variable_4315 = h_variable_282[3,136];
h_variable_4315;
matrix h_variable_4316[1][1] = 0;
matrix h_variable_4317[1][3] = concat(h_variable_4316,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4317); matrix h_variable_4318 = h_variable_l[1]; matrix h_variable_4319 = h_variable_l[2];
ncols(h_variable_4318);
matrix h_variable_4320 = DecideZeroRows(h_variable_4318,h_variable_58);
IsZeroMatrix(h_variable_4320);
nrows(h_variable_4319);
def h_variable_4321 = h_variable_282[1,136];
h_variable_4321;
matrix h_variable_4322[1][1] = 0;
matrix h_variable_4323[1][3] = concat(h_variable_4322,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4323); matrix h_variable_4324 = h_variable_l[1]; matrix h_variable_4325 = h_variable_l[2];
ncols(h_variable_4324);
matrix h_variable_4326 = DecideZeroRows(h_variable_4324,h_variable_58);
IsZeroMatrix(h_variable_4326);
nrows(h_variable_4325);
def h_variable_4327 = h_variable_282[3,137];
h_variable_4327;
matrix h_variable_4328[1][1] = 0;
matrix h_variable_4329[1][3] = concat(h_variable_4328,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4329); matrix h_variable_4330 = h_variable_l[1]; matrix h_variable_4331 = h_variable_l[2];
ncols(h_variable_4330);
matrix h_variable_4332 = DecideZeroRows(h_variable_4330,h_variable_58);
IsZeroMatrix(h_variable_4332);
nrows(h_variable_4331);
def h_variable_4333 = h_variable_282[1,137];
h_variable_4333;
matrix h_variable_4334[1][1] = 0;
matrix h_variable_4335[1][3] = concat(h_variable_4334,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4335); matrix h_variable_4336 = h_variable_l[1]; matrix h_variable_4337 = h_variable_l[2];
ncols(h_variable_4336);
matrix h_variable_4338 = DecideZeroRows(h_variable_4336,h_variable_58);
IsZeroMatrix(h_variable_4338);
nrows(h_variable_4337);
def h_variable_4339 = h_variable_282[3,138];
h_variable_4339;
matrix h_variable_4340[1][1] = 0;
matrix h_variable_4341[1][3] = concat(h_variable_4340,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4341); matrix h_variable_4342 = h_variable_l[1]; matrix h_variable_4343 = h_variable_l[2];
ncols(h_variable_4342);
matrix h_variable_4344 = DecideZeroRows(h_variable_4342,h_variable_58);
IsZeroMatrix(h_variable_4344);
nrows(h_variable_4343);
def h_variable_4345 = h_variable_282[1,138];
h_variable_4345;
matrix h_variable_4346[1][1] = 0;
matrix h_variable_4347[1][3] = concat(h_variable_4346,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4347); matrix h_variable_4348 = h_variable_l[1]; matrix h_variable_4349 = h_variable_l[2];
ncols(h_variable_4348);
matrix h_variable_4350 = DecideZeroRows(h_variable_4348,h_variable_58);
IsZeroMatrix(h_variable_4350);
nrows(h_variable_4349);
def h_variable_4351 = h_variable_282[3,139];
h_variable_4351;
matrix h_variable_4352[1][1] = 0;
matrix h_variable_4353[1][3] = concat(h_variable_4352,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4353); matrix h_variable_4354 = h_variable_l[1]; matrix h_variable_4355 = h_variable_l[2];
ncols(h_variable_4354);
matrix h_variable_4356 = DecideZeroRows(h_variable_4354,h_variable_58);
IsZeroMatrix(h_variable_4356);
nrows(h_variable_4355);
def h_variable_4357 = h_variable_282[1,139];
h_variable_4357;
matrix h_variable_4358[1][1] = 0;
matrix h_variable_4359[1][3] = concat(h_variable_4358,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4359); matrix h_variable_4360 = h_variable_l[1]; matrix h_variable_4361 = h_variable_l[2];
ncols(h_variable_4360);
matrix h_variable_4362 = DecideZeroRows(h_variable_4360,h_variable_58);
IsZeroMatrix(h_variable_4362);
nrows(h_variable_4361);
def h_variable_4363 = h_variable_282[3,140];
h_variable_4363;
matrix h_variable_4364[1][1] = 0;
matrix h_variable_4365[1][3] = concat(h_variable_4364,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4365); matrix h_variable_4366 = h_variable_l[1]; matrix h_variable_4367 = h_variable_l[2];
ncols(h_variable_4366);
matrix h_variable_4368 = DecideZeroRows(h_variable_4366,h_variable_58);
IsZeroMatrix(h_variable_4368);
nrows(h_variable_4367);
def h_variable_4369 = h_variable_282[1,140];
h_variable_4369;
matrix h_variable_4370[1][1] = 0;
matrix h_variable_4371[1][3] = concat(h_variable_4370,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4371); matrix h_variable_4372 = h_variable_l[1]; matrix h_variable_4373 = h_variable_l[2];
ncols(h_variable_4372);
matrix h_variable_4374 = DecideZeroRows(h_variable_4372,h_variable_58);
IsZeroMatrix(h_variable_4374);
nrows(h_variable_4373);
def h_variable_4375 = h_variable_282[3,141];
h_variable_4375;
matrix h_variable_4376[1][1] = 0;
matrix h_variable_4377[1][3] = concat(h_variable_4376,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4377); matrix h_variable_4378 = h_variable_l[1]; matrix h_variable_4379 = h_variable_l[2];
ncols(h_variable_4378);
matrix h_variable_4380 = DecideZeroRows(h_variable_4378,h_variable_58);
IsZeroMatrix(h_variable_4380);
nrows(h_variable_4379);
def h_variable_4381 = h_variable_282[1,141];
h_variable_4381;
matrix h_variable_4382[1][1] = 0;
matrix h_variable_4383[1][3] = concat(h_variable_4382,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4383); matrix h_variable_4384 = h_variable_l[1]; matrix h_variable_4385 = h_variable_l[2];
ncols(h_variable_4384);
matrix h_variable_4386 = DecideZeroRows(h_variable_4384,h_variable_58);
IsZeroMatrix(h_variable_4386);
nrows(h_variable_4385);
def h_variable_4387 = h_variable_282[3,142];
h_variable_4387;
matrix h_variable_4388[1][1] = 0;
matrix h_variable_4389[1][3] = concat(h_variable_4388,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4389); matrix h_variable_4390 = h_variable_l[1]; matrix h_variable_4391 = h_variable_l[2];
ncols(h_variable_4390);
matrix h_variable_4392 = DecideZeroRows(h_variable_4390,h_variable_58);
IsZeroMatrix(h_variable_4392);
nrows(h_variable_4391);
def h_variable_4393 = h_variable_282[1,142];
h_variable_4393;
matrix h_variable_4394[1][1] = 0;
matrix h_variable_4395[1][3] = concat(h_variable_4394,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4395); matrix h_variable_4396 = h_variable_l[1]; matrix h_variable_4397 = h_variable_l[2];
ncols(h_variable_4396);
matrix h_variable_4398 = DecideZeroRows(h_variable_4396,h_variable_58);
IsZeroMatrix(h_variable_4398);
nrows(h_variable_4397);
def h_variable_4399 = h_variable_282[3,143];
h_variable_4399;
matrix h_variable_4400[1][1] = 0;
matrix h_variable_4401[1][3] = concat(h_variable_4400,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4401); matrix h_variable_4402 = h_variable_l[1]; matrix h_variable_4403 = h_variable_l[2];
ncols(h_variable_4402);
matrix h_variable_4404 = DecideZeroRows(h_variable_4402,h_variable_58);
IsZeroMatrix(h_variable_4404);
nrows(h_variable_4403);
def h_variable_4405 = h_variable_282[1,143];
h_variable_4405;
matrix h_variable_4406[1][1] = 0;
matrix h_variable_4407[1][3] = concat(h_variable_4406,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4407); matrix h_variable_4408 = h_variable_l[1]; matrix h_variable_4409 = h_variable_l[2];
ncols(h_variable_4408);
matrix h_variable_4410 = DecideZeroRows(h_variable_4408,h_variable_58);
IsZeroMatrix(h_variable_4410);
nrows(h_variable_4409);
def h_variable_4411 = h_variable_282[3,144];
h_variable_4411;
matrix h_variable_4412[1][1] = 0;
matrix h_variable_4413[1][3] = concat(h_variable_4412,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4413); matrix h_variable_4414 = h_variable_l[1]; matrix h_variable_4415 = h_variable_l[2];
ncols(h_variable_4414);
matrix h_variable_4416 = DecideZeroRows(h_variable_4414,h_variable_58);
IsZeroMatrix(h_variable_4416);
nrows(h_variable_4415);
def h_variable_4417 = h_variable_282[1,144];
h_variable_4417;
matrix h_variable_4418[1][1] = 0;
matrix h_variable_4419[1][3] = concat(h_variable_4418,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4419); matrix h_variable_4420 = h_variable_l[1]; matrix h_variable_4421 = h_variable_l[2];
ncols(h_variable_4420);
matrix h_variable_4422 = DecideZeroRows(h_variable_4420,h_variable_58);
IsZeroMatrix(h_variable_4422);
nrows(h_variable_4421);
def h_variable_4423 = h_variable_282[3,145];
h_variable_4423;
matrix h_variable_4424[1][1] = 0;
matrix h_variable_4425[1][3] = concat(h_variable_4424,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4425); matrix h_variable_4426 = h_variable_l[1]; matrix h_variable_4427 = h_variable_l[2];
ncols(h_variable_4426);
matrix h_variable_4428 = DecideZeroRows(h_variable_4426,h_variable_58);
IsZeroMatrix(h_variable_4428);
nrows(h_variable_4427);
def h_variable_4429 = h_variable_282[1,145];
h_variable_4429;
matrix h_variable_4430[1][1] = 0;
matrix h_variable_4431[1][3] = concat(h_variable_4430,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4431); matrix h_variable_4432 = h_variable_l[1]; matrix h_variable_4433 = h_variable_l[2];
ncols(h_variable_4432);
matrix h_variable_4434 = DecideZeroRows(h_variable_4432,h_variable_58);
IsZeroMatrix(h_variable_4434);
nrows(h_variable_4433);
def h_variable_4435 = h_variable_282[3,146];
h_variable_4435;
matrix h_variable_4436[1][1] = 0;
matrix h_variable_4437[1][3] = concat(h_variable_4436,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4437); matrix h_variable_4438 = h_variable_l[1]; matrix h_variable_4439 = h_variable_l[2];
ncols(h_variable_4438);
matrix h_variable_4440 = DecideZeroRows(h_variable_4438,h_variable_58);
IsZeroMatrix(h_variable_4440);
nrows(h_variable_4439);
def h_variable_4441 = h_variable_282[1,146];
h_variable_4441;
matrix h_variable_4442[1][1] = 0;
matrix h_variable_4443[1][3] = concat(h_variable_4442,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4443); matrix h_variable_4444 = h_variable_l[1]; matrix h_variable_4445 = h_variable_l[2];
ncols(h_variable_4444);
matrix h_variable_4446 = DecideZeroRows(h_variable_4444,h_variable_58);
IsZeroMatrix(h_variable_4446);
nrows(h_variable_4445);
def h_variable_4447 = h_variable_282[3,147];
h_variable_4447;
matrix h_variable_4448[1][1] = 0;
matrix h_variable_4449[1][3] = concat(h_variable_4448,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4449); matrix h_variable_4450 = h_variable_l[1]; matrix h_variable_4451 = h_variable_l[2];
ncols(h_variable_4450);
matrix h_variable_4452 = DecideZeroRows(h_variable_4450,h_variable_58);
IsZeroMatrix(h_variable_4452);
nrows(h_variable_4451);
def h_variable_4453 = h_variable_282[1,147];
h_variable_4453;
matrix h_variable_4454[1][1] = 0;
matrix h_variable_4455[1][3] = concat(h_variable_4454,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4455); matrix h_variable_4456 = h_variable_l[1]; matrix h_variable_4457 = h_variable_l[2];
ncols(h_variable_4456);
matrix h_variable_4458 = DecideZeroRows(h_variable_4456,h_variable_58);
IsZeroMatrix(h_variable_4458);
nrows(h_variable_4457);
def h_variable_4459 = h_variable_282[3,148];
h_variable_4459;
matrix h_variable_4460[1][1] = 0;
matrix h_variable_4461[1][3] = concat(h_variable_4460,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4461); matrix h_variable_4462 = h_variable_l[1]; matrix h_variable_4463 = h_variable_l[2];
ncols(h_variable_4462);
matrix h_variable_4464 = DecideZeroRows(h_variable_4462,h_variable_58);
IsZeroMatrix(h_variable_4464);
nrows(h_variable_4463);
def h_variable_4465 = h_variable_282[1,148];
h_variable_4465;
matrix h_variable_4466[1][1] = 0;
matrix h_variable_4467[1][3] = concat(h_variable_4466,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4467); matrix h_variable_4468 = h_variable_l[1]; matrix h_variable_4469 = h_variable_l[2];
ncols(h_variable_4468);
matrix h_variable_4470 = DecideZeroRows(h_variable_4468,h_variable_58);
IsZeroMatrix(h_variable_4470);
nrows(h_variable_4469);
def h_variable_4471 = h_variable_282[3,149];
h_variable_4471;
matrix h_variable_4472[1][1] = 0;
matrix h_variable_4473[1][3] = concat(h_variable_4472,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4473); matrix h_variable_4474 = h_variable_l[1]; matrix h_variable_4475 = h_variable_l[2];
ncols(h_variable_4474);
matrix h_variable_4476 = DecideZeroRows(h_variable_4474,h_variable_58);
IsZeroMatrix(h_variable_4476);
nrows(h_variable_4475);
def h_variable_4477 = h_variable_282[1,149];
h_variable_4477;
matrix h_variable_4478[1][1] = 0;
matrix h_variable_4479[1][3] = concat(h_variable_4478,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4479); matrix h_variable_4480 = h_variable_l[1]; matrix h_variable_4481 = h_variable_l[2];
ncols(h_variable_4480);
matrix h_variable_4482 = DecideZeroRows(h_variable_4480,h_variable_58);
IsZeroMatrix(h_variable_4482);
nrows(h_variable_4481);
def h_variable_4483 = h_variable_282[3,150];
h_variable_4483;
matrix h_variable_4484[1][1] = 0;
matrix h_variable_4485[1][3] = concat(h_variable_4484,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4485); matrix h_variable_4486 = h_variable_l[1]; matrix h_variable_4487 = h_variable_l[2];
ncols(h_variable_4486);
matrix h_variable_4488 = DecideZeroRows(h_variable_4486,h_variable_58);
IsZeroMatrix(h_variable_4488);
nrows(h_variable_4487);
def h_variable_4489 = h_variable_282[1,150];
h_variable_4489;
matrix h_variable_4490[1][1] = 0;
matrix h_variable_4491[1][3] = concat(h_variable_4490,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4491); matrix h_variable_4492 = h_variable_l[1]; matrix h_variable_4493 = h_variable_l[2];
ncols(h_variable_4492);
matrix h_variable_4494 = DecideZeroRows(h_variable_4492,h_variable_58);
IsZeroMatrix(h_variable_4494);
nrows(h_variable_4493);
def h_variable_4495 = h_variable_282[3,151];
h_variable_4495;
matrix h_variable_4496[1][1] = 0;
matrix h_variable_4497[1][3] = concat(h_variable_4496,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4497); matrix h_variable_4498 = h_variable_l[1]; matrix h_variable_4499 = h_variable_l[2];
ncols(h_variable_4498);
matrix h_variable_4500 = DecideZeroRows(h_variable_4498,h_variable_58);
IsZeroMatrix(h_variable_4500);
nrows(h_variable_4499);
kill h_variable_3927;kill h_variable_3928;kill h_variable_3929;kill h_variable_3930;kill h_variable_3932;kill h_variable_3933;kill h_variable_3934;kill h_variable_3935;kill h_variable_3936;kill h_variable_3938;kill h_variable_3939;kill h_variable_3940;kill h_variable_3941;kill h_variable_3942;kill h_variable_3943;kill h_variable_3944;kill h_variable_3945;kill h_variable_3946;kill h_variable_3947;kill h_variable_3948;kill h_variable_3949;kill h_variable_3950;kill h_variable_3951;kill h_variable_3952;kill h_variable_3953;kill h_variable_3954;kill h_variable_3955;kill h_variable_3956;kill h_variable_3957;kill h_variable_3958;kill h_variable_3959;kill h_variable_3960;kill h_variable_3961;kill h_variable_3962;kill h_variable_3963;kill h_variable_3964;kill h_variable_3965;kill h_variable_3966;kill h_variable_3967;kill h_variable_3968;kill h_variable_3969;kill h_variable_3970;kill h_variable_3971;kill h_variable_3972;kill h_variable_3973;kill h_variable_3974;kill h_variable_3975;kill h_variable_3976;kill h_variable_3977;kill h_variable_3978;kill h_variable_3979;kill h_variable_3980;kill h_variable_3981;kill h_variable_3982;kill h_variable_3983;kill h_variable_3984;kill h_variable_3985;kill h_variable_3986;kill h_variable_3987;kill h_variable_3988;kill h_variable_3989;kill h_variable_3990;kill h_variable_3991;kill h_variable_3992;kill h_variable_3993;kill h_variable_3994;kill h_variable_3995;kill h_variable_3996;kill h_variable_3997;kill h_variable_3998;kill h_variable_3999;kill h_variable_4000;kill h_variable_4001;kill h_variable_4002;kill h_variable_4003;kill h_variable_4004;kill h_variable_4005;kill h_variable_4006;kill h_variable_4007;kill h_variable_4008;kill h_variable_4009;kill h_variable_4010;kill h_variable_4011;kill h_variable_4012;kill h_variable_4013;kill h_variable_4014;kill h_variable_4015;kill h_variable_4016;kill h_variable_4017;kill h_variable_4018;kill h_variable_4019;kill h_variable_4020;kill h_variable_4021;kill h_variable_4022;kill h_variable_4023;kill h_variable_4024;kill h_variable_4025;kill h_variable_4026;kill h_variable_4027;kill h_variable_4028;kill h_variable_4029;kill h_variable_4030;kill h_variable_4031;kill h_variable_4032;kill h_variable_4033;kill h_variable_4034;kill h_variable_4035;kill h_variable_4036;kill h_variable_4037;kill h_variable_4038;kill h_variable_4039;kill h_variable_4040;kill h_variable_4041;kill h_variable_4042;kill h_variable_4043;kill h_variable_4044;kill h_variable_4053;kill h_variable_4054;kill h_variable_4055;kill h_variable_4056;kill h_variable_4058;kill h_variable_4059;kill h_variable_4060;kill h_variable_4061;kill h_variable_4062;kill h_variable_4064;kill h_variable_4065;kill h_variable_4066;kill h_variable_4067;kill h_variable_4068;kill h_variable_4069;kill h_variable_4070;kill h_variable_4071;kill h_variable_4072;kill h_variable_4073;kill h_variable_4074;kill h_variable_4075;kill h_variable_4076;kill h_variable_4077;kill h_variable_4078;kill h_variable_4079;kill h_variable_4080;kill h_variable_4081;kill h_variable_4082;kill h_variable_4083;kill h_variable_4084;kill h_variable_4085;kill h_variable_4086;kill h_variable_4087;kill h_variable_4088;kill h_variable_4089;kill h_variable_4090;kill h_variable_4091;kill h_variable_4092;kill h_variable_4093;kill h_variable_4094;kill h_variable_4095;kill h_variable_4096;kill h_variable_4097;kill h_variable_4098;kill h_variable_4099;kill h_variable_4100;kill h_variable_4101;kill h_variable_4102;kill h_variable_4103;kill h_variable_4104;kill h_variable_4105;kill h_variable_4106;kill h_variable_4107;kill h_variable_4108;kill h_variable_4109;kill h_variable_4110;kill h_variable_4111;kill h_variable_4112;kill h_variable_4113;kill h_variable_4114;kill h_variable_4115;kill h_variable_4116;kill h_variable_4117;kill h_variable_4118;kill h_variable_4119;kill h_variable_4120;kill h_variable_4121;kill h_variable_4122;kill h_variable_4123;kill h_variable_4124;kill h_variable_4125;kill h_variable_4126;kill h_variable_4127;kill h_variable_4128;kill h_variable_4129;kill h_variable_4130;kill h_variable_4131;kill h_variable_4132;kill h_variable_4133;kill h_variable_4134;kill h_variable_4135;kill h_variable_4136;kill h_variable_4137;kill h_variable_4138;kill h_variable_4139;kill h_variable_4140;kill h_variable_4141;kill h_variable_4142;kill h_variable_4143;kill h_variable_4144;kill h_variable_4145;kill h_variable_4146;kill h_variable_4147;kill h_variable_4148;kill h_variable_4149;kill h_variable_4150;kill h_variable_4151;kill h_variable_4152;kill h_variable_4153;kill h_variable_4154;kill h_variable_4155;kill h_variable_4156;kill h_variable_4157;kill h_variable_4158;kill h_variable_4159;kill h_variable_4160;kill h_variable_4161;kill h_variable_4162;kill h_variable_4163;kill h_variable_4164;kill h_variable_4165;kill h_variable_4166;kill h_variable_4167;kill h_variable_4168;kill h_variable_4169;kill h_variable_4170;kill h_variable_4171;kill h_variable_4172;kill h_variable_4173;kill h_variable_4174;kill h_variable_4175;kill h_variable_4176;kill h_variable_4177;kill h_variable_4178;kill h_variable_4179;kill h_variable_4180;kill h_variable_4181;kill h_variable_4182;kill h_variable_4183;kill h_variable_4184;kill h_variable_4185;kill h_variable_4186;kill h_variable_4187;kill h_variable_4188;kill h_variable_4189;kill h_variable_4190;kill h_variable_4191;kill h_variable_4192;kill h_variable_4193;kill h_variable_4194;kill h_variable_4195;kill h_variable_4196;kill h_variable_4197;kill h_variable_4198;kill h_variable_4199;kill h_variable_4200;kill h_variable_4201;kill h_variable_4202;kill h_variable_4203;kill h_variable_4204;kill h_variable_4205;kill h_variable_4206;kill h_variable_4207;kill h_variable_4208;kill h_variable_4209;kill h_variable_4210;kill h_variable_4211;kill h_variable_4212;kill h_variable_4213;kill h_variable_4214;kill h_variable_4215;kill h_variable_4216;kill h_variable_4217;kill h_variable_4218;kill h_variable_4219;kill h_variable_4220;kill h_variable_4221;kill h_variable_4222;kill h_variable_4223;kill h_variable_4224;kill h_variable_4227;kill h_variable_4228;kill h_variable_4229;kill h_variable_4230;kill h_variable_4233;kill h_variable_4234;kill h_variable_4235;kill h_variable_4236;kill h_variable_4238;kill h_variable_4239;kill h_variable_4240;kill h_variable_4241;kill h_variable_4242;kill h_variable_4244;kill h_variable_4245;kill h_variable_4246;kill h_variable_4247;kill h_variable_4248;kill h_variable_4249;kill h_variable_4250;kill h_variable_4251;kill h_variable_4252;kill h_variable_4253;kill h_variable_4254;kill h_variable_4255;kill h_variable_4256;kill h_variable_4257;kill h_variable_4258;kill h_variable_4259;kill h_variable_4260;kill h_variable_4261;kill h_variable_4262;kill h_variable_4263;kill h_variable_4264;kill h_variable_4265;kill h_variable_4266;kill h_variable_4267;kill h_variable_4268;kill h_variable_4269;kill h_variable_4270;kill h_variable_4271;kill h_variable_4272;kill h_variable_4273;kill h_variable_4274;kill h_variable_4275;kill h_variable_4276;kill h_variable_4277;kill h_variable_4278;kill h_variable_4279;kill h_variable_4280;kill h_variable_4281;kill h_variable_4282;kill h_variable_4283;kill h_variable_4284;kill h_variable_4285;kill h_variable_4286;kill h_variable_4287;kill h_variable_4288;kill h_variable_4289;kill h_variable_4290;kill h_variable_4291;kill h_variable_4292;kill h_variable_4293;kill h_variable_4294;kill h_variable_4295;kill h_variable_4296;kill h_variable_4297;kill h_variable_4298;kill h_variable_4299;kill h_variable_4300;kill h_variable_4301;kill h_variable_4302;kill h_variable_4303;kill h_variable_4304;kill h_variable_4305;kill h_variable_4306;kill h_variable_4307;kill h_variable_4308;kill h_variable_4309;kill h_variable_4310;kill h_variable_4311;kill h_variable_4312;kill h_variable_4313;kill h_variable_4314;kill h_variable_4315;kill h_variable_4316;kill h_variable_4317;kill h_variable_4318;kill h_variable_4319;kill h_variable_4320;kill h_variable_4321;kill h_variable_4322;kill h_variable_4323;kill h_variable_4324;kill h_variable_4325;kill h_variable_4326;kill h_variable_4327;kill h_variable_4328;kill h_variable_4329;kill h_variable_4330;kill h_variable_4331;kill h_variable_4332;kill h_variable_4333;kill h_variable_4334;kill h_variable_4335;kill h_variable_4336;kill h_variable_4337;kill h_variable_4338;kill h_variable_4339;kill h_variable_4340;kill h_variable_4341;kill h_variable_4342;kill h_variable_4343;kill h_variable_4344;kill h_variable_4345;kill h_variable_4346;kill h_variable_4347;kill h_variable_4348;kill h_variable_4349;kill h_variable_4350;kill h_variable_4351;kill h_variable_4352;kill h_variable_4353;kill h_variable_4354;kill h_variable_4355;kill h_variable_4356;kill h_variable_4357;kill h_variable_4358;kill h_variable_4359;kill h_variable_4360;kill h_variable_4361;kill h_variable_4362;kill h_variable_4363;kill h_variable_4364;kill h_variable_4365;kill h_variable_4366;kill h_variable_4367;kill h_variable_4368;kill h_variable_4369;kill h_variable_4370;kill h_variable_4371;kill h_variable_4372;kill h_variable_4373;kill h_variable_4374;kill h_variable_4375;kill h_variable_4376;kill h_variable_4377;kill h_variable_4378;kill h_variable_4379;kill h_variable_4380;kill h_variable_4381;kill h_variable_4382;kill h_variable_4383;kill h_variable_4384;kill h_variable_4385;kill h_variable_4386;kill h_variable_4387;kill h_variable_4388;kill h_variable_4389;kill h_variable_4390;kill h_variable_4391;kill h_variable_4392;kill h_variable_4393;kill h_variable_4394;kill h_variable_4395;kill h_variable_4396;kill h_variable_4397;kill h_variable_4398;kill h_variable_4399;kill h_variable_4400;kill h_variable_4401;kill h_variable_4402;kill h_variable_4403;kill h_variable_4404;kill h_variable_4405;kill h_variable_4406;kill h_variable_4407;kill h_variable_4408;kill h_variable_4409;kill h_variable_4410;
def h_variable_4501 = h_variable_282[1,151];
h_variable_4501;
matrix h_variable_4502[1][1] = 0;
matrix h_variable_4503[1][3] = concat(h_variable_4502,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4503); matrix h_variable_4504 = h_variable_l[1]; matrix h_variable_4505 = h_variable_l[2];
ncols(h_variable_4504);
matrix h_variable_4506 = DecideZeroRows(h_variable_4504,h_variable_58);
IsZeroMatrix(h_variable_4506);
nrows(h_variable_4505);
def h_variable_4507 = h_variable_282[3,152];
h_variable_4507;
matrix h_variable_4508[1][1] = 0;
matrix h_variable_4509[1][3] = concat(h_variable_4508,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4509); matrix h_variable_4510 = h_variable_l[1]; matrix h_variable_4511 = h_variable_l[2];
ncols(h_variable_4510);
matrix h_variable_4512 = DecideZeroRows(h_variable_4510,h_variable_58);
IsZeroMatrix(h_variable_4512);
nrows(h_variable_4511);
def h_variable_4513 = h_variable_282[1,152];
h_variable_4513;
matrix h_variable_4514[1][1] = 0;
matrix h_variable_4515[1][3] = concat(h_variable_4514,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4515); matrix h_variable_4516 = h_variable_l[1]; matrix h_variable_4517 = h_variable_l[2];
ncols(h_variable_4516);
matrix h_variable_4518 = DecideZeroRows(h_variable_4516,h_variable_58);
IsZeroMatrix(h_variable_4518);
nrows(h_variable_4517);
def h_variable_4519 = h_variable_282[3,153];
h_variable_4519;
matrix h_variable_4520[1][1] = 0;
matrix h_variable_4521[1][3] = concat(h_variable_4520,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4521); matrix h_variable_4522 = h_variable_l[1]; matrix h_variable_4523 = h_variable_l[2];
ncols(h_variable_4522);
matrix h_variable_4524 = DecideZeroRows(h_variable_4522,h_variable_58);
IsZeroMatrix(h_variable_4524);
nrows(h_variable_4523);
def h_variable_4525 = h_variable_282[1,153];
h_variable_4525;
matrix h_variable_4526[1][1] = 0;
matrix h_variable_4527[1][3] = concat(h_variable_4526,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4527); matrix h_variable_4528 = h_variable_l[1]; matrix h_variable_4529 = h_variable_l[2];
ncols(h_variable_4528);
matrix h_variable_4530 = DecideZeroRows(h_variable_4528,h_variable_58);
IsZeroMatrix(h_variable_4530);
nrows(h_variable_4529);
def h_variable_4531 = h_variable_282[3,154];
h_variable_4531;
matrix h_variable_4532[1][1] = 0;
matrix h_variable_4533[1][3] = concat(h_variable_4532,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4533); matrix h_variable_4534 = h_variable_l[1]; matrix h_variable_4535 = h_variable_l[2];
ncols(h_variable_4534);
matrix h_variable_4536 = DecideZeroRows(h_variable_4534,h_variable_58);
IsZeroMatrix(h_variable_4536);
nrows(h_variable_4535);
def h_variable_4537 = h_variable_282[1,154];
h_variable_4537;
matrix h_variable_4538[1][1] = 0;
matrix h_variable_4539[1][3] = concat(h_variable_4538,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4539); matrix h_variable_4540 = h_variable_l[1]; matrix h_variable_4541 = h_variable_l[2];
ncols(h_variable_4540);
matrix h_variable_4542 = DecideZeroRows(h_variable_4540,h_variable_58);
IsZeroMatrix(h_variable_4542);
nrows(h_variable_4541);
def h_variable_4543 = h_variable_282[3,155];
h_variable_4543;
matrix h_variable_4544[1][1] = 0;
matrix h_variable_4545[1][3] = concat(h_variable_4544,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4545); matrix h_variable_4546 = h_variable_l[1]; matrix h_variable_4547 = h_variable_l[2];
ncols(h_variable_4546);
matrix h_variable_4548 = DecideZeroRows(h_variable_4546,h_variable_58);
IsZeroMatrix(h_variable_4548);
nrows(h_variable_4547);
def h_variable_4549 = h_variable_282[1,155];
h_variable_4549;
matrix h_variable_4550[1][1] = 0;
matrix h_variable_4551[1][3] = concat(h_variable_4550,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4551); matrix h_variable_4552 = h_variable_l[1]; matrix h_variable_4553 = h_variable_l[2];
ncols(h_variable_4552);
matrix h_variable_4554 = DecideZeroRows(h_variable_4552,h_variable_58);
IsZeroMatrix(h_variable_4554);
nrows(h_variable_4553);
def h_variable_4555 = h_variable_282[3,156];
h_variable_4555;
matrix h_variable_4556[1][1] = 0;
matrix h_variable_4557[1][3] = concat(h_variable_4556,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4557); matrix h_variable_4558 = h_variable_l[1]; matrix h_variable_4559 = h_variable_l[2];
ncols(h_variable_4558);
matrix h_variable_4560 = DecideZeroRows(h_variable_4558,h_variable_58);
IsZeroMatrix(h_variable_4560);
nrows(h_variable_4559);
def h_variable_4561 = h_variable_282[1,156];
h_variable_4561;
matrix h_variable_4562[1][1] = 0;
matrix h_variable_4563[1][3] = concat(h_variable_4562,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4563); matrix h_variable_4564 = h_variable_l[1]; matrix h_variable_4565 = h_variable_l[2];
ncols(h_variable_4564);
matrix h_variable_4566 = DecideZeroRows(h_variable_4564,h_variable_58);
IsZeroMatrix(h_variable_4566);
nrows(h_variable_4565);
def h_variable_4567 = h_variable_282[3,157];
h_variable_4567;
matrix h_variable_4568[1][1] = 0;
matrix h_variable_4569[1][3] = concat(h_variable_4568,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4569); matrix h_variable_4570 = h_variable_l[1]; matrix h_variable_4571 = h_variable_l[2];
ncols(h_variable_4570);
matrix h_variable_4572 = DecideZeroRows(h_variable_4570,h_variable_58);
IsZeroMatrix(h_variable_4572);
nrows(h_variable_4571);
def h_variable_4573 = h_variable_282[1,157];
h_variable_4573;
matrix h_variable_4574[1][1] = 0;
matrix h_variable_4575[1][3] = concat(h_variable_4574,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4575); matrix h_variable_4576 = h_variable_l[1]; matrix h_variable_4577 = h_variable_l[2];
ncols(h_variable_4576);
matrix h_variable_4578 = DecideZeroRows(h_variable_4576,h_variable_58);
IsZeroMatrix(h_variable_4578);
nrows(h_variable_4577);
def h_variable_4579 = h_variable_282[3,158];
h_variable_4579;
matrix h_variable_4580[1][1] = 0;
matrix h_variable_4581[1][3] = concat(h_variable_4580,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4581); matrix h_variable_4582 = h_variable_l[1]; matrix h_variable_4583 = h_variable_l[2];
ncols(h_variable_4582);
matrix h_variable_4584 = DecideZeroRows(h_variable_4582,h_variable_58);
IsZeroMatrix(h_variable_4584);
nrows(h_variable_4583);
def h_variable_4585 = h_variable_282[1,158];
h_variable_4585;
matrix h_variable_4586[1][1] = 0;
matrix h_variable_4587[1][3] = concat(h_variable_4586,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4587); matrix h_variable_4588 = h_variable_l[1]; matrix h_variable_4589 = h_variable_l[2];
ncols(h_variable_4588);
matrix h_variable_4590 = DecideZeroRows(h_variable_4588,h_variable_58);
IsZeroMatrix(h_variable_4590);
nrows(h_variable_4589);
def h_variable_4591 = h_variable_282[3,159];
h_variable_4591;
matrix h_variable_4592[1][1] = 0;
matrix h_variable_4593[1][3] = concat(h_variable_4592,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4593); matrix h_variable_4594 = h_variable_l[1]; matrix h_variable_4595 = h_variable_l[2];
ncols(h_variable_4594);
matrix h_variable_4596 = DecideZeroRows(h_variable_4594,h_variable_58);
IsZeroMatrix(h_variable_4596);
nrows(h_variable_4595);
def h_variable_4597 = h_variable_282[1,159];
h_variable_4597;
matrix h_variable_4598[1][1] = 0;
matrix h_variable_4599[1][3] = concat(h_variable_4598,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4599); matrix h_variable_4600 = h_variable_l[1]; matrix h_variable_4601 = h_variable_l[2];
ncols(h_variable_4600);
matrix h_variable_4602 = DecideZeroRows(h_variable_4600,h_variable_58);
IsZeroMatrix(h_variable_4602);
nrows(h_variable_4601);
def h_variable_4603 = h_variable_282[3,160];
h_variable_4603;
matrix h_variable_4604[1][1] = 0;
matrix h_variable_4605[1][3] = concat(h_variable_4604,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4605); matrix h_variable_4606 = h_variable_l[1]; matrix h_variable_4607 = h_variable_l[2];
ncols(h_variable_4606);
matrix h_variable_4608 = DecideZeroRows(h_variable_4606,h_variable_58);
IsZeroMatrix(h_variable_4608);
nrows(h_variable_4607);
def h_variable_4609 = h_variable_282[1,160];
h_variable_4609;
matrix h_variable_4610[1][1] = 0;
matrix h_variable_4611[1][3] = concat(h_variable_4610,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4611); matrix h_variable_4612 = h_variable_l[1]; matrix h_variable_4613 = h_variable_l[2];
ncols(h_variable_4612);
matrix h_variable_4614 = DecideZeroRows(h_variable_4612,h_variable_58);
IsZeroMatrix(h_variable_4614);
nrows(h_variable_4613);
def h_variable_4615 = h_variable_282[3,161];
h_variable_4615;
matrix h_variable_4616[1][1] = 0;
matrix h_variable_4617[1][3] = concat(h_variable_4616,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4617); matrix h_variable_4618 = h_variable_l[1]; matrix h_variable_4619 = h_variable_l[2];
ncols(h_variable_4618);
matrix h_variable_4620 = DecideZeroRows(h_variable_4618,h_variable_58);
IsZeroMatrix(h_variable_4620);
nrows(h_variable_4619);
def h_variable_4621 = h_variable_282[1,161];
h_variable_4621;
matrix h_variable_4622[1][1] = 0;
matrix h_variable_4623[1][3] = concat(h_variable_4622,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4623); matrix h_variable_4624 = h_variable_l[1]; matrix h_variable_4625 = h_variable_l[2];
ncols(h_variable_4624);
matrix h_variable_4626 = DecideZeroRows(h_variable_4624,h_variable_58);
IsZeroMatrix(h_variable_4626);
nrows(h_variable_4625);
def h_variable_4627 = h_variable_282[3,162];
h_variable_4627;
matrix h_variable_4628[1][1] = 0;
matrix h_variable_4629[1][3] = concat(h_variable_4628,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4629); matrix h_variable_4630 = h_variable_l[1]; matrix h_variable_4631 = h_variable_l[2];
ncols(h_variable_4630);
matrix h_variable_4632 = DecideZeroRows(h_variable_4630,h_variable_58);
IsZeroMatrix(h_variable_4632);
nrows(h_variable_4631);
def h_variable_4633 = h_variable_282[1,162];
h_variable_4633;
matrix h_variable_4634[1][1] = 0;
matrix h_variable_4635[1][3] = concat(h_variable_4634,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4635); matrix h_variable_4636 = h_variable_l[1]; matrix h_variable_4637 = h_variable_l[2];
ncols(h_variable_4636);
matrix h_variable_4638 = DecideZeroRows(h_variable_4636,h_variable_58);
IsZeroMatrix(h_variable_4638);
nrows(h_variable_4637);
def h_variable_4639 = h_variable_282[3,163];
h_variable_4639;
matrix h_variable_4640[1][1] = 0;
matrix h_variable_4641[1][3] = concat(h_variable_4640,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4641); matrix h_variable_4642 = h_variable_l[1]; matrix h_variable_4643 = h_variable_l[2];
ncols(h_variable_4642);
matrix h_variable_4644 = DecideZeroRows(h_variable_4642,h_variable_58);
IsZeroMatrix(h_variable_4644);
nrows(h_variable_4643);
def h_variable_4645 = h_variable_282[1,163];
h_variable_4645;
matrix h_variable_4646[1][1] = 0;
matrix h_variable_4647[1][3] = concat(h_variable_4646,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4647); matrix h_variable_4648 = h_variable_l[1]; matrix h_variable_4649 = h_variable_l[2];
ncols(h_variable_4648);
matrix h_variable_4650 = DecideZeroRows(h_variable_4648,h_variable_58);
IsZeroMatrix(h_variable_4650);
nrows(h_variable_4649);
def h_variable_4651 = h_variable_282[3,164];
h_variable_4651;
matrix h_variable_4652[1][1] = 0;
matrix h_variable_4653[1][3] = concat(h_variable_4652,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4653); matrix h_variable_4654 = h_variable_l[1]; matrix h_variable_4655 = h_variable_l[2];
ncols(h_variable_4654);
matrix h_variable_4656 = DecideZeroRows(h_variable_4654,h_variable_58);
IsZeroMatrix(h_variable_4656);
nrows(h_variable_4655);
def h_variable_4657 = h_variable_282[1,164];
h_variable_4657;
matrix h_variable_4658[1][1] = 0;
matrix h_variable_4659[1][3] = concat(h_variable_4658,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4659); matrix h_variable_4660 = h_variable_l[1]; matrix h_variable_4661 = h_variable_l[2];
ncols(h_variable_4660);
matrix h_variable_4662 = DecideZeroRows(h_variable_4660,h_variable_58);
IsZeroMatrix(h_variable_4662);
nrows(h_variable_4661);
def h_variable_4663 = h_variable_282[3,165];
h_variable_4663;
matrix h_variable_4664[1][1] = 0;
matrix h_variable_4665[1][3] = concat(h_variable_4664,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4665); matrix h_variable_4666 = h_variable_l[1]; matrix h_variable_4667 = h_variable_l[2];
ncols(h_variable_4666);
matrix h_variable_4668 = DecideZeroRows(h_variable_4666,h_variable_58);
IsZeroMatrix(h_variable_4668);
nrows(h_variable_4667);
def h_variable_4669 = h_variable_282[1,165];
h_variable_4669;
matrix h_variable_4670[1][1] = 0;
matrix h_variable_4671[1][3] = concat(h_variable_4670,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4671); matrix h_variable_4672 = h_variable_l[1]; matrix h_variable_4673 = h_variable_l[2];
ncols(h_variable_4672);
matrix h_variable_4674 = DecideZeroRows(h_variable_4672,h_variable_58);
IsZeroMatrix(h_variable_4674);
nrows(h_variable_4673);
def h_variable_4675 = h_variable_282[3,166];
h_variable_4675;
matrix h_variable_4676[1][1] = 0;
matrix h_variable_4677[1][3] = concat(h_variable_4676,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4677); matrix h_variable_4678 = h_variable_l[1]; matrix h_variable_4679 = h_variable_l[2];
ncols(h_variable_4678);
matrix h_variable_4680 = DecideZeroRows(h_variable_4678,h_variable_58);
IsZeroMatrix(h_variable_4680);
nrows(h_variable_4679);
def h_variable_4681 = h_variable_282[1,166];
h_variable_4681;
matrix h_variable_4682[1][1] = 0;
matrix h_variable_4683[1][3] = concat(h_variable_4682,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4683); matrix h_variable_4684 = h_variable_l[1]; matrix h_variable_4685 = h_variable_l[2];
ncols(h_variable_4684);
matrix h_variable_4686 = DecideZeroRows(h_variable_4684,h_variable_58);
IsZeroMatrix(h_variable_4686);
nrows(h_variable_4685);
def h_variable_4687 = h_variable_282[3,167];
h_variable_4687;
matrix h_variable_4688[1][1] = 0;
matrix h_variable_4689[1][3] = concat(h_variable_4688,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4689); matrix h_variable_4690 = h_variable_l[1]; matrix h_variable_4691 = h_variable_l[2];
ncols(h_variable_4690);
matrix h_variable_4692 = DecideZeroRows(h_variable_4690,h_variable_58);
IsZeroMatrix(h_variable_4692);
nrows(h_variable_4691);
def h_variable_4693 = h_variable_282[1,167];
h_variable_4693;
matrix h_variable_4694[1][1] = 0;
matrix h_variable_4695[1][3] = concat(h_variable_4694,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4695); matrix h_variable_4696 = h_variable_l[1]; matrix h_variable_4697 = h_variable_l[2];
ncols(h_variable_4696);
matrix h_variable_4698 = DecideZeroRows(h_variable_4696,h_variable_58);
IsZeroMatrix(h_variable_4698);
nrows(h_variable_4697);
def h_variable_4699 = h_variable_282[3,168];
h_variable_4699;
matrix h_variable_4700[1][1] = 0;
matrix h_variable_4701[1][3] = concat(h_variable_4700,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4701); matrix h_variable_4702 = h_variable_l[1]; matrix h_variable_4703 = h_variable_l[2];
ncols(h_variable_4702);
matrix h_variable_4704 = DecideZeroRows(h_variable_4702,h_variable_58);
IsZeroMatrix(h_variable_4704);
nrows(h_variable_4703);
def h_variable_4705 = h_variable_282[1,168];
h_variable_4705;
matrix h_variable_4706[1][1] = 0;
matrix h_variable_4707[1][3] = concat(h_variable_4706,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4707); matrix h_variable_4708 = h_variable_l[1]; matrix h_variable_4709 = h_variable_l[2];
ncols(h_variable_4708);
matrix h_variable_4710 = DecideZeroRows(h_variable_4708,h_variable_58);
IsZeroMatrix(h_variable_4710);
nrows(h_variable_4709);
def h_variable_4711 = h_variable_282[3,169];
h_variable_4711;
matrix h_variable_4712[1][1] = 0;
matrix h_variable_4713[1][3] = concat(h_variable_4712,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4713); matrix h_variable_4714 = h_variable_l[1]; matrix h_variable_4715 = h_variable_l[2];
ncols(h_variable_4714);
matrix h_variable_4716 = DecideZeroRows(h_variable_4714,h_variable_58);
IsZeroMatrix(h_variable_4716);
nrows(h_variable_4715);
def h_variable_4717 = h_variable_282[1,169];
h_variable_4717;
matrix h_variable_4718[1][1] = 0;
matrix h_variable_4719[1][3] = concat(h_variable_4718,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4719); matrix h_variable_4720 = h_variable_l[1]; matrix h_variable_4721 = h_variable_l[2];
ncols(h_variable_4720);
matrix h_variable_4722 = DecideZeroRows(h_variable_4720,h_variable_58);
IsZeroMatrix(h_variable_4722);
nrows(h_variable_4721);
def h_variable_4723 = h_variable_282[3,170];
h_variable_4723;
matrix h_variable_4724[1][1] = 0;
matrix h_variable_4725[1][3] = concat(h_variable_4724,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4725); matrix h_variable_4726 = h_variable_l[1]; matrix h_variable_4727 = h_variable_l[2];
ncols(h_variable_4726);
matrix h_variable_4728 = DecideZeroRows(h_variable_4726,h_variable_58);
IsZeroMatrix(h_variable_4728);
nrows(h_variable_4727);
def h_variable_4729 = h_variable_282[1,170];
h_variable_4729;
matrix h_variable_4730[1][1] = 0;
matrix h_variable_4731[1][3] = concat(h_variable_4730,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4731); matrix h_variable_4732 = h_variable_l[1]; matrix h_variable_4733 = h_variable_l[2];
ncols(h_variable_4732);
matrix h_variable_4734 = DecideZeroRows(h_variable_4732,h_variable_58);
IsZeroMatrix(h_variable_4734);
nrows(h_variable_4733);
def h_variable_4735 = h_variable_282[3,171];
h_variable_4735;
matrix h_variable_4736[1][1] = 0;
matrix h_variable_4737[1][3] = concat(h_variable_4736,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4737); matrix h_variable_4738 = h_variable_l[1]; matrix h_variable_4739 = h_variable_l[2];
ncols(h_variable_4738);
matrix h_variable_4740 = DecideZeroRows(h_variable_4738,h_variable_58);
IsZeroMatrix(h_variable_4740);
nrows(h_variable_4739);
def h_variable_4741 = h_variable_282[1,171];
h_variable_4741;
matrix h_variable_4742[1][1] = 0;
matrix h_variable_4743[1][3] = concat(h_variable_4742,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4743); matrix h_variable_4744 = h_variable_l[1]; matrix h_variable_4745 = h_variable_l[2];
ncols(h_variable_4744);
matrix h_variable_4746 = DecideZeroRows(h_variable_4744,h_variable_58);
IsZeroMatrix(h_variable_4746);
nrows(h_variable_4745);
def h_variable_4747 = h_variable_282[3,172];
h_variable_4747;
matrix h_variable_4748[1][1] = 0;
matrix h_variable_4749[1][3] = concat(h_variable_4748,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4749); matrix h_variable_4750 = h_variable_l[1]; matrix h_variable_4751 = h_variable_l[2];
ncols(h_variable_4750);
matrix h_variable_4752 = DecideZeroRows(h_variable_4750,h_variable_58);
IsZeroMatrix(h_variable_4752);
nrows(h_variable_4751);
def h_variable_4753 = h_variable_282[1,172];
h_variable_4753;
matrix h_variable_4754[1][1] = 0;
matrix h_variable_4755[1][3] = concat(h_variable_4754,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4755); matrix h_variable_4756 = h_variable_l[1]; matrix h_variable_4757 = h_variable_l[2];
ncols(h_variable_4756);
matrix h_variable_4758 = DecideZeroRows(h_variable_4756,h_variable_58);
IsZeroMatrix(h_variable_4758);
nrows(h_variable_4757);
def h_variable_4759 = h_variable_282[3,173];
h_variable_4759;
matrix h_variable_4760[1][1] = 0;
matrix h_variable_4761[1][3] = concat(h_variable_4760,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4761); matrix h_variable_4762 = h_variable_l[1]; matrix h_variable_4763 = h_variable_l[2];
ncols(h_variable_4762);
matrix h_variable_4764 = DecideZeroRows(h_variable_4762,h_variable_58);
IsZeroMatrix(h_variable_4764);
nrows(h_variable_4763);
def h_variable_4765 = h_variable_282[1,173];
h_variable_4765;
matrix h_variable_4766[1][1] = 0;
matrix h_variable_4767[1][3] = concat(h_variable_4766,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4767); matrix h_variable_4768 = h_variable_l[1]; matrix h_variable_4769 = h_variable_l[2];
ncols(h_variable_4768);
matrix h_variable_4770 = DecideZeroRows(h_variable_4768,h_variable_58);
IsZeroMatrix(h_variable_4770);
nrows(h_variable_4769);
def h_variable_4771 = h_variable_282[3,174];
h_variable_4771;
matrix h_variable_4772[1][1] = 0;
matrix h_variable_4773[1][3] = concat(h_variable_4772,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4773); matrix h_variable_4774 = h_variable_l[1]; matrix h_variable_4775 = h_variable_l[2];
ncols(h_variable_4774);
matrix h_variable_4776 = DecideZeroRows(h_variable_4774,h_variable_58);
IsZeroMatrix(h_variable_4776);
nrows(h_variable_4775);
def h_variable_4777 = h_variable_282[1,174];
h_variable_4777;
matrix h_variable_4778[1][1] = 0;
matrix h_variable_4779[1][3] = concat(h_variable_4778,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4779); matrix h_variable_4780 = h_variable_l[1]; matrix h_variable_4781 = h_variable_l[2];
ncols(h_variable_4780);
matrix h_variable_4782 = DecideZeroRows(h_variable_4780,h_variable_58);
IsZeroMatrix(h_variable_4782);
nrows(h_variable_4781);
def h_variable_4783 = h_variable_282[3,175];
h_variable_4783;
matrix h_variable_4784[1][1] = 0;
matrix h_variable_4785[1][3] = concat(h_variable_4784,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4785); matrix h_variable_4786 = h_variable_l[1]; matrix h_variable_4787 = h_variable_l[2];
ncols(h_variable_4786);
matrix h_variable_4788 = DecideZeroRows(h_variable_4786,h_variable_58);
IsZeroMatrix(h_variable_4788);
nrows(h_variable_4787);
def h_variable_4789 = h_variable_282[1,175];
h_variable_4789;
matrix h_variable_4790[1][1] = 0;
matrix h_variable_4791[1][3] = concat(h_variable_4790,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4791); matrix h_variable_4792 = h_variable_l[1]; matrix h_variable_4793 = h_variable_l[2];
ncols(h_variable_4792);
matrix h_variable_4794 = DecideZeroRows(h_variable_4792,h_variable_58);
IsZeroMatrix(h_variable_4794);
nrows(h_variable_4793);
def h_variable_4795 = h_variable_282[3,176];
h_variable_4795;
matrix h_variable_4796[1][1] = 0;
matrix h_variable_4797[1][3] = concat(h_variable_4796,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4797); matrix h_variable_4798 = h_variable_l[1]; matrix h_variable_4799 = h_variable_l[2];
ncols(h_variable_4798);
matrix h_variable_4800 = DecideZeroRows(h_variable_4798,h_variable_58);
IsZeroMatrix(h_variable_4800);
nrows(h_variable_4799);
def h_variable_4801 = h_variable_282[1,176];
h_variable_4801;
matrix h_variable_4802[1][1] = 0;
matrix h_variable_4803[1][3] = concat(h_variable_4802,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4803); matrix h_variable_4804 = h_variable_l[1]; matrix h_variable_4805 = h_variable_l[2];
ncols(h_variable_4804);
matrix h_variable_4806 = DecideZeroRows(h_variable_4804,h_variable_58);
IsZeroMatrix(h_variable_4806);
nrows(h_variable_4805);
matrix h_variable_4808 = submat(h_variable_275,1..3,intvec( 1, 3, 4, 5, 6, 7, 8, 11, 12, 13, 14, 15, 17, 18, 20, 22 ));
matrix h_variable_4809[3][6] = dsum(h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_4807 = DecideZeroRows(h_variable_4808,h_variable_4809);
IsZeroMatrix(h_variable_4807);
matrix h_variable_4811[3][6] = dsum(h_variable_48,h_variable_48,h_variable_48);
matrix h_variable_4810 = RelativeSyzygiesGeneratorsOfRows(h_variable_4807,h_variable_4811);
IsZeroMatrix(h_variable_4810);
ncols(h_variable_4810);
matrix h_variable_4813[16][32] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_4812 = DecideZeroRows(h_variable_4810,h_variable_4813);
IsZeroMatrix(h_variable_4812);
ZeroRows(h_variable_4812);
matrix h_variable_4815 = submat(h_variable_4810,1..16,intvec( 2, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156 ));
matrix h_variable_4816[16][32] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_4814 = DecideZeroRows(h_variable_4815,h_variable_4816);
IsZeroMatrix(h_variable_4814);
def h_variable_4817 = h_variable_4814[16,1];
h_variable_4817;
matrix h_variable_4818[1][1] = 0;
matrix h_variable_4819[1][3] = concat(h_variable_4818,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4819); matrix h_variable_4820 = h_variable_l[1]; matrix h_variable_4821 = h_variable_l[2];
ncols(h_variable_4820);
matrix h_variable_4822 = DecideZeroRows(h_variable_4820,h_variable_58);
IsZeroMatrix(h_variable_4822);
nrows(h_variable_4821);
def h_variable_4823 = h_variable_4814[15,1];
h_variable_4823;
matrix h_variable_4824[1][1] = 0;
matrix h_variable_4825[1][3] = concat(h_variable_4824,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4825); matrix h_variable_4826 = h_variable_l[1]; matrix h_variable_4827 = h_variable_l[2];
ncols(h_variable_4826);
matrix h_variable_4828 = DecideZeroRows(h_variable_4826,h_variable_58);
IsZeroMatrix(h_variable_4828);
nrows(h_variable_4827);
def h_variable_4829 = h_variable_4814[14,1];
h_variable_4829;
matrix h_variable_4830[1][1] = 0;
matrix h_variable_4831[1][3] = concat(h_variable_4830,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4831); matrix h_variable_4832 = h_variable_l[1]; matrix h_variable_4833 = h_variable_l[2];
ncols(h_variable_4832);
matrix h_variable_4834 = DecideZeroRows(h_variable_4832,h_variable_58);
IsZeroMatrix(h_variable_4834);
nrows(h_variable_4833);
def h_variable_4835 = h_variable_4814[13,1];
h_variable_4835;
matrix h_variable_4836[1][1] = 0;
matrix h_variable_4837[1][3] = concat(h_variable_4836,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4837); matrix h_variable_4838 = h_variable_l[1]; matrix h_variable_4839 = h_variable_l[2];
ncols(h_variable_4838);
matrix h_variable_4840 = DecideZeroRows(h_variable_4838,h_variable_58);
IsZeroMatrix(h_variable_4840);
nrows(h_variable_4839);
def h_variable_4841 = h_variable_4814[12,1];
h_variable_4841;
matrix h_variable_4842[1][1] = 0;
matrix h_variable_4843[1][3] = concat(h_variable_4842,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4843); matrix h_variable_4844 = h_variable_l[1]; matrix h_variable_4845 = h_variable_l[2];
ncols(h_variable_4844);
matrix h_variable_4846 = DecideZeroRows(h_variable_4844,h_variable_58);
IsZeroMatrix(h_variable_4846);
nrows(h_variable_4845);
def h_variable_4847 = h_variable_4814[11,1];
h_variable_4847;
matrix h_variable_4848[1][1] = 0;
matrix h_variable_4849[1][3] = concat(h_variable_4848,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4849); matrix h_variable_4850 = h_variable_l[1]; matrix h_variable_4851 = h_variable_l[2];
ncols(h_variable_4850);
matrix h_variable_4852 = DecideZeroRows(h_variable_4850,h_variable_58);
IsZeroMatrix(h_variable_4852);
nrows(h_variable_4851);
def h_variable_4853 = h_variable_4814[10,1];
h_variable_4853;
matrix h_variable_4854[1][1] = 0;
matrix h_variable_4855[1][3] = concat(h_variable_4854,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4855); matrix h_variable_4856 = h_variable_l[1]; matrix h_variable_4857 = h_variable_l[2];
ncols(h_variable_4856);
matrix h_variable_4858 = DecideZeroRows(h_variable_4856,h_variable_58);
IsZeroMatrix(h_variable_4858);
nrows(h_variable_4857);
def h_variable_4859 = h_variable_4814[9,1];
h_variable_4859;
matrix h_variable_4860[1][1] = 0;
matrix h_variable_4861[1][3] = concat(h_variable_4860,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4861); matrix h_variable_4862 = h_variable_l[1]; matrix h_variable_4863 = h_variable_l[2];
ncols(h_variable_4862);
matrix h_variable_4864 = DecideZeroRows(h_variable_4862,h_variable_58);
IsZeroMatrix(h_variable_4864);
nrows(h_variable_4863);
def h_variable_4865 = h_variable_4814[8,1];
h_variable_4865;
matrix h_variable_4866[1][1] = 0;
matrix h_variable_4867[1][3] = concat(h_variable_4866,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4867); matrix h_variable_4868 = h_variable_l[1]; matrix h_variable_4869 = h_variable_l[2];
ncols(h_variable_4868);
matrix h_variable_4870 = DecideZeroRows(h_variable_4868,h_variable_58);
IsZeroMatrix(h_variable_4870);
nrows(h_variable_4869);
def h_variable_4871 = h_variable_4814[7,1];
h_variable_4871;
matrix h_variable_4872[1][1] = 0;
matrix h_variable_4873[1][3] = concat(h_variable_4872,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4873); matrix h_variable_4874 = h_variable_l[1]; matrix h_variable_4875 = h_variable_l[2];
ncols(h_variable_4874);
matrix h_variable_4876 = DecideZeroRows(h_variable_4874,h_variable_58);
IsZeroMatrix(h_variable_4876);
nrows(h_variable_4875);
def h_variable_4877 = h_variable_4814[6,1];
h_variable_4877;
matrix h_variable_4878[1][1] = 0;
matrix h_variable_4879[1][3] = concat(h_variable_4878,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4879); matrix h_variable_4880 = h_variable_l[1]; matrix h_variable_4881 = h_variable_l[2];
ncols(h_variable_4880);
matrix h_variable_4882 = DecideZeroRows(h_variable_4880,h_variable_58);
IsZeroMatrix(h_variable_4882);
nrows(h_variable_4881);
def h_variable_4883 = h_variable_4814[5,1];
h_variable_4883;
matrix h_variable_4884[1][1] = 0;
matrix h_variable_4885[1][3] = concat(h_variable_4884,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4885); matrix h_variable_4886 = h_variable_l[1]; matrix h_variable_4887 = h_variable_l[2];
ncols(h_variable_4886);
matrix h_variable_4888 = DecideZeroRows(h_variable_4886,h_variable_58);
IsZeroMatrix(h_variable_4888);
nrows(h_variable_4887);
def h_variable_4889 = h_variable_4814[4,1];
h_variable_4889;
matrix h_variable_4890[1][1] = 0;
matrix h_variable_4891[1][3] = concat(h_variable_4890,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4891); matrix h_variable_4892 = h_variable_l[1]; matrix h_variable_4893 = h_variable_l[2];
ncols(h_variable_4892);
matrix h_variable_4894 = DecideZeroRows(h_variable_4892,h_variable_58);
IsZeroMatrix(h_variable_4894);
nrows(h_variable_4893);
def h_variable_4895 = h_variable_4814[3,1];
h_variable_4895;
matrix h_variable_4896[1][1] = 0;
matrix h_variable_4897[1][3] = concat(h_variable_4896,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4897); matrix h_variable_4898 = h_variable_l[1]; matrix h_variable_4899 = h_variable_l[2];
ncols(h_variable_4898);
matrix h_variable_4900 = DecideZeroRows(h_variable_4898,h_variable_58);
IsZeroMatrix(h_variable_4900);
nrows(h_variable_4899);
def h_variable_4901 = h_variable_4814[2,1];
h_variable_4901;
matrix h_variable_4902[1][1] = 3;
matrix h_variable_4903[1][3] = concat(h_variable_4902,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4903); matrix h_variable_4904 = h_variable_l[1]; matrix h_variable_4905 = h_variable_l[2];
ncols(h_variable_4904);
matrix h_variable_4906 = DecideZeroRows(h_variable_4904,h_variable_58);
IsZeroMatrix(h_variable_4906);
ZeroRows(h_variable_4906);
nrows(h_variable_4905);
matrix h_variable_4908 = submat(h_variable_4904,1..1,intvec( 1 ));
matrix h_variable_4907 = DecideZeroRows(h_variable_4908,h_variable_58);
IsZeroMatrix(h_variable_4907);
IsIdentityMatrix(h_variable_4907);
matrix h_variable_4909[1][3] = concat(h_variable_4907,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_4909); matrix h_variable_4910 = h_variable_l[1]; matrix h_variable_4911 = h_variable_l[2];
IsZeroMatrix(h_variable_4910);
matrix h_variable_4912 = DecideZeroRows(h_variable_4910,h_variable_58);
IsZeroMatrix(h_variable_4912);
def h_variable_4913 = h_variable_4814[1,1];
h_variable_4913;
matrix h_variable_4914[1][1] = 0;
matrix h_variable_4915[1][3] = concat(h_variable_4914,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4915); matrix h_variable_4916 = h_variable_l[1]; matrix h_variable_4917 = h_variable_l[2];
ncols(h_variable_4916);
matrix h_variable_4918 = DecideZeroRows(h_variable_4916,h_variable_58);
IsZeroMatrix(h_variable_4918);
nrows(h_variable_4917);
def h_variable_4919 = h_variable_4814[16,2];
h_variable_4919;
matrix h_variable_4920[1][1] = 0;
matrix h_variable_4921[1][3] = concat(h_variable_4920,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4921); matrix h_variable_4922 = h_variable_l[1]; matrix h_variable_4923 = h_variable_l[2];
ncols(h_variable_4922);
matrix h_variable_4924 = DecideZeroRows(h_variable_4922,h_variable_58);
IsZeroMatrix(h_variable_4924);
nrows(h_variable_4923);
def h_variable_4925 = h_variable_4814[15,2];
h_variable_4925;
matrix h_variable_4926[1][1] = 0;
matrix h_variable_4927[1][3] = concat(h_variable_4926,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4927); matrix h_variable_4928 = h_variable_l[1]; matrix h_variable_4929 = h_variable_l[2];
ncols(h_variable_4928);
matrix h_variable_4930 = DecideZeroRows(h_variable_4928,h_variable_58);
IsZeroMatrix(h_variable_4930);
nrows(h_variable_4929);
def h_variable_4931 = h_variable_4814[14,2];
h_variable_4931;
matrix h_variable_4932[1][1] = 0;
matrix h_variable_4933[1][3] = concat(h_variable_4932,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4933); matrix h_variable_4934 = h_variable_l[1]; matrix h_variable_4935 = h_variable_l[2];
ncols(h_variable_4934);
matrix h_variable_4936 = DecideZeroRows(h_variable_4934,h_variable_58);
IsZeroMatrix(h_variable_4936);
nrows(h_variable_4935);
def h_variable_4937 = h_variable_4814[13,2];
h_variable_4937;
matrix h_variable_4938[1][1] = 0;
matrix h_variable_4939[1][3] = concat(h_variable_4938,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4939); matrix h_variable_4940 = h_variable_l[1]; matrix h_variable_4941 = h_variable_l[2];
ncols(h_variable_4940);
matrix h_variable_4942 = DecideZeroRows(h_variable_4940,h_variable_58);
IsZeroMatrix(h_variable_4942);
nrows(h_variable_4941);
def h_variable_4943 = h_variable_4814[12,2];
h_variable_4943;
matrix h_variable_4944[1][1] = 0;
matrix h_variable_4945[1][3] = concat(h_variable_4944,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4945); matrix h_variable_4946 = h_variable_l[1]; matrix h_variable_4947 = h_variable_l[2];
ncols(h_variable_4946);
matrix h_variable_4948 = DecideZeroRows(h_variable_4946,h_variable_58);
IsZeroMatrix(h_variable_4948);
nrows(h_variable_4947);
def h_variable_4949 = h_variable_4814[11,2];
h_variable_4949;
matrix h_variable_4950[1][1] = 0;
matrix h_variable_4951[1][3] = concat(h_variable_4950,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4951); matrix h_variable_4952 = h_variable_l[1]; matrix h_variable_4953 = h_variable_l[2];
ncols(h_variable_4952);
matrix h_variable_4954 = DecideZeroRows(h_variable_4952,h_variable_58);
IsZeroMatrix(h_variable_4954);
nrows(h_variable_4953);
def h_variable_4955 = h_variable_4814[10,2];
h_variable_4955;
matrix h_variable_4956[1][1] = 0;
matrix h_variable_4957[1][3] = concat(h_variable_4956,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4957); matrix h_variable_4958 = h_variable_l[1]; matrix h_variable_4959 = h_variable_l[2];
ncols(h_variable_4958);
matrix h_variable_4960 = DecideZeroRows(h_variable_4958,h_variable_58);
IsZeroMatrix(h_variable_4960);
nrows(h_variable_4959);
def h_variable_4961 = h_variable_4814[9,2];
h_variable_4961;
matrix h_variable_4962[1][1] = 0;
matrix h_variable_4963[1][3] = concat(h_variable_4962,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4963); matrix h_variable_4964 = h_variable_l[1]; matrix h_variable_4965 = h_variable_l[2];
ncols(h_variable_4964);
matrix h_variable_4966 = DecideZeroRows(h_variable_4964,h_variable_58);
IsZeroMatrix(h_variable_4966);
nrows(h_variable_4965);
def h_variable_4967 = h_variable_4814[8,2];
h_variable_4967;
matrix h_variable_4968[1][1] = 0;
matrix h_variable_4969[1][3] = concat(h_variable_4968,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4969); matrix h_variable_4970 = h_variable_l[1]; matrix h_variable_4971 = h_variable_l[2];
ncols(h_variable_4970);
matrix h_variable_4972 = DecideZeroRows(h_variable_4970,h_variable_58);
IsZeroMatrix(h_variable_4972);
nrows(h_variable_4971);
def h_variable_4973 = h_variable_4814[7,2];
h_variable_4973;
matrix h_variable_4974[1][1] = 0;
matrix h_variable_4975[1][3] = concat(h_variable_4974,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4975); matrix h_variable_4976 = h_variable_l[1]; matrix h_variable_4977 = h_variable_l[2];
ncols(h_variable_4976);
matrix h_variable_4978 = DecideZeroRows(h_variable_4976,h_variable_58);
IsZeroMatrix(h_variable_4978);
nrows(h_variable_4977);
def h_variable_4979 = h_variable_4814[6,2];
h_variable_4979;
matrix h_variable_4980[1][1] = 0;
matrix h_variable_4981[1][3] = concat(h_variable_4980,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4981); matrix h_variable_4982 = h_variable_l[1]; matrix h_variable_4983 = h_variable_l[2];
ncols(h_variable_4982);
matrix h_variable_4984 = DecideZeroRows(h_variable_4982,h_variable_58);
IsZeroMatrix(h_variable_4984);
nrows(h_variable_4983);
def h_variable_4985 = h_variable_4814[5,2];
h_variable_4985;
matrix h_variable_4986[1][1] = -2;
matrix h_variable_4987[1][3] = concat(h_variable_4986,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_4987); matrix h_variable_4988 = h_variable_l[1]; matrix h_variable_4989 = h_variable_l[2];
ncols(h_variable_4988);
matrix h_variable_4990 = DecideZeroRows(h_variable_4988,h_variable_58);
IsZeroMatrix(h_variable_4990);
ZeroRows(h_variable_4990);
nrows(h_variable_4989);
matrix h_variable_4992 = submat(h_variable_4988,1..1,intvec( 1 ));
matrix h_variable_4991 = DecideZeroRows(h_variable_4992,h_variable_58);
IsZeroMatrix(h_variable_4991);
IsIdentityMatrix(h_variable_4991);
matrix h_variable_4993[1][3] = concat(h_variable_4991,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_4993); matrix h_variable_4994 = h_variable_l[1]; matrix h_variable_4995 = h_variable_l[2];
IsZeroMatrix(h_variable_4994);
matrix h_variable_4996 = DecideZeroRows(h_variable_4994,h_variable_58);
IsZeroMatrix(h_variable_4996);
def h_variable_4997 = h_variable_4814[4,2];
h_variable_4997;
matrix h_variable_4998[1][1] = 0;
matrix h_variable_4999[1][3] = concat(h_variable_4998,h_variable_48);
kill h_variable_4419;kill h_variable_4420;kill h_variable_4421;kill h_variable_4422;kill h_variable_4424;kill h_variable_4425;kill h_variable_4426;kill h_variable_4427;kill h_variable_4428;kill h_variable_4430;kill h_variable_4431;kill h_variable_4432;kill h_variable_4433;kill h_variable_4434;kill h_variable_4435;kill h_variable_4436;kill h_variable_4437;kill h_variable_4438;kill h_variable_4439;kill h_variable_4440;kill h_variable_4441;kill h_variable_4442;kill h_variable_4443;kill h_variable_4444;kill h_variable_4445;kill h_variable_4446;kill h_variable_4447;kill h_variable_4448;kill h_variable_4449;kill h_variable_4450;kill h_variable_4451;kill h_variable_4452;kill h_variable_4453;kill h_variable_4454;kill h_variable_4455;kill h_variable_4456;kill h_variable_4457;kill h_variable_4458;kill h_variable_4459;kill h_variable_4460;kill h_variable_4461;kill h_variable_4462;kill h_variable_4463;kill h_variable_4464;kill h_variable_4465;kill h_variable_4466;kill h_variable_4467;kill h_variable_4468;kill h_variable_4469;kill h_variable_4470;kill h_variable_4471;kill h_variable_4472;kill h_variable_4473;kill h_variable_4474;kill h_variable_4475;kill h_variable_4476;kill h_variable_4477;kill h_variable_4478;kill h_variable_4479;kill h_variable_4480;kill h_variable_4481;kill h_variable_4482;kill h_variable_4483;kill h_variable_4484;kill h_variable_4485;kill h_variable_4486;kill h_variable_4487;kill h_variable_4488;kill h_variable_4489;kill h_variable_4490;kill h_variable_4491;kill h_variable_4492;kill h_variable_4493;kill h_variable_4494;kill h_variable_4495;kill h_variable_4496;kill h_variable_4497;kill h_variable_4498;kill h_variable_4499;kill h_variable_4500;kill h_variable_4501;kill h_variable_4502;kill h_variable_4503;kill h_variable_4504;kill h_variable_4505;kill h_variable_4506;kill h_variable_4507;kill h_variable_4508;kill h_variable_4509;kill h_variable_4510;kill h_variable_4511;kill h_variable_4512;kill h_variable_4513;kill h_variable_4514;kill h_variable_4515;kill h_variable_4516;kill h_variable_4517;kill h_variable_4518;kill h_variable_4519;kill h_variable_4520;kill h_variable_4521;kill h_variable_4522;kill h_variable_4523;kill h_variable_4524;kill h_variable_4525;kill h_variable_4526;kill h_variable_4527;kill h_variable_4528;kill h_variable_4529;kill h_variable_4530;kill h_variable_4531;kill h_variable_4532;kill h_variable_4533;kill h_variable_4534;kill h_variable_4535;kill h_variable_4536;kill h_variable_4542;kill h_variable_4544;kill h_variable_4545;kill h_variable_4546;kill h_variable_4547;kill h_variable_4548;kill h_variable_4550;kill h_variable_4551;kill h_variable_4552;kill h_variable_4553;kill h_variable_4554;kill h_variable_4555;kill h_variable_4556;kill h_variable_4557;kill h_variable_4558;kill h_variable_4559;kill h_variable_4560;kill h_variable_4561;kill h_variable_4562;kill h_variable_4563;kill h_variable_4564;kill h_variable_4565;kill h_variable_4566;kill h_variable_4567;kill h_variable_4568;kill h_variable_4569;kill h_variable_4570;kill h_variable_4571;kill h_variable_4572;kill h_variable_4573;kill h_variable_4574;kill h_variable_4575;kill h_variable_4576;kill h_variable_4577;kill h_variable_4578;kill h_variable_4579;kill h_variable_4580;kill h_variable_4581;kill h_variable_4582;kill h_variable_4583;kill h_variable_4584;kill h_variable_4585;kill h_variable_4586;kill h_variable_4587;kill h_variable_4588;kill h_variable_4589;kill h_variable_4590;kill h_variable_4591;kill h_variable_4592;kill h_variable_4593;kill h_variable_4594;kill h_variable_4595;kill h_variable_4596;kill h_variable_4597;kill h_variable_4598;kill h_variable_4599;kill h_variable_4600;kill h_variable_4601;kill h_variable_4602;kill h_variable_4603;kill h_variable_4604;kill h_variable_4605;kill h_variable_4606;kill h_variable_4607;kill h_variable_4608;kill h_variable_4609;kill h_variable_4610;kill h_variable_4611;kill h_variable_4612;kill h_variable_4613;kill h_variable_4614;kill h_variable_4615;kill h_variable_4616;kill h_variable_4617;kill h_variable_4618;kill h_variable_4619;kill h_variable_4620;kill h_variable_4621;kill h_variable_4622;kill h_variable_4623;kill h_variable_4624;kill h_variable_4625;kill h_variable_4626;kill h_variable_4627;kill h_variable_4628;kill h_variable_4629;kill h_variable_4630;kill h_variable_4631;kill h_variable_4632;kill h_variable_4633;kill h_variable_4634;kill h_variable_4635;kill h_variable_4636;kill h_variable_4637;kill h_variable_4638;kill h_variable_4639;kill h_variable_4640;kill h_variable_4641;kill h_variable_4642;kill h_variable_4643;kill h_variable_4644;kill h_variable_4645;kill h_variable_4646;kill h_variable_4647;kill h_variable_4648;kill h_variable_4649;kill h_variable_4650;kill h_variable_4651;kill h_variable_4652;kill h_variable_4653;kill h_variable_4654;kill h_variable_4655;kill h_variable_4656;kill h_variable_4657;kill h_variable_4658;kill h_variable_4659;kill h_variable_4660;kill h_variable_4661;kill h_variable_4662;kill h_variable_4663;kill h_variable_4664;kill h_variable_4665;kill h_variable_4666;kill h_variable_4667;kill h_variable_4668;kill h_variable_4669;kill h_variable_4670;kill h_variable_4671;kill h_variable_4672;kill h_variable_4673;kill h_variable_4674;kill h_variable_4675;kill h_variable_4676;kill h_variable_4677;kill h_variable_4678;kill h_variable_4679;kill h_variable_4680;kill h_variable_4681;kill h_variable_4682;kill h_variable_4683;kill h_variable_4684;kill h_variable_4685;kill h_variable_4686;kill h_variable_4687;kill h_variable_4688;kill h_variable_4689;kill h_variable_4690;kill h_variable_4691;kill h_variable_4692;kill h_variable_4693;kill h_variable_4694;kill h_variable_4695;kill h_variable_4696;kill h_variable_4697;kill h_variable_4698;kill h_variable_4699;kill h_variable_4700;kill h_variable_4701;kill h_variable_4702;kill h_variable_4703;kill h_variable_4704;kill h_variable_4705;kill h_variable_4706;kill h_variable_4707;kill h_variable_4708;kill h_variable_4709;kill h_variable_4710;kill h_variable_4711;kill h_variable_4712;kill h_variable_4713;kill h_variable_4714;kill h_variable_4715;kill h_variable_4716;kill h_variable_4725;kill h_variable_4726;kill h_variable_4727;kill h_variable_4728;kill h_variable_4730;kill h_variable_4731;kill h_variable_4732;kill h_variable_4733;kill h_variable_4734;kill h_variable_4736;kill h_variable_4737;kill h_variable_4738;kill h_variable_4739;kill h_variable_4740;kill h_variable_4741;kill h_variable_4742;kill h_variable_4743;kill h_variable_4744;kill h_variable_4745;kill h_variable_4746;kill h_variable_4747;kill h_variable_4748;kill h_variable_4749;kill h_variable_4750;kill h_variable_4751;kill h_variable_4752;kill h_variable_4753;kill h_variable_4754;kill h_variable_4755;kill h_variable_4756;kill h_variable_4757;kill h_variable_4758;kill h_variable_4759;kill h_variable_4760;kill h_variable_4761;kill h_variable_4762;kill h_variable_4763;kill h_variable_4764;kill h_variable_4765;kill h_variable_4766;kill h_variable_4767;kill h_variable_4768;kill h_variable_4769;kill h_variable_4770;kill h_variable_4771;kill h_variable_4772;kill h_variable_4773;kill h_variable_4774;kill h_variable_4775;kill h_variable_4776;kill h_variable_4777;kill h_variable_4778;kill h_variable_4779;kill h_variable_4780;kill h_variable_4781;kill h_variable_4782;kill h_variable_4783;kill h_variable_4784;kill h_variable_4785;kill h_variable_4786;kill h_variable_4787;kill h_variable_4788;kill h_variable_4789;kill h_variable_4790;kill h_variable_4791;kill h_variable_4792;kill h_variable_4793;kill h_variable_4794;kill h_variable_4795;kill h_variable_4796;kill h_variable_4797;kill h_variable_4798;kill h_variable_4799;kill h_variable_4800;kill h_variable_4801;kill h_variable_4802;kill h_variable_4803;kill h_variable_4804;kill h_variable_4805;kill h_variable_4806;kill h_variable_4808;kill h_variable_4810;kill h_variable_4811;kill h_variable_4812;kill h_variable_4813;kill h_variable_4815;kill h_variable_4817;kill h_variable_4818;kill h_variable_4819;kill h_variable_4820;kill h_variable_4821;kill h_variable_4822;kill h_variable_4823;kill h_variable_4824;kill h_variable_4825;kill h_variable_4826;kill h_variable_4827;kill h_variable_4828;kill h_variable_4829;kill h_variable_4830;kill h_variable_4831;kill h_variable_4832;kill h_variable_4833;kill h_variable_4834;kill h_variable_4835;kill h_variable_4836;kill h_variable_4837;kill h_variable_4838;kill h_variable_4839;kill h_variable_4840;kill h_variable_4841;kill h_variable_4842;kill h_variable_4843;kill h_variable_4844;kill h_variable_4845;kill h_variable_4846;kill h_variable_4847;kill h_variable_4848;kill h_variable_4849;kill h_variable_4850;kill h_variable_4851;kill h_variable_4852;kill h_variable_4853;kill h_variable_4854;kill h_variable_4855;kill h_variable_4856;kill h_variable_4857;kill h_variable_4858;kill h_variable_4859;kill h_variable_4860;kill h_variable_4861;kill h_variable_4862;kill h_variable_4863;kill h_variable_4864;kill h_variable_4865;kill h_variable_4866;kill h_variable_4867;kill h_variable_4868;kill h_variable_4869;kill h_variable_4870;kill h_variable_4871;kill h_variable_4872;kill h_variable_4873;kill h_variable_4874;kill h_variable_4875;kill h_variable_4876;kill h_variable_4877;kill h_variable_4878;kill h_variable_4879;kill h_variable_4880;kill h_variable_4881;kill h_variable_4882;kill h_variable_4883;kill h_variable_4884;kill h_variable_4885;kill h_variable_4886;kill h_variable_4887;kill h_variable_4888;kill h_variable_4889;kill h_variable_4890;kill h_variable_4891;kill h_variable_4892;kill h_variable_4893;kill h_variable_4894;kill h_variable_4895;kill h_variable_4896;kill h_variable_4897;kill h_variable_4898;kill h_variable_4899;kill h_variable_4900;
list h_variable_l=BasisOfRowsCoeff(h_variable_4999); matrix h_variable_5000 = h_variable_l[1]; matrix h_variable_5001 = h_variable_l[2];
ncols(h_variable_5000);
matrix h_variable_5002 = DecideZeroRows(h_variable_5000,h_variable_58);
IsZeroMatrix(h_variable_5002);
nrows(h_variable_5001);
def h_variable_5003 = h_variable_4814[3,2];
h_variable_5003;
matrix h_variable_5004[1][1] = -4;
matrix h_variable_5005[1][3] = concat(h_variable_5004,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5005); matrix h_variable_5006 = h_variable_l[1]; matrix h_variable_5007 = h_variable_l[2];
ncols(h_variable_5006);
matrix h_variable_5008 = DecideZeroRows(h_variable_5006,h_variable_58);
IsZeroMatrix(h_variable_5008);
ZeroRows(h_variable_5008);
nrows(h_variable_5007);
matrix h_variable_5010 = submat(h_variable_5006,1..1,intvec( 1 ));
matrix h_variable_5009 = DecideZeroRows(h_variable_5010,h_variable_58);
IsZeroMatrix(h_variable_5009);
IsIdentityMatrix(h_variable_5009);
matrix h_variable_5011[1][3] = concat(h_variable_5009,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5011); matrix h_variable_5012 = h_variable_l[1]; matrix h_variable_5013 = h_variable_l[2];
IsZeroMatrix(h_variable_5012);
matrix h_variable_5014 = DecideZeroRows(h_variable_5012,h_variable_58);
IsZeroMatrix(h_variable_5014);
def h_variable_5015 = h_variable_4814[2,2];
h_variable_5015;
matrix h_variable_5016[1][1] = x2;
matrix h_variable_5017[1][3] = concat(h_variable_5016,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5017); matrix h_variable_5018 = h_variable_l[1]; matrix h_variable_5019 = h_variable_l[2];
ncols(h_variable_5018);
matrix h_variable_5020 = DecideZeroRows(h_variable_5018,h_variable_58);
IsZeroMatrix(h_variable_5020);
ZeroRows(h_variable_5020);
nrows(h_variable_5019);
matrix h_variable_5022 = submat(h_variable_5018,1..1,intvec( 2 ));
matrix h_variable_5021 = DecideZeroRows(h_variable_5022,h_variable_58);
IsZeroMatrix(h_variable_5021);
IsIdentityMatrix(h_variable_5021);
matrix h_variable_5023[1][3] = concat(h_variable_5021,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5023); matrix h_variable_5024 = h_variable_l[1]; matrix h_variable_5025 = h_variable_l[2];
IsZeroMatrix(h_variable_5024);
matrix h_variable_5026 = DecideZeroRows(h_variable_5024,h_variable_58);
IsZeroMatrix(h_variable_5026);
def h_variable_5027 = h_variable_4814[1,2];
h_variable_5027;
matrix h_variable_5028[1][1] = 0;
matrix h_variable_5029[1][3] = concat(h_variable_5028,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5029); matrix h_variable_5030 = h_variable_l[1]; matrix h_variable_5031 = h_variable_l[2];
ncols(h_variable_5030);
matrix h_variable_5032 = DecideZeroRows(h_variable_5030,h_variable_58);
IsZeroMatrix(h_variable_5032);
nrows(h_variable_5031);
def h_variable_5033 = h_variable_4814[16,3];
h_variable_5033;
matrix h_variable_5034[1][1] = 0;
matrix h_variable_5035[1][3] = concat(h_variable_5034,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5035); matrix h_variable_5036 = h_variable_l[1]; matrix h_variable_5037 = h_variable_l[2];
ncols(h_variable_5036);
matrix h_variable_5038 = DecideZeroRows(h_variable_5036,h_variable_58);
IsZeroMatrix(h_variable_5038);
nrows(h_variable_5037);
def h_variable_5039 = h_variable_4814[15,3];
h_variable_5039;
matrix h_variable_5040[1][1] = 0;
matrix h_variable_5041[1][3] = concat(h_variable_5040,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5041); matrix h_variable_5042 = h_variable_l[1]; matrix h_variable_5043 = h_variable_l[2];
ncols(h_variable_5042);
matrix h_variable_5044 = DecideZeroRows(h_variable_5042,h_variable_58);
IsZeroMatrix(h_variable_5044);
nrows(h_variable_5043);
def h_variable_5045 = h_variable_4814[14,3];
h_variable_5045;
matrix h_variable_5046[1][1] = -3;
matrix h_variable_5047[1][3] = concat(h_variable_5046,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5047); matrix h_variable_5048 = h_variable_l[1]; matrix h_variable_5049 = h_variable_l[2];
ncols(h_variable_5048);
matrix h_variable_5050 = DecideZeroRows(h_variable_5048,h_variable_58);
IsZeroMatrix(h_variable_5050);
ZeroRows(h_variable_5050);
nrows(h_variable_5049);
matrix h_variable_5052 = submat(h_variable_5048,1..1,intvec( 1 ));
matrix h_variable_5051 = DecideZeroRows(h_variable_5052,h_variable_58);
IsZeroMatrix(h_variable_5051);
IsIdentityMatrix(h_variable_5051);
matrix h_variable_5053[1][3] = concat(h_variable_5051,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5053); matrix h_variable_5054 = h_variable_l[1]; matrix h_variable_5055 = h_variable_l[2];
IsZeroMatrix(h_variable_5054);
matrix h_variable_5056 = DecideZeroRows(h_variable_5054,h_variable_58);
IsZeroMatrix(h_variable_5056);
def h_variable_5057 = h_variable_4814[13,3];
h_variable_5057;
matrix h_variable_5058[1][1] = -3;
matrix h_variable_5059[1][3] = concat(h_variable_5058,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5059); matrix h_variable_5060 = h_variable_l[1]; matrix h_variable_5061 = h_variable_l[2];
ncols(h_variable_5060);
matrix h_variable_5062 = DecideZeroRows(h_variable_5060,h_variable_58);
IsZeroMatrix(h_variable_5062);
ZeroRows(h_variable_5062);
nrows(h_variable_5061);
matrix h_variable_5064 = submat(h_variable_5060,1..1,intvec( 1 ));
matrix h_variable_5063 = DecideZeroRows(h_variable_5064,h_variable_58);
IsZeroMatrix(h_variable_5063);
IsIdentityMatrix(h_variable_5063);
matrix h_variable_5065[1][3] = concat(h_variable_5063,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5065); matrix h_variable_5066 = h_variable_l[1]; matrix h_variable_5067 = h_variable_l[2];
IsZeroMatrix(h_variable_5066);
matrix h_variable_5068 = DecideZeroRows(h_variable_5066,h_variable_58);
IsZeroMatrix(h_variable_5068);
def h_variable_5069 = h_variable_4814[12,3];
h_variable_5069;
matrix h_variable_5070[1][1] = 0;
matrix h_variable_5071[1][3] = concat(h_variable_5070,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5071); matrix h_variable_5072 = h_variable_l[1]; matrix h_variable_5073 = h_variable_l[2];
ncols(h_variable_5072);
matrix h_variable_5074 = DecideZeroRows(h_variable_5072,h_variable_58);
IsZeroMatrix(h_variable_5074);
nrows(h_variable_5073);
def h_variable_5075 = h_variable_4814[11,3];
h_variable_5075;
matrix h_variable_5076[1][1] = 0;
matrix h_variable_5077[1][3] = concat(h_variable_5076,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5077); matrix h_variable_5078 = h_variable_l[1]; matrix h_variable_5079 = h_variable_l[2];
ncols(h_variable_5078);
matrix h_variable_5080 = DecideZeroRows(h_variable_5078,h_variable_58);
IsZeroMatrix(h_variable_5080);
nrows(h_variable_5079);
def h_variable_5081 = h_variable_4814[10,3];
h_variable_5081;
matrix h_variable_5082[1][1] = 0;
matrix h_variable_5083[1][3] = concat(h_variable_5082,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5083); matrix h_variable_5084 = h_variable_l[1]; matrix h_variable_5085 = h_variable_l[2];
ncols(h_variable_5084);
matrix h_variable_5086 = DecideZeroRows(h_variable_5084,h_variable_58);
IsZeroMatrix(h_variable_5086);
nrows(h_variable_5085);
def h_variable_5087 = h_variable_4814[9,3];
h_variable_5087;
matrix h_variable_5088[1][1] = 0;
matrix h_variable_5089[1][3] = concat(h_variable_5088,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5089); matrix h_variable_5090 = h_variable_l[1]; matrix h_variable_5091 = h_variable_l[2];
ncols(h_variable_5090);
matrix h_variable_5092 = DecideZeroRows(h_variable_5090,h_variable_58);
IsZeroMatrix(h_variable_5092);
nrows(h_variable_5091);
def h_variable_5093 = h_variable_4814[8,3];
h_variable_5093;
matrix h_variable_5094[1][1] = 3*x2;
matrix h_variable_5095[1][3] = concat(h_variable_5094,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5095); matrix h_variable_5096 = h_variable_l[1]; matrix h_variable_5097 = h_variable_l[2];
ncols(h_variable_5096);
matrix h_variable_5098 = DecideZeroRows(h_variable_5096,h_variable_58);
IsZeroMatrix(h_variable_5098);
ZeroRows(h_variable_5098);
nrows(h_variable_5097);
matrix h_variable_5100 = submat(h_variable_5096,1..1,intvec( 2 ));
matrix h_variable_5099 = DecideZeroRows(h_variable_5100,h_variable_58);
IsZeroMatrix(h_variable_5099);
IsIdentityMatrix(h_variable_5099);
matrix h_variable_5101[1][3] = concat(h_variable_5099,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5101); matrix h_variable_5102 = h_variable_l[1]; matrix h_variable_5103 = h_variable_l[2];
IsZeroMatrix(h_variable_5102);
matrix h_variable_5104 = DecideZeroRows(h_variable_5102,h_variable_58);
IsZeroMatrix(h_variable_5104);
def h_variable_5105 = h_variable_4814[7,3];
h_variable_5105;
matrix h_variable_5106[1][1] = 0;
matrix h_variable_5107[1][3] = concat(h_variable_5106,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5107); matrix h_variable_5108 = h_variable_l[1]; matrix h_variable_5109 = h_variable_l[2];
ncols(h_variable_5108);
matrix h_variable_5110 = DecideZeroRows(h_variable_5108,h_variable_58);
IsZeroMatrix(h_variable_5110);
nrows(h_variable_5109);
def h_variable_5111 = h_variable_4814[6,3];
h_variable_5111;
matrix h_variable_5112[1][1] = 0;
matrix h_variable_5113[1][3] = concat(h_variable_5112,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5113); matrix h_variable_5114 = h_variable_l[1]; matrix h_variable_5115 = h_variable_l[2];
ncols(h_variable_5114);
matrix h_variable_5116 = DecideZeroRows(h_variable_5114,h_variable_58);
IsZeroMatrix(h_variable_5116);
nrows(h_variable_5115);
def h_variable_5117 = h_variable_4814[5,3];
h_variable_5117;
matrix h_variable_5118[1][1] = 0;
matrix h_variable_5119[1][3] = concat(h_variable_5118,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5119); matrix h_variable_5120 = h_variable_l[1]; matrix h_variable_5121 = h_variable_l[2];
ncols(h_variable_5120);
matrix h_variable_5122 = DecideZeroRows(h_variable_5120,h_variable_58);
IsZeroMatrix(h_variable_5122);
nrows(h_variable_5121);
def h_variable_5123 = h_variable_4814[4,3];
h_variable_5123;
matrix h_variable_5124[1][1] = 0;
matrix h_variable_5125[1][3] = concat(h_variable_5124,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5125); matrix h_variable_5126 = h_variable_l[1]; matrix h_variable_5127 = h_variable_l[2];
ncols(h_variable_5126);
matrix h_variable_5128 = DecideZeroRows(h_variable_5126,h_variable_58);
IsZeroMatrix(h_variable_5128);
nrows(h_variable_5127);
def h_variable_5129 = h_variable_4814[3,3];
h_variable_5129;
matrix h_variable_5130[1][1] = 0;
matrix h_variable_5131[1][3] = concat(h_variable_5130,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5131); matrix h_variable_5132 = h_variable_l[1]; matrix h_variable_5133 = h_variable_l[2];
ncols(h_variable_5132);
matrix h_variable_5134 = DecideZeroRows(h_variable_5132,h_variable_58);
IsZeroMatrix(h_variable_5134);
nrows(h_variable_5133);
def h_variable_5135 = h_variable_4814[2,3];
h_variable_5135;
matrix h_variable_5136[1][1] = 0;
matrix h_variable_5137[1][3] = concat(h_variable_5136,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5137); matrix h_variable_5138 = h_variable_l[1]; matrix h_variable_5139 = h_variable_l[2];
ncols(h_variable_5138);
matrix h_variable_5140 = DecideZeroRows(h_variable_5138,h_variable_58);
IsZeroMatrix(h_variable_5140);
nrows(h_variable_5139);
def h_variable_5141 = h_variable_4814[1,3];
h_variable_5141;
matrix h_variable_5142[1][1] = 0;
matrix h_variable_5143[1][3] = concat(h_variable_5142,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5143); matrix h_variable_5144 = h_variable_l[1]; matrix h_variable_5145 = h_variable_l[2];
ncols(h_variable_5144);
matrix h_variable_5146 = DecideZeroRows(h_variable_5144,h_variable_58);
IsZeroMatrix(h_variable_5146);
nrows(h_variable_5145);
def h_variable_5147 = h_variable_4814[16,4];
h_variable_5147;
matrix h_variable_5148[1][1] = 0;
matrix h_variable_5149[1][3] = concat(h_variable_5148,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5149); matrix h_variable_5150 = h_variable_l[1]; matrix h_variable_5151 = h_variable_l[2];
ncols(h_variable_5150);
matrix h_variable_5152 = DecideZeroRows(h_variable_5150,h_variable_58);
IsZeroMatrix(h_variable_5152);
nrows(h_variable_5151);
def h_variable_5153 = h_variable_4814[15,4];
h_variable_5153;
matrix h_variable_5154[1][1] = 0;
matrix h_variable_5155[1][3] = concat(h_variable_5154,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5155); matrix h_variable_5156 = h_variable_l[1]; matrix h_variable_5157 = h_variable_l[2];
ncols(h_variable_5156);
matrix h_variable_5158 = DecideZeroRows(h_variable_5156,h_variable_58);
IsZeroMatrix(h_variable_5158);
nrows(h_variable_5157);
def h_variable_5159 = h_variable_4814[14,4];
h_variable_5159;
matrix h_variable_5160[1][1] = 0;
matrix h_variable_5161[1][3] = concat(h_variable_5160,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5161); matrix h_variable_5162 = h_variable_l[1]; matrix h_variable_5163 = h_variable_l[2];
ncols(h_variable_5162);
matrix h_variable_5164 = DecideZeroRows(h_variable_5162,h_variable_58);
IsZeroMatrix(h_variable_5164);
nrows(h_variable_5163);
def h_variable_5165 = h_variable_4814[13,4];
h_variable_5165;
matrix h_variable_5166[1][1] = 0;
matrix h_variable_5167[1][3] = concat(h_variable_5166,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5167); matrix h_variable_5168 = h_variable_l[1]; matrix h_variable_5169 = h_variable_l[2];
ncols(h_variable_5168);
matrix h_variable_5170 = DecideZeroRows(h_variable_5168,h_variable_58);
IsZeroMatrix(h_variable_5170);
nrows(h_variable_5169);
def h_variable_5171 = h_variable_4814[12,4];
h_variable_5171;
matrix h_variable_5172[1][1] = 0;
matrix h_variable_5173[1][3] = concat(h_variable_5172,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5173); matrix h_variable_5174 = h_variable_l[1]; matrix h_variable_5175 = h_variable_l[2];
ncols(h_variable_5174);
matrix h_variable_5176 = DecideZeroRows(h_variable_5174,h_variable_58);
IsZeroMatrix(h_variable_5176);
nrows(h_variable_5175);
def h_variable_5177 = h_variable_4814[11,4];
h_variable_5177;
matrix h_variable_5178[1][1] = 0;
matrix h_variable_5179[1][3] = concat(h_variable_5178,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5179); matrix h_variable_5180 = h_variable_l[1]; matrix h_variable_5181 = h_variable_l[2];
ncols(h_variable_5180);
matrix h_variable_5182 = DecideZeroRows(h_variable_5180,h_variable_58);
IsZeroMatrix(h_variable_5182);
nrows(h_variable_5181);
def h_variable_5183 = h_variable_4814[10,4];
h_variable_5183;
matrix h_variable_5184[1][1] = 0;
matrix h_variable_5185[1][3] = concat(h_variable_5184,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5185); matrix h_variable_5186 = h_variable_l[1]; matrix h_variable_5187 = h_variable_l[2];
ncols(h_variable_5186);
matrix h_variable_5188 = DecideZeroRows(h_variable_5186,h_variable_58);
IsZeroMatrix(h_variable_5188);
nrows(h_variable_5187);
def h_variable_5189 = h_variable_4814[9,4];
h_variable_5189;
matrix h_variable_5190[1][1] = 0;
matrix h_variable_5191[1][3] = concat(h_variable_5190,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5191); matrix h_variable_5192 = h_variable_l[1]; matrix h_variable_5193 = h_variable_l[2];
ncols(h_variable_5192);
matrix h_variable_5194 = DecideZeroRows(h_variable_5192,h_variable_58);
IsZeroMatrix(h_variable_5194);
nrows(h_variable_5193);
def h_variable_5195 = h_variable_4814[8,4];
h_variable_5195;
matrix h_variable_5196[1][1] = 0;
matrix h_variable_5197[1][3] = concat(h_variable_5196,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5197); matrix h_variable_5198 = h_variable_l[1]; matrix h_variable_5199 = h_variable_l[2];
ncols(h_variable_5198);
matrix h_variable_5200 = DecideZeroRows(h_variable_5198,h_variable_58);
IsZeroMatrix(h_variable_5200);
nrows(h_variable_5199);
def h_variable_5201 = h_variable_4814[7,4];
h_variable_5201;
matrix h_variable_5202[1][1] = 0;
matrix h_variable_5203[1][3] = concat(h_variable_5202,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5203); matrix h_variable_5204 = h_variable_l[1]; matrix h_variable_5205 = h_variable_l[2];
ncols(h_variable_5204);
matrix h_variable_5206 = DecideZeroRows(h_variable_5204,h_variable_58);
IsZeroMatrix(h_variable_5206);
nrows(h_variable_5205);
def h_variable_5207 = h_variable_4814[6,4];
h_variable_5207;
matrix h_variable_5208[1][1] = -2;
matrix h_variable_5209[1][3] = concat(h_variable_5208,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5209); matrix h_variable_5210 = h_variable_l[1]; matrix h_variable_5211 = h_variable_l[2];
ncols(h_variable_5210);
matrix h_variable_5212 = DecideZeroRows(h_variable_5210,h_variable_58);
IsZeroMatrix(h_variable_5212);
ZeroRows(h_variable_5212);
nrows(h_variable_5211);
matrix h_variable_5214 = submat(h_variable_5210,1..1,intvec( 1 ));
matrix h_variable_5213 = DecideZeroRows(h_variable_5214,h_variable_58);
IsZeroMatrix(h_variable_5213);
IsIdentityMatrix(h_variable_5213);
matrix h_variable_5215[1][3] = concat(h_variable_5213,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5215); matrix h_variable_5216 = h_variable_l[1]; matrix h_variable_5217 = h_variable_l[2];
IsZeroMatrix(h_variable_5216);
matrix h_variable_5218 = DecideZeroRows(h_variable_5216,h_variable_58);
IsZeroMatrix(h_variable_5218);
def h_variable_5219 = h_variable_4814[5,4];
h_variable_5219;
matrix h_variable_5220[1][1] = 0;
matrix h_variable_5221[1][3] = concat(h_variable_5220,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5221); matrix h_variable_5222 = h_variable_l[1]; matrix h_variable_5223 = h_variable_l[2];
ncols(h_variable_5222);
matrix h_variable_5224 = DecideZeroRows(h_variable_5222,h_variable_58);
IsZeroMatrix(h_variable_5224);
nrows(h_variable_5223);
def h_variable_5225 = h_variable_4814[4,4];
h_variable_5225;
matrix h_variable_5226[1][1] = 2;
matrix h_variable_5227[1][3] = concat(h_variable_5226,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5227); matrix h_variable_5228 = h_variable_l[1]; matrix h_variable_5229 = h_variable_l[2];
ncols(h_variable_5228);
matrix h_variable_5230 = DecideZeroRows(h_variable_5228,h_variable_58);
IsZeroMatrix(h_variable_5230);
ZeroRows(h_variable_5230);
nrows(h_variable_5229);
matrix h_variable_5232 = submat(h_variable_5228,1..1,intvec( 1 ));
matrix h_variable_5231 = DecideZeroRows(h_variable_5232,h_variable_58);
IsZeroMatrix(h_variable_5231);
IsIdentityMatrix(h_variable_5231);
matrix h_variable_5233[1][3] = concat(h_variable_5231,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5233); matrix h_variable_5234 = h_variable_l[1]; matrix h_variable_5235 = h_variable_l[2];
IsZeroMatrix(h_variable_5234);
matrix h_variable_5236 = DecideZeroRows(h_variable_5234,h_variable_58);
IsZeroMatrix(h_variable_5236);
def h_variable_5237 = h_variable_4814[3,4];
h_variable_5237;
matrix h_variable_5238[1][1] = 0;
matrix h_variable_5239[1][3] = concat(h_variable_5238,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5239); matrix h_variable_5240 = h_variable_l[1]; matrix h_variable_5241 = h_variable_l[2];
ncols(h_variable_5240);
matrix h_variable_5242 = DecideZeroRows(h_variable_5240,h_variable_58);
IsZeroMatrix(h_variable_5242);
nrows(h_variable_5241);
def h_variable_5243 = h_variable_4814[2,4];
h_variable_5243;
matrix h_variable_5244[1][1] = x1;
matrix h_variable_5245[1][3] = concat(h_variable_5244,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5245); matrix h_variable_5246 = h_variable_l[1]; matrix h_variable_5247 = h_variable_l[2];
ncols(h_variable_5246);
matrix h_variable_5248 = DecideZeroRows(h_variable_5246,h_variable_58);
IsZeroMatrix(h_variable_5248);
ZeroRows(h_variable_5248);
nrows(h_variable_5247);
matrix h_variable_5250 = submat(h_variable_5246,1..1,intvec( 2 ));
matrix h_variable_5249 = DecideZeroRows(h_variable_5250,h_variable_58);
IsZeroMatrix(h_variable_5249);
IsIdentityMatrix(h_variable_5249);
matrix h_variable_5251[1][3] = concat(h_variable_5249,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5251); matrix h_variable_5252 = h_variable_l[1]; matrix h_variable_5253 = h_variable_l[2];
IsZeroMatrix(h_variable_5252);
matrix h_variable_5254 = DecideZeroRows(h_variable_5252,h_variable_58);
IsZeroMatrix(h_variable_5254);
def h_variable_5255 = h_variable_4814[1,4];
h_variable_5255;
matrix h_variable_5256[1][1] = 0;
matrix h_variable_5257[1][3] = concat(h_variable_5256,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5257); matrix h_variable_5258 = h_variable_l[1]; matrix h_variable_5259 = h_variable_l[2];
ncols(h_variable_5258);
matrix h_variable_5260 = DecideZeroRows(h_variable_5258,h_variable_58);
IsZeroMatrix(h_variable_5260);
nrows(h_variable_5259);
def h_variable_5261 = h_variable_4814[16,5];
h_variable_5261;
matrix h_variable_5262[1][1] = 0;
matrix h_variable_5263[1][3] = concat(h_variable_5262,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5263); matrix h_variable_5264 = h_variable_l[1]; matrix h_variable_5265 = h_variable_l[2];
ncols(h_variable_5264);
matrix h_variable_5266 = DecideZeroRows(h_variable_5264,h_variable_58);
IsZeroMatrix(h_variable_5266);
nrows(h_variable_5265);
def h_variable_5267 = h_variable_4814[15,5];
h_variable_5267;
matrix h_variable_5268[1][1] = 0;
matrix h_variable_5269[1][3] = concat(h_variable_5268,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5269); matrix h_variable_5270 = h_variable_l[1]; matrix h_variable_5271 = h_variable_l[2];
ncols(h_variable_5270);
matrix h_variable_5272 = DecideZeroRows(h_variable_5270,h_variable_58);
IsZeroMatrix(h_variable_5272);
nrows(h_variable_5271);
def h_variable_5273 = h_variable_4814[14,5];
h_variable_5273;
matrix h_variable_5274[1][1] = 0;
matrix h_variable_5275[1][3] = concat(h_variable_5274,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5275); matrix h_variable_5276 = h_variable_l[1]; matrix h_variable_5277 = h_variable_l[2];
ncols(h_variable_5276);
matrix h_variable_5278 = DecideZeroRows(h_variable_5276,h_variable_58);
IsZeroMatrix(h_variable_5278);
nrows(h_variable_5277);
def h_variable_5279 = h_variable_4814[13,5];
h_variable_5279;
matrix h_variable_5280[1][1] = 0;
matrix h_variable_5281[1][3] = concat(h_variable_5280,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5281); matrix h_variable_5282 = h_variable_l[1]; matrix h_variable_5283 = h_variable_l[2];
ncols(h_variable_5282);
matrix h_variable_5284 = DecideZeroRows(h_variable_5282,h_variable_58);
IsZeroMatrix(h_variable_5284);
nrows(h_variable_5283);
def h_variable_5285 = h_variable_4814[12,5];
h_variable_5285;
matrix h_variable_5286[1][1] = 0;
matrix h_variable_5287[1][3] = concat(h_variable_5286,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5287); matrix h_variable_5288 = h_variable_l[1]; matrix h_variable_5289 = h_variable_l[2];
ncols(h_variable_5288);
matrix h_variable_5290 = DecideZeroRows(h_variable_5288,h_variable_58);
IsZeroMatrix(h_variable_5290);
nrows(h_variable_5289);
def h_variable_5291 = h_variable_4814[11,5];
h_variable_5291;
matrix h_variable_5292[1][1] = 0;
matrix h_variable_5293[1][3] = concat(h_variable_5292,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5293); matrix h_variable_5294 = h_variable_l[1]; matrix h_variable_5295 = h_variable_l[2];
ncols(h_variable_5294);
matrix h_variable_5296 = DecideZeroRows(h_variable_5294,h_variable_58);
IsZeroMatrix(h_variable_5296);
nrows(h_variable_5295);
def h_variable_5297 = h_variable_4814[10,5];
h_variable_5297;
matrix h_variable_5298[1][1] = 0;
matrix h_variable_5299[1][3] = concat(h_variable_5298,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5299); matrix h_variable_5300 = h_variable_l[1]; matrix h_variable_5301 = h_variable_l[2];
ncols(h_variable_5300);
matrix h_variable_5302 = DecideZeroRows(h_variable_5300,h_variable_58);
IsZeroMatrix(h_variable_5302);
nrows(h_variable_5301);
def h_variable_5303 = h_variable_4814[9,5];
h_variable_5303;
matrix h_variable_5304[1][1] = 0;
matrix h_variable_5305[1][3] = concat(h_variable_5304,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5305); matrix h_variable_5306 = h_variable_l[1]; matrix h_variable_5307 = h_variable_l[2];
ncols(h_variable_5306);
matrix h_variable_5308 = DecideZeroRows(h_variable_5306,h_variable_58);
IsZeroMatrix(h_variable_5308);
nrows(h_variable_5307);
def h_variable_5309 = h_variable_4814[8,5];
h_variable_5309;
matrix h_variable_5310[1][1] = 0;
matrix h_variable_5311[1][3] = concat(h_variable_5310,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5311); matrix h_variable_5312 = h_variable_l[1]; matrix h_variable_5313 = h_variable_l[2];
ncols(h_variable_5312);
matrix h_variable_5314 = DecideZeroRows(h_variable_5312,h_variable_58);
IsZeroMatrix(h_variable_5314);
nrows(h_variable_5313);
def h_variable_5315 = h_variable_4814[7,5];
h_variable_5315;
matrix h_variable_5316[1][1] = -3;
matrix h_variable_5317[1][3] = concat(h_variable_5316,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5317); matrix h_variable_5318 = h_variable_l[1]; matrix h_variable_5319 = h_variable_l[2];
ncols(h_variable_5318);
matrix h_variable_5320 = DecideZeroRows(h_variable_5318,h_variable_58);
IsZeroMatrix(h_variable_5320);
ZeroRows(h_variable_5320);
nrows(h_variable_5319);
matrix h_variable_5322 = submat(h_variable_5318,1..1,intvec( 1 ));
matrix h_variable_5321 = DecideZeroRows(h_variable_5322,h_variable_58);
IsZeroMatrix(h_variable_5321);
IsIdentityMatrix(h_variable_5321);
matrix h_variable_5323[1][3] = concat(h_variable_5321,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5323); matrix h_variable_5324 = h_variable_l[1]; matrix h_variable_5325 = h_variable_l[2];
IsZeroMatrix(h_variable_5324);
matrix h_variable_5326 = DecideZeroRows(h_variable_5324,h_variable_58);
IsZeroMatrix(h_variable_5326);
def h_variable_5327 = h_variable_4814[6,5];
h_variable_5327;
matrix h_variable_5328[1][1] = 0;
matrix h_variable_5329[1][3] = concat(h_variable_5328,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5329); matrix h_variable_5330 = h_variable_l[1]; matrix h_variable_5331 = h_variable_l[2];
ncols(h_variable_5330);
matrix h_variable_5332 = DecideZeroRows(h_variable_5330,h_variable_58);
IsZeroMatrix(h_variable_5332);
nrows(h_variable_5331);
def h_variable_5333 = h_variable_4814[5,5];
h_variable_5333;
matrix h_variable_5334[1][1] = 0;
matrix h_variable_5335[1][3] = concat(h_variable_5334,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5335); matrix h_variable_5336 = h_variable_l[1]; matrix h_variable_5337 = h_variable_l[2];
ncols(h_variable_5336);
matrix h_variable_5338 = DecideZeroRows(h_variable_5336,h_variable_58);
IsZeroMatrix(h_variable_5338);
nrows(h_variable_5337);
def h_variable_5339 = h_variable_4814[4,5];
h_variable_5339;
matrix h_variable_5340[1][1] = 0;
matrix h_variable_5341[1][3] = concat(h_variable_5340,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5341); matrix h_variable_5342 = h_variable_l[1]; matrix h_variable_5343 = h_variable_l[2];
ncols(h_variable_5342);
matrix h_variable_5344 = DecideZeroRows(h_variable_5342,h_variable_58);
IsZeroMatrix(h_variable_5344);
nrows(h_variable_5343);
def h_variable_5345 = h_variable_4814[3,5];
h_variable_5345;
matrix h_variable_5346[1][1] = 3*x1+3*x2;
matrix h_variable_5347[1][3] = concat(h_variable_5346,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5347); matrix h_variable_5348 = h_variable_l[1]; matrix h_variable_5349 = h_variable_l[2];
ncols(h_variable_5348);
matrix h_variable_5350 = DecideZeroRows(h_variable_5348,h_variable_58);
IsZeroMatrix(h_variable_5350);
ZeroRows(h_variable_5350);
nrows(h_variable_5349);
matrix h_variable_5352 = submat(h_variable_5348,1..1,intvec( 2 ));
matrix h_variable_5351 = DecideZeroRows(h_variable_5352,h_variable_58);
IsZeroMatrix(h_variable_5351);
IsIdentityMatrix(h_variable_5351);
matrix h_variable_5353[1][3] = concat(h_variable_5351,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5353); matrix h_variable_5354 = h_variable_l[1]; matrix h_variable_5355 = h_variable_l[2];
IsZeroMatrix(h_variable_5354);
matrix h_variable_5356 = DecideZeroRows(h_variable_5354,h_variable_58);
IsZeroMatrix(h_variable_5356);
def h_variable_5357 = h_variable_4814[2,5];
h_variable_5357;
matrix h_variable_5358[1][1] = 0;
matrix h_variable_5359[1][3] = concat(h_variable_5358,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5359); matrix h_variable_5360 = h_variable_l[1]; matrix h_variable_5361 = h_variable_l[2];
ncols(h_variable_5360);
matrix h_variable_5362 = DecideZeroRows(h_variable_5360,h_variable_58);
IsZeroMatrix(h_variable_5362);
nrows(h_variable_5361);
def h_variable_5363 = h_variable_4814[1,5];
h_variable_5363;
matrix h_variable_5364[1][1] = 0;
matrix h_variable_5365[1][3] = concat(h_variable_5364,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5365); matrix h_variable_5366 = h_variable_l[1]; matrix h_variable_5367 = h_variable_l[2];
ncols(h_variable_5366);
matrix h_variable_5368 = DecideZeroRows(h_variable_5366,h_variable_58);
IsZeroMatrix(h_variable_5368);
nrows(h_variable_5367);
def h_variable_5369 = h_variable_4814[16,6];
h_variable_5369;
matrix h_variable_5370[1][1] = 0;
matrix h_variable_5371[1][3] = concat(h_variable_5370,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5371); matrix h_variable_5372 = h_variable_l[1]; matrix h_variable_5373 = h_variable_l[2];
ncols(h_variable_5372);
matrix h_variable_5374 = DecideZeroRows(h_variable_5372,h_variable_58);
IsZeroMatrix(h_variable_5374);
nrows(h_variable_5373);
def h_variable_5375 = h_variable_4814[15,6];
h_variable_5375;
matrix h_variable_5376[1][1] = 0;
matrix h_variable_5377[1][3] = concat(h_variable_5376,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5377); matrix h_variable_5378 = h_variable_l[1]; matrix h_variable_5379 = h_variable_l[2];
ncols(h_variable_5378);
matrix h_variable_5380 = DecideZeroRows(h_variable_5378,h_variable_58);
IsZeroMatrix(h_variable_5380);
nrows(h_variable_5379);
def h_variable_5381 = h_variable_4814[14,6];
h_variable_5381;
matrix h_variable_5382[1][1] = 0;
matrix h_variable_5383[1][3] = concat(h_variable_5382,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5383); matrix h_variable_5384 = h_variable_l[1]; matrix h_variable_5385 = h_variable_l[2];
ncols(h_variable_5384);
matrix h_variable_5386 = DecideZeroRows(h_variable_5384,h_variable_58);
IsZeroMatrix(h_variable_5386);
nrows(h_variable_5385);
def h_variable_5387 = h_variable_4814[13,6];
h_variable_5387;
matrix h_variable_5388[1][1] = 0;
matrix h_variable_5389[1][3] = concat(h_variable_5388,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5389); matrix h_variable_5390 = h_variable_l[1]; matrix h_variable_5391 = h_variable_l[2];
ncols(h_variable_5390);
matrix h_variable_5392 = DecideZeroRows(h_variable_5390,h_variable_58);
IsZeroMatrix(h_variable_5392);
nrows(h_variable_5391);
def h_variable_5393 = h_variable_4814[12,6];
h_variable_5393;
matrix h_variable_5394[1][1] = 0;
matrix h_variable_5395[1][3] = concat(h_variable_5394,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5395); matrix h_variable_5396 = h_variable_l[1]; matrix h_variable_5397 = h_variable_l[2];
ncols(h_variable_5396);
matrix h_variable_5398 = DecideZeroRows(h_variable_5396,h_variable_58);
IsZeroMatrix(h_variable_5398);
nrows(h_variable_5397);
def h_variable_5399 = h_variable_4814[11,6];
h_variable_5399;
matrix h_variable_5400[1][1] = 0;
matrix h_variable_5401[1][3] = concat(h_variable_5400,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5401); matrix h_variable_5402 = h_variable_l[1]; matrix h_variable_5403 = h_variable_l[2];
ncols(h_variable_5402);
matrix h_variable_5404 = DecideZeroRows(h_variable_5402,h_variable_58);
IsZeroMatrix(h_variable_5404);
nrows(h_variable_5403);
def h_variable_5405 = h_variable_4814[10,6];
h_variable_5405;
matrix h_variable_5406[1][1] = 0;
matrix h_variable_5407[1][3] = concat(h_variable_5406,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5407); matrix h_variable_5408 = h_variable_l[1]; matrix h_variable_5409 = h_variable_l[2];
ncols(h_variable_5408);
matrix h_variable_5410 = DecideZeroRows(h_variable_5408,h_variable_58);
IsZeroMatrix(h_variable_5410);
nrows(h_variable_5409);
def h_variable_5411 = h_variable_4814[9,6];
h_variable_5411;
matrix h_variable_5412[1][1] = 0;
matrix h_variable_5413[1][3] = concat(h_variable_5412,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5413); matrix h_variable_5414 = h_variable_l[1]; matrix h_variable_5415 = h_variable_l[2];
ncols(h_variable_5414);
matrix h_variable_5416 = DecideZeroRows(h_variable_5414,h_variable_58);
IsZeroMatrix(h_variable_5416);
nrows(h_variable_5415);
def h_variable_5417 = h_variable_4814[8,6];
h_variable_5417;
matrix h_variable_5418[1][1] = 0;
matrix h_variable_5419[1][3] = concat(h_variable_5418,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5419); matrix h_variable_5420 = h_variable_l[1]; matrix h_variable_5421 = h_variable_l[2];
ncols(h_variable_5420);
matrix h_variable_5422 = DecideZeroRows(h_variable_5420,h_variable_58);
IsZeroMatrix(h_variable_5422);
nrows(h_variable_5421);
def h_variable_5423 = h_variable_4814[7,6];
h_variable_5423;
matrix h_variable_5424[1][1] = 0;
matrix h_variable_5425[1][3] = concat(h_variable_5424,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5425); matrix h_variable_5426 = h_variable_l[1]; matrix h_variable_5427 = h_variable_l[2];
ncols(h_variable_5426);
matrix h_variable_5428 = DecideZeroRows(h_variable_5426,h_variable_58);
IsZeroMatrix(h_variable_5428);
nrows(h_variable_5427);
def h_variable_5429 = h_variable_4814[6,6];
h_variable_5429;
matrix h_variable_5430[1][1] = -2*x2;
matrix h_variable_5431[1][3] = concat(h_variable_5430,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5431); matrix h_variable_5432 = h_variable_l[1]; matrix h_variable_5433 = h_variable_l[2];
ncols(h_variable_5432);
matrix h_variable_5434 = DecideZeroRows(h_variable_5432,h_variable_58);
IsZeroMatrix(h_variable_5434);
ZeroRows(h_variable_5434);
nrows(h_variable_5433);
matrix h_variable_5436 = submat(h_variable_5432,1..1,intvec( 2 ));
matrix h_variable_5435 = DecideZeroRows(h_variable_5436,h_variable_58);
IsZeroMatrix(h_variable_5435);
IsIdentityMatrix(h_variable_5435);
matrix h_variable_5437[1][3] = concat(h_variable_5435,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5437); matrix h_variable_5438 = h_variable_l[1]; matrix h_variable_5439 = h_variable_l[2];
IsZeroMatrix(h_variable_5438);
matrix h_variable_5440 = DecideZeroRows(h_variable_5438,h_variable_58);
IsZeroMatrix(h_variable_5440);
def h_variable_5441 = h_variable_4814[5,6];
h_variable_5441;
matrix h_variable_5442[1][1] = 2*x1;
matrix h_variable_5443[1][3] = concat(h_variable_5442,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5443); matrix h_variable_5444 = h_variable_l[1]; matrix h_variable_5445 = h_variable_l[2];
ncols(h_variable_5444);
matrix h_variable_5446 = DecideZeroRows(h_variable_5444,h_variable_58);
IsZeroMatrix(h_variable_5446);
ZeroRows(h_variable_5446);
nrows(h_variable_5445);
matrix h_variable_5448 = submat(h_variable_5444,1..1,intvec( 2 ));
matrix h_variable_5447 = DecideZeroRows(h_variable_5448,h_variable_58);
IsZeroMatrix(h_variable_5447);
IsIdentityMatrix(h_variable_5447);
matrix h_variable_5449[1][3] = concat(h_variable_5447,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5449); matrix h_variable_5450 = h_variable_l[1]; matrix h_variable_5451 = h_variable_l[2];
IsZeroMatrix(h_variable_5450);
matrix h_variable_5452 = DecideZeroRows(h_variable_5450,h_variable_58);
IsZeroMatrix(h_variable_5452);
def h_variable_5453 = h_variable_4814[4,6];
h_variable_5453;
matrix h_variable_5454[1][1] = 2*x2;
matrix h_variable_5455[1][3] = concat(h_variable_5454,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5455); matrix h_variable_5456 = h_variable_l[1]; matrix h_variable_5457 = h_variable_l[2];
ncols(h_variable_5456);
matrix h_variable_5458 = DecideZeroRows(h_variable_5456,h_variable_58);
IsZeroMatrix(h_variable_5458);
ZeroRows(h_variable_5458);
nrows(h_variable_5457);
matrix h_variable_5460 = submat(h_variable_5456,1..1,intvec( 2 ));
matrix h_variable_5459 = DecideZeroRows(h_variable_5460,h_variable_58);
IsZeroMatrix(h_variable_5459);
IsIdentityMatrix(h_variable_5459);
matrix h_variable_5461[1][3] = concat(h_variable_5459,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5461); matrix h_variable_5462 = h_variable_l[1]; matrix h_variable_5463 = h_variable_l[2];
IsZeroMatrix(h_variable_5462);
matrix h_variable_5464 = DecideZeroRows(h_variable_5462,h_variable_58);
IsZeroMatrix(h_variable_5464);
def h_variable_5465 = h_variable_4814[3,6];
h_variable_5465;
matrix h_variable_5466[1][1] = 4*x1;
matrix h_variable_5467[1][3] = concat(h_variable_5466,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5467); matrix h_variable_5468 = h_variable_l[1]; matrix h_variable_5469 = h_variable_l[2];
ncols(h_variable_5468);
matrix h_variable_5470 = DecideZeroRows(h_variable_5468,h_variable_58);
IsZeroMatrix(h_variable_5470);
ZeroRows(h_variable_5470);
nrows(h_variable_5469);
matrix h_variable_5472 = submat(h_variable_5468,1..1,intvec( 2 ));
matrix h_variable_5471 = DecideZeroRows(h_variable_5472,h_variable_58);
IsZeroMatrix(h_variable_5471);
IsIdentityMatrix(h_variable_5471);
matrix h_variable_5473[1][3] = concat(h_variable_5471,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5473); matrix h_variable_5474 = h_variable_l[1]; matrix h_variable_5475 = h_variable_l[2];
IsZeroMatrix(h_variable_5474);
matrix h_variable_5476 = DecideZeroRows(h_variable_5474,h_variable_58);
IsZeroMatrix(h_variable_5476);
def h_variable_5477 = h_variable_4814[2,6];
h_variable_5477;
matrix h_variable_5478[1][1] = 0;
matrix h_variable_5479[1][3] = concat(h_variable_5478,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5479); matrix h_variable_5480 = h_variable_l[1]; matrix h_variable_5481 = h_variable_l[2];
ncols(h_variable_5480);
matrix h_variable_5482 = DecideZeroRows(h_variable_5480,h_variable_58);
IsZeroMatrix(h_variable_5482);
nrows(h_variable_5481);
def h_variable_5483 = h_variable_4814[1,6];
h_variable_5483;
matrix h_variable_5484[1][1] = 0;
matrix h_variable_5485[1][3] = concat(h_variable_5484,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5485); matrix h_variable_5486 = h_variable_l[1]; matrix h_variable_5487 = h_variable_l[2];
ncols(h_variable_5486);
matrix h_variable_5488 = DecideZeroRows(h_variable_5486,h_variable_58);
IsZeroMatrix(h_variable_5488);
nrows(h_variable_5487);
def h_variable_5489 = h_variable_4814[16,7];
h_variable_5489;
matrix h_variable_5490[1][1] = 0;
matrix h_variable_5491[1][3] = concat(h_variable_5490,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5491); matrix h_variable_5492 = h_variable_l[1]; matrix h_variable_5493 = h_variable_l[2];
ncols(h_variable_5492);
matrix h_variable_5494 = DecideZeroRows(h_variable_5492,h_variable_58);
IsZeroMatrix(h_variable_5494);
nrows(h_variable_5493);
def h_variable_5495 = h_variable_4814[15,7];
h_variable_5495;
matrix h_variable_5496[1][1] = 0;
matrix h_variable_5497[1][3] = concat(h_variable_5496,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5497); matrix h_variable_5498 = h_variable_l[1]; matrix h_variable_5499 = h_variable_l[2];
ncols(h_variable_5498);
matrix h_variable_5500 = DecideZeroRows(h_variable_5498,h_variable_58);
IsZeroMatrix(h_variable_5500);
nrows(h_variable_5499);
kill h_variable_4912;kill h_variable_4914;kill h_variable_4915;kill h_variable_4916;kill h_variable_4917;kill h_variable_4918;kill h_variable_4920;kill h_variable_4921;kill h_variable_4922;kill h_variable_4923;kill h_variable_4924;kill h_variable_4926;kill h_variable_4927;kill h_variable_4928;kill h_variable_4929;kill h_variable_4930;kill h_variable_4931;kill h_variable_4932;kill h_variable_4933;kill h_variable_4934;kill h_variable_4935;kill h_variable_4936;kill h_variable_4937;kill h_variable_4938;kill h_variable_4939;kill h_variable_4940;kill h_variable_4941;kill h_variable_4942;kill h_variable_4943;kill h_variable_4944;kill h_variable_4945;kill h_variable_4946;kill h_variable_4947;kill h_variable_4948;kill h_variable_4949;kill h_variable_4950;kill h_variable_4951;kill h_variable_4952;kill h_variable_4953;kill h_variable_4954;kill h_variable_4955;kill h_variable_4956;kill h_variable_4957;kill h_variable_4958;kill h_variable_4959;kill h_variable_4960;kill h_variable_4961;kill h_variable_4962;kill h_variable_4963;kill h_variable_4964;kill h_variable_4965;kill h_variable_4966;kill h_variable_4967;kill h_variable_4968;kill h_variable_4969;kill h_variable_4970;kill h_variable_4971;kill h_variable_4972;kill h_variable_4973;kill h_variable_4974;kill h_variable_4975;kill h_variable_4976;kill h_variable_4977;kill h_variable_4978;kill h_variable_4979;kill h_variable_4980;kill h_variable_4981;kill h_variable_4982;kill h_variable_4983;kill h_variable_4984;kill h_variable_4985;kill h_variable_4986;kill h_variable_4987;kill h_variable_4988;kill h_variable_4989;kill h_variable_4990;kill h_variable_4991;kill h_variable_4992;kill h_variable_4993;kill h_variable_4994;kill h_variable_4995;kill h_variable_4996;kill h_variable_4997;kill h_variable_4998;kill h_variable_4999;kill h_variable_5000;kill h_variable_5001;kill h_variable_5002;kill h_variable_5003;kill h_variable_5004;kill h_variable_5005;kill h_variable_5006;kill h_variable_5007;kill h_variable_5008;kill h_variable_5009;kill h_variable_5010;kill h_variable_5011;kill h_variable_5012;kill h_variable_5013;kill h_variable_5014;kill h_variable_5015;kill h_variable_5016;kill h_variable_5017;kill h_variable_5018;kill h_variable_5019;kill h_variable_5020;kill h_variable_5021;kill h_variable_5022;kill h_variable_5023;kill h_variable_5024;kill h_variable_5025;kill h_variable_5026;kill h_variable_5027;kill h_variable_5028;kill h_variable_5029;kill h_variable_5030;kill h_variable_5031;kill h_variable_5032;kill h_variable_5038;kill h_variable_5041;kill h_variable_5042;kill h_variable_5043;kill h_variable_5044;kill h_variable_5046;kill h_variable_5047;kill h_variable_5048;kill h_variable_5049;kill h_variable_5050;kill h_variable_5052;kill h_variable_5056;kill h_variable_5058;kill h_variable_5059;kill h_variable_5060;kill h_variable_5061;kill h_variable_5062;kill h_variable_5063;kill h_variable_5064;kill h_variable_5065;kill h_variable_5066;kill h_variable_5067;kill h_variable_5068;kill h_variable_5069;kill h_variable_5070;kill h_variable_5071;kill h_variable_5072;kill h_variable_5073;kill h_variable_5074;kill h_variable_5075;kill h_variable_5076;kill h_variable_5077;kill h_variable_5078;kill h_variable_5079;kill h_variable_5080;kill h_variable_5081;kill h_variable_5082;kill h_variable_5083;kill h_variable_5084;kill h_variable_5085;kill h_variable_5086;kill h_variable_5087;kill h_variable_5088;kill h_variable_5089;kill h_variable_5090;kill h_variable_5091;kill h_variable_5092;kill h_variable_5093;kill h_variable_5094;kill h_variable_5095;kill h_variable_5096;kill h_variable_5097;kill h_variable_5098;kill h_variable_5099;kill h_variable_5100;kill h_variable_5101;kill h_variable_5102;kill h_variable_5103;kill h_variable_5104;kill h_variable_5105;kill h_variable_5106;kill h_variable_5107;kill h_variable_5108;kill h_variable_5109;kill h_variable_5110;kill h_variable_5111;kill h_variable_5112;kill h_variable_5113;kill h_variable_5114;kill h_variable_5115;kill h_variable_5116;kill h_variable_5117;kill h_variable_5118;kill h_variable_5119;kill h_variable_5120;kill h_variable_5121;kill h_variable_5122;kill h_variable_5123;kill h_variable_5124;kill h_variable_5125;kill h_variable_5126;kill h_variable_5127;kill h_variable_5128;kill h_variable_5129;kill h_variable_5130;kill h_variable_5131;kill h_variable_5132;kill h_variable_5133;kill h_variable_5134;kill h_variable_5135;kill h_variable_5136;kill h_variable_5137;kill h_variable_5138;kill h_variable_5139;kill h_variable_5140;kill h_variable_5141;kill h_variable_5142;kill h_variable_5143;kill h_variable_5144;kill h_variable_5145;kill h_variable_5146;kill h_variable_5147;kill h_variable_5148;kill h_variable_5149;kill h_variable_5150;kill h_variable_5151;kill h_variable_5152;kill h_variable_5153;kill h_variable_5154;kill h_variable_5155;kill h_variable_5156;kill h_variable_5157;kill h_variable_5158;kill h_variable_5159;kill h_variable_5160;kill h_variable_5161;kill h_variable_5162;kill h_variable_5163;kill h_variable_5164;kill h_variable_5165;kill h_variable_5166;kill h_variable_5167;kill h_variable_5168;kill h_variable_5169;kill h_variable_5170;kill h_variable_5171;kill h_variable_5172;kill h_variable_5173;kill h_variable_5174;kill h_variable_5175;kill h_variable_5176;kill h_variable_5177;kill h_variable_5178;kill h_variable_5179;kill h_variable_5180;kill h_variable_5181;kill h_variable_5182;kill h_variable_5183;kill h_variable_5184;kill h_variable_5185;kill h_variable_5186;kill h_variable_5187;kill h_variable_5188;kill h_variable_5189;kill h_variable_5190;kill h_variable_5191;kill h_variable_5192;kill h_variable_5193;kill h_variable_5194;kill h_variable_5195;kill h_variable_5196;kill h_variable_5197;kill h_variable_5198;kill h_variable_5199;kill h_variable_5200;kill h_variable_5201;kill h_variable_5202;kill h_variable_5203;kill h_variable_5204;kill h_variable_5205;kill h_variable_5206;kill h_variable_5207;kill h_variable_5208;kill h_variable_5209;kill h_variable_5210;kill h_variable_5211;kill h_variable_5212;kill h_variable_5213;kill h_variable_5214;kill h_variable_5215;kill h_variable_5216;kill h_variable_5217;kill h_variable_5218;kill h_variable_5219;kill h_variable_5220;kill h_variable_5221;kill h_variable_5222;kill h_variable_5223;kill h_variable_5224;kill h_variable_5236;kill h_variable_5238;kill h_variable_5239;kill h_variable_5240;kill h_variable_5241;kill h_variable_5242;kill h_variable_5244;kill h_variable_5245;kill h_variable_5246;kill h_variable_5247;kill h_variable_5248;kill h_variable_5250;kill h_variable_5254;kill h_variable_5255;kill h_variable_5256;kill h_variable_5257;kill h_variable_5258;kill h_variable_5259;kill h_variable_5260;kill h_variable_5261;kill h_variable_5262;kill h_variable_5263;kill h_variable_5264;kill h_variable_5265;kill h_variable_5266;kill h_variable_5267;kill h_variable_5268;kill h_variable_5269;kill h_variable_5270;kill h_variable_5271;kill h_variable_5272;kill h_variable_5273;kill h_variable_5274;kill h_variable_5275;kill h_variable_5276;kill h_variable_5277;kill h_variable_5278;kill h_variable_5279;kill h_variable_5280;kill h_variable_5281;kill h_variable_5282;kill h_variable_5283;kill h_variable_5284;kill h_variable_5285;kill h_variable_5286;kill h_variable_5287;kill h_variable_5288;kill h_variable_5289;kill h_variable_5290;kill h_variable_5291;kill h_variable_5292;kill h_variable_5293;kill h_variable_5294;kill h_variable_5295;kill h_variable_5296;kill h_variable_5297;kill h_variable_5298;kill h_variable_5299;kill h_variable_5300;kill h_variable_5301;kill h_variable_5302;kill h_variable_5303;kill h_variable_5304;kill h_variable_5305;kill h_variable_5306;kill h_variable_5307;kill h_variable_5308;kill h_variable_5309;kill h_variable_5310;kill h_variable_5311;kill h_variable_5312;kill h_variable_5313;kill h_variable_5314;kill h_variable_5315;kill h_variable_5316;kill h_variable_5317;kill h_variable_5318;kill h_variable_5319;kill h_variable_5320;kill h_variable_5321;kill h_variable_5322;kill h_variable_5323;kill h_variable_5324;kill h_variable_5325;kill h_variable_5326;kill h_variable_5327;kill h_variable_5328;kill h_variable_5329;kill h_variable_5330;kill h_variable_5331;kill h_variable_5332;kill h_variable_5333;kill h_variable_5334;kill h_variable_5335;kill h_variable_5336;kill h_variable_5337;kill h_variable_5338;kill h_variable_5339;kill h_variable_5340;kill h_variable_5341;kill h_variable_5342;kill h_variable_5343;kill h_variable_5344;kill h_variable_5345;kill h_variable_5346;kill h_variable_5347;kill h_variable_5348;kill h_variable_5349;kill h_variable_5350;kill h_variable_5351;kill h_variable_5352;kill h_variable_5353;kill h_variable_5354;kill h_variable_5355;kill h_variable_5356;kill h_variable_5357;kill h_variable_5358;kill h_variable_5359;kill h_variable_5360;kill h_variable_5361;kill h_variable_5362;kill h_variable_5363;kill h_variable_5364;kill h_variable_5365;kill h_variable_5366;kill h_variable_5367;kill h_variable_5368;kill h_variable_5369;kill h_variable_5370;kill h_variable_5371;kill h_variable_5372;kill h_variable_5373;kill h_variable_5374;kill h_variable_5375;kill h_variable_5376;kill h_variable_5377;kill h_variable_5378;kill h_variable_5379;kill h_variable_5380;kill h_variable_5381;kill h_variable_5382;kill h_variable_5383;kill h_variable_5384;kill h_variable_5385;kill h_variable_5386;kill h_variable_5387;kill h_variable_5388;kill h_variable_5389;kill h_variable_5390;kill h_variable_5391;kill h_variable_5392;kill h_variable_5393;kill h_variable_5394;kill h_variable_5395;kill h_variable_5396;kill h_variable_5397;kill h_variable_5398;kill h_variable_5399;kill h_variable_5400;kill h_variable_5401;kill h_variable_5402;kill h_variable_5403;kill h_variable_5404;kill h_variable_5405;kill h_variable_5406;kill h_variable_5407;kill h_variable_5408;kill h_variable_5409;kill h_variable_5410;kill h_variable_5416;
def h_variable_5501 = h_variable_4814[14,7];
h_variable_5501;
matrix h_variable_5502[1][1] = 0;
matrix h_variable_5503[1][3] = concat(h_variable_5502,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5503); matrix h_variable_5504 = h_variable_l[1]; matrix h_variable_5505 = h_variable_l[2];
ncols(h_variable_5504);
matrix h_variable_5506 = DecideZeroRows(h_variable_5504,h_variable_58);
IsZeroMatrix(h_variable_5506);
nrows(h_variable_5505);
def h_variable_5507 = h_variable_4814[13,7];
h_variable_5507;
matrix h_variable_5508[1][1] = 0;
matrix h_variable_5509[1][3] = concat(h_variable_5508,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5509); matrix h_variable_5510 = h_variable_l[1]; matrix h_variable_5511 = h_variable_l[2];
ncols(h_variable_5510);
matrix h_variable_5512 = DecideZeroRows(h_variable_5510,h_variable_58);
IsZeroMatrix(h_variable_5512);
nrows(h_variable_5511);
def h_variable_5513 = h_variable_4814[12,7];
h_variable_5513;
matrix h_variable_5514[1][1] = 0;
matrix h_variable_5515[1][3] = concat(h_variable_5514,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5515); matrix h_variable_5516 = h_variable_l[1]; matrix h_variable_5517 = h_variable_l[2];
ncols(h_variable_5516);
matrix h_variable_5518 = DecideZeroRows(h_variable_5516,h_variable_58);
IsZeroMatrix(h_variable_5518);
nrows(h_variable_5517);
def h_variable_5519 = h_variable_4814[11,7];
h_variable_5519;
matrix h_variable_5520[1][1] = 0;
matrix h_variable_5521[1][3] = concat(h_variable_5520,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5521); matrix h_variable_5522 = h_variable_l[1]; matrix h_variable_5523 = h_variable_l[2];
ncols(h_variable_5522);
matrix h_variable_5524 = DecideZeroRows(h_variable_5522,h_variable_58);
IsZeroMatrix(h_variable_5524);
nrows(h_variable_5523);
def h_variable_5525 = h_variable_4814[10,7];
h_variable_5525;
matrix h_variable_5526[1][1] = 0;
matrix h_variable_5527[1][3] = concat(h_variable_5526,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5527); matrix h_variable_5528 = h_variable_l[1]; matrix h_variable_5529 = h_variable_l[2];
ncols(h_variable_5528);
matrix h_variable_5530 = DecideZeroRows(h_variable_5528,h_variable_58);
IsZeroMatrix(h_variable_5530);
nrows(h_variable_5529);
def h_variable_5531 = h_variable_4814[9,7];
h_variable_5531;
matrix h_variable_5532[1][1] = -3;
matrix h_variable_5533[1][3] = concat(h_variable_5532,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5533); matrix h_variable_5534 = h_variable_l[1]; matrix h_variable_5535 = h_variable_l[2];
ncols(h_variable_5534);
matrix h_variable_5536 = DecideZeroRows(h_variable_5534,h_variable_58);
IsZeroMatrix(h_variable_5536);
ZeroRows(h_variable_5536);
nrows(h_variable_5535);
matrix h_variable_5538 = submat(h_variable_5534,1..1,intvec( 1 ));
matrix h_variable_5537 = DecideZeroRows(h_variable_5538,h_variable_58);
IsZeroMatrix(h_variable_5537);
IsIdentityMatrix(h_variable_5537);
matrix h_variable_5539[1][3] = concat(h_variable_5537,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5539); matrix h_variable_5540 = h_variable_l[1]; matrix h_variable_5541 = h_variable_l[2];
IsZeroMatrix(h_variable_5540);
matrix h_variable_5542 = DecideZeroRows(h_variable_5540,h_variable_58);
IsZeroMatrix(h_variable_5542);
def h_variable_5543 = h_variable_4814[8,7];
h_variable_5543;
matrix h_variable_5544[1][1] = 0;
matrix h_variable_5545[1][3] = concat(h_variable_5544,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5545); matrix h_variable_5546 = h_variable_l[1]; matrix h_variable_5547 = h_variable_l[2];
ncols(h_variable_5546);
matrix h_variable_5548 = DecideZeroRows(h_variable_5546,h_variable_58);
IsZeroMatrix(h_variable_5548);
nrows(h_variable_5547);
def h_variable_5549 = h_variable_4814[7,7];
h_variable_5549;
matrix h_variable_5550[1][1] = 3*x1-3*x2;
matrix h_variable_5551[1][3] = concat(h_variable_5550,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5551); matrix h_variable_5552 = h_variable_l[1]; matrix h_variable_5553 = h_variable_l[2];
ncols(h_variable_5552);
matrix h_variable_5554 = DecideZeroRows(h_variable_5552,h_variable_58);
IsZeroMatrix(h_variable_5554);
ZeroRows(h_variable_5554);
nrows(h_variable_5553);
matrix h_variable_5556 = submat(h_variable_5552,1..1,intvec( 2 ));
matrix h_variable_5555 = DecideZeroRows(h_variable_5556,h_variable_58);
IsZeroMatrix(h_variable_5555);
IsIdentityMatrix(h_variable_5555);
matrix h_variable_5557[1][3] = concat(h_variable_5555,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5557); matrix h_variable_5558 = h_variable_l[1]; matrix h_variable_5559 = h_variable_l[2];
IsZeroMatrix(h_variable_5558);
matrix h_variable_5560 = DecideZeroRows(h_variable_5558,h_variable_58);
IsZeroMatrix(h_variable_5560);
def h_variable_5561 = h_variable_4814[6,7];
h_variable_5561;
matrix h_variable_5562[1][1] = 0;
matrix h_variable_5563[1][3] = concat(h_variable_5562,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5563); matrix h_variable_5564 = h_variable_l[1]; matrix h_variable_5565 = h_variable_l[2];
ncols(h_variable_5564);
matrix h_variable_5566 = DecideZeroRows(h_variable_5564,h_variable_58);
IsZeroMatrix(h_variable_5566);
nrows(h_variable_5565);
def h_variable_5567 = h_variable_4814[5,7];
h_variable_5567;
matrix h_variable_5568[1][1] = 0;
matrix h_variable_5569[1][3] = concat(h_variable_5568,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5569); matrix h_variable_5570 = h_variable_l[1]; matrix h_variable_5571 = h_variable_l[2];
ncols(h_variable_5570);
matrix h_variable_5572 = DecideZeroRows(h_variable_5570,h_variable_58);
IsZeroMatrix(h_variable_5572);
nrows(h_variable_5571);
def h_variable_5573 = h_variable_4814[4,7];
h_variable_5573;
matrix h_variable_5574[1][1] = 0;
matrix h_variable_5575[1][3] = concat(h_variable_5574,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5575); matrix h_variable_5576 = h_variable_l[1]; matrix h_variable_5577 = h_variable_l[2];
ncols(h_variable_5576);
matrix h_variable_5578 = DecideZeroRows(h_variable_5576,h_variable_58);
IsZeroMatrix(h_variable_5578);
nrows(h_variable_5577);
def h_variable_5579 = h_variable_4814[3,7];
h_variable_5579;
matrix h_variable_5580[1][1] = 0;
matrix h_variable_5581[1][3] = concat(h_variable_5580,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5581); matrix h_variable_5582 = h_variable_l[1]; matrix h_variable_5583 = h_variable_l[2];
ncols(h_variable_5582);
matrix h_variable_5584 = DecideZeroRows(h_variable_5582,h_variable_58);
IsZeroMatrix(h_variable_5584);
nrows(h_variable_5583);
def h_variable_5585 = h_variable_4814[2,7];
h_variable_5585;
matrix h_variable_5586[1][1] = 0;
matrix h_variable_5587[1][3] = concat(h_variable_5586,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5587); matrix h_variable_5588 = h_variable_l[1]; matrix h_variable_5589 = h_variable_l[2];
ncols(h_variable_5588);
matrix h_variable_5590 = DecideZeroRows(h_variable_5588,h_variable_58);
IsZeroMatrix(h_variable_5590);
nrows(h_variable_5589);
def h_variable_5591 = h_variable_4814[1,7];
h_variable_5591;
matrix h_variable_5592[1][1] = 0;
matrix h_variable_5593[1][3] = concat(h_variable_5592,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5593); matrix h_variable_5594 = h_variable_l[1]; matrix h_variable_5595 = h_variable_l[2];
ncols(h_variable_5594);
matrix h_variable_5596 = DecideZeroRows(h_variable_5594,h_variable_58);
IsZeroMatrix(h_variable_5596);
nrows(h_variable_5595);
def h_variable_5597 = h_variable_4814[16,8];
h_variable_5597;
matrix h_variable_5598[1][1] = 0;
matrix h_variable_5599[1][3] = concat(h_variable_5598,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5599); matrix h_variable_5600 = h_variable_l[1]; matrix h_variable_5601 = h_variable_l[2];
ncols(h_variable_5600);
matrix h_variable_5602 = DecideZeroRows(h_variable_5600,h_variable_58);
IsZeroMatrix(h_variable_5602);
nrows(h_variable_5601);
def h_variable_5603 = h_variable_4814[15,8];
h_variable_5603;
matrix h_variable_5604[1][1] = 0;
matrix h_variable_5605[1][3] = concat(h_variable_5604,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5605); matrix h_variable_5606 = h_variable_l[1]; matrix h_variable_5607 = h_variable_l[2];
ncols(h_variable_5606);
matrix h_variable_5608 = DecideZeroRows(h_variable_5606,h_variable_58);
IsZeroMatrix(h_variable_5608);
nrows(h_variable_5607);
def h_variable_5609 = h_variable_4814[14,8];
h_variable_5609;
matrix h_variable_5610[1][1] = 0;
matrix h_variable_5611[1][3] = concat(h_variable_5610,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5611); matrix h_variable_5612 = h_variable_l[1]; matrix h_variable_5613 = h_variable_l[2];
ncols(h_variable_5612);
matrix h_variable_5614 = DecideZeroRows(h_variable_5612,h_variable_58);
IsZeroMatrix(h_variable_5614);
nrows(h_variable_5613);
def h_variable_5615 = h_variable_4814[13,8];
h_variable_5615;
matrix h_variable_5616[1][1] = 0;
matrix h_variable_5617[1][3] = concat(h_variable_5616,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5617); matrix h_variable_5618 = h_variable_l[1]; matrix h_variable_5619 = h_variable_l[2];
ncols(h_variable_5618);
matrix h_variable_5620 = DecideZeroRows(h_variable_5618,h_variable_58);
IsZeroMatrix(h_variable_5620);
nrows(h_variable_5619);
def h_variable_5621 = h_variable_4814[12,8];
h_variable_5621;
matrix h_variable_5622[1][1] = -3;
matrix h_variable_5623[1][3] = concat(h_variable_5622,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5623); matrix h_variable_5624 = h_variable_l[1]; matrix h_variable_5625 = h_variable_l[2];
ncols(h_variable_5624);
matrix h_variable_5626 = DecideZeroRows(h_variable_5624,h_variable_58);
IsZeroMatrix(h_variable_5626);
ZeroRows(h_variable_5626);
nrows(h_variable_5625);
matrix h_variable_5628 = submat(h_variable_5624,1..1,intvec( 1 ));
matrix h_variable_5627 = DecideZeroRows(h_variable_5628,h_variable_58);
IsZeroMatrix(h_variable_5627);
IsIdentityMatrix(h_variable_5627);
matrix h_variable_5629[1][3] = concat(h_variable_5627,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5629); matrix h_variable_5630 = h_variable_l[1]; matrix h_variable_5631 = h_variable_l[2];
IsZeroMatrix(h_variable_5630);
matrix h_variable_5632 = DecideZeroRows(h_variable_5630,h_variable_58);
IsZeroMatrix(h_variable_5632);
def h_variable_5633 = h_variable_4814[11,8];
h_variable_5633;
matrix h_variable_5634[1][1] = 0;
matrix h_variable_5635[1][3] = concat(h_variable_5634,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5635); matrix h_variable_5636 = h_variable_l[1]; matrix h_variable_5637 = h_variable_l[2];
ncols(h_variable_5636);
matrix h_variable_5638 = DecideZeroRows(h_variable_5636,h_variable_58);
IsZeroMatrix(h_variable_5638);
nrows(h_variable_5637);
def h_variable_5639 = h_variable_4814[10,8];
h_variable_5639;
matrix h_variable_5640[1][1] = 3*x1+3*x2-3*x3;
matrix h_variable_5641[1][3] = concat(h_variable_5640,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5641); matrix h_variable_5642 = h_variable_l[1]; matrix h_variable_5643 = h_variable_l[2];
ncols(h_variable_5642);
matrix h_variable_5644 = DecideZeroRows(h_variable_5642,h_variable_58);
IsZeroMatrix(h_variable_5644);
ZeroRows(h_variable_5644);
nrows(h_variable_5643);
matrix h_variable_5646 = submat(h_variable_5642,1..1,intvec( 2 ));
matrix h_variable_5645 = DecideZeroRows(h_variable_5646,h_variable_58);
IsZeroMatrix(h_variable_5645);
IsIdentityMatrix(h_variable_5645);
matrix h_variable_5647[1][3] = concat(h_variable_5645,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5647); matrix h_variable_5648 = h_variable_l[1]; matrix h_variable_5649 = h_variable_l[2];
IsZeroMatrix(h_variable_5648);
matrix h_variable_5650 = DecideZeroRows(h_variable_5648,h_variable_58);
IsZeroMatrix(h_variable_5650);
def h_variable_5651 = h_variable_4814[9,8];
h_variable_5651;
matrix h_variable_5652[1][1] = 3*x2;
matrix h_variable_5653[1][3] = concat(h_variable_5652,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5653); matrix h_variable_5654 = h_variable_l[1]; matrix h_variable_5655 = h_variable_l[2];
ncols(h_variable_5654);
matrix h_variable_5656 = DecideZeroRows(h_variable_5654,h_variable_58);
IsZeroMatrix(h_variable_5656);
ZeroRows(h_variable_5656);
nrows(h_variable_5655);
matrix h_variable_5658 = submat(h_variable_5654,1..1,intvec( 2 ));
matrix h_variable_5657 = DecideZeroRows(h_variable_5658,h_variable_58);
IsZeroMatrix(h_variable_5657);
IsIdentityMatrix(h_variable_5657);
matrix h_variable_5659[1][3] = concat(h_variable_5657,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5659); matrix h_variable_5660 = h_variable_l[1]; matrix h_variable_5661 = h_variable_l[2];
IsZeroMatrix(h_variable_5660);
matrix h_variable_5662 = DecideZeroRows(h_variable_5660,h_variable_58);
IsZeroMatrix(h_variable_5662);
def h_variable_5663 = h_variable_4814[8,8];
h_variable_5663;
matrix h_variable_5664[1][1] = 0;
matrix h_variable_5665[1][3] = concat(h_variable_5664,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5665); matrix h_variable_5666 = h_variable_l[1]; matrix h_variable_5667 = h_variable_l[2];
ncols(h_variable_5666);
matrix h_variable_5668 = DecideZeroRows(h_variable_5666,h_variable_58);
IsZeroMatrix(h_variable_5668);
nrows(h_variable_5667);
def h_variable_5669 = h_variable_4814[7,8];
h_variable_5669;
matrix h_variable_5670[1][1] = 0;
matrix h_variable_5671[1][3] = concat(h_variable_5670,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5671); matrix h_variable_5672 = h_variable_l[1]; matrix h_variable_5673 = h_variable_l[2];
ncols(h_variable_5672);
matrix h_variable_5674 = DecideZeroRows(h_variable_5672,h_variable_58);
IsZeroMatrix(h_variable_5674);
nrows(h_variable_5673);
def h_variable_5675 = h_variable_4814[6,8];
h_variable_5675;
matrix h_variable_5676[1][1] = 0;
matrix h_variable_5677[1][3] = concat(h_variable_5676,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5677); matrix h_variable_5678 = h_variable_l[1]; matrix h_variable_5679 = h_variable_l[2];
ncols(h_variable_5678);
matrix h_variable_5680 = DecideZeroRows(h_variable_5678,h_variable_58);
IsZeroMatrix(h_variable_5680);
nrows(h_variable_5679);
def h_variable_5681 = h_variable_4814[5,8];
h_variable_5681;
matrix h_variable_5682[1][1] = 0;
matrix h_variable_5683[1][3] = concat(h_variable_5682,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5683); matrix h_variable_5684 = h_variable_l[1]; matrix h_variable_5685 = h_variable_l[2];
ncols(h_variable_5684);
matrix h_variable_5686 = DecideZeroRows(h_variable_5684,h_variable_58);
IsZeroMatrix(h_variable_5686);
nrows(h_variable_5685);
def h_variable_5687 = h_variable_4814[4,8];
h_variable_5687;
matrix h_variable_5688[1][1] = 0;
matrix h_variable_5689[1][3] = concat(h_variable_5688,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5689); matrix h_variable_5690 = h_variable_l[1]; matrix h_variable_5691 = h_variable_l[2];
ncols(h_variable_5690);
matrix h_variable_5692 = DecideZeroRows(h_variable_5690,h_variable_58);
IsZeroMatrix(h_variable_5692);
nrows(h_variable_5691);
def h_variable_5693 = h_variable_4814[3,8];
h_variable_5693;
matrix h_variable_5694[1][1] = 0;
matrix h_variable_5695[1][3] = concat(h_variable_5694,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5695); matrix h_variable_5696 = h_variable_l[1]; matrix h_variable_5697 = h_variable_l[2];
ncols(h_variable_5696);
matrix h_variable_5698 = DecideZeroRows(h_variable_5696,h_variable_58);
IsZeroMatrix(h_variable_5698);
nrows(h_variable_5697);
def h_variable_5699 = h_variable_4814[2,8];
h_variable_5699;
matrix h_variable_5700[1][1] = 0;
matrix h_variable_5701[1][3] = concat(h_variable_5700,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5701); matrix h_variable_5702 = h_variable_l[1]; matrix h_variable_5703 = h_variable_l[2];
ncols(h_variable_5702);
matrix h_variable_5704 = DecideZeroRows(h_variable_5702,h_variable_58);
IsZeroMatrix(h_variable_5704);
nrows(h_variable_5703);
def h_variable_5705 = h_variable_4814[1,8];
h_variable_5705;
matrix h_variable_5706[1][1] = 0;
matrix h_variable_5707[1][3] = concat(h_variable_5706,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5707); matrix h_variable_5708 = h_variable_l[1]; matrix h_variable_5709 = h_variable_l[2];
ncols(h_variable_5708);
matrix h_variable_5710 = DecideZeroRows(h_variable_5708,h_variable_58);
IsZeroMatrix(h_variable_5710);
nrows(h_variable_5709);
def h_variable_5711 = h_variable_4814[16,9];
h_variable_5711;
matrix h_variable_5712[1][1] = 0;
matrix h_variable_5713[1][3] = concat(h_variable_5712,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5713); matrix h_variable_5714 = h_variable_l[1]; matrix h_variable_5715 = h_variable_l[2];
ncols(h_variable_5714);
matrix h_variable_5716 = DecideZeroRows(h_variable_5714,h_variable_58);
IsZeroMatrix(h_variable_5716);
nrows(h_variable_5715);
def h_variable_5717 = h_variable_4814[15,9];
h_variable_5717;
matrix h_variable_5718[1][1] = 0;
matrix h_variable_5719[1][3] = concat(h_variable_5718,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5719); matrix h_variable_5720 = h_variable_l[1]; matrix h_variable_5721 = h_variable_l[2];
ncols(h_variable_5720);
matrix h_variable_5722 = DecideZeroRows(h_variable_5720,h_variable_58);
IsZeroMatrix(h_variable_5722);
nrows(h_variable_5721);
def h_variable_5723 = h_variable_4814[14,9];
h_variable_5723;
matrix h_variable_5724[1][1] = 0;
matrix h_variable_5725[1][3] = concat(h_variable_5724,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5725); matrix h_variable_5726 = h_variable_l[1]; matrix h_variable_5727 = h_variable_l[2];
ncols(h_variable_5726);
matrix h_variable_5728 = DecideZeroRows(h_variable_5726,h_variable_58);
IsZeroMatrix(h_variable_5728);
nrows(h_variable_5727);
def h_variable_5729 = h_variable_4814[13,9];
h_variable_5729;
matrix h_variable_5730[1][1] = 0;
matrix h_variable_5731[1][3] = concat(h_variable_5730,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5731); matrix h_variable_5732 = h_variable_l[1]; matrix h_variable_5733 = h_variable_l[2];
ncols(h_variable_5732);
matrix h_variable_5734 = DecideZeroRows(h_variable_5732,h_variable_58);
IsZeroMatrix(h_variable_5734);
nrows(h_variable_5733);
def h_variable_5735 = h_variable_4814[12,9];
h_variable_5735;
matrix h_variable_5736[1][1] = 0;
matrix h_variable_5737[1][3] = concat(h_variable_5736,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5737); matrix h_variable_5738 = h_variable_l[1]; matrix h_variable_5739 = h_variable_l[2];
ncols(h_variable_5738);
matrix h_variable_5740 = DecideZeroRows(h_variable_5738,h_variable_58);
IsZeroMatrix(h_variable_5740);
nrows(h_variable_5739);
def h_variable_5741 = h_variable_4814[11,9];
h_variable_5741;
matrix h_variable_5742[1][1] = 0;
matrix h_variable_5743[1][3] = concat(h_variable_5742,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5743); matrix h_variable_5744 = h_variable_l[1]; matrix h_variable_5745 = h_variable_l[2];
ncols(h_variable_5744);
matrix h_variable_5746 = DecideZeroRows(h_variable_5744,h_variable_58);
IsZeroMatrix(h_variable_5746);
nrows(h_variable_5745);
def h_variable_5747 = h_variable_4814[10,9];
h_variable_5747;
matrix h_variable_5748[1][1] = 0;
matrix h_variable_5749[1][3] = concat(h_variable_5748,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5749); matrix h_variable_5750 = h_variable_l[1]; matrix h_variable_5751 = h_variable_l[2];
ncols(h_variable_5750);
matrix h_variable_5752 = DecideZeroRows(h_variable_5750,h_variable_58);
IsZeroMatrix(h_variable_5752);
nrows(h_variable_5751);
def h_variable_5753 = h_variable_4814[9,9];
h_variable_5753;
matrix h_variable_5754[1][1] = 0;
matrix h_variable_5755[1][3] = concat(h_variable_5754,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5755); matrix h_variable_5756 = h_variable_l[1]; matrix h_variable_5757 = h_variable_l[2];
ncols(h_variable_5756);
matrix h_variable_5758 = DecideZeroRows(h_variable_5756,h_variable_58);
IsZeroMatrix(h_variable_5758);
nrows(h_variable_5757);
def h_variable_5759 = h_variable_4814[8,9];
h_variable_5759;
matrix h_variable_5760[1][1] = 0;
matrix h_variable_5761[1][3] = concat(h_variable_5760,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5761); matrix h_variable_5762 = h_variable_l[1]; matrix h_variable_5763 = h_variable_l[2];
ncols(h_variable_5762);
matrix h_variable_5764 = DecideZeroRows(h_variable_5762,h_variable_58);
IsZeroMatrix(h_variable_5764);
nrows(h_variable_5763);
def h_variable_5765 = h_variable_4814[7,9];
h_variable_5765;
matrix h_variable_5766[1][1] = 0;
matrix h_variable_5767[1][3] = concat(h_variable_5766,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5767); matrix h_variable_5768 = h_variable_l[1]; matrix h_variable_5769 = h_variable_l[2];
ncols(h_variable_5768);
matrix h_variable_5770 = DecideZeroRows(h_variable_5768,h_variable_58);
IsZeroMatrix(h_variable_5770);
nrows(h_variable_5769);
def h_variable_5771 = h_variable_4814[6,9];
h_variable_5771;
matrix h_variable_5772[1][1] = 0;
matrix h_variable_5773[1][3] = concat(h_variable_5772,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5773); matrix h_variable_5774 = h_variable_l[1]; matrix h_variable_5775 = h_variable_l[2];
ncols(h_variable_5774);
matrix h_variable_5776 = DecideZeroRows(h_variable_5774,h_variable_58);
IsZeroMatrix(h_variable_5776);
nrows(h_variable_5775);
def h_variable_5777 = h_variable_4814[5,9];
h_variable_5777;
matrix h_variable_5778[1][1] = 0;
matrix h_variable_5779[1][3] = concat(h_variable_5778,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5779); matrix h_variable_5780 = h_variable_l[1]; matrix h_variable_5781 = h_variable_l[2];
ncols(h_variable_5780);
matrix h_variable_5782 = DecideZeroRows(h_variable_5780,h_variable_58);
IsZeroMatrix(h_variable_5782);
nrows(h_variable_5781);
def h_variable_5783 = h_variable_4814[4,9];
h_variable_5783;
matrix h_variable_5784[1][1] = 0;
matrix h_variable_5785[1][3] = concat(h_variable_5784,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5785); matrix h_variable_5786 = h_variable_l[1]; matrix h_variable_5787 = h_variable_l[2];
ncols(h_variable_5786);
matrix h_variable_5788 = DecideZeroRows(h_variable_5786,h_variable_58);
IsZeroMatrix(h_variable_5788);
nrows(h_variable_5787);
def h_variable_5789 = h_variable_4814[3,9];
h_variable_5789;
matrix h_variable_5790[1][1] = 0;
matrix h_variable_5791[1][3] = concat(h_variable_5790,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5791); matrix h_variable_5792 = h_variable_l[1]; matrix h_variable_5793 = h_variable_l[2];
ncols(h_variable_5792);
matrix h_variable_5794 = DecideZeroRows(h_variable_5792,h_variable_58);
IsZeroMatrix(h_variable_5794);
nrows(h_variable_5793);
def h_variable_5795 = h_variable_4814[2,9];
h_variable_5795;
matrix h_variable_5796[1][1] = a7+1;
matrix h_variable_5797[1][3] = concat(h_variable_5796,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5797); matrix h_variable_5798 = h_variable_l[1]; matrix h_variable_5799 = h_variable_l[2];
ncols(h_variable_5798);
matrix h_variable_5800 = DecideZeroRows(h_variable_5798,h_variable_58);
IsZeroMatrix(h_variable_5800);
ZeroRows(h_variable_5800);
nrows(h_variable_5799);
matrix h_variable_5801[1][4] = concat(h_variable_5798,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_5801); matrix h_variable_5802 = h_variable_l[1]; matrix h_variable_5803 = h_variable_l[2];
IsZeroMatrix(h_variable_5802);
matrix h_variable_5804 = DecideZeroRows(h_variable_5802,h_variable_58);
IsZeroMatrix(h_variable_5804);
def h_variable_5805 = h_variable_4814[1,9];
h_variable_5805;
matrix h_variable_5806[1][1] = 0;
matrix h_variable_5807[1][3] = concat(h_variable_5806,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5807); matrix h_variable_5808 = h_variable_l[1]; matrix h_variable_5809 = h_variable_l[2];
ncols(h_variable_5808);
matrix h_variable_5810 = DecideZeroRows(h_variable_5808,h_variable_58);
IsZeroMatrix(h_variable_5810);
nrows(h_variable_5809);
def h_variable_5811 = h_variable_4814[16,10];
h_variable_5811;
matrix h_variable_5812[1][1] = 0;
matrix h_variable_5813[1][3] = concat(h_variable_5812,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5813); matrix h_variable_5814 = h_variable_l[1]; matrix h_variable_5815 = h_variable_l[2];
ncols(h_variable_5814);
matrix h_variable_5816 = DecideZeroRows(h_variable_5814,h_variable_58);
IsZeroMatrix(h_variable_5816);
nrows(h_variable_5815);
def h_variable_5817 = h_variable_4814[15,10];
h_variable_5817;
matrix h_variable_5818[1][1] = 0;
matrix h_variable_5819[1][3] = concat(h_variable_5818,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5819); matrix h_variable_5820 = h_variable_l[1]; matrix h_variable_5821 = h_variable_l[2];
ncols(h_variable_5820);
matrix h_variable_5822 = DecideZeroRows(h_variable_5820,h_variable_58);
IsZeroMatrix(h_variable_5822);
nrows(h_variable_5821);
def h_variable_5823 = h_variable_4814[14,10];
h_variable_5823;
matrix h_variable_5824[1][1] = 0;
matrix h_variable_5825[1][3] = concat(h_variable_5824,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5825); matrix h_variable_5826 = h_variable_l[1]; matrix h_variable_5827 = h_variable_l[2];
ncols(h_variable_5826);
matrix h_variable_5828 = DecideZeroRows(h_variable_5826,h_variable_58);
IsZeroMatrix(h_variable_5828);
nrows(h_variable_5827);
def h_variable_5829 = h_variable_4814[13,10];
h_variable_5829;
matrix h_variable_5830[1][1] = 0;
matrix h_variable_5831[1][3] = concat(h_variable_5830,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5831); matrix h_variable_5832 = h_variable_l[1]; matrix h_variable_5833 = h_variable_l[2];
ncols(h_variable_5832);
matrix h_variable_5834 = DecideZeroRows(h_variable_5832,h_variable_58);
IsZeroMatrix(h_variable_5834);
nrows(h_variable_5833);
def h_variable_5835 = h_variable_4814[12,10];
h_variable_5835;
matrix h_variable_5836[1][1] = 0;
matrix h_variable_5837[1][3] = concat(h_variable_5836,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5837); matrix h_variable_5838 = h_variable_l[1]; matrix h_variable_5839 = h_variable_l[2];
ncols(h_variable_5838);
matrix h_variable_5840 = DecideZeroRows(h_variable_5838,h_variable_58);
IsZeroMatrix(h_variable_5840);
nrows(h_variable_5839);
def h_variable_5841 = h_variable_4814[11,10];
h_variable_5841;
matrix h_variable_5842[1][1] = 0;
matrix h_variable_5843[1][3] = concat(h_variable_5842,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5843); matrix h_variable_5844 = h_variable_l[1]; matrix h_variable_5845 = h_variable_l[2];
ncols(h_variable_5844);
matrix h_variable_5846 = DecideZeroRows(h_variable_5844,h_variable_58);
IsZeroMatrix(h_variable_5846);
nrows(h_variable_5845);
def h_variable_5847 = h_variable_4814[10,10];
h_variable_5847;
matrix h_variable_5848[1][1] = 0;
matrix h_variable_5849[1][3] = concat(h_variable_5848,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5849); matrix h_variable_5850 = h_variable_l[1]; matrix h_variable_5851 = h_variable_l[2];
ncols(h_variable_5850);
matrix h_variable_5852 = DecideZeroRows(h_variable_5850,h_variable_58);
IsZeroMatrix(h_variable_5852);
nrows(h_variable_5851);
def h_variable_5853 = h_variable_4814[9,10];
h_variable_5853;
matrix h_variable_5854[1][1] = 0;
matrix h_variable_5855[1][3] = concat(h_variable_5854,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5855); matrix h_variable_5856 = h_variable_l[1]; matrix h_variable_5857 = h_variable_l[2];
ncols(h_variable_5856);
matrix h_variable_5858 = DecideZeroRows(h_variable_5856,h_variable_58);
IsZeroMatrix(h_variable_5858);
nrows(h_variable_5857);
def h_variable_5859 = h_variable_4814[8,10];
h_variable_5859;
matrix h_variable_5860[1][1] = 0;
matrix h_variable_5861[1][3] = concat(h_variable_5860,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5861); matrix h_variable_5862 = h_variable_l[1]; matrix h_variable_5863 = h_variable_l[2];
ncols(h_variable_5862);
matrix h_variable_5864 = DecideZeroRows(h_variable_5862,h_variable_58);
IsZeroMatrix(h_variable_5864);
nrows(h_variable_5863);
def h_variable_5865 = h_variable_4814[7,10];
h_variable_5865;
matrix h_variable_5866[1][1] = 0;
matrix h_variable_5867[1][3] = concat(h_variable_5866,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5867); matrix h_variable_5868 = h_variable_l[1]; matrix h_variable_5869 = h_variable_l[2];
ncols(h_variable_5868);
matrix h_variable_5870 = DecideZeroRows(h_variable_5868,h_variable_58);
IsZeroMatrix(h_variable_5870);
nrows(h_variable_5869);
def h_variable_5871 = h_variable_4814[6,10];
h_variable_5871;
matrix h_variable_5872[1][1] = -1;
matrix h_variable_5873[1][3] = concat(h_variable_5872,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5873); matrix h_variable_5874 = h_variable_l[1]; matrix h_variable_5875 = h_variable_l[2];
ncols(h_variable_5874);
matrix h_variable_5876 = DecideZeroRows(h_variable_5874,h_variable_58);
IsZeroMatrix(h_variable_5876);
nrows(h_variable_5875);
IsIdentityMatrix(h_variable_5876);
def h_variable_5877 = h_variable_4814[1,10];
h_variable_5877;
matrix h_variable_5878[1][1] = 0;
matrix h_variable_5879 = DecideZeroRows(h_variable_5878,h_variable_58);
IsZeroMatrix(h_variable_5879);
def h_variable_5880 = h_variable_5879[1,1];
h_variable_5880==0;
def h_variable_5881 = h_variable_4814[2,10];
h_variable_5881;
matrix h_variable_5882[1][1] = 0;
matrix h_variable_5883 = DecideZeroRows(h_variable_5882,h_variable_58);
IsZeroMatrix(h_variable_5883);
def h_variable_5884 = h_variable_5883[1,1];
h_variable_5884==0;
def h_variable_5885 = h_variable_4814[3,10];
h_variable_5885;
matrix h_variable_5886[1][1] = a7;
matrix h_variable_5887 = DecideZeroRows(h_variable_5886,h_variable_58);
IsZeroMatrix(h_variable_5887);
def h_variable_5888 = h_variable_5887[1,1];
h_variable_5888==0;
def h_variable_5889 = h_variable_4814[4,10];
h_variable_5889;
matrix h_variable_5890[1][1] = -2;
matrix h_variable_5891 = DecideZeroRows(h_variable_5890,h_variable_58);
IsZeroMatrix(h_variable_5891);
def h_variable_5892 = h_variable_5891[1,1];
h_variable_5892==0;
def h_variable_5893 = h_variable_4814[5,10];
h_variable_5893;
matrix h_variable_5894[1][1] = -2;
matrix h_variable_5895 = DecideZeroRows(h_variable_5894,h_variable_58);
IsZeroMatrix(h_variable_5895);
def h_variable_5896 = h_variable_5895[1,1];
h_variable_5896==0;
def h_variable_5897 = h_variable_4814[6,10];
h_variable_5897;
matrix h_variable_5898[1][1] = -1;
matrix h_variable_5899 = DecideZeroRows(h_variable_5898,h_variable_58);
IsZeroMatrix(h_variable_5899);
def h_variable_5900 = h_variable_5899[1,1];
h_variable_5900==0;
def h_variable_5901 = h_variable_4814[7,10];
h_variable_5901;
matrix h_variable_5902[1][1] = 0;
matrix h_variable_5903 = DecideZeroRows(h_variable_5902,h_variable_58);
IsZeroMatrix(h_variable_5903);
def h_variable_5904 = h_variable_5903[1,1];
h_variable_5904==0;
def h_variable_5905 = h_variable_4814[8,10];
h_variable_5905;
matrix h_variable_5906[1][1] = 0;
matrix h_variable_5907 = DecideZeroRows(h_variable_5906,h_variable_58);
IsZeroMatrix(h_variable_5907);
def h_variable_5908 = h_variable_5907[1,1];
h_variable_5908==0;
def h_variable_5909 = h_variable_4814[9,10];
h_variable_5909;
matrix h_variable_5910[1][1] = 0;
matrix h_variable_5911 = DecideZeroRows(h_variable_5910,h_variable_58);
IsZeroMatrix(h_variable_5911);
def h_variable_5912 = h_variable_5911[1,1];
h_variable_5912==0;
def h_variable_5913 = h_variable_4814[10,10];
h_variable_5913;
matrix h_variable_5914[1][1] = 0;
matrix h_variable_5915 = DecideZeroRows(h_variable_5914,h_variable_58);
IsZeroMatrix(h_variable_5915);
def h_variable_5916 = h_variable_5915[1,1];
h_variable_5916==0;
def h_variable_5917 = h_variable_4814[11,10];
h_variable_5917;
matrix h_variable_5918[1][1] = 0;
matrix h_variable_5919 = DecideZeroRows(h_variable_5918,h_variable_58);
IsZeroMatrix(h_variable_5919);
def h_variable_5920 = h_variable_5919[1,1];
h_variable_5920==0;
def h_variable_5921 = h_variable_4814[12,10];
h_variable_5921;
matrix h_variable_5922[1][1] = 0;
matrix h_variable_5923 = DecideZeroRows(h_variable_5922,h_variable_58);
IsZeroMatrix(h_variable_5923);
def h_variable_5924 = h_variable_5923[1,1];
h_variable_5924==0;
def h_variable_5925 = h_variable_4814[13,10];
h_variable_5925;
matrix h_variable_5926[1][1] = 0;
matrix h_variable_5927 = DecideZeroRows(h_variable_5926,h_variable_58);
IsZeroMatrix(h_variable_5927);
def h_variable_5928 = h_variable_5927[1,1];
h_variable_5928==0;
def h_variable_5929 = h_variable_4814[14,10];
h_variable_5929;
matrix h_variable_5930[1][1] = 0;
matrix h_variable_5931 = DecideZeroRows(h_variable_5930,h_variable_58);
IsZeroMatrix(h_variable_5931);
def h_variable_5932 = h_variable_5931[1,1];
h_variable_5932==0;
def h_variable_5933 = h_variable_4814[15,10];
h_variable_5933;
matrix h_variable_5934[1][1] = 0;
matrix h_variable_5935 = DecideZeroRows(h_variable_5934,h_variable_58);
IsZeroMatrix(h_variable_5935);
def h_variable_5936 = h_variable_5935[1,1];
h_variable_5936==0;
def h_variable_5937 = h_variable_4814[16,10];
h_variable_5937;
matrix h_variable_5938[1][1] = 0;
matrix h_variable_5939 = DecideZeroRows(h_variable_5938,h_variable_58);
IsZeroMatrix(h_variable_5939);
def h_variable_5940 = h_variable_5939[1,1];
h_variable_5940==0;
def h_variable_5941 = h_variable_4814[16,11];
h_variable_5941;
matrix h_variable_5942[1][1] = 0;
matrix h_variable_5943[1][3] = concat(h_variable_5942,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5943); matrix h_variable_5944 = h_variable_l[1]; matrix h_variable_5945 = h_variable_l[2];
ncols(h_variable_5944);
matrix h_variable_5946 = DecideZeroRows(h_variable_5944,h_variable_58);
IsZeroMatrix(h_variable_5946);
nrows(h_variable_5945);
def h_variable_5947 = h_variable_4814[15,11];
h_variable_5947;
matrix h_variable_5948[1][1] = 0;
matrix h_variable_5949[1][3] = concat(h_variable_5948,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5949); matrix h_variable_5950 = h_variable_l[1]; matrix h_variable_5951 = h_variable_l[2];
ncols(h_variable_5950);
matrix h_variable_5952 = DecideZeroRows(h_variable_5950,h_variable_58);
IsZeroMatrix(h_variable_5952);
nrows(h_variable_5951);
def h_variable_5953 = h_variable_4814[14,11];
h_variable_5953;
matrix h_variable_5954[1][1] = 0;
matrix h_variable_5955[1][3] = concat(h_variable_5954,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5955); matrix h_variable_5956 = h_variable_l[1]; matrix h_variable_5957 = h_variable_l[2];
ncols(h_variable_5956);
matrix h_variable_5958 = DecideZeroRows(h_variable_5956,h_variable_58);
IsZeroMatrix(h_variable_5958);
nrows(h_variable_5957);
def h_variable_5959 = h_variable_4814[13,11];
h_variable_5959;
matrix h_variable_5960[1][1] = 0;
matrix h_variable_5961[1][3] = concat(h_variable_5960,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5961); matrix h_variable_5962 = h_variable_l[1]; matrix h_variable_5963 = h_variable_l[2];
ncols(h_variable_5962);
matrix h_variable_5964 = DecideZeroRows(h_variable_5962,h_variable_58);
IsZeroMatrix(h_variable_5964);
nrows(h_variable_5963);
def h_variable_5965 = h_variable_4814[12,11];
h_variable_5965;
matrix h_variable_5966[1][1] = 0;
matrix h_variable_5967[1][3] = concat(h_variable_5966,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5967); matrix h_variable_5968 = h_variable_l[1]; matrix h_variable_5969 = h_variable_l[2];
ncols(h_variable_5968);
matrix h_variable_5970 = DecideZeroRows(h_variable_5968,h_variable_58);
IsZeroMatrix(h_variable_5970);
nrows(h_variable_5969);
def h_variable_5971 = h_variable_4814[11,11];
h_variable_5971;
matrix h_variable_5972[1][1] = 0;
matrix h_variable_5973[1][3] = concat(h_variable_5972,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5973); matrix h_variable_5974 = h_variable_l[1]; matrix h_variable_5975 = h_variable_l[2];
ncols(h_variable_5974);
matrix h_variable_5976 = DecideZeroRows(h_variable_5974,h_variable_58);
IsZeroMatrix(h_variable_5976);
nrows(h_variable_5975);
def h_variable_5977 = h_variable_4814[10,11];
h_variable_5977;
matrix h_variable_5978[1][1] = 0;
matrix h_variable_5979[1][3] = concat(h_variable_5978,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5979); matrix h_variable_5980 = h_variable_l[1]; matrix h_variable_5981 = h_variable_l[2];
ncols(h_variable_5980);
matrix h_variable_5982 = DecideZeroRows(h_variable_5980,h_variable_58);
IsZeroMatrix(h_variable_5982);
nrows(h_variable_5981);
def h_variable_5983 = h_variable_4814[9,11];
h_variable_5983;
matrix h_variable_5984[1][1] = 0;
matrix h_variable_5985[1][3] = concat(h_variable_5984,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5985); matrix h_variable_5986 = h_variable_l[1]; matrix h_variable_5987 = h_variable_l[2];
ncols(h_variable_5986);
matrix h_variable_5988 = DecideZeroRows(h_variable_5986,h_variable_58);
IsZeroMatrix(h_variable_5988);
nrows(h_variable_5987);
def h_variable_5989 = h_variable_4814[8,11];
h_variable_5989;
matrix h_variable_5990[1][1] = 0;
matrix h_variable_5991[1][3] = concat(h_variable_5990,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5991); matrix h_variable_5992 = h_variable_l[1]; matrix h_variable_5993 = h_variable_l[2];
ncols(h_variable_5992);
matrix h_variable_5994 = DecideZeroRows(h_variable_5992,h_variable_58);
IsZeroMatrix(h_variable_5994);
nrows(h_variable_5993);
def h_variable_5995 = h_variable_4814[7,11];
h_variable_5995;
matrix h_variable_5996[1][1] = 0;
matrix h_variable_5997[1][3] = concat(h_variable_5996,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_5997); matrix h_variable_5998 = h_variable_l[1]; matrix h_variable_5999 = h_variable_l[2];
ncols(h_variable_5998);
matrix h_variable_6000 = DecideZeroRows(h_variable_5998,h_variable_58);
IsZeroMatrix(h_variable_6000);
nrows(h_variable_5999);
kill h_variable_5419;kill h_variable_5420;kill h_variable_5421;kill h_variable_5422;kill h_variable_5424;kill h_variable_5425;kill h_variable_5426;kill h_variable_5427;kill h_variable_5428;kill h_variable_5430;kill h_variable_5431;kill h_variable_5432;kill h_variable_5433;kill h_variable_5434;kill h_variable_5435;kill h_variable_5436;kill h_variable_5437;kill h_variable_5438;kill h_variable_5439;kill h_variable_5440;kill h_variable_5441;kill h_variable_5442;kill h_variable_5443;kill h_variable_5444;kill h_variable_5445;kill h_variable_5446;kill h_variable_5447;kill h_variable_5448;kill h_variable_5449;kill h_variable_5450;kill h_variable_5451;kill h_variable_5452;kill h_variable_5453;kill h_variable_5454;kill h_variable_5455;kill h_variable_5456;kill h_variable_5457;kill h_variable_5458;kill h_variable_5459;kill h_variable_5460;kill h_variable_5461;kill h_variable_5462;kill h_variable_5463;kill h_variable_5464;kill h_variable_5465;kill h_variable_5466;kill h_variable_5467;kill h_variable_5468;kill h_variable_5469;kill h_variable_5470;kill h_variable_5471;kill h_variable_5472;kill h_variable_5473;kill h_variable_5474;kill h_variable_5475;kill h_variable_5476;kill h_variable_5477;kill h_variable_5478;kill h_variable_5479;kill h_variable_5480;kill h_variable_5481;kill h_variable_5482;kill h_variable_5483;kill h_variable_5484;kill h_variable_5485;kill h_variable_5486;kill h_variable_5487;kill h_variable_5488;kill h_variable_5489;kill h_variable_5490;kill h_variable_5491;kill h_variable_5492;kill h_variable_5493;kill h_variable_5494;kill h_variable_5495;kill h_variable_5496;kill h_variable_5497;kill h_variable_5498;kill h_variable_5499;kill h_variable_5500;kill h_variable_5501;kill h_variable_5502;kill h_variable_5503;kill h_variable_5504;kill h_variable_5505;kill h_variable_5506;kill h_variable_5507;kill h_variable_5508;kill h_variable_5509;kill h_variable_5510;kill h_variable_5511;kill h_variable_5512;kill h_variable_5513;kill h_variable_5514;kill h_variable_5515;kill h_variable_5516;kill h_variable_5517;kill h_variable_5518;kill h_variable_5519;kill h_variable_5520;kill h_variable_5521;kill h_variable_5522;kill h_variable_5523;kill h_variable_5524;kill h_variable_5525;kill h_variable_5526;kill h_variable_5527;kill h_variable_5528;kill h_variable_5529;kill h_variable_5530;kill h_variable_5531;kill h_variable_5532;kill h_variable_5533;kill h_variable_5534;kill h_variable_5535;kill h_variable_5536;kill h_variable_5537;kill h_variable_5538;kill h_variable_5539;kill h_variable_5540;kill h_variable_5541;kill h_variable_5542;kill h_variable_5548;kill h_variable_5551;kill h_variable_5554;kill h_variable_5556;kill h_variable_5560;kill h_variable_5562;kill h_variable_5563;kill h_variable_5564;kill h_variable_5565;kill h_variable_5566;kill h_variable_5568;kill h_variable_5569;kill h_variable_5570;kill h_variable_5571;kill h_variable_5572;kill h_variable_5573;kill h_variable_5574;kill h_variable_5575;kill h_variable_5576;kill h_variable_5577;kill h_variable_5578;kill h_variable_5579;kill h_variable_5580;kill h_variable_5581;kill h_variable_5582;kill h_variable_5583;kill h_variable_5584;kill h_variable_5585;kill h_variable_5586;kill h_variable_5587;kill h_variable_5588;kill h_variable_5589;kill h_variable_5590;kill h_variable_5591;kill h_variable_5592;kill h_variable_5593;kill h_variable_5594;kill h_variable_5595;kill h_variable_5596;kill h_variable_5597;kill h_variable_5598;kill h_variable_5599;kill h_variable_5600;kill h_variable_5601;kill h_variable_5602;kill h_variable_5603;kill h_variable_5604;kill h_variable_5605;kill h_variable_5606;kill h_variable_5607;kill h_variable_5608;kill h_variable_5609;kill h_variable_5610;kill h_variable_5611;kill h_variable_5612;kill h_variable_5613;kill h_variable_5614;kill h_variable_5615;kill h_variable_5616;kill h_variable_5617;kill h_variable_5618;kill h_variable_5619;kill h_variable_5620;kill h_variable_5621;kill h_variable_5622;kill h_variable_5623;kill h_variable_5624;kill h_variable_5625;kill h_variable_5626;kill h_variable_5627;kill h_variable_5628;kill h_variable_5629;kill h_variable_5630;kill h_variable_5631;kill h_variable_5632;kill h_variable_5633;kill h_variable_5634;kill h_variable_5635;kill h_variable_5636;kill h_variable_5637;kill h_variable_5638;kill h_variable_5639;kill h_variable_5640;kill h_variable_5641;kill h_variable_5642;kill h_variable_5643;kill h_variable_5644;kill h_variable_5645;kill h_variable_5646;kill h_variable_5647;kill h_variable_5648;kill h_variable_5649;kill h_variable_5650;kill h_variable_5651;kill h_variable_5652;kill h_variable_5653;kill h_variable_5654;kill h_variable_5655;kill h_variable_5656;kill h_variable_5657;kill h_variable_5658;kill h_variable_5659;kill h_variable_5660;kill h_variable_5661;kill h_variable_5662;kill h_variable_5663;kill h_variable_5664;kill h_variable_5665;kill h_variable_5666;kill h_variable_5667;kill h_variable_5668;kill h_variable_5669;kill h_variable_5670;kill h_variable_5671;kill h_variable_5672;kill h_variable_5673;kill h_variable_5674;kill h_variable_5675;kill h_variable_5676;kill h_variable_5677;kill h_variable_5678;kill h_variable_5679;kill h_variable_5680;kill h_variable_5681;kill h_variable_5682;kill h_variable_5683;kill h_variable_5684;kill h_variable_5685;kill h_variable_5686;kill h_variable_5687;kill h_variable_5688;kill h_variable_5689;kill h_variable_5690;kill h_variable_5691;kill h_variable_5692;kill h_variable_5693;kill h_variable_5694;kill h_variable_5695;kill h_variable_5696;kill h_variable_5697;kill h_variable_5698;kill h_variable_5699;kill h_variable_5700;kill h_variable_5701;kill h_variable_5702;kill h_variable_5703;kill h_variable_5704;kill h_variable_5705;kill h_variable_5706;kill h_variable_5707;kill h_variable_5708;kill h_variable_5709;kill h_variable_5710;kill h_variable_5711;kill h_variable_5712;kill h_variable_5713;kill h_variable_5714;kill h_variable_5715;kill h_variable_5716;kill h_variable_5717;kill h_variable_5718;kill h_variable_5719;kill h_variable_5720;kill h_variable_5721;kill h_variable_5722;kill h_variable_5723;kill h_variable_5724;kill h_variable_5725;kill h_variable_5726;kill h_variable_5727;kill h_variable_5728;kill h_variable_5731;kill h_variable_5732;kill h_variable_5733;kill h_variable_5734;kill h_variable_5737;kill h_variable_5738;kill h_variable_5739;kill h_variable_5740;kill h_variable_5742;kill h_variable_5743;kill h_variable_5744;kill h_variable_5745;kill h_variable_5746;kill h_variable_5748;kill h_variable_5749;kill h_variable_5750;kill h_variable_5751;kill h_variable_5752;kill h_variable_5753;kill h_variable_5754;kill h_variable_5755;kill h_variable_5756;kill h_variable_5757;kill h_variable_5758;kill h_variable_5759;kill h_variable_5760;kill h_variable_5761;kill h_variable_5762;kill h_variable_5763;kill h_variable_5764;kill h_variable_5765;kill h_variable_5766;kill h_variable_5767;kill h_variable_5768;kill h_variable_5769;kill h_variable_5770;kill h_variable_5771;kill h_variable_5772;kill h_variable_5773;kill h_variable_5774;kill h_variable_5775;kill h_variable_5776;kill h_variable_5777;kill h_variable_5778;kill h_variable_5779;kill h_variable_5780;kill h_variable_5781;kill h_variable_5782;kill h_variable_5783;kill h_variable_5784;kill h_variable_5785;kill h_variable_5786;kill h_variable_5787;kill h_variable_5788;kill h_variable_5789;kill h_variable_5790;kill h_variable_5791;kill h_variable_5792;kill h_variable_5793;kill h_variable_5794;kill h_variable_5795;kill h_variable_5796;kill h_variable_5797;kill h_variable_5798;kill h_variable_5799;kill h_variable_5800;kill h_variable_5801;kill h_variable_5802;kill h_variable_5803;kill h_variable_5804;kill h_variable_5805;kill h_variable_5806;kill h_variable_5807;kill h_variable_5808;kill h_variable_5809;kill h_variable_5810;kill h_variable_5811;kill h_variable_5812;kill h_variable_5813;kill h_variable_5814;kill h_variable_5815;kill h_variable_5816;kill h_variable_5817;kill h_variable_5818;kill h_variable_5819;kill h_variable_5820;kill h_variable_5821;kill h_variable_5822;kill h_variable_5823;kill h_variable_5824;kill h_variable_5825;kill h_variable_5826;kill h_variable_5827;kill h_variable_5828;kill h_variable_5829;kill h_variable_5830;kill h_variable_5831;kill h_variable_5832;kill h_variable_5833;kill h_variable_5834;kill h_variable_5835;kill h_variable_5836;kill h_variable_5837;kill h_variable_5838;kill h_variable_5839;kill h_variable_5840;kill h_variable_5841;kill h_variable_5842;kill h_variable_5843;kill h_variable_5844;kill h_variable_5845;kill h_variable_5846;kill h_variable_5847;kill h_variable_5848;kill h_variable_5849;kill h_variable_5850;kill h_variable_5851;kill h_variable_5852;kill h_variable_5853;kill h_variable_5854;kill h_variable_5855;kill h_variable_5856;kill h_variable_5857;kill h_variable_5858;kill h_variable_5859;kill h_variable_5860;kill h_variable_5861;kill h_variable_5862;kill h_variable_5863;kill h_variable_5864;kill h_variable_5865;kill h_variable_5866;kill h_variable_5867;kill h_variable_5868;kill h_variable_5869;kill h_variable_5870;kill h_variable_5871;kill h_variable_5872;kill h_variable_5873;kill h_variable_5874;kill h_variable_5875;kill h_variable_5876;kill h_variable_5877;kill h_variable_5878;kill h_variable_5879;kill h_variable_5880;kill h_variable_5881;kill h_variable_5882;kill h_variable_5883;kill h_variable_5884;kill h_variable_5885;kill h_variable_5886;kill h_variable_5887;kill h_variable_5888;kill h_variable_5889;kill h_variable_5890;kill h_variable_5891;kill h_variable_5892;kill h_variable_5893;kill h_variable_5894;kill h_variable_5895;kill h_variable_5896;kill h_variable_5897;kill h_variable_5898;kill h_variable_5899;kill h_variable_5900;kill h_variable_5901;kill h_variable_5902;kill h_variable_5903;kill h_variable_5904;kill h_variable_5905;kill h_variable_5906;kill h_variable_5907;kill h_variable_5908;kill h_variable_5909;kill h_variable_5910;kill h_variable_5911;kill h_variable_5912;kill h_variable_5913;kill h_variable_5914;kill h_variable_5915;kill h_variable_5916;kill h_variable_5917;kill h_variable_5918;kill h_variable_5919;kill h_variable_5920;kill h_variable_5921;kill h_variable_5922;kill h_variable_5923;kill h_variable_5924;kill h_variable_5925;kill h_variable_5926;kill h_variable_5927;kill h_variable_5928;kill h_variable_5929;kill h_variable_5930;kill h_variable_5931;kill h_variable_5932;kill h_variable_5933;kill h_variable_5934;kill h_variable_5935;kill h_variable_5936;kill h_variable_5937;kill h_variable_5938;kill h_variable_5939;kill h_variable_5940;kill h_variable_5943;kill h_variable_5944;kill h_variable_5945;kill h_variable_5946;
def h_variable_6001 = h_variable_4814[2,11];
h_variable_6001;
matrix h_variable_6002[1][1] = x3;
matrix h_variable_6003[1][3] = concat(h_variable_6002,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6003); matrix h_variable_6004 = h_variable_l[1]; matrix h_variable_6005 = h_variable_l[2];
ncols(h_variable_6004);
matrix h_variable_6006 = DecideZeroRows(h_variable_6004,h_variable_58);
IsZeroMatrix(h_variable_6006);
ZeroRows(h_variable_6006);
nrows(h_variable_6005);
matrix h_variable_6008 = submat(h_variable_6004,1..1,intvec( 2 ));
matrix h_variable_6007 = DecideZeroRows(h_variable_6008,h_variable_58);
IsZeroMatrix(h_variable_6007);
IsIdentityMatrix(h_variable_6007);
matrix h_variable_6009[1][3] = concat(h_variable_6007,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6009); matrix h_variable_6010 = h_variable_l[1]; matrix h_variable_6011 = h_variable_l[2];
IsZeroMatrix(h_variable_6010);
matrix h_variable_6012 = DecideZeroRows(h_variable_6010,h_variable_58);
IsZeroMatrix(h_variable_6012);
def h_variable_6013 = h_variable_4814[1,11];
h_variable_6013;
matrix h_variable_6014[1][1] = 0;
matrix h_variable_6015[1][3] = concat(h_variable_6014,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6015); matrix h_variable_6016 = h_variable_l[1]; matrix h_variable_6017 = h_variable_l[2];
ncols(h_variable_6016);
matrix h_variable_6018 = DecideZeroRows(h_variable_6016,h_variable_58);
IsZeroMatrix(h_variable_6018);
nrows(h_variable_6017);
def h_variable_6019 = h_variable_4814[16,12];
h_variable_6019;
matrix h_variable_6020[1][1] = 0;
matrix h_variable_6021[1][3] = concat(h_variable_6020,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6021); matrix h_variable_6022 = h_variable_l[1]; matrix h_variable_6023 = h_variable_l[2];
ncols(h_variable_6022);
matrix h_variable_6024 = DecideZeroRows(h_variable_6022,h_variable_58);
IsZeroMatrix(h_variable_6024);
nrows(h_variable_6023);
def h_variable_6025 = h_variable_4814[15,12];
h_variable_6025;
matrix h_variable_6026[1][1] = 0;
matrix h_variable_6027[1][3] = concat(h_variable_6026,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6027); matrix h_variable_6028 = h_variable_l[1]; matrix h_variable_6029 = h_variable_l[2];
ncols(h_variable_6028);
matrix h_variable_6030 = DecideZeroRows(h_variable_6028,h_variable_58);
IsZeroMatrix(h_variable_6030);
nrows(h_variable_6029);
def h_variable_6031 = h_variable_4814[14,12];
h_variable_6031;
matrix h_variable_6032[1][1] = 0;
matrix h_variable_6033[1][3] = concat(h_variable_6032,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6033); matrix h_variable_6034 = h_variable_l[1]; matrix h_variable_6035 = h_variable_l[2];
ncols(h_variable_6034);
matrix h_variable_6036 = DecideZeroRows(h_variable_6034,h_variable_58);
IsZeroMatrix(h_variable_6036);
nrows(h_variable_6035);
def h_variable_6037 = h_variable_4814[13,12];
h_variable_6037;
matrix h_variable_6038[1][1] = 0;
matrix h_variable_6039[1][3] = concat(h_variable_6038,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6039); matrix h_variable_6040 = h_variable_l[1]; matrix h_variable_6041 = h_variable_l[2];
ncols(h_variable_6040);
matrix h_variable_6042 = DecideZeroRows(h_variable_6040,h_variable_58);
IsZeroMatrix(h_variable_6042);
nrows(h_variable_6041);
def h_variable_6043 = h_variable_4814[12,12];
h_variable_6043;
matrix h_variable_6044[1][1] = 0;
matrix h_variable_6045[1][3] = concat(h_variable_6044,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6045); matrix h_variable_6046 = h_variable_l[1]; matrix h_variable_6047 = h_variable_l[2];
ncols(h_variable_6046);
matrix h_variable_6048 = DecideZeroRows(h_variable_6046,h_variable_58);
IsZeroMatrix(h_variable_6048);
nrows(h_variable_6047);
def h_variable_6049 = h_variable_4814[11,12];
h_variable_6049;
matrix h_variable_6050[1][1] = 0;
matrix h_variable_6051[1][3] = concat(h_variable_6050,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6051); matrix h_variable_6052 = h_variable_l[1]; matrix h_variable_6053 = h_variable_l[2];
ncols(h_variable_6052);
matrix h_variable_6054 = DecideZeroRows(h_variable_6052,h_variable_58);
IsZeroMatrix(h_variable_6054);
nrows(h_variable_6053);
def h_variable_6055 = h_variable_4814[10,12];
h_variable_6055;
matrix h_variable_6056[1][1] = 0;
matrix h_variable_6057[1][3] = concat(h_variable_6056,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6057); matrix h_variable_6058 = h_variable_l[1]; matrix h_variable_6059 = h_variable_l[2];
ncols(h_variable_6058);
matrix h_variable_6060 = DecideZeroRows(h_variable_6058,h_variable_58);
IsZeroMatrix(h_variable_6060);
nrows(h_variable_6059);
def h_variable_6061 = h_variable_4814[9,12];
h_variable_6061;
matrix h_variable_6062[1][1] = 0;
matrix h_variable_6063[1][3] = concat(h_variable_6062,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6063); matrix h_variable_6064 = h_variable_l[1]; matrix h_variable_6065 = h_variable_l[2];
ncols(h_variable_6064);
matrix h_variable_6066 = DecideZeroRows(h_variable_6064,h_variable_58);
IsZeroMatrix(h_variable_6066);
nrows(h_variable_6065);
def h_variable_6067 = h_variable_4814[8,12];
h_variable_6067;
matrix h_variable_6068[1][1] = 0;
matrix h_variable_6069[1][3] = concat(h_variable_6068,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6069); matrix h_variable_6070 = h_variable_l[1]; matrix h_variable_6071 = h_variable_l[2];
ncols(h_variable_6070);
matrix h_variable_6072 = DecideZeroRows(h_variable_6070,h_variable_58);
IsZeroMatrix(h_variable_6072);
nrows(h_variable_6071);
def h_variable_6073 = h_variable_4814[7,12];
h_variable_6073;
matrix h_variable_6074[1][1] = 0;
matrix h_variable_6075[1][3] = concat(h_variable_6074,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6075); matrix h_variable_6076 = h_variable_l[1]; matrix h_variable_6077 = h_variable_l[2];
ncols(h_variable_6076);
matrix h_variable_6078 = DecideZeroRows(h_variable_6076,h_variable_58);
IsZeroMatrix(h_variable_6078);
nrows(h_variable_6077);
def h_variable_6079 = h_variable_4814[2,12];
h_variable_6079;
matrix h_variable_6080[1][1] = 0;
matrix h_variable_6081[1][3] = concat(h_variable_6080,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6081); matrix h_variable_6082 = h_variable_l[1]; matrix h_variable_6083 = h_variable_l[2];
ncols(h_variable_6082);
matrix h_variable_6084 = DecideZeroRows(h_variable_6082,h_variable_58);
IsZeroMatrix(h_variable_6084);
nrows(h_variable_6083);
def h_variable_6085 = h_variable_4814[1,12];
h_variable_6085;
matrix h_variable_6086[1][1] = 0;
matrix h_variable_6087[1][3] = concat(h_variable_6086,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6087); matrix h_variable_6088 = h_variable_l[1]; matrix h_variable_6089 = h_variable_l[2];
ncols(h_variable_6088);
matrix h_variable_6090 = DecideZeroRows(h_variable_6088,h_variable_58);
IsZeroMatrix(h_variable_6090);
nrows(h_variable_6089);
def h_variable_6091 = h_variable_4814[16,13];
h_variable_6091;
matrix h_variable_6092[1][1] = 0;
matrix h_variable_6093[1][3] = concat(h_variable_6092,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6093); matrix h_variable_6094 = h_variable_l[1]; matrix h_variable_6095 = h_variable_l[2];
ncols(h_variable_6094);
matrix h_variable_6096 = DecideZeroRows(h_variable_6094,h_variable_58);
IsZeroMatrix(h_variable_6096);
nrows(h_variable_6095);
def h_variable_6097 = h_variable_4814[15,13];
h_variable_6097;
matrix h_variable_6098[1][1] = 0;
matrix h_variable_6099[1][3] = concat(h_variable_6098,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6099); matrix h_variable_6100 = h_variable_l[1]; matrix h_variable_6101 = h_variable_l[2];
ncols(h_variable_6100);
matrix h_variable_6102 = DecideZeroRows(h_variable_6100,h_variable_58);
IsZeroMatrix(h_variable_6102);
nrows(h_variable_6101);
def h_variable_6103 = h_variable_4814[14,13];
h_variable_6103;
matrix h_variable_6104[1][1] = 0;
matrix h_variable_6105[1][3] = concat(h_variable_6104,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6105); matrix h_variable_6106 = h_variable_l[1]; matrix h_variable_6107 = h_variable_l[2];
ncols(h_variable_6106);
matrix h_variable_6108 = DecideZeroRows(h_variable_6106,h_variable_58);
IsZeroMatrix(h_variable_6108);
nrows(h_variable_6107);
def h_variable_6109 = h_variable_4814[13,13];
h_variable_6109;
matrix h_variable_6110[1][1] = 0;
matrix h_variable_6111[1][3] = concat(h_variable_6110,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6111); matrix h_variable_6112 = h_variable_l[1]; matrix h_variable_6113 = h_variable_l[2];
ncols(h_variable_6112);
matrix h_variable_6114 = DecideZeroRows(h_variable_6112,h_variable_58);
IsZeroMatrix(h_variable_6114);
nrows(h_variable_6113);
def h_variable_6115 = h_variable_4814[12,13];
h_variable_6115;
matrix h_variable_6116[1][1] = 0;
matrix h_variable_6117[1][3] = concat(h_variable_6116,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6117); matrix h_variable_6118 = h_variable_l[1]; matrix h_variable_6119 = h_variable_l[2];
ncols(h_variable_6118);
matrix h_variable_6120 = DecideZeroRows(h_variable_6118,h_variable_58);
IsZeroMatrix(h_variable_6120);
nrows(h_variable_6119);
def h_variable_6121 = h_variable_4814[11,13];
h_variable_6121;
matrix h_variable_6122[1][1] = 0;
matrix h_variable_6123[1][3] = concat(h_variable_6122,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6123); matrix h_variable_6124 = h_variable_l[1]; matrix h_variable_6125 = h_variable_l[2];
ncols(h_variable_6124);
matrix h_variable_6126 = DecideZeroRows(h_variable_6124,h_variable_58);
IsZeroMatrix(h_variable_6126);
nrows(h_variable_6125);
def h_variable_6127 = h_variable_4814[10,13];
h_variable_6127;
matrix h_variable_6128[1][1] = 0;
matrix h_variable_6129[1][3] = concat(h_variable_6128,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6129); matrix h_variable_6130 = h_variable_l[1]; matrix h_variable_6131 = h_variable_l[2];
ncols(h_variable_6130);
matrix h_variable_6132 = DecideZeroRows(h_variable_6130,h_variable_58);
IsZeroMatrix(h_variable_6132);
nrows(h_variable_6131);
def h_variable_6133 = h_variable_4814[9,13];
h_variable_6133;
matrix h_variable_6134[1][1] = 0;
matrix h_variable_6135[1][3] = concat(h_variable_6134,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6135); matrix h_variable_6136 = h_variable_l[1]; matrix h_variable_6137 = h_variable_l[2];
ncols(h_variable_6136);
matrix h_variable_6138 = DecideZeroRows(h_variable_6136,h_variable_58);
IsZeroMatrix(h_variable_6138);
nrows(h_variable_6137);
def h_variable_6139 = h_variable_4814[8,13];
h_variable_6139;
matrix h_variable_6140[1][1] = 0;
matrix h_variable_6141[1][3] = concat(h_variable_6140,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6141); matrix h_variable_6142 = h_variable_l[1]; matrix h_variable_6143 = h_variable_l[2];
ncols(h_variable_6142);
matrix h_variable_6144 = DecideZeroRows(h_variable_6142,h_variable_58);
IsZeroMatrix(h_variable_6144);
nrows(h_variable_6143);
def h_variable_6145 = h_variable_4814[7,13];
h_variable_6145;
matrix h_variable_6146[1][1] = 0;
matrix h_variable_6147[1][3] = concat(h_variable_6146,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6147); matrix h_variable_6148 = h_variable_l[1]; matrix h_variable_6149 = h_variable_l[2];
ncols(h_variable_6148);
matrix h_variable_6150 = DecideZeroRows(h_variable_6148,h_variable_58);
IsZeroMatrix(h_variable_6150);
nrows(h_variable_6149);
def h_variable_6151 = h_variable_4814[2,13];
h_variable_6151;
matrix h_variable_6152[1][1] = -2*x3;
matrix h_variable_6153[1][3] = concat(h_variable_6152,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6153); matrix h_variable_6154 = h_variable_l[1]; matrix h_variable_6155 = h_variable_l[2];
ncols(h_variable_6154);
matrix h_variable_6156 = DecideZeroRows(h_variable_6154,h_variable_58);
IsZeroMatrix(h_variable_6156);
ZeroRows(h_variable_6156);
nrows(h_variable_6155);
matrix h_variable_6158 = submat(h_variable_6154,1..1,intvec( 2 ));
matrix h_variable_6157 = DecideZeroRows(h_variable_6158,h_variable_58);
IsZeroMatrix(h_variable_6157);
IsIdentityMatrix(h_variable_6157);
matrix h_variable_6159[1][3] = concat(h_variable_6157,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6159); matrix h_variable_6160 = h_variable_l[1]; matrix h_variable_6161 = h_variable_l[2];
IsZeroMatrix(h_variable_6160);
matrix h_variable_6162 = DecideZeroRows(h_variable_6160,h_variable_58);
IsZeroMatrix(h_variable_6162);
def h_variable_6163 = h_variable_4814[1,13];
h_variable_6163;
matrix h_variable_6164[1][1] = 0;
matrix h_variable_6165[1][3] = concat(h_variable_6164,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6165); matrix h_variable_6166 = h_variable_l[1]; matrix h_variable_6167 = h_variable_l[2];
ncols(h_variable_6166);
matrix h_variable_6168 = DecideZeroRows(h_variable_6166,h_variable_58);
IsZeroMatrix(h_variable_6168);
nrows(h_variable_6167);
def h_variable_6169 = h_variable_4814[16,14];
h_variable_6169;
matrix h_variable_6170[1][1] = 0;
matrix h_variable_6171[1][3] = concat(h_variable_6170,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6171); matrix h_variable_6172 = h_variable_l[1]; matrix h_variable_6173 = h_variable_l[2];
ncols(h_variable_6172);
matrix h_variable_6174 = DecideZeroRows(h_variable_6172,h_variable_58);
IsZeroMatrix(h_variable_6174);
nrows(h_variable_6173);
def h_variable_6175 = h_variable_4814[15,14];
h_variable_6175;
matrix h_variable_6176[1][1] = 0;
matrix h_variable_6177[1][3] = concat(h_variable_6176,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6177); matrix h_variable_6178 = h_variable_l[1]; matrix h_variable_6179 = h_variable_l[2];
ncols(h_variable_6178);
matrix h_variable_6180 = DecideZeroRows(h_variable_6178,h_variable_58);
IsZeroMatrix(h_variable_6180);
nrows(h_variable_6179);
def h_variable_6181 = h_variable_4814[14,14];
h_variable_6181;
matrix h_variable_6182[1][1] = 0;
matrix h_variable_6183[1][3] = concat(h_variable_6182,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6183); matrix h_variable_6184 = h_variable_l[1]; matrix h_variable_6185 = h_variable_l[2];
ncols(h_variable_6184);
matrix h_variable_6186 = DecideZeroRows(h_variable_6184,h_variable_58);
IsZeroMatrix(h_variable_6186);
nrows(h_variable_6185);
def h_variable_6187 = h_variable_4814[13,14];
h_variable_6187;
matrix h_variable_6188[1][1] = 0;
matrix h_variable_6189[1][3] = concat(h_variable_6188,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6189); matrix h_variable_6190 = h_variable_l[1]; matrix h_variable_6191 = h_variable_l[2];
ncols(h_variable_6190);
matrix h_variable_6192 = DecideZeroRows(h_variable_6190,h_variable_58);
IsZeroMatrix(h_variable_6192);
nrows(h_variable_6191);
def h_variable_6193 = h_variable_4814[12,14];
h_variable_6193;
matrix h_variable_6194[1][1] = 0;
matrix h_variable_6195[1][3] = concat(h_variable_6194,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6195); matrix h_variable_6196 = h_variable_l[1]; matrix h_variable_6197 = h_variable_l[2];
ncols(h_variable_6196);
matrix h_variable_6198 = DecideZeroRows(h_variable_6196,h_variable_58);
IsZeroMatrix(h_variable_6198);
nrows(h_variable_6197);
def h_variable_6199 = h_variable_4814[11,14];
h_variable_6199;
matrix h_variable_6200[1][1] = 0;
matrix h_variable_6201[1][3] = concat(h_variable_6200,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6201); matrix h_variable_6202 = h_variable_l[1]; matrix h_variable_6203 = h_variable_l[2];
ncols(h_variable_6202);
matrix h_variable_6204 = DecideZeroRows(h_variable_6202,h_variable_58);
IsZeroMatrix(h_variable_6204);
nrows(h_variable_6203);
def h_variable_6205 = h_variable_4814[10,14];
h_variable_6205;
matrix h_variable_6206[1][1] = 0;
matrix h_variable_6207[1][3] = concat(h_variable_6206,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6207); matrix h_variable_6208 = h_variable_l[1]; matrix h_variable_6209 = h_variable_l[2];
ncols(h_variable_6208);
matrix h_variable_6210 = DecideZeroRows(h_variable_6208,h_variable_58);
IsZeroMatrix(h_variable_6210);
nrows(h_variable_6209);
def h_variable_6211 = h_variable_4814[9,14];
h_variable_6211;
matrix h_variable_6212[1][1] = 0;
matrix h_variable_6213[1][3] = concat(h_variable_6212,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6213); matrix h_variable_6214 = h_variable_l[1]; matrix h_variable_6215 = h_variable_l[2];
ncols(h_variable_6214);
matrix h_variable_6216 = DecideZeroRows(h_variable_6214,h_variable_58);
IsZeroMatrix(h_variable_6216);
nrows(h_variable_6215);
def h_variable_6217 = h_variable_4814[8,14];
h_variable_6217;
matrix h_variable_6218[1][1] = 0;
matrix h_variable_6219[1][3] = concat(h_variable_6218,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6219); matrix h_variable_6220 = h_variable_l[1]; matrix h_variable_6221 = h_variable_l[2];
ncols(h_variable_6220);
matrix h_variable_6222 = DecideZeroRows(h_variable_6220,h_variable_58);
IsZeroMatrix(h_variable_6222);
nrows(h_variable_6221);
def h_variable_6223 = h_variable_4814[7,14];
h_variable_6223;
matrix h_variable_6224[1][1] = a7+4;
matrix h_variable_6225[1][3] = concat(h_variable_6224,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6225); matrix h_variable_6226 = h_variable_l[1]; matrix h_variable_6227 = h_variable_l[2];
ncols(h_variable_6226);
matrix h_variable_6228 = DecideZeroRows(h_variable_6226,h_variable_58);
IsZeroMatrix(h_variable_6228);
ZeroRows(h_variable_6228);
nrows(h_variable_6227);
matrix h_variable_6229[1][4] = concat(h_variable_6226,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6229); matrix h_variable_6230 = h_variable_l[1]; matrix h_variable_6231 = h_variable_l[2];
IsZeroMatrix(h_variable_6230);
matrix h_variable_6232 = DecideZeroRows(h_variable_6230,h_variable_58);
IsZeroMatrix(h_variable_6232);
def h_variable_6233 = h_variable_4814[2,14];
h_variable_6233;
matrix h_variable_6234[1][1] = 0;
matrix h_variable_6235[1][3] = concat(h_variable_6234,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6235); matrix h_variable_6236 = h_variable_l[1]; matrix h_variable_6237 = h_variable_l[2];
ncols(h_variable_6236);
matrix h_variable_6238 = DecideZeroRows(h_variable_6236,h_variable_58);
IsZeroMatrix(h_variable_6238);
nrows(h_variable_6237);
def h_variable_6239 = h_variable_4814[1,14];
h_variable_6239;
matrix h_variable_6240[1][1] = 0;
matrix h_variable_6241[1][3] = concat(h_variable_6240,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6241); matrix h_variable_6242 = h_variable_l[1]; matrix h_variable_6243 = h_variable_l[2];
ncols(h_variable_6242);
matrix h_variable_6244 = DecideZeroRows(h_variable_6242,h_variable_58);
IsZeroMatrix(h_variable_6244);
nrows(h_variable_6243);
def h_variable_6245 = h_variable_4814[16,15];
h_variable_6245;
matrix h_variable_6246[1][1] = 0;
matrix h_variable_6247[1][3] = concat(h_variable_6246,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6247); matrix h_variable_6248 = h_variable_l[1]; matrix h_variable_6249 = h_variable_l[2];
ncols(h_variable_6248);
matrix h_variable_6250 = DecideZeroRows(h_variable_6248,h_variable_58);
IsZeroMatrix(h_variable_6250);
nrows(h_variable_6249);
def h_variable_6251 = h_variable_4814[15,15];
h_variable_6251;
matrix h_variable_6252[1][1] = 0;
matrix h_variable_6253[1][3] = concat(h_variable_6252,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6253); matrix h_variable_6254 = h_variable_l[1]; matrix h_variable_6255 = h_variable_l[2];
ncols(h_variable_6254);
matrix h_variable_6256 = DecideZeroRows(h_variable_6254,h_variable_58);
IsZeroMatrix(h_variable_6256);
nrows(h_variable_6255);
def h_variable_6257 = h_variable_4814[14,15];
h_variable_6257;
matrix h_variable_6258[1][1] = 0;
matrix h_variable_6259[1][3] = concat(h_variable_6258,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6259); matrix h_variable_6260 = h_variable_l[1]; matrix h_variable_6261 = h_variable_l[2];
ncols(h_variable_6260);
matrix h_variable_6262 = DecideZeroRows(h_variable_6260,h_variable_58);
IsZeroMatrix(h_variable_6262);
nrows(h_variable_6261);
def h_variable_6263 = h_variable_4814[13,15];
h_variable_6263;
matrix h_variable_6264[1][1] = 0;
matrix h_variable_6265[1][3] = concat(h_variable_6264,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6265); matrix h_variable_6266 = h_variable_l[1]; matrix h_variable_6267 = h_variable_l[2];
ncols(h_variable_6266);
matrix h_variable_6268 = DecideZeroRows(h_variable_6266,h_variable_58);
IsZeroMatrix(h_variable_6268);
nrows(h_variable_6267);
def h_variable_6269 = h_variable_4814[12,15];
h_variable_6269;
matrix h_variable_6270[1][1] = 0;
matrix h_variable_6271[1][3] = concat(h_variable_6270,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6271); matrix h_variable_6272 = h_variable_l[1]; matrix h_variable_6273 = h_variable_l[2];
ncols(h_variable_6272);
matrix h_variable_6274 = DecideZeroRows(h_variable_6272,h_variable_58);
IsZeroMatrix(h_variable_6274);
nrows(h_variable_6273);
def h_variable_6275 = h_variable_4814[11,15];
h_variable_6275;
matrix h_variable_6276[1][1] = 0;
matrix h_variable_6277[1][3] = concat(h_variable_6276,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6277); matrix h_variable_6278 = h_variable_l[1]; matrix h_variable_6279 = h_variable_l[2];
ncols(h_variable_6278);
matrix h_variable_6280 = DecideZeroRows(h_variable_6278,h_variable_58);
IsZeroMatrix(h_variable_6280);
nrows(h_variable_6279);
def h_variable_6281 = h_variable_4814[10,15];
h_variable_6281;
matrix h_variable_6282[1][1] = 0;
matrix h_variable_6283[1][3] = concat(h_variable_6282,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6283); matrix h_variable_6284 = h_variable_l[1]; matrix h_variable_6285 = h_variable_l[2];
ncols(h_variable_6284);
matrix h_variable_6286 = DecideZeroRows(h_variable_6284,h_variable_58);
IsZeroMatrix(h_variable_6286);
nrows(h_variable_6285);
def h_variable_6287 = h_variable_4814[9,15];
h_variable_6287;
matrix h_variable_6288[1][1] = 0;
matrix h_variable_6289[1][3] = concat(h_variable_6288,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6289); matrix h_variable_6290 = h_variable_l[1]; matrix h_variable_6291 = h_variable_l[2];
ncols(h_variable_6290);
matrix h_variable_6292 = DecideZeroRows(h_variable_6290,h_variable_58);
IsZeroMatrix(h_variable_6292);
nrows(h_variable_6291);
def h_variable_6293 = h_variable_4814[8,15];
h_variable_6293;
matrix h_variable_6294[1][1] = 0;
matrix h_variable_6295[1][3] = concat(h_variable_6294,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6295); matrix h_variable_6296 = h_variable_l[1]; matrix h_variable_6297 = h_variable_l[2];
ncols(h_variable_6296);
matrix h_variable_6298 = DecideZeroRows(h_variable_6296,h_variable_58);
IsZeroMatrix(h_variable_6298);
nrows(h_variable_6297);
def h_variable_6299 = h_variable_4814[7,15];
h_variable_6299;
matrix h_variable_6300[1][1] = 0;
matrix h_variable_6301[1][3] = concat(h_variable_6300,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6301); matrix h_variable_6302 = h_variable_l[1]; matrix h_variable_6303 = h_variable_l[2];
ncols(h_variable_6302);
matrix h_variable_6304 = DecideZeroRows(h_variable_6302,h_variable_58);
IsZeroMatrix(h_variable_6304);
nrows(h_variable_6303);
def h_variable_6305 = h_variable_4814[2,15];
h_variable_6305;
matrix h_variable_6306[1][1] = x3^2;
matrix h_variable_6307[1][3] = concat(h_variable_6306,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6307); matrix h_variable_6308 = h_variable_l[1]; matrix h_variable_6309 = h_variable_l[2];
ncols(h_variable_6308);
matrix h_variable_6310 = DecideZeroRows(h_variable_6308,h_variable_58);
IsZeroMatrix(h_variable_6310);
ZeroRows(h_variable_6310);
nrows(h_variable_6309);
matrix h_variable_6312 = submat(h_variable_6308,1..1,intvec( 2 ));
matrix h_variable_6311 = DecideZeroRows(h_variable_6312,h_variable_58);
IsZeroMatrix(h_variable_6311);
IsIdentityMatrix(h_variable_6311);
matrix h_variable_6313[1][3] = concat(h_variable_6311,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6313); matrix h_variable_6314 = h_variable_l[1]; matrix h_variable_6315 = h_variable_l[2];
IsZeroMatrix(h_variable_6314);
matrix h_variable_6316 = DecideZeroRows(h_variable_6314,h_variable_58);
IsZeroMatrix(h_variable_6316);
def h_variable_6317 = h_variable_4814[1,15];
h_variable_6317;
matrix h_variable_6318[1][1] = 0;
matrix h_variable_6319[1][3] = concat(h_variable_6318,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6319); matrix h_variable_6320 = h_variable_l[1]; matrix h_variable_6321 = h_variable_l[2];
ncols(h_variable_6320);
matrix h_variable_6322 = DecideZeroRows(h_variable_6320,h_variable_58);
IsZeroMatrix(h_variable_6322);
nrows(h_variable_6321);
def h_variable_6323 = h_variable_4814[16,16];
h_variable_6323;
matrix h_variable_6324[1][1] = 0;
matrix h_variable_6325[1][3] = concat(h_variable_6324,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6325); matrix h_variable_6326 = h_variable_l[1]; matrix h_variable_6327 = h_variable_l[2];
ncols(h_variable_6326);
matrix h_variable_6328 = DecideZeroRows(h_variable_6326,h_variable_58);
IsZeroMatrix(h_variable_6328);
nrows(h_variable_6327);
def h_variable_6329 = h_variable_4814[15,16];
h_variable_6329;
matrix h_variable_6330[1][1] = 0;
matrix h_variable_6331[1][3] = concat(h_variable_6330,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6331); matrix h_variable_6332 = h_variable_l[1]; matrix h_variable_6333 = h_variable_l[2];
ncols(h_variable_6332);
matrix h_variable_6334 = DecideZeroRows(h_variable_6332,h_variable_58);
IsZeroMatrix(h_variable_6334);
nrows(h_variable_6333);
def h_variable_6335 = h_variable_4814[14,16];
h_variable_6335;
matrix h_variable_6336[1][1] = 0;
matrix h_variable_6337[1][3] = concat(h_variable_6336,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6337); matrix h_variable_6338 = h_variable_l[1]; matrix h_variable_6339 = h_variable_l[2];
ncols(h_variable_6338);
matrix h_variable_6340 = DecideZeroRows(h_variable_6338,h_variable_58);
IsZeroMatrix(h_variable_6340);
nrows(h_variable_6339);
def h_variable_6341 = h_variable_4814[13,16];
h_variable_6341;
matrix h_variable_6342[1][1] = 0;
matrix h_variable_6343[1][3] = concat(h_variable_6342,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6343); matrix h_variable_6344 = h_variable_l[1]; matrix h_variable_6345 = h_variable_l[2];
ncols(h_variable_6344);
matrix h_variable_6346 = DecideZeroRows(h_variable_6344,h_variable_58);
IsZeroMatrix(h_variable_6346);
nrows(h_variable_6345);
def h_variable_6347 = h_variable_4814[12,16];
h_variable_6347;
matrix h_variable_6348[1][1] = 0;
matrix h_variable_6349[1][3] = concat(h_variable_6348,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6349); matrix h_variable_6350 = h_variable_l[1]; matrix h_variable_6351 = h_variable_l[2];
ncols(h_variable_6350);
matrix h_variable_6352 = DecideZeroRows(h_variable_6350,h_variable_58);
IsZeroMatrix(h_variable_6352);
nrows(h_variable_6351);
def h_variable_6353 = h_variable_4814[11,16];
h_variable_6353;
matrix h_variable_6354[1][1] = 0;
matrix h_variable_6355[1][3] = concat(h_variable_6354,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6355); matrix h_variable_6356 = h_variable_l[1]; matrix h_variable_6357 = h_variable_l[2];
ncols(h_variable_6356);
matrix h_variable_6358 = DecideZeroRows(h_variable_6356,h_variable_58);
IsZeroMatrix(h_variable_6358);
nrows(h_variable_6357);
def h_variable_6359 = h_variable_4814[10,16];
h_variable_6359;
matrix h_variable_6360[1][1] = 0;
matrix h_variable_6361[1][3] = concat(h_variable_6360,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6361); matrix h_variable_6362 = h_variable_l[1]; matrix h_variable_6363 = h_variable_l[2];
ncols(h_variable_6362);
matrix h_variable_6364 = DecideZeroRows(h_variable_6362,h_variable_58);
IsZeroMatrix(h_variable_6364);
nrows(h_variable_6363);
def h_variable_6365 = h_variable_4814[9,16];
h_variable_6365;
matrix h_variable_6366[1][1] = 0;
matrix h_variable_6367[1][3] = concat(h_variable_6366,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6367); matrix h_variable_6368 = h_variable_l[1]; matrix h_variable_6369 = h_variable_l[2];
ncols(h_variable_6368);
matrix h_variable_6370 = DecideZeroRows(h_variable_6368,h_variable_58);
IsZeroMatrix(h_variable_6370);
nrows(h_variable_6369);
def h_variable_6371 = h_variable_4814[8,16];
h_variable_6371;
matrix h_variable_6372[1][1] = 3;
matrix h_variable_6373[1][3] = concat(h_variable_6372,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6373); matrix h_variable_6374 = h_variable_l[1]; matrix h_variable_6375 = h_variable_l[2];
ncols(h_variable_6374);
matrix h_variable_6376 = DecideZeroRows(h_variable_6374,h_variable_58);
IsZeroMatrix(h_variable_6376);
ZeroRows(h_variable_6376);
nrows(h_variable_6375);
matrix h_variable_6378 = submat(h_variable_6374,1..1,intvec( 1 ));
matrix h_variable_6377 = DecideZeroRows(h_variable_6378,h_variable_58);
IsZeroMatrix(h_variable_6377);
IsIdentityMatrix(h_variable_6377);
matrix h_variable_6379[1][3] = concat(h_variable_6377,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6379); matrix h_variable_6380 = h_variable_l[1]; matrix h_variable_6381 = h_variable_l[2];
IsZeroMatrix(h_variable_6380);
matrix h_variable_6382 = DecideZeroRows(h_variable_6380,h_variable_58);
IsZeroMatrix(h_variable_6382);
def h_variable_6383 = h_variable_4814[7,16];
h_variable_6383;
matrix h_variable_6384[1][1] = -3*x2;
matrix h_variable_6385[1][3] = concat(h_variable_6384,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6385); matrix h_variable_6386 = h_variable_l[1]; matrix h_variable_6387 = h_variable_l[2];
ncols(h_variable_6386);
matrix h_variable_6388 = DecideZeroRows(h_variable_6386,h_variable_58);
IsZeroMatrix(h_variable_6388);
ZeroRows(h_variable_6388);
nrows(h_variable_6387);
matrix h_variable_6390 = submat(h_variable_6386,1..1,intvec( 2 ));
matrix h_variable_6389 = DecideZeroRows(h_variable_6390,h_variable_58);
IsZeroMatrix(h_variable_6389);
IsIdentityMatrix(h_variable_6389);
matrix h_variable_6391[1][3] = concat(h_variable_6389,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6391); matrix h_variable_6392 = h_variable_l[1]; matrix h_variable_6393 = h_variable_l[2];
IsZeroMatrix(h_variable_6392);
matrix h_variable_6394 = DecideZeroRows(h_variable_6392,h_variable_58);
IsZeroMatrix(h_variable_6394);
def h_variable_6395 = h_variable_4814[2,16];
h_variable_6395;
matrix h_variable_6396[1][1] = 0;
matrix h_variable_6397[1][3] = concat(h_variable_6396,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6397); matrix h_variable_6398 = h_variable_l[1]; matrix h_variable_6399 = h_variable_l[2];
ncols(h_variable_6398);
matrix h_variable_6400 = DecideZeroRows(h_variable_6398,h_variable_58);
IsZeroMatrix(h_variable_6400);
nrows(h_variable_6399);
def h_variable_6401 = h_variable_4814[1,16];
h_variable_6401;
matrix h_variable_6402[1][1] = 0;
matrix h_variable_6403[1][3] = concat(h_variable_6402,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6403); matrix h_variable_6404 = h_variable_l[1]; matrix h_variable_6405 = h_variable_l[2];
ncols(h_variable_6404);
matrix h_variable_6406 = DecideZeroRows(h_variable_6404,h_variable_58);
IsZeroMatrix(h_variable_6406);
nrows(h_variable_6405);
def h_variable_6407 = h_variable_4814[16,17];
h_variable_6407;
matrix h_variable_6408[1][1] = 0;
matrix h_variable_6409[1][3] = concat(h_variable_6408,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6409); matrix h_variable_6410 = h_variable_l[1]; matrix h_variable_6411 = h_variable_l[2];
ncols(h_variable_6410);
matrix h_variable_6412 = DecideZeroRows(h_variable_6410,h_variable_58);
IsZeroMatrix(h_variable_6412);
nrows(h_variable_6411);
def h_variable_6413 = h_variable_4814[15,17];
h_variable_6413;
matrix h_variable_6414[1][1] = 0;
matrix h_variable_6415[1][3] = concat(h_variable_6414,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6415); matrix h_variable_6416 = h_variable_l[1]; matrix h_variable_6417 = h_variable_l[2];
ncols(h_variable_6416);
matrix h_variable_6418 = DecideZeroRows(h_variable_6416,h_variable_58);
IsZeroMatrix(h_variable_6418);
nrows(h_variable_6417);
def h_variable_6419 = h_variable_4814[14,17];
h_variable_6419;
matrix h_variable_6420[1][1] = 0;
matrix h_variable_6421[1][3] = concat(h_variable_6420,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6421); matrix h_variable_6422 = h_variable_l[1]; matrix h_variable_6423 = h_variable_l[2];
ncols(h_variable_6422);
matrix h_variable_6424 = DecideZeroRows(h_variable_6422,h_variable_58);
IsZeroMatrix(h_variable_6424);
nrows(h_variable_6423);
def h_variable_6425 = h_variable_4814[13,17];
h_variable_6425;
matrix h_variable_6426[1][1] = 0;
matrix h_variable_6427[1][3] = concat(h_variable_6426,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6427); matrix h_variable_6428 = h_variable_l[1]; matrix h_variable_6429 = h_variable_l[2];
ncols(h_variable_6428);
matrix h_variable_6430 = DecideZeroRows(h_variable_6428,h_variable_58);
IsZeroMatrix(h_variable_6430);
nrows(h_variable_6429);
def h_variable_6431 = h_variable_4814[12,17];
h_variable_6431;
matrix h_variable_6432[1][1] = 0;
matrix h_variable_6433[1][3] = concat(h_variable_6432,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6433); matrix h_variable_6434 = h_variable_l[1]; matrix h_variable_6435 = h_variable_l[2];
ncols(h_variable_6434);
matrix h_variable_6436 = DecideZeroRows(h_variable_6434,h_variable_58);
IsZeroMatrix(h_variable_6436);
nrows(h_variable_6435);
def h_variable_6437 = h_variable_4814[11,17];
h_variable_6437;
matrix h_variable_6438[1][1] = 0;
matrix h_variable_6439[1][3] = concat(h_variable_6438,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6439); matrix h_variable_6440 = h_variable_l[1]; matrix h_variable_6441 = h_variable_l[2];
ncols(h_variable_6440);
matrix h_variable_6442 = DecideZeroRows(h_variable_6440,h_variable_58);
IsZeroMatrix(h_variable_6442);
nrows(h_variable_6441);
def h_variable_6443 = h_variable_4814[10,17];
h_variable_6443;
matrix h_variable_6444[1][1] = 0;
matrix h_variable_6445[1][3] = concat(h_variable_6444,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6445); matrix h_variable_6446 = h_variable_l[1]; matrix h_variable_6447 = h_variable_l[2];
ncols(h_variable_6446);
matrix h_variable_6448 = DecideZeroRows(h_variable_6446,h_variable_58);
IsZeroMatrix(h_variable_6448);
nrows(h_variable_6447);
def h_variable_6449 = h_variable_4814[9,17];
h_variable_6449;
matrix h_variable_6450[1][1] = 0;
matrix h_variable_6451[1][3] = concat(h_variable_6450,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6451); matrix h_variable_6452 = h_variable_l[1]; matrix h_variable_6453 = h_variable_l[2];
ncols(h_variable_6452);
matrix h_variable_6454 = DecideZeroRows(h_variable_6452,h_variable_58);
IsZeroMatrix(h_variable_6454);
nrows(h_variable_6453);
def h_variable_6455 = h_variable_4814[8,17];
h_variable_6455;
matrix h_variable_6456[1][1] = 4;
matrix h_variable_6457[1][3] = concat(h_variable_6456,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6457); matrix h_variable_6458 = h_variable_l[1]; matrix h_variable_6459 = h_variable_l[2];
ncols(h_variable_6458);
matrix h_variable_6460 = DecideZeroRows(h_variable_6458,h_variable_58);
IsZeroMatrix(h_variable_6460);
ZeroRows(h_variable_6460);
nrows(h_variable_6459);
matrix h_variable_6462 = submat(h_variable_6458,1..1,intvec( 1 ));
matrix h_variable_6461 = DecideZeroRows(h_variable_6462,h_variable_58);
IsZeroMatrix(h_variable_6461);
IsIdentityMatrix(h_variable_6461);
matrix h_variable_6463[1][3] = concat(h_variable_6461,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6463); matrix h_variable_6464 = h_variable_l[1]; matrix h_variable_6465 = h_variable_l[2];
IsZeroMatrix(h_variable_6464);
matrix h_variable_6466 = DecideZeroRows(h_variable_6464,h_variable_58);
IsZeroMatrix(h_variable_6466);
def h_variable_6467 = h_variable_4814[7,17];
h_variable_6467;
matrix h_variable_6468[1][1] = -4*x2-2*x3;
matrix h_variable_6469[1][3] = concat(h_variable_6468,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6469); matrix h_variable_6470 = h_variable_l[1]; matrix h_variable_6471 = h_variable_l[2];
ncols(h_variable_6470);
matrix h_variable_6472 = DecideZeroRows(h_variable_6470,h_variable_58);
IsZeroMatrix(h_variable_6472);
ZeroRows(h_variable_6472);
nrows(h_variable_6471);
matrix h_variable_6474 = submat(h_variable_6470,1..1,intvec( 2 ));
matrix h_variable_6473 = DecideZeroRows(h_variable_6474,h_variable_58);
IsZeroMatrix(h_variable_6473);
IsIdentityMatrix(h_variable_6473);
matrix h_variable_6475[1][3] = concat(h_variable_6473,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6475); matrix h_variable_6476 = h_variable_l[1]; matrix h_variable_6477 = h_variable_l[2];
IsZeroMatrix(h_variable_6476);
matrix h_variable_6478 = DecideZeroRows(h_variable_6476,h_variable_58);
IsZeroMatrix(h_variable_6478);
def h_variable_6479 = h_variable_4814[2,17];
h_variable_6479;
matrix h_variable_6480[1][1] = 0;
matrix h_variable_6481[1][3] = concat(h_variable_6480,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6481); matrix h_variable_6482 = h_variable_l[1]; matrix h_variable_6483 = h_variable_l[2];
ncols(h_variable_6482);
matrix h_variable_6484 = DecideZeroRows(h_variable_6482,h_variable_58);
IsZeroMatrix(h_variable_6484);
nrows(h_variable_6483);
def h_variable_6485 = h_variable_4814[1,17];
h_variable_6485;
matrix h_variable_6486[1][1] = 0;
matrix h_variable_6487[1][3] = concat(h_variable_6486,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6487); matrix h_variable_6488 = h_variable_l[1]; matrix h_variable_6489 = h_variable_l[2];
ncols(h_variable_6488);
matrix h_variable_6490 = DecideZeroRows(h_variable_6488,h_variable_58);
IsZeroMatrix(h_variable_6490);
nrows(h_variable_6489);
def h_variable_6491 = h_variable_4814[16,18];
h_variable_6491;
matrix h_variable_6492[1][1] = 0;
matrix h_variable_6493[1][3] = concat(h_variable_6492,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6493); matrix h_variable_6494 = h_variable_l[1]; matrix h_variable_6495 = h_variable_l[2];
ncols(h_variable_6494);
matrix h_variable_6496 = DecideZeroRows(h_variable_6494,h_variable_58);
IsZeroMatrix(h_variable_6496);
nrows(h_variable_6495);
def h_variable_6497 = h_variable_4814[15,18];
h_variable_6497;
matrix h_variable_6498[1][1] = 0;
matrix h_variable_6499[1][3] = concat(h_variable_6498,h_variable_48);
kill h_variable_5949;kill h_variable_5950;kill h_variable_5951;kill h_variable_5952;kill h_variable_5954;kill h_variable_5955;kill h_variable_5956;kill h_variable_5957;kill h_variable_5958;kill h_variable_5960;kill h_variable_5961;kill h_variable_5962;kill h_variable_5963;kill h_variable_5964;kill h_variable_5965;kill h_variable_5966;kill h_variable_5967;kill h_variable_5968;kill h_variable_5969;kill h_variable_5970;kill h_variable_5971;kill h_variable_5972;kill h_variable_5973;kill h_variable_5974;kill h_variable_5975;kill h_variable_5976;kill h_variable_5977;kill h_variable_5978;kill h_variable_5979;kill h_variable_5980;kill h_variable_5981;kill h_variable_5982;kill h_variable_5983;kill h_variable_5984;kill h_variable_5985;kill h_variable_5986;kill h_variable_5987;kill h_variable_5988;kill h_variable_5989;kill h_variable_5990;kill h_variable_5991;kill h_variable_5992;kill h_variable_5993;kill h_variable_5994;kill h_variable_5995;kill h_variable_5996;kill h_variable_5997;kill h_variable_5998;kill h_variable_5999;kill h_variable_6000;kill h_variable_6001;kill h_variable_6002;kill h_variable_6003;kill h_variable_6004;kill h_variable_6005;kill h_variable_6006;kill h_variable_6007;kill h_variable_6008;kill h_variable_6009;kill h_variable_6010;kill h_variable_6011;kill h_variable_6012;kill h_variable_6013;kill h_variable_6014;kill h_variable_6015;kill h_variable_6016;kill h_variable_6017;kill h_variable_6018;kill h_variable_6019;kill h_variable_6020;kill h_variable_6021;kill h_variable_6022;kill h_variable_6023;kill h_variable_6024;kill h_variable_6025;kill h_variable_6026;kill h_variable_6027;kill h_variable_6028;kill h_variable_6029;kill h_variable_6030;kill h_variable_6031;kill h_variable_6032;kill h_variable_6033;kill h_variable_6034;kill h_variable_6035;kill h_variable_6036;kill h_variable_6037;kill h_variable_6038;kill h_variable_6039;kill h_variable_6040;kill h_variable_6041;kill h_variable_6042;kill h_variable_6043;kill h_variable_6044;kill h_variable_6045;kill h_variable_6046;kill h_variable_6047;kill h_variable_6048;kill h_variable_6049;kill h_variable_6050;kill h_variable_6051;kill h_variable_6052;kill h_variable_6053;kill h_variable_6054;kill h_variable_6063;kill h_variable_6064;kill h_variable_6065;kill h_variable_6066;kill h_variable_6068;kill h_variable_6069;kill h_variable_6070;kill h_variable_6071;kill h_variable_6072;kill h_variable_6074;kill h_variable_6075;kill h_variable_6076;kill h_variable_6077;kill h_variable_6078;kill h_variable_6079;kill h_variable_6080;kill h_variable_6081;kill h_variable_6082;kill h_variable_6083;kill h_variable_6084;kill h_variable_6085;kill h_variable_6086;kill h_variable_6087;kill h_variable_6088;kill h_variable_6089;kill h_variable_6090;kill h_variable_6091;kill h_variable_6092;kill h_variable_6093;kill h_variable_6094;kill h_variable_6095;kill h_variable_6096;kill h_variable_6097;kill h_variable_6098;kill h_variable_6099;kill h_variable_6100;kill h_variable_6101;kill h_variable_6102;kill h_variable_6103;kill h_variable_6104;kill h_variable_6105;kill h_variable_6106;kill h_variable_6107;kill h_variable_6108;kill h_variable_6109;kill h_variable_6110;kill h_variable_6111;kill h_variable_6112;kill h_variable_6113;kill h_variable_6114;kill h_variable_6115;kill h_variable_6116;kill h_variable_6117;kill h_variable_6118;kill h_variable_6119;kill h_variable_6120;kill h_variable_6121;kill h_variable_6122;kill h_variable_6123;kill h_variable_6124;kill h_variable_6125;kill h_variable_6126;kill h_variable_6127;kill h_variable_6128;kill h_variable_6129;kill h_variable_6130;kill h_variable_6131;kill h_variable_6132;kill h_variable_6133;kill h_variable_6134;kill h_variable_6135;kill h_variable_6136;kill h_variable_6137;kill h_variable_6138;kill h_variable_6139;kill h_variable_6140;kill h_variable_6141;kill h_variable_6142;kill h_variable_6143;kill h_variable_6144;kill h_variable_6145;kill h_variable_6146;kill h_variable_6147;kill h_variable_6148;kill h_variable_6149;kill h_variable_6150;kill h_variable_6151;kill h_variable_6152;kill h_variable_6153;kill h_variable_6154;kill h_variable_6155;kill h_variable_6156;kill h_variable_6157;kill h_variable_6158;kill h_variable_6159;kill h_variable_6160;kill h_variable_6161;kill h_variable_6162;kill h_variable_6163;kill h_variable_6164;kill h_variable_6165;kill h_variable_6166;kill h_variable_6167;kill h_variable_6168;kill h_variable_6169;kill h_variable_6170;kill h_variable_6171;kill h_variable_6172;kill h_variable_6173;kill h_variable_6174;kill h_variable_6175;kill h_variable_6176;kill h_variable_6177;kill h_variable_6178;kill h_variable_6179;kill h_variable_6180;kill h_variable_6181;kill h_variable_6182;kill h_variable_6183;kill h_variable_6184;kill h_variable_6185;kill h_variable_6186;kill h_variable_6187;kill h_variable_6188;kill h_variable_6189;kill h_variable_6190;kill h_variable_6191;kill h_variable_6192;kill h_variable_6193;kill h_variable_6194;kill h_variable_6195;kill h_variable_6196;kill h_variable_6197;kill h_variable_6198;kill h_variable_6199;kill h_variable_6200;kill h_variable_6201;kill h_variable_6202;kill h_variable_6203;kill h_variable_6204;kill h_variable_6205;kill h_variable_6206;kill h_variable_6207;kill h_variable_6208;kill h_variable_6209;kill h_variable_6210;kill h_variable_6211;kill h_variable_6212;kill h_variable_6213;kill h_variable_6214;kill h_variable_6215;kill h_variable_6216;kill h_variable_6217;kill h_variable_6218;kill h_variable_6219;kill h_variable_6220;kill h_variable_6221;kill h_variable_6222;kill h_variable_6223;kill h_variable_6224;kill h_variable_6225;kill h_variable_6226;kill h_variable_6227;kill h_variable_6228;kill h_variable_6229;kill h_variable_6230;kill h_variable_6231;kill h_variable_6232;kill h_variable_6238;kill h_variable_6241;kill h_variable_6242;kill h_variable_6243;kill h_variable_6244;kill h_variable_6246;kill h_variable_6247;kill h_variable_6248;kill h_variable_6249;kill h_variable_6250;kill h_variable_6252;kill h_variable_6253;kill h_variable_6254;kill h_variable_6255;kill h_variable_6256;kill h_variable_6257;kill h_variable_6258;kill h_variable_6259;kill h_variable_6260;kill h_variable_6261;kill h_variable_6262;kill h_variable_6263;kill h_variable_6264;kill h_variable_6265;kill h_variable_6266;kill h_variable_6267;kill h_variable_6268;kill h_variable_6269;kill h_variable_6270;kill h_variable_6271;kill h_variable_6272;kill h_variable_6273;kill h_variable_6274;kill h_variable_6275;kill h_variable_6276;kill h_variable_6277;kill h_variable_6278;kill h_variable_6279;kill h_variable_6280;kill h_variable_6281;kill h_variable_6282;kill h_variable_6283;kill h_variable_6284;kill h_variable_6285;kill h_variable_6286;kill h_variable_6287;kill h_variable_6288;kill h_variable_6289;kill h_variable_6290;kill h_variable_6291;kill h_variable_6292;kill h_variable_6293;kill h_variable_6294;kill h_variable_6295;kill h_variable_6296;kill h_variable_6297;kill h_variable_6298;kill h_variable_6299;kill h_variable_6300;kill h_variable_6301;kill h_variable_6302;kill h_variable_6303;kill h_variable_6304;kill h_variable_6305;kill h_variable_6306;kill h_variable_6307;kill h_variable_6308;kill h_variable_6309;kill h_variable_6310;kill h_variable_6311;kill h_variable_6312;kill h_variable_6313;kill h_variable_6314;kill h_variable_6315;kill h_variable_6316;kill h_variable_6317;kill h_variable_6318;kill h_variable_6319;kill h_variable_6320;kill h_variable_6321;kill h_variable_6322;kill h_variable_6323;kill h_variable_6324;kill h_variable_6325;kill h_variable_6326;kill h_variable_6327;kill h_variable_6328;kill h_variable_6329;kill h_variable_6330;kill h_variable_6331;kill h_variable_6332;kill h_variable_6333;kill h_variable_6334;kill h_variable_6335;kill h_variable_6336;kill h_variable_6337;kill h_variable_6338;kill h_variable_6339;kill h_variable_6340;kill h_variable_6341;kill h_variable_6342;kill h_variable_6343;kill h_variable_6344;kill h_variable_6345;kill h_variable_6346;kill h_variable_6347;kill h_variable_6348;kill h_variable_6349;kill h_variable_6350;kill h_variable_6351;kill h_variable_6352;kill h_variable_6353;kill h_variable_6354;kill h_variable_6355;kill h_variable_6356;kill h_variable_6357;kill h_variable_6358;kill h_variable_6359;kill h_variable_6360;kill h_variable_6361;kill h_variable_6362;kill h_variable_6363;kill h_variable_6364;kill h_variable_6365;kill h_variable_6366;kill h_variable_6367;kill h_variable_6368;kill h_variable_6369;kill h_variable_6370;kill h_variable_6371;kill h_variable_6372;kill h_variable_6373;kill h_variable_6374;kill h_variable_6375;kill h_variable_6376;kill h_variable_6377;kill h_variable_6378;kill h_variable_6379;kill h_variable_6380;kill h_variable_6381;kill h_variable_6382;kill h_variable_6383;kill h_variable_6384;kill h_variable_6385;kill h_variable_6386;kill h_variable_6387;kill h_variable_6388;kill h_variable_6389;kill h_variable_6390;kill h_variable_6391;kill h_variable_6392;kill h_variable_6393;kill h_variable_6394;kill h_variable_6395;kill h_variable_6396;kill h_variable_6397;kill h_variable_6398;kill h_variable_6399;kill h_variable_6400;kill h_variable_6401;kill h_variable_6402;kill h_variable_6403;kill h_variable_6404;kill h_variable_6405;kill h_variable_6406;kill h_variable_6407;kill h_variable_6408;kill h_variable_6409;kill h_variable_6410;kill h_variable_6411;kill h_variable_6412;kill h_variable_6413;kill h_variable_6414;kill h_variable_6415;kill h_variable_6416;kill h_variable_6417;kill h_variable_6418;
list h_variable_l=BasisOfRowsCoeff(h_variable_6499); matrix h_variable_6500 = h_variable_l[1]; matrix h_variable_6501 = h_variable_l[2];
ncols(h_variable_6500);
matrix h_variable_6502 = DecideZeroRows(h_variable_6500,h_variable_58);
IsZeroMatrix(h_variable_6502);
nrows(h_variable_6501);
def h_variable_6503 = h_variable_4814[14,18];
h_variable_6503;
matrix h_variable_6504[1][1] = 0;
matrix h_variable_6505[1][3] = concat(h_variable_6504,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6505); matrix h_variable_6506 = h_variable_l[1]; matrix h_variable_6507 = h_variable_l[2];
ncols(h_variable_6506);
matrix h_variable_6508 = DecideZeroRows(h_variable_6506,h_variable_58);
IsZeroMatrix(h_variable_6508);
nrows(h_variable_6507);
def h_variable_6509 = h_variable_4814[13,18];
h_variable_6509;
matrix h_variable_6510[1][1] = 0;
matrix h_variable_6511[1][3] = concat(h_variable_6510,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6511); matrix h_variable_6512 = h_variable_l[1]; matrix h_variable_6513 = h_variable_l[2];
ncols(h_variable_6512);
matrix h_variable_6514 = DecideZeroRows(h_variable_6512,h_variable_58);
IsZeroMatrix(h_variable_6514);
nrows(h_variable_6513);
def h_variable_6515 = h_variable_4814[12,18];
h_variable_6515;
matrix h_variable_6516[1][1] = 0;
matrix h_variable_6517[1][3] = concat(h_variable_6516,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6517); matrix h_variable_6518 = h_variable_l[1]; matrix h_variable_6519 = h_variable_l[2];
ncols(h_variable_6518);
matrix h_variable_6520 = DecideZeroRows(h_variable_6518,h_variable_58);
IsZeroMatrix(h_variable_6520);
nrows(h_variable_6519);
def h_variable_6521 = h_variable_4814[11,18];
h_variable_6521;
matrix h_variable_6522[1][1] = 0;
matrix h_variable_6523[1][3] = concat(h_variable_6522,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6523); matrix h_variable_6524 = h_variable_l[1]; matrix h_variable_6525 = h_variable_l[2];
ncols(h_variable_6524);
matrix h_variable_6526 = DecideZeroRows(h_variable_6524,h_variable_58);
IsZeroMatrix(h_variable_6526);
nrows(h_variable_6525);
def h_variable_6527 = h_variable_4814[10,18];
h_variable_6527;
matrix h_variable_6528[1][1] = 0;
matrix h_variable_6529[1][3] = concat(h_variable_6528,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6529); matrix h_variable_6530 = h_variable_l[1]; matrix h_variable_6531 = h_variable_l[2];
ncols(h_variable_6530);
matrix h_variable_6532 = DecideZeroRows(h_variable_6530,h_variable_58);
IsZeroMatrix(h_variable_6532);
nrows(h_variable_6531);
def h_variable_6533 = h_variable_4814[9,18];
h_variable_6533;
matrix h_variable_6534[1][1] = 1;
matrix h_variable_6535[1][3] = concat(h_variable_6534,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6535); matrix h_variable_6536 = h_variable_l[1]; matrix h_variable_6537 = h_variable_l[2];
ncols(h_variable_6536);
matrix h_variable_6538 = DecideZeroRows(h_variable_6536,h_variable_58);
IsZeroMatrix(h_variable_6538);
nrows(h_variable_6537);
IsIdentityMatrix(h_variable_6538);
def h_variable_6539 = h_variable_4814[1,18];
h_variable_6539;
matrix h_variable_6540[1][1] = 0;
matrix h_variable_6541 = DecideZeroRows(h_variable_6540,h_variable_58);
IsZeroMatrix(h_variable_6541);
def h_variable_6542 = h_variable_6541[1,1];
h_variable_6542==0;
def h_variable_6543 = h_variable_4814[2,18];
h_variable_6543;
matrix h_variable_6544[1][1] = 0;
matrix h_variable_6545 = DecideZeroRows(h_variable_6544,h_variable_58);
IsZeroMatrix(h_variable_6545);
def h_variable_6546 = h_variable_6545[1,1];
h_variable_6546==0;
def h_variable_6547 = h_variable_4814[7,18];
h_variable_6547;
matrix h_variable_6548[1][1] = -x1+x2;
matrix h_variable_6549 = DecideZeroRows(h_variable_6548,h_variable_58);
IsZeroMatrix(h_variable_6549);
def h_variable_6550 = h_variable_6549[1,1];
h_variable_6550==0;
def h_variable_6551 = h_variable_4814[8,18];
h_variable_6551;
matrix h_variable_6552[1][1] = 0;
matrix h_variable_6553 = DecideZeroRows(h_variable_6552,h_variable_58);
IsZeroMatrix(h_variable_6553);
def h_variable_6554 = h_variable_6553[1,1];
h_variable_6554==0;
def h_variable_6555 = h_variable_4814[9,18];
h_variable_6555;
matrix h_variable_6556[1][1] = 1;
matrix h_variable_6557 = DecideZeroRows(h_variable_6556,h_variable_58);
IsZeroMatrix(h_variable_6557);
def h_variable_6558 = h_variable_6557[1,1];
h_variable_6558==0;
def h_variable_6559 = h_variable_4814[10,18];
h_variable_6559;
matrix h_variable_6560[1][1] = 0;
matrix h_variable_6561 = DecideZeroRows(h_variable_6560,h_variable_58);
IsZeroMatrix(h_variable_6561);
def h_variable_6562 = h_variable_6561[1,1];
h_variable_6562==0;
def h_variable_6563 = h_variable_4814[11,18];
h_variable_6563;
matrix h_variable_6564[1][1] = 0;
matrix h_variable_6565 = DecideZeroRows(h_variable_6564,h_variable_58);
IsZeroMatrix(h_variable_6565);
def h_variable_6566 = h_variable_6565[1,1];
h_variable_6566==0;
def h_variable_6567 = h_variable_4814[12,18];
h_variable_6567;
matrix h_variable_6568[1][1] = 0;
matrix h_variable_6569 = DecideZeroRows(h_variable_6568,h_variable_58);
IsZeroMatrix(h_variable_6569);
def h_variable_6570 = h_variable_6569[1,1];
h_variable_6570==0;
def h_variable_6571 = h_variable_4814[13,18];
h_variable_6571;
matrix h_variable_6572[1][1] = 0;
matrix h_variable_6573 = DecideZeroRows(h_variable_6572,h_variable_58);
IsZeroMatrix(h_variable_6573);
def h_variable_6574 = h_variable_6573[1,1];
h_variable_6574==0;
def h_variable_6575 = h_variable_4814[14,18];
h_variable_6575;
matrix h_variable_6576[1][1] = 0;
matrix h_variable_6577 = DecideZeroRows(h_variable_6576,h_variable_58);
IsZeroMatrix(h_variable_6577);
def h_variable_6578 = h_variable_6577[1,1];
h_variable_6578==0;
def h_variable_6579 = h_variable_4814[15,18];
h_variable_6579;
matrix h_variable_6580[1][1] = 0;
matrix h_variable_6581 = DecideZeroRows(h_variable_6580,h_variable_58);
IsZeroMatrix(h_variable_6581);
def h_variable_6582 = h_variable_6581[1,1];
h_variable_6582==0;
def h_variable_6583 = h_variable_4814[16,18];
h_variable_6583;
matrix h_variable_6584[1][1] = 0;
matrix h_variable_6585 = DecideZeroRows(h_variable_6584,h_variable_58);
IsZeroMatrix(h_variable_6585);
def h_variable_6586 = h_variable_6585[1,1];
h_variable_6586==0;
def h_variable_6587 = h_variable_4814[16,19];
h_variable_6587;
matrix h_variable_6588[1][1] = 0;
matrix h_variable_6589[1][3] = concat(h_variable_6588,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6589); matrix h_variable_6590 = h_variable_l[1]; matrix h_variable_6591 = h_variable_l[2];
ncols(h_variable_6590);
matrix h_variable_6592 = DecideZeroRows(h_variable_6590,h_variable_58);
IsZeroMatrix(h_variable_6592);
nrows(h_variable_6591);
def h_variable_6593 = h_variable_4814[15,19];
h_variable_6593;
matrix h_variable_6594[1][1] = 0;
matrix h_variable_6595[1][3] = concat(h_variable_6594,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6595); matrix h_variable_6596 = h_variable_l[1]; matrix h_variable_6597 = h_variable_l[2];
ncols(h_variable_6596);
matrix h_variable_6598 = DecideZeroRows(h_variable_6596,h_variable_58);
IsZeroMatrix(h_variable_6598);
nrows(h_variable_6597);
def h_variable_6599 = h_variable_4814[14,19];
h_variable_6599;
matrix h_variable_6600[1][1] = -3;
matrix h_variable_6601[1][3] = concat(h_variable_6600,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6601); matrix h_variable_6602 = h_variable_l[1]; matrix h_variable_6603 = h_variable_l[2];
ncols(h_variable_6602);
matrix h_variable_6604 = DecideZeroRows(h_variable_6602,h_variable_58);
IsZeroMatrix(h_variable_6604);
ZeroRows(h_variable_6604);
nrows(h_variable_6603);
matrix h_variable_6606 = submat(h_variable_6602,1..1,intvec( 1 ));
matrix h_variable_6605 = DecideZeroRows(h_variable_6606,h_variable_58);
IsZeroMatrix(h_variable_6605);
IsIdentityMatrix(h_variable_6605);
matrix h_variable_6607[1][3] = concat(h_variable_6605,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6607); matrix h_variable_6608 = h_variable_l[1]; matrix h_variable_6609 = h_variable_l[2];
IsZeroMatrix(h_variable_6608);
matrix h_variable_6610 = DecideZeroRows(h_variable_6608,h_variable_58);
IsZeroMatrix(h_variable_6610);
def h_variable_6611 = h_variable_4814[13,19];
h_variable_6611;
matrix h_variable_6612[1][1] = -3;
matrix h_variable_6613[1][3] = concat(h_variable_6612,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6613); matrix h_variable_6614 = h_variable_l[1]; matrix h_variable_6615 = h_variable_l[2];
ncols(h_variable_6614);
matrix h_variable_6616 = DecideZeroRows(h_variable_6614,h_variable_58);
IsZeroMatrix(h_variable_6616);
ZeroRows(h_variable_6616);
nrows(h_variable_6615);
matrix h_variable_6618 = submat(h_variable_6614,1..1,intvec( 1 ));
matrix h_variable_6617 = DecideZeroRows(h_variable_6618,h_variable_58);
IsZeroMatrix(h_variable_6617);
IsIdentityMatrix(h_variable_6617);
matrix h_variable_6619[1][3] = concat(h_variable_6617,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6619); matrix h_variable_6620 = h_variable_l[1]; matrix h_variable_6621 = h_variable_l[2];
IsZeroMatrix(h_variable_6620);
matrix h_variable_6622 = DecideZeroRows(h_variable_6620,h_variable_58);
IsZeroMatrix(h_variable_6622);
def h_variable_6623 = h_variable_4814[12,19];
h_variable_6623;
matrix h_variable_6624[1][1] = 0;
matrix h_variable_6625[1][3] = concat(h_variable_6624,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6625); matrix h_variable_6626 = h_variable_l[1]; matrix h_variable_6627 = h_variable_l[2];
ncols(h_variable_6626);
matrix h_variable_6628 = DecideZeroRows(h_variable_6626,h_variable_58);
IsZeroMatrix(h_variable_6628);
nrows(h_variable_6627);
def h_variable_6629 = h_variable_4814[11,19];
h_variable_6629;
matrix h_variable_6630[1][1] = 0;
matrix h_variable_6631[1][3] = concat(h_variable_6630,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6631); matrix h_variable_6632 = h_variable_l[1]; matrix h_variable_6633 = h_variable_l[2];
ncols(h_variable_6632);
matrix h_variable_6634 = DecideZeroRows(h_variable_6632,h_variable_58);
IsZeroMatrix(h_variable_6634);
nrows(h_variable_6633);
def h_variable_6635 = h_variable_4814[10,19];
h_variable_6635;
matrix h_variable_6636[1][1] = 0;
matrix h_variable_6637[1][3] = concat(h_variable_6636,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6637); matrix h_variable_6638 = h_variable_l[1]; matrix h_variable_6639 = h_variable_l[2];
ncols(h_variable_6638);
matrix h_variable_6640 = DecideZeroRows(h_variable_6638,h_variable_58);
IsZeroMatrix(h_variable_6640);
nrows(h_variable_6639);
def h_variable_6641 = h_variable_4814[8,19];
h_variable_6641;
matrix h_variable_6642[1][1] = 3*x1;
matrix h_variable_6643[1][3] = concat(h_variable_6642,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6643); matrix h_variable_6644 = h_variable_l[1]; matrix h_variable_6645 = h_variable_l[2];
ncols(h_variable_6644);
matrix h_variable_6646 = DecideZeroRows(h_variable_6644,h_variable_58);
IsZeroMatrix(h_variable_6646);
ZeroRows(h_variable_6646);
nrows(h_variable_6645);
matrix h_variable_6648 = submat(h_variable_6644,1..1,intvec( 2 ));
matrix h_variable_6647 = DecideZeroRows(h_variable_6648,h_variable_58);
IsZeroMatrix(h_variable_6647);
IsIdentityMatrix(h_variable_6647);
matrix h_variable_6649[1][3] = concat(h_variable_6647,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6649); matrix h_variable_6650 = h_variable_l[1]; matrix h_variable_6651 = h_variable_l[2];
IsZeroMatrix(h_variable_6650);
matrix h_variable_6652 = DecideZeroRows(h_variable_6650,h_variable_58);
IsZeroMatrix(h_variable_6652);
def h_variable_6653 = h_variable_4814[2,19];
h_variable_6653;
matrix h_variable_6654[1][1] = 0;
matrix h_variable_6655[1][3] = concat(h_variable_6654,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6655); matrix h_variable_6656 = h_variable_l[1]; matrix h_variable_6657 = h_variable_l[2];
ncols(h_variable_6656);
matrix h_variable_6658 = DecideZeroRows(h_variable_6656,h_variable_58);
IsZeroMatrix(h_variable_6658);
nrows(h_variable_6657);
def h_variable_6659 = h_variable_4814[1,19];
h_variable_6659;
matrix h_variable_6660[1][1] = 0;
matrix h_variable_6661[1][3] = concat(h_variable_6660,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6661); matrix h_variable_6662 = h_variable_l[1]; matrix h_variable_6663 = h_variable_l[2];
ncols(h_variable_6662);
matrix h_variable_6664 = DecideZeroRows(h_variable_6662,h_variable_58);
IsZeroMatrix(h_variable_6664);
nrows(h_variable_6663);
def h_variable_6665 = h_variable_4814[16,20];
h_variable_6665;
matrix h_variable_6666[1][1] = 0;
matrix h_variable_6667[1][3] = concat(h_variable_6666,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6667); matrix h_variable_6668 = h_variable_l[1]; matrix h_variable_6669 = h_variable_l[2];
ncols(h_variable_6668);
matrix h_variable_6670 = DecideZeroRows(h_variable_6668,h_variable_58);
IsZeroMatrix(h_variable_6670);
nrows(h_variable_6669);
def h_variable_6671 = h_variable_4814[15,20];
h_variable_6671;
matrix h_variable_6672[1][1] = 0;
matrix h_variable_6673[1][3] = concat(h_variable_6672,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6673); matrix h_variable_6674 = h_variable_l[1]; matrix h_variable_6675 = h_variable_l[2];
ncols(h_variable_6674);
matrix h_variable_6676 = DecideZeroRows(h_variable_6674,h_variable_58);
IsZeroMatrix(h_variable_6676);
nrows(h_variable_6675);
def h_variable_6677 = h_variable_4814[14,20];
h_variable_6677;
matrix h_variable_6678[1][1] = -3*x1+3*x3;
matrix h_variable_6679[1][3] = concat(h_variable_6678,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6679); matrix h_variable_6680 = h_variable_l[1]; matrix h_variable_6681 = h_variable_l[2];
ncols(h_variable_6680);
matrix h_variable_6682 = DecideZeroRows(h_variable_6680,h_variable_58);
IsZeroMatrix(h_variable_6682);
ZeroRows(h_variable_6682);
nrows(h_variable_6681);
matrix h_variable_6684 = submat(h_variable_6680,1..1,intvec( 2 ));
matrix h_variable_6683 = DecideZeroRows(h_variable_6684,h_variable_58);
IsZeroMatrix(h_variable_6683);
IsIdentityMatrix(h_variable_6683);
matrix h_variable_6685[1][3] = concat(h_variable_6683,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6685); matrix h_variable_6686 = h_variable_l[1]; matrix h_variable_6687 = h_variable_l[2];
IsZeroMatrix(h_variable_6686);
matrix h_variable_6688 = DecideZeroRows(h_variable_6686,h_variable_58);
IsZeroMatrix(h_variable_6688);
def h_variable_6689 = h_variable_4814[13,20];
h_variable_6689;
matrix h_variable_6690[1][1] = -3*x1;
matrix h_variable_6691[1][3] = concat(h_variable_6690,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6691); matrix h_variable_6692 = h_variable_l[1]; matrix h_variable_6693 = h_variable_l[2];
ncols(h_variable_6692);
matrix h_variable_6694 = DecideZeroRows(h_variable_6692,h_variable_58);
IsZeroMatrix(h_variable_6694);
ZeroRows(h_variable_6694);
nrows(h_variable_6693);
matrix h_variable_6696 = submat(h_variable_6692,1..1,intvec( 2 ));
matrix h_variable_6695 = DecideZeroRows(h_variable_6696,h_variable_58);
IsZeroMatrix(h_variable_6695);
IsIdentityMatrix(h_variable_6695);
matrix h_variable_6697[1][3] = concat(h_variable_6695,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6697); matrix h_variable_6698 = h_variable_l[1]; matrix h_variable_6699 = h_variable_l[2];
IsZeroMatrix(h_variable_6698);
matrix h_variable_6700 = DecideZeroRows(h_variable_6698,h_variable_58);
IsZeroMatrix(h_variable_6700);
def h_variable_6701 = h_variable_4814[12,20];
h_variable_6701;
matrix h_variable_6702[1][1] = -3*x2+3*x3;
matrix h_variable_6703[1][3] = concat(h_variable_6702,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6703); matrix h_variable_6704 = h_variable_l[1]; matrix h_variable_6705 = h_variable_l[2];
ncols(h_variable_6704);
matrix h_variable_6706 = DecideZeroRows(h_variable_6704,h_variable_58);
IsZeroMatrix(h_variable_6706);
ZeroRows(h_variable_6706);
nrows(h_variable_6705);
matrix h_variable_6708 = submat(h_variable_6704,1..1,intvec( 2 ));
matrix h_variable_6707 = DecideZeroRows(h_variable_6708,h_variable_58);
IsZeroMatrix(h_variable_6707);
IsIdentityMatrix(h_variable_6707);
matrix h_variable_6709[1][3] = concat(h_variable_6707,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6709); matrix h_variable_6710 = h_variable_l[1]; matrix h_variable_6711 = h_variable_l[2];
IsZeroMatrix(h_variable_6710);
matrix h_variable_6712 = DecideZeroRows(h_variable_6710,h_variable_58);
IsZeroMatrix(h_variable_6712);
def h_variable_6713 = h_variable_4814[11,20];
h_variable_6713;
matrix h_variable_6714[1][1] = 0;
matrix h_variable_6715[1][3] = concat(h_variable_6714,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6715); matrix h_variable_6716 = h_variable_l[1]; matrix h_variable_6717 = h_variable_l[2];
ncols(h_variable_6716);
matrix h_variable_6718 = DecideZeroRows(h_variable_6716,h_variable_58);
IsZeroMatrix(h_variable_6718);
nrows(h_variable_6717);
def h_variable_6719 = h_variable_4814[10,20];
h_variable_6719;
matrix h_variable_6720[1][1] = 0;
matrix h_variable_6721[1][3] = concat(h_variable_6720,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6721); matrix h_variable_6722 = h_variable_l[1]; matrix h_variable_6723 = h_variable_l[2];
ncols(h_variable_6722);
matrix h_variable_6724 = DecideZeroRows(h_variable_6722,h_variable_58);
IsZeroMatrix(h_variable_6724);
nrows(h_variable_6723);
def h_variable_6725 = h_variable_4814[8,20];
h_variable_6725;
matrix h_variable_6726[1][1] = -3*x3^2;
matrix h_variable_6727[1][3] = concat(h_variable_6726,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6727); matrix h_variable_6728 = h_variable_l[1]; matrix h_variable_6729 = h_variable_l[2];
ncols(h_variable_6728);
matrix h_variable_6730 = DecideZeroRows(h_variable_6728,h_variable_58);
IsZeroMatrix(h_variable_6730);
ZeroRows(h_variable_6730);
nrows(h_variable_6729);
matrix h_variable_6732 = submat(h_variable_6728,1..1,intvec( 2 ));
matrix h_variable_6731 = DecideZeroRows(h_variable_6732,h_variable_58);
IsZeroMatrix(h_variable_6731);
IsIdentityMatrix(h_variable_6731);
matrix h_variable_6733[1][3] = concat(h_variable_6731,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6733); matrix h_variable_6734 = h_variable_l[1]; matrix h_variable_6735 = h_variable_l[2];
IsZeroMatrix(h_variable_6734);
matrix h_variable_6736 = DecideZeroRows(h_variable_6734,h_variable_58);
IsZeroMatrix(h_variable_6736);
def h_variable_6737 = h_variable_4814[2,20];
h_variable_6737;
matrix h_variable_6738[1][1] = 0;
matrix h_variable_6739[1][3] = concat(h_variable_6738,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6739); matrix h_variable_6740 = h_variable_l[1]; matrix h_variable_6741 = h_variable_l[2];
ncols(h_variable_6740);
matrix h_variable_6742 = DecideZeroRows(h_variable_6740,h_variable_58);
IsZeroMatrix(h_variable_6742);
nrows(h_variable_6741);
def h_variable_6743 = h_variable_4814[1,20];
h_variable_6743;
matrix h_variable_6744[1][1] = 0;
matrix h_variable_6745[1][3] = concat(h_variable_6744,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6745); matrix h_variable_6746 = h_variable_l[1]; matrix h_variable_6747 = h_variable_l[2];
ncols(h_variable_6746);
matrix h_variable_6748 = DecideZeroRows(h_variable_6746,h_variable_58);
IsZeroMatrix(h_variable_6748);
nrows(h_variable_6747);
def h_variable_6749 = h_variable_4814[16,21];
h_variable_6749;
matrix h_variable_6750[1][1] = 0;
matrix h_variable_6751[1][3] = concat(h_variable_6750,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6751); matrix h_variable_6752 = h_variable_l[1]; matrix h_variable_6753 = h_variable_l[2];
ncols(h_variable_6752);
matrix h_variable_6754 = DecideZeroRows(h_variable_6752,h_variable_58);
IsZeroMatrix(h_variable_6754);
nrows(h_variable_6753);
def h_variable_6755 = h_variable_4814[15,21];
h_variable_6755;
matrix h_variable_6756[1][1] = 0;
matrix h_variable_6757[1][3] = concat(h_variable_6756,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6757); matrix h_variable_6758 = h_variable_l[1]; matrix h_variable_6759 = h_variable_l[2];
ncols(h_variable_6758);
matrix h_variable_6760 = DecideZeroRows(h_variable_6758,h_variable_58);
IsZeroMatrix(h_variable_6760);
nrows(h_variable_6759);
def h_variable_6761 = h_variable_4814[14,21];
h_variable_6761;
matrix h_variable_6762[1][1] = 0;
matrix h_variable_6763[1][3] = concat(h_variable_6762,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6763); matrix h_variable_6764 = h_variable_l[1]; matrix h_variable_6765 = h_variable_l[2];
ncols(h_variable_6764);
matrix h_variable_6766 = DecideZeroRows(h_variable_6764,h_variable_58);
IsZeroMatrix(h_variable_6766);
nrows(h_variable_6765);
def h_variable_6767 = h_variable_4814[13,21];
h_variable_6767;
matrix h_variable_6768[1][1] = 3;
matrix h_variable_6769[1][3] = concat(h_variable_6768,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6769); matrix h_variable_6770 = h_variable_l[1]; matrix h_variable_6771 = h_variable_l[2];
ncols(h_variable_6770);
matrix h_variable_6772 = DecideZeroRows(h_variable_6770,h_variable_58);
IsZeroMatrix(h_variable_6772);
ZeroRows(h_variable_6772);
nrows(h_variable_6771);
matrix h_variable_6774 = submat(h_variable_6770,1..1,intvec( 1 ));
matrix h_variable_6773 = DecideZeroRows(h_variable_6774,h_variable_58);
IsZeroMatrix(h_variable_6773);
IsIdentityMatrix(h_variable_6773);
matrix h_variable_6775[1][3] = concat(h_variable_6773,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6775); matrix h_variable_6776 = h_variable_l[1]; matrix h_variable_6777 = h_variable_l[2];
IsZeroMatrix(h_variable_6776);
matrix h_variable_6778 = DecideZeroRows(h_variable_6776,h_variable_58);
IsZeroMatrix(h_variable_6778);
def h_variable_6779 = h_variable_4814[12,21];
h_variable_6779;
matrix h_variable_6780[1][1] = 3;
matrix h_variable_6781[1][3] = concat(h_variable_6780,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6781); matrix h_variable_6782 = h_variable_l[1]; matrix h_variable_6783 = h_variable_l[2];
ncols(h_variable_6782);
matrix h_variable_6784 = DecideZeroRows(h_variable_6782,h_variable_58);
IsZeroMatrix(h_variable_6784);
ZeroRows(h_variable_6784);
nrows(h_variable_6783);
matrix h_variable_6786 = submat(h_variable_6782,1..1,intvec( 1 ));
matrix h_variable_6785 = DecideZeroRows(h_variable_6786,h_variable_58);
IsZeroMatrix(h_variable_6785);
IsIdentityMatrix(h_variable_6785);
matrix h_variable_6787[1][3] = concat(h_variable_6785,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6787); matrix h_variable_6788 = h_variable_l[1]; matrix h_variable_6789 = h_variable_l[2];
IsZeroMatrix(h_variable_6788);
matrix h_variable_6790 = DecideZeroRows(h_variable_6788,h_variable_58);
IsZeroMatrix(h_variable_6790);
def h_variable_6791 = h_variable_4814[11,21];
h_variable_6791;
matrix h_variable_6792[1][1] = 0;
matrix h_variable_6793[1][3] = concat(h_variable_6792,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6793); matrix h_variable_6794 = h_variable_l[1]; matrix h_variable_6795 = h_variable_l[2];
ncols(h_variable_6794);
matrix h_variable_6796 = DecideZeroRows(h_variable_6794,h_variable_58);
IsZeroMatrix(h_variable_6796);
nrows(h_variable_6795);
def h_variable_6797 = h_variable_4814[10,21];
h_variable_6797;
matrix h_variable_6798[1][1] = -3*x2+3*x3;
matrix h_variable_6799[1][3] = concat(h_variable_6798,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6799); matrix h_variable_6800 = h_variable_l[1]; matrix h_variable_6801 = h_variable_l[2];
ncols(h_variable_6800);
matrix h_variable_6802 = DecideZeroRows(h_variable_6800,h_variable_58);
IsZeroMatrix(h_variable_6802);
ZeroRows(h_variable_6802);
nrows(h_variable_6801);
matrix h_variable_6804 = submat(h_variable_6800,1..1,intvec( 2 ));
matrix h_variable_6803 = DecideZeroRows(h_variable_6804,h_variable_58);
IsZeroMatrix(h_variable_6803);
IsIdentityMatrix(h_variable_6803);
matrix h_variable_6805[1][3] = concat(h_variable_6803,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6805); matrix h_variable_6806 = h_variable_l[1]; matrix h_variable_6807 = h_variable_l[2];
IsZeroMatrix(h_variable_6806);
matrix h_variable_6808 = DecideZeroRows(h_variable_6806,h_variable_58);
IsZeroMatrix(h_variable_6808);
def h_variable_6809 = h_variable_4814[8,21];
h_variable_6809;
matrix h_variable_6810[1][1] = 3*x1;
matrix h_variable_6811[1][3] = concat(h_variable_6810,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6811); matrix h_variable_6812 = h_variable_l[1]; matrix h_variable_6813 = h_variable_l[2];
ncols(h_variable_6812);
matrix h_variable_6814 = DecideZeroRows(h_variable_6812,h_variable_58);
IsZeroMatrix(h_variable_6814);
ZeroRows(h_variable_6814);
nrows(h_variable_6813);
matrix h_variable_6816 = submat(h_variable_6812,1..1,intvec( 2 ));
matrix h_variable_6815 = DecideZeroRows(h_variable_6816,h_variable_58);
IsZeroMatrix(h_variable_6815);
IsIdentityMatrix(h_variable_6815);
matrix h_variable_6817[1][3] = concat(h_variable_6815,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6817); matrix h_variable_6818 = h_variable_l[1]; matrix h_variable_6819 = h_variable_l[2];
IsZeroMatrix(h_variable_6818);
matrix h_variable_6820 = DecideZeroRows(h_variable_6818,h_variable_58);
IsZeroMatrix(h_variable_6820);
def h_variable_6821 = h_variable_4814[2,21];
h_variable_6821;
matrix h_variable_6822[1][1] = 0;
matrix h_variable_6823[1][3] = concat(h_variable_6822,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6823); matrix h_variable_6824 = h_variable_l[1]; matrix h_variable_6825 = h_variable_l[2];
ncols(h_variable_6824);
matrix h_variable_6826 = DecideZeroRows(h_variable_6824,h_variable_58);
IsZeroMatrix(h_variable_6826);
nrows(h_variable_6825);
def h_variable_6827 = h_variable_4814[1,21];
h_variable_6827;
matrix h_variable_6828[1][1] = 0;
matrix h_variable_6829[1][3] = concat(h_variable_6828,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6829); matrix h_variable_6830 = h_variable_l[1]; matrix h_variable_6831 = h_variable_l[2];
ncols(h_variable_6830);
matrix h_variable_6832 = DecideZeroRows(h_variable_6830,h_variable_58);
IsZeroMatrix(h_variable_6832);
nrows(h_variable_6831);
def h_variable_6833 = h_variable_4814[16,22];
h_variable_6833;
matrix h_variable_6834[1][1] = 0;
matrix h_variable_6835[1][3] = concat(h_variable_6834,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6835); matrix h_variable_6836 = h_variable_l[1]; matrix h_variable_6837 = h_variable_l[2];
ncols(h_variable_6836);
matrix h_variable_6838 = DecideZeroRows(h_variable_6836,h_variable_58);
IsZeroMatrix(h_variable_6838);
nrows(h_variable_6837);
def h_variable_6839 = h_variable_4814[15,22];
h_variable_6839;
matrix h_variable_6840[1][1] = 0;
matrix h_variable_6841[1][3] = concat(h_variable_6840,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6841); matrix h_variable_6842 = h_variable_l[1]; matrix h_variable_6843 = h_variable_l[2];
ncols(h_variable_6842);
matrix h_variable_6844 = DecideZeroRows(h_variable_6842,h_variable_58);
IsZeroMatrix(h_variable_6844);
nrows(h_variable_6843);
def h_variable_6845 = h_variable_4814[14,22];
h_variable_6845;
matrix h_variable_6846[1][1] = -3*x1-3*x2;
matrix h_variable_6847[1][3] = concat(h_variable_6846,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6847); matrix h_variable_6848 = h_variable_l[1]; matrix h_variable_6849 = h_variable_l[2];
ncols(h_variable_6848);
matrix h_variable_6850 = DecideZeroRows(h_variable_6848,h_variable_58);
IsZeroMatrix(h_variable_6850);
ZeroRows(h_variable_6850);
nrows(h_variable_6849);
matrix h_variable_6852 = submat(h_variable_6848,1..1,intvec( 2 ));
matrix h_variable_6851 = DecideZeroRows(h_variable_6852,h_variable_58);
IsZeroMatrix(h_variable_6851);
IsIdentityMatrix(h_variable_6851);
matrix h_variable_6853[1][3] = concat(h_variable_6851,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6853); matrix h_variable_6854 = h_variable_l[1]; matrix h_variable_6855 = h_variable_l[2];
IsZeroMatrix(h_variable_6854);
matrix h_variable_6856 = DecideZeroRows(h_variable_6854,h_variable_58);
IsZeroMatrix(h_variable_6856);
def h_variable_6857 = h_variable_4814[13,22];
h_variable_6857;
matrix h_variable_6858[1][1] = 0;
matrix h_variable_6859[1][3] = concat(h_variable_6858,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6859); matrix h_variable_6860 = h_variable_l[1]; matrix h_variable_6861 = h_variable_l[2];
ncols(h_variable_6860);
matrix h_variable_6862 = DecideZeroRows(h_variable_6860,h_variable_58);
IsZeroMatrix(h_variable_6862);
nrows(h_variable_6861);
def h_variable_6863 = h_variable_4814[12,22];
h_variable_6863;
matrix h_variable_6864[1][1] = 3*x2;
matrix h_variable_6865[1][3] = concat(h_variable_6864,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6865); matrix h_variable_6866 = h_variable_l[1]; matrix h_variable_6867 = h_variable_l[2];
ncols(h_variable_6866);
matrix h_variable_6868 = DecideZeroRows(h_variable_6866,h_variable_58);
IsZeroMatrix(h_variable_6868);
ZeroRows(h_variable_6868);
nrows(h_variable_6867);
matrix h_variable_6870 = submat(h_variable_6866,1..1,intvec( 2 ));
matrix h_variable_6869 = DecideZeroRows(h_variable_6870,h_variable_58);
IsZeroMatrix(h_variable_6869);
IsIdentityMatrix(h_variable_6869);
matrix h_variable_6871[1][3] = concat(h_variable_6869,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6871); matrix h_variable_6872 = h_variable_l[1]; matrix h_variable_6873 = h_variable_l[2];
IsZeroMatrix(h_variable_6872);
matrix h_variable_6874 = DecideZeroRows(h_variable_6872,h_variable_58);
IsZeroMatrix(h_variable_6874);
def h_variable_6875 = h_variable_4814[11,22];
h_variable_6875;
matrix h_variable_6876[1][1] = 0;
matrix h_variable_6877[1][3] = concat(h_variable_6876,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6877); matrix h_variable_6878 = h_variable_l[1]; matrix h_variable_6879 = h_variable_l[2];
ncols(h_variable_6878);
matrix h_variable_6880 = DecideZeroRows(h_variable_6878,h_variable_58);
IsZeroMatrix(h_variable_6880);
nrows(h_variable_6879);
def h_variable_6881 = h_variable_4814[10,22];
h_variable_6881;
matrix h_variable_6882[1][1] = 3*x2*x3;
matrix h_variable_6883[1][3] = concat(h_variable_6882,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6883); matrix h_variable_6884 = h_variable_l[1]; matrix h_variable_6885 = h_variable_l[2];
ncols(h_variable_6884);
matrix h_variable_6886 = DecideZeroRows(h_variable_6884,h_variable_58);
IsZeroMatrix(h_variable_6886);
ZeroRows(h_variable_6886);
nrows(h_variable_6885);
matrix h_variable_6888 = submat(h_variable_6884,1..1,intvec( 2 ));
matrix h_variable_6887 = DecideZeroRows(h_variable_6888,h_variable_58);
IsZeroMatrix(h_variable_6887);
IsIdentityMatrix(h_variable_6887);
matrix h_variable_6889[1][3] = concat(h_variable_6887,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6889); matrix h_variable_6890 = h_variable_l[1]; matrix h_variable_6891 = h_variable_l[2];
IsZeroMatrix(h_variable_6890);
matrix h_variable_6892 = DecideZeroRows(h_variable_6890,h_variable_58);
IsZeroMatrix(h_variable_6892);
def h_variable_6893 = h_variable_4814[8,22];
h_variable_6893;
matrix h_variable_6894[1][1] = 0;
matrix h_variable_6895[1][3] = concat(h_variable_6894,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6895); matrix h_variable_6896 = h_variable_l[1]; matrix h_variable_6897 = h_variable_l[2];
ncols(h_variable_6896);
matrix h_variable_6898 = DecideZeroRows(h_variable_6896,h_variable_58);
IsZeroMatrix(h_variable_6898);
nrows(h_variable_6897);
def h_variable_6899 = h_variable_4814[2,22];
h_variable_6899;
matrix h_variable_6900[1][1] = 0;
matrix h_variable_6901[1][3] = concat(h_variable_6900,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6901); matrix h_variable_6902 = h_variable_l[1]; matrix h_variable_6903 = h_variable_l[2];
ncols(h_variable_6902);
matrix h_variable_6904 = DecideZeroRows(h_variable_6902,h_variable_58);
IsZeroMatrix(h_variable_6904);
nrows(h_variable_6903);
def h_variable_6905 = h_variable_4814[1,22];
h_variable_6905;
matrix h_variable_6906[1][1] = 0;
matrix h_variable_6907[1][3] = concat(h_variable_6906,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6907); matrix h_variable_6908 = h_variable_l[1]; matrix h_variable_6909 = h_variable_l[2];
ncols(h_variable_6908);
matrix h_variable_6910 = DecideZeroRows(h_variable_6908,h_variable_58);
IsZeroMatrix(h_variable_6910);
nrows(h_variable_6909);
def h_variable_6911 = h_variable_4814[16,23];
h_variable_6911;
matrix h_variable_6912[1][1] = -3;
matrix h_variable_6913[1][3] = concat(h_variable_6912,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6913); matrix h_variable_6914 = h_variable_l[1]; matrix h_variable_6915 = h_variable_l[2];
ncols(h_variable_6914);
matrix h_variable_6916 = DecideZeroRows(h_variable_6914,h_variable_58);
IsZeroMatrix(h_variable_6916);
ZeroRows(h_variable_6916);
nrows(h_variable_6915);
matrix h_variable_6918 = submat(h_variable_6914,1..1,intvec( 1 ));
matrix h_variable_6917 = DecideZeroRows(h_variable_6918,h_variable_58);
IsZeroMatrix(h_variable_6917);
IsIdentityMatrix(h_variable_6917);
matrix h_variable_6919[1][3] = concat(h_variable_6917,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6919); matrix h_variable_6920 = h_variable_l[1]; matrix h_variable_6921 = h_variable_l[2];
IsZeroMatrix(h_variable_6920);
matrix h_variable_6922 = DecideZeroRows(h_variable_6920,h_variable_58);
IsZeroMatrix(h_variable_6922);
def h_variable_6923 = h_variable_4814[15,23];
h_variable_6923;
matrix h_variable_6924[1][1] = 0;
matrix h_variable_6925[1][3] = concat(h_variable_6924,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6925); matrix h_variable_6926 = h_variable_l[1]; matrix h_variable_6927 = h_variable_l[2];
ncols(h_variable_6926);
matrix h_variable_6928 = DecideZeroRows(h_variable_6926,h_variable_58);
IsZeroMatrix(h_variable_6928);
nrows(h_variable_6927);
def h_variable_6929 = h_variable_4814[14,23];
h_variable_6929;
matrix h_variable_6930[1][1] = 3*x1-3*x3;
matrix h_variable_6931[1][3] = concat(h_variable_6930,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6931); matrix h_variable_6932 = h_variable_l[1]; matrix h_variable_6933 = h_variable_l[2];
ncols(h_variable_6932);
matrix h_variable_6934 = DecideZeroRows(h_variable_6932,h_variable_58);
IsZeroMatrix(h_variable_6934);
ZeroRows(h_variable_6934);
nrows(h_variable_6933);
matrix h_variable_6936 = submat(h_variable_6932,1..1,intvec( 2 ));
matrix h_variable_6935 = DecideZeroRows(h_variable_6936,h_variable_58);
IsZeroMatrix(h_variable_6935);
IsIdentityMatrix(h_variable_6935);
matrix h_variable_6937[1][3] = concat(h_variable_6935,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6937); matrix h_variable_6938 = h_variable_l[1]; matrix h_variable_6939 = h_variable_l[2];
IsZeroMatrix(h_variable_6938);
matrix h_variable_6940 = DecideZeroRows(h_variable_6938,h_variable_58);
IsZeroMatrix(h_variable_6940);
def h_variable_6941 = h_variable_4814[13,23];
h_variable_6941;
matrix h_variable_6942[1][1] = 0;
matrix h_variable_6943[1][3] = concat(h_variable_6942,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6943); matrix h_variable_6944 = h_variable_l[1]; matrix h_variable_6945 = h_variable_l[2];
ncols(h_variable_6944);
matrix h_variable_6946 = DecideZeroRows(h_variable_6944,h_variable_58);
IsZeroMatrix(h_variable_6946);
nrows(h_variable_6945);
def h_variable_6947 = h_variable_4814[12,23];
h_variable_6947;
matrix h_variable_6948[1][1] = -3*x2;
matrix h_variable_6949[1][3] = concat(h_variable_6948,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6949); matrix h_variable_6950 = h_variable_l[1]; matrix h_variable_6951 = h_variable_l[2];
ncols(h_variable_6950);
matrix h_variable_6952 = DecideZeroRows(h_variable_6950,h_variable_58);
IsZeroMatrix(h_variable_6952);
ZeroRows(h_variable_6952);
nrows(h_variable_6951);
matrix h_variable_6954 = submat(h_variable_6950,1..1,intvec( 2 ));
matrix h_variable_6953 = DecideZeroRows(h_variable_6954,h_variable_58);
IsZeroMatrix(h_variable_6953);
IsIdentityMatrix(h_variable_6953);
matrix h_variable_6955[1][3] = concat(h_variable_6953,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6955); matrix h_variable_6956 = h_variable_l[1]; matrix h_variable_6957 = h_variable_l[2];
IsZeroMatrix(h_variable_6956);
matrix h_variable_6958 = DecideZeroRows(h_variable_6956,h_variable_58);
IsZeroMatrix(h_variable_6958);
def h_variable_6959 = h_variable_4814[11,23];
h_variable_6959;
matrix h_variable_6960[1][1] = 0;
matrix h_variable_6961[1][3] = concat(h_variable_6960,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6961); matrix h_variable_6962 = h_variable_l[1]; matrix h_variable_6963 = h_variable_l[2];
ncols(h_variable_6962);
matrix h_variable_6964 = DecideZeroRows(h_variable_6962,h_variable_58);
IsZeroMatrix(h_variable_6964);
nrows(h_variable_6963);
def h_variable_6965 = h_variable_4814[10,23];
h_variable_6965;
matrix h_variable_6966[1][1] = 0;
matrix h_variable_6967[1][3] = concat(h_variable_6966,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6967); matrix h_variable_6968 = h_variable_l[1]; matrix h_variable_6969 = h_variable_l[2];
ncols(h_variable_6968);
matrix h_variable_6970 = DecideZeroRows(h_variable_6968,h_variable_58);
IsZeroMatrix(h_variable_6970);
nrows(h_variable_6969);
def h_variable_6971 = h_variable_4814[8,23];
h_variable_6971;
matrix h_variable_6972[1][1] = 3*x1*x3;
matrix h_variable_6973[1][3] = concat(h_variable_6972,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6973); matrix h_variable_6974 = h_variable_l[1]; matrix h_variable_6975 = h_variable_l[2];
ncols(h_variable_6974);
matrix h_variable_6976 = DecideZeroRows(h_variable_6974,h_variable_58);
IsZeroMatrix(h_variable_6976);
ZeroRows(h_variable_6976);
nrows(h_variable_6975);
matrix h_variable_6978 = submat(h_variable_6974,1..1,intvec( 2 ));
matrix h_variable_6977 = DecideZeroRows(h_variable_6978,h_variable_58);
IsZeroMatrix(h_variable_6977);
IsIdentityMatrix(h_variable_6977);
matrix h_variable_6979[1][3] = concat(h_variable_6977,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_6979); matrix h_variable_6980 = h_variable_l[1]; matrix h_variable_6981 = h_variable_l[2];
IsZeroMatrix(h_variable_6980);
matrix h_variable_6982 = DecideZeroRows(h_variable_6980,h_variable_58);
IsZeroMatrix(h_variable_6982);
def h_variable_6983 = h_variable_4814[2,23];
h_variable_6983;
matrix h_variable_6984[1][1] = 0;
matrix h_variable_6985[1][3] = concat(h_variable_6984,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6985); matrix h_variable_6986 = h_variable_l[1]; matrix h_variable_6987 = h_variable_l[2];
ncols(h_variable_6986);
matrix h_variable_6988 = DecideZeroRows(h_variable_6986,h_variable_58);
IsZeroMatrix(h_variable_6988);
nrows(h_variable_6987);
def h_variable_6989 = h_variable_4814[1,23];
h_variable_6989;
matrix h_variable_6990[1][1] = 0;
matrix h_variable_6991[1][3] = concat(h_variable_6990,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6991); matrix h_variable_6992 = h_variable_l[1]; matrix h_variable_6993 = h_variable_l[2];
ncols(h_variable_6992);
matrix h_variable_6994 = DecideZeroRows(h_variable_6992,h_variable_58);
IsZeroMatrix(h_variable_6994);
nrows(h_variable_6993);
def h_variable_6995 = h_variable_4814[16,24];
h_variable_6995;
matrix h_variable_6996[1][1] = -2;
matrix h_variable_6997[1][3] = concat(h_variable_6996,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_6997); matrix h_variable_6998 = h_variable_l[1]; matrix h_variable_6999 = h_variable_l[2];
ncols(h_variable_6998);
matrix h_variable_7000 = DecideZeroRows(h_variable_6998,h_variable_58);
IsZeroMatrix(h_variable_7000);
ZeroRows(h_variable_7000);
nrows(h_variable_6999);
kill h_variable_6424;kill h_variable_6426;kill h_variable_6427;kill h_variable_6428;kill h_variable_6429;kill h_variable_6430;kill h_variable_6432;kill h_variable_6433;kill h_variable_6434;kill h_variable_6435;kill h_variable_6436;kill h_variable_6437;kill h_variable_6438;kill h_variable_6439;kill h_variable_6440;kill h_variable_6441;kill h_variable_6442;kill h_variable_6443;kill h_variable_6444;kill h_variable_6445;kill h_variable_6446;kill h_variable_6447;kill h_variable_6448;kill h_variable_6449;kill h_variable_6450;kill h_variable_6451;kill h_variable_6452;kill h_variable_6453;kill h_variable_6454;kill h_variable_6455;kill h_variable_6456;kill h_variable_6457;kill h_variable_6458;kill h_variable_6459;kill h_variable_6460;kill h_variable_6461;kill h_variable_6462;kill h_variable_6463;kill h_variable_6464;kill h_variable_6465;kill h_variable_6466;kill h_variable_6467;kill h_variable_6468;kill h_variable_6469;kill h_variable_6470;kill h_variable_6471;kill h_variable_6472;kill h_variable_6473;kill h_variable_6474;kill h_variable_6475;kill h_variable_6476;kill h_variable_6477;kill h_variable_6478;kill h_variable_6479;kill h_variable_6480;kill h_variable_6481;kill h_variable_6482;kill h_variable_6483;kill h_variable_6484;kill h_variable_6485;kill h_variable_6486;kill h_variable_6487;kill h_variable_6488;kill h_variable_6489;kill h_variable_6490;kill h_variable_6491;kill h_variable_6492;kill h_variable_6493;kill h_variable_6494;kill h_variable_6495;kill h_variable_6496;kill h_variable_6497;kill h_variable_6498;kill h_variable_6499;kill h_variable_6500;kill h_variable_6501;kill h_variable_6502;kill h_variable_6503;kill h_variable_6504;kill h_variable_6505;kill h_variable_6506;kill h_variable_6507;kill h_variable_6508;kill h_variable_6509;kill h_variable_6510;kill h_variable_6511;kill h_variable_6512;kill h_variable_6513;kill h_variable_6514;kill h_variable_6515;kill h_variable_6516;kill h_variable_6517;kill h_variable_6518;kill h_variable_6519;kill h_variable_6520;kill h_variable_6521;kill h_variable_6522;kill h_variable_6523;kill h_variable_6524;kill h_variable_6525;kill h_variable_6526;kill h_variable_6527;kill h_variable_6528;kill h_variable_6529;kill h_variable_6530;kill h_variable_6531;kill h_variable_6532;kill h_variable_6533;kill h_variable_6534;kill h_variable_6535;kill h_variable_6536;kill h_variable_6537;kill h_variable_6538;kill h_variable_6539;kill h_variable_6540;kill h_variable_6541;kill h_variable_6542;kill h_variable_6543;kill h_variable_6544;kill h_variable_6545;kill h_variable_6546;kill h_variable_6553;kill h_variable_6554;kill h_variable_6556;kill h_variable_6557;kill h_variable_6558;kill h_variable_6559;kill h_variable_6560;kill h_variable_6561;kill h_variable_6562;kill h_variable_6563;kill h_variable_6564;kill h_variable_6565;kill h_variable_6566;kill h_variable_6567;kill h_variable_6568;kill h_variable_6569;kill h_variable_6570;kill h_variable_6571;kill h_variable_6572;kill h_variable_6573;kill h_variable_6574;kill h_variable_6575;kill h_variable_6576;kill h_variable_6577;kill h_variable_6578;kill h_variable_6579;kill h_variable_6580;kill h_variable_6581;kill h_variable_6582;kill h_variable_6583;kill h_variable_6584;kill h_variable_6585;kill h_variable_6586;kill h_variable_6587;kill h_variable_6588;kill h_variable_6589;kill h_variable_6590;kill h_variable_6591;kill h_variable_6592;kill h_variable_6593;kill h_variable_6594;kill h_variable_6595;kill h_variable_6596;kill h_variable_6597;kill h_variable_6598;kill h_variable_6599;kill h_variable_6600;kill h_variable_6601;kill h_variable_6602;kill h_variable_6603;kill h_variable_6604;kill h_variable_6605;kill h_variable_6606;kill h_variable_6607;kill h_variable_6608;kill h_variable_6609;kill h_variable_6610;kill h_variable_6611;kill h_variable_6612;kill h_variable_6613;kill h_variable_6614;kill h_variable_6615;kill h_variable_6616;kill h_variable_6617;kill h_variable_6618;kill h_variable_6619;kill h_variable_6620;kill h_variable_6621;kill h_variable_6622;kill h_variable_6623;kill h_variable_6624;kill h_variable_6625;kill h_variable_6626;kill h_variable_6627;kill h_variable_6628;kill h_variable_6629;kill h_variable_6630;kill h_variable_6631;kill h_variable_6632;kill h_variable_6633;kill h_variable_6634;kill h_variable_6635;kill h_variable_6636;kill h_variable_6637;kill h_variable_6638;kill h_variable_6639;kill h_variable_6640;kill h_variable_6641;kill h_variable_6642;kill h_variable_6643;kill h_variable_6644;kill h_variable_6645;kill h_variable_6646;kill h_variable_6647;kill h_variable_6648;kill h_variable_6649;kill h_variable_6650;kill h_variable_6651;kill h_variable_6652;kill h_variable_6653;kill h_variable_6654;kill h_variable_6655;kill h_variable_6656;kill h_variable_6657;kill h_variable_6658;kill h_variable_6659;kill h_variable_6660;kill h_variable_6661;kill h_variable_6662;kill h_variable_6663;kill h_variable_6664;kill h_variable_6665;kill h_variable_6666;kill h_variable_6667;kill h_variable_6668;kill h_variable_6669;kill h_variable_6670;kill h_variable_6671;kill h_variable_6672;kill h_variable_6673;kill h_variable_6674;kill h_variable_6675;kill h_variable_6676;kill h_variable_6677;kill h_variable_6678;kill h_variable_6679;kill h_variable_6680;kill h_variable_6681;kill h_variable_6682;kill h_variable_6683;kill h_variable_6684;kill h_variable_6685;kill h_variable_6686;kill h_variable_6687;kill h_variable_6688;kill h_variable_6689;kill h_variable_6690;kill h_variable_6691;kill h_variable_6692;kill h_variable_6693;kill h_variable_6694;kill h_variable_6695;kill h_variable_6696;kill h_variable_6697;kill h_variable_6698;kill h_variable_6699;kill h_variable_6700;kill h_variable_6701;kill h_variable_6702;kill h_variable_6703;kill h_variable_6704;kill h_variable_6705;kill h_variable_6706;kill h_variable_6707;kill h_variable_6708;kill h_variable_6709;kill h_variable_6710;kill h_variable_6711;kill h_variable_6712;kill h_variable_6713;kill h_variable_6714;kill h_variable_6715;kill h_variable_6716;kill h_variable_6717;kill h_variable_6718;kill h_variable_6719;kill h_variable_6720;kill h_variable_6721;kill h_variable_6722;kill h_variable_6723;kill h_variable_6724;kill h_variable_6725;kill h_variable_6726;kill h_variable_6727;kill h_variable_6728;kill h_variable_6729;kill h_variable_6730;kill h_variable_6731;kill h_variable_6732;kill h_variable_6733;kill h_variable_6734;kill h_variable_6735;kill h_variable_6736;kill h_variable_6737;kill h_variable_6738;kill h_variable_6739;kill h_variable_6740;kill h_variable_6741;kill h_variable_6742;kill h_variable_6743;kill h_variable_6744;kill h_variable_6745;kill h_variable_6746;kill h_variable_6747;kill h_variable_6748;kill h_variable_6749;kill h_variable_6750;kill h_variable_6751;kill h_variable_6752;kill h_variable_6753;kill h_variable_6754;kill h_variable_6763;kill h_variable_6764;kill h_variable_6765;kill h_variable_6766;kill h_variable_6768;kill h_variable_6769;kill h_variable_6770;kill h_variable_6771;kill h_variable_6772;kill h_variable_6774;kill h_variable_6778;kill h_variable_6780;kill h_variable_6781;kill h_variable_6782;kill h_variable_6783;kill h_variable_6784;kill h_variable_6785;kill h_variable_6786;kill h_variable_6787;kill h_variable_6788;kill h_variable_6789;kill h_variable_6790;kill h_variable_6791;kill h_variable_6792;kill h_variable_6793;kill h_variable_6794;kill h_variable_6795;kill h_variable_6796;kill h_variable_6797;kill h_variable_6798;kill h_variable_6799;kill h_variable_6800;kill h_variable_6801;kill h_variable_6802;kill h_variable_6803;kill h_variable_6804;kill h_variable_6805;kill h_variable_6806;kill h_variable_6807;kill h_variable_6808;kill h_variable_6809;kill h_variable_6810;kill h_variable_6811;kill h_variable_6812;kill h_variable_6813;kill h_variable_6814;kill h_variable_6815;kill h_variable_6816;kill h_variable_6817;kill h_variable_6818;kill h_variable_6819;kill h_variable_6820;kill h_variable_6821;kill h_variable_6822;kill h_variable_6823;kill h_variable_6824;kill h_variable_6825;kill h_variable_6826;kill h_variable_6827;kill h_variable_6828;kill h_variable_6829;kill h_variable_6830;kill h_variable_6831;kill h_variable_6832;kill h_variable_6833;kill h_variable_6834;kill h_variable_6835;kill h_variable_6836;kill h_variable_6837;kill h_variable_6838;kill h_variable_6839;kill h_variable_6840;kill h_variable_6841;kill h_variable_6842;kill h_variable_6843;kill h_variable_6844;kill h_variable_6845;kill h_variable_6846;kill h_variable_6847;kill h_variable_6848;kill h_variable_6849;kill h_variable_6850;kill h_variable_6851;kill h_variable_6852;kill h_variable_6853;kill h_variable_6854;kill h_variable_6855;kill h_variable_6856;kill h_variable_6857;kill h_variable_6858;kill h_variable_6859;kill h_variable_6860;kill h_variable_6861;kill h_variable_6862;kill h_variable_6863;kill h_variable_6864;kill h_variable_6865;kill h_variable_6866;kill h_variable_6867;kill h_variable_6868;kill h_variable_6869;kill h_variable_6870;kill h_variable_6871;kill h_variable_6872;kill h_variable_6873;kill h_variable_6874;kill h_variable_6875;kill h_variable_6876;kill h_variable_6877;kill h_variable_6878;kill h_variable_6879;kill h_variable_6880;kill h_variable_6881;kill h_variable_6882;kill h_variable_6883;kill h_variable_6884;kill h_variable_6885;kill h_variable_6886;kill h_variable_6887;kill h_variable_6888;kill h_variable_6889;kill h_variable_6890;kill h_variable_6891;kill h_variable_6892;kill h_variable_6893;kill h_variable_6894;kill h_variable_6895;kill h_variable_6896;kill h_variable_6897;kill h_variable_6898;kill h_variable_6899;kill h_variable_6900;kill h_variable_6901;kill h_variable_6902;kill h_variable_6903;kill h_variable_6904;kill h_variable_6905;kill h_variable_6906;kill h_variable_6907;kill h_variable_6908;kill h_variable_6909;kill h_variable_6910;kill h_variable_6911;kill h_variable_6912;kill h_variable_6913;kill h_variable_6914;kill h_variable_6915;kill h_variable_6916;kill h_variable_6917;kill h_variable_6918;kill h_variable_6919;kill h_variable_6920;kill h_variable_6921;kill h_variable_6922;kill h_variable_6923;kill h_variable_6924;kill h_variable_6925;kill h_variable_6926;kill h_variable_6927;kill h_variable_6928;kill h_variable_6929;kill h_variable_6930;kill h_variable_6931;kill h_variable_6932;kill h_variable_6933;kill h_variable_6934;kill h_variable_6935;kill h_variable_6936;kill h_variable_6937;kill h_variable_6938;kill h_variable_6939;kill h_variable_6940;kill h_variable_6941;kill h_variable_6942;kill h_variable_6943;kill h_variable_6944;kill h_variable_6945;kill h_variable_6946;kill h_variable_6949;kill h_variable_6952;kill h_variable_6954;
matrix h_variable_7002 = submat(h_variable_6998,1..1,intvec( 1 ));
matrix h_variable_7001 = DecideZeroRows(h_variable_7002,h_variable_58);
IsZeroMatrix(h_variable_7001);
IsIdentityMatrix(h_variable_7001);
matrix h_variable_7003[1][3] = concat(h_variable_7001,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7003); matrix h_variable_7004 = h_variable_l[1]; matrix h_variable_7005 = h_variable_l[2];
IsZeroMatrix(h_variable_7004);
matrix h_variable_7006 = DecideZeroRows(h_variable_7004,h_variable_58);
IsZeroMatrix(h_variable_7006);
def h_variable_7007 = h_variable_4814[15,24];
h_variable_7007;
matrix h_variable_7008[1][1] = -4;
matrix h_variable_7009[1][3] = concat(h_variable_7008,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7009); matrix h_variable_7010 = h_variable_l[1]; matrix h_variable_7011 = h_variable_l[2];
ncols(h_variable_7010);
matrix h_variable_7012 = DecideZeroRows(h_variable_7010,h_variable_58);
IsZeroMatrix(h_variable_7012);
ZeroRows(h_variable_7012);
nrows(h_variable_7011);
matrix h_variable_7014 = submat(h_variable_7010,1..1,intvec( 1 ));
matrix h_variable_7013 = DecideZeroRows(h_variable_7014,h_variable_58);
IsZeroMatrix(h_variable_7013);
IsIdentityMatrix(h_variable_7013);
matrix h_variable_7015[1][3] = concat(h_variable_7013,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7015); matrix h_variable_7016 = h_variable_l[1]; matrix h_variable_7017 = h_variable_l[2];
IsZeroMatrix(h_variable_7016);
matrix h_variable_7018 = DecideZeroRows(h_variable_7016,h_variable_58);
IsZeroMatrix(h_variable_7018);
def h_variable_7019 = h_variable_4814[14,24];
h_variable_7019;
matrix h_variable_7020[1][1] = x1+3*x3;
matrix h_variable_7021[1][3] = concat(h_variable_7020,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7021); matrix h_variable_7022 = h_variable_l[1]; matrix h_variable_7023 = h_variable_l[2];
ncols(h_variable_7022);
matrix h_variable_7024 = DecideZeroRows(h_variable_7022,h_variable_58);
IsZeroMatrix(h_variable_7024);
ZeroRows(h_variable_7024);
nrows(h_variable_7023);
matrix h_variable_7026 = submat(h_variable_7022,1..1,intvec( 2 ));
matrix h_variable_7025 = DecideZeroRows(h_variable_7026,h_variable_58);
IsZeroMatrix(h_variable_7025);
IsIdentityMatrix(h_variable_7025);
matrix h_variable_7027[1][3] = concat(h_variable_7025,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7027); matrix h_variable_7028 = h_variable_l[1]; matrix h_variable_7029 = h_variable_l[2];
IsZeroMatrix(h_variable_7028);
matrix h_variable_7030 = DecideZeroRows(h_variable_7028,h_variable_58);
IsZeroMatrix(h_variable_7030);
def h_variable_7031 = h_variable_4814[13,24];
h_variable_7031;
matrix h_variable_7032[1][1] = -3*x1;
matrix h_variable_7033[1][3] = concat(h_variable_7032,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7033); matrix h_variable_7034 = h_variable_l[1]; matrix h_variable_7035 = h_variable_l[2];
ncols(h_variable_7034);
matrix h_variable_7036 = DecideZeroRows(h_variable_7034,h_variable_58);
IsZeroMatrix(h_variable_7036);
ZeroRows(h_variable_7036);
nrows(h_variable_7035);
matrix h_variable_7038 = submat(h_variable_7034,1..1,intvec( 2 ));
matrix h_variable_7037 = DecideZeroRows(h_variable_7038,h_variable_58);
IsZeroMatrix(h_variable_7037);
IsIdentityMatrix(h_variable_7037);
matrix h_variable_7039[1][3] = concat(h_variable_7037,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7039); matrix h_variable_7040 = h_variable_l[1]; matrix h_variable_7041 = h_variable_l[2];
IsZeroMatrix(h_variable_7040);
matrix h_variable_7042 = DecideZeroRows(h_variable_7040,h_variable_58);
IsZeroMatrix(h_variable_7042);
def h_variable_7043 = h_variable_4814[12,24];
h_variable_7043;
matrix h_variable_7044[1][1] = x2+5*x3;
matrix h_variable_7045[1][3] = concat(h_variable_7044,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7045); matrix h_variable_7046 = h_variable_l[1]; matrix h_variable_7047 = h_variable_l[2];
ncols(h_variable_7046);
matrix h_variable_7048 = DecideZeroRows(h_variable_7046,h_variable_58);
IsZeroMatrix(h_variable_7048);
ZeroRows(h_variable_7048);
nrows(h_variable_7047);
matrix h_variable_7050 = submat(h_variable_7046,1..1,intvec( 2 ));
matrix h_variable_7049 = DecideZeroRows(h_variable_7050,h_variable_58);
IsZeroMatrix(h_variable_7049);
IsIdentityMatrix(h_variable_7049);
matrix h_variable_7051[1][3] = concat(h_variable_7049,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7051); matrix h_variable_7052 = h_variable_l[1]; matrix h_variable_7053 = h_variable_l[2];
IsZeroMatrix(h_variable_7052);
matrix h_variable_7054 = DecideZeroRows(h_variable_7052,h_variable_58);
IsZeroMatrix(h_variable_7054);
def h_variable_7055 = h_variable_4814[11,24];
h_variable_7055;
matrix h_variable_7056[1][1] = -4*x3^2;
matrix h_variable_7057[1][3] = concat(h_variable_7056,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7057); matrix h_variable_7058 = h_variable_l[1]; matrix h_variable_7059 = h_variable_l[2];
ncols(h_variable_7058);
matrix h_variable_7060 = DecideZeroRows(h_variable_7058,h_variable_58);
IsZeroMatrix(h_variable_7060);
ZeroRows(h_variable_7060);
nrows(h_variable_7059);
matrix h_variable_7062 = submat(h_variable_7058,1..1,intvec( 2 ));
matrix h_variable_7061 = DecideZeroRows(h_variable_7062,h_variable_58);
IsZeroMatrix(h_variable_7061);
IsIdentityMatrix(h_variable_7061);
matrix h_variable_7063[1][3] = concat(h_variable_7061,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7063); matrix h_variable_7064 = h_variable_l[1]; matrix h_variable_7065 = h_variable_l[2];
IsZeroMatrix(h_variable_7064);
matrix h_variable_7066 = DecideZeroRows(h_variable_7064,h_variable_58);
IsZeroMatrix(h_variable_7066);
def h_variable_7067 = h_variable_4814[10,24];
h_variable_7067;
matrix h_variable_7068[1][1] = 0;
matrix h_variable_7069[1][3] = concat(h_variable_7068,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7069); matrix h_variable_7070 = h_variable_l[1]; matrix h_variable_7071 = h_variable_l[2];
ncols(h_variable_7070);
matrix h_variable_7072 = DecideZeroRows(h_variable_7070,h_variable_58);
IsZeroMatrix(h_variable_7072);
nrows(h_variable_7071);
def h_variable_7073 = h_variable_4814[8,24];
h_variable_7073;
matrix h_variable_7074[1][1] = -3*x3^2;
matrix h_variable_7075[1][3] = concat(h_variable_7074,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7075); matrix h_variable_7076 = h_variable_l[1]; matrix h_variable_7077 = h_variable_l[2];
ncols(h_variable_7076);
matrix h_variable_7078 = DecideZeroRows(h_variable_7076,h_variable_58);
IsZeroMatrix(h_variable_7078);
ZeroRows(h_variable_7078);
nrows(h_variable_7077);
matrix h_variable_7080 = submat(h_variable_7076,1..1,intvec( 2 ));
matrix h_variable_7079 = DecideZeroRows(h_variable_7080,h_variable_58);
IsZeroMatrix(h_variable_7079);
IsIdentityMatrix(h_variable_7079);
matrix h_variable_7081[1][3] = concat(h_variable_7079,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7081); matrix h_variable_7082 = h_variable_l[1]; matrix h_variable_7083 = h_variable_l[2];
IsZeroMatrix(h_variable_7082);
matrix h_variable_7084 = DecideZeroRows(h_variable_7082,h_variable_58);
IsZeroMatrix(h_variable_7084);
def h_variable_7085 = h_variable_4814[2,24];
h_variable_7085;
matrix h_variable_7086[1][1] = 0;
matrix h_variable_7087[1][3] = concat(h_variable_7086,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7087); matrix h_variable_7088 = h_variable_l[1]; matrix h_variable_7089 = h_variable_l[2];
ncols(h_variable_7088);
matrix h_variable_7090 = DecideZeroRows(h_variable_7088,h_variable_58);
IsZeroMatrix(h_variable_7090);
nrows(h_variable_7089);
def h_variable_7091 = h_variable_4814[1,24];
h_variable_7091;
matrix h_variable_7092[1][1] = 0;
matrix h_variable_7093[1][3] = concat(h_variable_7092,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7093); matrix h_variable_7094 = h_variable_l[1]; matrix h_variable_7095 = h_variable_l[2];
ncols(h_variable_7094);
matrix h_variable_7096 = DecideZeroRows(h_variable_7094,h_variable_58);
IsZeroMatrix(h_variable_7096);
nrows(h_variable_7095);
def h_variable_7097 = h_variable_4814[16,25];
h_variable_7097;
matrix h_variable_7098[1][1] = 0;
matrix h_variable_7099[1][3] = concat(h_variable_7098,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7099); matrix h_variable_7100 = h_variable_l[1]; matrix h_variable_7101 = h_variable_l[2];
ncols(h_variable_7100);
matrix h_variable_7102 = DecideZeroRows(h_variable_7100,h_variable_58);
IsZeroMatrix(h_variable_7102);
nrows(h_variable_7101);
def h_variable_7103 = h_variable_4814[15,25];
h_variable_7103;
matrix h_variable_7104[1][1] = 0;
matrix h_variable_7105[1][3] = concat(h_variable_7104,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7105); matrix h_variable_7106 = h_variable_l[1]; matrix h_variable_7107 = h_variable_l[2];
ncols(h_variable_7106);
matrix h_variable_7108 = DecideZeroRows(h_variable_7106,h_variable_58);
IsZeroMatrix(h_variable_7108);
nrows(h_variable_7107);
def h_variable_7109 = h_variable_4814[14,25];
h_variable_7109;
matrix h_variable_7110[1][1] = 0;
matrix h_variable_7111[1][3] = concat(h_variable_7110,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7111); matrix h_variable_7112 = h_variable_l[1]; matrix h_variable_7113 = h_variable_l[2];
ncols(h_variable_7112);
matrix h_variable_7114 = DecideZeroRows(h_variable_7112,h_variable_58);
IsZeroMatrix(h_variable_7114);
nrows(h_variable_7113);
def h_variable_7115 = h_variable_4814[13,25];
h_variable_7115;
matrix h_variable_7116[1][1] = 0;
matrix h_variable_7117[1][3] = concat(h_variable_7116,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7117); matrix h_variable_7118 = h_variable_l[1]; matrix h_variable_7119 = h_variable_l[2];
ncols(h_variable_7118);
matrix h_variable_7120 = DecideZeroRows(h_variable_7118,h_variable_58);
IsZeroMatrix(h_variable_7120);
nrows(h_variable_7119);
def h_variable_7121 = h_variable_4814[12,25];
h_variable_7121;
matrix h_variable_7122[1][1] = 0;
matrix h_variable_7123[1][3] = concat(h_variable_7122,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7123); matrix h_variable_7124 = h_variable_l[1]; matrix h_variable_7125 = h_variable_l[2];
ncols(h_variable_7124);
matrix h_variable_7126 = DecideZeroRows(h_variable_7124,h_variable_58);
IsZeroMatrix(h_variable_7126);
nrows(h_variable_7125);
def h_variable_7127 = h_variable_4814[11,25];
h_variable_7127;
matrix h_variable_7128[1][1] = 0;
matrix h_variable_7129[1][3] = concat(h_variable_7128,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7129); matrix h_variable_7130 = h_variable_l[1]; matrix h_variable_7131 = h_variable_l[2];
ncols(h_variable_7130);
matrix h_variable_7132 = DecideZeroRows(h_variable_7130,h_variable_58);
IsZeroMatrix(h_variable_7132);
nrows(h_variable_7131);
def h_variable_7133 = h_variable_4814[10,25];
h_variable_7133;
matrix h_variable_7134[1][1] = 3;
matrix h_variable_7135[1][3] = concat(h_variable_7134,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7135); matrix h_variable_7136 = h_variable_l[1]; matrix h_variable_7137 = h_variable_l[2];
ncols(h_variable_7136);
matrix h_variable_7138 = DecideZeroRows(h_variable_7136,h_variable_58);
IsZeroMatrix(h_variable_7138);
ZeroRows(h_variable_7138);
nrows(h_variable_7137);
matrix h_variable_7140 = submat(h_variable_7136,1..1,intvec( 1 ));
matrix h_variable_7139 = DecideZeroRows(h_variable_7140,h_variable_58);
IsZeroMatrix(h_variable_7139);
IsIdentityMatrix(h_variable_7139);
matrix h_variable_7141[1][3] = concat(h_variable_7139,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7141); matrix h_variable_7142 = h_variable_l[1]; matrix h_variable_7143 = h_variable_l[2];
IsZeroMatrix(h_variable_7142);
matrix h_variable_7144 = DecideZeroRows(h_variable_7142,h_variable_58);
IsZeroMatrix(h_variable_7144);
def h_variable_7145 = h_variable_4814[8,25];
h_variable_7145;
matrix h_variable_7146[1][1] = 3;
matrix h_variable_7147[1][3] = concat(h_variable_7146,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7147); matrix h_variable_7148 = h_variable_l[1]; matrix h_variable_7149 = h_variable_l[2];
ncols(h_variable_7148);
matrix h_variable_7150 = DecideZeroRows(h_variable_7148,h_variable_58);
IsZeroMatrix(h_variable_7150);
ZeroRows(h_variable_7150);
nrows(h_variable_7149);
matrix h_variable_7152 = submat(h_variable_7148,1..1,intvec( 1 ));
matrix h_variable_7151 = DecideZeroRows(h_variable_7152,h_variable_58);
IsZeroMatrix(h_variable_7151);
IsIdentityMatrix(h_variable_7151);
matrix h_variable_7153[1][3] = concat(h_variable_7151,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7153); matrix h_variable_7154 = h_variable_l[1]; matrix h_variable_7155 = h_variable_l[2];
IsZeroMatrix(h_variable_7154);
matrix h_variable_7156 = DecideZeroRows(h_variable_7154,h_variable_58);
IsZeroMatrix(h_variable_7156);
def h_variable_7157 = h_variable_4814[2,25];
h_variable_7157;
matrix h_variable_7158[1][1] = 0;
matrix h_variable_7159[1][3] = concat(h_variable_7158,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7159); matrix h_variable_7160 = h_variable_l[1]; matrix h_variable_7161 = h_variable_l[2];
ncols(h_variable_7160);
matrix h_variable_7162 = DecideZeroRows(h_variable_7160,h_variable_58);
IsZeroMatrix(h_variable_7162);
nrows(h_variable_7161);
def h_variable_7163 = h_variable_4814[1,25];
h_variable_7163;
matrix h_variable_7164[1][1] = 0;
matrix h_variable_7165[1][3] = concat(h_variable_7164,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7165); matrix h_variable_7166 = h_variable_l[1]; matrix h_variable_7167 = h_variable_l[2];
ncols(h_variable_7166);
matrix h_variable_7168 = DecideZeroRows(h_variable_7166,h_variable_58);
IsZeroMatrix(h_variable_7168);
nrows(h_variable_7167);
def h_variable_7169 = h_variable_4814[16,26];
h_variable_7169;
matrix h_variable_7170[1][1] = 0;
matrix h_variable_7171[1][3] = concat(h_variable_7170,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7171); matrix h_variable_7172 = h_variable_l[1]; matrix h_variable_7173 = h_variable_l[2];
ncols(h_variable_7172);
matrix h_variable_7174 = DecideZeroRows(h_variable_7172,h_variable_58);
IsZeroMatrix(h_variable_7174);
nrows(h_variable_7173);
def h_variable_7175 = h_variable_4814[15,26];
h_variable_7175;
matrix h_variable_7176[1][1] = 0;
matrix h_variable_7177[1][3] = concat(h_variable_7176,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7177); matrix h_variable_7178 = h_variable_l[1]; matrix h_variable_7179 = h_variable_l[2];
ncols(h_variable_7178);
matrix h_variable_7180 = DecideZeroRows(h_variable_7178,h_variable_58);
IsZeroMatrix(h_variable_7180);
nrows(h_variable_7179);
def h_variable_7181 = h_variable_4814[14,26];
h_variable_7181;
matrix h_variable_7182[1][1] = 0;
matrix h_variable_7183[1][3] = concat(h_variable_7182,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7183); matrix h_variable_7184 = h_variable_l[1]; matrix h_variable_7185 = h_variable_l[2];
ncols(h_variable_7184);
matrix h_variable_7186 = DecideZeroRows(h_variable_7184,h_variable_58);
IsZeroMatrix(h_variable_7186);
nrows(h_variable_7185);
def h_variable_7187 = h_variable_4814[13,26];
h_variable_7187;
matrix h_variable_7188[1][1] = 0;
matrix h_variable_7189[1][3] = concat(h_variable_7188,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7189); matrix h_variable_7190 = h_variable_l[1]; matrix h_variable_7191 = h_variable_l[2];
ncols(h_variable_7190);
matrix h_variable_7192 = DecideZeroRows(h_variable_7190,h_variable_58);
IsZeroMatrix(h_variable_7192);
nrows(h_variable_7191);
def h_variable_7193 = h_variable_4814[12,26];
h_variable_7193;
matrix h_variable_7194[1][1] = 0;
matrix h_variable_7195[1][3] = concat(h_variable_7194,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7195); matrix h_variable_7196 = h_variable_l[1]; matrix h_variable_7197 = h_variable_l[2];
ncols(h_variable_7196);
matrix h_variable_7198 = DecideZeroRows(h_variable_7196,h_variable_58);
IsZeroMatrix(h_variable_7198);
nrows(h_variable_7197);
def h_variable_7199 = h_variable_4814[11,26];
h_variable_7199;
matrix h_variable_7200[1][1] = 0;
matrix h_variable_7201[1][3] = concat(h_variable_7200,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7201); matrix h_variable_7202 = h_variable_l[1]; matrix h_variable_7203 = h_variable_l[2];
ncols(h_variable_7202);
matrix h_variable_7204 = DecideZeroRows(h_variable_7202,h_variable_58);
IsZeroMatrix(h_variable_7204);
nrows(h_variable_7203);
def h_variable_7205 = h_variable_4814[10,26];
h_variable_7205;
matrix h_variable_7206[1][1] = 3*a7;
matrix h_variable_7207[1][3] = concat(h_variable_7206,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7207); matrix h_variable_7208 = h_variable_l[1]; matrix h_variable_7209 = h_variable_l[2];
ncols(h_variable_7208);
matrix h_variable_7210 = DecideZeroRows(h_variable_7208,h_variable_58);
IsZeroMatrix(h_variable_7210);
ZeroRows(h_variable_7210);
nrows(h_variable_7209);
matrix h_variable_7212 = submat(h_variable_7208,1..1,intvec( 1 ));
matrix h_variable_7211 = DecideZeroRows(h_variable_7212,h_variable_58);
IsZeroMatrix(h_variable_7211);
IsIdentityMatrix(h_variable_7211);
matrix h_variable_7213[1][3] = concat(h_variable_7211,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7213); matrix h_variable_7214 = h_variable_l[1]; matrix h_variable_7215 = h_variable_l[2];
IsZeroMatrix(h_variable_7214);
matrix h_variable_7216 = DecideZeroRows(h_variable_7214,h_variable_58);
IsZeroMatrix(h_variable_7216);
def h_variable_7217 = h_variable_4814[8,26];
h_variable_7217;
matrix h_variable_7218[1][1] = 0;
matrix h_variable_7219[1][3] = concat(h_variable_7218,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7219); matrix h_variable_7220 = h_variable_l[1]; matrix h_variable_7221 = h_variable_l[2];
ncols(h_variable_7220);
matrix h_variable_7222 = DecideZeroRows(h_variable_7220,h_variable_58);
IsZeroMatrix(h_variable_7222);
nrows(h_variable_7221);
def h_variable_7223 = h_variable_4814[2,26];
h_variable_7223;
matrix h_variable_7224[1][1] = 0;
matrix h_variable_7225[1][3] = concat(h_variable_7224,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7225); matrix h_variable_7226 = h_variable_l[1]; matrix h_variable_7227 = h_variable_l[2];
ncols(h_variable_7226);
matrix h_variable_7228 = DecideZeroRows(h_variable_7226,h_variable_58);
IsZeroMatrix(h_variable_7228);
nrows(h_variable_7227);
def h_variable_7229 = h_variable_4814[1,26];
h_variable_7229;
matrix h_variable_7230[1][1] = 0;
matrix h_variable_7231[1][3] = concat(h_variable_7230,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7231); matrix h_variable_7232 = h_variable_l[1]; matrix h_variable_7233 = h_variable_l[2];
ncols(h_variable_7232);
matrix h_variable_7234 = DecideZeroRows(h_variable_7232,h_variable_58);
IsZeroMatrix(h_variable_7234);
nrows(h_variable_7233);
def h_variable_7235 = h_variable_4814[16,27];
h_variable_7235;
matrix h_variable_7236[1][1] = 0;
matrix h_variable_7237[1][3] = concat(h_variable_7236,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7237); matrix h_variable_7238 = h_variable_l[1]; matrix h_variable_7239 = h_variable_l[2];
ncols(h_variable_7238);
matrix h_variable_7240 = DecideZeroRows(h_variable_7238,h_variable_58);
IsZeroMatrix(h_variable_7240);
nrows(h_variable_7239);
def h_variable_7241 = h_variable_4814[15,27];
h_variable_7241;
matrix h_variable_7242[1][1] = 0;
matrix h_variable_7243[1][3] = concat(h_variable_7242,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7243); matrix h_variable_7244 = h_variable_l[1]; matrix h_variable_7245 = h_variable_l[2];
ncols(h_variable_7244);
matrix h_variable_7246 = DecideZeroRows(h_variable_7244,h_variable_58);
IsZeroMatrix(h_variable_7246);
nrows(h_variable_7245);
def h_variable_7247 = h_variable_4814[14,27];
h_variable_7247;
matrix h_variable_7248[1][1] = -3;
matrix h_variable_7249[1][3] = concat(h_variable_7248,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7249); matrix h_variable_7250 = h_variable_l[1]; matrix h_variable_7251 = h_variable_l[2];
ncols(h_variable_7250);
matrix h_variable_7252 = DecideZeroRows(h_variable_7250,h_variable_58);
IsZeroMatrix(h_variable_7252);
ZeroRows(h_variable_7252);
nrows(h_variable_7251);
matrix h_variable_7254 = submat(h_variable_7250,1..1,intvec( 1 ));
matrix h_variable_7253 = DecideZeroRows(h_variable_7254,h_variable_58);
IsZeroMatrix(h_variable_7253);
IsIdentityMatrix(h_variable_7253);
matrix h_variable_7255[1][3] = concat(h_variable_7253,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7255); matrix h_variable_7256 = h_variable_l[1]; matrix h_variable_7257 = h_variable_l[2];
IsZeroMatrix(h_variable_7256);
matrix h_variable_7258 = DecideZeroRows(h_variable_7256,h_variable_58);
IsZeroMatrix(h_variable_7258);
def h_variable_7259 = h_variable_4814[13,27];
h_variable_7259;
matrix h_variable_7260[1][1] = -3;
matrix h_variable_7261[1][3] = concat(h_variable_7260,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7261); matrix h_variable_7262 = h_variable_l[1]; matrix h_variable_7263 = h_variable_l[2];
ncols(h_variable_7262);
matrix h_variable_7264 = DecideZeroRows(h_variable_7262,h_variable_58);
IsZeroMatrix(h_variable_7264);
ZeroRows(h_variable_7264);
nrows(h_variable_7263);
matrix h_variable_7266 = submat(h_variable_7262,1..1,intvec( 1 ));
matrix h_variable_7265 = DecideZeroRows(h_variable_7266,h_variable_58);
IsZeroMatrix(h_variable_7265);
IsIdentityMatrix(h_variable_7265);
matrix h_variable_7267[1][3] = concat(h_variable_7265,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7267); matrix h_variable_7268 = h_variable_l[1]; matrix h_variable_7269 = h_variable_l[2];
IsZeroMatrix(h_variable_7268);
matrix h_variable_7270 = DecideZeroRows(h_variable_7268,h_variable_58);
IsZeroMatrix(h_variable_7270);
def h_variable_7271 = h_variable_4814[12,27];
h_variable_7271;
matrix h_variable_7272[1][1] = -3;
matrix h_variable_7273[1][3] = concat(h_variable_7272,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7273); matrix h_variable_7274 = h_variable_l[1]; matrix h_variable_7275 = h_variable_l[2];
ncols(h_variable_7274);
matrix h_variable_7276 = DecideZeroRows(h_variable_7274,h_variable_58);
IsZeroMatrix(h_variable_7276);
ZeroRows(h_variable_7276);
nrows(h_variable_7275);
matrix h_variable_7278 = submat(h_variable_7274,1..1,intvec( 1 ));
matrix h_variable_7277 = DecideZeroRows(h_variable_7278,h_variable_58);
IsZeroMatrix(h_variable_7277);
IsIdentityMatrix(h_variable_7277);
matrix h_variable_7279[1][3] = concat(h_variable_7277,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7279); matrix h_variable_7280 = h_variable_l[1]; matrix h_variable_7281 = h_variable_l[2];
IsZeroMatrix(h_variable_7280);
matrix h_variable_7282 = DecideZeroRows(h_variable_7280,h_variable_58);
IsZeroMatrix(h_variable_7282);
def h_variable_7283 = h_variable_4814[11,27];
h_variable_7283;
matrix h_variable_7284[1][1] = 0;
matrix h_variable_7285[1][3] = concat(h_variable_7284,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7285); matrix h_variable_7286 = h_variable_l[1]; matrix h_variable_7287 = h_variable_l[2];
ncols(h_variable_7286);
matrix h_variable_7288 = DecideZeroRows(h_variable_7286,h_variable_58);
IsZeroMatrix(h_variable_7288);
nrows(h_variable_7287);
def h_variable_7289 = h_variable_4814[10,27];
h_variable_7289;
matrix h_variable_7290[1][1] = -3*x3;
matrix h_variable_7291[1][3] = concat(h_variable_7290,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7291); matrix h_variable_7292 = h_variable_l[1]; matrix h_variable_7293 = h_variable_l[2];
ncols(h_variable_7292);
matrix h_variable_7294 = DecideZeroRows(h_variable_7292,h_variable_58);
IsZeroMatrix(h_variable_7294);
ZeroRows(h_variable_7294);
nrows(h_variable_7293);
matrix h_variable_7296 = submat(h_variable_7292,1..1,intvec( 2 ));
matrix h_variable_7295 = DecideZeroRows(h_variable_7296,h_variable_58);
IsZeroMatrix(h_variable_7295);
IsIdentityMatrix(h_variable_7295);
matrix h_variable_7297[1][3] = concat(h_variable_7295,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7297); matrix h_variable_7298 = h_variable_l[1]; matrix h_variable_7299 = h_variable_l[2];
IsZeroMatrix(h_variable_7298);
matrix h_variable_7300 = DecideZeroRows(h_variable_7298,h_variable_58);
IsZeroMatrix(h_variable_7300);
def h_variable_7301 = h_variable_4814[8,27];
h_variable_7301;
matrix h_variable_7302[1][1] = -3*x1;
matrix h_variable_7303[1][3] = concat(h_variable_7302,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7303); matrix h_variable_7304 = h_variable_l[1]; matrix h_variable_7305 = h_variable_l[2];
ncols(h_variable_7304);
matrix h_variable_7306 = DecideZeroRows(h_variable_7304,h_variable_58);
IsZeroMatrix(h_variable_7306);
ZeroRows(h_variable_7306);
nrows(h_variable_7305);
matrix h_variable_7308 = submat(h_variable_7304,1..1,intvec( 2 ));
matrix h_variable_7307 = DecideZeroRows(h_variable_7308,h_variable_58);
IsZeroMatrix(h_variable_7307);
IsIdentityMatrix(h_variable_7307);
matrix h_variable_7309[1][3] = concat(h_variable_7307,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7309); matrix h_variable_7310 = h_variable_l[1]; matrix h_variable_7311 = h_variable_l[2];
IsZeroMatrix(h_variable_7310);
matrix h_variable_7312 = DecideZeroRows(h_variable_7310,h_variable_58);
IsZeroMatrix(h_variable_7312);
def h_variable_7313 = h_variable_4814[2,27];
h_variable_7313;
matrix h_variable_7314[1][1] = 0;
matrix h_variable_7315[1][3] = concat(h_variable_7314,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7315); matrix h_variable_7316 = h_variable_l[1]; matrix h_variable_7317 = h_variable_l[2];
ncols(h_variable_7316);
matrix h_variable_7318 = DecideZeroRows(h_variable_7316,h_variable_58);
IsZeroMatrix(h_variable_7318);
nrows(h_variable_7317);
def h_variable_7319 = h_variable_4814[1,27];
h_variable_7319;
matrix h_variable_7320[1][1] = 0;
matrix h_variable_7321[1][3] = concat(h_variable_7320,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7321); matrix h_variable_7322 = h_variable_l[1]; matrix h_variable_7323 = h_variable_l[2];
ncols(h_variable_7322);
matrix h_variable_7324 = DecideZeroRows(h_variable_7322,h_variable_58);
IsZeroMatrix(h_variable_7324);
nrows(h_variable_7323);
def h_variable_7325 = h_variable_4814[16,28];
h_variable_7325;
matrix h_variable_7326[1][1] = 3;
matrix h_variable_7327[1][3] = concat(h_variable_7326,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7327); matrix h_variable_7328 = h_variable_l[1]; matrix h_variable_7329 = h_variable_l[2];
ncols(h_variable_7328);
matrix h_variable_7330 = DecideZeroRows(h_variable_7328,h_variable_58);
IsZeroMatrix(h_variable_7330);
ZeroRows(h_variable_7330);
nrows(h_variable_7329);
matrix h_variable_7332 = submat(h_variable_7328,1..1,intvec( 1 ));
matrix h_variable_7331 = DecideZeroRows(h_variable_7332,h_variable_58);
IsZeroMatrix(h_variable_7331);
IsIdentityMatrix(h_variable_7331);
matrix h_variable_7333[1][3] = concat(h_variable_7331,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7333); matrix h_variable_7334 = h_variable_l[1]; matrix h_variable_7335 = h_variable_l[2];
IsZeroMatrix(h_variable_7334);
matrix h_variable_7336 = DecideZeroRows(h_variable_7334,h_variable_58);
IsZeroMatrix(h_variable_7336);
def h_variable_7337 = h_variable_4814[15,28];
h_variable_7337;
matrix h_variable_7338[1][1] = 0;
matrix h_variable_7339[1][3] = concat(h_variable_7338,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7339); matrix h_variable_7340 = h_variable_l[1]; matrix h_variable_7341 = h_variable_l[2];
ncols(h_variable_7340);
matrix h_variable_7342 = DecideZeroRows(h_variable_7340,h_variable_58);
IsZeroMatrix(h_variable_7342);
nrows(h_variable_7341);
def h_variable_7343 = h_variable_4814[14,28];
h_variable_7343;
matrix h_variable_7344[1][1] = 0;
matrix h_variable_7345[1][3] = concat(h_variable_7344,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7345); matrix h_variable_7346 = h_variable_l[1]; matrix h_variable_7347 = h_variable_l[2];
ncols(h_variable_7346);
matrix h_variable_7348 = DecideZeroRows(h_variable_7346,h_variable_58);
IsZeroMatrix(h_variable_7348);
nrows(h_variable_7347);
def h_variable_7349 = h_variable_4814[13,28];
h_variable_7349;
matrix h_variable_7350[1][1] = 3*x2+3*x3;
matrix h_variable_7351[1][3] = concat(h_variable_7350,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7351); matrix h_variable_7352 = h_variable_l[1]; matrix h_variable_7353 = h_variable_l[2];
ncols(h_variable_7352);
matrix h_variable_7354 = DecideZeroRows(h_variable_7352,h_variable_58);
IsZeroMatrix(h_variable_7354);
ZeroRows(h_variable_7354);
nrows(h_variable_7353);
matrix h_variable_7356 = submat(h_variable_7352,1..1,intvec( 2 ));
matrix h_variable_7355 = DecideZeroRows(h_variable_7356,h_variable_58);
IsZeroMatrix(h_variable_7355);
IsIdentityMatrix(h_variable_7355);
matrix h_variable_7357[1][3] = concat(h_variable_7355,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7357); matrix h_variable_7358 = h_variable_l[1]; matrix h_variable_7359 = h_variable_l[2];
IsZeroMatrix(h_variable_7358);
matrix h_variable_7360 = DecideZeroRows(h_variable_7358,h_variable_58);
IsZeroMatrix(h_variable_7360);
def h_variable_7361 = h_variable_4814[12,28];
h_variable_7361;
matrix h_variable_7362[1][1] = -3*x2;
matrix h_variable_7363[1][3] = concat(h_variable_7362,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7363); matrix h_variable_7364 = h_variable_l[1]; matrix h_variable_7365 = h_variable_l[2];
ncols(h_variable_7364);
matrix h_variable_7366 = DecideZeroRows(h_variable_7364,h_variable_58);
IsZeroMatrix(h_variable_7366);
ZeroRows(h_variable_7366);
nrows(h_variable_7365);
matrix h_variable_7368 = submat(h_variable_7364,1..1,intvec( 2 ));
matrix h_variable_7367 = DecideZeroRows(h_variable_7368,h_variable_58);
IsZeroMatrix(h_variable_7367);
IsIdentityMatrix(h_variable_7367);
matrix h_variable_7369[1][3] = concat(h_variable_7367,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7369); matrix h_variable_7370 = h_variable_l[1]; matrix h_variable_7371 = h_variable_l[2];
IsZeroMatrix(h_variable_7370);
matrix h_variable_7372 = DecideZeroRows(h_variable_7370,h_variable_58);
IsZeroMatrix(h_variable_7372);
def h_variable_7373 = h_variable_4814[11,28];
h_variable_7373;
matrix h_variable_7374[1][1] = 0;
matrix h_variable_7375[1][3] = concat(h_variable_7374,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7375); matrix h_variable_7376 = h_variable_l[1]; matrix h_variable_7377 = h_variable_l[2];
ncols(h_variable_7376);
matrix h_variable_7378 = DecideZeroRows(h_variable_7376,h_variable_58);
IsZeroMatrix(h_variable_7378);
nrows(h_variable_7377);
def h_variable_7379 = h_variable_4814[10,28];
h_variable_7379;
matrix h_variable_7380[1][1] = 3*x3^2;
matrix h_variable_7381[1][3] = concat(h_variable_7380,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7381); matrix h_variable_7382 = h_variable_l[1]; matrix h_variable_7383 = h_variable_l[2];
ncols(h_variable_7382);
matrix h_variable_7384 = DecideZeroRows(h_variable_7382,h_variable_58);
IsZeroMatrix(h_variable_7384);
ZeroRows(h_variable_7384);
nrows(h_variable_7383);
matrix h_variable_7386 = submat(h_variable_7382,1..1,intvec( 2 ));
matrix h_variable_7385 = DecideZeroRows(h_variable_7386,h_variable_58);
IsZeroMatrix(h_variable_7385);
IsIdentityMatrix(h_variable_7385);
matrix h_variable_7387[1][3] = concat(h_variable_7385,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7387); matrix h_variable_7388 = h_variable_l[1]; matrix h_variable_7389 = h_variable_l[2];
IsZeroMatrix(h_variable_7388);
matrix h_variable_7390 = DecideZeroRows(h_variable_7388,h_variable_58);
IsZeroMatrix(h_variable_7390);
def h_variable_7391 = h_variable_4814[8,28];
h_variable_7391;
matrix h_variable_7392[1][1] = -3*x3^2;
matrix h_variable_7393[1][3] = concat(h_variable_7392,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7393); matrix h_variable_7394 = h_variable_l[1]; matrix h_variable_7395 = h_variable_l[2];
ncols(h_variable_7394);
matrix h_variable_7396 = DecideZeroRows(h_variable_7394,h_variable_58);
IsZeroMatrix(h_variable_7396);
ZeroRows(h_variable_7396);
nrows(h_variable_7395);
matrix h_variable_7398 = submat(h_variable_7394,1..1,intvec( 2 ));
matrix h_variable_7397 = DecideZeroRows(h_variable_7398,h_variable_58);
IsZeroMatrix(h_variable_7397);
IsIdentityMatrix(h_variable_7397);
matrix h_variable_7399[1][3] = concat(h_variable_7397,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7399); matrix h_variable_7400 = h_variable_l[1]; matrix h_variable_7401 = h_variable_l[2];
IsZeroMatrix(h_variable_7400);
matrix h_variable_7402 = DecideZeroRows(h_variable_7400,h_variable_58);
IsZeroMatrix(h_variable_7402);
def h_variable_7403 = h_variable_4814[2,28];
h_variable_7403;
matrix h_variable_7404[1][1] = 0;
matrix h_variable_7405[1][3] = concat(h_variable_7404,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7405); matrix h_variable_7406 = h_variable_l[1]; matrix h_variable_7407 = h_variable_l[2];
ncols(h_variable_7406);
matrix h_variable_7408 = DecideZeroRows(h_variable_7406,h_variable_58);
IsZeroMatrix(h_variable_7408);
nrows(h_variable_7407);
def h_variable_7409 = h_variable_4814[1,28];
h_variable_7409;
matrix h_variable_7410[1][1] = 0;
matrix h_variable_7411[1][3] = concat(h_variable_7410,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7411); matrix h_variable_7412 = h_variable_l[1]; matrix h_variable_7413 = h_variable_l[2];
ncols(h_variable_7412);
matrix h_variable_7414 = DecideZeroRows(h_variable_7412,h_variable_58);
IsZeroMatrix(h_variable_7414);
nrows(h_variable_7413);
def h_variable_7415 = h_variable_4814[16,29];
h_variable_7415;
matrix h_variable_7416[1][1] = -3;
matrix h_variable_7417[1][3] = concat(h_variable_7416,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7417); matrix h_variable_7418 = h_variable_l[1]; matrix h_variable_7419 = h_variable_l[2];
ncols(h_variable_7418);
matrix h_variable_7420 = DecideZeroRows(h_variable_7418,h_variable_58);
IsZeroMatrix(h_variable_7420);
ZeroRows(h_variable_7420);
nrows(h_variable_7419);
matrix h_variable_7422 = submat(h_variable_7418,1..1,intvec( 1 ));
matrix h_variable_7421 = DecideZeroRows(h_variable_7422,h_variable_58);
IsZeroMatrix(h_variable_7421);
IsIdentityMatrix(h_variable_7421);
matrix h_variable_7423[1][3] = concat(h_variable_7421,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7423); matrix h_variable_7424 = h_variable_l[1]; matrix h_variable_7425 = h_variable_l[2];
IsZeroMatrix(h_variable_7424);
matrix h_variable_7426 = DecideZeroRows(h_variable_7424,h_variable_58);
IsZeroMatrix(h_variable_7426);
def h_variable_7427 = h_variable_4814[15,29];
h_variable_7427;
matrix h_variable_7428[1][1] = 0;
matrix h_variable_7429[1][3] = concat(h_variable_7428,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7429); matrix h_variable_7430 = h_variable_l[1]; matrix h_variable_7431 = h_variable_l[2];
ncols(h_variable_7430);
matrix h_variable_7432 = DecideZeroRows(h_variable_7430,h_variable_58);
IsZeroMatrix(h_variable_7432);
nrows(h_variable_7431);
def h_variable_7433 = h_variable_4814[14,29];
h_variable_7433;
matrix h_variable_7434[1][1] = 3*x2-3*x3;
matrix h_variable_7435[1][3] = concat(h_variable_7434,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7435); matrix h_variable_7436 = h_variable_l[1]; matrix h_variable_7437 = h_variable_l[2];
ncols(h_variable_7436);
matrix h_variable_7438 = DecideZeroRows(h_variable_7436,h_variable_58);
IsZeroMatrix(h_variable_7438);
ZeroRows(h_variable_7438);
nrows(h_variable_7437);
matrix h_variable_7440 = submat(h_variable_7436,1..1,intvec( 2 ));
matrix h_variable_7439 = DecideZeroRows(h_variable_7440,h_variable_58);
IsZeroMatrix(h_variable_7439);
IsIdentityMatrix(h_variable_7439);
matrix h_variable_7441[1][3] = concat(h_variable_7439,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7441); matrix h_variable_7442 = h_variable_l[1]; matrix h_variable_7443 = h_variable_l[2];
IsZeroMatrix(h_variable_7442);
matrix h_variable_7444 = DecideZeroRows(h_variable_7442,h_variable_58);
IsZeroMatrix(h_variable_7444);
def h_variable_7445 = h_variable_4814[13,29];
h_variable_7445;
matrix h_variable_7446[1][1] = -3*x2-3*x3;
matrix h_variable_7447[1][3] = concat(h_variable_7446,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7447); matrix h_variable_7448 = h_variable_l[1]; matrix h_variable_7449 = h_variable_l[2];
ncols(h_variable_7448);
matrix h_variable_7450 = DecideZeroRows(h_variable_7448,h_variable_58);
IsZeroMatrix(h_variable_7450);
ZeroRows(h_variable_7450);
nrows(h_variable_7449);
matrix h_variable_7452 = submat(h_variable_7448,1..1,intvec( 2 ));
matrix h_variable_7451 = DecideZeroRows(h_variable_7452,h_variable_58);
IsZeroMatrix(h_variable_7451);
IsIdentityMatrix(h_variable_7451);
matrix h_variable_7453[1][3] = concat(h_variable_7451,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7453); matrix h_variable_7454 = h_variable_l[1]; matrix h_variable_7455 = h_variable_l[2];
IsZeroMatrix(h_variable_7454);
matrix h_variable_7456 = DecideZeroRows(h_variable_7454,h_variable_58);
IsZeroMatrix(h_variable_7456);
def h_variable_7457 = h_variable_4814[12,29];
h_variable_7457;
matrix h_variable_7458[1][1] = 0;
matrix h_variable_7459[1][3] = concat(h_variable_7458,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7459); matrix h_variable_7460 = h_variable_l[1]; matrix h_variable_7461 = h_variable_l[2];
ncols(h_variable_7460);
matrix h_variable_7462 = DecideZeroRows(h_variable_7460,h_variable_58);
IsZeroMatrix(h_variable_7462);
nrows(h_variable_7461);
def h_variable_7463 = h_variable_4814[11,29];
h_variable_7463;
matrix h_variable_7464[1][1] = 0;
matrix h_variable_7465[1][3] = concat(h_variable_7464,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7465); matrix h_variable_7466 = h_variable_l[1]; matrix h_variable_7467 = h_variable_l[2];
ncols(h_variable_7466);
matrix h_variable_7468 = DecideZeroRows(h_variable_7466,h_variable_58);
IsZeroMatrix(h_variable_7468);
nrows(h_variable_7467);
def h_variable_7469 = h_variable_4814[10,29];
h_variable_7469;
matrix h_variable_7470[1][1] = 3*x2^2-3*x3^2;
matrix h_variable_7471[1][3] = concat(h_variable_7470,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7471); matrix h_variable_7472 = h_variable_l[1]; matrix h_variable_7473 = h_variable_l[2];
ncols(h_variable_7472);
matrix h_variable_7474 = DecideZeroRows(h_variable_7472,h_variable_58);
IsZeroMatrix(h_variable_7474);
ZeroRows(h_variable_7474);
nrows(h_variable_7473);
matrix h_variable_7476 = submat(h_variable_7472,1..1,intvec( 2 ));
matrix h_variable_7475 = DecideZeroRows(h_variable_7476,h_variable_58);
IsZeroMatrix(h_variable_7475);
IsIdentityMatrix(h_variable_7475);
matrix h_variable_7477[1][3] = concat(h_variable_7475,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7477); matrix h_variable_7478 = h_variable_l[1]; matrix h_variable_7479 = h_variable_l[2];
IsZeroMatrix(h_variable_7478);
matrix h_variable_7480 = DecideZeroRows(h_variable_7478,h_variable_58);
IsZeroMatrix(h_variable_7480);
def h_variable_7481 = h_variable_4814[8,29];
h_variable_7481;
matrix h_variable_7482[1][1] = 3*x3^2;
matrix h_variable_7483[1][3] = concat(h_variable_7482,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7483); matrix h_variable_7484 = h_variable_l[1]; matrix h_variable_7485 = h_variable_l[2];
ncols(h_variable_7484);
matrix h_variable_7486 = DecideZeroRows(h_variable_7484,h_variable_58);
IsZeroMatrix(h_variable_7486);
ZeroRows(h_variable_7486);
nrows(h_variable_7485);
matrix h_variable_7488 = submat(h_variable_7484,1..1,intvec( 2 ));
matrix h_variable_7487 = DecideZeroRows(h_variable_7488,h_variable_58);
IsZeroMatrix(h_variable_7487);
IsIdentityMatrix(h_variable_7487);
matrix h_variable_7489[1][3] = concat(h_variable_7487,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7489); matrix h_variable_7490 = h_variable_l[1]; matrix h_variable_7491 = h_variable_l[2];
IsZeroMatrix(h_variable_7490);
matrix h_variable_7492 = DecideZeroRows(h_variable_7490,h_variable_58);
IsZeroMatrix(h_variable_7492);
def h_variable_7493 = h_variable_4814[2,29];
h_variable_7493;
matrix h_variable_7494[1][1] = 0;
matrix h_variable_7495[1][3] = concat(h_variable_7494,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7495); matrix h_variable_7496 = h_variable_l[1]; matrix h_variable_7497 = h_variable_l[2];
ncols(h_variable_7496);
matrix h_variable_7498 = DecideZeroRows(h_variable_7496,h_variable_58);
IsZeroMatrix(h_variable_7498);
nrows(h_variable_7497);
def h_variable_7499 = h_variable_4814[1,29];
h_variable_7499;
matrix h_variable_7500[1][1] = 0;
kill h_variable_6960;kill h_variable_6961;kill h_variable_6962;kill h_variable_6963;kill h_variable_6964;kill h_variable_6966;kill h_variable_6967;kill h_variable_6968;kill h_variable_6969;kill h_variable_6970;kill h_variable_6972;kill h_variable_6973;kill h_variable_6974;kill h_variable_6975;kill h_variable_6976;kill h_variable_6977;kill h_variable_6978;kill h_variable_6979;kill h_variable_6980;kill h_variable_6981;kill h_variable_6982;kill h_variable_6983;kill h_variable_6984;kill h_variable_6985;kill h_variable_6986;kill h_variable_6987;kill h_variable_6988;kill h_variable_6989;kill h_variable_6990;kill h_variable_6991;kill h_variable_6992;kill h_variable_6993;kill h_variable_6994;kill h_variable_6995;kill h_variable_6996;kill h_variable_6997;kill h_variable_6998;kill h_variable_6999;kill h_variable_7000;kill h_variable_7001;kill h_variable_7002;kill h_variable_7003;kill h_variable_7004;kill h_variable_7005;kill h_variable_7006;kill h_variable_7007;kill h_variable_7008;kill h_variable_7009;kill h_variable_7010;kill h_variable_7011;kill h_variable_7012;kill h_variable_7013;kill h_variable_7014;kill h_variable_7015;kill h_variable_7016;kill h_variable_7017;kill h_variable_7018;kill h_variable_7019;kill h_variable_7020;kill h_variable_7021;kill h_variable_7022;kill h_variable_7023;kill h_variable_7024;kill h_variable_7025;kill h_variable_7026;kill h_variable_7027;kill h_variable_7028;kill h_variable_7029;kill h_variable_7030;kill h_variable_7031;kill h_variable_7032;kill h_variable_7033;kill h_variable_7034;kill h_variable_7035;kill h_variable_7036;kill h_variable_7037;kill h_variable_7038;kill h_variable_7039;kill h_variable_7040;kill h_variable_7041;kill h_variable_7042;kill h_variable_7043;kill h_variable_7044;kill h_variable_7045;kill h_variable_7046;kill h_variable_7047;kill h_variable_7048;kill h_variable_7049;kill h_variable_7050;kill h_variable_7051;kill h_variable_7052;kill h_variable_7053;kill h_variable_7054;kill h_variable_7055;kill h_variable_7056;kill h_variable_7057;kill h_variable_7058;kill h_variable_7059;kill h_variable_7060;kill h_variable_7061;kill h_variable_7062;kill h_variable_7063;kill h_variable_7064;kill h_variable_7065;kill h_variable_7066;kill h_variable_7067;kill h_variable_7068;kill h_variable_7069;kill h_variable_7070;kill h_variable_7071;kill h_variable_7072;kill h_variable_7078;kill h_variable_7084;kill h_variable_7086;kill h_variable_7087;kill h_variable_7088;kill h_variable_7089;kill h_variable_7090;kill h_variable_7092;kill h_variable_7093;kill h_variable_7094;kill h_variable_7095;kill h_variable_7096;kill h_variable_7098;kill h_variable_7099;kill h_variable_7100;kill h_variable_7101;kill h_variable_7102;kill h_variable_7103;kill h_variable_7104;kill h_variable_7105;kill h_variable_7106;kill h_variable_7107;kill h_variable_7108;kill h_variable_7109;kill h_variable_7110;kill h_variable_7111;kill h_variable_7112;kill h_variable_7113;kill h_variable_7114;kill h_variable_7115;kill h_variable_7116;kill h_variable_7117;kill h_variable_7118;kill h_variable_7119;kill h_variable_7120;kill h_variable_7121;kill h_variable_7122;kill h_variable_7123;kill h_variable_7124;kill h_variable_7125;kill h_variable_7126;kill h_variable_7127;kill h_variable_7128;kill h_variable_7129;kill h_variable_7130;kill h_variable_7131;kill h_variable_7132;kill h_variable_7133;kill h_variable_7134;kill h_variable_7135;kill h_variable_7136;kill h_variable_7137;kill h_variable_7138;kill h_variable_7139;kill h_variable_7140;kill h_variable_7141;kill h_variable_7142;kill h_variable_7143;kill h_variable_7144;kill h_variable_7145;kill h_variable_7146;kill h_variable_7147;kill h_variable_7148;kill h_variable_7149;kill h_variable_7150;kill h_variable_7151;kill h_variable_7152;kill h_variable_7153;kill h_variable_7154;kill h_variable_7155;kill h_variable_7156;kill h_variable_7157;kill h_variable_7158;kill h_variable_7159;kill h_variable_7160;kill h_variable_7161;kill h_variable_7162;kill h_variable_7163;kill h_variable_7164;kill h_variable_7165;kill h_variable_7166;kill h_variable_7167;kill h_variable_7168;kill h_variable_7169;kill h_variable_7170;kill h_variable_7171;kill h_variable_7172;kill h_variable_7173;kill h_variable_7174;kill h_variable_7175;kill h_variable_7176;kill h_variable_7177;kill h_variable_7178;kill h_variable_7179;kill h_variable_7180;kill h_variable_7181;kill h_variable_7182;kill h_variable_7183;kill h_variable_7184;kill h_variable_7185;kill h_variable_7186;kill h_variable_7187;kill h_variable_7188;kill h_variable_7189;kill h_variable_7190;kill h_variable_7191;kill h_variable_7192;kill h_variable_7193;kill h_variable_7194;kill h_variable_7195;kill h_variable_7196;kill h_variable_7197;kill h_variable_7198;kill h_variable_7199;kill h_variable_7200;kill h_variable_7201;kill h_variable_7202;kill h_variable_7203;kill h_variable_7204;kill h_variable_7205;kill h_variable_7206;kill h_variable_7207;kill h_variable_7208;kill h_variable_7209;kill h_variable_7210;kill h_variable_7211;kill h_variable_7212;kill h_variable_7213;kill h_variable_7214;kill h_variable_7215;kill h_variable_7216;kill h_variable_7217;kill h_variable_7218;kill h_variable_7219;kill h_variable_7220;kill h_variable_7221;kill h_variable_7222;kill h_variable_7223;kill h_variable_7224;kill h_variable_7225;kill h_variable_7226;kill h_variable_7227;kill h_variable_7228;kill h_variable_7229;kill h_variable_7230;kill h_variable_7231;kill h_variable_7232;kill h_variable_7233;kill h_variable_7234;kill h_variable_7235;kill h_variable_7236;kill h_variable_7237;kill h_variable_7238;kill h_variable_7239;kill h_variable_7240;kill h_variable_7241;kill h_variable_7242;kill h_variable_7243;kill h_variable_7244;kill h_variable_7245;kill h_variable_7246;kill h_variable_7247;kill h_variable_7248;kill h_variable_7249;kill h_variable_7250;kill h_variable_7251;kill h_variable_7252;kill h_variable_7253;kill h_variable_7254;kill h_variable_7255;kill h_variable_7256;kill h_variable_7257;kill h_variable_7258;kill h_variable_7264;kill h_variable_7266;kill h_variable_7270;kill h_variable_7272;kill h_variable_7273;kill h_variable_7274;kill h_variable_7275;kill h_variable_7276;kill h_variable_7278;kill h_variable_7282;kill h_variable_7284;kill h_variable_7285;kill h_variable_7286;kill h_variable_7287;kill h_variable_7288;kill h_variable_7289;kill h_variable_7290;kill h_variable_7291;kill h_variable_7292;kill h_variable_7293;kill h_variable_7294;kill h_variable_7295;kill h_variable_7296;kill h_variable_7297;kill h_variable_7298;kill h_variable_7299;kill h_variable_7300;kill h_variable_7301;kill h_variable_7302;kill h_variable_7303;kill h_variable_7304;kill h_variable_7305;kill h_variable_7306;kill h_variable_7307;kill h_variable_7308;kill h_variable_7309;kill h_variable_7310;kill h_variable_7311;kill h_variable_7312;kill h_variable_7313;kill h_variable_7314;kill h_variable_7315;kill h_variable_7316;kill h_variable_7317;kill h_variable_7318;kill h_variable_7319;kill h_variable_7320;kill h_variable_7321;kill h_variable_7322;kill h_variable_7323;kill h_variable_7324;kill h_variable_7325;kill h_variable_7326;kill h_variable_7327;kill h_variable_7328;kill h_variable_7329;kill h_variable_7330;kill h_variable_7331;kill h_variable_7332;kill h_variable_7333;kill h_variable_7334;kill h_variable_7335;kill h_variable_7336;kill h_variable_7337;kill h_variable_7338;kill h_variable_7339;kill h_variable_7340;kill h_variable_7341;kill h_variable_7342;kill h_variable_7343;kill h_variable_7344;kill h_variable_7345;kill h_variable_7346;kill h_variable_7347;kill h_variable_7348;kill h_variable_7349;kill h_variable_7350;kill h_variable_7351;kill h_variable_7352;kill h_variable_7353;kill h_variable_7354;kill h_variable_7355;kill h_variable_7356;kill h_variable_7357;kill h_variable_7358;kill h_variable_7359;kill h_variable_7360;kill h_variable_7361;kill h_variable_7362;kill h_variable_7363;kill h_variable_7364;kill h_variable_7365;kill h_variable_7366;kill h_variable_7367;kill h_variable_7368;kill h_variable_7369;kill h_variable_7370;kill h_variable_7371;kill h_variable_7372;kill h_variable_7373;kill h_variable_7374;kill h_variable_7375;kill h_variable_7376;kill h_variable_7377;kill h_variable_7378;kill h_variable_7379;kill h_variable_7380;kill h_variable_7381;kill h_variable_7382;kill h_variable_7383;kill h_variable_7384;kill h_variable_7385;kill h_variable_7386;kill h_variable_7387;kill h_variable_7388;kill h_variable_7389;kill h_variable_7390;kill h_variable_7391;kill h_variable_7392;kill h_variable_7393;kill h_variable_7394;kill h_variable_7395;kill h_variable_7396;kill h_variable_7397;kill h_variable_7398;kill h_variable_7399;kill h_variable_7400;kill h_variable_7401;kill h_variable_7402;kill h_variable_7403;kill h_variable_7404;kill h_variable_7405;kill h_variable_7406;kill h_variable_7407;kill h_variable_7408;kill h_variable_7409;kill h_variable_7410;kill h_variable_7411;kill h_variable_7412;kill h_variable_7413;kill h_variable_7414;kill h_variable_7415;kill h_variable_7416;kill h_variable_7417;kill h_variable_7418;kill h_variable_7419;kill h_variable_7420;kill h_variable_7421;kill h_variable_7422;kill h_variable_7423;kill h_variable_7424;kill h_variable_7425;kill h_variable_7426;kill h_variable_7427;kill h_variable_7428;kill h_variable_7429;kill h_variable_7430;kill h_variable_7431;kill h_variable_7432;kill h_variable_7433;kill h_variable_7434;kill h_variable_7435;kill h_variable_7436;kill h_variable_7437;kill h_variable_7438;kill h_variable_7439;kill h_variable_7440;kill h_variable_7441;kill h_variable_7442;kill h_variable_7443;kill h_variable_7444;kill h_variable_7445;kill h_variable_7446;kill h_variable_7447;kill h_variable_7448;kill h_variable_7449;kill h_variable_7450;kill h_variable_7451;kill h_variable_7452;kill h_variable_7453;kill h_variable_7454;kill h_variable_7455;kill h_variable_7456;kill h_variable_7462;
matrix h_variable_7501[1][3] = concat(h_variable_7500,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7501); matrix h_variable_7502 = h_variable_l[1]; matrix h_variable_7503 = h_variable_l[2];
ncols(h_variable_7502);
matrix h_variable_7504 = DecideZeroRows(h_variable_7502,h_variable_58);
IsZeroMatrix(h_variable_7504);
nrows(h_variable_7503);
def h_variable_7505 = h_variable_4814[16,30];
h_variable_7505;
matrix h_variable_7506[1][1] = 0;
matrix h_variable_7507[1][3] = concat(h_variable_7506,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7507); matrix h_variable_7508 = h_variable_l[1]; matrix h_variable_7509 = h_variable_l[2];
ncols(h_variable_7508);
matrix h_variable_7510 = DecideZeroRows(h_variable_7508,h_variable_58);
IsZeroMatrix(h_variable_7510);
nrows(h_variable_7509);
def h_variable_7511 = h_variable_4814[15,30];
h_variable_7511;
matrix h_variable_7512[1][1] = 0;
matrix h_variable_7513[1][3] = concat(h_variable_7512,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7513); matrix h_variable_7514 = h_variable_l[1]; matrix h_variable_7515 = h_variable_l[2];
ncols(h_variable_7514);
matrix h_variable_7516 = DecideZeroRows(h_variable_7514,h_variable_58);
IsZeroMatrix(h_variable_7516);
nrows(h_variable_7515);
def h_variable_7517 = h_variable_4814[14,30];
h_variable_7517;
matrix h_variable_7518[1][1] = 0;
matrix h_variable_7519[1][3] = concat(h_variable_7518,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7519); matrix h_variable_7520 = h_variable_l[1]; matrix h_variable_7521 = h_variable_l[2];
ncols(h_variable_7520);
matrix h_variable_7522 = DecideZeroRows(h_variable_7520,h_variable_58);
IsZeroMatrix(h_variable_7522);
nrows(h_variable_7521);
def h_variable_7523 = h_variable_4814[13,30];
h_variable_7523;
matrix h_variable_7524[1][1] = 0;
matrix h_variable_7525[1][3] = concat(h_variable_7524,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7525); matrix h_variable_7526 = h_variable_l[1]; matrix h_variable_7527 = h_variable_l[2];
ncols(h_variable_7526);
matrix h_variable_7528 = DecideZeroRows(h_variable_7526,h_variable_58);
IsZeroMatrix(h_variable_7528);
nrows(h_variable_7527);
def h_variable_7529 = h_variable_4814[12,30];
h_variable_7529;
matrix h_variable_7530[1][1] = 0;
matrix h_variable_7531[1][3] = concat(h_variable_7530,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7531); matrix h_variable_7532 = h_variable_l[1]; matrix h_variable_7533 = h_variable_l[2];
ncols(h_variable_7532);
matrix h_variable_7534 = DecideZeroRows(h_variable_7532,h_variable_58);
IsZeroMatrix(h_variable_7534);
nrows(h_variable_7533);
def h_variable_7535 = h_variable_4814[11,30];
h_variable_7535;
matrix h_variable_7536[1][1] = 0;
matrix h_variable_7537[1][3] = concat(h_variable_7536,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7537); matrix h_variable_7538 = h_variable_l[1]; matrix h_variable_7539 = h_variable_l[2];
ncols(h_variable_7538);
matrix h_variable_7540 = DecideZeroRows(h_variable_7538,h_variable_58);
IsZeroMatrix(h_variable_7540);
nrows(h_variable_7539);
def h_variable_7541 = h_variable_4814[10,30];
h_variable_7541;
matrix h_variable_7542[1][1] = 2*a7-1;
matrix h_variable_7543[1][3] = concat(h_variable_7542,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7543); matrix h_variable_7544 = h_variable_l[1]; matrix h_variable_7545 = h_variable_l[2];
ncols(h_variable_7544);
matrix h_variable_7546 = DecideZeroRows(h_variable_7544,h_variable_58);
IsZeroMatrix(h_variable_7546);
ZeroRows(h_variable_7546);
nrows(h_variable_7545);
matrix h_variable_7547[1][4] = concat(h_variable_7544,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7547); matrix h_variable_7548 = h_variable_l[1]; matrix h_variable_7549 = h_variable_l[2];
IsZeroMatrix(h_variable_7548);
matrix h_variable_7550 = DecideZeroRows(h_variable_7548,h_variable_58);
IsZeroMatrix(h_variable_7550);
def h_variable_7551 = h_variable_4814[8,30];
h_variable_7551;
matrix h_variable_7552[1][1] = 4*a7-3;
matrix h_variable_7553[1][3] = concat(h_variable_7552,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7553); matrix h_variable_7554 = h_variable_l[1]; matrix h_variable_7555 = h_variable_l[2];
ncols(h_variable_7554);
matrix h_variable_7556 = DecideZeroRows(h_variable_7554,h_variable_58);
IsZeroMatrix(h_variable_7556);
nrows(h_variable_7555);
IsIdentityMatrix(h_variable_7556);
def h_variable_7557 = h_variable_4814[1,30];
h_variable_7557;
matrix h_variable_7558[1][1] = 0;
matrix h_variable_7559 = DecideZeroRows(h_variable_7558,h_variable_58);
IsZeroMatrix(h_variable_7559);
def h_variable_7560 = h_variable_7559[1,1];
h_variable_7560==0;
def h_variable_7561 = h_variable_4814[2,30];
h_variable_7561;
matrix h_variable_7562[1][1] = 0;
matrix h_variable_7563 = DecideZeroRows(h_variable_7562,h_variable_58);
IsZeroMatrix(h_variable_7563);
def h_variable_7564 = h_variable_7563[1,1];
h_variable_7564==0;
def h_variable_7565 = h_variable_4814[8,30];
h_variable_7565;
matrix h_variable_7566[1][1] = 4*a7-3;
matrix h_variable_7567 = DecideZeroRows(h_variable_7566,h_variable_58);
IsZeroMatrix(h_variable_7567);
def h_variable_7568 = h_variable_7567[1,1];
h_variable_7568==0;
def h_variable_7569 = h_variable_4814[10,30];
h_variable_7569;
matrix h_variable_7570[1][1] = 2*a7-1;
matrix h_variable_7571 = DecideZeroRows(h_variable_7570,h_variable_58);
IsZeroMatrix(h_variable_7571);
def h_variable_7572 = h_variable_7571[1,1];
h_variable_7572==0;
def h_variable_7573 = h_variable_4814[11,30];
h_variable_7573;
matrix h_variable_7574[1][1] = 0;
matrix h_variable_7575 = DecideZeroRows(h_variable_7574,h_variable_58);
IsZeroMatrix(h_variable_7575);
def h_variable_7576 = h_variable_7575[1,1];
h_variable_7576==0;
def h_variable_7577 = h_variable_4814[12,30];
h_variable_7577;
matrix h_variable_7578[1][1] = 0;
matrix h_variable_7579 = DecideZeroRows(h_variable_7578,h_variable_58);
IsZeroMatrix(h_variable_7579);
def h_variable_7580 = h_variable_7579[1,1];
h_variable_7580==0;
def h_variable_7581 = h_variable_4814[13,30];
h_variable_7581;
matrix h_variable_7582[1][1] = 0;
matrix h_variable_7583 = DecideZeroRows(h_variable_7582,h_variable_58);
IsZeroMatrix(h_variable_7583);
def h_variable_7584 = h_variable_7583[1,1];
h_variable_7584==0;
def h_variable_7585 = h_variable_4814[14,30];
h_variable_7585;
matrix h_variable_7586[1][1] = 0;
matrix h_variable_7587 = DecideZeroRows(h_variable_7586,h_variable_58);
IsZeroMatrix(h_variable_7587);
def h_variable_7588 = h_variable_7587[1,1];
h_variable_7588==0;
def h_variable_7589 = h_variable_4814[15,30];
h_variable_7589;
matrix h_variable_7590[1][1] = 0;
matrix h_variable_7591 = DecideZeroRows(h_variable_7590,h_variable_58);
IsZeroMatrix(h_variable_7591);
def h_variable_7592 = h_variable_7591[1,1];
h_variable_7592==0;
def h_variable_7593 = h_variable_4814[16,30];
h_variable_7593;
matrix h_variable_7594[1][1] = 0;
matrix h_variable_7595 = DecideZeroRows(h_variable_7594,h_variable_58);
IsZeroMatrix(h_variable_7595);
def h_variable_7596 = h_variable_7595[1,1];
h_variable_7596==0;
def h_variable_7597 = h_variable_4814[16,31];
h_variable_7597;
matrix h_variable_7598[1][1] = 0;
matrix h_variable_7599[1][3] = concat(h_variable_7598,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7599); matrix h_variable_7600 = h_variable_l[1]; matrix h_variable_7601 = h_variable_l[2];
ncols(h_variable_7600);
matrix h_variable_7602 = DecideZeroRows(h_variable_7600,h_variable_58);
IsZeroMatrix(h_variable_7602);
nrows(h_variable_7601);
def h_variable_7603 = h_variable_4814[15,31];
h_variable_7603;
matrix h_variable_7604[1][1] = 0;
matrix h_variable_7605[1][3] = concat(h_variable_7604,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7605); matrix h_variable_7606 = h_variable_l[1]; matrix h_variable_7607 = h_variable_l[2];
ncols(h_variable_7606);
matrix h_variable_7608 = DecideZeroRows(h_variable_7606,h_variable_58);
IsZeroMatrix(h_variable_7608);
nrows(h_variable_7607);
def h_variable_7609 = h_variable_4814[14,31];
h_variable_7609;
matrix h_variable_7610[1][1] = 0;
matrix h_variable_7611[1][3] = concat(h_variable_7610,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7611); matrix h_variable_7612 = h_variable_l[1]; matrix h_variable_7613 = h_variable_l[2];
ncols(h_variable_7612);
matrix h_variable_7614 = DecideZeroRows(h_variable_7612,h_variable_58);
IsZeroMatrix(h_variable_7614);
nrows(h_variable_7613);
def h_variable_7615 = h_variable_4814[13,31];
h_variable_7615;
matrix h_variable_7616[1][1] = 0;
matrix h_variable_7617[1][3] = concat(h_variable_7616,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7617); matrix h_variable_7618 = h_variable_l[1]; matrix h_variable_7619 = h_variable_l[2];
ncols(h_variable_7618);
matrix h_variable_7620 = DecideZeroRows(h_variable_7618,h_variable_58);
IsZeroMatrix(h_variable_7620);
nrows(h_variable_7619);
def h_variable_7621 = h_variable_4814[12,31];
h_variable_7621;
matrix h_variable_7622[1][1] = 0;
matrix h_variable_7623[1][3] = concat(h_variable_7622,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7623); matrix h_variable_7624 = h_variable_l[1]; matrix h_variable_7625 = h_variable_l[2];
ncols(h_variable_7624);
matrix h_variable_7626 = DecideZeroRows(h_variable_7624,h_variable_58);
IsZeroMatrix(h_variable_7626);
nrows(h_variable_7625);
def h_variable_7627 = h_variable_4814[11,31];
h_variable_7627;
matrix h_variable_7628[1][1] = 0;
matrix h_variable_7629[1][3] = concat(h_variable_7628,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7629); matrix h_variable_7630 = h_variable_l[1]; matrix h_variable_7631 = h_variable_l[2];
ncols(h_variable_7630);
matrix h_variable_7632 = DecideZeroRows(h_variable_7630,h_variable_58);
IsZeroMatrix(h_variable_7632);
nrows(h_variable_7631);
def h_variable_7633 = h_variable_4814[2,31];
h_variable_7633;
matrix h_variable_7634[1][1] = 0;
matrix h_variable_7635[1][3] = concat(h_variable_7634,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7635); matrix h_variable_7636 = h_variable_l[1]; matrix h_variable_7637 = h_variable_l[2];
ncols(h_variable_7636);
matrix h_variable_7638 = DecideZeroRows(h_variable_7636,h_variable_58);
IsZeroMatrix(h_variable_7638);
nrows(h_variable_7637);
def h_variable_7639 = h_variable_4814[1,31];
h_variable_7639;
matrix h_variable_7640[1][1] = 0;
matrix h_variable_7641[1][3] = concat(h_variable_7640,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7641); matrix h_variable_7642 = h_variable_l[1]; matrix h_variable_7643 = h_variable_l[2];
ncols(h_variable_7642);
matrix h_variable_7644 = DecideZeroRows(h_variable_7642,h_variable_58);
IsZeroMatrix(h_variable_7644);
nrows(h_variable_7643);
def h_variable_7645 = h_variable_4814[16,32];
h_variable_7645;
matrix h_variable_7646[1][1] = 0;
matrix h_variable_7647[1][3] = concat(h_variable_7646,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7647); matrix h_variable_7648 = h_variable_l[1]; matrix h_variable_7649 = h_variable_l[2];
ncols(h_variable_7648);
matrix h_variable_7650 = DecideZeroRows(h_variable_7648,h_variable_58);
IsZeroMatrix(h_variable_7650);
nrows(h_variable_7649);
def h_variable_7651 = h_variable_4814[15,32];
h_variable_7651;
matrix h_variable_7652[1][1] = 0;
matrix h_variable_7653[1][3] = concat(h_variable_7652,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7653); matrix h_variable_7654 = h_variable_l[1]; matrix h_variable_7655 = h_variable_l[2];
ncols(h_variable_7654);
matrix h_variable_7656 = DecideZeroRows(h_variable_7654,h_variable_58);
IsZeroMatrix(h_variable_7656);
nrows(h_variable_7655);
def h_variable_7657 = h_variable_4814[14,32];
h_variable_7657;
matrix h_variable_7658[1][1] = 0;
matrix h_variable_7659[1][3] = concat(h_variable_7658,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7659); matrix h_variable_7660 = h_variable_l[1]; matrix h_variable_7661 = h_variable_l[2];
ncols(h_variable_7660);
matrix h_variable_7662 = DecideZeroRows(h_variable_7660,h_variable_58);
IsZeroMatrix(h_variable_7662);
nrows(h_variable_7661);
def h_variable_7663 = h_variable_4814[13,32];
h_variable_7663;
matrix h_variable_7664[1][1] = 0;
matrix h_variable_7665[1][3] = concat(h_variable_7664,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7665); matrix h_variable_7666 = h_variable_l[1]; matrix h_variable_7667 = h_variable_l[2];
ncols(h_variable_7666);
matrix h_variable_7668 = DecideZeroRows(h_variable_7666,h_variable_58);
IsZeroMatrix(h_variable_7668);
nrows(h_variable_7667);
def h_variable_7669 = h_variable_4814[12,32];
h_variable_7669;
matrix h_variable_7670[1][1] = 0;
matrix h_variable_7671[1][3] = concat(h_variable_7670,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7671); matrix h_variable_7672 = h_variable_l[1]; matrix h_variable_7673 = h_variable_l[2];
ncols(h_variable_7672);
matrix h_variable_7674 = DecideZeroRows(h_variable_7672,h_variable_58);
IsZeroMatrix(h_variable_7674);
nrows(h_variable_7673);
def h_variable_7675 = h_variable_4814[11,32];
h_variable_7675;
matrix h_variable_7676[1][1] = 0;
matrix h_variable_7677[1][3] = concat(h_variable_7676,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7677); matrix h_variable_7678 = h_variable_l[1]; matrix h_variable_7679 = h_variable_l[2];
ncols(h_variable_7678);
matrix h_variable_7680 = DecideZeroRows(h_variable_7678,h_variable_58);
IsZeroMatrix(h_variable_7680);
nrows(h_variable_7679);
def h_variable_7681 = h_variable_4814[2,32];
h_variable_7681;
matrix h_variable_7682[1][1] = 0;
matrix h_variable_7683[1][3] = concat(h_variable_7682,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7683); matrix h_variable_7684 = h_variable_l[1]; matrix h_variable_7685 = h_variable_l[2];
ncols(h_variable_7684);
matrix h_variable_7686 = DecideZeroRows(h_variable_7684,h_variable_58);
IsZeroMatrix(h_variable_7686);
nrows(h_variable_7685);
def h_variable_7687 = h_variable_4814[1,32];
h_variable_7687;
matrix h_variable_7688[1][1] = 0;
matrix h_variable_7689[1][3] = concat(h_variable_7688,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7689); matrix h_variable_7690 = h_variable_l[1]; matrix h_variable_7691 = h_variable_l[2];
ncols(h_variable_7690);
matrix h_variable_7692 = DecideZeroRows(h_variable_7690,h_variable_58);
IsZeroMatrix(h_variable_7692);
nrows(h_variable_7691);
def h_variable_7693 = h_variable_4814[16,33];
h_variable_7693;
matrix h_variable_7694[1][1] = 2;
matrix h_variable_7695[1][3] = concat(h_variable_7694,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7695); matrix h_variable_7696 = h_variable_l[1]; matrix h_variable_7697 = h_variable_l[2];
ncols(h_variable_7696);
matrix h_variable_7698 = DecideZeroRows(h_variable_7696,h_variable_58);
IsZeroMatrix(h_variable_7698);
ZeroRows(h_variable_7698);
nrows(h_variable_7697);
matrix h_variable_7700 = submat(h_variable_7696,1..1,intvec( 1 ));
matrix h_variable_7699 = DecideZeroRows(h_variable_7700,h_variable_58);
IsZeroMatrix(h_variable_7699);
IsIdentityMatrix(h_variable_7699);
matrix h_variable_7701[1][3] = concat(h_variable_7699,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7701); matrix h_variable_7702 = h_variable_l[1]; matrix h_variable_7703 = h_variable_l[2];
IsZeroMatrix(h_variable_7702);
matrix h_variable_7704 = DecideZeroRows(h_variable_7702,h_variable_58);
IsZeroMatrix(h_variable_7704);
def h_variable_7705 = h_variable_4814[15,33];
h_variable_7705;
matrix h_variable_7706[1][1] = 0;
matrix h_variable_7707[1][3] = concat(h_variable_7706,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7707); matrix h_variable_7708 = h_variable_l[1]; matrix h_variable_7709 = h_variable_l[2];
ncols(h_variable_7708);
matrix h_variable_7710 = DecideZeroRows(h_variable_7708,h_variable_58);
IsZeroMatrix(h_variable_7710);
nrows(h_variable_7709);
def h_variable_7711 = h_variable_4814[14,33];
h_variable_7711;
matrix h_variable_7712[1][1] = -3*x1+3*x3;
matrix h_variable_7713[1][3] = concat(h_variable_7712,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7713); matrix h_variable_7714 = h_variable_l[1]; matrix h_variable_7715 = h_variable_l[2];
ncols(h_variable_7714);
matrix h_variable_7716 = DecideZeroRows(h_variable_7714,h_variable_58);
IsZeroMatrix(h_variable_7716);
ZeroRows(h_variable_7716);
nrows(h_variable_7715);
matrix h_variable_7718 = submat(h_variable_7714,1..1,intvec( 2 ));
matrix h_variable_7717 = DecideZeroRows(h_variable_7718,h_variable_58);
IsZeroMatrix(h_variable_7717);
IsIdentityMatrix(h_variable_7717);
matrix h_variable_7719[1][3] = concat(h_variable_7717,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7719); matrix h_variable_7720 = h_variable_l[1]; matrix h_variable_7721 = h_variable_l[2];
IsZeroMatrix(h_variable_7720);
matrix h_variable_7722 = DecideZeroRows(h_variable_7720,h_variable_58);
IsZeroMatrix(h_variable_7722);
def h_variable_7723 = h_variable_4814[13,33];
h_variable_7723;
matrix h_variable_7724[1][1] = -3*x1-2*x2;
matrix h_variable_7725[1][3] = concat(h_variable_7724,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7725); matrix h_variable_7726 = h_variable_l[1]; matrix h_variable_7727 = h_variable_l[2];
ncols(h_variable_7726);
matrix h_variable_7728 = DecideZeroRows(h_variable_7726,h_variable_58);
IsZeroMatrix(h_variable_7728);
ZeroRows(h_variable_7728);
nrows(h_variable_7727);
matrix h_variable_7730 = submat(h_variable_7726,1..1,intvec( 2, 3, 4 ));
matrix h_variable_7729 = DecideZeroRows(h_variable_7730,h_variable_58);
IsZeroMatrix(h_variable_7729);
matrix h_variable_7731[1][5] = concat(h_variable_7729,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7731); matrix h_variable_7732 = h_variable_l[1]; matrix h_variable_7733 = h_variable_l[2];
IsZeroMatrix(h_variable_7732);
matrix h_variable_7734 = DecideZeroRows(h_variable_7732,h_variable_58);
IsZeroMatrix(h_variable_7734);
def h_variable_7735 = h_variable_4814[12,33];
h_variable_7735;
matrix h_variable_7736[1][1] = x1-2*x2;
matrix h_variable_7737[1][3] = concat(h_variable_7736,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7737); matrix h_variable_7738 = h_variable_l[1]; matrix h_variable_7739 = h_variable_l[2];
ncols(h_variable_7738);
matrix h_variable_7740 = DecideZeroRows(h_variable_7738,h_variable_58);
IsZeroMatrix(h_variable_7740);
ZeroRows(h_variable_7740);
nrows(h_variable_7739);
matrix h_variable_7742 = submat(h_variable_7738,1..1,intvec( 2 ));
matrix h_variable_7741 = DecideZeroRows(h_variable_7742,h_variable_58);
IsZeroMatrix(h_variable_7741);
IsIdentityMatrix(h_variable_7741);
matrix h_variable_7743[1][3] = concat(h_variable_7741,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7743); matrix h_variable_7744 = h_variable_l[1]; matrix h_variable_7745 = h_variable_l[2];
IsZeroMatrix(h_variable_7744);
matrix h_variable_7746 = DecideZeroRows(h_variable_7744,h_variable_58);
IsZeroMatrix(h_variable_7746);
def h_variable_7747 = h_variable_4814[11,33];
h_variable_7747;
matrix h_variable_7748[1][1] = -2*x2*x3-2*x3^2;
matrix h_variable_7749[1][3] = concat(h_variable_7748,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7749); matrix h_variable_7750 = h_variable_l[1]; matrix h_variable_7751 = h_variable_l[2];
ncols(h_variable_7750);
matrix h_variable_7752 = DecideZeroRows(h_variable_7750,h_variable_58);
IsZeroMatrix(h_variable_7752);
ZeroRows(h_variable_7752);
nrows(h_variable_7751);
matrix h_variable_7754 = submat(h_variable_7750,1..1,intvec( 2 ));
matrix h_variable_7753 = DecideZeroRows(h_variable_7754,h_variable_58);
IsZeroMatrix(h_variable_7753);
IsIdentityMatrix(h_variable_7753);
matrix h_variable_7755[1][3] = concat(h_variable_7753,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7755); matrix h_variable_7756 = h_variable_l[1]; matrix h_variable_7757 = h_variable_l[2];
IsZeroMatrix(h_variable_7756);
matrix h_variable_7758 = DecideZeroRows(h_variable_7756,h_variable_58);
IsZeroMatrix(h_variable_7758);
def h_variable_7759 = h_variable_4814[2,33];
h_variable_7759;
matrix h_variable_7760[1][1] = 0;
matrix h_variable_7761[1][3] = concat(h_variable_7760,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7761); matrix h_variable_7762 = h_variable_l[1]; matrix h_variable_7763 = h_variable_l[2];
ncols(h_variable_7762);
matrix h_variable_7764 = DecideZeroRows(h_variable_7762,h_variable_58);
IsZeroMatrix(h_variable_7764);
nrows(h_variable_7763);
def h_variable_7765 = h_variable_4814[1,33];
h_variable_7765;
matrix h_variable_7766[1][1] = 0;
matrix h_variable_7767[1][3] = concat(h_variable_7766,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7767); matrix h_variable_7768 = h_variable_l[1]; matrix h_variable_7769 = h_variable_l[2];
ncols(h_variable_7768);
matrix h_variable_7770 = DecideZeroRows(h_variable_7768,h_variable_58);
IsZeroMatrix(h_variable_7770);
nrows(h_variable_7769);
def h_variable_7771 = h_variable_4814[16,34];
h_variable_7771;
matrix h_variable_7772[1][1] = 0;
matrix h_variable_7773[1][3] = concat(h_variable_7772,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7773); matrix h_variable_7774 = h_variable_l[1]; matrix h_variable_7775 = h_variable_l[2];
ncols(h_variable_7774);
matrix h_variable_7776 = DecideZeroRows(h_variable_7774,h_variable_58);
IsZeroMatrix(h_variable_7776);
nrows(h_variable_7775);
def h_variable_7777 = h_variable_4814[15,34];
h_variable_7777;
matrix h_variable_7778[1][1] = 0;
matrix h_variable_7779[1][3] = concat(h_variable_7778,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7779); matrix h_variable_7780 = h_variable_l[1]; matrix h_variable_7781 = h_variable_l[2];
ncols(h_variable_7780);
matrix h_variable_7782 = DecideZeroRows(h_variable_7780,h_variable_58);
IsZeroMatrix(h_variable_7782);
nrows(h_variable_7781);
def h_variable_7783 = h_variable_4814[14,34];
h_variable_7783;
matrix h_variable_7784[1][1] = 3*x2^2;
matrix h_variable_7785[1][3] = concat(h_variable_7784,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7785); matrix h_variable_7786 = h_variable_l[1]; matrix h_variable_7787 = h_variable_l[2];
ncols(h_variable_7786);
matrix h_variable_7788 = DecideZeroRows(h_variable_7786,h_variable_58);
IsZeroMatrix(h_variable_7788);
ZeroRows(h_variable_7788);
nrows(h_variable_7787);
matrix h_variable_7790 = submat(h_variable_7786,1..1,intvec( 2 ));
matrix h_variable_7789 = DecideZeroRows(h_variable_7790,h_variable_58);
IsZeroMatrix(h_variable_7789);
IsIdentityMatrix(h_variable_7789);
matrix h_variable_7791[1][3] = concat(h_variable_7789,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7791); matrix h_variable_7792 = h_variable_l[1]; matrix h_variable_7793 = h_variable_l[2];
IsZeroMatrix(h_variable_7792);
matrix h_variable_7794 = DecideZeroRows(h_variable_7792,h_variable_58);
IsZeroMatrix(h_variable_7794);
def h_variable_7795 = h_variable_4814[13,34];
h_variable_7795;
matrix h_variable_7796[1][1] = 3*x1*x2+3*x3^2;
matrix h_variable_7797[1][3] = concat(h_variable_7796,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7797); matrix h_variable_7798 = h_variable_l[1]; matrix h_variable_7799 = h_variable_l[2];
ncols(h_variable_7798);
matrix h_variable_7800 = DecideZeroRows(h_variable_7798,h_variable_58);
IsZeroMatrix(h_variable_7800);
ZeroRows(h_variable_7800);
nrows(h_variable_7799);
matrix h_variable_7802 = submat(h_variable_7798,1..1,intvec( 2 ));
matrix h_variable_7801 = DecideZeroRows(h_variable_7802,h_variable_58);
IsZeroMatrix(h_variable_7801);
IsIdentityMatrix(h_variable_7801);
matrix h_variable_7803[1][3] = concat(h_variable_7801,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7803); matrix h_variable_7804 = h_variable_l[1]; matrix h_variable_7805 = h_variable_l[2];
IsZeroMatrix(h_variable_7804);
matrix h_variable_7806 = DecideZeroRows(h_variable_7804,h_variable_58);
IsZeroMatrix(h_variable_7806);
def h_variable_7807 = h_variable_4814[12,34];
h_variable_7807;
matrix h_variable_7808[1][1] = 0;
matrix h_variable_7809[1][3] = concat(h_variable_7808,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7809); matrix h_variable_7810 = h_variable_l[1]; matrix h_variable_7811 = h_variable_l[2];
ncols(h_variable_7810);
matrix h_variable_7812 = DecideZeroRows(h_variable_7810,h_variable_58);
IsZeroMatrix(h_variable_7812);
nrows(h_variable_7811);
def h_variable_7813 = h_variable_4814[11,34];
h_variable_7813;
matrix h_variable_7814[1][1] = 0;
matrix h_variable_7815[1][3] = concat(h_variable_7814,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7815); matrix h_variable_7816 = h_variable_l[1]; matrix h_variable_7817 = h_variable_l[2];
ncols(h_variable_7816);
matrix h_variable_7818 = DecideZeroRows(h_variable_7816,h_variable_58);
IsZeroMatrix(h_variable_7818);
nrows(h_variable_7817);
def h_variable_7819 = h_variable_4814[2,34];
h_variable_7819;
matrix h_variable_7820[1][1] = 0;
matrix h_variable_7821[1][3] = concat(h_variable_7820,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7821); matrix h_variable_7822 = h_variable_l[1]; matrix h_variable_7823 = h_variable_l[2];
ncols(h_variable_7822);
matrix h_variable_7824 = DecideZeroRows(h_variable_7822,h_variable_58);
IsZeroMatrix(h_variable_7824);
nrows(h_variable_7823);
def h_variable_7825 = h_variable_4814[1,34];
h_variable_7825;
matrix h_variable_7826[1][1] = 0;
matrix h_variable_7827[1][3] = concat(h_variable_7826,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7827); matrix h_variable_7828 = h_variable_l[1]; matrix h_variable_7829 = h_variable_l[2];
ncols(h_variable_7828);
matrix h_variable_7830 = DecideZeroRows(h_variable_7828,h_variable_58);
IsZeroMatrix(h_variable_7830);
nrows(h_variable_7829);
def h_variable_7831 = h_variable_4814[16,35];
h_variable_7831;
matrix h_variable_7832[1][1] = -3*x2;
matrix h_variable_7833[1][3] = concat(h_variable_7832,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7833); matrix h_variable_7834 = h_variable_l[1]; matrix h_variable_7835 = h_variable_l[2];
ncols(h_variable_7834);
matrix h_variable_7836 = DecideZeroRows(h_variable_7834,h_variable_58);
IsZeroMatrix(h_variable_7836);
ZeroRows(h_variable_7836);
nrows(h_variable_7835);
matrix h_variable_7838 = submat(h_variable_7834,1..1,intvec( 2 ));
matrix h_variable_7837 = DecideZeroRows(h_variable_7838,h_variable_58);
IsZeroMatrix(h_variable_7837);
IsIdentityMatrix(h_variable_7837);
matrix h_variable_7839[1][3] = concat(h_variable_7837,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7839); matrix h_variable_7840 = h_variable_l[1]; matrix h_variable_7841 = h_variable_l[2];
IsZeroMatrix(h_variable_7840);
matrix h_variable_7842 = DecideZeroRows(h_variable_7840,h_variable_58);
IsZeroMatrix(h_variable_7842);
def h_variable_7843 = h_variable_4814[15,35];
h_variable_7843;
matrix h_variable_7844[1][1] = 0;
matrix h_variable_7845[1][3] = concat(h_variable_7844,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7845); matrix h_variable_7846 = h_variable_l[1]; matrix h_variable_7847 = h_variable_l[2];
ncols(h_variable_7846);
matrix h_variable_7848 = DecideZeroRows(h_variable_7846,h_variable_58);
IsZeroMatrix(h_variable_7848);
nrows(h_variable_7847);
def h_variable_7849 = h_variable_4814[14,35];
h_variable_7849;
matrix h_variable_7850[1][1] = 3*x1*x2+3*x1*x3-3*x2*x3;
matrix h_variable_7851[1][3] = concat(h_variable_7850,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7851); matrix h_variable_7852 = h_variable_l[1]; matrix h_variable_7853 = h_variable_l[2];
ncols(h_variable_7852);
matrix h_variable_7854 = DecideZeroRows(h_variable_7852,h_variable_58);
IsZeroMatrix(h_variable_7854);
ZeroRows(h_variable_7854);
nrows(h_variable_7853);
matrix h_variable_7856 = submat(h_variable_7852,1..1,intvec( 2 ));
matrix h_variable_7855 = DecideZeroRows(h_variable_7856,h_variable_58);
IsZeroMatrix(h_variable_7855);
IsIdentityMatrix(h_variable_7855);
matrix h_variable_7857[1][3] = concat(h_variable_7855,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7857); matrix h_variable_7858 = h_variable_l[1]; matrix h_variable_7859 = h_variable_l[2];
IsZeroMatrix(h_variable_7858);
matrix h_variable_7860 = DecideZeroRows(h_variable_7858,h_variable_58);
IsZeroMatrix(h_variable_7860);
def h_variable_7861 = h_variable_4814[13,35];
h_variable_7861;
matrix h_variable_7862[1][1] = 3*x1*x3;
matrix h_variable_7863[1][3] = concat(h_variable_7862,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7863); matrix h_variable_7864 = h_variable_l[1]; matrix h_variable_7865 = h_variable_l[2];
ncols(h_variable_7864);
matrix h_variable_7866 = DecideZeroRows(h_variable_7864,h_variable_58);
IsZeroMatrix(h_variable_7866);
ZeroRows(h_variable_7866);
nrows(h_variable_7865);
matrix h_variable_7868 = submat(h_variable_7864,1..1,intvec( 2 ));
matrix h_variable_7867 = DecideZeroRows(h_variable_7868,h_variable_58);
IsZeroMatrix(h_variable_7867);
IsIdentityMatrix(h_variable_7867);
matrix h_variable_7869[1][3] = concat(h_variable_7867,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7869); matrix h_variable_7870 = h_variable_l[1]; matrix h_variable_7871 = h_variable_l[2];
IsZeroMatrix(h_variable_7870);
matrix h_variable_7872 = DecideZeroRows(h_variable_7870,h_variable_58);
IsZeroMatrix(h_variable_7872);
def h_variable_7873 = h_variable_4814[12,35];
h_variable_7873;
matrix h_variable_7874[1][1] = -3*x2^2;
matrix h_variable_7875[1][3] = concat(h_variable_7874,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7875); matrix h_variable_7876 = h_variable_l[1]; matrix h_variable_7877 = h_variable_l[2];
ncols(h_variable_7876);
matrix h_variable_7878 = DecideZeroRows(h_variable_7876,h_variable_58);
IsZeroMatrix(h_variable_7878);
ZeroRows(h_variable_7878);
nrows(h_variable_7877);
matrix h_variable_7880 = submat(h_variable_7876,1..1,intvec( 2 ));
matrix h_variable_7879 = DecideZeroRows(h_variable_7880,h_variable_58);
IsZeroMatrix(h_variable_7879);
IsIdentityMatrix(h_variable_7879);
matrix h_variable_7881[1][3] = concat(h_variable_7879,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7881); matrix h_variable_7882 = h_variable_l[1]; matrix h_variable_7883 = h_variable_l[2];
IsZeroMatrix(h_variable_7882);
matrix h_variable_7884 = DecideZeroRows(h_variable_7882,h_variable_58);
IsZeroMatrix(h_variable_7884);
def h_variable_7885 = h_variable_4814[11,35];
h_variable_7885;
matrix h_variable_7886[1][1] = 0;
matrix h_variable_7887[1][3] = concat(h_variable_7886,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7887); matrix h_variable_7888 = h_variable_l[1]; matrix h_variable_7889 = h_variable_l[2];
ncols(h_variable_7888);
matrix h_variable_7890 = DecideZeroRows(h_variable_7888,h_variable_58);
IsZeroMatrix(h_variable_7890);
nrows(h_variable_7889);
def h_variable_7891 = h_variable_4814[2,35];
h_variable_7891;
matrix h_variable_7892[1][1] = 0;
matrix h_variable_7893[1][3] = concat(h_variable_7892,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7893); matrix h_variable_7894 = h_variable_l[1]; matrix h_variable_7895 = h_variable_l[2];
ncols(h_variable_7894);
matrix h_variable_7896 = DecideZeroRows(h_variable_7894,h_variable_58);
IsZeroMatrix(h_variable_7896);
nrows(h_variable_7895);
def h_variable_7897 = h_variable_4814[1,35];
h_variable_7897;
matrix h_variable_7898[1][1] = 0;
matrix h_variable_7899[1][3] = concat(h_variable_7898,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7899); matrix h_variable_7900 = h_variable_l[1]; matrix h_variable_7901 = h_variable_l[2];
ncols(h_variable_7900);
matrix h_variable_7902 = DecideZeroRows(h_variable_7900,h_variable_58);
IsZeroMatrix(h_variable_7902);
nrows(h_variable_7901);
def h_variable_7903 = h_variable_4814[16,36];
h_variable_7903;
matrix h_variable_7904[1][1] = 0;
matrix h_variable_7905[1][3] = concat(h_variable_7904,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7905); matrix h_variable_7906 = h_variable_l[1]; matrix h_variable_7907 = h_variable_l[2];
ncols(h_variable_7906);
matrix h_variable_7908 = DecideZeroRows(h_variable_7906,h_variable_58);
IsZeroMatrix(h_variable_7908);
nrows(h_variable_7907);
def h_variable_7909 = h_variable_4814[15,36];
h_variable_7909;
matrix h_variable_7910[1][1] = 0;
matrix h_variable_7911[1][3] = concat(h_variable_7910,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7911); matrix h_variable_7912 = h_variable_l[1]; matrix h_variable_7913 = h_variable_l[2];
ncols(h_variable_7912);
matrix h_variable_7914 = DecideZeroRows(h_variable_7912,h_variable_58);
IsZeroMatrix(h_variable_7914);
nrows(h_variable_7913);
def h_variable_7915 = h_variable_4814[14,36];
h_variable_7915;
matrix h_variable_7916[1][1] = 0;
matrix h_variable_7917[1][3] = concat(h_variable_7916,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7917); matrix h_variable_7918 = h_variable_l[1]; matrix h_variable_7919 = h_variable_l[2];
ncols(h_variable_7918);
matrix h_variable_7920 = DecideZeroRows(h_variable_7918,h_variable_58);
IsZeroMatrix(h_variable_7920);
nrows(h_variable_7919);
def h_variable_7921 = h_variable_4814[13,36];
h_variable_7921;
matrix h_variable_7922[1][1] = 0;
matrix h_variable_7923[1][3] = concat(h_variable_7922,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7923); matrix h_variable_7924 = h_variable_l[1]; matrix h_variable_7925 = h_variable_l[2];
ncols(h_variable_7924);
matrix h_variable_7926 = DecideZeroRows(h_variable_7924,h_variable_58);
IsZeroMatrix(h_variable_7926);
nrows(h_variable_7925);
def h_variable_7927 = h_variable_4814[12,36];
h_variable_7927;
matrix h_variable_7928[1][1] = 0;
matrix h_variable_7929[1][3] = concat(h_variable_7928,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7929); matrix h_variable_7930 = h_variable_l[1]; matrix h_variable_7931 = h_variable_l[2];
ncols(h_variable_7930);
matrix h_variable_7932 = DecideZeroRows(h_variable_7930,h_variable_58);
IsZeroMatrix(h_variable_7932);
nrows(h_variable_7931);
def h_variable_7933 = h_variable_4814[11,36];
h_variable_7933;
matrix h_variable_7934[1][1] = -2*a7+4;
matrix h_variable_7935[1][3] = concat(h_variable_7934,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7935); matrix h_variable_7936 = h_variable_l[1]; matrix h_variable_7937 = h_variable_l[2];
ncols(h_variable_7936);
matrix h_variable_7938 = DecideZeroRows(h_variable_7936,h_variable_58);
IsZeroMatrix(h_variable_7938);
ZeroRows(h_variable_7938);
nrows(h_variable_7937);
matrix h_variable_7940 = submat(h_variable_7936,1..1,intvec( 2 ));
matrix h_variable_7939 = DecideZeroRows(h_variable_7940,h_variable_58);
IsZeroMatrix(h_variable_7939);
IsIdentityMatrix(h_variable_7939);
matrix h_variable_7941[1][3] = concat(h_variable_7939,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7941); matrix h_variable_7942 = h_variable_l[1]; matrix h_variable_7943 = h_variable_l[2];
IsZeroMatrix(h_variable_7942);
matrix h_variable_7944 = DecideZeroRows(h_variable_7942,h_variable_58);
IsZeroMatrix(h_variable_7944);
def h_variable_7945 = h_variable_4814[2,36];
h_variable_7945;
matrix h_variable_7946[1][1] = 0;
matrix h_variable_7947[1][3] = concat(h_variable_7946,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7947); matrix h_variable_7948 = h_variable_l[1]; matrix h_variable_7949 = h_variable_l[2];
ncols(h_variable_7948);
matrix h_variable_7950 = DecideZeroRows(h_variable_7948,h_variable_58);
IsZeroMatrix(h_variable_7950);
nrows(h_variable_7949);
def h_variable_7951 = h_variable_4814[1,36];
h_variable_7951;
matrix h_variable_7952[1][1] = 0;
matrix h_variable_7953[1][3] = concat(h_variable_7952,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7953); matrix h_variable_7954 = h_variable_l[1]; matrix h_variable_7955 = h_variable_l[2];
ncols(h_variable_7954);
matrix h_variable_7956 = DecideZeroRows(h_variable_7954,h_variable_58);
IsZeroMatrix(h_variable_7956);
nrows(h_variable_7955);
def h_variable_7957 = h_variable_4814[16,37];
h_variable_7957;
matrix h_variable_7958[1][1] = 0;
matrix h_variable_7959[1][3] = concat(h_variable_7958,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7959); matrix h_variable_7960 = h_variable_l[1]; matrix h_variable_7961 = h_variable_l[2];
ncols(h_variable_7960);
matrix h_variable_7962 = DecideZeroRows(h_variable_7960,h_variable_58);
IsZeroMatrix(h_variable_7962);
nrows(h_variable_7961);
def h_variable_7963 = h_variable_4814[15,37];
h_variable_7963;
matrix h_variable_7964[1][1] = 0;
matrix h_variable_7965[1][3] = concat(h_variable_7964,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7965); matrix h_variable_7966 = h_variable_l[1]; matrix h_variable_7967 = h_variable_l[2];
ncols(h_variable_7966);
matrix h_variable_7968 = DecideZeroRows(h_variable_7966,h_variable_58);
IsZeroMatrix(h_variable_7968);
nrows(h_variable_7967);
def h_variable_7969 = h_variable_4814[14,37];
h_variable_7969;
matrix h_variable_7970[1][1] = 0;
matrix h_variable_7971[1][3] = concat(h_variable_7970,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7971); matrix h_variable_7972 = h_variable_l[1]; matrix h_variable_7973 = h_variable_l[2];
ncols(h_variable_7972);
matrix h_variable_7974 = DecideZeroRows(h_variable_7972,h_variable_58);
IsZeroMatrix(h_variable_7974);
nrows(h_variable_7973);
def h_variable_7975 = h_variable_4814[13,37];
h_variable_7975;
matrix h_variable_7976[1][1] = 0;
matrix h_variable_7977[1][3] = concat(h_variable_7976,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7977); matrix h_variable_7978 = h_variable_l[1]; matrix h_variable_7979 = h_variable_l[2];
ncols(h_variable_7978);
matrix h_variable_7980 = DecideZeroRows(h_variable_7978,h_variable_58);
IsZeroMatrix(h_variable_7980);
nrows(h_variable_7979);
def h_variable_7981 = h_variable_4814[12,37];
h_variable_7981;
matrix h_variable_7982[1][1] = 0;
matrix h_variable_7983[1][3] = concat(h_variable_7982,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7983); matrix h_variable_7984 = h_variable_l[1]; matrix h_variable_7985 = h_variable_l[2];
ncols(h_variable_7984);
matrix h_variable_7986 = DecideZeroRows(h_variable_7984,h_variable_58);
IsZeroMatrix(h_variable_7986);
nrows(h_variable_7985);
def h_variable_7987 = h_variable_4814[11,37];
h_variable_7987;
matrix h_variable_7988[1][1] = -3;
matrix h_variable_7989[1][3] = concat(h_variable_7988,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_7989); matrix h_variable_7990 = h_variable_l[1]; matrix h_variable_7991 = h_variable_l[2];
ncols(h_variable_7990);
matrix h_variable_7992 = DecideZeroRows(h_variable_7990,h_variable_58);
IsZeroMatrix(h_variable_7992);
ZeroRows(h_variable_7992);
nrows(h_variable_7991);
matrix h_variable_7994 = submat(h_variable_7990,1..1,intvec( 1 ));
matrix h_variable_7993 = DecideZeroRows(h_variable_7994,h_variable_58);
IsZeroMatrix(h_variable_7993);
IsIdentityMatrix(h_variable_7993);
matrix h_variable_7995[1][3] = concat(h_variable_7993,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_7995); matrix h_variable_7996 = h_variable_l[1]; matrix h_variable_7997 = h_variable_l[2];
IsZeroMatrix(h_variable_7996);
matrix h_variable_7998 = DecideZeroRows(h_variable_7996,h_variable_58);
IsZeroMatrix(h_variable_7998);
def h_variable_7999 = h_variable_4814[2,37];
h_variable_7999;
matrix h_variable_8000[1][1] = 0;
kill h_variable_7465;kill h_variable_7466;kill h_variable_7467;kill h_variable_7468;kill h_variable_7470;kill h_variable_7471;kill h_variable_7472;kill h_variable_7473;kill h_variable_7474;kill h_variable_7476;kill h_variable_7480;kill h_variable_7482;kill h_variable_7483;kill h_variable_7484;kill h_variable_7485;kill h_variable_7486;kill h_variable_7487;kill h_variable_7488;kill h_variable_7489;kill h_variable_7490;kill h_variable_7491;kill h_variable_7492;kill h_variable_7493;kill h_variable_7494;kill h_variable_7495;kill h_variable_7496;kill h_variable_7497;kill h_variable_7498;kill h_variable_7499;kill h_variable_7500;kill h_variable_7501;kill h_variable_7502;kill h_variable_7503;kill h_variable_7504;kill h_variable_7505;kill h_variable_7506;kill h_variable_7507;kill h_variable_7508;kill h_variable_7509;kill h_variable_7510;kill h_variable_7511;kill h_variable_7512;kill h_variable_7513;kill h_variable_7514;kill h_variable_7515;kill h_variable_7516;kill h_variable_7517;kill h_variable_7518;kill h_variable_7519;kill h_variable_7520;kill h_variable_7521;kill h_variable_7522;kill h_variable_7523;kill h_variable_7524;kill h_variable_7525;kill h_variable_7526;kill h_variable_7527;kill h_variable_7528;kill h_variable_7529;kill h_variable_7530;kill h_variable_7531;kill h_variable_7532;kill h_variable_7533;kill h_variable_7534;kill h_variable_7535;kill h_variable_7536;kill h_variable_7537;kill h_variable_7538;kill h_variable_7539;kill h_variable_7540;kill h_variable_7541;kill h_variable_7542;kill h_variable_7543;kill h_variable_7544;kill h_variable_7545;kill h_variable_7546;kill h_variable_7547;kill h_variable_7548;kill h_variable_7549;kill h_variable_7550;kill h_variable_7551;kill h_variable_7552;kill h_variable_7553;kill h_variable_7554;kill h_variable_7555;kill h_variable_7556;kill h_variable_7557;kill h_variable_7558;kill h_variable_7559;kill h_variable_7560;kill h_variable_7561;kill h_variable_7562;kill h_variable_7563;kill h_variable_7564;kill h_variable_7565;kill h_variable_7566;kill h_variable_7567;kill h_variable_7568;kill h_variable_7569;kill h_variable_7570;kill h_variable_7571;kill h_variable_7572;kill h_variable_7573;kill h_variable_7574;kill h_variable_7575;kill h_variable_7576;kill h_variable_7577;kill h_variable_7578;kill h_variable_7579;kill h_variable_7580;kill h_variable_7581;kill h_variable_7582;kill h_variable_7583;kill h_variable_7584;kill h_variable_7585;kill h_variable_7586;kill h_variable_7587;kill h_variable_7588;kill h_variable_7589;kill h_variable_7590;kill h_variable_7591;kill h_variable_7592;kill h_variable_7593;kill h_variable_7594;kill h_variable_7595;kill h_variable_7596;kill h_variable_7605;kill h_variable_7606;kill h_variable_7607;kill h_variable_7608;kill h_variable_7610;kill h_variable_7611;kill h_variable_7612;kill h_variable_7613;kill h_variable_7614;kill h_variable_7616;kill h_variable_7617;kill h_variable_7618;kill h_variable_7619;kill h_variable_7620;kill h_variable_7621;kill h_variable_7622;kill h_variable_7623;kill h_variable_7624;kill h_variable_7625;kill h_variable_7626;kill h_variable_7627;kill h_variable_7628;kill h_variable_7629;kill h_variable_7630;kill h_variable_7631;kill h_variable_7632;kill h_variable_7633;kill h_variable_7634;kill h_variable_7635;kill h_variable_7636;kill h_variable_7637;kill h_variable_7638;kill h_variable_7639;kill h_variable_7640;kill h_variable_7641;kill h_variable_7642;kill h_variable_7643;kill h_variable_7644;kill h_variable_7645;kill h_variable_7646;kill h_variable_7647;kill h_variable_7648;kill h_variable_7649;kill h_variable_7650;kill h_variable_7651;kill h_variable_7652;kill h_variable_7653;kill h_variable_7654;kill h_variable_7655;kill h_variable_7656;kill h_variable_7657;kill h_variable_7658;kill h_variable_7659;kill h_variable_7660;kill h_variable_7661;kill h_variable_7662;kill h_variable_7663;kill h_variable_7664;kill h_variable_7665;kill h_variable_7666;kill h_variable_7667;kill h_variable_7668;kill h_variable_7669;kill h_variable_7670;kill h_variable_7671;kill h_variable_7672;kill h_variable_7673;kill h_variable_7674;kill h_variable_7675;kill h_variable_7676;kill h_variable_7677;kill h_variable_7678;kill h_variable_7679;kill h_variable_7680;kill h_variable_7681;kill h_variable_7682;kill h_variable_7683;kill h_variable_7684;kill h_variable_7685;kill h_variable_7686;kill h_variable_7687;kill h_variable_7688;kill h_variable_7689;kill h_variable_7690;kill h_variable_7691;kill h_variable_7692;kill h_variable_7693;kill h_variable_7694;kill h_variable_7695;kill h_variable_7696;kill h_variable_7697;kill h_variable_7698;kill h_variable_7699;kill h_variable_7700;kill h_variable_7701;kill h_variable_7702;kill h_variable_7703;kill h_variable_7704;kill h_variable_7705;kill h_variable_7706;kill h_variable_7707;kill h_variable_7708;kill h_variable_7709;kill h_variable_7710;kill h_variable_7711;kill h_variable_7712;kill h_variable_7713;kill h_variable_7714;kill h_variable_7715;kill h_variable_7716;kill h_variable_7717;kill h_variable_7718;kill h_variable_7719;kill h_variable_7720;kill h_variable_7721;kill h_variable_7722;kill h_variable_7723;kill h_variable_7724;kill h_variable_7725;kill h_variable_7726;kill h_variable_7727;kill h_variable_7728;kill h_variable_7729;kill h_variable_7730;kill h_variable_7731;kill h_variable_7732;kill h_variable_7733;kill h_variable_7734;kill h_variable_7735;kill h_variable_7736;kill h_variable_7737;kill h_variable_7738;kill h_variable_7739;kill h_variable_7740;kill h_variable_7741;kill h_variable_7742;kill h_variable_7743;kill h_variable_7744;kill h_variable_7745;kill h_variable_7746;kill h_variable_7747;kill h_variable_7748;kill h_variable_7749;kill h_variable_7750;kill h_variable_7751;kill h_variable_7752;kill h_variable_7753;kill h_variable_7754;kill h_variable_7755;kill h_variable_7756;kill h_variable_7757;kill h_variable_7758;kill h_variable_7759;kill h_variable_7760;kill h_variable_7761;kill h_variable_7762;kill h_variable_7763;kill h_variable_7764;kill h_variable_7765;kill h_variable_7766;kill h_variable_7767;kill h_variable_7768;kill h_variable_7769;kill h_variable_7770;kill h_variable_7771;kill h_variable_7772;kill h_variable_7773;kill h_variable_7774;kill h_variable_7775;kill h_variable_7776;kill h_variable_7785;kill h_variable_7788;kill h_variable_7790;kill h_variable_7794;kill h_variable_7796;kill h_variable_7797;kill h_variable_7798;kill h_variable_7799;kill h_variable_7800;kill h_variable_7802;kill h_variable_7806;kill h_variable_7807;kill h_variable_7808;kill h_variable_7809;kill h_variable_7810;kill h_variable_7811;kill h_variable_7812;kill h_variable_7813;kill h_variable_7814;kill h_variable_7815;kill h_variable_7816;kill h_variable_7817;kill h_variable_7818;kill h_variable_7819;kill h_variable_7820;kill h_variable_7821;kill h_variable_7822;kill h_variable_7823;kill h_variable_7824;kill h_variable_7825;kill h_variable_7826;kill h_variable_7827;kill h_variable_7828;kill h_variable_7829;kill h_variable_7830;kill h_variable_7831;kill h_variable_7832;kill h_variable_7833;kill h_variable_7834;kill h_variable_7835;kill h_variable_7836;kill h_variable_7837;kill h_variable_7838;kill h_variable_7839;kill h_variable_7840;kill h_variable_7841;kill h_variable_7842;kill h_variable_7843;kill h_variable_7844;kill h_variable_7845;kill h_variable_7846;kill h_variable_7847;kill h_variable_7848;kill h_variable_7849;kill h_variable_7850;kill h_variable_7851;kill h_variable_7852;kill h_variable_7853;kill h_variable_7854;kill h_variable_7855;kill h_variable_7856;kill h_variable_7857;kill h_variable_7858;kill h_variable_7859;kill h_variable_7860;kill h_variable_7861;kill h_variable_7862;kill h_variable_7863;kill h_variable_7864;kill h_variable_7865;kill h_variable_7866;kill h_variable_7867;kill h_variable_7868;kill h_variable_7869;kill h_variable_7870;kill h_variable_7871;kill h_variable_7872;kill h_variable_7873;kill h_variable_7874;kill h_variable_7875;kill h_variable_7876;kill h_variable_7877;kill h_variable_7878;kill h_variable_7879;kill h_variable_7880;kill h_variable_7881;kill h_variable_7882;kill h_variable_7883;kill h_variable_7884;kill h_variable_7885;kill h_variable_7886;kill h_variable_7887;kill h_variable_7888;kill h_variable_7889;kill h_variable_7890;kill h_variable_7891;kill h_variable_7892;kill h_variable_7893;kill h_variable_7894;kill h_variable_7895;kill h_variable_7896;kill h_variable_7897;kill h_variable_7898;kill h_variable_7899;kill h_variable_7900;kill h_variable_7901;kill h_variable_7902;kill h_variable_7903;kill h_variable_7904;kill h_variable_7905;kill h_variable_7906;kill h_variable_7907;kill h_variable_7908;kill h_variable_7909;kill h_variable_7910;kill h_variable_7911;kill h_variable_7912;kill h_variable_7913;kill h_variable_7914;kill h_variable_7915;kill h_variable_7916;kill h_variable_7917;kill h_variable_7918;kill h_variable_7919;kill h_variable_7920;kill h_variable_7921;kill h_variable_7922;kill h_variable_7923;kill h_variable_7924;kill h_variable_7925;kill h_variable_7926;kill h_variable_7927;kill h_variable_7928;kill h_variable_7929;kill h_variable_7930;kill h_variable_7931;kill h_variable_7932;kill h_variable_7933;kill h_variable_7934;kill h_variable_7935;kill h_variable_7936;kill h_variable_7937;kill h_variable_7938;kill h_variable_7939;kill h_variable_7940;kill h_variable_7941;kill h_variable_7942;kill h_variable_7943;kill h_variable_7944;kill h_variable_7945;kill h_variable_7946;kill h_variable_7947;kill h_variable_7948;kill h_variable_7949;kill h_variable_7950;kill h_variable_7951;kill h_variable_7952;kill h_variable_7953;kill h_variable_7954;kill h_variable_7955;kill h_variable_7956;kill h_variable_7957;kill h_variable_7958;kill h_variable_7959;kill h_variable_7960;kill h_variable_7961;kill h_variable_7962;
matrix h_variable_8001[1][3] = concat(h_variable_8000,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8001); matrix h_variable_8002 = h_variable_l[1]; matrix h_variable_8003 = h_variable_l[2];
ncols(h_variable_8002);
matrix h_variable_8004 = DecideZeroRows(h_variable_8002,h_variable_58);
IsZeroMatrix(h_variable_8004);
nrows(h_variable_8003);
def h_variable_8005 = h_variable_4814[1,37];
h_variable_8005;
matrix h_variable_8006[1][1] = 0;
matrix h_variable_8007[1][3] = concat(h_variable_8006,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8007); matrix h_variable_8008 = h_variable_l[1]; matrix h_variable_8009 = h_variable_l[2];
ncols(h_variable_8008);
matrix h_variable_8010 = DecideZeroRows(h_variable_8008,h_variable_58);
IsZeroMatrix(h_variable_8010);
nrows(h_variable_8009);
def h_variable_8011 = h_variable_4814[16,38];
h_variable_8011;
matrix h_variable_8012[1][1] = 0;
matrix h_variable_8013[1][3] = concat(h_variable_8012,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8013); matrix h_variable_8014 = h_variable_l[1]; matrix h_variable_8015 = h_variable_l[2];
ncols(h_variable_8014);
matrix h_variable_8016 = DecideZeroRows(h_variable_8014,h_variable_58);
IsZeroMatrix(h_variable_8016);
nrows(h_variable_8015);
def h_variable_8017 = h_variable_4814[15,38];
h_variable_8017;
matrix h_variable_8018[1][1] = 0;
matrix h_variable_8019[1][3] = concat(h_variable_8018,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8019); matrix h_variable_8020 = h_variable_l[1]; matrix h_variable_8021 = h_variable_l[2];
ncols(h_variable_8020);
matrix h_variable_8022 = DecideZeroRows(h_variable_8020,h_variable_58);
IsZeroMatrix(h_variable_8022);
nrows(h_variable_8021);
def h_variable_8023 = h_variable_4814[14,38];
h_variable_8023;
matrix h_variable_8024[1][1] = 0;
matrix h_variable_8025[1][3] = concat(h_variable_8024,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8025); matrix h_variable_8026 = h_variable_l[1]; matrix h_variable_8027 = h_variable_l[2];
ncols(h_variable_8026);
matrix h_variable_8028 = DecideZeroRows(h_variable_8026,h_variable_58);
IsZeroMatrix(h_variable_8028);
nrows(h_variable_8027);
def h_variable_8029 = h_variable_4814[13,38];
h_variable_8029;
matrix h_variable_8030[1][1] = 0;
matrix h_variable_8031[1][3] = concat(h_variable_8030,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8031); matrix h_variable_8032 = h_variable_l[1]; matrix h_variable_8033 = h_variable_l[2];
ncols(h_variable_8032);
matrix h_variable_8034 = DecideZeroRows(h_variable_8032,h_variable_58);
IsZeroMatrix(h_variable_8034);
nrows(h_variable_8033);
def h_variable_8035 = h_variable_4814[12,38];
h_variable_8035;
matrix h_variable_8036[1][1] = 0;
matrix h_variable_8037[1][3] = concat(h_variable_8036,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8037); matrix h_variable_8038 = h_variable_l[1]; matrix h_variable_8039 = h_variable_l[2];
ncols(h_variable_8038);
matrix h_variable_8040 = DecideZeroRows(h_variable_8038,h_variable_58);
IsZeroMatrix(h_variable_8040);
nrows(h_variable_8039);
def h_variable_8041 = h_variable_4814[11,38];
h_variable_8041;
matrix h_variable_8042[1][1] = a7+1;
matrix h_variable_8043[1][3] = concat(h_variable_8042,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8043); matrix h_variable_8044 = h_variable_l[1]; matrix h_variable_8045 = h_variable_l[2];
ncols(h_variable_8044);
matrix h_variable_8046 = DecideZeroRows(h_variable_8044,h_variable_58);
IsZeroMatrix(h_variable_8046);
ZeroRows(h_variable_8046);
nrows(h_variable_8045);
matrix h_variable_8047[1][4] = concat(h_variable_8044,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8047); matrix h_variable_8048 = h_variable_l[1]; matrix h_variable_8049 = h_variable_l[2];
IsZeroMatrix(h_variable_8048);
matrix h_variable_8050 = DecideZeroRows(h_variable_8048,h_variable_58);
IsZeroMatrix(h_variable_8050);
def h_variable_8051 = h_variable_4814[2,38];
h_variable_8051;
matrix h_variable_8052[1][1] = 0;
matrix h_variable_8053[1][3] = concat(h_variable_8052,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8053); matrix h_variable_8054 = h_variable_l[1]; matrix h_variable_8055 = h_variable_l[2];
ncols(h_variable_8054);
matrix h_variable_8056 = DecideZeroRows(h_variable_8054,h_variable_58);
IsZeroMatrix(h_variable_8056);
nrows(h_variable_8055);
def h_variable_8057 = h_variable_4814[1,38];
h_variable_8057;
matrix h_variable_8058[1][1] = 0;
matrix h_variable_8059[1][3] = concat(h_variable_8058,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8059); matrix h_variable_8060 = h_variable_l[1]; matrix h_variable_8061 = h_variable_l[2];
ncols(h_variable_8060);
matrix h_variable_8062 = DecideZeroRows(h_variable_8060,h_variable_58);
IsZeroMatrix(h_variable_8062);
nrows(h_variable_8061);
def h_variable_8063 = h_variable_4814[16,39];
h_variable_8063;
matrix h_variable_8064[1][1] = 0;
matrix h_variable_8065[1][3] = concat(h_variable_8064,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8065); matrix h_variable_8066 = h_variable_l[1]; matrix h_variable_8067 = h_variable_l[2];
ncols(h_variable_8066);
matrix h_variable_8068 = DecideZeroRows(h_variable_8066,h_variable_58);
IsZeroMatrix(h_variable_8068);
nrows(h_variable_8067);
def h_variable_8069 = h_variable_4814[15,39];
h_variable_8069;
matrix h_variable_8070[1][1] = 0;
matrix h_variable_8071[1][3] = concat(h_variable_8070,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8071); matrix h_variable_8072 = h_variable_l[1]; matrix h_variable_8073 = h_variable_l[2];
ncols(h_variable_8072);
matrix h_variable_8074 = DecideZeroRows(h_variable_8072,h_variable_58);
IsZeroMatrix(h_variable_8074);
nrows(h_variable_8073);
def h_variable_8075 = h_variable_4814[14,39];
h_variable_8075;
matrix h_variable_8076[1][1] = 0;
matrix h_variable_8077[1][3] = concat(h_variable_8076,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8077); matrix h_variable_8078 = h_variable_l[1]; matrix h_variable_8079 = h_variable_l[2];
ncols(h_variable_8078);
matrix h_variable_8080 = DecideZeroRows(h_variable_8078,h_variable_58);
IsZeroMatrix(h_variable_8080);
nrows(h_variable_8079);
def h_variable_8081 = h_variable_4814[13,39];
h_variable_8081;
matrix h_variable_8082[1][1] = 0;
matrix h_variable_8083[1][3] = concat(h_variable_8082,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8083); matrix h_variable_8084 = h_variable_l[1]; matrix h_variable_8085 = h_variable_l[2];
ncols(h_variable_8084);
matrix h_variable_8086 = DecideZeroRows(h_variable_8084,h_variable_58);
IsZeroMatrix(h_variable_8086);
nrows(h_variable_8085);
def h_variable_8087 = h_variable_4814[12,39];
h_variable_8087;
matrix h_variable_8088[1][1] = 0;
matrix h_variable_8089[1][3] = concat(h_variable_8088,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8089); matrix h_variable_8090 = h_variable_l[1]; matrix h_variable_8091 = h_variable_l[2];
ncols(h_variable_8090);
matrix h_variable_8092 = DecideZeroRows(h_variable_8090,h_variable_58);
IsZeroMatrix(h_variable_8092);
nrows(h_variable_8091);
def h_variable_8093 = h_variable_4814[11,39];
h_variable_8093;
matrix h_variable_8094[1][1] = 0;
matrix h_variable_8095[1][3] = concat(h_variable_8094,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8095); matrix h_variable_8096 = h_variable_l[1]; matrix h_variable_8097 = h_variable_l[2];
ncols(h_variable_8096);
matrix h_variable_8098 = DecideZeroRows(h_variable_8096,h_variable_58);
IsZeroMatrix(h_variable_8098);
nrows(h_variable_8097);
def h_variable_8099 = h_variable_4814[2,39];
h_variable_8099;
matrix h_variable_8100[1][1] = 0;
matrix h_variable_8101[1][3] = concat(h_variable_8100,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8101); matrix h_variable_8102 = h_variable_l[1]; matrix h_variable_8103 = h_variable_l[2];
ncols(h_variable_8102);
matrix h_variable_8104 = DecideZeroRows(h_variable_8102,h_variable_58);
IsZeroMatrix(h_variable_8104);
nrows(h_variable_8103);
def h_variable_8105 = h_variable_4814[1,39];
h_variable_8105;
matrix h_variable_8106[1][1] = 0;
matrix h_variable_8107[1][3] = concat(h_variable_8106,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8107); matrix h_variable_8108 = h_variable_l[1]; matrix h_variable_8109 = h_variable_l[2];
ncols(h_variable_8108);
matrix h_variable_8110 = DecideZeroRows(h_variable_8108,h_variable_58);
IsZeroMatrix(h_variable_8110);
nrows(h_variable_8109);
def h_variable_8111 = h_variable_4814[16,40];
h_variable_8111;
matrix h_variable_8112[1][1] = 0;
matrix h_variable_8113[1][3] = concat(h_variable_8112,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8113); matrix h_variable_8114 = h_variable_l[1]; matrix h_variable_8115 = h_variable_l[2];
ncols(h_variable_8114);
matrix h_variable_8116 = DecideZeroRows(h_variable_8114,h_variable_58);
IsZeroMatrix(h_variable_8116);
nrows(h_variable_8115);
def h_variable_8117 = h_variable_4814[15,40];
h_variable_8117;
matrix h_variable_8118[1][1] = 0;
matrix h_variable_8119[1][3] = concat(h_variable_8118,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8119); matrix h_variable_8120 = h_variable_l[1]; matrix h_variable_8121 = h_variable_l[2];
ncols(h_variable_8120);
matrix h_variable_8122 = DecideZeroRows(h_variable_8120,h_variable_58);
IsZeroMatrix(h_variable_8122);
nrows(h_variable_8121);
def h_variable_8123 = h_variable_4814[14,40];
h_variable_8123;
matrix h_variable_8124[1][1] = -a7+4;
matrix h_variable_8125[1][3] = concat(h_variable_8124,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8125); matrix h_variable_8126 = h_variable_l[1]; matrix h_variable_8127 = h_variable_l[2];
ncols(h_variable_8126);
matrix h_variable_8128 = DecideZeroRows(h_variable_8126,h_variable_58);
IsZeroMatrix(h_variable_8128);
nrows(h_variable_8127);
IsIdentityMatrix(h_variable_8128);
def h_variable_8129 = h_variable_4814[1,40];
h_variable_8129;
matrix h_variable_8130[1][1] = 0;
matrix h_variable_8131 = DecideZeroRows(h_variable_8130,h_variable_58);
IsZeroMatrix(h_variable_8131);
def h_variable_8132 = h_variable_8131[1,1];
h_variable_8132==0;
def h_variable_8133 = h_variable_4814[2,40];
h_variable_8133;
matrix h_variable_8134[1][1] = 0;
matrix h_variable_8135 = DecideZeroRows(h_variable_8134,h_variable_58);
IsZeroMatrix(h_variable_8135);
def h_variable_8136 = h_variable_8135[1,1];
h_variable_8136==0;
def h_variable_8137 = h_variable_4814[11,40];
h_variable_8137;
matrix h_variable_8138[1][1] = 4*a7*x2+2*x2-4*x3;
matrix h_variable_8139 = DecideZeroRows(h_variable_8138,h_variable_58);
IsZeroMatrix(h_variable_8139);
def h_variable_8140 = h_variable_8139[1,1];
h_variable_8140==0;
def h_variable_8141 = h_variable_4814[12,40];
h_variable_8141;
matrix h_variable_8142[1][1] = -4*a7+1;
matrix h_variable_8143 = DecideZeroRows(h_variable_8142,h_variable_58);
IsZeroMatrix(h_variable_8143);
def h_variable_8144 = h_variable_8143[1,1];
h_variable_8144==0;
def h_variable_8145 = h_variable_4814[13,40];
h_variable_8145;
matrix h_variable_8146[1][1] = -3*a7+5;
matrix h_variable_8147 = DecideZeroRows(h_variable_8146,h_variable_58);
IsZeroMatrix(h_variable_8147);
def h_variable_8148 = h_variable_8147[1,1];
h_variable_8148==0;
def h_variable_8149 = h_variable_4814[14,40];
h_variable_8149;
matrix h_variable_8150[1][1] = -a7+4;
matrix h_variable_8151 = DecideZeroRows(h_variable_8150,h_variable_58);
IsZeroMatrix(h_variable_8151);
def h_variable_8152 = h_variable_8151[1,1];
h_variable_8152==0;
def h_variable_8153 = h_variable_4814[15,40];
h_variable_8153;
matrix h_variable_8154[1][1] = 0;
matrix h_variable_8155 = DecideZeroRows(h_variable_8154,h_variable_58);
IsZeroMatrix(h_variable_8155);
def h_variable_8156 = h_variable_8155[1,1];
h_variable_8156==0;
def h_variable_8157 = h_variable_4814[16,40];
h_variable_8157;
matrix h_variable_8158[1][1] = 0;
matrix h_variable_8159 = DecideZeroRows(h_variable_8158,h_variable_58);
IsZeroMatrix(h_variable_8159);
def h_variable_8160 = h_variable_8159[1,1];
h_variable_8160==0;
def h_variable_8161 = h_variable_4814[16,41];
h_variable_8161;
matrix h_variable_8162[1][1] = 3;
matrix h_variable_8163[1][3] = concat(h_variable_8162,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8163); matrix h_variable_8164 = h_variable_l[1]; matrix h_variable_8165 = h_variable_l[2];
ncols(h_variable_8164);
matrix h_variable_8166 = DecideZeroRows(h_variable_8164,h_variable_58);
IsZeroMatrix(h_variable_8166);
ZeroRows(h_variable_8166);
nrows(h_variable_8165);
matrix h_variable_8168 = submat(h_variable_8164,1..1,intvec( 1 ));
matrix h_variable_8167 = DecideZeroRows(h_variable_8168,h_variable_58);
IsZeroMatrix(h_variable_8167);
IsIdentityMatrix(h_variable_8167);
matrix h_variable_8169[1][3] = concat(h_variable_8167,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8169); matrix h_variable_8170 = h_variable_l[1]; matrix h_variable_8171 = h_variable_l[2];
IsZeroMatrix(h_variable_8170);
matrix h_variable_8172 = DecideZeroRows(h_variable_8170,h_variable_58);
IsZeroMatrix(h_variable_8172);
def h_variable_8173 = h_variable_4814[15,41];
h_variable_8173;
matrix h_variable_8174[1][1] = 0;
matrix h_variable_8175[1][3] = concat(h_variable_8174,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8175); matrix h_variable_8176 = h_variable_l[1]; matrix h_variable_8177 = h_variable_l[2];
ncols(h_variable_8176);
matrix h_variable_8178 = DecideZeroRows(h_variable_8176,h_variable_58);
IsZeroMatrix(h_variable_8178);
nrows(h_variable_8177);
def h_variable_8179 = h_variable_4814[2,41];
h_variable_8179;
matrix h_variable_8180[1][1] = 0;
matrix h_variable_8181[1][3] = concat(h_variable_8180,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8181); matrix h_variable_8182 = h_variable_l[1]; matrix h_variable_8183 = h_variable_l[2];
ncols(h_variable_8182);
matrix h_variable_8184 = DecideZeroRows(h_variable_8182,h_variable_58);
IsZeroMatrix(h_variable_8184);
nrows(h_variable_8183);
def h_variable_8185 = h_variable_4814[1,41];
h_variable_8185;
matrix h_variable_8186[1][1] = 0;
matrix h_variable_8187[1][3] = concat(h_variable_8186,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8187); matrix h_variable_8188 = h_variable_l[1]; matrix h_variable_8189 = h_variable_l[2];
ncols(h_variable_8188);
matrix h_variable_8190 = DecideZeroRows(h_variable_8188,h_variable_58);
IsZeroMatrix(h_variable_8190);
nrows(h_variable_8189);
def h_variable_8191 = h_variable_4814[16,42];
h_variable_8191;
matrix h_variable_8192[1][1] = 0;
matrix h_variable_8193[1][3] = concat(h_variable_8192,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8193); matrix h_variable_8194 = h_variable_l[1]; matrix h_variable_8195 = h_variable_l[2];
ncols(h_variable_8194);
matrix h_variable_8196 = DecideZeroRows(h_variable_8194,h_variable_58);
IsZeroMatrix(h_variable_8196);
nrows(h_variable_8195);
def h_variable_8197 = h_variable_4814[15,42];
h_variable_8197;
matrix h_variable_8198[1][1] = 0;
matrix h_variable_8199[1][3] = concat(h_variable_8198,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8199); matrix h_variable_8200 = h_variable_l[1]; matrix h_variable_8201 = h_variable_l[2];
ncols(h_variable_8200);
matrix h_variable_8202 = DecideZeroRows(h_variable_8200,h_variable_58);
IsZeroMatrix(h_variable_8202);
nrows(h_variable_8201);
def h_variable_8203 = h_variable_4814[2,42];
h_variable_8203;
matrix h_variable_8204[1][1] = 0;
matrix h_variable_8205[1][3] = concat(h_variable_8204,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8205); matrix h_variable_8206 = h_variable_l[1]; matrix h_variable_8207 = h_variable_l[2];
ncols(h_variable_8206);
matrix h_variable_8208 = DecideZeroRows(h_variable_8206,h_variable_58);
IsZeroMatrix(h_variable_8208);
nrows(h_variable_8207);
def h_variable_8209 = h_variable_4814[1,42];
h_variable_8209;
matrix h_variable_8210[1][1] = 0;
matrix h_variable_8211[1][3] = concat(h_variable_8210,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8211); matrix h_variable_8212 = h_variable_l[1]; matrix h_variable_8213 = h_variable_l[2];
ncols(h_variable_8212);
matrix h_variable_8214 = DecideZeroRows(h_variable_8212,h_variable_58);
IsZeroMatrix(h_variable_8214);
nrows(h_variable_8213);
def h_variable_8215 = h_variable_4814[16,43];
h_variable_8215;
matrix h_variable_8216[1][1] = 0;
matrix h_variable_8217[1][3] = concat(h_variable_8216,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8217); matrix h_variable_8218 = h_variable_l[1]; matrix h_variable_8219 = h_variable_l[2];
ncols(h_variable_8218);
matrix h_variable_8220 = DecideZeroRows(h_variable_8218,h_variable_58);
IsZeroMatrix(h_variable_8220);
nrows(h_variable_8219);
def h_variable_8221 = h_variable_4814[15,43];
h_variable_8221;
matrix h_variable_8222[1][1] = 0;
matrix h_variable_8223[1][3] = concat(h_variable_8222,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8223); matrix h_variable_8224 = h_variable_l[1]; matrix h_variable_8225 = h_variable_l[2];
ncols(h_variable_8224);
matrix h_variable_8226 = DecideZeroRows(h_variable_8224,h_variable_58);
IsZeroMatrix(h_variable_8226);
nrows(h_variable_8225);
def h_variable_8227 = h_variable_4814[2,43];
h_variable_8227;
matrix h_variable_8228[1][1] = 0;
matrix h_variable_8229[1][3] = concat(h_variable_8228,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8229); matrix h_variable_8230 = h_variable_l[1]; matrix h_variable_8231 = h_variable_l[2];
ncols(h_variable_8230);
matrix h_variable_8232 = DecideZeroRows(h_variable_8230,h_variable_58);
IsZeroMatrix(h_variable_8232);
nrows(h_variable_8231);
def h_variable_8233 = h_variable_4814[1,43];
h_variable_8233;
matrix h_variable_8234[1][1] = 0;
matrix h_variable_8235[1][3] = concat(h_variable_8234,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8235); matrix h_variable_8236 = h_variable_l[1]; matrix h_variable_8237 = h_variable_l[2];
ncols(h_variable_8236);
matrix h_variable_8238 = DecideZeroRows(h_variable_8236,h_variable_58);
IsZeroMatrix(h_variable_8238);
nrows(h_variable_8237);
def h_variable_8239 = h_variable_4814[16,44];
h_variable_8239;
matrix h_variable_8240[1][1] = 0;
matrix h_variable_8241[1][3] = concat(h_variable_8240,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8241); matrix h_variable_8242 = h_variable_l[1]; matrix h_variable_8243 = h_variable_l[2];
ncols(h_variable_8242);
matrix h_variable_8244 = DecideZeroRows(h_variable_8242,h_variable_58);
IsZeroMatrix(h_variable_8244);
nrows(h_variable_8243);
def h_variable_8245 = h_variable_4814[15,44];
h_variable_8245;
matrix h_variable_8246[1][1] = 0;
matrix h_variable_8247[1][3] = concat(h_variable_8246,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8247); matrix h_variable_8248 = h_variable_l[1]; matrix h_variable_8249 = h_variable_l[2];
ncols(h_variable_8248);
matrix h_variable_8250 = DecideZeroRows(h_variable_8248,h_variable_58);
IsZeroMatrix(h_variable_8250);
nrows(h_variable_8249);
def h_variable_8251 = h_variable_4814[2,44];
h_variable_8251;
matrix h_variable_8252[1][1] = 0;
matrix h_variable_8253[1][3] = concat(h_variable_8252,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8253); matrix h_variable_8254 = h_variable_l[1]; matrix h_variable_8255 = h_variable_l[2];
ncols(h_variable_8254);
matrix h_variable_8256 = DecideZeroRows(h_variable_8254,h_variable_58);
IsZeroMatrix(h_variable_8256);
nrows(h_variable_8255);
def h_variable_8257 = h_variable_4814[1,44];
h_variable_8257;
matrix h_variable_8258[1][1] = 0;
matrix h_variable_8259[1][3] = concat(h_variable_8258,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8259); matrix h_variable_8260 = h_variable_l[1]; matrix h_variable_8261 = h_variable_l[2];
ncols(h_variable_8260);
matrix h_variable_8262 = DecideZeroRows(h_variable_8260,h_variable_58);
IsZeroMatrix(h_variable_8262);
nrows(h_variable_8261);
def h_variable_8263 = h_variable_4814[16,45];
h_variable_8263;
matrix h_variable_8264[1][1] = 1;
matrix h_variable_8265[1][3] = concat(h_variable_8264,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8265); matrix h_variable_8266 = h_variable_l[1]; matrix h_variable_8267 = h_variable_l[2];
ncols(h_variable_8266);
matrix h_variable_8268 = DecideZeroRows(h_variable_8266,h_variable_58);
IsZeroMatrix(h_variable_8268);
nrows(h_variable_8267);
IsIdentityMatrix(h_variable_8268);
def h_variable_8269 = h_variable_4814[1,45];
h_variable_8269;
matrix h_variable_8270[1][1] = 0;
matrix h_variable_8271 = DecideZeroRows(h_variable_8270,h_variable_58);
IsZeroMatrix(h_variable_8271);
def h_variable_8272 = h_variable_8271[1,1];
h_variable_8272==0;
def h_variable_8273 = h_variable_4814[2,45];
h_variable_8273;
matrix h_variable_8274[1][1] = 0;
matrix h_variable_8275 = DecideZeroRows(h_variable_8274,h_variable_58);
IsZeroMatrix(h_variable_8275);
def h_variable_8276 = h_variable_8275[1,1];
h_variable_8276==0;
def h_variable_8277 = h_variable_4814[15,45];
h_variable_8277;
matrix h_variable_8278[1][1] = 0;
matrix h_variable_8279 = DecideZeroRows(h_variable_8278,h_variable_58);
IsZeroMatrix(h_variable_8279);
def h_variable_8280 = h_variable_8279[1,1];
h_variable_8280==0;
def h_variable_8281 = h_variable_4814[16,45];
h_variable_8281;
matrix h_variable_8282[1][1] = 1;
matrix h_variable_8283 = DecideZeroRows(h_variable_8282,h_variable_58);
IsZeroMatrix(h_variable_8283);
def h_variable_8284 = h_variable_8283[1,1];
h_variable_8284==0;
def h_variable_8285 = h_variable_4814[15,46];
h_variable_8285;
matrix h_variable_8286[1][1] = 0;
matrix h_variable_8287[1][3] = concat(h_variable_8286,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8287); matrix h_variable_8288 = h_variable_l[1]; matrix h_variable_8289 = h_variable_l[2];
ncols(h_variable_8288);
matrix h_variable_8290 = DecideZeroRows(h_variable_8288,h_variable_58);
IsZeroMatrix(h_variable_8290);
nrows(h_variable_8289);
def h_variable_8291 = h_variable_4814[2,46];
h_variable_8291;
matrix h_variable_8292[1][1] = 0;
matrix h_variable_8293[1][3] = concat(h_variable_8292,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8293); matrix h_variable_8294 = h_variable_l[1]; matrix h_variable_8295 = h_variable_l[2];
ncols(h_variable_8294);
matrix h_variable_8296 = DecideZeroRows(h_variable_8294,h_variable_58);
IsZeroMatrix(h_variable_8296);
nrows(h_variable_8295);
def h_variable_8297 = h_variable_4814[1,46];
h_variable_8297;
matrix h_variable_8298[1][1] = 0;
matrix h_variable_8299[1][3] = concat(h_variable_8298,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8299); matrix h_variable_8300 = h_variable_l[1]; matrix h_variable_8301 = h_variable_l[2];
ncols(h_variable_8300);
matrix h_variable_8302 = DecideZeroRows(h_variable_8300,h_variable_58);
IsZeroMatrix(h_variable_8302);
nrows(h_variable_8301);
def h_variable_8303 = h_variable_4814[15,47];
h_variable_8303;
matrix h_variable_8304[1][1] = 0;
matrix h_variable_8305[1][3] = concat(h_variable_8304,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8305); matrix h_variable_8306 = h_variable_l[1]; matrix h_variable_8307 = h_variable_l[2];
ncols(h_variable_8306);
matrix h_variable_8308 = DecideZeroRows(h_variable_8306,h_variable_58);
IsZeroMatrix(h_variable_8308);
nrows(h_variable_8307);
def h_variable_8309 = h_variable_4814[2,47];
h_variable_8309;
matrix h_variable_8310[1][1] = 0;
matrix h_variable_8311[1][3] = concat(h_variable_8310,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8311); matrix h_variable_8312 = h_variable_l[1]; matrix h_variable_8313 = h_variable_l[2];
ncols(h_variable_8312);
matrix h_variable_8314 = DecideZeroRows(h_variable_8312,h_variable_58);
IsZeroMatrix(h_variable_8314);
nrows(h_variable_8313);
def h_variable_8315 = h_variable_4814[1,47];
h_variable_8315;
matrix h_variable_8316[1][1] = 0;
matrix h_variable_8317[1][3] = concat(h_variable_8316,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8317); matrix h_variable_8318 = h_variable_l[1]; matrix h_variable_8319 = h_variable_l[2];
ncols(h_variable_8318);
matrix h_variable_8320 = DecideZeroRows(h_variable_8318,h_variable_58);
IsZeroMatrix(h_variable_8320);
nrows(h_variable_8319);
def h_variable_8321 = h_variable_4814[15,48];
h_variable_8321;
matrix h_variable_8322[1][1] = 0;
matrix h_variable_8323[1][3] = concat(h_variable_8322,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8323); matrix h_variable_8324 = h_variable_l[1]; matrix h_variable_8325 = h_variable_l[2];
ncols(h_variable_8324);
matrix h_variable_8326 = DecideZeroRows(h_variable_8324,h_variable_58);
IsZeroMatrix(h_variable_8326);
nrows(h_variable_8325);
def h_variable_8327 = h_variable_4814[2,48];
h_variable_8327;
matrix h_variable_8328[1][1] = 0;
matrix h_variable_8329[1][3] = concat(h_variable_8328,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8329); matrix h_variable_8330 = h_variable_l[1]; matrix h_variable_8331 = h_variable_l[2];
ncols(h_variable_8330);
matrix h_variable_8332 = DecideZeroRows(h_variable_8330,h_variable_58);
IsZeroMatrix(h_variable_8332);
nrows(h_variable_8331);
def h_variable_8333 = h_variable_4814[1,48];
h_variable_8333;
matrix h_variable_8334[1][1] = 0;
matrix h_variable_8335[1][3] = concat(h_variable_8334,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8335); matrix h_variable_8336 = h_variable_l[1]; matrix h_variable_8337 = h_variable_l[2];
ncols(h_variable_8336);
matrix h_variable_8338 = DecideZeroRows(h_variable_8336,h_variable_58);
IsZeroMatrix(h_variable_8338);
nrows(h_variable_8337);
def h_variable_8339 = h_variable_4814[15,49];
h_variable_8339;
matrix h_variable_8340[1][1] = 0;
matrix h_variable_8341[1][3] = concat(h_variable_8340,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8341); matrix h_variable_8342 = h_variable_l[1]; matrix h_variable_8343 = h_variable_l[2];
ncols(h_variable_8342);
matrix h_variable_8344 = DecideZeroRows(h_variable_8342,h_variable_58);
IsZeroMatrix(h_variable_8344);
nrows(h_variable_8343);
def h_variable_8345 = h_variable_4814[2,49];
h_variable_8345;
matrix h_variable_8346[1][1] = 0;
matrix h_variable_8347[1][3] = concat(h_variable_8346,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8347); matrix h_variable_8348 = h_variable_l[1]; matrix h_variable_8349 = h_variable_l[2];
ncols(h_variable_8348);
matrix h_variable_8350 = DecideZeroRows(h_variable_8348,h_variable_58);
IsZeroMatrix(h_variable_8350);
nrows(h_variable_8349);
def h_variable_8351 = h_variable_4814[1,49];
h_variable_8351;
matrix h_variable_8352[1][1] = 0;
matrix h_variable_8353[1][3] = concat(h_variable_8352,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8353); matrix h_variable_8354 = h_variable_l[1]; matrix h_variable_8355 = h_variable_l[2];
ncols(h_variable_8354);
matrix h_variable_8356 = DecideZeroRows(h_variable_8354,h_variable_58);
IsZeroMatrix(h_variable_8356);
nrows(h_variable_8355);
def h_variable_8357 = h_variable_4814[15,50];
h_variable_8357;
matrix h_variable_8358[1][1] = -2;
matrix h_variable_8359[1][3] = concat(h_variable_8358,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8359); matrix h_variable_8360 = h_variable_l[1]; matrix h_variable_8361 = h_variable_l[2];
ncols(h_variable_8360);
matrix h_variable_8362 = DecideZeroRows(h_variable_8360,h_variable_58);
IsZeroMatrix(h_variable_8362);
ZeroRows(h_variable_8362);
nrows(h_variable_8361);
matrix h_variable_8364 = submat(h_variable_8360,1..1,intvec( 1 ));
matrix h_variable_8363 = DecideZeroRows(h_variable_8364,h_variable_58);
IsZeroMatrix(h_variable_8363);
IsIdentityMatrix(h_variable_8363);
matrix h_variable_8365[1][3] = concat(h_variable_8363,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8365); matrix h_variable_8366 = h_variable_l[1]; matrix h_variable_8367 = h_variable_l[2];
IsZeroMatrix(h_variable_8366);
matrix h_variable_8368 = DecideZeroRows(h_variable_8366,h_variable_58);
IsZeroMatrix(h_variable_8368);
def h_variable_8369 = h_variable_4814[2,50];
h_variable_8369;
matrix h_variable_8370[1][1] = 0;
matrix h_variable_8371[1][3] = concat(h_variable_8370,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8371); matrix h_variable_8372 = h_variable_l[1]; matrix h_variable_8373 = h_variable_l[2];
ncols(h_variable_8372);
matrix h_variable_8374 = DecideZeroRows(h_variable_8372,h_variable_58);
IsZeroMatrix(h_variable_8374);
nrows(h_variable_8373);
def h_variable_8375 = h_variable_4814[1,50];
h_variable_8375;
matrix h_variable_8376[1][1] = 0;
matrix h_variable_8377[1][3] = concat(h_variable_8376,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8377); matrix h_variable_8378 = h_variable_l[1]; matrix h_variable_8379 = h_variable_l[2];
ncols(h_variable_8378);
matrix h_variable_8380 = DecideZeroRows(h_variable_8378,h_variable_58);
IsZeroMatrix(h_variable_8380);
nrows(h_variable_8379);
def h_variable_8381 = h_variable_4814[15,51];
h_variable_8381;
matrix h_variable_8382[1][1] = 4*x2;
matrix h_variable_8383[1][3] = concat(h_variable_8382,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8383); matrix h_variable_8384 = h_variable_l[1]; matrix h_variable_8385 = h_variable_l[2];
ncols(h_variable_8384);
matrix h_variable_8386 = DecideZeroRows(h_variable_8384,h_variable_58);
IsZeroMatrix(h_variable_8386);
ZeroRows(h_variable_8386);
nrows(h_variable_8385);
matrix h_variable_8388 = submat(h_variable_8384,1..1,intvec( 2 ));
matrix h_variable_8387 = DecideZeroRows(h_variable_8388,h_variable_58);
IsZeroMatrix(h_variable_8387);
IsIdentityMatrix(h_variable_8387);
matrix h_variable_8389[1][3] = concat(h_variable_8387,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8389); matrix h_variable_8390 = h_variable_l[1]; matrix h_variable_8391 = h_variable_l[2];
IsZeroMatrix(h_variable_8390);
matrix h_variable_8392 = DecideZeroRows(h_variable_8390,h_variable_58);
IsZeroMatrix(h_variable_8392);
def h_variable_8393 = h_variable_4814[2,51];
h_variable_8393;
matrix h_variable_8394[1][1] = 0;
matrix h_variable_8395[1][3] = concat(h_variable_8394,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8395); matrix h_variable_8396 = h_variable_l[1]; matrix h_variable_8397 = h_variable_l[2];
ncols(h_variable_8396);
matrix h_variable_8398 = DecideZeroRows(h_variable_8396,h_variable_58);
IsZeroMatrix(h_variable_8398);
nrows(h_variable_8397);
def h_variable_8399 = h_variable_4814[1,51];
h_variable_8399;
matrix h_variable_8400[1][1] = 0;
matrix h_variable_8401[1][3] = concat(h_variable_8400,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8401); matrix h_variable_8402 = h_variable_l[1]; matrix h_variable_8403 = h_variable_l[2];
ncols(h_variable_8402);
matrix h_variable_8404 = DecideZeroRows(h_variable_8402,h_variable_58);
IsZeroMatrix(h_variable_8404);
nrows(h_variable_8403);
def h_variable_8405 = h_variable_4814[15,52];
h_variable_8405;
matrix h_variable_8406[1][1] = 2*x2+4*x3;
matrix h_variable_8407[1][3] = concat(h_variable_8406,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8407); matrix h_variable_8408 = h_variable_l[1]; matrix h_variable_8409 = h_variable_l[2];
ncols(h_variable_8408);
matrix h_variable_8410 = DecideZeroRows(h_variable_8408,h_variable_58);
IsZeroMatrix(h_variable_8410);
ZeroRows(h_variable_8410);
nrows(h_variable_8409);
matrix h_variable_8412 = submat(h_variable_8408,1..1,intvec( 2 ));
matrix h_variable_8411 = DecideZeroRows(h_variable_8412,h_variable_58);
IsZeroMatrix(h_variable_8411);
IsIdentityMatrix(h_variable_8411);
matrix h_variable_8413[1][3] = concat(h_variable_8411,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8413); matrix h_variable_8414 = h_variable_l[1]; matrix h_variable_8415 = h_variable_l[2];
IsZeroMatrix(h_variable_8414);
matrix h_variable_8416 = DecideZeroRows(h_variable_8414,h_variable_58);
IsZeroMatrix(h_variable_8416);
def h_variable_8417 = h_variable_4814[2,52];
h_variable_8417;
matrix h_variable_8418[1][1] = 0;
matrix h_variable_8419[1][3] = concat(h_variable_8418,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8419); matrix h_variable_8420 = h_variable_l[1]; matrix h_variable_8421 = h_variable_l[2];
ncols(h_variable_8420);
matrix h_variable_8422 = DecideZeroRows(h_variable_8420,h_variable_58);
IsZeroMatrix(h_variable_8422);
nrows(h_variable_8421);
def h_variable_8423 = h_variable_4814[1,52];
h_variable_8423;
matrix h_variable_8424[1][1] = 0;
matrix h_variable_8425[1][3] = concat(h_variable_8424,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8425); matrix h_variable_8426 = h_variable_l[1]; matrix h_variable_8427 = h_variable_l[2];
ncols(h_variable_8426);
matrix h_variable_8428 = DecideZeroRows(h_variable_8426,h_variable_58);
IsZeroMatrix(h_variable_8428);
nrows(h_variable_8427);
def h_variable_8429 = h_variable_4814[15,53];
h_variable_8429;
matrix h_variable_8430[1][1] = 0;
matrix h_variable_8431[1][3] = concat(h_variable_8430,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8431); matrix h_variable_8432 = h_variable_l[1]; matrix h_variable_8433 = h_variable_l[2];
ncols(h_variable_8432);
matrix h_variable_8434 = DecideZeroRows(h_variable_8432,h_variable_58);
IsZeroMatrix(h_variable_8434);
nrows(h_variable_8433);
def h_variable_8435 = h_variable_4814[2,53];
h_variable_8435;
matrix h_variable_8436[1][1] = 0;
matrix h_variable_8437[1][3] = concat(h_variable_8436,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8437); matrix h_variable_8438 = h_variable_l[1]; matrix h_variable_8439 = h_variable_l[2];
ncols(h_variable_8438);
matrix h_variable_8440 = DecideZeroRows(h_variable_8438,h_variable_58);
IsZeroMatrix(h_variable_8440);
nrows(h_variable_8439);
def h_variable_8441 = h_variable_4814[1,53];
h_variable_8441;
matrix h_variable_8442[1][1] = 0;
matrix h_variable_8443[1][3] = concat(h_variable_8442,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8443); matrix h_variable_8444 = h_variable_l[1]; matrix h_variable_8445 = h_variable_l[2];
ncols(h_variable_8444);
matrix h_variable_8446 = DecideZeroRows(h_variable_8444,h_variable_58);
IsZeroMatrix(h_variable_8446);
nrows(h_variable_8445);
def h_variable_8447 = h_variable_4814[15,54];
h_variable_8447;
matrix h_variable_8448[1][1] = 0;
matrix h_variable_8449[1][3] = concat(h_variable_8448,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8449); matrix h_variable_8450 = h_variable_l[1]; matrix h_variable_8451 = h_variable_l[2];
ncols(h_variable_8450);
matrix h_variable_8452 = DecideZeroRows(h_variable_8450,h_variable_58);
IsZeroMatrix(h_variable_8452);
nrows(h_variable_8451);
def h_variable_8453 = h_variable_4814[2,54];
h_variable_8453;
matrix h_variable_8454[1][1] = 0;
matrix h_variable_8455[1][3] = concat(h_variable_8454,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8455); matrix h_variable_8456 = h_variable_l[1]; matrix h_variable_8457 = h_variable_l[2];
ncols(h_variable_8456);
matrix h_variable_8458 = DecideZeroRows(h_variable_8456,h_variable_58);
IsZeroMatrix(h_variable_8458);
nrows(h_variable_8457);
def h_variable_8459 = h_variable_4814[1,54];
h_variable_8459;
matrix h_variable_8460[1][1] = 0;
matrix h_variable_8461[1][3] = concat(h_variable_8460,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8461); matrix h_variable_8462 = h_variable_l[1]; matrix h_variable_8463 = h_variable_l[2];
ncols(h_variable_8462);
matrix h_variable_8464 = DecideZeroRows(h_variable_8462,h_variable_58);
IsZeroMatrix(h_variable_8464);
nrows(h_variable_8463);
def h_variable_8465 = h_variable_4814[15,55];
h_variable_8465;
matrix h_variable_8466[1][1] = 4;
matrix h_variable_8467[1][3] = concat(h_variable_8466,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8467); matrix h_variable_8468 = h_variable_l[1]; matrix h_variable_8469 = h_variable_l[2];
ncols(h_variable_8468);
matrix h_variable_8470 = DecideZeroRows(h_variable_8468,h_variable_58);
IsZeroMatrix(h_variable_8470);
ZeroRows(h_variable_8470);
nrows(h_variable_8469);
matrix h_variable_8472 = submat(h_variable_8468,1..1,intvec( 1 ));
matrix h_variable_8471 = DecideZeroRows(h_variable_8472,h_variable_58);
IsZeroMatrix(h_variable_8471);
IsIdentityMatrix(h_variable_8471);
matrix h_variable_8473[1][3] = concat(h_variable_8471,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8473); matrix h_variable_8474 = h_variable_l[1]; matrix h_variable_8475 = h_variable_l[2];
IsZeroMatrix(h_variable_8474);
matrix h_variable_8476 = DecideZeroRows(h_variable_8474,h_variable_58);
IsZeroMatrix(h_variable_8476);
def h_variable_8477 = h_variable_4814[2,55];
h_variable_8477;
matrix h_variable_8478[1][1] = 0;
matrix h_variable_8479[1][3] = concat(h_variable_8478,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8479); matrix h_variable_8480 = h_variable_l[1]; matrix h_variable_8481 = h_variable_l[2];
ncols(h_variable_8480);
matrix h_variable_8482 = DecideZeroRows(h_variable_8480,h_variable_58);
IsZeroMatrix(h_variable_8482);
nrows(h_variable_8481);
def h_variable_8483 = h_variable_4814[1,55];
h_variable_8483;
matrix h_variable_8484[1][1] = 0;
matrix h_variable_8485[1][3] = concat(h_variable_8484,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8485); matrix h_variable_8486 = h_variable_l[1]; matrix h_variable_8487 = h_variable_l[2];
ncols(h_variable_8486);
matrix h_variable_8488 = DecideZeroRows(h_variable_8486,h_variable_58);
IsZeroMatrix(h_variable_8488);
nrows(h_variable_8487);
def h_variable_8489 = h_variable_4814[15,56];
h_variable_8489;
matrix h_variable_8490[1][1] = -2*x3;
matrix h_variable_8491[1][3] = concat(h_variable_8490,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8491); matrix h_variable_8492 = h_variable_l[1]; matrix h_variable_8493 = h_variable_l[2];
ncols(h_variable_8492);
matrix h_variable_8494 = DecideZeroRows(h_variable_8492,h_variable_58);
IsZeroMatrix(h_variable_8494);
ZeroRows(h_variable_8494);
nrows(h_variable_8493);
matrix h_variable_8496 = submat(h_variable_8492,1..1,intvec( 2 ));
matrix h_variable_8495 = DecideZeroRows(h_variable_8496,h_variable_58);
IsZeroMatrix(h_variable_8495);
IsIdentityMatrix(h_variable_8495);
matrix h_variable_8497[1][3] = concat(h_variable_8495,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8497); matrix h_variable_8498 = h_variable_l[1]; matrix h_variable_8499 = h_variable_l[2];
IsZeroMatrix(h_variable_8498);
matrix h_variable_8500 = DecideZeroRows(h_variable_8498,h_variable_58);
IsZeroMatrix(h_variable_8500);
kill h_variable_7971;kill h_variable_7972;kill h_variable_7973;kill h_variable_7974;kill h_variable_7976;kill h_variable_7977;kill h_variable_7978;kill h_variable_7979;kill h_variable_7980;kill h_variable_7982;kill h_variable_7983;kill h_variable_7984;kill h_variable_7985;kill h_variable_7986;kill h_variable_7987;kill h_variable_7988;kill h_variable_7989;kill h_variable_7990;kill h_variable_7991;kill h_variable_7992;kill h_variable_7993;kill h_variable_7994;kill h_variable_7995;kill h_variable_7996;kill h_variable_7997;kill h_variable_7998;kill h_variable_7999;kill h_variable_8000;kill h_variable_8001;kill h_variable_8002;kill h_variable_8003;kill h_variable_8004;kill h_variable_8005;kill h_variable_8006;kill h_variable_8007;kill h_variable_8008;kill h_variable_8009;kill h_variable_8010;kill h_variable_8011;kill h_variable_8012;kill h_variable_8013;kill h_variable_8014;kill h_variable_8015;kill h_variable_8016;kill h_variable_8017;kill h_variable_8018;kill h_variable_8019;kill h_variable_8020;kill h_variable_8021;kill h_variable_8022;kill h_variable_8023;kill h_variable_8024;kill h_variable_8025;kill h_variable_8026;kill h_variable_8027;kill h_variable_8028;kill h_variable_8029;kill h_variable_8030;kill h_variable_8031;kill h_variable_8032;kill h_variable_8033;kill h_variable_8034;kill h_variable_8035;kill h_variable_8036;kill h_variable_8037;kill h_variable_8038;kill h_variable_8039;kill h_variable_8040;kill h_variable_8041;kill h_variable_8042;kill h_variable_8043;kill h_variable_8044;kill h_variable_8045;kill h_variable_8046;kill h_variable_8047;kill h_variable_8048;kill h_variable_8049;kill h_variable_8050;kill h_variable_8051;kill h_variable_8052;kill h_variable_8053;kill h_variable_8054;kill h_variable_8055;kill h_variable_8056;kill h_variable_8057;kill h_variable_8058;kill h_variable_8059;kill h_variable_8060;kill h_variable_8061;kill h_variable_8062;kill h_variable_8063;kill h_variable_8064;kill h_variable_8065;kill h_variable_8066;kill h_variable_8067;kill h_variable_8068;kill h_variable_8069;kill h_variable_8070;kill h_variable_8071;kill h_variable_8072;kill h_variable_8073;kill h_variable_8074;kill h_variable_8083;kill h_variable_8084;kill h_variable_8085;kill h_variable_8086;kill h_variable_8088;kill h_variable_8089;kill h_variable_8090;kill h_variable_8091;kill h_variable_8092;kill h_variable_8094;kill h_variable_8095;kill h_variable_8096;kill h_variable_8097;kill h_variable_8098;kill h_variable_8099;kill h_variable_8100;kill h_variable_8101;kill h_variable_8102;kill h_variable_8103;kill h_variable_8104;kill h_variable_8105;kill h_variable_8106;kill h_variable_8107;kill h_variable_8108;kill h_variable_8109;kill h_variable_8110;kill h_variable_8111;kill h_variable_8112;kill h_variable_8113;kill h_variable_8114;kill h_variable_8115;kill h_variable_8116;kill h_variable_8117;kill h_variable_8118;kill h_variable_8119;kill h_variable_8120;kill h_variable_8121;kill h_variable_8122;kill h_variable_8123;kill h_variable_8124;kill h_variable_8125;kill h_variable_8126;kill h_variable_8127;kill h_variable_8128;kill h_variable_8129;kill h_variable_8130;kill h_variable_8131;kill h_variable_8132;kill h_variable_8133;kill h_variable_8134;kill h_variable_8135;kill h_variable_8136;kill h_variable_8137;kill h_variable_8138;kill h_variable_8139;kill h_variable_8140;kill h_variable_8141;kill h_variable_8142;kill h_variable_8143;kill h_variable_8144;kill h_variable_8145;kill h_variable_8146;kill h_variable_8147;kill h_variable_8148;kill h_variable_8149;kill h_variable_8150;kill h_variable_8151;kill h_variable_8152;kill h_variable_8153;kill h_variable_8154;kill h_variable_8155;kill h_variable_8156;kill h_variable_8157;kill h_variable_8158;kill h_variable_8159;kill h_variable_8160;kill h_variable_8161;kill h_variable_8162;kill h_variable_8163;kill h_variable_8164;kill h_variable_8165;kill h_variable_8166;kill h_variable_8167;kill h_variable_8168;kill h_variable_8169;kill h_variable_8170;kill h_variable_8171;kill h_variable_8172;kill h_variable_8173;kill h_variable_8174;kill h_variable_8175;kill h_variable_8176;kill h_variable_8177;kill h_variable_8178;kill h_variable_8179;kill h_variable_8180;kill h_variable_8181;kill h_variable_8182;kill h_variable_8183;kill h_variable_8184;kill h_variable_8185;kill h_variable_8186;kill h_variable_8187;kill h_variable_8188;kill h_variable_8189;kill h_variable_8190;kill h_variable_8191;kill h_variable_8192;kill h_variable_8193;kill h_variable_8194;kill h_variable_8195;kill h_variable_8196;kill h_variable_8197;kill h_variable_8198;kill h_variable_8199;kill h_variable_8200;kill h_variable_8201;kill h_variable_8202;kill h_variable_8203;kill h_variable_8204;kill h_variable_8205;kill h_variable_8206;kill h_variable_8207;kill h_variable_8208;kill h_variable_8209;kill h_variable_8210;kill h_variable_8211;kill h_variable_8212;kill h_variable_8213;kill h_variable_8214;kill h_variable_8215;kill h_variable_8216;kill h_variable_8217;kill h_variable_8218;kill h_variable_8219;kill h_variable_8220;kill h_variable_8221;kill h_variable_8222;kill h_variable_8223;kill h_variable_8224;kill h_variable_8225;kill h_variable_8226;kill h_variable_8227;kill h_variable_8228;kill h_variable_8229;kill h_variable_8230;kill h_variable_8231;kill h_variable_8232;kill h_variable_8233;kill h_variable_8234;kill h_variable_8235;kill h_variable_8236;kill h_variable_8237;kill h_variable_8238;kill h_variable_8239;kill h_variable_8240;kill h_variable_8241;kill h_variable_8242;kill h_variable_8243;kill h_variable_8244;kill h_variable_8245;kill h_variable_8246;kill h_variable_8247;kill h_variable_8248;kill h_variable_8249;kill h_variable_8250;kill h_variable_8251;kill h_variable_8252;kill h_variable_8253;kill h_variable_8254;kill h_variable_8255;kill h_variable_8256;kill h_variable_8265;kill h_variable_8268;kill h_variable_8270;kill h_variable_8274;kill h_variable_8275;kill h_variable_8276;kill h_variable_8277;kill h_variable_8278;kill h_variable_8279;kill h_variable_8280;kill h_variable_8281;kill h_variable_8282;kill h_variable_8283;kill h_variable_8284;kill h_variable_8285;kill h_variable_8286;kill h_variable_8287;kill h_variable_8288;kill h_variable_8289;kill h_variable_8290;kill h_variable_8291;kill h_variable_8292;kill h_variable_8293;kill h_variable_8294;kill h_variable_8295;kill h_variable_8296;kill h_variable_8297;kill h_variable_8298;kill h_variable_8299;kill h_variable_8300;kill h_variable_8301;kill h_variable_8302;kill h_variable_8303;kill h_variable_8304;kill h_variable_8305;kill h_variable_8306;kill h_variable_8307;kill h_variable_8308;kill h_variable_8309;kill h_variable_8310;kill h_variable_8311;kill h_variable_8312;kill h_variable_8313;kill h_variable_8314;kill h_variable_8315;kill h_variable_8316;kill h_variable_8317;kill h_variable_8318;kill h_variable_8319;kill h_variable_8320;kill h_variable_8321;kill h_variable_8322;kill h_variable_8323;kill h_variable_8324;kill h_variable_8325;kill h_variable_8326;kill h_variable_8327;kill h_variable_8328;kill h_variable_8329;kill h_variable_8330;kill h_variable_8331;kill h_variable_8332;kill h_variable_8333;kill h_variable_8334;kill h_variable_8335;kill h_variable_8336;kill h_variable_8337;kill h_variable_8338;kill h_variable_8339;kill h_variable_8340;kill h_variable_8341;kill h_variable_8342;kill h_variable_8343;kill h_variable_8344;kill h_variable_8345;kill h_variable_8346;kill h_variable_8347;kill h_variable_8348;kill h_variable_8349;kill h_variable_8350;kill h_variable_8351;kill h_variable_8352;kill h_variable_8353;kill h_variable_8354;kill h_variable_8355;kill h_variable_8356;kill h_variable_8357;kill h_variable_8358;kill h_variable_8359;kill h_variable_8360;kill h_variable_8361;kill h_variable_8362;kill h_variable_8363;kill h_variable_8364;kill h_variable_8365;kill h_variable_8366;kill h_variable_8367;kill h_variable_8368;kill h_variable_8369;kill h_variable_8370;kill h_variable_8371;kill h_variable_8372;kill h_variable_8373;kill h_variable_8374;kill h_variable_8375;kill h_variable_8376;kill h_variable_8377;kill h_variable_8378;kill h_variable_8379;kill h_variable_8380;kill h_variable_8381;kill h_variable_8382;kill h_variable_8383;kill h_variable_8384;kill h_variable_8385;kill h_variable_8386;kill h_variable_8387;kill h_variable_8388;kill h_variable_8389;kill h_variable_8390;kill h_variable_8391;kill h_variable_8392;kill h_variable_8393;kill h_variable_8394;kill h_variable_8395;kill h_variable_8396;kill h_variable_8397;kill h_variable_8398;kill h_variable_8399;kill h_variable_8400;kill h_variable_8401;kill h_variable_8402;kill h_variable_8403;kill h_variable_8404;kill h_variable_8405;kill h_variable_8406;kill h_variable_8407;kill h_variable_8408;kill h_variable_8409;kill h_variable_8410;kill h_variable_8411;kill h_variable_8412;kill h_variable_8413;kill h_variable_8414;kill h_variable_8415;kill h_variable_8416;kill h_variable_8417;kill h_variable_8418;kill h_variable_8419;kill h_variable_8420;kill h_variable_8421;kill h_variable_8422;kill h_variable_8423;kill h_variable_8424;kill h_variable_8425;kill h_variable_8426;kill h_variable_8427;kill h_variable_8428;kill h_variable_8429;kill h_variable_8430;kill h_variable_8431;kill h_variable_8432;kill h_variable_8433;kill h_variable_8434;kill h_variable_8440;
def h_variable_8501 = h_variable_4814[2,56];
h_variable_8501;
matrix h_variable_8502[1][1] = 0;
matrix h_variable_8503[1][3] = concat(h_variable_8502,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8503); matrix h_variable_8504 = h_variable_l[1]; matrix h_variable_8505 = h_variable_l[2];
ncols(h_variable_8504);
matrix h_variable_8506 = DecideZeroRows(h_variable_8504,h_variable_58);
IsZeroMatrix(h_variable_8506);
nrows(h_variable_8505);
def h_variable_8507 = h_variable_4814[1,56];
h_variable_8507;
matrix h_variable_8508[1][1] = 0;
matrix h_variable_8509[1][3] = concat(h_variable_8508,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8509); matrix h_variable_8510 = h_variable_l[1]; matrix h_variable_8511 = h_variable_l[2];
ncols(h_variable_8510);
matrix h_variable_8512 = DecideZeroRows(h_variable_8510,h_variable_58);
IsZeroMatrix(h_variable_8512);
nrows(h_variable_8511);
def h_variable_8513 = h_variable_4814[15,57];
h_variable_8513;
matrix h_variable_8514[1][1] = 4*x3;
matrix h_variable_8515[1][3] = concat(h_variable_8514,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8515); matrix h_variable_8516 = h_variable_l[1]; matrix h_variable_8517 = h_variable_l[2];
ncols(h_variable_8516);
matrix h_variable_8518 = DecideZeroRows(h_variable_8516,h_variable_58);
IsZeroMatrix(h_variable_8518);
ZeroRows(h_variable_8518);
nrows(h_variable_8517);
matrix h_variable_8520 = submat(h_variable_8516,1..1,intvec( 2 ));
matrix h_variable_8519 = DecideZeroRows(h_variable_8520,h_variable_58);
IsZeroMatrix(h_variable_8519);
IsIdentityMatrix(h_variable_8519);
matrix h_variable_8521[1][3] = concat(h_variable_8519,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8521); matrix h_variable_8522 = h_variable_l[1]; matrix h_variable_8523 = h_variable_l[2];
IsZeroMatrix(h_variable_8522);
matrix h_variable_8524 = DecideZeroRows(h_variable_8522,h_variable_58);
IsZeroMatrix(h_variable_8524);
def h_variable_8525 = h_variable_4814[2,57];
h_variable_8525;
matrix h_variable_8526[1][1] = 0;
matrix h_variable_8527[1][3] = concat(h_variable_8526,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8527); matrix h_variable_8528 = h_variable_l[1]; matrix h_variable_8529 = h_variable_l[2];
ncols(h_variable_8528);
matrix h_variable_8530 = DecideZeroRows(h_variable_8528,h_variable_58);
IsZeroMatrix(h_variable_8530);
nrows(h_variable_8529);
def h_variable_8531 = h_variable_4814[1,57];
h_variable_8531;
matrix h_variable_8532[1][1] = 0;
matrix h_variable_8533[1][3] = concat(h_variable_8532,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8533); matrix h_variable_8534 = h_variable_l[1]; matrix h_variable_8535 = h_variable_l[2];
ncols(h_variable_8534);
matrix h_variable_8536 = DecideZeroRows(h_variable_8534,h_variable_58);
IsZeroMatrix(h_variable_8536);
nrows(h_variable_8535);
def h_variable_8537 = h_variable_4814[15,58];
h_variable_8537;
matrix h_variable_8538[1][1] = 2;
matrix h_variable_8539[1][3] = concat(h_variable_8538,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8539); matrix h_variable_8540 = h_variable_l[1]; matrix h_variable_8541 = h_variable_l[2];
ncols(h_variable_8540);
matrix h_variable_8542 = DecideZeroRows(h_variable_8540,h_variable_58);
IsZeroMatrix(h_variable_8542);
ZeroRows(h_variable_8542);
nrows(h_variable_8541);
matrix h_variable_8544 = submat(h_variable_8540,1..1,intvec( 1 ));
matrix h_variable_8543 = DecideZeroRows(h_variable_8544,h_variable_58);
IsZeroMatrix(h_variable_8543);
IsIdentityMatrix(h_variable_8543);
matrix h_variable_8545[1][3] = concat(h_variable_8543,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8545); matrix h_variable_8546 = h_variable_l[1]; matrix h_variable_8547 = h_variable_l[2];
IsZeroMatrix(h_variable_8546);
matrix h_variable_8548 = DecideZeroRows(h_variable_8546,h_variable_58);
IsZeroMatrix(h_variable_8548);
def h_variable_8549 = h_variable_4814[2,58];
h_variable_8549;
matrix h_variable_8550[1][1] = 0;
matrix h_variable_8551[1][3] = concat(h_variable_8550,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8551); matrix h_variable_8552 = h_variable_l[1]; matrix h_variable_8553 = h_variable_l[2];
ncols(h_variable_8552);
matrix h_variable_8554 = DecideZeroRows(h_variable_8552,h_variable_58);
IsZeroMatrix(h_variable_8554);
nrows(h_variable_8553);
def h_variable_8555 = h_variable_4814[1,58];
h_variable_8555;
matrix h_variable_8556[1][1] = 0;
matrix h_variable_8557[1][3] = concat(h_variable_8556,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8557); matrix h_variable_8558 = h_variable_l[1]; matrix h_variable_8559 = h_variable_l[2];
ncols(h_variable_8558);
matrix h_variable_8560 = DecideZeroRows(h_variable_8558,h_variable_58);
IsZeroMatrix(h_variable_8560);
nrows(h_variable_8559);
def h_variable_8561 = h_variable_4814[15,59];
h_variable_8561;
matrix h_variable_8562[1][1] = 4*a7-2;
matrix h_variable_8563[1][3] = concat(h_variable_8562,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8563); matrix h_variable_8564 = h_variable_l[1]; matrix h_variable_8565 = h_variable_l[2];
ncols(h_variable_8564);
matrix h_variable_8566 = DecideZeroRows(h_variable_8564,h_variable_58);
IsZeroMatrix(h_variable_8566);
ZeroRows(h_variable_8566);
nrows(h_variable_8565);
matrix h_variable_8568 = submat(h_variable_8564,1..1,intvec( 2 ));
matrix h_variable_8567 = DecideZeroRows(h_variable_8568,h_variable_58);
IsZeroMatrix(h_variable_8567);
IsIdentityMatrix(h_variable_8567);
matrix h_variable_8569[1][3] = concat(h_variable_8567,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8569); matrix h_variable_8570 = h_variable_l[1]; matrix h_variable_8571 = h_variable_l[2];
IsZeroMatrix(h_variable_8570);
matrix h_variable_8572 = DecideZeroRows(h_variable_8570,h_variable_58);
IsZeroMatrix(h_variable_8572);
def h_variable_8573 = h_variable_4814[2,59];
h_variable_8573;
matrix h_variable_8574[1][1] = 0;
matrix h_variable_8575[1][3] = concat(h_variable_8574,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8575); matrix h_variable_8576 = h_variable_l[1]; matrix h_variable_8577 = h_variable_l[2];
ncols(h_variable_8576);
matrix h_variable_8578 = DecideZeroRows(h_variable_8576,h_variable_58);
IsZeroMatrix(h_variable_8578);
nrows(h_variable_8577);
def h_variable_8579 = h_variable_4814[1,59];
h_variable_8579;
matrix h_variable_8580[1][1] = 0;
matrix h_variable_8581[1][3] = concat(h_variable_8580,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8581); matrix h_variable_8582 = h_variable_l[1]; matrix h_variable_8583 = h_variable_l[2];
ncols(h_variable_8582);
matrix h_variable_8584 = DecideZeroRows(h_variable_8582,h_variable_58);
IsZeroMatrix(h_variable_8584);
nrows(h_variable_8583);
def h_variable_8585 = h_variable_4814[15,60];
h_variable_8585;
matrix h_variable_8586[1][1] = 0;
matrix h_variable_8587[1][3] = concat(h_variable_8586,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8587); matrix h_variable_8588 = h_variable_l[1]; matrix h_variable_8589 = h_variable_l[2];
ncols(h_variable_8588);
matrix h_variable_8590 = DecideZeroRows(h_variable_8588,h_variable_58);
IsZeroMatrix(h_variable_8590);
nrows(h_variable_8589);
def h_variable_8591 = h_variable_4814[2,60];
h_variable_8591;
matrix h_variable_8592[1][1] = 0;
matrix h_variable_8593[1][3] = concat(h_variable_8592,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8593); matrix h_variable_8594 = h_variable_l[1]; matrix h_variable_8595 = h_variable_l[2];
ncols(h_variable_8594);
matrix h_variable_8596 = DecideZeroRows(h_variable_8594,h_variable_58);
IsZeroMatrix(h_variable_8596);
nrows(h_variable_8595);
def h_variable_8597 = h_variable_4814[1,60];
h_variable_8597;
matrix h_variable_8598[1][1] = 0;
matrix h_variable_8599[1][3] = concat(h_variable_8598,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8599); matrix h_variable_8600 = h_variable_l[1]; matrix h_variable_8601 = h_variable_l[2];
ncols(h_variable_8600);
matrix h_variable_8602 = DecideZeroRows(h_variable_8600,h_variable_58);
IsZeroMatrix(h_variable_8602);
nrows(h_variable_8601);
def h_variable_8603 = h_variable_4814[15,61];
h_variable_8603;
matrix h_variable_8604[1][1] = 0;
matrix h_variable_8605[1][3] = concat(h_variable_8604,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8605); matrix h_variable_8606 = h_variable_l[1]; matrix h_variable_8607 = h_variable_l[2];
ncols(h_variable_8606);
matrix h_variable_8608 = DecideZeroRows(h_variable_8606,h_variable_58);
IsZeroMatrix(h_variable_8608);
nrows(h_variable_8607);
def h_variable_8609 = h_variable_4814[2,61];
h_variable_8609;
matrix h_variable_8610[1][1] = 0;
matrix h_variable_8611[1][3] = concat(h_variable_8610,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8611); matrix h_variable_8612 = h_variable_l[1]; matrix h_variable_8613 = h_variable_l[2];
ncols(h_variable_8612);
matrix h_variable_8614 = DecideZeroRows(h_variable_8612,h_variable_58);
IsZeroMatrix(h_variable_8614);
nrows(h_variable_8613);
def h_variable_8615 = h_variable_4814[1,61];
h_variable_8615;
matrix h_variable_8616[1][1] = 0;
matrix h_variable_8617[1][3] = concat(h_variable_8616,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8617); matrix h_variable_8618 = h_variable_l[1]; matrix h_variable_8619 = h_variable_l[2];
ncols(h_variable_8618);
matrix h_variable_8620 = DecideZeroRows(h_variable_8618,h_variable_58);
IsZeroMatrix(h_variable_8620);
nrows(h_variable_8619);
def h_variable_8621 = h_variable_4814[15,62];
h_variable_8621;
matrix h_variable_8622[1][1] = 4*x3;
matrix h_variable_8623[1][3] = concat(h_variable_8622,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8623); matrix h_variable_8624 = h_variable_l[1]; matrix h_variable_8625 = h_variable_l[2];
ncols(h_variable_8624);
matrix h_variable_8626 = DecideZeroRows(h_variable_8624,h_variable_58);
IsZeroMatrix(h_variable_8626);
ZeroRows(h_variable_8626);
nrows(h_variable_8625);
matrix h_variable_8628 = submat(h_variable_8624,1..1,intvec( 2 ));
matrix h_variable_8627 = DecideZeroRows(h_variable_8628,h_variable_58);
IsZeroMatrix(h_variable_8627);
IsIdentityMatrix(h_variable_8627);
matrix h_variable_8629[1][3] = concat(h_variable_8627,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8629); matrix h_variable_8630 = h_variable_l[1]; matrix h_variable_8631 = h_variable_l[2];
IsZeroMatrix(h_variable_8630);
matrix h_variable_8632 = DecideZeroRows(h_variable_8630,h_variable_58);
IsZeroMatrix(h_variable_8632);
def h_variable_8633 = h_variable_4814[2,62];
h_variable_8633;
matrix h_variable_8634[1][1] = 0;
matrix h_variable_8635[1][3] = concat(h_variable_8634,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8635); matrix h_variable_8636 = h_variable_l[1]; matrix h_variable_8637 = h_variable_l[2];
ncols(h_variable_8636);
matrix h_variable_8638 = DecideZeroRows(h_variable_8636,h_variable_58);
IsZeroMatrix(h_variable_8638);
nrows(h_variable_8637);
def h_variable_8639 = h_variable_4814[1,62];
h_variable_8639;
matrix h_variable_8640[1][1] = 0;
matrix h_variable_8641[1][3] = concat(h_variable_8640,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8641); matrix h_variable_8642 = h_variable_l[1]; matrix h_variable_8643 = h_variable_l[2];
ncols(h_variable_8642);
matrix h_variable_8644 = DecideZeroRows(h_variable_8642,h_variable_58);
IsZeroMatrix(h_variable_8644);
nrows(h_variable_8643);
def h_variable_8645 = h_variable_4814[15,63];
h_variable_8645;
matrix h_variable_8646[1][1] = 2*a7-4;
matrix h_variable_8647[1][3] = concat(h_variable_8646,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8647); matrix h_variable_8648 = h_variable_l[1]; matrix h_variable_8649 = h_variable_l[2];
ncols(h_variable_8648);
matrix h_variable_8650 = DecideZeroRows(h_variable_8648,h_variable_58);
IsZeroMatrix(h_variable_8650);
ZeroRows(h_variable_8650);
nrows(h_variable_8649);
matrix h_variable_8652 = submat(h_variable_8648,1..1,intvec( 2 ));
matrix h_variable_8651 = DecideZeroRows(h_variable_8652,h_variable_58);
IsZeroMatrix(h_variable_8651);
IsIdentityMatrix(h_variable_8651);
matrix h_variable_8653[1][3] = concat(h_variable_8651,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8653); matrix h_variable_8654 = h_variable_l[1]; matrix h_variable_8655 = h_variable_l[2];
IsZeroMatrix(h_variable_8654);
matrix h_variable_8656 = DecideZeroRows(h_variable_8654,h_variable_58);
IsZeroMatrix(h_variable_8656);
def h_variable_8657 = h_variable_4814[2,63];
h_variable_8657;
matrix h_variable_8658[1][1] = 0;
matrix h_variable_8659[1][3] = concat(h_variable_8658,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8659); matrix h_variable_8660 = h_variable_l[1]; matrix h_variable_8661 = h_variable_l[2];
ncols(h_variable_8660);
matrix h_variable_8662 = DecideZeroRows(h_variable_8660,h_variable_58);
IsZeroMatrix(h_variable_8662);
nrows(h_variable_8661);
def h_variable_8663 = h_variable_4814[1,63];
h_variable_8663;
matrix h_variable_8664[1][1] = 0;
matrix h_variable_8665[1][3] = concat(h_variable_8664,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8665); matrix h_variable_8666 = h_variable_l[1]; matrix h_variable_8667 = h_variable_l[2];
ncols(h_variable_8666);
matrix h_variable_8668 = DecideZeroRows(h_variable_8666,h_variable_58);
IsZeroMatrix(h_variable_8668);
nrows(h_variable_8667);
def h_variable_8669 = h_variable_4814[15,64];
h_variable_8669;
matrix h_variable_8670[1][1] = -4*a7+2;
matrix h_variable_8671[1][3] = concat(h_variable_8670,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8671); matrix h_variable_8672 = h_variable_l[1]; matrix h_variable_8673 = h_variable_l[2];
ncols(h_variable_8672);
matrix h_variable_8674 = DecideZeroRows(h_variable_8672,h_variable_58);
IsZeroMatrix(h_variable_8674);
ZeroRows(h_variable_8674);
nrows(h_variable_8673);
matrix h_variable_8676 = submat(h_variable_8672,1..1,intvec( 2 ));
matrix h_variable_8675 = DecideZeroRows(h_variable_8676,h_variable_58);
IsZeroMatrix(h_variable_8675);
IsIdentityMatrix(h_variable_8675);
matrix h_variable_8677[1][3] = concat(h_variable_8675,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8677); matrix h_variable_8678 = h_variable_l[1]; matrix h_variable_8679 = h_variable_l[2];
IsZeroMatrix(h_variable_8678);
matrix h_variable_8680 = DecideZeroRows(h_variable_8678,h_variable_58);
IsZeroMatrix(h_variable_8680);
def h_variable_8681 = h_variable_4814[2,64];
h_variable_8681;
matrix h_variable_8682[1][1] = 0;
matrix h_variable_8683[1][3] = concat(h_variable_8682,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8683); matrix h_variable_8684 = h_variable_l[1]; matrix h_variable_8685 = h_variable_l[2];
ncols(h_variable_8684);
matrix h_variable_8686 = DecideZeroRows(h_variable_8684,h_variable_58);
IsZeroMatrix(h_variable_8686);
nrows(h_variable_8685);
def h_variable_8687 = h_variable_4814[1,64];
h_variable_8687;
matrix h_variable_8688[1][1] = 0;
matrix h_variable_8689[1][3] = concat(h_variable_8688,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8689); matrix h_variable_8690 = h_variable_l[1]; matrix h_variable_8691 = h_variable_l[2];
ncols(h_variable_8690);
matrix h_variable_8692 = DecideZeroRows(h_variable_8690,h_variable_58);
IsZeroMatrix(h_variable_8692);
nrows(h_variable_8691);
def h_variable_8693 = h_variable_4814[15,65];
h_variable_8693;
matrix h_variable_8694[1][1] = -4*a7+4;
matrix h_variable_8695[1][3] = concat(h_variable_8694,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8695); matrix h_variable_8696 = h_variable_l[1]; matrix h_variable_8697 = h_variable_l[2];
ncols(h_variable_8696);
matrix h_variable_8698 = DecideZeroRows(h_variable_8696,h_variable_58);
IsZeroMatrix(h_variable_8698);
ZeroRows(h_variable_8698);
nrows(h_variable_8697);
matrix h_variable_8700 = submat(h_variable_8696,1..1,intvec( 1 ));
matrix h_variable_8699 = DecideZeroRows(h_variable_8700,h_variable_58);
IsZeroMatrix(h_variable_8699);
IsIdentityMatrix(h_variable_8699);
matrix h_variable_8701[1][3] = concat(h_variable_8699,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8701); matrix h_variable_8702 = h_variable_l[1]; matrix h_variable_8703 = h_variable_l[2];
IsZeroMatrix(h_variable_8702);
matrix h_variable_8704 = DecideZeroRows(h_variable_8702,h_variable_58);
IsZeroMatrix(h_variable_8704);
def h_variable_8705 = h_variable_4814[2,65];
h_variable_8705;
matrix h_variable_8706[1][1] = 0;
matrix h_variable_8707[1][3] = concat(h_variable_8706,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8707); matrix h_variable_8708 = h_variable_l[1]; matrix h_variable_8709 = h_variable_l[2];
ncols(h_variable_8708);
matrix h_variable_8710 = DecideZeroRows(h_variable_8708,h_variable_58);
IsZeroMatrix(h_variable_8710);
nrows(h_variable_8709);
def h_variable_8711 = h_variable_4814[1,65];
h_variable_8711;
matrix h_variable_8712[1][1] = 0;
matrix h_variable_8713[1][3] = concat(h_variable_8712,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8713); matrix h_variable_8714 = h_variable_l[1]; matrix h_variable_8715 = h_variable_l[2];
ncols(h_variable_8714);
matrix h_variable_8716 = DecideZeroRows(h_variable_8714,h_variable_58);
IsZeroMatrix(h_variable_8716);
nrows(h_variable_8715);
def h_variable_8717 = h_variable_4814[15,66];
h_variable_8717;
matrix h_variable_8718[1][1] = -2*x1;
matrix h_variable_8719[1][3] = concat(h_variable_8718,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8719); matrix h_variable_8720 = h_variable_l[1]; matrix h_variable_8721 = h_variable_l[2];
ncols(h_variable_8720);
matrix h_variable_8722 = DecideZeroRows(h_variable_8720,h_variable_58);
IsZeroMatrix(h_variable_8722);
ZeroRows(h_variable_8722);
nrows(h_variable_8721);
matrix h_variable_8724 = submat(h_variable_8720,1..1,intvec( 2 ));
matrix h_variable_8723 = DecideZeroRows(h_variable_8724,h_variable_58);
IsZeroMatrix(h_variable_8723);
IsIdentityMatrix(h_variable_8723);
matrix h_variable_8725[1][3] = concat(h_variable_8723,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8725); matrix h_variable_8726 = h_variable_l[1]; matrix h_variable_8727 = h_variable_l[2];
IsZeroMatrix(h_variable_8726);
matrix h_variable_8728 = DecideZeroRows(h_variable_8726,h_variable_58);
IsZeroMatrix(h_variable_8728);
def h_variable_8729 = h_variable_4814[2,66];
h_variable_8729;
matrix h_variable_8730[1][1] = 0;
matrix h_variable_8731[1][3] = concat(h_variable_8730,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8731); matrix h_variable_8732 = h_variable_l[1]; matrix h_variable_8733 = h_variable_l[2];
ncols(h_variable_8732);
matrix h_variable_8734 = DecideZeroRows(h_variable_8732,h_variable_58);
IsZeroMatrix(h_variable_8734);
nrows(h_variable_8733);
def h_variable_8735 = h_variable_4814[1,66];
h_variable_8735;
matrix h_variable_8736[1][1] = 0;
matrix h_variable_8737[1][3] = concat(h_variable_8736,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8737); matrix h_variable_8738 = h_variable_l[1]; matrix h_variable_8739 = h_variable_l[2];
ncols(h_variable_8738);
matrix h_variable_8740 = DecideZeroRows(h_variable_8738,h_variable_58);
IsZeroMatrix(h_variable_8740);
nrows(h_variable_8739);
def h_variable_8741 = h_variable_4814[15,67];
h_variable_8741;
matrix h_variable_8742[1][1] = -2*a7;
matrix h_variable_8743[1][3] = concat(h_variable_8742,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8743); matrix h_variable_8744 = h_variable_l[1]; matrix h_variable_8745 = h_variable_l[2];
ncols(h_variable_8744);
matrix h_variable_8746 = DecideZeroRows(h_variable_8744,h_variable_58);
IsZeroMatrix(h_variable_8746);
ZeroRows(h_variable_8746);
nrows(h_variable_8745);
matrix h_variable_8748 = submat(h_variable_8744,1..1,intvec( 1 ));
matrix h_variable_8747 = DecideZeroRows(h_variable_8748,h_variable_58);
IsZeroMatrix(h_variable_8747);
IsIdentityMatrix(h_variable_8747);
matrix h_variable_8749[1][3] = concat(h_variable_8747,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8749); matrix h_variable_8750 = h_variable_l[1]; matrix h_variable_8751 = h_variable_l[2];
IsZeroMatrix(h_variable_8750);
matrix h_variable_8752 = DecideZeroRows(h_variable_8750,h_variable_58);
IsZeroMatrix(h_variable_8752);
def h_variable_8753 = h_variable_4814[2,67];
h_variable_8753;
matrix h_variable_8754[1][1] = 0;
matrix h_variable_8755[1][3] = concat(h_variable_8754,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8755); matrix h_variable_8756 = h_variable_l[1]; matrix h_variable_8757 = h_variable_l[2];
ncols(h_variable_8756);
matrix h_variable_8758 = DecideZeroRows(h_variable_8756,h_variable_58);
IsZeroMatrix(h_variable_8758);
nrows(h_variable_8757);
def h_variable_8759 = h_variable_4814[1,67];
h_variable_8759;
matrix h_variable_8760[1][1] = 0;
matrix h_variable_8761[1][3] = concat(h_variable_8760,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8761); matrix h_variable_8762 = h_variable_l[1]; matrix h_variable_8763 = h_variable_l[2];
ncols(h_variable_8762);
matrix h_variable_8764 = DecideZeroRows(h_variable_8762,h_variable_58);
IsZeroMatrix(h_variable_8764);
nrows(h_variable_8763);
def h_variable_8765 = h_variable_4814[15,68];
h_variable_8765;
matrix h_variable_8766[1][1] = 4*a7+2;
matrix h_variable_8767[1][3] = concat(h_variable_8766,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8767); matrix h_variable_8768 = h_variable_l[1]; matrix h_variable_8769 = h_variable_l[2];
ncols(h_variable_8768);
matrix h_variable_8770 = DecideZeroRows(h_variable_8768,h_variable_58);
IsZeroMatrix(h_variable_8770);
ZeroRows(h_variable_8770);
nrows(h_variable_8769);
matrix h_variable_8772 = submat(h_variable_8768,1..1,intvec( 1 ));
matrix h_variable_8771 = DecideZeroRows(h_variable_8772,h_variable_58);
IsZeroMatrix(h_variable_8771);
IsIdentityMatrix(h_variable_8771);
matrix h_variable_8773[1][3] = concat(h_variable_8771,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8773); matrix h_variable_8774 = h_variable_l[1]; matrix h_variable_8775 = h_variable_l[2];
IsZeroMatrix(h_variable_8774);
matrix h_variable_8776 = DecideZeroRows(h_variable_8774,h_variable_58);
IsZeroMatrix(h_variable_8776);
def h_variable_8777 = h_variable_4814[2,68];
h_variable_8777;
matrix h_variable_8778[1][1] = 0;
matrix h_variable_8779[1][3] = concat(h_variable_8778,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8779); matrix h_variable_8780 = h_variable_l[1]; matrix h_variable_8781 = h_variable_l[2];
ncols(h_variable_8780);
matrix h_variable_8782 = DecideZeroRows(h_variable_8780,h_variable_58);
IsZeroMatrix(h_variable_8782);
nrows(h_variable_8781);
def h_variable_8783 = h_variable_4814[1,68];
h_variable_8783;
matrix h_variable_8784[1][1] = 0;
matrix h_variable_8785[1][3] = concat(h_variable_8784,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8785); matrix h_variable_8786 = h_variable_l[1]; matrix h_variable_8787 = h_variable_l[2];
ncols(h_variable_8786);
matrix h_variable_8788 = DecideZeroRows(h_variable_8786,h_variable_58);
IsZeroMatrix(h_variable_8788);
nrows(h_variable_8787);
def h_variable_8789 = h_variable_4814[15,69];
h_variable_8789;
matrix h_variable_8790[1][1] = 2*x2;
matrix h_variable_8791[1][3] = concat(h_variable_8790,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8791); matrix h_variable_8792 = h_variable_l[1]; matrix h_variable_8793 = h_variable_l[2];
ncols(h_variable_8792);
matrix h_variable_8794 = DecideZeroRows(h_variable_8792,h_variable_58);
IsZeroMatrix(h_variable_8794);
ZeroRows(h_variable_8794);
nrows(h_variable_8793);
matrix h_variable_8796 = submat(h_variable_8792,1..1,intvec( 2 ));
matrix h_variable_8795 = DecideZeroRows(h_variable_8796,h_variable_58);
IsZeroMatrix(h_variable_8795);
IsIdentityMatrix(h_variable_8795);
matrix h_variable_8797[1][3] = concat(h_variable_8795,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8797); matrix h_variable_8798 = h_variable_l[1]; matrix h_variable_8799 = h_variable_l[2];
IsZeroMatrix(h_variable_8798);
matrix h_variable_8800 = DecideZeroRows(h_variable_8798,h_variable_58);
IsZeroMatrix(h_variable_8800);
def h_variable_8801 = h_variable_4814[2,69];
h_variable_8801;
matrix h_variable_8802[1][1] = 0;
matrix h_variable_8803[1][3] = concat(h_variable_8802,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8803); matrix h_variable_8804 = h_variable_l[1]; matrix h_variable_8805 = h_variable_l[2];
ncols(h_variable_8804);
matrix h_variable_8806 = DecideZeroRows(h_variable_8804,h_variable_58);
IsZeroMatrix(h_variable_8806);
nrows(h_variable_8805);
def h_variable_8807 = h_variable_4814[1,69];
h_variable_8807;
matrix h_variable_8808[1][1] = 0;
matrix h_variable_8809[1][3] = concat(h_variable_8808,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8809); matrix h_variable_8810 = h_variable_l[1]; matrix h_variable_8811 = h_variable_l[2];
ncols(h_variable_8810);
matrix h_variable_8812 = DecideZeroRows(h_variable_8810,h_variable_58);
IsZeroMatrix(h_variable_8812);
nrows(h_variable_8811);
def h_variable_8813 = h_variable_4814[15,70];
h_variable_8813;
matrix h_variable_8814[1][1] = 0;
matrix h_variable_8815[1][3] = concat(h_variable_8814,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8815); matrix h_variable_8816 = h_variable_l[1]; matrix h_variable_8817 = h_variable_l[2];
ncols(h_variable_8816);
matrix h_variable_8818 = DecideZeroRows(h_variable_8816,h_variable_58);
IsZeroMatrix(h_variable_8818);
nrows(h_variable_8817);
def h_variable_8819 = h_variable_4814[2,70];
h_variable_8819;
matrix h_variable_8820[1][1] = 0;
matrix h_variable_8821[1][3] = concat(h_variable_8820,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8821); matrix h_variable_8822 = h_variable_l[1]; matrix h_variable_8823 = h_variable_l[2];
ncols(h_variable_8822);
matrix h_variable_8824 = DecideZeroRows(h_variable_8822,h_variable_58);
IsZeroMatrix(h_variable_8824);
nrows(h_variable_8823);
def h_variable_8825 = h_variable_4814[1,70];
h_variable_8825;
matrix h_variable_8826[1][1] = 0;
matrix h_variable_8827[1][3] = concat(h_variable_8826,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8827); matrix h_variable_8828 = h_variable_l[1]; matrix h_variable_8829 = h_variable_l[2];
ncols(h_variable_8828);
matrix h_variable_8830 = DecideZeroRows(h_variable_8828,h_variable_58);
IsZeroMatrix(h_variable_8830);
nrows(h_variable_8829);
def h_variable_8831 = h_variable_4814[15,71];
h_variable_8831;
matrix h_variable_8832[1][1] = 0;
matrix h_variable_8833[1][3] = concat(h_variable_8832,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8833); matrix h_variable_8834 = h_variable_l[1]; matrix h_variable_8835 = h_variable_l[2];
ncols(h_variable_8834);
matrix h_variable_8836 = DecideZeroRows(h_variable_8834,h_variable_58);
IsZeroMatrix(h_variable_8836);
nrows(h_variable_8835);
def h_variable_8837 = h_variable_4814[2,71];
h_variable_8837;
matrix h_variable_8838[1][1] = 0;
matrix h_variable_8839[1][3] = concat(h_variable_8838,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8839); matrix h_variable_8840 = h_variable_l[1]; matrix h_variable_8841 = h_variable_l[2];
ncols(h_variable_8840);
matrix h_variable_8842 = DecideZeroRows(h_variable_8840,h_variable_58);
IsZeroMatrix(h_variable_8842);
nrows(h_variable_8841);
def h_variable_8843 = h_variable_4814[1,71];
h_variable_8843;
matrix h_variable_8844[1][1] = 0;
matrix h_variable_8845[1][3] = concat(h_variable_8844,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8845); matrix h_variable_8846 = h_variable_l[1]; matrix h_variable_8847 = h_variable_l[2];
ncols(h_variable_8846);
matrix h_variable_8848 = DecideZeroRows(h_variable_8846,h_variable_58);
IsZeroMatrix(h_variable_8848);
nrows(h_variable_8847);
def h_variable_8849 = h_variable_4814[15,72];
h_variable_8849;
matrix h_variable_8850[1][1] = 0;
matrix h_variable_8851[1][3] = concat(h_variable_8850,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8851); matrix h_variable_8852 = h_variable_l[1]; matrix h_variable_8853 = h_variable_l[2];
ncols(h_variable_8852);
matrix h_variable_8854 = DecideZeroRows(h_variable_8852,h_variable_58);
IsZeroMatrix(h_variable_8854);
nrows(h_variable_8853);
def h_variable_8855 = h_variable_4814[2,72];
h_variable_8855;
matrix h_variable_8856[1][1] = 0;
matrix h_variable_8857[1][3] = concat(h_variable_8856,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8857); matrix h_variable_8858 = h_variable_l[1]; matrix h_variable_8859 = h_variable_l[2];
ncols(h_variable_8858);
matrix h_variable_8860 = DecideZeroRows(h_variable_8858,h_variable_58);
IsZeroMatrix(h_variable_8860);
nrows(h_variable_8859);
def h_variable_8861 = h_variable_4814[1,72];
h_variable_8861;
matrix h_variable_8862[1][1] = 0;
matrix h_variable_8863[1][3] = concat(h_variable_8862,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8863); matrix h_variable_8864 = h_variable_l[1]; matrix h_variable_8865 = h_variable_l[2];
ncols(h_variable_8864);
matrix h_variable_8866 = DecideZeroRows(h_variable_8864,h_variable_58);
IsZeroMatrix(h_variable_8866);
nrows(h_variable_8865);
def h_variable_8867 = h_variable_4814[15,73];
h_variable_8867;
matrix h_variable_8868[1][1] = -4;
matrix h_variable_8869[1][3] = concat(h_variable_8868,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8869); matrix h_variable_8870 = h_variable_l[1]; matrix h_variable_8871 = h_variable_l[2];
ncols(h_variable_8870);
matrix h_variable_8872 = DecideZeroRows(h_variable_8870,h_variable_58);
IsZeroMatrix(h_variable_8872);
ZeroRows(h_variable_8872);
nrows(h_variable_8871);
matrix h_variable_8874 = submat(h_variable_8870,1..1,intvec( 1 ));
matrix h_variable_8873 = DecideZeroRows(h_variable_8874,h_variable_58);
IsZeroMatrix(h_variable_8873);
IsIdentityMatrix(h_variable_8873);
matrix h_variable_8875[1][3] = concat(h_variable_8873,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8875); matrix h_variable_8876 = h_variable_l[1]; matrix h_variable_8877 = h_variable_l[2];
IsZeroMatrix(h_variable_8876);
matrix h_variable_8878 = DecideZeroRows(h_variable_8876,h_variable_58);
IsZeroMatrix(h_variable_8878);
def h_variable_8879 = h_variable_4814[2,73];
h_variable_8879;
matrix h_variable_8880[1][1] = 0;
matrix h_variable_8881[1][3] = concat(h_variable_8880,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8881); matrix h_variable_8882 = h_variable_l[1]; matrix h_variable_8883 = h_variable_l[2];
ncols(h_variable_8882);
matrix h_variable_8884 = DecideZeroRows(h_variable_8882,h_variable_58);
IsZeroMatrix(h_variable_8884);
nrows(h_variable_8883);
def h_variable_8885 = h_variable_4814[1,73];
h_variable_8885;
matrix h_variable_8886[1][1] = 0;
matrix h_variable_8887[1][3] = concat(h_variable_8886,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8887); matrix h_variable_8888 = h_variable_l[1]; matrix h_variable_8889 = h_variable_l[2];
ncols(h_variable_8888);
matrix h_variable_8890 = DecideZeroRows(h_variable_8888,h_variable_58);
IsZeroMatrix(h_variable_8890);
nrows(h_variable_8889);
def h_variable_8891 = h_variable_4814[15,74];
h_variable_8891;
matrix h_variable_8892[1][1] = 4*a7-2;
matrix h_variable_8893[1][3] = concat(h_variable_8892,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8893); matrix h_variable_8894 = h_variable_l[1]; matrix h_variable_8895 = h_variable_l[2];
ncols(h_variable_8894);
matrix h_variable_8896 = DecideZeroRows(h_variable_8894,h_variable_58);
IsZeroMatrix(h_variable_8896);
ZeroRows(h_variable_8896);
nrows(h_variable_8895);
matrix h_variable_8898 = submat(h_variable_8894,1..1,intvec( 2 ));
matrix h_variable_8897 = DecideZeroRows(h_variable_8898,h_variable_58);
IsZeroMatrix(h_variable_8897);
IsIdentityMatrix(h_variable_8897);
matrix h_variable_8899[1][3] = concat(h_variable_8897,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8899); matrix h_variable_8900 = h_variable_l[1]; matrix h_variable_8901 = h_variable_l[2];
IsZeroMatrix(h_variable_8900);
matrix h_variable_8902 = DecideZeroRows(h_variable_8900,h_variable_58);
IsZeroMatrix(h_variable_8902);
def h_variable_8903 = h_variable_4814[2,74];
h_variable_8903;
matrix h_variable_8904[1][1] = 0;
matrix h_variable_8905[1][3] = concat(h_variable_8904,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8905); matrix h_variable_8906 = h_variable_l[1]; matrix h_variable_8907 = h_variable_l[2];
ncols(h_variable_8906);
matrix h_variable_8908 = DecideZeroRows(h_variable_8906,h_variable_58);
IsZeroMatrix(h_variable_8908);
nrows(h_variable_8907);
def h_variable_8909 = h_variable_4814[1,74];
h_variable_8909;
matrix h_variable_8910[1][1] = 0;
matrix h_variable_8911[1][3] = concat(h_variable_8910,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8911); matrix h_variable_8912 = h_variable_l[1]; matrix h_variable_8913 = h_variable_l[2];
ncols(h_variable_8912);
matrix h_variable_8914 = DecideZeroRows(h_variable_8912,h_variable_58);
IsZeroMatrix(h_variable_8914);
nrows(h_variable_8913);
def h_variable_8915 = h_variable_4814[15,75];
h_variable_8915;
matrix h_variable_8916[1][1] = 2*a7-2;
matrix h_variable_8917[1][3] = concat(h_variable_8916,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8917); matrix h_variable_8918 = h_variable_l[1]; matrix h_variable_8919 = h_variable_l[2];
ncols(h_variable_8918);
matrix h_variable_8920 = DecideZeroRows(h_variable_8918,h_variable_58);
IsZeroMatrix(h_variable_8920);
ZeroRows(h_variable_8920);
nrows(h_variable_8919);
matrix h_variable_8922 = submat(h_variable_8918,1..1,intvec( 1 ));
matrix h_variable_8921 = DecideZeroRows(h_variable_8922,h_variable_58);
IsZeroMatrix(h_variable_8921);
IsIdentityMatrix(h_variable_8921);
matrix h_variable_8923[1][3] = concat(h_variable_8921,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8923); matrix h_variable_8924 = h_variable_l[1]; matrix h_variable_8925 = h_variable_l[2];
IsZeroMatrix(h_variable_8924);
matrix h_variable_8926 = DecideZeroRows(h_variable_8924,h_variable_58);
IsZeroMatrix(h_variable_8926);
def h_variable_8927 = h_variable_4814[2,75];
h_variable_8927;
matrix h_variable_8928[1][1] = 0;
matrix h_variable_8929[1][3] = concat(h_variable_8928,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8929); matrix h_variable_8930 = h_variable_l[1]; matrix h_variable_8931 = h_variable_l[2];
ncols(h_variable_8930);
matrix h_variable_8932 = DecideZeroRows(h_variable_8930,h_variable_58);
IsZeroMatrix(h_variable_8932);
nrows(h_variable_8931);
def h_variable_8933 = h_variable_4814[1,75];
h_variable_8933;
matrix h_variable_8934[1][1] = 0;
matrix h_variable_8935[1][3] = concat(h_variable_8934,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8935); matrix h_variable_8936 = h_variable_l[1]; matrix h_variable_8937 = h_variable_l[2];
ncols(h_variable_8936);
matrix h_variable_8938 = DecideZeroRows(h_variable_8936,h_variable_58);
IsZeroMatrix(h_variable_8938);
nrows(h_variable_8937);
def h_variable_8939 = h_variable_4814[15,76];
h_variable_8939;
matrix h_variable_8940[1][1] = 0;
matrix h_variable_8941[1][3] = concat(h_variable_8940,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8941); matrix h_variable_8942 = h_variable_l[1]; matrix h_variable_8943 = h_variable_l[2];
ncols(h_variable_8942);
matrix h_variable_8944 = DecideZeroRows(h_variable_8942,h_variable_58);
IsZeroMatrix(h_variable_8944);
nrows(h_variable_8943);
def h_variable_8945 = h_variable_4814[2,76];
h_variable_8945;
matrix h_variable_8946[1][1] = 0;
matrix h_variable_8947[1][3] = concat(h_variable_8946,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8947); matrix h_variable_8948 = h_variable_l[1]; matrix h_variable_8949 = h_variable_l[2];
ncols(h_variable_8948);
matrix h_variable_8950 = DecideZeroRows(h_variable_8948,h_variable_58);
IsZeroMatrix(h_variable_8950);
nrows(h_variable_8949);
def h_variable_8951 = h_variable_4814[1,76];
h_variable_8951;
matrix h_variable_8952[1][1] = 0;
matrix h_variable_8953[1][3] = concat(h_variable_8952,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8953); matrix h_variable_8954 = h_variable_l[1]; matrix h_variable_8955 = h_variable_l[2];
ncols(h_variable_8954);
matrix h_variable_8956 = DecideZeroRows(h_variable_8954,h_variable_58);
IsZeroMatrix(h_variable_8956);
nrows(h_variable_8955);
def h_variable_8957 = h_variable_4814[15,77];
h_variable_8957;
matrix h_variable_8958[1][1] = -4*a7+2;
matrix h_variable_8959[1][3] = concat(h_variable_8958,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8959); matrix h_variable_8960 = h_variable_l[1]; matrix h_variable_8961 = h_variable_l[2];
ncols(h_variable_8960);
matrix h_variable_8962 = DecideZeroRows(h_variable_8960,h_variable_58);
IsZeroMatrix(h_variable_8962);
ZeroRows(h_variable_8962);
nrows(h_variable_8961);
matrix h_variable_8964 = submat(h_variable_8960,1..1,intvec( 2 ));
matrix h_variable_8963 = DecideZeroRows(h_variable_8964,h_variable_58);
IsZeroMatrix(h_variable_8963);
IsIdentityMatrix(h_variable_8963);
matrix h_variable_8965[1][3] = concat(h_variable_8963,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8965); matrix h_variable_8966 = h_variable_l[1]; matrix h_variable_8967 = h_variable_l[2];
IsZeroMatrix(h_variable_8966);
matrix h_variable_8968 = DecideZeroRows(h_variable_8966,h_variable_58);
IsZeroMatrix(h_variable_8968);
def h_variable_8969 = h_variable_4814[2,77];
h_variable_8969;
matrix h_variable_8970[1][1] = 0;
matrix h_variable_8971[1][3] = concat(h_variable_8970,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8971); matrix h_variable_8972 = h_variable_l[1]; matrix h_variable_8973 = h_variable_l[2];
ncols(h_variable_8972);
matrix h_variable_8974 = DecideZeroRows(h_variable_8972,h_variable_58);
IsZeroMatrix(h_variable_8974);
nrows(h_variable_8973);
def h_variable_8975 = h_variable_4814[1,77];
h_variable_8975;
matrix h_variable_8976[1][1] = 0;
matrix h_variable_8977[1][3] = concat(h_variable_8976,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8977); matrix h_variable_8978 = h_variable_l[1]; matrix h_variable_8979 = h_variable_l[2];
ncols(h_variable_8978);
matrix h_variable_8980 = DecideZeroRows(h_variable_8978,h_variable_58);
IsZeroMatrix(h_variable_8980);
nrows(h_variable_8979);
def h_variable_8981 = h_variable_4814[15,78];
h_variable_8981;
matrix h_variable_8982[1][1] = 4*a7*x2+2*a7*x3-4*x1+4*x2;
matrix h_variable_8983[1][3] = concat(h_variable_8982,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8983); matrix h_variable_8984 = h_variable_l[1]; matrix h_variable_8985 = h_variable_l[2];
ncols(h_variable_8984);
matrix h_variable_8986 = DecideZeroRows(h_variable_8984,h_variable_58);
IsZeroMatrix(h_variable_8986);
ZeroRows(h_variable_8986);
nrows(h_variable_8985);
matrix h_variable_8988 = submat(h_variable_8984,1..1,intvec( 2, 3, 4 ));
matrix h_variable_8987 = DecideZeroRows(h_variable_8988,h_variable_58);
IsZeroMatrix(h_variable_8987);
matrix h_variable_8989[1][5] = concat(h_variable_8987,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_8989); matrix h_variable_8990 = h_variable_l[1]; matrix h_variable_8991 = h_variable_l[2];
IsZeroMatrix(h_variable_8990);
matrix h_variable_8992 = DecideZeroRows(h_variable_8990,h_variable_58);
IsZeroMatrix(h_variable_8992);
def h_variable_8993 = h_variable_4814[2,78];
h_variable_8993;
matrix h_variable_8994[1][1] = 0;
matrix h_variable_8995[1][3] = concat(h_variable_8994,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_8995); matrix h_variable_8996 = h_variable_l[1]; matrix h_variable_8997 = h_variable_l[2];
ncols(h_variable_8996);
matrix h_variable_8998 = DecideZeroRows(h_variable_8996,h_variable_58);
IsZeroMatrix(h_variable_8998);
nrows(h_variable_8997);
def h_variable_8999 = h_variable_4814[1,78];
h_variable_8999;
matrix h_variable_9000[1][1] = 0;
kill h_variable_8443;kill h_variable_8444;kill h_variable_8445;kill h_variable_8446;kill h_variable_8448;kill h_variable_8449;kill h_variable_8450;kill h_variable_8451;kill h_variable_8452;kill h_variable_8454;kill h_variable_8455;kill h_variable_8456;kill h_variable_8457;kill h_variable_8458;kill h_variable_8459;kill h_variable_8460;kill h_variable_8461;kill h_variable_8462;kill h_variable_8463;kill h_variable_8464;kill h_variable_8465;kill h_variable_8466;kill h_variable_8467;kill h_variable_8468;kill h_variable_8469;kill h_variable_8470;kill h_variable_8471;kill h_variable_8472;kill h_variable_8473;kill h_variable_8474;kill h_variable_8475;kill h_variable_8476;kill h_variable_8477;kill h_variable_8478;kill h_variable_8479;kill h_variable_8480;kill h_variable_8481;kill h_variable_8482;kill h_variable_8483;kill h_variable_8484;kill h_variable_8485;kill h_variable_8486;kill h_variable_8487;kill h_variable_8488;kill h_variable_8489;kill h_variable_8490;kill h_variable_8491;kill h_variable_8492;kill h_variable_8493;kill h_variable_8494;kill h_variable_8495;kill h_variable_8496;kill h_variable_8497;kill h_variable_8498;kill h_variable_8499;kill h_variable_8500;kill h_variable_8501;kill h_variable_8502;kill h_variable_8503;kill h_variable_8504;kill h_variable_8505;kill h_variable_8506;kill h_variable_8507;kill h_variable_8508;kill h_variable_8509;kill h_variable_8510;kill h_variable_8511;kill h_variable_8512;kill h_variable_8513;kill h_variable_8514;kill h_variable_8515;kill h_variable_8516;kill h_variable_8517;kill h_variable_8518;kill h_variable_8519;kill h_variable_8520;kill h_variable_8521;kill h_variable_8522;kill h_variable_8523;kill h_variable_8524;kill h_variable_8525;kill h_variable_8526;kill h_variable_8527;kill h_variable_8528;kill h_variable_8529;kill h_variable_8530;kill h_variable_8531;kill h_variable_8532;kill h_variable_8533;kill h_variable_8534;kill h_variable_8535;kill h_variable_8536;kill h_variable_8537;kill h_variable_8538;kill h_variable_8539;kill h_variable_8540;kill h_variable_8541;kill h_variable_8542;kill h_variable_8543;kill h_variable_8544;kill h_variable_8545;kill h_variable_8546;kill h_variable_8547;kill h_variable_8548;kill h_variable_8549;kill h_variable_8550;kill h_variable_8551;kill h_variable_8552;kill h_variable_8553;kill h_variable_8554;kill h_variable_8560;kill h_variable_8563;kill h_variable_8566;kill h_variable_8568;kill h_variable_8572;kill h_variable_8574;kill h_variable_8575;kill h_variable_8576;kill h_variable_8577;kill h_variable_8578;kill h_variable_8580;kill h_variable_8581;kill h_variable_8582;kill h_variable_8583;kill h_variable_8584;kill h_variable_8585;kill h_variable_8586;kill h_variable_8587;kill h_variable_8588;kill h_variable_8589;kill h_variable_8590;kill h_variable_8591;kill h_variable_8592;kill h_variable_8593;kill h_variable_8594;kill h_variable_8595;kill h_variable_8596;kill h_variable_8597;kill h_variable_8598;kill h_variable_8599;kill h_variable_8600;kill h_variable_8601;kill h_variable_8602;kill h_variable_8603;kill h_variable_8604;kill h_variable_8605;kill h_variable_8606;kill h_variable_8607;kill h_variable_8608;kill h_variable_8609;kill h_variable_8610;kill h_variable_8611;kill h_variable_8612;kill h_variable_8613;kill h_variable_8614;kill h_variable_8615;kill h_variable_8616;kill h_variable_8617;kill h_variable_8618;kill h_variable_8619;kill h_variable_8620;kill h_variable_8621;kill h_variable_8622;kill h_variable_8623;kill h_variable_8624;kill h_variable_8625;kill h_variable_8626;kill h_variable_8627;kill h_variable_8628;kill h_variable_8629;kill h_variable_8630;kill h_variable_8631;kill h_variable_8632;kill h_variable_8633;kill h_variable_8634;kill h_variable_8635;kill h_variable_8636;kill h_variable_8637;kill h_variable_8638;kill h_variable_8639;kill h_variable_8640;kill h_variable_8641;kill h_variable_8642;kill h_variable_8643;kill h_variable_8644;kill h_variable_8645;kill h_variable_8646;kill h_variable_8647;kill h_variable_8648;kill h_variable_8649;kill h_variable_8650;kill h_variable_8651;kill h_variable_8652;kill h_variable_8653;kill h_variable_8654;kill h_variable_8655;kill h_variable_8656;kill h_variable_8657;kill h_variable_8658;kill h_variable_8659;kill h_variable_8660;kill h_variable_8661;kill h_variable_8662;kill h_variable_8663;kill h_variable_8664;kill h_variable_8665;kill h_variable_8666;kill h_variable_8667;kill h_variable_8668;kill h_variable_8669;kill h_variable_8670;kill h_variable_8671;kill h_variable_8672;kill h_variable_8673;kill h_variable_8674;kill h_variable_8675;kill h_variable_8676;kill h_variable_8677;kill h_variable_8678;kill h_variable_8679;kill h_variable_8680;kill h_variable_8681;kill h_variable_8682;kill h_variable_8683;kill h_variable_8684;kill h_variable_8685;kill h_variable_8686;kill h_variable_8687;kill h_variable_8688;kill h_variable_8689;kill h_variable_8690;kill h_variable_8691;kill h_variable_8692;kill h_variable_8693;kill h_variable_8694;kill h_variable_8695;kill h_variable_8696;kill h_variable_8697;kill h_variable_8698;kill h_variable_8699;kill h_variable_8700;kill h_variable_8701;kill h_variable_8702;kill h_variable_8703;kill h_variable_8704;kill h_variable_8705;kill h_variable_8706;kill h_variable_8707;kill h_variable_8708;kill h_variable_8709;kill h_variable_8710;kill h_variable_8711;kill h_variable_8712;kill h_variable_8713;kill h_variable_8714;kill h_variable_8715;kill h_variable_8716;kill h_variable_8717;kill h_variable_8718;kill h_variable_8719;kill h_variable_8720;kill h_variable_8721;kill h_variable_8722;kill h_variable_8723;kill h_variable_8724;kill h_variable_8725;kill h_variable_8726;kill h_variable_8727;kill h_variable_8728;kill h_variable_8729;kill h_variable_8730;kill h_variable_8731;kill h_variable_8732;kill h_variable_8733;kill h_variable_8734;kill h_variable_8740;kill h_variable_8742;kill h_variable_8743;kill h_variable_8744;kill h_variable_8745;kill h_variable_8746;kill h_variable_8748;kill h_variable_8752;kill h_variable_8754;kill h_variable_8755;kill h_variable_8756;kill h_variable_8757;kill h_variable_8758;kill h_variable_8759;kill h_variable_8760;kill h_variable_8761;kill h_variable_8762;kill h_variable_8763;kill h_variable_8764;kill h_variable_8765;kill h_variable_8766;kill h_variable_8767;kill h_variable_8768;kill h_variable_8769;kill h_variable_8770;kill h_variable_8771;kill h_variable_8772;kill h_variable_8773;kill h_variable_8774;kill h_variable_8775;kill h_variable_8776;kill h_variable_8777;kill h_variable_8778;kill h_variable_8779;kill h_variable_8780;kill h_variable_8781;kill h_variable_8782;kill h_variable_8783;kill h_variable_8784;kill h_variable_8785;kill h_variable_8786;kill h_variable_8787;kill h_variable_8788;kill h_variable_8789;kill h_variable_8790;kill h_variable_8791;kill h_variable_8792;kill h_variable_8793;kill h_variable_8794;kill h_variable_8795;kill h_variable_8796;kill h_variable_8797;kill h_variable_8798;kill h_variable_8799;kill h_variable_8800;kill h_variable_8801;kill h_variable_8802;kill h_variable_8803;kill h_variable_8804;kill h_variable_8805;kill h_variable_8806;kill h_variable_8807;kill h_variable_8808;kill h_variable_8809;kill h_variable_8810;kill h_variable_8811;kill h_variable_8812;kill h_variable_8813;kill h_variable_8814;kill h_variable_8815;kill h_variable_8816;kill h_variable_8817;kill h_variable_8818;kill h_variable_8819;kill h_variable_8820;kill h_variable_8821;kill h_variable_8822;kill h_variable_8823;kill h_variable_8824;kill h_variable_8825;kill h_variable_8826;kill h_variable_8827;kill h_variable_8828;kill h_variable_8829;kill h_variable_8830;kill h_variable_8831;kill h_variable_8832;kill h_variable_8833;kill h_variable_8834;kill h_variable_8835;kill h_variable_8836;kill h_variable_8837;kill h_variable_8838;kill h_variable_8839;kill h_variable_8840;kill h_variable_8841;kill h_variable_8842;kill h_variable_8843;kill h_variable_8844;kill h_variable_8845;kill h_variable_8846;kill h_variable_8847;kill h_variable_8848;kill h_variable_8849;kill h_variable_8850;kill h_variable_8851;kill h_variable_8852;kill h_variable_8853;kill h_variable_8854;kill h_variable_8855;kill h_variable_8856;kill h_variable_8857;kill h_variable_8858;kill h_variable_8859;kill h_variable_8860;kill h_variable_8861;kill h_variable_8862;kill h_variable_8863;kill h_variable_8864;kill h_variable_8865;kill h_variable_8866;kill h_variable_8867;kill h_variable_8868;kill h_variable_8869;kill h_variable_8870;kill h_variable_8871;kill h_variable_8872;kill h_variable_8873;kill h_variable_8874;kill h_variable_8875;kill h_variable_8876;kill h_variable_8877;kill h_variable_8878;kill h_variable_8879;kill h_variable_8880;kill h_variable_8881;kill h_variable_8882;kill h_variable_8883;kill h_variable_8884;kill h_variable_8885;kill h_variable_8886;kill h_variable_8887;kill h_variable_8888;kill h_variable_8889;kill h_variable_8890;kill h_variable_8891;kill h_variable_8892;kill h_variable_8893;kill h_variable_8894;kill h_variable_8895;kill h_variable_8896;kill h_variable_8897;kill h_variable_8898;kill h_variable_8899;kill h_variable_8900;kill h_variable_8901;kill h_variable_8902;kill h_variable_8903;kill h_variable_8904;kill h_variable_8905;kill h_variable_8906;kill h_variable_8907;kill h_variable_8908;
matrix h_variable_9001[1][3] = concat(h_variable_9000,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9001); matrix h_variable_9002 = h_variable_l[1]; matrix h_variable_9003 = h_variable_l[2];
ncols(h_variable_9002);
matrix h_variable_9004 = DecideZeroRows(h_variable_9002,h_variable_58);
IsZeroMatrix(h_variable_9004);
nrows(h_variable_9003);
def h_variable_9005 = h_variable_4814[15,79];
h_variable_9005;
matrix h_variable_9006[1][1] = 2*a7*x2+2*a7*x3-4*x2-2*x3;
matrix h_variable_9007[1][3] = concat(h_variable_9006,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9007); matrix h_variable_9008 = h_variable_l[1]; matrix h_variable_9009 = h_variable_l[2];
ncols(h_variable_9008);
matrix h_variable_9010 = DecideZeroRows(h_variable_9008,h_variable_58);
IsZeroMatrix(h_variable_9010);
ZeroRows(h_variable_9010);
nrows(h_variable_9009);
matrix h_variable_9012 = submat(h_variable_9008,1..1,intvec( 2, 3, 4 ));
matrix h_variable_9011 = DecideZeroRows(h_variable_9012,h_variable_58);
IsZeroMatrix(h_variable_9011);
matrix h_variable_9013[1][5] = concat(h_variable_9011,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9013); matrix h_variable_9014 = h_variable_l[1]; matrix h_variable_9015 = h_variable_l[2];
IsZeroMatrix(h_variable_9014);
matrix h_variable_9016 = DecideZeroRows(h_variable_9014,h_variable_58);
IsZeroMatrix(h_variable_9016);
def h_variable_9017 = h_variable_4814[2,79];
h_variable_9017;
matrix h_variable_9018[1][1] = 0;
matrix h_variable_9019[1][3] = concat(h_variable_9018,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9019); matrix h_variable_9020 = h_variable_l[1]; matrix h_variable_9021 = h_variable_l[2];
ncols(h_variable_9020);
matrix h_variable_9022 = DecideZeroRows(h_variable_9020,h_variable_58);
IsZeroMatrix(h_variable_9022);
nrows(h_variable_9021);
def h_variable_9023 = h_variable_4814[1,79];
h_variable_9023;
matrix h_variable_9024[1][1] = 0;
matrix h_variable_9025[1][3] = concat(h_variable_9024,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9025); matrix h_variable_9026 = h_variable_l[1]; matrix h_variable_9027 = h_variable_l[2];
ncols(h_variable_9026);
matrix h_variable_9028 = DecideZeroRows(h_variable_9026,h_variable_58);
IsZeroMatrix(h_variable_9028);
nrows(h_variable_9027);
def h_variable_9029 = h_variable_4814[15,80];
h_variable_9029;
matrix h_variable_9030[1][1] = -4*a7*x3+2*x1+4*x3;
matrix h_variable_9031[1][3] = concat(h_variable_9030,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9031); matrix h_variable_9032 = h_variable_l[1]; matrix h_variable_9033 = h_variable_l[2];
ncols(h_variable_9032);
matrix h_variable_9034 = DecideZeroRows(h_variable_9032,h_variable_58);
IsZeroMatrix(h_variable_9034);
ZeroRows(h_variable_9034);
nrows(h_variable_9033);
matrix h_variable_9036 = submat(h_variable_9032,1..1,intvec( 2, 3, 4 ));
matrix h_variable_9035 = DecideZeroRows(h_variable_9036,h_variable_58);
IsZeroMatrix(h_variable_9035);
matrix h_variable_9037[1][5] = concat(h_variable_9035,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9037); matrix h_variable_9038 = h_variable_l[1]; matrix h_variable_9039 = h_variable_l[2];
IsZeroMatrix(h_variable_9038);
matrix h_variable_9040 = DecideZeroRows(h_variable_9038,h_variable_58);
IsZeroMatrix(h_variable_9040);
def h_variable_9041 = h_variable_4814[2,80];
h_variable_9041;
matrix h_variable_9042[1][1] = 0;
matrix h_variable_9043[1][3] = concat(h_variable_9042,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9043); matrix h_variable_9044 = h_variable_l[1]; matrix h_variable_9045 = h_variable_l[2];
ncols(h_variable_9044);
matrix h_variable_9046 = DecideZeroRows(h_variable_9044,h_variable_58);
IsZeroMatrix(h_variable_9046);
nrows(h_variable_9045);
def h_variable_9047 = h_variable_4814[1,80];
h_variable_9047;
matrix h_variable_9048[1][1] = 0;
matrix h_variable_9049[1][3] = concat(h_variable_9048,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9049); matrix h_variable_9050 = h_variable_l[1]; matrix h_variable_9051 = h_variable_l[2];
ncols(h_variable_9050);
matrix h_variable_9052 = DecideZeroRows(h_variable_9050,h_variable_58);
IsZeroMatrix(h_variable_9052);
nrows(h_variable_9051);
def h_variable_9053 = h_variable_4814[15,81];
h_variable_9053;
matrix h_variable_9054[1][1] = -4*a7*x3-2*x1+2*x3;
matrix h_variable_9055[1][3] = concat(h_variable_9054,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9055); matrix h_variable_9056 = h_variable_l[1]; matrix h_variable_9057 = h_variable_l[2];
ncols(h_variable_9056);
matrix h_variable_9058 = DecideZeroRows(h_variable_9056,h_variable_58);
IsZeroMatrix(h_variable_9058);
ZeroRows(h_variable_9058);
nrows(h_variable_9057);
matrix h_variable_9060 = submat(h_variable_9056,1..1,intvec( 2, 3, 4 ));
matrix h_variable_9059 = DecideZeroRows(h_variable_9060,h_variable_58);
IsZeroMatrix(h_variable_9059);
matrix h_variable_9061[1][5] = concat(h_variable_9059,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9061); matrix h_variable_9062 = h_variable_l[1]; matrix h_variable_9063 = h_variable_l[2];
IsZeroMatrix(h_variable_9062);
matrix h_variable_9064 = DecideZeroRows(h_variable_9062,h_variable_58);
IsZeroMatrix(h_variable_9064);
def h_variable_9065 = h_variable_4814[2,81];
h_variable_9065;
matrix h_variable_9066[1][1] = 0;
matrix h_variable_9067[1][3] = concat(h_variable_9066,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9067); matrix h_variable_9068 = h_variable_l[1]; matrix h_variable_9069 = h_variable_l[2];
ncols(h_variable_9068);
matrix h_variable_9070 = DecideZeroRows(h_variable_9068,h_variable_58);
IsZeroMatrix(h_variable_9070);
nrows(h_variable_9069);
def h_variable_9071 = h_variable_4814[1,81];
h_variable_9071;
matrix h_variable_9072[1][1] = 0;
matrix h_variable_9073[1][3] = concat(h_variable_9072,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9073); matrix h_variable_9074 = h_variable_l[1]; matrix h_variable_9075 = h_variable_l[2];
ncols(h_variable_9074);
matrix h_variable_9076 = DecideZeroRows(h_variable_9074,h_variable_58);
IsZeroMatrix(h_variable_9076);
nrows(h_variable_9075);
def h_variable_9077 = h_variable_4814[15,82];
h_variable_9077;
matrix h_variable_9078[1][1] = 0;
matrix h_variable_9079[1][3] = concat(h_variable_9078,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9079); matrix h_variable_9080 = h_variable_l[1]; matrix h_variable_9081 = h_variable_l[2];
ncols(h_variable_9080);
matrix h_variable_9082 = DecideZeroRows(h_variable_9080,h_variable_58);
IsZeroMatrix(h_variable_9082);
nrows(h_variable_9081);
def h_variable_9083 = h_variable_4814[2,82];
h_variable_9083;
matrix h_variable_9084[1][1] = 0;
matrix h_variable_9085[1][3] = concat(h_variable_9084,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9085); matrix h_variable_9086 = h_variable_l[1]; matrix h_variable_9087 = h_variable_l[2];
ncols(h_variable_9086);
matrix h_variable_9088 = DecideZeroRows(h_variable_9086,h_variable_58);
IsZeroMatrix(h_variable_9088);
nrows(h_variable_9087);
def h_variable_9089 = h_variable_4814[1,82];
h_variable_9089;
matrix h_variable_9090[1][1] = 0;
matrix h_variable_9091[1][3] = concat(h_variable_9090,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9091); matrix h_variable_9092 = h_variable_l[1]; matrix h_variable_9093 = h_variable_l[2];
ncols(h_variable_9092);
matrix h_variable_9094 = DecideZeroRows(h_variable_9092,h_variable_58);
IsZeroMatrix(h_variable_9094);
nrows(h_variable_9093);
def h_variable_9095 = h_variable_4814[15,83];
h_variable_9095;
matrix h_variable_9096[1][1] = 4*a7-4;
matrix h_variable_9097[1][3] = concat(h_variable_9096,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9097); matrix h_variable_9098 = h_variable_l[1]; matrix h_variable_9099 = h_variable_l[2];
ncols(h_variable_9098);
matrix h_variable_9100 = DecideZeroRows(h_variable_9098,h_variable_58);
IsZeroMatrix(h_variable_9100);
ZeroRows(h_variable_9100);
nrows(h_variable_9099);
matrix h_variable_9102 = submat(h_variable_9098,1..1,intvec( 1 ));
matrix h_variable_9101 = DecideZeroRows(h_variable_9102,h_variable_58);
IsZeroMatrix(h_variable_9101);
IsIdentityMatrix(h_variable_9101);
matrix h_variable_9103[1][3] = concat(h_variable_9101,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9103); matrix h_variable_9104 = h_variable_l[1]; matrix h_variable_9105 = h_variable_l[2];
IsZeroMatrix(h_variable_9104);
matrix h_variable_9106 = DecideZeroRows(h_variable_9104,h_variable_58);
IsZeroMatrix(h_variable_9106);
def h_variable_9107 = h_variable_4814[2,83];
h_variable_9107;
matrix h_variable_9108[1][1] = 0;
matrix h_variable_9109[1][3] = concat(h_variable_9108,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9109); matrix h_variable_9110 = h_variable_l[1]; matrix h_variable_9111 = h_variable_l[2];
ncols(h_variable_9110);
matrix h_variable_9112 = DecideZeroRows(h_variable_9110,h_variable_58);
IsZeroMatrix(h_variable_9112);
nrows(h_variable_9111);
def h_variable_9113 = h_variable_4814[1,83];
h_variable_9113;
matrix h_variable_9114[1][1] = 0;
matrix h_variable_9115[1][3] = concat(h_variable_9114,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9115); matrix h_variable_9116 = h_variable_l[1]; matrix h_variable_9117 = h_variable_l[2];
ncols(h_variable_9116);
matrix h_variable_9118 = DecideZeroRows(h_variable_9116,h_variable_58);
IsZeroMatrix(h_variable_9118);
nrows(h_variable_9117);
def h_variable_9119 = h_variable_4814[15,84];
h_variable_9119;
matrix h_variable_9120[1][1] = -4*a7*x1+4*a7*x3-2*x1+2*x3;
matrix h_variable_9121[1][3] = concat(h_variable_9120,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9121); matrix h_variable_9122 = h_variable_l[1]; matrix h_variable_9123 = h_variable_l[2];
ncols(h_variable_9122);
matrix h_variable_9124 = DecideZeroRows(h_variable_9122,h_variable_58);
IsZeroMatrix(h_variable_9124);
ZeroRows(h_variable_9124);
nrows(h_variable_9123);
matrix h_variable_9126 = submat(h_variable_9122,1..1,intvec( 2 ));
matrix h_variable_9125 = DecideZeroRows(h_variable_9126,h_variable_58);
IsZeroMatrix(h_variable_9125);
IsIdentityMatrix(h_variable_9125);
matrix h_variable_9127[1][3] = concat(h_variable_9125,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9127); matrix h_variable_9128 = h_variable_l[1]; matrix h_variable_9129 = h_variable_l[2];
IsZeroMatrix(h_variable_9128);
matrix h_variable_9130 = DecideZeroRows(h_variable_9128,h_variable_58);
IsZeroMatrix(h_variable_9130);
def h_variable_9131 = h_variable_4814[2,84];
h_variable_9131;
matrix h_variable_9132[1][1] = 0;
matrix h_variable_9133[1][3] = concat(h_variable_9132,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9133); matrix h_variable_9134 = h_variable_l[1]; matrix h_variable_9135 = h_variable_l[2];
ncols(h_variable_9134);
matrix h_variable_9136 = DecideZeroRows(h_variable_9134,h_variable_58);
IsZeroMatrix(h_variable_9136);
nrows(h_variable_9135);
def h_variable_9137 = h_variable_4814[1,84];
h_variable_9137;
matrix h_variable_9138[1][1] = 0;
matrix h_variable_9139[1][3] = concat(h_variable_9138,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9139); matrix h_variable_9140 = h_variable_l[1]; matrix h_variable_9141 = h_variable_l[2];
ncols(h_variable_9140);
matrix h_variable_9142 = DecideZeroRows(h_variable_9140,h_variable_58);
IsZeroMatrix(h_variable_9142);
nrows(h_variable_9141);
def h_variable_9143 = h_variable_4814[15,85];
h_variable_9143;
matrix h_variable_9144[1][1] = 4*x1*x2-2*x2^2-4*x3^2;
matrix h_variable_9145[1][3] = concat(h_variable_9144,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9145); matrix h_variable_9146 = h_variable_l[1]; matrix h_variable_9147 = h_variable_l[2];
ncols(h_variable_9146);
matrix h_variable_9148 = DecideZeroRows(h_variable_9146,h_variable_58);
IsZeroMatrix(h_variable_9148);
ZeroRows(h_variable_9148);
nrows(h_variable_9147);
matrix h_variable_9150 = submat(h_variable_9146,1..1,intvec( 2 ));
matrix h_variable_9149 = DecideZeroRows(h_variable_9150,h_variable_58);
IsZeroMatrix(h_variable_9149);
IsIdentityMatrix(h_variable_9149);
matrix h_variable_9151[1][3] = concat(h_variable_9149,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9151); matrix h_variable_9152 = h_variable_l[1]; matrix h_variable_9153 = h_variable_l[2];
IsZeroMatrix(h_variable_9152);
matrix h_variable_9154 = DecideZeroRows(h_variable_9152,h_variable_58);
IsZeroMatrix(h_variable_9154);
def h_variable_9155 = h_variable_4814[2,85];
h_variable_9155;
matrix h_variable_9156[1][1] = 0;
matrix h_variable_9157[1][3] = concat(h_variable_9156,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9157); matrix h_variable_9158 = h_variable_l[1]; matrix h_variable_9159 = h_variable_l[2];
ncols(h_variable_9158);
matrix h_variable_9160 = DecideZeroRows(h_variable_9158,h_variable_58);
IsZeroMatrix(h_variable_9160);
nrows(h_variable_9159);
def h_variable_9161 = h_variable_4814[1,85];
h_variable_9161;
matrix h_variable_9162[1][1] = 0;
matrix h_variable_9163[1][3] = concat(h_variable_9162,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9163); matrix h_variable_9164 = h_variable_l[1]; matrix h_variable_9165 = h_variable_l[2];
ncols(h_variable_9164);
matrix h_variable_9166 = DecideZeroRows(h_variable_9164,h_variable_58);
IsZeroMatrix(h_variable_9166);
nrows(h_variable_9165);
def h_variable_9167 = h_variable_4814[15,86];
h_variable_9167;
matrix h_variable_9168[1][1] = -2*x2^2+4*x1*x3-2*x2*x3-2*x3^2;
matrix h_variable_9169[1][3] = concat(h_variable_9168,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9169); matrix h_variable_9170 = h_variable_l[1]; matrix h_variable_9171 = h_variable_l[2];
ncols(h_variable_9170);
matrix h_variable_9172 = DecideZeroRows(h_variable_9170,h_variable_58);
IsZeroMatrix(h_variable_9172);
ZeroRows(h_variable_9172);
nrows(h_variable_9171);
matrix h_variable_9174 = submat(h_variable_9170,1..1,intvec( 2 ));
matrix h_variable_9173 = DecideZeroRows(h_variable_9174,h_variable_58);
IsZeroMatrix(h_variable_9173);
IsIdentityMatrix(h_variable_9173);
matrix h_variable_9175[1][3] = concat(h_variable_9173,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9175); matrix h_variable_9176 = h_variable_l[1]; matrix h_variable_9177 = h_variable_l[2];
IsZeroMatrix(h_variable_9176);
matrix h_variable_9178 = DecideZeroRows(h_variable_9176,h_variable_58);
IsZeroMatrix(h_variable_9178);
def h_variable_9179 = h_variable_4814[2,86];
h_variable_9179;
matrix h_variable_9180[1][1] = 0;
matrix h_variable_9181[1][3] = concat(h_variable_9180,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9181); matrix h_variable_9182 = h_variable_l[1]; matrix h_variable_9183 = h_variable_l[2];
ncols(h_variable_9182);
matrix h_variable_9184 = DecideZeroRows(h_variable_9182,h_variable_58);
IsZeroMatrix(h_variable_9184);
nrows(h_variable_9183);
def h_variable_9185 = h_variable_4814[1,86];
h_variable_9185;
matrix h_variable_9186[1][1] = 0;
matrix h_variable_9187[1][3] = concat(h_variable_9186,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9187); matrix h_variable_9188 = h_variable_l[1]; matrix h_variable_9189 = h_variable_l[2];
ncols(h_variable_9188);
matrix h_variable_9190 = DecideZeroRows(h_variable_9188,h_variable_58);
IsZeroMatrix(h_variable_9190);
nrows(h_variable_9189);
def h_variable_9191 = h_variable_4814[15,87];
h_variable_9191;
matrix h_variable_9192[1][1] = 4*x2^2-4*x2*x3+2*x3^2;
matrix h_variable_9193[1][3] = concat(h_variable_9192,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9193); matrix h_variable_9194 = h_variable_l[1]; matrix h_variable_9195 = h_variable_l[2];
ncols(h_variable_9194);
matrix h_variable_9196 = DecideZeroRows(h_variable_9194,h_variable_58);
IsZeroMatrix(h_variable_9196);
ZeroRows(h_variable_9196);
nrows(h_variable_9195);
matrix h_variable_9198 = submat(h_variable_9194,1..1,intvec( 2 ));
matrix h_variable_9197 = DecideZeroRows(h_variable_9198,h_variable_58);
IsZeroMatrix(h_variable_9197);
IsIdentityMatrix(h_variable_9197);
matrix h_variable_9199[1][3] = concat(h_variable_9197,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9199); matrix h_variable_9200 = h_variable_l[1]; matrix h_variable_9201 = h_variable_l[2];
IsZeroMatrix(h_variable_9200);
matrix h_variable_9202 = DecideZeroRows(h_variable_9200,h_variable_58);
IsZeroMatrix(h_variable_9202);
def h_variable_9203 = h_variable_4814[2,87];
h_variable_9203;
matrix h_variable_9204[1][1] = 0;
matrix h_variable_9205[1][3] = concat(h_variable_9204,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9205); matrix h_variable_9206 = h_variable_l[1]; matrix h_variable_9207 = h_variable_l[2];
ncols(h_variable_9206);
matrix h_variable_9208 = DecideZeroRows(h_variable_9206,h_variable_58);
IsZeroMatrix(h_variable_9208);
nrows(h_variable_9207);
def h_variable_9209 = h_variable_4814[1,87];
h_variable_9209;
matrix h_variable_9210[1][1] = 0;
matrix h_variable_9211[1][3] = concat(h_variable_9210,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9211); matrix h_variable_9212 = h_variable_l[1]; matrix h_variable_9213 = h_variable_l[2];
ncols(h_variable_9212);
matrix h_variable_9214 = DecideZeroRows(h_variable_9212,h_variable_58);
IsZeroMatrix(h_variable_9214);
nrows(h_variable_9213);
def h_variable_9215 = h_variable_4814[15,88];
h_variable_9215;
matrix h_variable_9216[1][1] = 2*x1+4*x2+2*x3;
matrix h_variable_9217[1][3] = concat(h_variable_9216,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9217); matrix h_variable_9218 = h_variable_l[1]; matrix h_variable_9219 = h_variable_l[2];
ncols(h_variable_9218);
matrix h_variable_9220 = DecideZeroRows(h_variable_9218,h_variable_58);
IsZeroMatrix(h_variable_9220);
ZeroRows(h_variable_9220);
nrows(h_variable_9219);
matrix h_variable_9222 = submat(h_variable_9218,1..1,intvec( 2 ));
matrix h_variable_9221 = DecideZeroRows(h_variable_9222,h_variable_58);
IsZeroMatrix(h_variable_9221);
IsIdentityMatrix(h_variable_9221);
matrix h_variable_9223[1][3] = concat(h_variable_9221,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9223); matrix h_variable_9224 = h_variable_l[1]; matrix h_variable_9225 = h_variable_l[2];
IsZeroMatrix(h_variable_9224);
matrix h_variable_9226 = DecideZeroRows(h_variable_9224,h_variable_58);
IsZeroMatrix(h_variable_9226);
def h_variable_9227 = h_variable_4814[2,88];
h_variable_9227;
matrix h_variable_9228[1][1] = 0;
matrix h_variable_9229[1][3] = concat(h_variable_9228,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9229); matrix h_variable_9230 = h_variable_l[1]; matrix h_variable_9231 = h_variable_l[2];
ncols(h_variable_9230);
matrix h_variable_9232 = DecideZeroRows(h_variable_9230,h_variable_58);
IsZeroMatrix(h_variable_9232);
nrows(h_variable_9231);
def h_variable_9233 = h_variable_4814[1,88];
h_variable_9233;
matrix h_variable_9234[1][1] = 0;
matrix h_variable_9235[1][3] = concat(h_variable_9234,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9235); matrix h_variable_9236 = h_variable_l[1]; matrix h_variable_9237 = h_variable_l[2];
ncols(h_variable_9236);
matrix h_variable_9238 = DecideZeroRows(h_variable_9236,h_variable_58);
IsZeroMatrix(h_variable_9238);
nrows(h_variable_9237);
def h_variable_9239 = h_variable_4814[15,89];
h_variable_9239;
matrix h_variable_9240[1][1] = 4*a7*x2+4*a7*x3-2*x1+2*x3;
matrix h_variable_9241[1][3] = concat(h_variable_9240,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9241); matrix h_variable_9242 = h_variable_l[1]; matrix h_variable_9243 = h_variable_l[2];
ncols(h_variable_9242);
matrix h_variable_9244 = DecideZeroRows(h_variable_9242,h_variable_58);
IsZeroMatrix(h_variable_9244);
ZeroRows(h_variable_9244);
nrows(h_variable_9243);
matrix h_variable_9246 = submat(h_variable_9242,1..1,intvec( 2, 3, 4 ));
matrix h_variable_9245 = DecideZeroRows(h_variable_9246,h_variable_58);
IsZeroMatrix(h_variable_9245);
matrix h_variable_9247[1][5] = concat(h_variable_9245,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9247); matrix h_variable_9248 = h_variable_l[1]; matrix h_variable_9249 = h_variable_l[2];
IsZeroMatrix(h_variable_9248);
matrix h_variable_9250 = DecideZeroRows(h_variable_9248,h_variable_58);
IsZeroMatrix(h_variable_9250);
def h_variable_9251 = h_variable_4814[2,89];
h_variable_9251;
matrix h_variable_9252[1][1] = 0;
matrix h_variable_9253[1][3] = concat(h_variable_9252,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9253); matrix h_variable_9254 = h_variable_l[1]; matrix h_variable_9255 = h_variable_l[2];
ncols(h_variable_9254);
matrix h_variable_9256 = DecideZeroRows(h_variable_9254,h_variable_58);
IsZeroMatrix(h_variable_9256);
nrows(h_variable_9255);
def h_variable_9257 = h_variable_4814[1,89];
h_variable_9257;
matrix h_variable_9258[1][1] = 0;
matrix h_variable_9259[1][3] = concat(h_variable_9258,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9259); matrix h_variable_9260 = h_variable_l[1]; matrix h_variable_9261 = h_variable_l[2];
ncols(h_variable_9260);
matrix h_variable_9262 = DecideZeroRows(h_variable_9260,h_variable_58);
IsZeroMatrix(h_variable_9262);
nrows(h_variable_9261);
def h_variable_9263 = h_variable_4814[15,90];
h_variable_9263;
matrix h_variable_9264[1][1] = -2*a7*x3+2*x2+2*x3;
matrix h_variable_9265[1][3] = concat(h_variable_9264,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9265); matrix h_variable_9266 = h_variable_l[1]; matrix h_variable_9267 = h_variable_l[2];
ncols(h_variable_9266);
matrix h_variable_9268 = DecideZeroRows(h_variable_9266,h_variable_58);
IsZeroMatrix(h_variable_9268);
ZeroRows(h_variable_9268);
nrows(h_variable_9267);
matrix h_variable_9270 = submat(h_variable_9266,1..1,intvec( 2, 3, 4 ));
matrix h_variable_9269 = DecideZeroRows(h_variable_9270,h_variable_58);
IsZeroMatrix(h_variable_9269);
matrix h_variable_9271[1][5] = concat(h_variable_9269,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9271); matrix h_variable_9272 = h_variable_l[1]; matrix h_variable_9273 = h_variable_l[2];
IsZeroMatrix(h_variable_9272);
matrix h_variable_9274 = DecideZeroRows(h_variable_9272,h_variable_58);
IsZeroMatrix(h_variable_9274);
def h_variable_9275 = h_variable_4814[2,90];
h_variable_9275;
matrix h_variable_9276[1][1] = 0;
matrix h_variable_9277[1][3] = concat(h_variable_9276,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9277); matrix h_variable_9278 = h_variable_l[1]; matrix h_variable_9279 = h_variable_l[2];
ncols(h_variable_9278);
matrix h_variable_9280 = DecideZeroRows(h_variable_9278,h_variable_58);
IsZeroMatrix(h_variable_9280);
nrows(h_variable_9279);
def h_variable_9281 = h_variable_4814[1,90];
h_variable_9281;
matrix h_variable_9282[1][1] = 0;
matrix h_variable_9283[1][3] = concat(h_variable_9282,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9283); matrix h_variable_9284 = h_variable_l[1]; matrix h_variable_9285 = h_variable_l[2];
ncols(h_variable_9284);
matrix h_variable_9286 = DecideZeroRows(h_variable_9284,h_variable_58);
IsZeroMatrix(h_variable_9286);
nrows(h_variable_9285);
def h_variable_9287 = h_variable_4814[15,91];
h_variable_9287;
matrix h_variable_9288[1][1] = 2*a7*x3^2+2*x1^2+2*x1*x2+4*x2^2-2*x3^2;
matrix h_variable_9289[1][3] = concat(h_variable_9288,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9289); matrix h_variable_9290 = h_variable_l[1]; matrix h_variable_9291 = h_variable_l[2];
ncols(h_variable_9290);
matrix h_variable_9292 = DecideZeroRows(h_variable_9290,h_variable_58);
IsZeroMatrix(h_variable_9292);
ZeroRows(h_variable_9292);
nrows(h_variable_9291);
matrix h_variable_9294 = submat(h_variable_9290,1..1,intvec( 3, 4, 5 ));
matrix h_variable_9293 = DecideZeroRows(h_variable_9294,h_variable_58);
IsZeroMatrix(h_variable_9293);
matrix h_variable_9295[1][5] = concat(h_variable_9293,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9295); matrix h_variable_9296 = h_variable_l[1]; matrix h_variable_9297 = h_variable_l[2];
IsZeroMatrix(h_variable_9296);
matrix h_variable_9298 = DecideZeroRows(h_variable_9296,h_variable_58);
IsZeroMatrix(h_variable_9298);
def h_variable_9299 = h_variable_4814[2,91];
h_variable_9299;
matrix h_variable_9300[1][1] = 0;
matrix h_variable_9301[1][3] = concat(h_variable_9300,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9301); matrix h_variable_9302 = h_variable_l[1]; matrix h_variable_9303 = h_variable_l[2];
ncols(h_variable_9302);
matrix h_variable_9304 = DecideZeroRows(h_variable_9302,h_variable_58);
IsZeroMatrix(h_variable_9304);
nrows(h_variable_9303);
def h_variable_9305 = h_variable_4814[1,91];
h_variable_9305;
matrix h_variable_9306[1][1] = 0;
matrix h_variable_9307[1][3] = concat(h_variable_9306,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9307); matrix h_variable_9308 = h_variable_l[1]; matrix h_variable_9309 = h_variable_l[2];
ncols(h_variable_9308);
matrix h_variable_9310 = DecideZeroRows(h_variable_9308,h_variable_58);
IsZeroMatrix(h_variable_9310);
nrows(h_variable_9309);
def h_variable_9311 = h_variable_4814[15,92];
h_variable_9311;
matrix h_variable_9312[1][1] = 4*a7-1;
matrix h_variable_9313[1][3] = concat(h_variable_9312,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9313); matrix h_variable_9314 = h_variable_l[1]; matrix h_variable_9315 = h_variable_l[2];
ncols(h_variable_9314);
matrix h_variable_9316 = DecideZeroRows(h_variable_9314,h_variable_58);
IsZeroMatrix(h_variable_9316);
nrows(h_variable_9315);
IsIdentityMatrix(h_variable_9316);
def h_variable_9317 = h_variable_4814[1,92];
h_variable_9317;
matrix h_variable_9318[1][1] = 0;
matrix h_variable_9319 = DecideZeroRows(h_variable_9318,h_variable_58);
IsZeroMatrix(h_variable_9319);
def h_variable_9320 = h_variable_9319[1,1];
h_variable_9320==0;
def h_variable_9321 = h_variable_4814[2,92];
h_variable_9321;
matrix h_variable_9322[1][1] = 0;
matrix h_variable_9323 = DecideZeroRows(h_variable_9322,h_variable_58);
IsZeroMatrix(h_variable_9323);
def h_variable_9324 = h_variable_9323[1,1];
h_variable_9324==0;
def h_variable_9325 = h_variable_4814[15,92];
h_variable_9325;
matrix h_variable_9326[1][1] = 4*a7-1;
matrix h_variable_9327 = DecideZeroRows(h_variable_9326,h_variable_58);
IsZeroMatrix(h_variable_9327);
def h_variable_9328 = h_variable_9327[1,1];
h_variable_9328==0;
def h_variable_9329 = h_variable_4814[2,93];
h_variable_9329;
matrix h_variable_9330[1][1] = 0;
matrix h_variable_9331[1][3] = concat(h_variable_9330,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9331); matrix h_variable_9332 = h_variable_l[1]; matrix h_variable_9333 = h_variable_l[2];
ncols(h_variable_9332);
matrix h_variable_9334 = DecideZeroRows(h_variable_9332,h_variable_58);
IsZeroMatrix(h_variable_9334);
nrows(h_variable_9333);
def h_variable_9335 = h_variable_4814[1,93];
h_variable_9335;
matrix h_variable_9336[1][1] = 0;
matrix h_variable_9337[1][3] = concat(h_variable_9336,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9337); matrix h_variable_9338 = h_variable_l[1]; matrix h_variable_9339 = h_variable_l[2];
ncols(h_variable_9338);
matrix h_variable_9340 = DecideZeroRows(h_variable_9338,h_variable_58);
IsZeroMatrix(h_variable_9340);
nrows(h_variable_9339);
def h_variable_9341 = h_variable_4814[2,94];
h_variable_9341;
matrix h_variable_9342[1][1] = 0;
matrix h_variable_9343[1][3] = concat(h_variable_9342,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9343); matrix h_variable_9344 = h_variable_l[1]; matrix h_variable_9345 = h_variable_l[2];
ncols(h_variable_9344);
matrix h_variable_9346 = DecideZeroRows(h_variable_9344,h_variable_58);
IsZeroMatrix(h_variable_9346);
nrows(h_variable_9345);
def h_variable_9347 = h_variable_4814[1,94];
h_variable_9347;
matrix h_variable_9348[1][1] = 0;
matrix h_variable_9349[1][3] = concat(h_variable_9348,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9349); matrix h_variable_9350 = h_variable_l[1]; matrix h_variable_9351 = h_variable_l[2];
ncols(h_variable_9350);
matrix h_variable_9352 = DecideZeroRows(h_variable_9350,h_variable_58);
IsZeroMatrix(h_variable_9352);
nrows(h_variable_9351);
def h_variable_9353 = h_variable_4814[2,95];
h_variable_9353;
matrix h_variable_9354[1][1] = 0;
matrix h_variable_9355[1][3] = concat(h_variable_9354,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9355); matrix h_variable_9356 = h_variable_l[1]; matrix h_variable_9357 = h_variable_l[2];
ncols(h_variable_9356);
matrix h_variable_9358 = DecideZeroRows(h_variable_9356,h_variable_58);
IsZeroMatrix(h_variable_9358);
nrows(h_variable_9357);
def h_variable_9359 = h_variable_4814[1,95];
h_variable_9359;
matrix h_variable_9360[1][1] = 0;
matrix h_variable_9361[1][3] = concat(h_variable_9360,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9361); matrix h_variable_9362 = h_variable_l[1]; matrix h_variable_9363 = h_variable_l[2];
ncols(h_variable_9362);
matrix h_variable_9364 = DecideZeroRows(h_variable_9362,h_variable_58);
IsZeroMatrix(h_variable_9364);
nrows(h_variable_9363);
def h_variable_9365 = h_variable_4814[2,96];
h_variable_9365;
matrix h_variable_9366[1][1] = 0;
matrix h_variable_9367[1][3] = concat(h_variable_9366,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9367); matrix h_variable_9368 = h_variable_l[1]; matrix h_variable_9369 = h_variable_l[2];
ncols(h_variable_9368);
matrix h_variable_9370 = DecideZeroRows(h_variable_9368,h_variable_58);
IsZeroMatrix(h_variable_9370);
nrows(h_variable_9369);
def h_variable_9371 = h_variable_4814[1,96];
h_variable_9371;
matrix h_variable_9372[1][1] = 0;
matrix h_variable_9373[1][3] = concat(h_variable_9372,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9373); matrix h_variable_9374 = h_variable_l[1]; matrix h_variable_9375 = h_variable_l[2];
ncols(h_variable_9374);
matrix h_variable_9376 = DecideZeroRows(h_variable_9374,h_variable_58);
IsZeroMatrix(h_variable_9376);
nrows(h_variable_9375);
def h_variable_9377 = h_variable_4814[2,97];
h_variable_9377;
matrix h_variable_9378[1][1] = 0;
matrix h_variable_9379[1][3] = concat(h_variable_9378,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9379); matrix h_variable_9380 = h_variable_l[1]; matrix h_variable_9381 = h_variable_l[2];
ncols(h_variable_9380);
matrix h_variable_9382 = DecideZeroRows(h_variable_9380,h_variable_58);
IsZeroMatrix(h_variable_9382);
nrows(h_variable_9381);
def h_variable_9383 = h_variable_4814[1,97];
h_variable_9383;
matrix h_variable_9384[1][1] = 0;
matrix h_variable_9385[1][3] = concat(h_variable_9384,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9385); matrix h_variable_9386 = h_variable_l[1]; matrix h_variable_9387 = h_variable_l[2];
ncols(h_variable_9386);
matrix h_variable_9388 = DecideZeroRows(h_variable_9386,h_variable_58);
IsZeroMatrix(h_variable_9388);
nrows(h_variable_9387);
def h_variable_9389 = h_variable_4814[2,98];
h_variable_9389;
matrix h_variable_9390[1][1] = 0;
matrix h_variable_9391[1][3] = concat(h_variable_9390,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9391); matrix h_variable_9392 = h_variable_l[1]; matrix h_variable_9393 = h_variable_l[2];
ncols(h_variable_9392);
matrix h_variable_9394 = DecideZeroRows(h_variable_9392,h_variable_58);
IsZeroMatrix(h_variable_9394);
nrows(h_variable_9393);
def h_variable_9395 = h_variable_4814[1,98];
h_variable_9395;
matrix h_variable_9396[1][1] = 0;
matrix h_variable_9397[1][3] = concat(h_variable_9396,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9397); matrix h_variable_9398 = h_variable_l[1]; matrix h_variable_9399 = h_variable_l[2];
ncols(h_variable_9398);
matrix h_variable_9400 = DecideZeroRows(h_variable_9398,h_variable_58);
IsZeroMatrix(h_variable_9400);
nrows(h_variable_9399);
def h_variable_9401 = h_variable_4814[2,99];
h_variable_9401;
matrix h_variable_9402[1][1] = 0;
matrix h_variable_9403[1][3] = concat(h_variable_9402,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9403); matrix h_variable_9404 = h_variable_l[1]; matrix h_variable_9405 = h_variable_l[2];
ncols(h_variable_9404);
matrix h_variable_9406 = DecideZeroRows(h_variable_9404,h_variable_58);
IsZeroMatrix(h_variable_9406);
nrows(h_variable_9405);
def h_variable_9407 = h_variable_4814[1,99];
h_variable_9407;
matrix h_variable_9408[1][1] = 0;
matrix h_variable_9409[1][3] = concat(h_variable_9408,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9409); matrix h_variable_9410 = h_variable_l[1]; matrix h_variable_9411 = h_variable_l[2];
ncols(h_variable_9410);
matrix h_variable_9412 = DecideZeroRows(h_variable_9410,h_variable_58);
IsZeroMatrix(h_variable_9412);
nrows(h_variable_9411);
def h_variable_9413 = h_variable_4814[2,100];
h_variable_9413;
matrix h_variable_9414[1][1] = 0;
matrix h_variable_9415[1][3] = concat(h_variable_9414,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9415); matrix h_variable_9416 = h_variable_l[1]; matrix h_variable_9417 = h_variable_l[2];
ncols(h_variable_9416);
matrix h_variable_9418 = DecideZeroRows(h_variable_9416,h_variable_58);
IsZeroMatrix(h_variable_9418);
nrows(h_variable_9417);
def h_variable_9419 = h_variable_4814[1,100];
h_variable_9419;
matrix h_variable_9420[1][1] = 0;
matrix h_variable_9421[1][3] = concat(h_variable_9420,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9421); matrix h_variable_9422 = h_variable_l[1]; matrix h_variable_9423 = h_variable_l[2];
ncols(h_variable_9422);
matrix h_variable_9424 = DecideZeroRows(h_variable_9422,h_variable_58);
IsZeroMatrix(h_variable_9424);
nrows(h_variable_9423);
def h_variable_9425 = h_variable_4814[2,101];
h_variable_9425;
matrix h_variable_9426[1][1] = 0;
matrix h_variable_9427[1][3] = concat(h_variable_9426,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9427); matrix h_variable_9428 = h_variable_l[1]; matrix h_variable_9429 = h_variable_l[2];
ncols(h_variable_9428);
matrix h_variable_9430 = DecideZeroRows(h_variable_9428,h_variable_58);
IsZeroMatrix(h_variable_9430);
nrows(h_variable_9429);
def h_variable_9431 = h_variable_4814[1,101];
h_variable_9431;
matrix h_variable_9432[1][1] = 0;
matrix h_variable_9433[1][3] = concat(h_variable_9432,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9433); matrix h_variable_9434 = h_variable_l[1]; matrix h_variable_9435 = h_variable_l[2];
ncols(h_variable_9434);
matrix h_variable_9436 = DecideZeroRows(h_variable_9434,h_variable_58);
IsZeroMatrix(h_variable_9436);
nrows(h_variable_9435);
def h_variable_9437 = h_variable_4814[2,102];
h_variable_9437;
matrix h_variable_9438[1][1] = 0;
matrix h_variable_9439[1][3] = concat(h_variable_9438,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9439); matrix h_variable_9440 = h_variable_l[1]; matrix h_variable_9441 = h_variable_l[2];
ncols(h_variable_9440);
matrix h_variable_9442 = DecideZeroRows(h_variable_9440,h_variable_58);
IsZeroMatrix(h_variable_9442);
nrows(h_variable_9441);
def h_variable_9443 = h_variable_4814[1,102];
h_variable_9443;
matrix h_variable_9444[1][1] = 0;
matrix h_variable_9445[1][3] = concat(h_variable_9444,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9445); matrix h_variable_9446 = h_variable_l[1]; matrix h_variable_9447 = h_variable_l[2];
ncols(h_variable_9446);
matrix h_variable_9448 = DecideZeroRows(h_variable_9446,h_variable_58);
IsZeroMatrix(h_variable_9448);
nrows(h_variable_9447);
def h_variable_9449 = h_variable_4814[2,103];
h_variable_9449;
matrix h_variable_9450[1][1] = 0;
matrix h_variable_9451[1][3] = concat(h_variable_9450,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9451); matrix h_variable_9452 = h_variable_l[1]; matrix h_variable_9453 = h_variable_l[2];
ncols(h_variable_9452);
matrix h_variable_9454 = DecideZeroRows(h_variable_9452,h_variable_58);
IsZeroMatrix(h_variable_9454);
nrows(h_variable_9453);
def h_variable_9455 = h_variable_4814[1,103];
h_variable_9455;
matrix h_variable_9456[1][1] = 0;
matrix h_variable_9457[1][3] = concat(h_variable_9456,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9457); matrix h_variable_9458 = h_variable_l[1]; matrix h_variable_9459 = h_variable_l[2];
ncols(h_variable_9458);
matrix h_variable_9460 = DecideZeroRows(h_variable_9458,h_variable_58);
IsZeroMatrix(h_variable_9460);
nrows(h_variable_9459);
def h_variable_9461 = h_variable_4814[2,104];
h_variable_9461;
matrix h_variable_9462[1][1] = 0;
matrix h_variable_9463[1][3] = concat(h_variable_9462,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9463); matrix h_variable_9464 = h_variable_l[1]; matrix h_variable_9465 = h_variable_l[2];
ncols(h_variable_9464);
matrix h_variable_9466 = DecideZeroRows(h_variable_9464,h_variable_58);
IsZeroMatrix(h_variable_9466);
nrows(h_variable_9465);
def h_variable_9467 = h_variable_4814[1,104];
h_variable_9467;
matrix h_variable_9468[1][1] = 0;
matrix h_variable_9469[1][3] = concat(h_variable_9468,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9469); matrix h_variable_9470 = h_variable_l[1]; matrix h_variable_9471 = h_variable_l[2];
ncols(h_variable_9470);
matrix h_variable_9472 = DecideZeroRows(h_variable_9470,h_variable_58);
IsZeroMatrix(h_variable_9472);
nrows(h_variable_9471);
def h_variable_9473 = h_variable_4814[2,105];
h_variable_9473;
matrix h_variable_9474[1][1] = 0;
matrix h_variable_9475[1][3] = concat(h_variable_9474,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9475); matrix h_variable_9476 = h_variable_l[1]; matrix h_variable_9477 = h_variable_l[2];
ncols(h_variable_9476);
matrix h_variable_9478 = DecideZeroRows(h_variable_9476,h_variable_58);
IsZeroMatrix(h_variable_9478);
nrows(h_variable_9477);
def h_variable_9479 = h_variable_4814[1,105];
h_variable_9479;
matrix h_variable_9480[1][1] = 0;
matrix h_variable_9481[1][3] = concat(h_variable_9480,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9481); matrix h_variable_9482 = h_variable_l[1]; matrix h_variable_9483 = h_variable_l[2];
ncols(h_variable_9482);
matrix h_variable_9484 = DecideZeroRows(h_variable_9482,h_variable_58);
IsZeroMatrix(h_variable_9484);
nrows(h_variable_9483);
def h_variable_9485 = h_variable_4814[2,106];
h_variable_9485;
matrix h_variable_9486[1][1] = 0;
matrix h_variable_9487[1][3] = concat(h_variable_9486,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9487); matrix h_variable_9488 = h_variable_l[1]; matrix h_variable_9489 = h_variable_l[2];
ncols(h_variable_9488);
matrix h_variable_9490 = DecideZeroRows(h_variable_9488,h_variable_58);
IsZeroMatrix(h_variable_9490);
nrows(h_variable_9489);
def h_variable_9491 = h_variable_4814[1,106];
h_variable_9491;
matrix h_variable_9492[1][1] = 0;
matrix h_variable_9493[1][3] = concat(h_variable_9492,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9493); matrix h_variable_9494 = h_variable_l[1]; matrix h_variable_9495 = h_variable_l[2];
ncols(h_variable_9494);
matrix h_variable_9496 = DecideZeroRows(h_variable_9494,h_variable_58);
IsZeroMatrix(h_variable_9496);
nrows(h_variable_9495);
def h_variable_9497 = h_variable_4814[2,107];
h_variable_9497;
matrix h_variable_9498[1][1] = 0;
matrix h_variable_9499[1][3] = concat(h_variable_9498,h_variable_48);
kill h_variable_8917;kill h_variable_8920;kill h_variable_8922;kill h_variable_8926;kill h_variable_8928;kill h_variable_8929;kill h_variable_8930;kill h_variable_8931;kill h_variable_8932;kill h_variable_8934;kill h_variable_8935;kill h_variable_8936;kill h_variable_8937;kill h_variable_8938;kill h_variable_8939;kill h_variable_8940;kill h_variable_8941;kill h_variable_8942;kill h_variable_8943;kill h_variable_8944;kill h_variable_8945;kill h_variable_8946;kill h_variable_8947;kill h_variable_8948;kill h_variable_8949;kill h_variable_8950;kill h_variable_8951;kill h_variable_8952;kill h_variable_8953;kill h_variable_8954;kill h_variable_8955;kill h_variable_8956;kill h_variable_8957;kill h_variable_8958;kill h_variable_8959;kill h_variable_8960;kill h_variable_8961;kill h_variable_8962;kill h_variable_8963;kill h_variable_8964;kill h_variable_8965;kill h_variable_8966;kill h_variable_8967;kill h_variable_8968;kill h_variable_8969;kill h_variable_8970;kill h_variable_8971;kill h_variable_8972;kill h_variable_8973;kill h_variable_8974;kill h_variable_8975;kill h_variable_8976;kill h_variable_8977;kill h_variable_8978;kill h_variable_8979;kill h_variable_8980;kill h_variable_8981;kill h_variable_8982;kill h_variable_8983;kill h_variable_8984;kill h_variable_8985;kill h_variable_8986;kill h_variable_8987;kill h_variable_8988;kill h_variable_8989;kill h_variable_8990;kill h_variable_8991;kill h_variable_8992;kill h_variable_8993;kill h_variable_8994;kill h_variable_8995;kill h_variable_8996;kill h_variable_8997;kill h_variable_8998;kill h_variable_8999;kill h_variable_9000;kill h_variable_9001;kill h_variable_9002;kill h_variable_9003;kill h_variable_9004;kill h_variable_9005;kill h_variable_9006;kill h_variable_9007;kill h_variable_9008;kill h_variable_9009;kill h_variable_9010;kill h_variable_9011;kill h_variable_9012;kill h_variable_9013;kill h_variable_9014;kill h_variable_9015;kill h_variable_9016;kill h_variable_9017;kill h_variable_9018;kill h_variable_9019;kill h_variable_9020;kill h_variable_9021;kill h_variable_9022;kill h_variable_9025;kill h_variable_9026;kill h_variable_9027;kill h_variable_9028;kill h_variable_9031;kill h_variable_9034;kill h_variable_9036;kill h_variable_9040;kill h_variable_9042;kill h_variable_9043;kill h_variable_9044;kill h_variable_9045;kill h_variable_9046;kill h_variable_9048;kill h_variable_9049;kill h_variable_9050;kill h_variable_9051;kill h_variable_9052;kill h_variable_9053;kill h_variable_9054;kill h_variable_9055;kill h_variable_9056;kill h_variable_9057;kill h_variable_9058;kill h_variable_9059;kill h_variable_9060;kill h_variable_9061;kill h_variable_9062;kill h_variable_9063;kill h_variable_9064;kill h_variable_9065;kill h_variable_9066;kill h_variable_9067;kill h_variable_9068;kill h_variable_9069;kill h_variable_9070;kill h_variable_9071;kill h_variable_9072;kill h_variable_9073;kill h_variable_9074;kill h_variable_9075;kill h_variable_9076;kill h_variable_9077;kill h_variable_9078;kill h_variable_9079;kill h_variable_9080;kill h_variable_9081;kill h_variable_9082;kill h_variable_9083;kill h_variable_9084;kill h_variable_9085;kill h_variable_9086;kill h_variable_9087;kill h_variable_9088;kill h_variable_9089;kill h_variable_9090;kill h_variable_9091;kill h_variable_9092;kill h_variable_9093;kill h_variable_9094;kill h_variable_9095;kill h_variable_9096;kill h_variable_9097;kill h_variable_9098;kill h_variable_9099;kill h_variable_9100;kill h_variable_9101;kill h_variable_9102;kill h_variable_9103;kill h_variable_9104;kill h_variable_9105;kill h_variable_9106;kill h_variable_9107;kill h_variable_9108;kill h_variable_9109;kill h_variable_9110;kill h_variable_9111;kill h_variable_9112;kill h_variable_9113;kill h_variable_9114;kill h_variable_9115;kill h_variable_9116;kill h_variable_9117;kill h_variable_9118;kill h_variable_9119;kill h_variable_9120;kill h_variable_9121;kill h_variable_9122;kill h_variable_9123;kill h_variable_9124;kill h_variable_9125;kill h_variable_9126;kill h_variable_9127;kill h_variable_9128;kill h_variable_9129;kill h_variable_9130;kill h_variable_9131;kill h_variable_9132;kill h_variable_9133;kill h_variable_9134;kill h_variable_9135;kill h_variable_9136;kill h_variable_9137;kill h_variable_9138;kill h_variable_9139;kill h_variable_9140;kill h_variable_9141;kill h_variable_9142;kill h_variable_9143;kill h_variable_9144;kill h_variable_9145;kill h_variable_9146;kill h_variable_9147;kill h_variable_9148;kill h_variable_9149;kill h_variable_9150;kill h_variable_9151;kill h_variable_9152;kill h_variable_9153;kill h_variable_9154;kill h_variable_9155;kill h_variable_9156;kill h_variable_9157;kill h_variable_9158;kill h_variable_9159;kill h_variable_9160;kill h_variable_9161;kill h_variable_9162;kill h_variable_9163;kill h_variable_9164;kill h_variable_9165;kill h_variable_9166;kill h_variable_9167;kill h_variable_9168;kill h_variable_9169;kill h_variable_9170;kill h_variable_9171;kill h_variable_9172;kill h_variable_9173;kill h_variable_9174;kill h_variable_9175;kill h_variable_9176;kill h_variable_9177;kill h_variable_9178;kill h_variable_9179;kill h_variable_9180;kill h_variable_9181;kill h_variable_9182;kill h_variable_9183;kill h_variable_9184;kill h_variable_9185;kill h_variable_9186;kill h_variable_9187;kill h_variable_9188;kill h_variable_9189;kill h_variable_9190;kill h_variable_9191;kill h_variable_9192;kill h_variable_9193;kill h_variable_9194;kill h_variable_9195;kill h_variable_9196;kill h_variable_9197;kill h_variable_9198;kill h_variable_9199;kill h_variable_9200;kill h_variable_9201;kill h_variable_9202;kill h_variable_9208;kill h_variable_9211;kill h_variable_9212;kill h_variable_9213;kill h_variable_9214;kill h_variable_9216;kill h_variable_9217;kill h_variable_9218;kill h_variable_9219;kill h_variable_9220;kill h_variable_9222;kill h_variable_9226;kill h_variable_9228;kill h_variable_9229;kill h_variable_9230;kill h_variable_9231;kill h_variable_9232;kill h_variable_9233;kill h_variable_9234;kill h_variable_9235;kill h_variable_9236;kill h_variable_9237;kill h_variable_9238;kill h_variable_9239;kill h_variable_9240;kill h_variable_9241;kill h_variable_9242;kill h_variable_9243;kill h_variable_9244;kill h_variable_9245;kill h_variable_9246;kill h_variable_9247;kill h_variable_9248;kill h_variable_9249;kill h_variable_9250;kill h_variable_9251;kill h_variable_9252;kill h_variable_9253;kill h_variable_9254;kill h_variable_9255;kill h_variable_9256;kill h_variable_9257;kill h_variable_9258;kill h_variable_9259;kill h_variable_9260;kill h_variable_9261;kill h_variable_9262;kill h_variable_9263;kill h_variable_9264;kill h_variable_9265;kill h_variable_9266;kill h_variable_9267;kill h_variable_9268;kill h_variable_9269;kill h_variable_9270;kill h_variable_9271;kill h_variable_9272;kill h_variable_9273;kill h_variable_9274;kill h_variable_9275;kill h_variable_9276;kill h_variable_9277;kill h_variable_9278;kill h_variable_9279;kill h_variable_9280;kill h_variable_9281;kill h_variable_9282;kill h_variable_9283;kill h_variable_9284;kill h_variable_9285;kill h_variable_9286;kill h_variable_9287;kill h_variable_9288;kill h_variable_9289;kill h_variable_9290;kill h_variable_9291;kill h_variable_9292;kill h_variable_9293;kill h_variable_9294;kill h_variable_9295;kill h_variable_9296;kill h_variable_9297;kill h_variable_9298;kill h_variable_9299;kill h_variable_9300;kill h_variable_9301;kill h_variable_9302;kill h_variable_9303;kill h_variable_9304;kill h_variable_9305;kill h_variable_9306;kill h_variable_9307;kill h_variable_9308;kill h_variable_9309;kill h_variable_9310;kill h_variable_9311;kill h_variable_9312;kill h_variable_9313;kill h_variable_9314;kill h_variable_9315;kill h_variable_9316;kill h_variable_9317;kill h_variable_9318;kill h_variable_9319;kill h_variable_9320;kill h_variable_9321;kill h_variable_9322;kill h_variable_9323;kill h_variable_9324;kill h_variable_9325;kill h_variable_9326;kill h_variable_9327;kill h_variable_9328;kill h_variable_9329;kill h_variable_9330;kill h_variable_9331;kill h_variable_9332;kill h_variable_9333;kill h_variable_9334;kill h_variable_9335;kill h_variable_9336;kill h_variable_9337;kill h_variable_9338;kill h_variable_9339;kill h_variable_9340;kill h_variable_9341;kill h_variable_9342;kill h_variable_9343;kill h_variable_9344;kill h_variable_9345;kill h_variable_9346;kill h_variable_9347;kill h_variable_9348;kill h_variable_9349;kill h_variable_9350;kill h_variable_9351;kill h_variable_9352;kill h_variable_9353;kill h_variable_9354;kill h_variable_9355;kill h_variable_9356;kill h_variable_9357;kill h_variable_9358;kill h_variable_9359;kill h_variable_9360;kill h_variable_9361;kill h_variable_9362;kill h_variable_9363;kill h_variable_9364;kill h_variable_9365;kill h_variable_9366;kill h_variable_9367;kill h_variable_9368;kill h_variable_9369;kill h_variable_9370;kill h_variable_9371;kill h_variable_9372;kill h_variable_9373;kill h_variable_9374;kill h_variable_9375;kill h_variable_9376;kill h_variable_9377;kill h_variable_9378;kill h_variable_9379;kill h_variable_9380;kill h_variable_9381;kill h_variable_9382;
list h_variable_l=BasisOfRowsCoeff(h_variable_9499); matrix h_variable_9500 = h_variable_l[1]; matrix h_variable_9501 = h_variable_l[2];
ncols(h_variable_9500);
matrix h_variable_9502 = DecideZeroRows(h_variable_9500,h_variable_58);
IsZeroMatrix(h_variable_9502);
nrows(h_variable_9501);
def h_variable_9503 = h_variable_4814[1,107];
h_variable_9503;
matrix h_variable_9504[1][1] = 0;
matrix h_variable_9505[1][3] = concat(h_variable_9504,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9505); matrix h_variable_9506 = h_variable_l[1]; matrix h_variable_9507 = h_variable_l[2];
ncols(h_variable_9506);
matrix h_variable_9508 = DecideZeroRows(h_variable_9506,h_variable_58);
IsZeroMatrix(h_variable_9508);
nrows(h_variable_9507);
def h_variable_9509 = h_variable_4814[2,108];
h_variable_9509;
matrix h_variable_9510[1][1] = 0;
matrix h_variable_9511[1][3] = concat(h_variable_9510,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9511); matrix h_variable_9512 = h_variable_l[1]; matrix h_variable_9513 = h_variable_l[2];
ncols(h_variable_9512);
matrix h_variable_9514 = DecideZeroRows(h_variable_9512,h_variable_58);
IsZeroMatrix(h_variable_9514);
nrows(h_variable_9513);
def h_variable_9515 = h_variable_4814[1,108];
h_variable_9515;
matrix h_variable_9516[1][1] = 0;
matrix h_variable_9517[1][3] = concat(h_variable_9516,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9517); matrix h_variable_9518 = h_variable_l[1]; matrix h_variable_9519 = h_variable_l[2];
ncols(h_variable_9518);
matrix h_variable_9520 = DecideZeroRows(h_variable_9518,h_variable_58);
IsZeroMatrix(h_variable_9520);
nrows(h_variable_9519);
def h_variable_9521 = h_variable_4814[2,109];
h_variable_9521;
matrix h_variable_9522[1][1] = 0;
matrix h_variable_9523[1][3] = concat(h_variable_9522,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9523); matrix h_variable_9524 = h_variable_l[1]; matrix h_variable_9525 = h_variable_l[2];
ncols(h_variable_9524);
matrix h_variable_9526 = DecideZeroRows(h_variable_9524,h_variable_58);
IsZeroMatrix(h_variable_9526);
nrows(h_variable_9525);
def h_variable_9527 = h_variable_4814[1,109];
h_variable_9527;
matrix h_variable_9528[1][1] = 0;
matrix h_variable_9529[1][3] = concat(h_variable_9528,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9529); matrix h_variable_9530 = h_variable_l[1]; matrix h_variable_9531 = h_variable_l[2];
ncols(h_variable_9530);
matrix h_variable_9532 = DecideZeroRows(h_variable_9530,h_variable_58);
IsZeroMatrix(h_variable_9532);
nrows(h_variable_9531);
def h_variable_9533 = h_variable_4814[2,110];
h_variable_9533;
matrix h_variable_9534[1][1] = 0;
matrix h_variable_9535[1][3] = concat(h_variable_9534,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9535); matrix h_variable_9536 = h_variable_l[1]; matrix h_variable_9537 = h_variable_l[2];
ncols(h_variable_9536);
matrix h_variable_9538 = DecideZeroRows(h_variable_9536,h_variable_58);
IsZeroMatrix(h_variable_9538);
nrows(h_variable_9537);
def h_variable_9539 = h_variable_4814[1,110];
h_variable_9539;
matrix h_variable_9540[1][1] = 0;
matrix h_variable_9541[1][3] = concat(h_variable_9540,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9541); matrix h_variable_9542 = h_variable_l[1]; matrix h_variable_9543 = h_variable_l[2];
ncols(h_variable_9542);
matrix h_variable_9544 = DecideZeroRows(h_variable_9542,h_variable_58);
IsZeroMatrix(h_variable_9544);
nrows(h_variable_9543);
def h_variable_9545 = h_variable_4814[2,111];
h_variable_9545;
matrix h_variable_9546[1][1] = 0;
matrix h_variable_9547[1][3] = concat(h_variable_9546,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9547); matrix h_variable_9548 = h_variable_l[1]; matrix h_variable_9549 = h_variable_l[2];
ncols(h_variable_9548);
matrix h_variable_9550 = DecideZeroRows(h_variable_9548,h_variable_58);
IsZeroMatrix(h_variable_9550);
nrows(h_variable_9549);
def h_variable_9551 = h_variable_4814[1,111];
h_variable_9551;
matrix h_variable_9552[1][1] = 0;
matrix h_variable_9553[1][3] = concat(h_variable_9552,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9553); matrix h_variable_9554 = h_variable_l[1]; matrix h_variable_9555 = h_variable_l[2];
ncols(h_variable_9554);
matrix h_variable_9556 = DecideZeroRows(h_variable_9554,h_variable_58);
IsZeroMatrix(h_variable_9556);
nrows(h_variable_9555);
def h_variable_9557 = h_variable_4814[2,112];
h_variable_9557;
matrix h_variable_9558[1][1] = 0;
matrix h_variable_9559[1][3] = concat(h_variable_9558,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9559); matrix h_variable_9560 = h_variable_l[1]; matrix h_variable_9561 = h_variable_l[2];
ncols(h_variable_9560);
matrix h_variable_9562 = DecideZeroRows(h_variable_9560,h_variable_58);
IsZeroMatrix(h_variable_9562);
nrows(h_variable_9561);
def h_variable_9563 = h_variable_4814[1,112];
h_variable_9563;
matrix h_variable_9564[1][1] = 0;
matrix h_variable_9565[1][3] = concat(h_variable_9564,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9565); matrix h_variable_9566 = h_variable_l[1]; matrix h_variable_9567 = h_variable_l[2];
ncols(h_variable_9566);
matrix h_variable_9568 = DecideZeroRows(h_variable_9566,h_variable_58);
IsZeroMatrix(h_variable_9568);
nrows(h_variable_9567);
def h_variable_9569 = h_variable_4814[2,113];
h_variable_9569;
matrix h_variable_9570[1][1] = 0;
matrix h_variable_9571[1][3] = concat(h_variable_9570,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9571); matrix h_variable_9572 = h_variable_l[1]; matrix h_variable_9573 = h_variable_l[2];
ncols(h_variable_9572);
matrix h_variable_9574 = DecideZeroRows(h_variable_9572,h_variable_58);
IsZeroMatrix(h_variable_9574);
nrows(h_variable_9573);
def h_variable_9575 = h_variable_4814[1,113];
h_variable_9575;
matrix h_variable_9576[1][1] = 0;
matrix h_variable_9577[1][3] = concat(h_variable_9576,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9577); matrix h_variable_9578 = h_variable_l[1]; matrix h_variable_9579 = h_variable_l[2];
ncols(h_variable_9578);
matrix h_variable_9580 = DecideZeroRows(h_variable_9578,h_variable_58);
IsZeroMatrix(h_variable_9580);
nrows(h_variable_9579);
def h_variable_9581 = h_variable_4814[2,114];
h_variable_9581;
matrix h_variable_9582[1][1] = 0;
matrix h_variable_9583[1][3] = concat(h_variable_9582,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9583); matrix h_variable_9584 = h_variable_l[1]; matrix h_variable_9585 = h_variable_l[2];
ncols(h_variable_9584);
matrix h_variable_9586 = DecideZeroRows(h_variable_9584,h_variable_58);
IsZeroMatrix(h_variable_9586);
nrows(h_variable_9585);
def h_variable_9587 = h_variable_4814[1,114];
h_variable_9587;
matrix h_variable_9588[1][1] = 0;
matrix h_variable_9589[1][3] = concat(h_variable_9588,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9589); matrix h_variable_9590 = h_variable_l[1]; matrix h_variable_9591 = h_variable_l[2];
ncols(h_variable_9590);
matrix h_variable_9592 = DecideZeroRows(h_variable_9590,h_variable_58);
IsZeroMatrix(h_variable_9592);
nrows(h_variable_9591);
def h_variable_9593 = h_variable_4814[2,115];
h_variable_9593;
matrix h_variable_9594[1][1] = 0;
matrix h_variable_9595[1][3] = concat(h_variable_9594,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9595); matrix h_variable_9596 = h_variable_l[1]; matrix h_variable_9597 = h_variable_l[2];
ncols(h_variable_9596);
matrix h_variable_9598 = DecideZeroRows(h_variable_9596,h_variable_58);
IsZeroMatrix(h_variable_9598);
nrows(h_variable_9597);
def h_variable_9599 = h_variable_4814[1,115];
h_variable_9599;
matrix h_variable_9600[1][1] = 0;
matrix h_variable_9601[1][3] = concat(h_variable_9600,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9601); matrix h_variable_9602 = h_variable_l[1]; matrix h_variable_9603 = h_variable_l[2];
ncols(h_variable_9602);
matrix h_variable_9604 = DecideZeroRows(h_variable_9602,h_variable_58);
IsZeroMatrix(h_variable_9604);
nrows(h_variable_9603);
def h_variable_9605 = h_variable_4814[2,116];
h_variable_9605;
matrix h_variable_9606[1][1] = 0;
matrix h_variable_9607[1][3] = concat(h_variable_9606,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9607); matrix h_variable_9608 = h_variable_l[1]; matrix h_variable_9609 = h_variable_l[2];
ncols(h_variable_9608);
matrix h_variable_9610 = DecideZeroRows(h_variable_9608,h_variable_58);
IsZeroMatrix(h_variable_9610);
nrows(h_variable_9609);
def h_variable_9611 = h_variable_4814[1,116];
h_variable_9611;
matrix h_variable_9612[1][1] = 0;
matrix h_variable_9613[1][3] = concat(h_variable_9612,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9613); matrix h_variable_9614 = h_variable_l[1]; matrix h_variable_9615 = h_variable_l[2];
ncols(h_variable_9614);
matrix h_variable_9616 = DecideZeroRows(h_variable_9614,h_variable_58);
IsZeroMatrix(h_variable_9616);
nrows(h_variable_9615);
def h_variable_9617 = h_variable_4814[2,117];
h_variable_9617;
matrix h_variable_9618[1][1] = 0;
matrix h_variable_9619[1][3] = concat(h_variable_9618,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9619); matrix h_variable_9620 = h_variable_l[1]; matrix h_variable_9621 = h_variable_l[2];
ncols(h_variable_9620);
matrix h_variable_9622 = DecideZeroRows(h_variable_9620,h_variable_58);
IsZeroMatrix(h_variable_9622);
nrows(h_variable_9621);
def h_variable_9623 = h_variable_4814[1,117];
h_variable_9623;
matrix h_variable_9624[1][1] = 0;
matrix h_variable_9625[1][3] = concat(h_variable_9624,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9625); matrix h_variable_9626 = h_variable_l[1]; matrix h_variable_9627 = h_variable_l[2];
ncols(h_variable_9626);
matrix h_variable_9628 = DecideZeroRows(h_variable_9626,h_variable_58);
IsZeroMatrix(h_variable_9628);
nrows(h_variable_9627);
def h_variable_9629 = h_variable_4814[2,118];
h_variable_9629;
matrix h_variable_9630[1][1] = 0;
matrix h_variable_9631[1][3] = concat(h_variable_9630,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9631); matrix h_variable_9632 = h_variable_l[1]; matrix h_variable_9633 = h_variable_l[2];
ncols(h_variable_9632);
matrix h_variable_9634 = DecideZeroRows(h_variable_9632,h_variable_58);
IsZeroMatrix(h_variable_9634);
nrows(h_variable_9633);
def h_variable_9635 = h_variable_4814[1,118];
h_variable_9635;
matrix h_variable_9636[1][1] = 0;
matrix h_variable_9637[1][3] = concat(h_variable_9636,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9637); matrix h_variable_9638 = h_variable_l[1]; matrix h_variable_9639 = h_variable_l[2];
ncols(h_variable_9638);
matrix h_variable_9640 = DecideZeroRows(h_variable_9638,h_variable_58);
IsZeroMatrix(h_variable_9640);
nrows(h_variable_9639);
def h_variable_9641 = h_variable_4814[2,119];
h_variable_9641;
matrix h_variable_9642[1][1] = 0;
matrix h_variable_9643[1][3] = concat(h_variable_9642,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9643); matrix h_variable_9644 = h_variable_l[1]; matrix h_variable_9645 = h_variable_l[2];
ncols(h_variable_9644);
matrix h_variable_9646 = DecideZeroRows(h_variable_9644,h_variable_58);
IsZeroMatrix(h_variable_9646);
nrows(h_variable_9645);
def h_variable_9647 = h_variable_4814[1,119];
h_variable_9647;
matrix h_variable_9648[1][1] = 0;
matrix h_variable_9649[1][3] = concat(h_variable_9648,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9649); matrix h_variable_9650 = h_variable_l[1]; matrix h_variable_9651 = h_variable_l[2];
ncols(h_variable_9650);
matrix h_variable_9652 = DecideZeroRows(h_variable_9650,h_variable_58);
IsZeroMatrix(h_variable_9652);
nrows(h_variable_9651);
def h_variable_9653 = h_variable_4814[2,120];
h_variable_9653;
matrix h_variable_9654[1][1] = 0;
matrix h_variable_9655[1][3] = concat(h_variable_9654,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9655); matrix h_variable_9656 = h_variable_l[1]; matrix h_variable_9657 = h_variable_l[2];
ncols(h_variable_9656);
matrix h_variable_9658 = DecideZeroRows(h_variable_9656,h_variable_58);
IsZeroMatrix(h_variable_9658);
nrows(h_variable_9657);
def h_variable_9659 = h_variable_4814[1,120];
h_variable_9659;
matrix h_variable_9660[1][1] = 0;
matrix h_variable_9661[1][3] = concat(h_variable_9660,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9661); matrix h_variable_9662 = h_variable_l[1]; matrix h_variable_9663 = h_variable_l[2];
ncols(h_variable_9662);
matrix h_variable_9664 = DecideZeroRows(h_variable_9662,h_variable_58);
IsZeroMatrix(h_variable_9664);
nrows(h_variable_9663);
def h_variable_9665 = h_variable_4814[2,121];
h_variable_9665;
matrix h_variable_9666[1][1] = 0;
matrix h_variable_9667[1][3] = concat(h_variable_9666,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9667); matrix h_variable_9668 = h_variable_l[1]; matrix h_variable_9669 = h_variable_l[2];
ncols(h_variable_9668);
matrix h_variable_9670 = DecideZeroRows(h_variable_9668,h_variable_58);
IsZeroMatrix(h_variable_9670);
nrows(h_variable_9669);
def h_variable_9671 = h_variable_4814[1,121];
h_variable_9671;
matrix h_variable_9672[1][1] = 0;
matrix h_variable_9673[1][3] = concat(h_variable_9672,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9673); matrix h_variable_9674 = h_variable_l[1]; matrix h_variable_9675 = h_variable_l[2];
ncols(h_variable_9674);
matrix h_variable_9676 = DecideZeroRows(h_variable_9674,h_variable_58);
IsZeroMatrix(h_variable_9676);
nrows(h_variable_9675);
def h_variable_9677 = h_variable_4814[2,122];
h_variable_9677;
matrix h_variable_9678[1][1] = 0;
matrix h_variable_9679[1][3] = concat(h_variable_9678,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9679); matrix h_variable_9680 = h_variable_l[1]; matrix h_variable_9681 = h_variable_l[2];
ncols(h_variable_9680);
matrix h_variable_9682 = DecideZeroRows(h_variable_9680,h_variable_58);
IsZeroMatrix(h_variable_9682);
nrows(h_variable_9681);
def h_variable_9683 = h_variable_4814[1,122];
h_variable_9683;
matrix h_variable_9684[1][1] = 0;
matrix h_variable_9685[1][3] = concat(h_variable_9684,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9685); matrix h_variable_9686 = h_variable_l[1]; matrix h_variable_9687 = h_variable_l[2];
ncols(h_variable_9686);
matrix h_variable_9688 = DecideZeroRows(h_variable_9686,h_variable_58);
IsZeroMatrix(h_variable_9688);
nrows(h_variable_9687);
def h_variable_9689 = h_variable_4814[2,123];
h_variable_9689;
matrix h_variable_9690[1][1] = 0;
matrix h_variable_9691[1][3] = concat(h_variable_9690,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9691); matrix h_variable_9692 = h_variable_l[1]; matrix h_variable_9693 = h_variable_l[2];
ncols(h_variable_9692);
matrix h_variable_9694 = DecideZeroRows(h_variable_9692,h_variable_58);
IsZeroMatrix(h_variable_9694);
nrows(h_variable_9693);
def h_variable_9695 = h_variable_4814[1,123];
h_variable_9695;
matrix h_variable_9696[1][1] = 0;
matrix h_variable_9697[1][3] = concat(h_variable_9696,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9697); matrix h_variable_9698 = h_variable_l[1]; matrix h_variable_9699 = h_variable_l[2];
ncols(h_variable_9698);
matrix h_variable_9700 = DecideZeroRows(h_variable_9698,h_variable_58);
IsZeroMatrix(h_variable_9700);
nrows(h_variable_9699);
def h_variable_9701 = h_variable_4814[2,124];
h_variable_9701;
matrix h_variable_9702[1][1] = 0;
matrix h_variable_9703[1][3] = concat(h_variable_9702,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9703); matrix h_variable_9704 = h_variable_l[1]; matrix h_variable_9705 = h_variable_l[2];
ncols(h_variable_9704);
matrix h_variable_9706 = DecideZeroRows(h_variable_9704,h_variable_58);
IsZeroMatrix(h_variable_9706);
nrows(h_variable_9705);
def h_variable_9707 = h_variable_4814[1,124];
h_variable_9707;
matrix h_variable_9708[1][1] = 0;
matrix h_variable_9709[1][3] = concat(h_variable_9708,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9709); matrix h_variable_9710 = h_variable_l[1]; matrix h_variable_9711 = h_variable_l[2];
ncols(h_variable_9710);
matrix h_variable_9712 = DecideZeroRows(h_variable_9710,h_variable_58);
IsZeroMatrix(h_variable_9712);
nrows(h_variable_9711);
def h_variable_9713 = h_variable_4814[2,125];
h_variable_9713;
matrix h_variable_9714[1][1] = 0;
matrix h_variable_9715[1][3] = concat(h_variable_9714,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9715); matrix h_variable_9716 = h_variable_l[1]; matrix h_variable_9717 = h_variable_l[2];
ncols(h_variable_9716);
matrix h_variable_9718 = DecideZeroRows(h_variable_9716,h_variable_58);
IsZeroMatrix(h_variable_9718);
nrows(h_variable_9717);
def h_variable_9719 = h_variable_4814[1,125];
h_variable_9719;
matrix h_variable_9720[1][1] = 0;
matrix h_variable_9721[1][3] = concat(h_variable_9720,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9721); matrix h_variable_9722 = h_variable_l[1]; matrix h_variable_9723 = h_variable_l[2];
ncols(h_variable_9722);
matrix h_variable_9724 = DecideZeroRows(h_variable_9722,h_variable_58);
IsZeroMatrix(h_variable_9724);
nrows(h_variable_9723);
def h_variable_9725 = h_variable_4814[2,126];
h_variable_9725;
matrix h_variable_9726[1][1] = 0;
matrix h_variable_9727[1][3] = concat(h_variable_9726,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9727); matrix h_variable_9728 = h_variable_l[1]; matrix h_variable_9729 = h_variable_l[2];
ncols(h_variable_9728);
matrix h_variable_9730 = DecideZeroRows(h_variable_9728,h_variable_58);
IsZeroMatrix(h_variable_9730);
nrows(h_variable_9729);
def h_variable_9731 = h_variable_4814[1,126];
h_variable_9731;
matrix h_variable_9732[1][1] = 0;
matrix h_variable_9733[1][3] = concat(h_variable_9732,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9733); matrix h_variable_9734 = h_variable_l[1]; matrix h_variable_9735 = h_variable_l[2];
ncols(h_variable_9734);
matrix h_variable_9736 = DecideZeroRows(h_variable_9734,h_variable_58);
IsZeroMatrix(h_variable_9736);
nrows(h_variable_9735);
def h_variable_9737 = h_variable_4814[2,127];
h_variable_9737;
matrix h_variable_9738[1][1] = 0;
matrix h_variable_9739[1][3] = concat(h_variable_9738,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9739); matrix h_variable_9740 = h_variable_l[1]; matrix h_variable_9741 = h_variable_l[2];
ncols(h_variable_9740);
matrix h_variable_9742 = DecideZeroRows(h_variable_9740,h_variable_58);
IsZeroMatrix(h_variable_9742);
nrows(h_variable_9741);
def h_variable_9743 = h_variable_4814[1,127];
h_variable_9743;
matrix h_variable_9744[1][1] = 0;
matrix h_variable_9745[1][3] = concat(h_variable_9744,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9745); matrix h_variable_9746 = h_variable_l[1]; matrix h_variable_9747 = h_variable_l[2];
ncols(h_variable_9746);
matrix h_variable_9748 = DecideZeroRows(h_variable_9746,h_variable_58);
IsZeroMatrix(h_variable_9748);
nrows(h_variable_9747);
def h_variable_9749 = h_variable_4814[2,128];
h_variable_9749;
matrix h_variable_9750[1][1] = 0;
matrix h_variable_9751[1][3] = concat(h_variable_9750,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9751); matrix h_variable_9752 = h_variable_l[1]; matrix h_variable_9753 = h_variable_l[2];
ncols(h_variable_9752);
matrix h_variable_9754 = DecideZeroRows(h_variable_9752,h_variable_58);
IsZeroMatrix(h_variable_9754);
nrows(h_variable_9753);
def h_variable_9755 = h_variable_4814[1,128];
h_variable_9755;
matrix h_variable_9756[1][1] = 0;
matrix h_variable_9757[1][3] = concat(h_variable_9756,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9757); matrix h_variable_9758 = h_variable_l[1]; matrix h_variable_9759 = h_variable_l[2];
ncols(h_variable_9758);
matrix h_variable_9760 = DecideZeroRows(h_variable_9758,h_variable_58);
IsZeroMatrix(h_variable_9760);
nrows(h_variable_9759);
def h_variable_9761 = h_variable_4814[2,129];
h_variable_9761;
matrix h_variable_9762[1][1] = 0;
matrix h_variable_9763[1][3] = concat(h_variable_9762,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9763); matrix h_variable_9764 = h_variable_l[1]; matrix h_variable_9765 = h_variable_l[2];
ncols(h_variable_9764);
matrix h_variable_9766 = DecideZeroRows(h_variable_9764,h_variable_58);
IsZeroMatrix(h_variable_9766);
nrows(h_variable_9765);
def h_variable_9767 = h_variable_4814[1,129];
h_variable_9767;
matrix h_variable_9768[1][1] = 0;
matrix h_variable_9769[1][3] = concat(h_variable_9768,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9769); matrix h_variable_9770 = h_variable_l[1]; matrix h_variable_9771 = h_variable_l[2];
ncols(h_variable_9770);
matrix h_variable_9772 = DecideZeroRows(h_variable_9770,h_variable_58);
IsZeroMatrix(h_variable_9772);
nrows(h_variable_9771);
def h_variable_9773 = h_variable_4814[2,130];
h_variable_9773;
matrix h_variable_9774[1][1] = 0;
matrix h_variable_9775[1][3] = concat(h_variable_9774,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9775); matrix h_variable_9776 = h_variable_l[1]; matrix h_variable_9777 = h_variable_l[2];
ncols(h_variable_9776);
matrix h_variable_9778 = DecideZeroRows(h_variable_9776,h_variable_58);
IsZeroMatrix(h_variable_9778);
nrows(h_variable_9777);
def h_variable_9779 = h_variable_4814[1,130];
h_variable_9779;
matrix h_variable_9780[1][1] = 0;
matrix h_variable_9781[1][3] = concat(h_variable_9780,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9781); matrix h_variable_9782 = h_variable_l[1]; matrix h_variable_9783 = h_variable_l[2];
ncols(h_variable_9782);
matrix h_variable_9784 = DecideZeroRows(h_variable_9782,h_variable_58);
IsZeroMatrix(h_variable_9784);
nrows(h_variable_9783);
def h_variable_9785 = h_variable_4814[2,131];
h_variable_9785;
matrix h_variable_9786[1][1] = 0;
matrix h_variable_9787[1][3] = concat(h_variable_9786,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9787); matrix h_variable_9788 = h_variable_l[1]; matrix h_variable_9789 = h_variable_l[2];
ncols(h_variable_9788);
matrix h_variable_9790 = DecideZeroRows(h_variable_9788,h_variable_58);
IsZeroMatrix(h_variable_9790);
nrows(h_variable_9789);
def h_variable_9791 = h_variable_4814[1,131];
h_variable_9791;
matrix h_variable_9792[1][1] = 0;
matrix h_variable_9793[1][3] = concat(h_variable_9792,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9793); matrix h_variable_9794 = h_variable_l[1]; matrix h_variable_9795 = h_variable_l[2];
ncols(h_variable_9794);
matrix h_variable_9796 = DecideZeroRows(h_variable_9794,h_variable_58);
IsZeroMatrix(h_variable_9796);
nrows(h_variable_9795);
matrix h_variable_9798 = submat(h_variable_4807,1..3,intvec( 1, 2, 3, 4, 5, 7, 10, 11, 12, 13 ));
matrix h_variable_9799[3][6] = dsum(h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_9797 = DecideZeroRows(h_variable_9798,h_variable_9799);
IsZeroMatrix(h_variable_9797);
matrix h_variable_9801[3][6] = dsum(h_variable_48,h_variable_48,h_variable_48);
matrix h_variable_9800 = RelativeSyzygiesGeneratorsOfRows(h_variable_9797,h_variable_9801);
IsZeroMatrix(h_variable_9800);
ncols(h_variable_9800);
matrix h_variable_9803[10][20] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_9802 = DecideZeroRows(h_variable_9800,h_variable_9803);
IsZeroMatrix(h_variable_9802);
ZeroRows(h_variable_9802);
matrix h_variable_9805 = submat(h_variable_9800,1..10,intvec( 2, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 29, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118 ));
matrix h_variable_9806[10][20] = dsum(h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_9804 = DecideZeroRows(h_variable_9805,h_variable_9806);
IsZeroMatrix(h_variable_9804);
def h_variable_9807 = h_variable_9804[10,1];
h_variable_9807;
matrix h_variable_9808[1][1] = 0;
matrix h_variable_9809[1][3] = concat(h_variable_9808,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9809); matrix h_variable_9810 = h_variable_l[1]; matrix h_variable_9811 = h_variable_l[2];
ncols(h_variable_9810);
matrix h_variable_9812 = DecideZeroRows(h_variable_9810,h_variable_58);
IsZeroMatrix(h_variable_9812);
nrows(h_variable_9811);
def h_variable_9813 = h_variable_9804[9,1];
h_variable_9813;
matrix h_variable_9814[1][1] = 0;
matrix h_variable_9815[1][3] = concat(h_variable_9814,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9815); matrix h_variable_9816 = h_variable_l[1]; matrix h_variable_9817 = h_variable_l[2];
ncols(h_variable_9816);
matrix h_variable_9818 = DecideZeroRows(h_variable_9816,h_variable_58);
IsZeroMatrix(h_variable_9818);
nrows(h_variable_9817);
def h_variable_9819 = h_variable_9804[8,1];
h_variable_9819;
matrix h_variable_9820[1][1] = 0;
matrix h_variable_9821[1][3] = concat(h_variable_9820,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9821); matrix h_variable_9822 = h_variable_l[1]; matrix h_variable_9823 = h_variable_l[2];
ncols(h_variable_9822);
matrix h_variable_9824 = DecideZeroRows(h_variable_9822,h_variable_58);
IsZeroMatrix(h_variable_9824);
nrows(h_variable_9823);
def h_variable_9825 = h_variable_9804[7,1];
h_variable_9825;
matrix h_variable_9826[1][1] = 0;
matrix h_variable_9827[1][3] = concat(h_variable_9826,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9827); matrix h_variable_9828 = h_variable_l[1]; matrix h_variable_9829 = h_variable_l[2];
ncols(h_variable_9828);
matrix h_variable_9830 = DecideZeroRows(h_variable_9828,h_variable_58);
IsZeroMatrix(h_variable_9830);
nrows(h_variable_9829);
def h_variable_9831 = h_variable_9804[6,1];
h_variable_9831;
matrix h_variable_9832[1][1] = 0;
matrix h_variable_9833[1][3] = concat(h_variable_9832,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9833); matrix h_variable_9834 = h_variable_l[1]; matrix h_variable_9835 = h_variable_l[2];
ncols(h_variable_9834);
matrix h_variable_9836 = DecideZeroRows(h_variable_9834,h_variable_58);
IsZeroMatrix(h_variable_9836);
nrows(h_variable_9835);
def h_variable_9837 = h_variable_9804[5,1];
h_variable_9837;
matrix h_variable_9838[1][1] = 0;
matrix h_variable_9839[1][3] = concat(h_variable_9838,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9839); matrix h_variable_9840 = h_variable_l[1]; matrix h_variable_9841 = h_variable_l[2];
ncols(h_variable_9840);
matrix h_variable_9842 = DecideZeroRows(h_variable_9840,h_variable_58);
IsZeroMatrix(h_variable_9842);
nrows(h_variable_9841);
def h_variable_9843 = h_variable_9804[4,1];
h_variable_9843;
matrix h_variable_9844[1][1] = 0;
matrix h_variable_9845[1][3] = concat(h_variable_9844,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9845); matrix h_variable_9846 = h_variable_l[1]; matrix h_variable_9847 = h_variable_l[2];
ncols(h_variable_9846);
matrix h_variable_9848 = DecideZeroRows(h_variable_9846,h_variable_58);
IsZeroMatrix(h_variable_9848);
nrows(h_variable_9847);
def h_variable_9849 = h_variable_9804[3,1];
h_variable_9849;
matrix h_variable_9850[1][1] = 0;
matrix h_variable_9851[1][3] = concat(h_variable_9850,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9851); matrix h_variable_9852 = h_variable_l[1]; matrix h_variable_9853 = h_variable_l[2];
ncols(h_variable_9852);
matrix h_variable_9854 = DecideZeroRows(h_variable_9852,h_variable_58);
IsZeroMatrix(h_variable_9854);
nrows(h_variable_9853);
def h_variable_9855 = h_variable_9804[2,1];
h_variable_9855;
matrix h_variable_9856[1][1] = 3;
matrix h_variable_9857[1][3] = concat(h_variable_9856,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9857); matrix h_variable_9858 = h_variable_l[1]; matrix h_variable_9859 = h_variable_l[2];
ncols(h_variable_9858);
matrix h_variable_9860 = DecideZeroRows(h_variable_9858,h_variable_58);
IsZeroMatrix(h_variable_9860);
ZeroRows(h_variable_9860);
nrows(h_variable_9859);
matrix h_variable_9862 = submat(h_variable_9858,1..1,intvec( 1 ));
matrix h_variable_9861 = DecideZeroRows(h_variable_9862,h_variable_58);
IsZeroMatrix(h_variable_9861);
IsIdentityMatrix(h_variable_9861);
matrix h_variable_9863[1][3] = concat(h_variable_9861,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9863); matrix h_variable_9864 = h_variable_l[1]; matrix h_variable_9865 = h_variable_l[2];
IsZeroMatrix(h_variable_9864);
matrix h_variable_9866 = DecideZeroRows(h_variable_9864,h_variable_58);
IsZeroMatrix(h_variable_9866);
def h_variable_9867 = h_variable_9804[1,1];
h_variable_9867;
matrix h_variable_9868[1][1] = 0;
matrix h_variable_9869[1][3] = concat(h_variable_9868,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9869); matrix h_variable_9870 = h_variable_l[1]; matrix h_variable_9871 = h_variable_l[2];
ncols(h_variable_9870);
matrix h_variable_9872 = DecideZeroRows(h_variable_9870,h_variable_58);
IsZeroMatrix(h_variable_9872);
nrows(h_variable_9871);
def h_variable_9873 = h_variable_9804[10,2];
h_variable_9873;
matrix h_variable_9874[1][1] = 0;
matrix h_variable_9875[1][3] = concat(h_variable_9874,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9875); matrix h_variable_9876 = h_variable_l[1]; matrix h_variable_9877 = h_variable_l[2];
ncols(h_variable_9876);
matrix h_variable_9878 = DecideZeroRows(h_variable_9876,h_variable_58);
IsZeroMatrix(h_variable_9878);
nrows(h_variable_9877);
def h_variable_9879 = h_variable_9804[9,2];
h_variable_9879;
matrix h_variable_9880[1][1] = 0;
matrix h_variable_9881[1][3] = concat(h_variable_9880,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9881); matrix h_variable_9882 = h_variable_l[1]; matrix h_variable_9883 = h_variable_l[2];
ncols(h_variable_9882);
matrix h_variable_9884 = DecideZeroRows(h_variable_9882,h_variable_58);
IsZeroMatrix(h_variable_9884);
nrows(h_variable_9883);
def h_variable_9885 = h_variable_9804[8,2];
h_variable_9885;
matrix h_variable_9886[1][1] = 0;
matrix h_variable_9887[1][3] = concat(h_variable_9886,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9887); matrix h_variable_9888 = h_variable_l[1]; matrix h_variable_9889 = h_variable_l[2];
ncols(h_variable_9888);
matrix h_variable_9890 = DecideZeroRows(h_variable_9888,h_variable_58);
IsZeroMatrix(h_variable_9890);
nrows(h_variable_9889);
def h_variable_9891 = h_variable_9804[7,2];
h_variable_9891;
matrix h_variable_9892[1][1] = 0;
matrix h_variable_9893[1][3] = concat(h_variable_9892,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9893); matrix h_variable_9894 = h_variable_l[1]; matrix h_variable_9895 = h_variable_l[2];
ncols(h_variable_9894);
matrix h_variable_9896 = DecideZeroRows(h_variable_9894,h_variable_58);
IsZeroMatrix(h_variable_9896);
nrows(h_variable_9895);
def h_variable_9897 = h_variable_9804[6,2];
h_variable_9897;
matrix h_variable_9898[1][1] = 0;
matrix h_variable_9899[1][3] = concat(h_variable_9898,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9899); matrix h_variable_9900 = h_variable_l[1]; matrix h_variable_9901 = h_variable_l[2];
ncols(h_variable_9900);
matrix h_variable_9902 = DecideZeroRows(h_variable_9900,h_variable_58);
IsZeroMatrix(h_variable_9902);
nrows(h_variable_9901);
def h_variable_9903 = h_variable_9804[5,2];
h_variable_9903;
matrix h_variable_9904[1][1] = -2;
matrix h_variable_9905[1][3] = concat(h_variable_9904,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9905); matrix h_variable_9906 = h_variable_l[1]; matrix h_variable_9907 = h_variable_l[2];
ncols(h_variable_9906);
matrix h_variable_9908 = DecideZeroRows(h_variable_9906,h_variable_58);
IsZeroMatrix(h_variable_9908);
ZeroRows(h_variable_9908);
nrows(h_variable_9907);
matrix h_variable_9910 = submat(h_variable_9906,1..1,intvec( 1 ));
matrix h_variable_9909 = DecideZeroRows(h_variable_9910,h_variable_58);
IsZeroMatrix(h_variable_9909);
IsIdentityMatrix(h_variable_9909);
matrix h_variable_9911[1][3] = concat(h_variable_9909,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9911); matrix h_variable_9912 = h_variable_l[1]; matrix h_variable_9913 = h_variable_l[2];
IsZeroMatrix(h_variable_9912);
matrix h_variable_9914 = DecideZeroRows(h_variable_9912,h_variable_58);
IsZeroMatrix(h_variable_9914);
def h_variable_9915 = h_variable_9804[4,2];
h_variable_9915;
matrix h_variable_9916[1][1] = 0;
matrix h_variable_9917[1][3] = concat(h_variable_9916,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9917); matrix h_variable_9918 = h_variable_l[1]; matrix h_variable_9919 = h_variable_l[2];
ncols(h_variable_9918);
matrix h_variable_9920 = DecideZeroRows(h_variable_9918,h_variable_58);
IsZeroMatrix(h_variable_9920);
nrows(h_variable_9919);
def h_variable_9921 = h_variable_9804[3,2];
h_variable_9921;
matrix h_variable_9922[1][1] = -4;
matrix h_variable_9923[1][3] = concat(h_variable_9922,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9923); matrix h_variable_9924 = h_variable_l[1]; matrix h_variable_9925 = h_variable_l[2];
ncols(h_variable_9924);
matrix h_variable_9926 = DecideZeroRows(h_variable_9924,h_variable_58);
IsZeroMatrix(h_variable_9926);
ZeroRows(h_variable_9926);
nrows(h_variable_9925);
matrix h_variable_9928 = submat(h_variable_9924,1..1,intvec( 1 ));
matrix h_variable_9927 = DecideZeroRows(h_variable_9928,h_variable_58);
IsZeroMatrix(h_variable_9927);
IsIdentityMatrix(h_variable_9927);
matrix h_variable_9929[1][3] = concat(h_variable_9927,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9929); matrix h_variable_9930 = h_variable_l[1]; matrix h_variable_9931 = h_variable_l[2];
IsZeroMatrix(h_variable_9930);
matrix h_variable_9932 = DecideZeroRows(h_variable_9930,h_variable_58);
IsZeroMatrix(h_variable_9932);
def h_variable_9933 = h_variable_9804[2,2];
h_variable_9933;
matrix h_variable_9934[1][1] = x2;
matrix h_variable_9935[1][3] = concat(h_variable_9934,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9935); matrix h_variable_9936 = h_variable_l[1]; matrix h_variable_9937 = h_variable_l[2];
ncols(h_variable_9936);
matrix h_variable_9938 = DecideZeroRows(h_variable_9936,h_variable_58);
IsZeroMatrix(h_variable_9938);
ZeroRows(h_variable_9938);
nrows(h_variable_9937);
matrix h_variable_9940 = submat(h_variable_9936,1..1,intvec( 2 ));
matrix h_variable_9939 = DecideZeroRows(h_variable_9940,h_variable_58);
IsZeroMatrix(h_variable_9939);
IsIdentityMatrix(h_variable_9939);
matrix h_variable_9941[1][3] = concat(h_variable_9939,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9941); matrix h_variable_9942 = h_variable_l[1]; matrix h_variable_9943 = h_variable_l[2];
IsZeroMatrix(h_variable_9942);
matrix h_variable_9944 = DecideZeroRows(h_variable_9942,h_variable_58);
IsZeroMatrix(h_variable_9944);
def h_variable_9945 = h_variable_9804[1,2];
h_variable_9945;
matrix h_variable_9946[1][1] = 0;
matrix h_variable_9947[1][3] = concat(h_variable_9946,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9947); matrix h_variable_9948 = h_variable_l[1]; matrix h_variable_9949 = h_variable_l[2];
ncols(h_variable_9948);
matrix h_variable_9950 = DecideZeroRows(h_variable_9948,h_variable_58);
IsZeroMatrix(h_variable_9950);
nrows(h_variable_9949);
def h_variable_9951 = h_variable_9804[10,3];
h_variable_9951;
matrix h_variable_9952[1][1] = 0;
matrix h_variable_9953[1][3] = concat(h_variable_9952,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9953); matrix h_variable_9954 = h_variable_l[1]; matrix h_variable_9955 = h_variable_l[2];
ncols(h_variable_9954);
matrix h_variable_9956 = DecideZeroRows(h_variable_9954,h_variable_58);
IsZeroMatrix(h_variable_9956);
nrows(h_variable_9955);
def h_variable_9957 = h_variable_9804[9,3];
h_variable_9957;
matrix h_variable_9958[1][1] = 0;
matrix h_variable_9959[1][3] = concat(h_variable_9958,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9959); matrix h_variable_9960 = h_variable_l[1]; matrix h_variable_9961 = h_variable_l[2];
ncols(h_variable_9960);
matrix h_variable_9962 = DecideZeroRows(h_variable_9960,h_variable_58);
IsZeroMatrix(h_variable_9962);
nrows(h_variable_9961);
def h_variable_9963 = h_variable_9804[8,3];
h_variable_9963;
matrix h_variable_9964[1][1] = 0;
matrix h_variable_9965[1][3] = concat(h_variable_9964,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9965); matrix h_variable_9966 = h_variable_l[1]; matrix h_variable_9967 = h_variable_l[2];
ncols(h_variable_9966);
matrix h_variable_9968 = DecideZeroRows(h_variable_9966,h_variable_58);
IsZeroMatrix(h_variable_9968);
nrows(h_variable_9967);
def h_variable_9969 = h_variable_9804[7,3];
h_variable_9969;
matrix h_variable_9970[1][1] = 0;
matrix h_variable_9971[1][3] = concat(h_variable_9970,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9971); matrix h_variable_9972 = h_variable_l[1]; matrix h_variable_9973 = h_variable_l[2];
ncols(h_variable_9972);
matrix h_variable_9974 = DecideZeroRows(h_variable_9972,h_variable_58);
IsZeroMatrix(h_variable_9974);
nrows(h_variable_9973);
def h_variable_9975 = h_variable_9804[6,3];
h_variable_9975;
matrix h_variable_9976[1][1] = -3;
matrix h_variable_9977[1][3] = concat(h_variable_9976,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9977); matrix h_variable_9978 = h_variable_l[1]; matrix h_variable_9979 = h_variable_l[2];
ncols(h_variable_9978);
matrix h_variable_9980 = DecideZeroRows(h_variable_9978,h_variable_58);
IsZeroMatrix(h_variable_9980);
ZeroRows(h_variable_9980);
nrows(h_variable_9979);
matrix h_variable_9982 = submat(h_variable_9978,1..1,intvec( 1 ));
matrix h_variable_9981 = DecideZeroRows(h_variable_9982,h_variable_58);
IsZeroMatrix(h_variable_9981);
IsIdentityMatrix(h_variable_9981);
matrix h_variable_9983[1][3] = concat(h_variable_9981,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_9983); matrix h_variable_9984 = h_variable_l[1]; matrix h_variable_9985 = h_variable_l[2];
IsZeroMatrix(h_variable_9984);
matrix h_variable_9986 = DecideZeroRows(h_variable_9984,h_variable_58);
IsZeroMatrix(h_variable_9986);
def h_variable_9987 = h_variable_9804[5,3];
h_variable_9987;
matrix h_variable_9988[1][1] = 0;
matrix h_variable_9989[1][3] = concat(h_variable_9988,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9989); matrix h_variable_9990 = h_variable_l[1]; matrix h_variable_9991 = h_variable_l[2];
ncols(h_variable_9990);
matrix h_variable_9992 = DecideZeroRows(h_variable_9990,h_variable_58);
IsZeroMatrix(h_variable_9992);
nrows(h_variable_9991);
def h_variable_9993 = h_variable_9804[4,3];
h_variable_9993;
matrix h_variable_9994[1][1] = 0;
matrix h_variable_9995[1][3] = concat(h_variable_9994,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_9995); matrix h_variable_9996 = h_variable_l[1]; matrix h_variable_9997 = h_variable_l[2];
ncols(h_variable_9996);
matrix h_variable_9998 = DecideZeroRows(h_variable_9996,h_variable_58);
IsZeroMatrix(h_variable_9998);
nrows(h_variable_9997);
def h_variable_9999 = h_variable_9804[3,3];
h_variable_9999;
matrix h_variable_10000[1][1] = 3*x1+3*x2;
kill h_variable_9391;kill h_variable_9392;kill h_variable_9393;kill h_variable_9394;kill h_variable_9396;kill h_variable_9397;kill h_variable_9398;kill h_variable_9399;kill h_variable_9400;kill h_variable_9402;kill h_variable_9403;kill h_variable_9404;kill h_variable_9405;kill h_variable_9406;kill h_variable_9407;kill h_variable_9408;kill h_variable_9409;kill h_variable_9410;kill h_variable_9411;kill h_variable_9412;kill h_variable_9413;kill h_variable_9414;kill h_variable_9415;kill h_variable_9416;kill h_variable_9417;kill h_variable_9418;kill h_variable_9419;kill h_variable_9420;kill h_variable_9421;kill h_variable_9422;kill h_variable_9423;kill h_variable_9424;kill h_variable_9425;kill h_variable_9426;kill h_variable_9427;kill h_variable_9428;kill h_variable_9429;kill h_variable_9430;kill h_variable_9431;kill h_variable_9432;kill h_variable_9433;kill h_variable_9434;kill h_variable_9435;kill h_variable_9436;kill h_variable_9437;kill h_variable_9438;kill h_variable_9439;kill h_variable_9440;kill h_variable_9441;kill h_variable_9442;kill h_variable_9443;kill h_variable_9444;kill h_variable_9445;kill h_variable_9446;kill h_variable_9447;kill h_variable_9448;kill h_variable_9449;kill h_variable_9450;kill h_variable_9451;kill h_variable_9452;kill h_variable_9453;kill h_variable_9454;kill h_variable_9455;kill h_variable_9456;kill h_variable_9457;kill h_variable_9458;kill h_variable_9459;kill h_variable_9460;kill h_variable_9461;kill h_variable_9462;kill h_variable_9463;kill h_variable_9464;kill h_variable_9465;kill h_variable_9466;kill h_variable_9467;kill h_variable_9468;kill h_variable_9469;kill h_variable_9470;kill h_variable_9471;kill h_variable_9472;kill h_variable_9473;kill h_variable_9474;kill h_variable_9475;kill h_variable_9476;kill h_variable_9477;kill h_variable_9478;kill h_variable_9479;kill h_variable_9480;kill h_variable_9481;kill h_variable_9482;kill h_variable_9483;kill h_variable_9484;kill h_variable_9485;kill h_variable_9486;kill h_variable_9487;kill h_variable_9488;kill h_variable_9489;kill h_variable_9490;kill h_variable_9491;kill h_variable_9492;kill h_variable_9493;kill h_variable_9494;kill h_variable_9495;kill h_variable_9496;kill h_variable_9505;kill h_variable_9506;kill h_variable_9507;kill h_variable_9508;kill h_variable_9510;kill h_variable_9511;kill h_variable_9512;kill h_variable_9513;kill h_variable_9514;kill h_variable_9516;kill h_variable_9517;kill h_variable_9518;kill h_variable_9519;kill h_variable_9520;kill h_variable_9521;kill h_variable_9522;kill h_variable_9523;kill h_variable_9524;kill h_variable_9525;kill h_variable_9526;kill h_variable_9527;kill h_variable_9528;kill h_variable_9529;kill h_variable_9530;kill h_variable_9531;kill h_variable_9532;kill h_variable_9533;kill h_variable_9534;kill h_variable_9535;kill h_variable_9536;kill h_variable_9537;kill h_variable_9538;kill h_variable_9539;kill h_variable_9540;kill h_variable_9541;kill h_variable_9542;kill h_variable_9543;kill h_variable_9544;kill h_variable_9545;kill h_variable_9546;kill h_variable_9547;kill h_variable_9548;kill h_variable_9549;kill h_variable_9550;kill h_variable_9551;kill h_variable_9552;kill h_variable_9553;kill h_variable_9554;kill h_variable_9555;kill h_variable_9556;kill h_variable_9557;kill h_variable_9558;kill h_variable_9559;kill h_variable_9560;kill h_variable_9561;kill h_variable_9562;kill h_variable_9563;kill h_variable_9564;kill h_variable_9565;kill h_variable_9566;kill h_variable_9567;kill h_variable_9568;kill h_variable_9569;kill h_variable_9570;kill h_variable_9571;kill h_variable_9572;kill h_variable_9573;kill h_variable_9574;kill h_variable_9575;kill h_variable_9576;kill h_variable_9577;kill h_variable_9578;kill h_variable_9579;kill h_variable_9580;kill h_variable_9581;kill h_variable_9582;kill h_variable_9583;kill h_variable_9584;kill h_variable_9585;kill h_variable_9586;kill h_variable_9587;kill h_variable_9588;kill h_variable_9589;kill h_variable_9590;kill h_variable_9591;kill h_variable_9592;kill h_variable_9593;kill h_variable_9594;kill h_variable_9595;kill h_variable_9596;kill h_variable_9597;kill h_variable_9598;kill h_variable_9599;kill h_variable_9600;kill h_variable_9601;kill h_variable_9602;kill h_variable_9603;kill h_variable_9604;kill h_variable_9605;kill h_variable_9606;kill h_variable_9607;kill h_variable_9608;kill h_variable_9609;kill h_variable_9610;kill h_variable_9611;kill h_variable_9612;kill h_variable_9613;kill h_variable_9614;kill h_variable_9615;kill h_variable_9616;kill h_variable_9617;kill h_variable_9618;kill h_variable_9619;kill h_variable_9620;kill h_variable_9621;kill h_variable_9622;kill h_variable_9623;kill h_variable_9624;kill h_variable_9625;kill h_variable_9626;kill h_variable_9627;kill h_variable_9628;kill h_variable_9629;kill h_variable_9630;kill h_variable_9631;kill h_variable_9632;kill h_variable_9633;kill h_variable_9634;kill h_variable_9635;kill h_variable_9636;kill h_variable_9637;kill h_variable_9638;kill h_variable_9639;kill h_variable_9640;kill h_variable_9643;kill h_variable_9644;kill h_variable_9645;kill h_variable_9646;kill h_variable_9649;kill h_variable_9650;kill h_variable_9651;kill h_variable_9652;kill h_variable_9654;kill h_variable_9655;kill h_variable_9656;kill h_variable_9657;kill h_variable_9658;kill h_variable_9660;kill h_variable_9661;kill h_variable_9662;kill h_variable_9663;kill h_variable_9664;kill h_variable_9665;kill h_variable_9666;kill h_variable_9667;kill h_variable_9668;kill h_variable_9669;kill h_variable_9670;kill h_variable_9671;kill h_variable_9672;kill h_variable_9673;kill h_variable_9674;kill h_variable_9675;kill h_variable_9676;kill h_variable_9677;kill h_variable_9678;kill h_variable_9679;kill h_variable_9680;kill h_variable_9681;kill h_variable_9682;kill h_variable_9683;kill h_variable_9684;kill h_variable_9685;kill h_variable_9686;kill h_variable_9687;kill h_variable_9688;kill h_variable_9689;kill h_variable_9690;kill h_variable_9691;kill h_variable_9692;kill h_variable_9693;kill h_variable_9694;kill h_variable_9695;kill h_variable_9696;kill h_variable_9697;kill h_variable_9698;kill h_variable_9699;kill h_variable_9700;kill h_variable_9701;kill h_variable_9702;kill h_variable_9703;kill h_variable_9704;kill h_variable_9705;kill h_variable_9706;kill h_variable_9707;kill h_variable_9708;kill h_variable_9709;kill h_variable_9710;kill h_variable_9711;kill h_variable_9712;kill h_variable_9713;kill h_variable_9714;kill h_variable_9715;kill h_variable_9716;kill h_variable_9717;kill h_variable_9718;kill h_variable_9719;kill h_variable_9720;kill h_variable_9721;kill h_variable_9722;kill h_variable_9723;kill h_variable_9724;kill h_variable_9725;kill h_variable_9726;kill h_variable_9727;kill h_variable_9728;kill h_variable_9729;kill h_variable_9730;kill h_variable_9731;kill h_variable_9732;kill h_variable_9733;kill h_variable_9734;kill h_variable_9735;kill h_variable_9736;kill h_variable_9737;kill h_variable_9738;kill h_variable_9739;kill h_variable_9740;kill h_variable_9741;kill h_variable_9742;kill h_variable_9743;kill h_variable_9744;kill h_variable_9745;kill h_variable_9746;kill h_variable_9747;kill h_variable_9748;kill h_variable_9749;kill h_variable_9750;kill h_variable_9751;kill h_variable_9752;kill h_variable_9753;kill h_variable_9754;kill h_variable_9755;kill h_variable_9756;kill h_variable_9757;kill h_variable_9758;kill h_variable_9759;kill h_variable_9760;kill h_variable_9761;kill h_variable_9762;kill h_variable_9763;kill h_variable_9764;kill h_variable_9765;kill h_variable_9766;kill h_variable_9767;kill h_variable_9768;kill h_variable_9769;kill h_variable_9770;kill h_variable_9771;kill h_variable_9772;kill h_variable_9773;kill h_variable_9774;kill h_variable_9775;kill h_variable_9776;kill h_variable_9777;kill h_variable_9778;kill h_variable_9779;kill h_variable_9780;kill h_variable_9781;kill h_variable_9782;kill h_variable_9783;kill h_variable_9784;kill h_variable_9785;kill h_variable_9786;kill h_variable_9787;kill h_variable_9788;kill h_variable_9789;kill h_variable_9790;kill h_variable_9791;kill h_variable_9792;kill h_variable_9793;kill h_variable_9794;kill h_variable_9795;kill h_variable_9796;kill h_variable_9798;kill h_variable_9808;kill h_variable_9809;kill h_variable_9810;kill h_variable_9811;kill h_variable_9812;kill h_variable_9814;kill h_variable_9815;kill h_variable_9816;kill h_variable_9817;kill h_variable_9818;kill h_variable_9820;kill h_variable_9821;kill h_variable_9822;kill h_variable_9823;kill h_variable_9824;kill h_variable_9825;kill h_variable_9826;kill h_variable_9827;kill h_variable_9828;kill h_variable_9829;kill h_variable_9830;kill h_variable_9831;kill h_variable_9832;kill h_variable_9833;kill h_variable_9834;kill h_variable_9835;kill h_variable_9836;kill h_variable_9837;kill h_variable_9838;kill h_variable_9839;kill h_variable_9840;kill h_variable_9841;kill h_variable_9842;kill h_variable_9843;kill h_variable_9844;kill h_variable_9845;kill h_variable_9846;kill h_variable_9847;kill h_variable_9848;kill h_variable_9849;kill h_variable_9850;kill h_variable_9851;kill h_variable_9852;kill h_variable_9853;kill h_variable_9854;kill h_variable_9855;kill h_variable_9856;kill h_variable_9857;kill h_variable_9858;kill h_variable_9859;kill h_variable_9860;kill h_variable_9861;kill h_variable_9862;kill h_variable_9863;kill h_variable_9864;kill h_variable_9865;kill h_variable_9866;kill h_variable_9867;kill h_variable_9868;kill h_variable_9869;kill h_variable_9870;kill h_variable_9871;kill h_variable_9872;kill h_variable_9873;kill h_variable_9874;kill h_variable_9875;kill h_variable_9876;kill h_variable_9877;kill h_variable_9878;kill h_variable_9879;kill h_variable_9880;kill h_variable_9881;kill h_variable_9882;kill h_variable_9883;kill h_variable_9884;kill h_variable_9885;kill h_variable_9886;kill h_variable_9887;kill h_variable_9888;kill h_variable_9889;kill h_variable_9890;kill h_variable_9891;kill h_variable_9892;kill h_variable_9893;kill h_variable_9894;kill h_variable_9895;kill h_variable_9896;kill h_variable_9897;kill h_variable_9898;kill h_variable_9899;kill h_variable_9900;kill h_variable_9901;kill h_variable_9902;kill h_variable_9903;kill h_variable_9904;kill h_variable_9905;kill h_variable_9906;kill h_variable_9907;kill h_variable_9908;kill h_variable_9909;kill h_variable_9910;kill h_variable_9911;kill h_variable_9912;kill h_variable_9913;kill h_variable_9914;kill h_variable_9915;kill h_variable_9916;kill h_variable_9917;kill h_variable_9918;kill h_variable_9919;kill h_variable_9920;kill h_variable_9921;kill h_variable_9922;kill h_variable_9923;kill h_variable_9924;kill h_variable_9925;kill h_variable_9926;kill h_variable_9927;kill h_variable_9928;kill h_variable_9929;kill h_variable_9930;kill h_variable_9931;kill h_variable_9932;kill h_variable_9933;kill h_variable_9934;kill h_variable_9935;kill h_variable_9936;kill h_variable_9937;kill h_variable_9938;kill h_variable_9939;kill h_variable_9940;kill h_variable_9941;kill h_variable_9942;kill h_variable_9943;kill h_variable_9944;kill h_variable_9945;kill h_variable_9946;kill h_variable_9947;kill h_variable_9948;kill h_variable_9949;kill h_variable_9950;kill h_variable_9951;kill h_variable_9952;kill h_variable_9953;kill h_variable_9954;kill h_variable_9955;kill h_variable_9956;kill h_variable_9957;kill h_variable_9958;kill h_variable_9959;kill h_variable_9960;kill h_variable_9961;kill h_variable_9962;kill h_variable_9963;kill h_variable_9964;kill h_variable_9965;kill h_variable_9966;kill h_variable_9967;kill h_variable_9968;
matrix h_variable_10001[1][3] = concat(h_variable_10000,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10001); matrix h_variable_10002 = h_variable_l[1]; matrix h_variable_10003 = h_variable_l[2];
ncols(h_variable_10002);
matrix h_variable_10004 = DecideZeroRows(h_variable_10002,h_variable_58);
IsZeroMatrix(h_variable_10004);
ZeroRows(h_variable_10004);
nrows(h_variable_10003);
matrix h_variable_10006 = submat(h_variable_10002,1..1,intvec( 2 ));
matrix h_variable_10005 = DecideZeroRows(h_variable_10006,h_variable_58);
IsZeroMatrix(h_variable_10005);
IsIdentityMatrix(h_variable_10005);
matrix h_variable_10007[1][3] = concat(h_variable_10005,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10007); matrix h_variable_10008 = h_variable_l[1]; matrix h_variable_10009 = h_variable_l[2];
IsZeroMatrix(h_variable_10008);
matrix h_variable_10010 = DecideZeroRows(h_variable_10008,h_variable_58);
IsZeroMatrix(h_variable_10010);
def h_variable_10011 = h_variable_9804[2,3];
h_variable_10011;
matrix h_variable_10012[1][1] = 0;
matrix h_variable_10013[1][3] = concat(h_variable_10012,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10013); matrix h_variable_10014 = h_variable_l[1]; matrix h_variable_10015 = h_variable_l[2];
ncols(h_variable_10014);
matrix h_variable_10016 = DecideZeroRows(h_variable_10014,h_variable_58);
IsZeroMatrix(h_variable_10016);
nrows(h_variable_10015);
def h_variable_10017 = h_variable_9804[1,3];
h_variable_10017;
matrix h_variable_10018[1][1] = 0;
matrix h_variable_10019[1][3] = concat(h_variable_10018,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10019); matrix h_variable_10020 = h_variable_l[1]; matrix h_variable_10021 = h_variable_l[2];
ncols(h_variable_10020);
matrix h_variable_10022 = DecideZeroRows(h_variable_10020,h_variable_58);
IsZeroMatrix(h_variable_10022);
nrows(h_variable_10021);
def h_variable_10023 = h_variable_9804[10,4];
h_variable_10023;
matrix h_variable_10024[1][1] = 0;
matrix h_variable_10025[1][3] = concat(h_variable_10024,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10025); matrix h_variable_10026 = h_variable_l[1]; matrix h_variable_10027 = h_variable_l[2];
ncols(h_variable_10026);
matrix h_variable_10028 = DecideZeroRows(h_variable_10026,h_variable_58);
IsZeroMatrix(h_variable_10028);
nrows(h_variable_10027);
def h_variable_10029 = h_variable_9804[9,4];
h_variable_10029;
matrix h_variable_10030[1][1] = 0;
matrix h_variable_10031[1][3] = concat(h_variable_10030,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10031); matrix h_variable_10032 = h_variable_l[1]; matrix h_variable_10033 = h_variable_l[2];
ncols(h_variable_10032);
matrix h_variable_10034 = DecideZeroRows(h_variable_10032,h_variable_58);
IsZeroMatrix(h_variable_10034);
nrows(h_variable_10033);
def h_variable_10035 = h_variable_9804[8,4];
h_variable_10035;
matrix h_variable_10036[1][1] = 0;
matrix h_variable_10037[1][3] = concat(h_variable_10036,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10037); matrix h_variable_10038 = h_variable_l[1]; matrix h_variable_10039 = h_variable_l[2];
ncols(h_variable_10038);
matrix h_variable_10040 = DecideZeroRows(h_variable_10038,h_variable_58);
IsZeroMatrix(h_variable_10040);
nrows(h_variable_10039);
def h_variable_10041 = h_variable_9804[7,4];
h_variable_10041;
matrix h_variable_10042[1][1] = 0;
matrix h_variable_10043[1][3] = concat(h_variable_10042,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10043); matrix h_variable_10044 = h_variable_l[1]; matrix h_variable_10045 = h_variable_l[2];
ncols(h_variable_10044);
matrix h_variable_10046 = DecideZeroRows(h_variable_10044,h_variable_58);
IsZeroMatrix(h_variable_10046);
nrows(h_variable_10045);
def h_variable_10047 = h_variable_9804[6,4];
h_variable_10047;
matrix h_variable_10048[1][1] = 0;
matrix h_variable_10049[1][3] = concat(h_variable_10048,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10049); matrix h_variable_10050 = h_variable_l[1]; matrix h_variable_10051 = h_variable_l[2];
ncols(h_variable_10050);
matrix h_variable_10052 = DecideZeroRows(h_variable_10050,h_variable_58);
IsZeroMatrix(h_variable_10052);
nrows(h_variable_10051);
def h_variable_10053 = h_variable_9804[5,4];
h_variable_10053;
matrix h_variable_10054[1][1] = 0;
matrix h_variable_10055[1][3] = concat(h_variable_10054,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10055); matrix h_variable_10056 = h_variable_l[1]; matrix h_variable_10057 = h_variable_l[2];
ncols(h_variable_10056);
matrix h_variable_10058 = DecideZeroRows(h_variable_10056,h_variable_58);
IsZeroMatrix(h_variable_10058);
nrows(h_variable_10057);
def h_variable_10059 = h_variable_9804[4,4];
h_variable_10059;
matrix h_variable_10060[1][1] = 0;
matrix h_variable_10061[1][3] = concat(h_variable_10060,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10061); matrix h_variable_10062 = h_variable_l[1]; matrix h_variable_10063 = h_variable_l[2];
ncols(h_variable_10062);
matrix h_variable_10064 = DecideZeroRows(h_variable_10062,h_variable_58);
IsZeroMatrix(h_variable_10064);
nrows(h_variable_10063);
def h_variable_10065 = h_variable_9804[3,4];
h_variable_10065;
matrix h_variable_10066[1][1] = 0;
matrix h_variable_10067[1][3] = concat(h_variable_10066,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10067); matrix h_variable_10068 = h_variable_l[1]; matrix h_variable_10069 = h_variable_l[2];
ncols(h_variable_10068);
matrix h_variable_10070 = DecideZeroRows(h_variable_10068,h_variable_58);
IsZeroMatrix(h_variable_10070);
nrows(h_variable_10069);
def h_variable_10071 = h_variable_9804[2,4];
h_variable_10071;
matrix h_variable_10072[1][1] = a7+1;
matrix h_variable_10073[1][3] = concat(h_variable_10072,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10073); matrix h_variable_10074 = h_variable_l[1]; matrix h_variable_10075 = h_variable_l[2];
ncols(h_variable_10074);
matrix h_variable_10076 = DecideZeroRows(h_variable_10074,h_variable_58);
IsZeroMatrix(h_variable_10076);
ZeroRows(h_variable_10076);
nrows(h_variable_10075);
matrix h_variable_10077[1][4] = concat(h_variable_10074,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10077); matrix h_variable_10078 = h_variable_l[1]; matrix h_variable_10079 = h_variable_l[2];
IsZeroMatrix(h_variable_10078);
matrix h_variable_10080 = DecideZeroRows(h_variable_10078,h_variable_58);
IsZeroMatrix(h_variable_10080);
def h_variable_10081 = h_variable_9804[1,4];
h_variable_10081;
matrix h_variable_10082[1][1] = 0;
matrix h_variable_10083[1][3] = concat(h_variable_10082,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10083); matrix h_variable_10084 = h_variable_l[1]; matrix h_variable_10085 = h_variable_l[2];
ncols(h_variable_10084);
matrix h_variable_10086 = DecideZeroRows(h_variable_10084,h_variable_58);
IsZeroMatrix(h_variable_10086);
nrows(h_variable_10085);
def h_variable_10087 = h_variable_9804[10,5];
h_variable_10087;
matrix h_variable_10088[1][1] = 0;
matrix h_variable_10089[1][3] = concat(h_variable_10088,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10089); matrix h_variable_10090 = h_variable_l[1]; matrix h_variable_10091 = h_variable_l[2];
ncols(h_variable_10090);
matrix h_variable_10092 = DecideZeroRows(h_variable_10090,h_variable_58);
IsZeroMatrix(h_variable_10092);
nrows(h_variable_10091);
def h_variable_10093 = h_variable_9804[9,5];
h_variable_10093;
matrix h_variable_10094[1][1] = 0;
matrix h_variable_10095[1][3] = concat(h_variable_10094,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10095); matrix h_variable_10096 = h_variable_l[1]; matrix h_variable_10097 = h_variable_l[2];
ncols(h_variable_10096);
matrix h_variable_10098 = DecideZeroRows(h_variable_10096,h_variable_58);
IsZeroMatrix(h_variable_10098);
nrows(h_variable_10097);
def h_variable_10099 = h_variable_9804[8,5];
h_variable_10099;
matrix h_variable_10100[1][1] = 0;
matrix h_variable_10101[1][3] = concat(h_variable_10100,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10101); matrix h_variable_10102 = h_variable_l[1]; matrix h_variable_10103 = h_variable_l[2];
ncols(h_variable_10102);
matrix h_variable_10104 = DecideZeroRows(h_variable_10102,h_variable_58);
IsZeroMatrix(h_variable_10104);
nrows(h_variable_10103);
def h_variable_10105 = h_variable_9804[7,5];
h_variable_10105;
matrix h_variable_10106[1][1] = 0;
matrix h_variable_10107[1][3] = concat(h_variable_10106,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10107); matrix h_variable_10108 = h_variable_l[1]; matrix h_variable_10109 = h_variable_l[2];
ncols(h_variable_10108);
matrix h_variable_10110 = DecideZeroRows(h_variable_10108,h_variable_58);
IsZeroMatrix(h_variable_10110);
nrows(h_variable_10109);
def h_variable_10111 = h_variable_9804[6,5];
h_variable_10111;
matrix h_variable_10112[1][1] = 0;
matrix h_variable_10113[1][3] = concat(h_variable_10112,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10113); matrix h_variable_10114 = h_variable_l[1]; matrix h_variable_10115 = h_variable_l[2];
ncols(h_variable_10114);
matrix h_variable_10116 = DecideZeroRows(h_variable_10114,h_variable_58);
IsZeroMatrix(h_variable_10116);
nrows(h_variable_10115);
def h_variable_10117 = h_variable_9804[5,5];
h_variable_10117;
matrix h_variable_10118[1][1] = 2;
matrix h_variable_10119[1][3] = concat(h_variable_10118,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10119); matrix h_variable_10120 = h_variable_l[1]; matrix h_variable_10121 = h_variable_l[2];
ncols(h_variable_10120);
matrix h_variable_10122 = DecideZeroRows(h_variable_10120,h_variable_58);
IsZeroMatrix(h_variable_10122);
ZeroRows(h_variable_10122);
nrows(h_variable_10121);
matrix h_variable_10124 = submat(h_variable_10120,1..1,intvec( 1 ));
matrix h_variable_10123 = DecideZeroRows(h_variable_10124,h_variable_58);
IsZeroMatrix(h_variable_10123);
IsIdentityMatrix(h_variable_10123);
matrix h_variable_10125[1][3] = concat(h_variable_10123,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10125); matrix h_variable_10126 = h_variable_l[1]; matrix h_variable_10127 = h_variable_l[2];
IsZeroMatrix(h_variable_10126);
matrix h_variable_10128 = DecideZeroRows(h_variable_10126,h_variable_58);
IsZeroMatrix(h_variable_10128);
def h_variable_10129 = h_variable_9804[4,5];
h_variable_10129;
matrix h_variable_10130[1][1] = 0;
matrix h_variable_10131[1][3] = concat(h_variable_10130,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10131); matrix h_variable_10132 = h_variable_l[1]; matrix h_variable_10133 = h_variable_l[2];
ncols(h_variable_10132);
matrix h_variable_10134 = DecideZeroRows(h_variable_10132,h_variable_58);
IsZeroMatrix(h_variable_10134);
nrows(h_variable_10133);
def h_variable_10135 = h_variable_9804[3,5];
h_variable_10135;
matrix h_variable_10136[1][1] = 2*a7;
matrix h_variable_10137[1][3] = concat(h_variable_10136,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10137); matrix h_variable_10138 = h_variable_l[1]; matrix h_variable_10139 = h_variable_l[2];
ncols(h_variable_10138);
matrix h_variable_10140 = DecideZeroRows(h_variable_10138,h_variable_58);
IsZeroMatrix(h_variable_10140);
ZeroRows(h_variable_10140);
nrows(h_variable_10139);
matrix h_variable_10142 = submat(h_variable_10138,1..1,intvec( 1 ));
matrix h_variable_10141 = DecideZeroRows(h_variable_10142,h_variable_58);
IsZeroMatrix(h_variable_10141);
IsIdentityMatrix(h_variable_10141);
matrix h_variable_10143[1][3] = concat(h_variable_10141,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10143); matrix h_variable_10144 = h_variable_l[1]; matrix h_variable_10145 = h_variable_l[2];
IsZeroMatrix(h_variable_10144);
matrix h_variable_10146 = DecideZeroRows(h_variable_10144,h_variable_58);
IsZeroMatrix(h_variable_10146);
def h_variable_10147 = h_variable_9804[2,5];
h_variable_10147;
matrix h_variable_10148[1][1] = -x1;
matrix h_variable_10149[1][3] = concat(h_variable_10148,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10149); matrix h_variable_10150 = h_variable_l[1]; matrix h_variable_10151 = h_variable_l[2];
ncols(h_variable_10150);
matrix h_variable_10152 = DecideZeroRows(h_variable_10150,h_variable_58);
IsZeroMatrix(h_variable_10152);
ZeroRows(h_variable_10152);
nrows(h_variable_10151);
matrix h_variable_10154 = submat(h_variable_10150,1..1,intvec( 2 ));
matrix h_variable_10153 = DecideZeroRows(h_variable_10154,h_variable_58);
IsZeroMatrix(h_variable_10153);
IsIdentityMatrix(h_variable_10153);
matrix h_variable_10155[1][3] = concat(h_variable_10153,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10155); matrix h_variable_10156 = h_variable_l[1]; matrix h_variable_10157 = h_variable_l[2];
IsZeroMatrix(h_variable_10156);
matrix h_variable_10158 = DecideZeroRows(h_variable_10156,h_variable_58);
IsZeroMatrix(h_variable_10158);
def h_variable_10159 = h_variable_9804[1,5];
h_variable_10159;
matrix h_variable_10160[1][1] = 0;
matrix h_variable_10161[1][3] = concat(h_variable_10160,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10161); matrix h_variable_10162 = h_variable_l[1]; matrix h_variable_10163 = h_variable_l[2];
ncols(h_variable_10162);
matrix h_variable_10164 = DecideZeroRows(h_variable_10162,h_variable_58);
IsZeroMatrix(h_variable_10164);
nrows(h_variable_10163);
def h_variable_10165 = h_variable_9804[10,6];
h_variable_10165;
matrix h_variable_10166[1][1] = 0;
matrix h_variable_10167[1][3] = concat(h_variable_10166,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10167); matrix h_variable_10168 = h_variable_l[1]; matrix h_variable_10169 = h_variable_l[2];
ncols(h_variable_10168);
matrix h_variable_10170 = DecideZeroRows(h_variable_10168,h_variable_58);
IsZeroMatrix(h_variable_10170);
nrows(h_variable_10169);
def h_variable_10171 = h_variable_9804[9,6];
h_variable_10171;
matrix h_variable_10172[1][1] = 0;
matrix h_variable_10173[1][3] = concat(h_variable_10172,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10173); matrix h_variable_10174 = h_variable_l[1]; matrix h_variable_10175 = h_variable_l[2];
ncols(h_variable_10174);
matrix h_variable_10176 = DecideZeroRows(h_variable_10174,h_variable_58);
IsZeroMatrix(h_variable_10176);
nrows(h_variable_10175);
def h_variable_10177 = h_variable_9804[8,6];
h_variable_10177;
matrix h_variable_10178[1][1] = 0;
matrix h_variable_10179[1][3] = concat(h_variable_10178,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10179); matrix h_variable_10180 = h_variable_l[1]; matrix h_variable_10181 = h_variable_l[2];
ncols(h_variable_10180);
matrix h_variable_10182 = DecideZeroRows(h_variable_10180,h_variable_58);
IsZeroMatrix(h_variable_10182);
nrows(h_variable_10181);
def h_variable_10183 = h_variable_9804[7,6];
h_variable_10183;
matrix h_variable_10184[1][1] = 0;
matrix h_variable_10185[1][3] = concat(h_variable_10184,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10185); matrix h_variable_10186 = h_variable_l[1]; matrix h_variable_10187 = h_variable_l[2];
ncols(h_variable_10186);
matrix h_variable_10188 = DecideZeroRows(h_variable_10186,h_variable_58);
IsZeroMatrix(h_variable_10188);
nrows(h_variable_10187);
def h_variable_10189 = h_variable_9804[6,6];
h_variable_10189;
matrix h_variable_10190[1][1] = 0;
matrix h_variable_10191[1][3] = concat(h_variable_10190,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10191); matrix h_variable_10192 = h_variable_l[1]; matrix h_variable_10193 = h_variable_l[2];
ncols(h_variable_10192);
matrix h_variable_10194 = DecideZeroRows(h_variable_10192,h_variable_58);
IsZeroMatrix(h_variable_10194);
nrows(h_variable_10193);
def h_variable_10195 = h_variable_9804[5,6];
h_variable_10195;
matrix h_variable_10196[1][1] = 1;
matrix h_variable_10197[1][3] = concat(h_variable_10196,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10197); matrix h_variable_10198 = h_variable_l[1]; matrix h_variable_10199 = h_variable_l[2];
ncols(h_variable_10198);
matrix h_variable_10200 = DecideZeroRows(h_variable_10198,h_variable_58);
IsZeroMatrix(h_variable_10200);
nrows(h_variable_10199);
IsIdentityMatrix(h_variable_10200);
def h_variable_10201 = h_variable_9804[1,6];
h_variable_10201;
matrix h_variable_10202[1][1] = 0;
matrix h_variable_10203 = DecideZeroRows(h_variable_10202,h_variable_58);
IsZeroMatrix(h_variable_10203);
def h_variable_10204 = h_variable_10203[1,1];
h_variable_10204==0;
def h_variable_10205 = h_variable_9804[2,6];
h_variable_10205;
matrix h_variable_10206[1][1] = x3;
matrix h_variable_10207 = DecideZeroRows(h_variable_10206,h_variable_58);
IsZeroMatrix(h_variable_10207);
def h_variable_10208 = h_variable_10207[1,1];
h_variable_10208==0;
def h_variable_10209 = h_variable_9804[3,6];
h_variable_10209;
matrix h_variable_10210[1][1] = 2;
matrix h_variable_10211 = DecideZeroRows(h_variable_10210,h_variable_58);
IsZeroMatrix(h_variable_10211);
def h_variable_10212 = h_variable_10211[1,1];
h_variable_10212==0;
def h_variable_10213 = h_variable_9804[4,6];
h_variable_10213;
matrix h_variable_10214[1][1] = a7-5;
matrix h_variable_10215 = DecideZeroRows(h_variable_10214,h_variable_58);
IsZeroMatrix(h_variable_10215);
def h_variable_10216 = h_variable_10215[1,1];
h_variable_10216==0;
def h_variable_10217 = h_variable_9804[5,6];
h_variable_10217;
matrix h_variable_10218[1][1] = 1;
matrix h_variable_10219 = DecideZeroRows(h_variable_10218,h_variable_58);
IsZeroMatrix(h_variable_10219);
def h_variable_10220 = h_variable_10219[1,1];
h_variable_10220==0;
def h_variable_10221 = h_variable_9804[6,6];
h_variable_10221;
matrix h_variable_10222[1][1] = 0;
matrix h_variable_10223 = DecideZeroRows(h_variable_10222,h_variable_58);
IsZeroMatrix(h_variable_10223);
def h_variable_10224 = h_variable_10223[1,1];
h_variable_10224==0;
def h_variable_10225 = h_variable_9804[7,6];
h_variable_10225;
matrix h_variable_10226[1][1] = 0;
matrix h_variable_10227 = DecideZeroRows(h_variable_10226,h_variable_58);
IsZeroMatrix(h_variable_10227);
def h_variable_10228 = h_variable_10227[1,1];
h_variable_10228==0;
def h_variable_10229 = h_variable_9804[8,6];
h_variable_10229;
matrix h_variable_10230[1][1] = 0;
matrix h_variable_10231 = DecideZeroRows(h_variable_10230,h_variable_58);
IsZeroMatrix(h_variable_10231);
def h_variable_10232 = h_variable_10231[1,1];
h_variable_10232==0;
def h_variable_10233 = h_variable_9804[9,6];
h_variable_10233;
matrix h_variable_10234[1][1] = 0;
matrix h_variable_10235 = DecideZeroRows(h_variable_10234,h_variable_58);
IsZeroMatrix(h_variable_10235);
def h_variable_10236 = h_variable_10235[1,1];
h_variable_10236==0;
def h_variable_10237 = h_variable_9804[10,6];
h_variable_10237;
matrix h_variable_10238[1][1] = 0;
matrix h_variable_10239 = DecideZeroRows(h_variable_10238,h_variable_58);
IsZeroMatrix(h_variable_10239);
def h_variable_10240 = h_variable_10239[1,1];
h_variable_10240==0;
def h_variable_10241 = h_variable_9804[10,7];
h_variable_10241;
matrix h_variable_10242[1][1] = 0;
matrix h_variable_10243[1][3] = concat(h_variable_10242,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10243); matrix h_variable_10244 = h_variable_l[1]; matrix h_variable_10245 = h_variable_l[2];
ncols(h_variable_10244);
matrix h_variable_10246 = DecideZeroRows(h_variable_10244,h_variable_58);
IsZeroMatrix(h_variable_10246);
nrows(h_variable_10245);
def h_variable_10247 = h_variable_9804[9,7];
h_variable_10247;
matrix h_variable_10248[1][1] = 0;
matrix h_variable_10249[1][3] = concat(h_variable_10248,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10249); matrix h_variable_10250 = h_variable_l[1]; matrix h_variable_10251 = h_variable_l[2];
ncols(h_variable_10250);
matrix h_variable_10252 = DecideZeroRows(h_variable_10250,h_variable_58);
IsZeroMatrix(h_variable_10252);
nrows(h_variable_10251);
def h_variable_10253 = h_variable_9804[8,7];
h_variable_10253;
matrix h_variable_10254[1][1] = 0;
matrix h_variable_10255[1][3] = concat(h_variable_10254,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10255); matrix h_variable_10256 = h_variable_l[1]; matrix h_variable_10257 = h_variable_l[2];
ncols(h_variable_10256);
matrix h_variable_10258 = DecideZeroRows(h_variable_10256,h_variable_58);
IsZeroMatrix(h_variable_10258);
nrows(h_variable_10257);
def h_variable_10259 = h_variable_9804[7,7];
h_variable_10259;
matrix h_variable_10260[1][1] = 0;
matrix h_variable_10261[1][3] = concat(h_variable_10260,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10261); matrix h_variable_10262 = h_variable_l[1]; matrix h_variable_10263 = h_variable_l[2];
ncols(h_variable_10262);
matrix h_variable_10264 = DecideZeroRows(h_variable_10262,h_variable_58);
IsZeroMatrix(h_variable_10264);
nrows(h_variable_10263);
def h_variable_10265 = h_variable_9804[6,7];
h_variable_10265;
matrix h_variable_10266[1][1] = 0;
matrix h_variable_10267[1][3] = concat(h_variable_10266,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10267); matrix h_variable_10268 = h_variable_l[1]; matrix h_variable_10269 = h_variable_l[2];
ncols(h_variable_10268);
matrix h_variable_10270 = DecideZeroRows(h_variable_10268,h_variable_58);
IsZeroMatrix(h_variable_10270);
nrows(h_variable_10269);
def h_variable_10271 = h_variable_9804[1,7];
h_variable_10271;
matrix h_variable_10272[1][1] = 0;
matrix h_variable_10273[1][3] = concat(h_variable_10272,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10273); matrix h_variable_10274 = h_variable_l[1]; matrix h_variable_10275 = h_variable_l[2];
ncols(h_variable_10274);
matrix h_variable_10276 = DecideZeroRows(h_variable_10274,h_variable_58);
IsZeroMatrix(h_variable_10276);
nrows(h_variable_10275);
def h_variable_10277 = h_variable_9804[10,8];
h_variable_10277;
matrix h_variable_10278[1][1] = 0;
matrix h_variable_10279[1][3] = concat(h_variable_10278,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10279); matrix h_variable_10280 = h_variable_l[1]; matrix h_variable_10281 = h_variable_l[2];
ncols(h_variable_10280);
matrix h_variable_10282 = DecideZeroRows(h_variable_10280,h_variable_58);
IsZeroMatrix(h_variable_10282);
nrows(h_variable_10281);
def h_variable_10283 = h_variable_9804[9,8];
h_variable_10283;
matrix h_variable_10284[1][1] = 0;
matrix h_variable_10285[1][3] = concat(h_variable_10284,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10285); matrix h_variable_10286 = h_variable_l[1]; matrix h_variable_10287 = h_variable_l[2];
ncols(h_variable_10286);
matrix h_variable_10288 = DecideZeroRows(h_variable_10286,h_variable_58);
IsZeroMatrix(h_variable_10288);
nrows(h_variable_10287);
def h_variable_10289 = h_variable_9804[8,8];
h_variable_10289;
matrix h_variable_10290[1][1] = 0;
matrix h_variable_10291[1][3] = concat(h_variable_10290,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10291); matrix h_variable_10292 = h_variable_l[1]; matrix h_variable_10293 = h_variable_l[2];
ncols(h_variable_10292);
matrix h_variable_10294 = DecideZeroRows(h_variable_10292,h_variable_58);
IsZeroMatrix(h_variable_10294);
nrows(h_variable_10293);
def h_variable_10295 = h_variable_9804[7,8];
h_variable_10295;
matrix h_variable_10296[1][1] = 0;
matrix h_variable_10297[1][3] = concat(h_variable_10296,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10297); matrix h_variable_10298 = h_variable_l[1]; matrix h_variable_10299 = h_variable_l[2];
ncols(h_variable_10298);
matrix h_variable_10300 = DecideZeroRows(h_variable_10298,h_variable_58);
IsZeroMatrix(h_variable_10300);
nrows(h_variable_10299);
def h_variable_10301 = h_variable_9804[6,8];
h_variable_10301;
matrix h_variable_10302[1][1] = 0;
matrix h_variable_10303[1][3] = concat(h_variable_10302,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10303); matrix h_variable_10304 = h_variable_l[1]; matrix h_variable_10305 = h_variable_l[2];
ncols(h_variable_10304);
matrix h_variable_10306 = DecideZeroRows(h_variable_10304,h_variable_58);
IsZeroMatrix(h_variable_10306);
nrows(h_variable_10305);
def h_variable_10307 = h_variable_9804[1,8];
h_variable_10307;
matrix h_variable_10308[1][1] = 0;
matrix h_variable_10309[1][3] = concat(h_variable_10308,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10309); matrix h_variable_10310 = h_variable_l[1]; matrix h_variable_10311 = h_variable_l[2];
ncols(h_variable_10310);
matrix h_variable_10312 = DecideZeroRows(h_variable_10310,h_variable_58);
IsZeroMatrix(h_variable_10312);
nrows(h_variable_10311);
def h_variable_10313 = h_variable_9804[10,9];
h_variable_10313;
matrix h_variable_10314[1][1] = 0;
matrix h_variable_10315[1][3] = concat(h_variable_10314,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10315); matrix h_variable_10316 = h_variable_l[1]; matrix h_variable_10317 = h_variable_l[2];
ncols(h_variable_10316);
matrix h_variable_10318 = DecideZeroRows(h_variable_10316,h_variable_58);
IsZeroMatrix(h_variable_10318);
nrows(h_variable_10317);
def h_variable_10319 = h_variable_9804[9,9];
h_variable_10319;
matrix h_variable_10320[1][1] = 0;
matrix h_variable_10321[1][3] = concat(h_variable_10320,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10321); matrix h_variable_10322 = h_variable_l[1]; matrix h_variable_10323 = h_variable_l[2];
ncols(h_variable_10322);
matrix h_variable_10324 = DecideZeroRows(h_variable_10322,h_variable_58);
IsZeroMatrix(h_variable_10324);
nrows(h_variable_10323);
def h_variable_10325 = h_variable_9804[8,9];
h_variable_10325;
matrix h_variable_10326[1][1] = 0;
matrix h_variable_10327[1][3] = concat(h_variable_10326,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10327); matrix h_variable_10328 = h_variable_l[1]; matrix h_variable_10329 = h_variable_l[2];
ncols(h_variable_10328);
matrix h_variable_10330 = DecideZeroRows(h_variable_10328,h_variable_58);
IsZeroMatrix(h_variable_10330);
nrows(h_variable_10329);
def h_variable_10331 = h_variable_9804[7,9];
h_variable_10331;
matrix h_variable_10332[1][1] = 3;
matrix h_variable_10333[1][3] = concat(h_variable_10332,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10333); matrix h_variable_10334 = h_variable_l[1]; matrix h_variable_10335 = h_variable_l[2];
ncols(h_variable_10334);
matrix h_variable_10336 = DecideZeroRows(h_variable_10334,h_variable_58);
IsZeroMatrix(h_variable_10336);
ZeroRows(h_variable_10336);
nrows(h_variable_10335);
matrix h_variable_10338 = submat(h_variable_10334,1..1,intvec( 1 ));
matrix h_variable_10337 = DecideZeroRows(h_variable_10338,h_variable_58);
IsZeroMatrix(h_variable_10337);
IsIdentityMatrix(h_variable_10337);
matrix h_variable_10339[1][3] = concat(h_variable_10337,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10339); matrix h_variable_10340 = h_variable_l[1]; matrix h_variable_10341 = h_variable_l[2];
IsZeroMatrix(h_variable_10340);
matrix h_variable_10342 = DecideZeroRows(h_variable_10340,h_variable_58);
IsZeroMatrix(h_variable_10342);
def h_variable_10343 = h_variable_9804[6,9];
h_variable_10343;
matrix h_variable_10344[1][1] = -3*x3;
matrix h_variable_10345[1][3] = concat(h_variable_10344,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10345); matrix h_variable_10346 = h_variable_l[1]; matrix h_variable_10347 = h_variable_l[2];
ncols(h_variable_10346);
matrix h_variable_10348 = DecideZeroRows(h_variable_10346,h_variable_58);
IsZeroMatrix(h_variable_10348);
ZeroRows(h_variable_10348);
nrows(h_variable_10347);
matrix h_variable_10350 = submat(h_variable_10346,1..1,intvec( 2 ));
matrix h_variable_10349 = DecideZeroRows(h_variable_10350,h_variable_58);
IsZeroMatrix(h_variable_10349);
IsIdentityMatrix(h_variable_10349);
matrix h_variable_10351[1][3] = concat(h_variable_10349,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10351); matrix h_variable_10352 = h_variable_l[1]; matrix h_variable_10353 = h_variable_l[2];
IsZeroMatrix(h_variable_10352);
matrix h_variable_10354 = DecideZeroRows(h_variable_10352,h_variable_58);
IsZeroMatrix(h_variable_10354);
def h_variable_10355 = h_variable_9804[1,9];
h_variable_10355;
matrix h_variable_10356[1][1] = 0;
matrix h_variable_10357[1][3] = concat(h_variable_10356,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10357); matrix h_variable_10358 = h_variable_l[1]; matrix h_variable_10359 = h_variable_l[2];
ncols(h_variable_10358);
matrix h_variable_10360 = DecideZeroRows(h_variable_10358,h_variable_58);
IsZeroMatrix(h_variable_10360);
nrows(h_variable_10359);
def h_variable_10361 = h_variable_9804[10,10];
h_variable_10361;
matrix h_variable_10362[1][1] = 0;
matrix h_variable_10363[1][3] = concat(h_variable_10362,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10363); matrix h_variable_10364 = h_variable_l[1]; matrix h_variable_10365 = h_variable_l[2];
ncols(h_variable_10364);
matrix h_variable_10366 = DecideZeroRows(h_variable_10364,h_variable_58);
IsZeroMatrix(h_variable_10366);
nrows(h_variable_10365);
def h_variable_10367 = h_variable_9804[9,10];
h_variable_10367;
matrix h_variable_10368[1][1] = 0;
matrix h_variable_10369[1][3] = concat(h_variable_10368,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10369); matrix h_variable_10370 = h_variable_l[1]; matrix h_variable_10371 = h_variable_l[2];
ncols(h_variable_10370);
matrix h_variable_10372 = DecideZeroRows(h_variable_10370,h_variable_58);
IsZeroMatrix(h_variable_10372);
nrows(h_variable_10371);
def h_variable_10373 = h_variable_9804[8,10];
h_variable_10373;
matrix h_variable_10374[1][1] = 0;
matrix h_variable_10375[1][3] = concat(h_variable_10374,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10375); matrix h_variable_10376 = h_variable_l[1]; matrix h_variable_10377 = h_variable_l[2];
ncols(h_variable_10376);
matrix h_variable_10378 = DecideZeroRows(h_variable_10376,h_variable_58);
IsZeroMatrix(h_variable_10378);
nrows(h_variable_10377);
def h_variable_10379 = h_variable_9804[7,10];
h_variable_10379;
matrix h_variable_10380[1][1] = 3*x1+3*x2;
matrix h_variable_10381[1][3] = concat(h_variable_10380,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10381); matrix h_variable_10382 = h_variable_l[1]; matrix h_variable_10383 = h_variable_l[2];
ncols(h_variable_10382);
matrix h_variable_10384 = DecideZeroRows(h_variable_10382,h_variable_58);
IsZeroMatrix(h_variable_10384);
ZeroRows(h_variable_10384);
nrows(h_variable_10383);
matrix h_variable_10386 = submat(h_variable_10382,1..1,intvec( 2 ));
matrix h_variable_10385 = DecideZeroRows(h_variable_10386,h_variable_58);
IsZeroMatrix(h_variable_10385);
IsIdentityMatrix(h_variable_10385);
matrix h_variable_10387[1][3] = concat(h_variable_10385,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10387); matrix h_variable_10388 = h_variable_l[1]; matrix h_variable_10389 = h_variable_l[2];
IsZeroMatrix(h_variable_10388);
matrix h_variable_10390 = DecideZeroRows(h_variable_10388,h_variable_58);
IsZeroMatrix(h_variable_10390);
def h_variable_10391 = h_variable_9804[6,10];
h_variable_10391;
matrix h_variable_10392[1][1] = 3*x2^2-3*x1*x3-3*x2*x3+3*x3^2;
matrix h_variable_10393[1][3] = concat(h_variable_10392,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10393); matrix h_variable_10394 = h_variable_l[1]; matrix h_variable_10395 = h_variable_l[2];
ncols(h_variable_10394);
matrix h_variable_10396 = DecideZeroRows(h_variable_10394,h_variable_58);
IsZeroMatrix(h_variable_10396);
ZeroRows(h_variable_10396);
nrows(h_variable_10395);
matrix h_variable_10398 = submat(h_variable_10394,1..1,intvec( 2 ));
matrix h_variable_10397 = DecideZeroRows(h_variable_10398,h_variable_58);
IsZeroMatrix(h_variable_10397);
IsIdentityMatrix(h_variable_10397);
matrix h_variable_10399[1][3] = concat(h_variable_10397,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10399); matrix h_variable_10400 = h_variable_l[1]; matrix h_variable_10401 = h_variable_l[2];
IsZeroMatrix(h_variable_10400);
matrix h_variable_10402 = DecideZeroRows(h_variable_10400,h_variable_58);
IsZeroMatrix(h_variable_10402);
def h_variable_10403 = h_variable_9804[1,10];
h_variable_10403;
matrix h_variable_10404[1][1] = 0;
matrix h_variable_10405[1][3] = concat(h_variable_10404,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10405); matrix h_variable_10406 = h_variable_l[1]; matrix h_variable_10407 = h_variable_l[2];
ncols(h_variable_10406);
matrix h_variable_10408 = DecideZeroRows(h_variable_10406,h_variable_58);
IsZeroMatrix(h_variable_10408);
nrows(h_variable_10407);
def h_variable_10409 = h_variable_9804[10,11];
h_variable_10409;
matrix h_variable_10410[1][1] = 0;
matrix h_variable_10411[1][3] = concat(h_variable_10410,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10411); matrix h_variable_10412 = h_variable_l[1]; matrix h_variable_10413 = h_variable_l[2];
ncols(h_variable_10412);
matrix h_variable_10414 = DecideZeroRows(h_variable_10412,h_variable_58);
IsZeroMatrix(h_variable_10414);
nrows(h_variable_10413);
def h_variable_10415 = h_variable_9804[9,11];
h_variable_10415;
matrix h_variable_10416[1][1] = 0;
matrix h_variable_10417[1][3] = concat(h_variable_10416,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10417); matrix h_variable_10418 = h_variable_l[1]; matrix h_variable_10419 = h_variable_l[2];
ncols(h_variable_10418);
matrix h_variable_10420 = DecideZeroRows(h_variable_10418,h_variable_58);
IsZeroMatrix(h_variable_10420);
nrows(h_variable_10419);
def h_variable_10421 = h_variable_9804[8,11];
h_variable_10421;
matrix h_variable_10422[1][1] = 0;
matrix h_variable_10423[1][3] = concat(h_variable_10422,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10423); matrix h_variable_10424 = h_variable_l[1]; matrix h_variable_10425 = h_variable_l[2];
ncols(h_variable_10424);
matrix h_variable_10426 = DecideZeroRows(h_variable_10424,h_variable_58);
IsZeroMatrix(h_variable_10426);
nrows(h_variable_10425);
def h_variable_10427 = h_variable_9804[7,11];
h_variable_10427;
matrix h_variable_10428[1][1] = 0;
matrix h_variable_10429[1][3] = concat(h_variable_10428,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10429); matrix h_variable_10430 = h_variable_l[1]; matrix h_variable_10431 = h_variable_l[2];
ncols(h_variable_10430);
matrix h_variable_10432 = DecideZeroRows(h_variable_10430,h_variable_58);
IsZeroMatrix(h_variable_10432);
nrows(h_variable_10431);
def h_variable_10433 = h_variable_9804[6,11];
h_variable_10433;
matrix h_variable_10434[1][1] = 0;
matrix h_variable_10435[1][3] = concat(h_variable_10434,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10435); matrix h_variable_10436 = h_variable_l[1]; matrix h_variable_10437 = h_variable_l[2];
ncols(h_variable_10436);
matrix h_variable_10438 = DecideZeroRows(h_variable_10436,h_variable_58);
IsZeroMatrix(h_variable_10438);
nrows(h_variable_10437);
def h_variable_10439 = h_variable_9804[1,11];
h_variable_10439;
matrix h_variable_10440[1][1] = 0;
matrix h_variable_10441[1][3] = concat(h_variable_10440,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10441); matrix h_variable_10442 = h_variable_l[1]; matrix h_variable_10443 = h_variable_l[2];
ncols(h_variable_10442);
matrix h_variable_10444 = DecideZeroRows(h_variable_10442,h_variable_58);
IsZeroMatrix(h_variable_10444);
nrows(h_variable_10443);
def h_variable_10445 = h_variable_9804[10,12];
h_variable_10445;
matrix h_variable_10446[1][1] = 0;
matrix h_variable_10447[1][3] = concat(h_variable_10446,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10447); matrix h_variable_10448 = h_variable_l[1]; matrix h_variable_10449 = h_variable_l[2];
ncols(h_variable_10448);
matrix h_variable_10450 = DecideZeroRows(h_variable_10448,h_variable_58);
IsZeroMatrix(h_variable_10450);
nrows(h_variable_10449);
def h_variable_10451 = h_variable_9804[9,12];
h_variable_10451;
matrix h_variable_10452[1][1] = -3;
matrix h_variable_10453[1][3] = concat(h_variable_10452,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10453); matrix h_variable_10454 = h_variable_l[1]; matrix h_variable_10455 = h_variable_l[2];
ncols(h_variable_10454);
matrix h_variable_10456 = DecideZeroRows(h_variable_10454,h_variable_58);
IsZeroMatrix(h_variable_10456);
ZeroRows(h_variable_10456);
nrows(h_variable_10455);
matrix h_variable_10458 = submat(h_variable_10454,1..1,intvec( 1 ));
matrix h_variable_10457 = DecideZeroRows(h_variable_10458,h_variable_58);
IsZeroMatrix(h_variable_10457);
IsIdentityMatrix(h_variable_10457);
matrix h_variable_10459[1][3] = concat(h_variable_10457,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10459); matrix h_variable_10460 = h_variable_l[1]; matrix h_variable_10461 = h_variable_l[2];
IsZeroMatrix(h_variable_10460);
matrix h_variable_10462 = DecideZeroRows(h_variable_10460,h_variable_58);
IsZeroMatrix(h_variable_10462);
def h_variable_10463 = h_variable_9804[8,12];
h_variable_10463;
matrix h_variable_10464[1][1] = 0;
matrix h_variable_10465[1][3] = concat(h_variable_10464,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10465); matrix h_variable_10466 = h_variable_l[1]; matrix h_variable_10467 = h_variable_l[2];
ncols(h_variable_10466);
matrix h_variable_10468 = DecideZeroRows(h_variable_10466,h_variable_58);
IsZeroMatrix(h_variable_10468);
nrows(h_variable_10467);
def h_variable_10469 = h_variable_9804[7,12];
h_variable_10469;
matrix h_variable_10470[1][1] = 3*x3;
matrix h_variable_10471[1][3] = concat(h_variable_10470,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10471); matrix h_variable_10472 = h_variable_l[1]; matrix h_variable_10473 = h_variable_l[2];
ncols(h_variable_10472);
matrix h_variable_10474 = DecideZeroRows(h_variable_10472,h_variable_58);
IsZeroMatrix(h_variable_10474);
ZeroRows(h_variable_10474);
nrows(h_variable_10473);
matrix h_variable_10476 = submat(h_variable_10472,1..1,intvec( 2 ));
matrix h_variable_10475 = DecideZeroRows(h_variable_10476,h_variable_58);
IsZeroMatrix(h_variable_10475);
IsIdentityMatrix(h_variable_10475);
matrix h_variable_10477[1][3] = concat(h_variable_10475,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10477); matrix h_variable_10478 = h_variable_l[1]; matrix h_variable_10479 = h_variable_l[2];
IsZeroMatrix(h_variable_10478);
matrix h_variable_10480 = DecideZeroRows(h_variable_10478,h_variable_58);
IsZeroMatrix(h_variable_10480);
def h_variable_10481 = h_variable_9804[6,12];
h_variable_10481;
matrix h_variable_10482[1][1] = 3*x1*x2+3*x1*x3+3*x2*x3-3*x3^2;
matrix h_variable_10483[1][3] = concat(h_variable_10482,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10483); matrix h_variable_10484 = h_variable_l[1]; matrix h_variable_10485 = h_variable_l[2];
ncols(h_variable_10484);
matrix h_variable_10486 = DecideZeroRows(h_variable_10484,h_variable_58);
IsZeroMatrix(h_variable_10486);
ZeroRows(h_variable_10486);
nrows(h_variable_10485);
matrix h_variable_10488 = submat(h_variable_10484,1..1,intvec( 2 ));
matrix h_variable_10487 = DecideZeroRows(h_variable_10488,h_variable_58);
IsZeroMatrix(h_variable_10487);
IsIdentityMatrix(h_variable_10487);
matrix h_variable_10489[1][3] = concat(h_variable_10487,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10489); matrix h_variable_10490 = h_variable_l[1]; matrix h_variable_10491 = h_variable_l[2];
IsZeroMatrix(h_variable_10490);
matrix h_variable_10492 = DecideZeroRows(h_variable_10490,h_variable_58);
IsZeroMatrix(h_variable_10492);
def h_variable_10493 = h_variable_9804[1,12];
h_variable_10493;
matrix h_variable_10494[1][1] = 0;
matrix h_variable_10495[1][3] = concat(h_variable_10494,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10495); matrix h_variable_10496 = h_variable_l[1]; matrix h_variable_10497 = h_variable_l[2];
ncols(h_variable_10496);
matrix h_variable_10498 = DecideZeroRows(h_variable_10496,h_variable_58);
IsZeroMatrix(h_variable_10498);
nrows(h_variable_10497);
def h_variable_10499 = h_variable_9804[10,13];
h_variable_10499;
matrix h_variable_10500[1][1] = 0;
kill h_variable_9974;kill h_variable_9976;kill h_variable_9977;kill h_variable_9978;kill h_variable_9979;kill h_variable_9980;kill h_variable_9982;kill h_variable_9986;kill h_variable_9988;kill h_variable_9989;kill h_variable_9990;kill h_variable_9991;kill h_variable_9992;kill h_variable_9993;kill h_variable_9994;kill h_variable_9995;kill h_variable_9996;kill h_variable_9997;kill h_variable_9998;kill h_variable_9999;kill h_variable_10000;kill h_variable_10001;kill h_variable_10002;kill h_variable_10003;kill h_variable_10004;kill h_variable_10005;kill h_variable_10006;kill h_variable_10007;kill h_variable_10008;kill h_variable_10009;kill h_variable_10010;kill h_variable_10011;kill h_variable_10012;kill h_variable_10013;kill h_variable_10014;kill h_variable_10015;kill h_variable_10016;kill h_variable_10017;kill h_variable_10018;kill h_variable_10019;kill h_variable_10020;kill h_variable_10021;kill h_variable_10022;kill h_variable_10023;kill h_variable_10024;kill h_variable_10025;kill h_variable_10026;kill h_variable_10027;kill h_variable_10028;kill h_variable_10029;kill h_variable_10030;kill h_variable_10031;kill h_variable_10032;kill h_variable_10033;kill h_variable_10034;kill h_variable_10035;kill h_variable_10036;kill h_variable_10037;kill h_variable_10038;kill h_variable_10039;kill h_variable_10040;kill h_variable_10041;kill h_variable_10042;kill h_variable_10043;kill h_variable_10044;kill h_variable_10045;kill h_variable_10046;kill h_variable_10055;kill h_variable_10056;kill h_variable_10057;kill h_variable_10058;kill h_variable_10060;kill h_variable_10061;kill h_variable_10062;kill h_variable_10063;kill h_variable_10064;kill h_variable_10066;kill h_variable_10067;kill h_variable_10068;kill h_variable_10069;kill h_variable_10070;kill h_variable_10071;kill h_variable_10072;kill h_variable_10073;kill h_variable_10074;kill h_variable_10075;kill h_variable_10076;kill h_variable_10077;kill h_variable_10078;kill h_variable_10079;kill h_variable_10080;kill h_variable_10081;kill h_variable_10082;kill h_variable_10083;kill h_variable_10084;kill h_variable_10085;kill h_variable_10086;kill h_variable_10087;kill h_variable_10088;kill h_variable_10089;kill h_variable_10090;kill h_variable_10091;kill h_variable_10092;kill h_variable_10093;kill h_variable_10094;kill h_variable_10095;kill h_variable_10096;kill h_variable_10097;kill h_variable_10098;kill h_variable_10099;kill h_variable_10100;kill h_variable_10101;kill h_variable_10102;kill h_variable_10103;kill h_variable_10104;kill h_variable_10105;kill h_variable_10106;kill h_variable_10107;kill h_variable_10108;kill h_variable_10109;kill h_variable_10110;kill h_variable_10111;kill h_variable_10112;kill h_variable_10113;kill h_variable_10114;kill h_variable_10115;kill h_variable_10116;kill h_variable_10117;kill h_variable_10118;kill h_variable_10119;kill h_variable_10120;kill h_variable_10121;kill h_variable_10122;kill h_variable_10123;kill h_variable_10124;kill h_variable_10125;kill h_variable_10126;kill h_variable_10127;kill h_variable_10128;kill h_variable_10129;kill h_variable_10130;kill h_variable_10131;kill h_variable_10132;kill h_variable_10133;kill h_variable_10134;kill h_variable_10135;kill h_variable_10136;kill h_variable_10137;kill h_variable_10138;kill h_variable_10139;kill h_variable_10140;kill h_variable_10141;kill h_variable_10142;kill h_variable_10143;kill h_variable_10144;kill h_variable_10145;kill h_variable_10146;kill h_variable_10147;kill h_variable_10148;kill h_variable_10149;kill h_variable_10150;kill h_variable_10151;kill h_variable_10152;kill h_variable_10153;kill h_variable_10154;kill h_variable_10155;kill h_variable_10156;kill h_variable_10157;kill h_variable_10158;kill h_variable_10159;kill h_variable_10160;kill h_variable_10161;kill h_variable_10162;kill h_variable_10163;kill h_variable_10164;kill h_variable_10165;kill h_variable_10166;kill h_variable_10167;kill h_variable_10168;kill h_variable_10169;kill h_variable_10170;kill h_variable_10171;kill h_variable_10172;kill h_variable_10173;kill h_variable_10174;kill h_variable_10175;kill h_variable_10176;kill h_variable_10177;kill h_variable_10178;kill h_variable_10179;kill h_variable_10180;kill h_variable_10181;kill h_variable_10182;kill h_variable_10183;kill h_variable_10184;kill h_variable_10185;kill h_variable_10186;kill h_variable_10187;kill h_variable_10188;kill h_variable_10189;kill h_variable_10190;kill h_variable_10191;kill h_variable_10192;kill h_variable_10193;kill h_variable_10194;kill h_variable_10195;kill h_variable_10196;kill h_variable_10197;kill h_variable_10198;kill h_variable_10199;kill h_variable_10200;kill h_variable_10201;kill h_variable_10202;kill h_variable_10203;kill h_variable_10204;kill h_variable_10205;kill h_variable_10206;kill h_variable_10207;kill h_variable_10208;kill h_variable_10209;kill h_variable_10210;kill h_variable_10211;kill h_variable_10212;kill h_variable_10213;kill h_variable_10214;kill h_variable_10215;kill h_variable_10216;kill h_variable_10217;kill h_variable_10218;kill h_variable_10219;kill h_variable_10220;kill h_variable_10230;kill h_variable_10231;kill h_variable_10232;kill h_variable_10233;kill h_variable_10234;kill h_variable_10235;kill h_variable_10236;kill h_variable_10237;kill h_variable_10238;kill h_variable_10239;kill h_variable_10240;kill h_variable_10241;kill h_variable_10242;kill h_variable_10243;kill h_variable_10244;kill h_variable_10245;kill h_variable_10246;kill h_variable_10247;kill h_variable_10248;kill h_variable_10249;kill h_variable_10250;kill h_variable_10251;kill h_variable_10252;kill h_variable_10253;kill h_variable_10254;kill h_variable_10255;kill h_variable_10256;kill h_variable_10257;kill h_variable_10258;kill h_variable_10259;kill h_variable_10260;kill h_variable_10261;kill h_variable_10262;kill h_variable_10263;kill h_variable_10264;kill h_variable_10265;kill h_variable_10266;kill h_variable_10267;kill h_variable_10268;kill h_variable_10269;kill h_variable_10270;kill h_variable_10271;kill h_variable_10272;kill h_variable_10273;kill h_variable_10274;kill h_variable_10275;kill h_variable_10276;kill h_variable_10277;kill h_variable_10278;kill h_variable_10279;kill h_variable_10280;kill h_variable_10281;kill h_variable_10282;kill h_variable_10283;kill h_variable_10284;kill h_variable_10285;kill h_variable_10286;kill h_variable_10287;kill h_variable_10288;kill h_variable_10289;kill h_variable_10290;kill h_variable_10291;kill h_variable_10292;kill h_variable_10293;kill h_variable_10294;kill h_variable_10295;kill h_variable_10296;kill h_variable_10297;kill h_variable_10298;kill h_variable_10299;kill h_variable_10300;kill h_variable_10301;kill h_variable_10302;kill h_variable_10303;kill h_variable_10304;kill h_variable_10305;kill h_variable_10306;kill h_variable_10307;kill h_variable_10308;kill h_variable_10309;kill h_variable_10310;kill h_variable_10311;kill h_variable_10312;kill h_variable_10313;kill h_variable_10314;kill h_variable_10315;kill h_variable_10316;kill h_variable_10317;kill h_variable_10318;kill h_variable_10319;kill h_variable_10320;kill h_variable_10321;kill h_variable_10322;kill h_variable_10323;kill h_variable_10324;kill h_variable_10325;kill h_variable_10326;kill h_variable_10327;kill h_variable_10328;kill h_variable_10329;kill h_variable_10330;kill h_variable_10331;kill h_variable_10332;kill h_variable_10333;kill h_variable_10334;kill h_variable_10335;kill h_variable_10336;kill h_variable_10337;kill h_variable_10338;kill h_variable_10339;kill h_variable_10340;kill h_variable_10341;kill h_variable_10342;kill h_variable_10343;kill h_variable_10344;kill h_variable_10345;kill h_variable_10346;kill h_variable_10347;kill h_variable_10348;kill h_variable_10349;kill h_variable_10350;kill h_variable_10351;kill h_variable_10352;kill h_variable_10353;kill h_variable_10354;kill h_variable_10355;kill h_variable_10356;kill h_variable_10357;kill h_variable_10358;kill h_variable_10359;kill h_variable_10360;kill h_variable_10361;kill h_variable_10362;kill h_variable_10363;kill h_variable_10364;kill h_variable_10365;kill h_variable_10366;kill h_variable_10367;kill h_variable_10368;kill h_variable_10369;kill h_variable_10370;kill h_variable_10371;kill h_variable_10372;kill h_variable_10373;kill h_variable_10374;kill h_variable_10375;kill h_variable_10376;kill h_variable_10377;kill h_variable_10378;kill h_variable_10379;kill h_variable_10380;kill h_variable_10381;kill h_variable_10382;kill h_variable_10383;kill h_variable_10384;kill h_variable_10385;kill h_variable_10386;kill h_variable_10387;kill h_variable_10388;kill h_variable_10389;kill h_variable_10390;
matrix h_variable_10501[1][3] = concat(h_variable_10500,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10501); matrix h_variable_10502 = h_variable_l[1]; matrix h_variable_10503 = h_variable_l[2];
ncols(h_variable_10502);
matrix h_variable_10504 = DecideZeroRows(h_variable_10502,h_variable_58);
IsZeroMatrix(h_variable_10504);
nrows(h_variable_10503);
def h_variable_10505 = h_variable_9804[9,13];
h_variable_10505;
matrix h_variable_10506[1][1] = 0;
matrix h_variable_10507[1][3] = concat(h_variable_10506,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10507); matrix h_variable_10508 = h_variable_l[1]; matrix h_variable_10509 = h_variable_l[2];
ncols(h_variable_10508);
matrix h_variable_10510 = DecideZeroRows(h_variable_10508,h_variable_58);
IsZeroMatrix(h_variable_10510);
nrows(h_variable_10509);
def h_variable_10511 = h_variable_9804[8,13];
h_variable_10511;
matrix h_variable_10512[1][1] = 0;
matrix h_variable_10513[1][3] = concat(h_variable_10512,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10513); matrix h_variable_10514 = h_variable_l[1]; matrix h_variable_10515 = h_variable_l[2];
ncols(h_variable_10514);
matrix h_variable_10516 = DecideZeroRows(h_variable_10514,h_variable_58);
IsZeroMatrix(h_variable_10516);
nrows(h_variable_10515);
def h_variable_10517 = h_variable_9804[7,13];
h_variable_10517;
matrix h_variable_10518[1][1] = 0;
matrix h_variable_10519[1][3] = concat(h_variable_10518,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10519); matrix h_variable_10520 = h_variable_l[1]; matrix h_variable_10521 = h_variable_l[2];
ncols(h_variable_10520);
matrix h_variable_10522 = DecideZeroRows(h_variable_10520,h_variable_58);
IsZeroMatrix(h_variable_10522);
nrows(h_variable_10521);
def h_variable_10523 = h_variable_9804[6,13];
h_variable_10523;
matrix h_variable_10524[1][1] = 2*a7-1;
matrix h_variable_10525[1][3] = concat(h_variable_10524,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10525); matrix h_variable_10526 = h_variable_l[1]; matrix h_variable_10527 = h_variable_l[2];
ncols(h_variable_10526);
matrix h_variable_10528 = DecideZeroRows(h_variable_10526,h_variable_58);
IsZeroMatrix(h_variable_10528);
ZeroRows(h_variable_10528);
nrows(h_variable_10527);
matrix h_variable_10529[1][4] = concat(h_variable_10526,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10529); matrix h_variable_10530 = h_variable_l[1]; matrix h_variable_10531 = h_variable_l[2];
IsZeroMatrix(h_variable_10530);
matrix h_variable_10532 = DecideZeroRows(h_variable_10530,h_variable_58);
IsZeroMatrix(h_variable_10532);
def h_variable_10533 = h_variable_9804[1,13];
h_variable_10533;
matrix h_variable_10534[1][1] = 0;
matrix h_variable_10535[1][3] = concat(h_variable_10534,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10535); matrix h_variable_10536 = h_variable_l[1]; matrix h_variable_10537 = h_variable_l[2];
ncols(h_variable_10536);
matrix h_variable_10538 = DecideZeroRows(h_variable_10536,h_variable_58);
IsZeroMatrix(h_variable_10538);
nrows(h_variable_10537);
def h_variable_10539 = h_variable_9804[10,14];
h_variable_10539;
matrix h_variable_10540[1][1] = 0;
matrix h_variable_10541[1][3] = concat(h_variable_10540,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10541); matrix h_variable_10542 = h_variable_l[1]; matrix h_variable_10543 = h_variable_l[2];
ncols(h_variable_10542);
matrix h_variable_10544 = DecideZeroRows(h_variable_10542,h_variable_58);
IsZeroMatrix(h_variable_10544);
nrows(h_variable_10543);
def h_variable_10545 = h_variable_9804[9,14];
h_variable_10545;
matrix h_variable_10546[1][1] = 0;
matrix h_variable_10547[1][3] = concat(h_variable_10546,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10547); matrix h_variable_10548 = h_variable_l[1]; matrix h_variable_10549 = h_variable_l[2];
ncols(h_variable_10548);
matrix h_variable_10550 = DecideZeroRows(h_variable_10548,h_variable_58);
IsZeroMatrix(h_variable_10550);
nrows(h_variable_10549);
def h_variable_10551 = h_variable_9804[8,14];
h_variable_10551;
matrix h_variable_10552[1][1] = -2*a7+4;
matrix h_variable_10553[1][3] = concat(h_variable_10552,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10553); matrix h_variable_10554 = h_variable_l[1]; matrix h_variable_10555 = h_variable_l[2];
ncols(h_variable_10554);
matrix h_variable_10556 = DecideZeroRows(h_variable_10554,h_variable_58);
IsZeroMatrix(h_variable_10556);
ZeroRows(h_variable_10556);
nrows(h_variable_10555);
matrix h_variable_10558 = submat(h_variable_10554,1..1,intvec( 2 ));
matrix h_variable_10557 = DecideZeroRows(h_variable_10558,h_variable_58);
IsZeroMatrix(h_variable_10557);
IsIdentityMatrix(h_variable_10557);
matrix h_variable_10559[1][3] = concat(h_variable_10557,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10559); matrix h_variable_10560 = h_variable_l[1]; matrix h_variable_10561 = h_variable_l[2];
IsZeroMatrix(h_variable_10560);
matrix h_variable_10562 = DecideZeroRows(h_variable_10560,h_variable_58);
IsZeroMatrix(h_variable_10562);
def h_variable_10563 = h_variable_9804[7,14];
h_variable_10563;
matrix h_variable_10564[1][1] = 2*a7+2;
matrix h_variable_10565[1][3] = concat(h_variable_10564,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10565); matrix h_variable_10566 = h_variable_l[1]; matrix h_variable_10567 = h_variable_l[2];
ncols(h_variable_10566);
matrix h_variable_10568 = DecideZeroRows(h_variable_10566,h_variable_58);
IsZeroMatrix(h_variable_10568);
ZeroRows(h_variable_10568);
nrows(h_variable_10567);
matrix h_variable_10570 = submat(h_variable_10566,1..1,intvec( 2 ));
matrix h_variable_10569 = DecideZeroRows(h_variable_10570,h_variable_58);
IsZeroMatrix(h_variable_10569);
IsIdentityMatrix(h_variable_10569);
matrix h_variable_10571[1][3] = concat(h_variable_10569,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10571); matrix h_variable_10572 = h_variable_l[1]; matrix h_variable_10573 = h_variable_l[2];
IsZeroMatrix(h_variable_10572);
matrix h_variable_10574 = DecideZeroRows(h_variable_10572,h_variable_58);
IsZeroMatrix(h_variable_10574);
def h_variable_10575 = h_variable_9804[6,14];
h_variable_10575;
matrix h_variable_10576[1][1] = 2*a7*x2+4*a7*x3+x1-4*x3;
matrix h_variable_10577[1][3] = concat(h_variable_10576,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10577); matrix h_variable_10578 = h_variable_l[1]; matrix h_variable_10579 = h_variable_l[2];
ncols(h_variable_10578);
matrix h_variable_10580 = DecideZeroRows(h_variable_10578,h_variable_58);
IsZeroMatrix(h_variable_10580);
ZeroRows(h_variable_10580);
nrows(h_variable_10579);
matrix h_variable_10582 = submat(h_variable_10578,1..1,intvec( 2, 3, 4, 5 ));
matrix h_variable_10581 = DecideZeroRows(h_variable_10582,h_variable_58);
IsZeroMatrix(h_variable_10581);
matrix h_variable_10583[1][6] = concat(h_variable_10581,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10583); matrix h_variable_10584 = h_variable_l[1]; matrix h_variable_10585 = h_variable_l[2];
IsZeroMatrix(h_variable_10584);
matrix h_variable_10586 = DecideZeroRows(h_variable_10584,h_variable_58);
IsZeroMatrix(h_variable_10586);
def h_variable_10587 = h_variable_9804[1,14];
h_variable_10587;
matrix h_variable_10588[1][1] = 0;
matrix h_variable_10589[1][3] = concat(h_variable_10588,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10589); matrix h_variable_10590 = h_variable_l[1]; matrix h_variable_10591 = h_variable_l[2];
ncols(h_variable_10590);
matrix h_variable_10592 = DecideZeroRows(h_variable_10590,h_variable_58);
IsZeroMatrix(h_variable_10592);
nrows(h_variable_10591);
def h_variable_10593 = h_variable_9804[10,15];
h_variable_10593;
matrix h_variable_10594[1][1] = 0;
matrix h_variable_10595[1][3] = concat(h_variable_10594,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10595); matrix h_variable_10596 = h_variable_l[1]; matrix h_variable_10597 = h_variable_l[2];
ncols(h_variable_10596);
matrix h_variable_10598 = DecideZeroRows(h_variable_10596,h_variable_58);
IsZeroMatrix(h_variable_10598);
nrows(h_variable_10597);
def h_variable_10599 = h_variable_9804[9,15];
h_variable_10599;
matrix h_variable_10600[1][1] = 0;
matrix h_variable_10601[1][3] = concat(h_variable_10600,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10601); matrix h_variable_10602 = h_variable_l[1]; matrix h_variable_10603 = h_variable_l[2];
ncols(h_variable_10602);
matrix h_variable_10604 = DecideZeroRows(h_variable_10602,h_variable_58);
IsZeroMatrix(h_variable_10604);
nrows(h_variable_10603);
def h_variable_10605 = h_variable_9804[8,15];
h_variable_10605;
matrix h_variable_10606[1][1] = -3;
matrix h_variable_10607[1][3] = concat(h_variable_10606,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10607); matrix h_variable_10608 = h_variable_l[1]; matrix h_variable_10609 = h_variable_l[2];
ncols(h_variable_10608);
matrix h_variable_10610 = DecideZeroRows(h_variable_10608,h_variable_58);
IsZeroMatrix(h_variable_10610);
ZeroRows(h_variable_10610);
nrows(h_variable_10609);
matrix h_variable_10612 = submat(h_variable_10608,1..1,intvec( 1 ));
matrix h_variable_10611 = DecideZeroRows(h_variable_10612,h_variable_58);
IsZeroMatrix(h_variable_10611);
IsIdentityMatrix(h_variable_10611);
matrix h_variable_10613[1][3] = concat(h_variable_10611,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10613); matrix h_variable_10614 = h_variable_l[1]; matrix h_variable_10615 = h_variable_l[2];
IsZeroMatrix(h_variable_10614);
matrix h_variable_10616 = DecideZeroRows(h_variable_10614,h_variable_58);
IsZeroMatrix(h_variable_10616);
def h_variable_10617 = h_variable_9804[7,15];
h_variable_10617;
matrix h_variable_10618[1][1] = -3*a7;
matrix h_variable_10619[1][3] = concat(h_variable_10618,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10619); matrix h_variable_10620 = h_variable_l[1]; matrix h_variable_10621 = h_variable_l[2];
ncols(h_variable_10620);
matrix h_variable_10622 = DecideZeroRows(h_variable_10620,h_variable_58);
IsZeroMatrix(h_variable_10622);
ZeroRows(h_variable_10622);
nrows(h_variable_10621);
matrix h_variable_10624 = submat(h_variable_10620,1..1,intvec( 1 ));
matrix h_variable_10623 = DecideZeroRows(h_variable_10624,h_variable_58);
IsZeroMatrix(h_variable_10623);
IsIdentityMatrix(h_variable_10623);
matrix h_variable_10625[1][3] = concat(h_variable_10623,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10625); matrix h_variable_10626 = h_variable_l[1]; matrix h_variable_10627 = h_variable_l[2];
IsZeroMatrix(h_variable_10626);
matrix h_variable_10628 = DecideZeroRows(h_variable_10626,h_variable_58);
IsZeroMatrix(h_variable_10628);
def h_variable_10629 = h_variable_9804[6,15];
h_variable_10629;
matrix h_variable_10630[1][1] = 3*a7*x3-3*x2;
matrix h_variable_10631[1][3] = concat(h_variable_10630,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10631); matrix h_variable_10632 = h_variable_l[1]; matrix h_variable_10633 = h_variable_l[2];
ncols(h_variable_10632);
matrix h_variable_10634 = DecideZeroRows(h_variable_10632,h_variable_58);
IsZeroMatrix(h_variable_10634);
ZeroRows(h_variable_10634);
nrows(h_variable_10633);
matrix h_variable_10636 = submat(h_variable_10632,1..1,intvec( 2, 3, 4 ));
matrix h_variable_10635 = DecideZeroRows(h_variable_10636,h_variable_58);
IsZeroMatrix(h_variable_10635);
matrix h_variable_10637[1][5] = concat(h_variable_10635,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10637); matrix h_variable_10638 = h_variable_l[1]; matrix h_variable_10639 = h_variable_l[2];
IsZeroMatrix(h_variable_10638);
matrix h_variable_10640 = DecideZeroRows(h_variable_10638,h_variable_58);
IsZeroMatrix(h_variable_10640);
def h_variable_10641 = h_variable_9804[1,15];
h_variable_10641;
matrix h_variable_10642[1][1] = 0;
matrix h_variable_10643[1][3] = concat(h_variable_10642,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10643); matrix h_variable_10644 = h_variable_l[1]; matrix h_variable_10645 = h_variable_l[2];
ncols(h_variable_10644);
matrix h_variable_10646 = DecideZeroRows(h_variable_10644,h_variable_58);
IsZeroMatrix(h_variable_10646);
nrows(h_variable_10645);
def h_variable_10647 = h_variable_9804[10,16];
h_variable_10647;
matrix h_variable_10648[1][1] = 0;
matrix h_variable_10649[1][3] = concat(h_variable_10648,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10649); matrix h_variable_10650 = h_variable_l[1]; matrix h_variable_10651 = h_variable_l[2];
ncols(h_variable_10650);
matrix h_variable_10652 = DecideZeroRows(h_variable_10650,h_variable_58);
IsZeroMatrix(h_variable_10652);
nrows(h_variable_10651);
def h_variable_10653 = h_variable_9804[9,16];
h_variable_10653;
matrix h_variable_10654[1][1] = 0;
matrix h_variable_10655[1][3] = concat(h_variable_10654,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10655); matrix h_variable_10656 = h_variable_l[1]; matrix h_variable_10657 = h_variable_l[2];
ncols(h_variable_10656);
matrix h_variable_10658 = DecideZeroRows(h_variable_10656,h_variable_58);
IsZeroMatrix(h_variable_10658);
nrows(h_variable_10657);
def h_variable_10659 = h_variable_9804[8,16];
h_variable_10659;
matrix h_variable_10660[1][1] = a7-5;
matrix h_variable_10661[1][3] = concat(h_variable_10660,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10661); matrix h_variable_10662 = h_variable_l[1]; matrix h_variable_10663 = h_variable_l[2];
ncols(h_variable_10662);
matrix h_variable_10664 = DecideZeroRows(h_variable_10662,h_variable_58);
IsZeroMatrix(h_variable_10664);
ZeroRows(h_variable_10664);
nrows(h_variable_10663);
matrix h_variable_10665[1][4] = concat(h_variable_10662,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10665); matrix h_variable_10666 = h_variable_l[1]; matrix h_variable_10667 = h_variable_l[2];
IsZeroMatrix(h_variable_10666);
matrix h_variable_10668 = DecideZeroRows(h_variable_10666,h_variable_58);
IsZeroMatrix(h_variable_10668);
def h_variable_10669 = h_variable_9804[7,16];
h_variable_10669;
matrix h_variable_10670[1][1] = -4*a7-1;
matrix h_variable_10671[1][3] = concat(h_variable_10670,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10671); matrix h_variable_10672 = h_variable_l[1]; matrix h_variable_10673 = h_variable_l[2];
ncols(h_variable_10672);
matrix h_variable_10674 = DecideZeroRows(h_variable_10672,h_variable_58);
IsZeroMatrix(h_variable_10674);
ZeroRows(h_variable_10674);
nrows(h_variable_10673);
matrix h_variable_10675[1][4] = concat(h_variable_10672,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10675); matrix h_variable_10676 = h_variable_l[1]; matrix h_variable_10677 = h_variable_l[2];
IsZeroMatrix(h_variable_10676);
matrix h_variable_10678 = DecideZeroRows(h_variable_10676,h_variable_58);
IsZeroMatrix(h_variable_10678);
def h_variable_10679 = h_variable_9804[6,16];
h_variable_10679;
matrix h_variable_10680[1][1] = -3*a7*x2-2*a7*x3-2*x1+x2+2*x3;
matrix h_variable_10681[1][3] = concat(h_variable_10680,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10681); matrix h_variable_10682 = h_variable_l[1]; matrix h_variable_10683 = h_variable_l[2];
ncols(h_variable_10682);
matrix h_variable_10684 = DecideZeroRows(h_variable_10682,h_variable_58);
IsZeroMatrix(h_variable_10684);
ZeroRows(h_variable_10684);
nrows(h_variable_10683);
matrix h_variable_10686 = submat(h_variable_10682,1..1,intvec( 2, 3, 4, 5, 7, 8, 9 ));
matrix h_variable_10685 = DecideZeroRows(h_variable_10686,h_variable_58);
IsZeroMatrix(h_variable_10685);
matrix h_variable_10687[1][9] = concat(h_variable_10685,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10687); matrix h_variable_10688 = h_variable_l[1]; matrix h_variable_10689 = h_variable_l[2];
IsZeroMatrix(h_variable_10688);
matrix h_variable_10690 = DecideZeroRows(h_variable_10688,h_variable_58);
IsZeroMatrix(h_variable_10690);
def h_variable_10691 = h_variable_9804[1,16];
h_variable_10691;
matrix h_variable_10692[1][1] = 0;
matrix h_variable_10693[1][3] = concat(h_variable_10692,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10693); matrix h_variable_10694 = h_variable_l[1]; matrix h_variable_10695 = h_variable_l[2];
ncols(h_variable_10694);
matrix h_variable_10696 = DecideZeroRows(h_variable_10694,h_variable_58);
IsZeroMatrix(h_variable_10696);
nrows(h_variable_10695);
def h_variable_10697 = h_variable_9804[10,17];
h_variable_10697;
matrix h_variable_10698[1][1] = 0;
matrix h_variable_10699[1][3] = concat(h_variable_10698,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10699); matrix h_variable_10700 = h_variable_l[1]; matrix h_variable_10701 = h_variable_l[2];
ncols(h_variable_10700);
matrix h_variable_10702 = DecideZeroRows(h_variable_10700,h_variable_58);
IsZeroMatrix(h_variable_10702);
nrows(h_variable_10701);
def h_variable_10703 = h_variable_9804[9,17];
h_variable_10703;
matrix h_variable_10704[1][1] = 0;
matrix h_variable_10705[1][3] = concat(h_variable_10704,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10705); matrix h_variable_10706 = h_variable_l[1]; matrix h_variable_10707 = h_variable_l[2];
ncols(h_variable_10706);
matrix h_variable_10708 = DecideZeroRows(h_variable_10706,h_variable_58);
IsZeroMatrix(h_variable_10708);
nrows(h_variable_10707);
def h_variable_10709 = h_variable_9804[8,17];
h_variable_10709;
matrix h_variable_10710[1][1] = 0;
matrix h_variable_10711[1][3] = concat(h_variable_10710,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10711); matrix h_variable_10712 = h_variable_l[1]; matrix h_variable_10713 = h_variable_l[2];
ncols(h_variable_10712);
matrix h_variable_10714 = DecideZeroRows(h_variable_10712,h_variable_58);
IsZeroMatrix(h_variable_10714);
nrows(h_variable_10713);
def h_variable_10715 = h_variable_9804[7,17];
h_variable_10715;
matrix h_variable_10716[1][1] = 0;
matrix h_variable_10717[1][3] = concat(h_variable_10716,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10717); matrix h_variable_10718 = h_variable_l[1]; matrix h_variable_10719 = h_variable_l[2];
ncols(h_variable_10718);
matrix h_variable_10720 = DecideZeroRows(h_variable_10718,h_variable_58);
IsZeroMatrix(h_variable_10720);
nrows(h_variable_10719);
def h_variable_10721 = h_variable_9804[6,17];
h_variable_10721;
matrix h_variable_10722[1][1] = -5*a7+1;
matrix h_variable_10723[1][3] = concat(h_variable_10722,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10723); matrix h_variable_10724 = h_variable_l[1]; matrix h_variable_10725 = h_variable_l[2];
ncols(h_variable_10724);
matrix h_variable_10726 = DecideZeroRows(h_variable_10724,h_variable_58);
IsZeroMatrix(h_variable_10726);
ZeroRows(h_variable_10726);
nrows(h_variable_10725);
matrix h_variable_10727[1][4] = concat(h_variable_10724,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10727); matrix h_variable_10728 = h_variable_l[1]; matrix h_variable_10729 = h_variable_l[2];
IsZeroMatrix(h_variable_10728);
matrix h_variable_10730 = DecideZeroRows(h_variable_10728,h_variable_58);
IsZeroMatrix(h_variable_10730);
def h_variable_10731 = h_variable_9804[1,17];
h_variable_10731;
matrix h_variable_10732[1][1] = 0;
matrix h_variable_10733[1][3] = concat(h_variable_10732,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10733); matrix h_variable_10734 = h_variable_l[1]; matrix h_variable_10735 = h_variable_l[2];
ncols(h_variable_10734);
matrix h_variable_10736 = DecideZeroRows(h_variable_10734,h_variable_58);
IsZeroMatrix(h_variable_10736);
nrows(h_variable_10735);
def h_variable_10737 = h_variable_9804[10,18];
h_variable_10737;
matrix h_variable_10738[1][1] = 0;
matrix h_variable_10739[1][3] = concat(h_variable_10738,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10739); matrix h_variable_10740 = h_variable_l[1]; matrix h_variable_10741 = h_variable_l[2];
ncols(h_variable_10740);
matrix h_variable_10742 = DecideZeroRows(h_variable_10740,h_variable_58);
IsZeroMatrix(h_variable_10742);
nrows(h_variable_10741);
def h_variable_10743 = h_variable_9804[9,18];
h_variable_10743;
matrix h_variable_10744[1][1] = 0;
matrix h_variable_10745[1][3] = concat(h_variable_10744,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10745); matrix h_variable_10746 = h_variable_l[1]; matrix h_variable_10747 = h_variable_l[2];
ncols(h_variable_10746);
matrix h_variable_10748 = DecideZeroRows(h_variable_10746,h_variable_58);
IsZeroMatrix(h_variable_10748);
nrows(h_variable_10747);
def h_variable_10749 = h_variable_9804[8,18];
h_variable_10749;
matrix h_variable_10750[1][1] = 0;
matrix h_variable_10751[1][3] = concat(h_variable_10750,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10751); matrix h_variable_10752 = h_variable_l[1]; matrix h_variable_10753 = h_variable_l[2];
ncols(h_variable_10752);
matrix h_variable_10754 = DecideZeroRows(h_variable_10752,h_variable_58);
IsZeroMatrix(h_variable_10754);
nrows(h_variable_10753);
def h_variable_10755 = h_variable_9804[7,18];
h_variable_10755;
matrix h_variable_10756[1][1] = 2*a7+2;
matrix h_variable_10757[1][3] = concat(h_variable_10756,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10757); matrix h_variable_10758 = h_variable_l[1]; matrix h_variable_10759 = h_variable_l[2];
ncols(h_variable_10758);
matrix h_variable_10760 = DecideZeroRows(h_variable_10758,h_variable_58);
IsZeroMatrix(h_variable_10760);
ZeroRows(h_variable_10760);
nrows(h_variable_10759);
matrix h_variable_10762 = submat(h_variable_10758,1..1,intvec( 2 ));
matrix h_variable_10761 = DecideZeroRows(h_variable_10762,h_variable_58);
IsZeroMatrix(h_variable_10761);
IsIdentityMatrix(h_variable_10761);
matrix h_variable_10763[1][3] = concat(h_variable_10761,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10763); matrix h_variable_10764 = h_variable_l[1]; matrix h_variable_10765 = h_variable_l[2];
IsZeroMatrix(h_variable_10764);
matrix h_variable_10766 = DecideZeroRows(h_variable_10764,h_variable_58);
IsZeroMatrix(h_variable_10766);
def h_variable_10767 = h_variable_9804[6,18];
h_variable_10767;
matrix h_variable_10768[1][1] = 2*a7*x1+2*a7*x2+4*a7*x3+2*x1;
matrix h_variable_10769[1][3] = concat(h_variable_10768,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10769); matrix h_variable_10770 = h_variable_l[1]; matrix h_variable_10771 = h_variable_l[2];
ncols(h_variable_10770);
matrix h_variable_10772 = DecideZeroRows(h_variable_10770,h_variable_58);
IsZeroMatrix(h_variable_10772);
ZeroRows(h_variable_10772);
nrows(h_variable_10771);
matrix h_variable_10774 = submat(h_variable_10770,1..1,intvec( 2, 3, 4 ));
matrix h_variable_10773 = DecideZeroRows(h_variable_10774,h_variable_58);
IsZeroMatrix(h_variable_10773);
matrix h_variable_10775[1][5] = concat(h_variable_10773,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10775); matrix h_variable_10776 = h_variable_l[1]; matrix h_variable_10777 = h_variable_l[2];
IsZeroMatrix(h_variable_10776);
matrix h_variable_10778 = DecideZeroRows(h_variable_10776,h_variable_58);
IsZeroMatrix(h_variable_10778);
def h_variable_10779 = h_variable_9804[1,18];
h_variable_10779;
matrix h_variable_10780[1][1] = 0;
matrix h_variable_10781[1][3] = concat(h_variable_10780,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10781); matrix h_variable_10782 = h_variable_l[1]; matrix h_variable_10783 = h_variable_l[2];
ncols(h_variable_10782);
matrix h_variable_10784 = DecideZeroRows(h_variable_10782,h_variable_58);
IsZeroMatrix(h_variable_10784);
nrows(h_variable_10783);
def h_variable_10785 = h_variable_9804[10,19];
h_variable_10785;
matrix h_variable_10786[1][1] = 0;
matrix h_variable_10787[1][3] = concat(h_variable_10786,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10787); matrix h_variable_10788 = h_variable_l[1]; matrix h_variable_10789 = h_variable_l[2];
ncols(h_variable_10788);
matrix h_variable_10790 = DecideZeroRows(h_variable_10788,h_variable_58);
IsZeroMatrix(h_variable_10790);
nrows(h_variable_10789);
def h_variable_10791 = h_variable_9804[9,19];
h_variable_10791;
matrix h_variable_10792[1][1] = 0;
matrix h_variable_10793[1][3] = concat(h_variable_10792,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10793); matrix h_variable_10794 = h_variable_l[1]; matrix h_variable_10795 = h_variable_l[2];
ncols(h_variable_10794);
matrix h_variable_10796 = DecideZeroRows(h_variable_10794,h_variable_58);
IsZeroMatrix(h_variable_10796);
nrows(h_variable_10795);
def h_variable_10797 = h_variable_9804[8,19];
h_variable_10797;
matrix h_variable_10798[1][1] = 0;
matrix h_variable_10799[1][3] = concat(h_variable_10798,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10799); matrix h_variable_10800 = h_variable_l[1]; matrix h_variable_10801 = h_variable_l[2];
ncols(h_variable_10800);
matrix h_variable_10802 = DecideZeroRows(h_variable_10800,h_variable_58);
IsZeroMatrix(h_variable_10802);
nrows(h_variable_10801);
def h_variable_10803 = h_variable_9804[7,19];
h_variable_10803;
matrix h_variable_10804[1][1] = 0;
matrix h_variable_10805[1][3] = concat(h_variable_10804,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10805); matrix h_variable_10806 = h_variable_l[1]; matrix h_variable_10807 = h_variable_l[2];
ncols(h_variable_10806);
matrix h_variable_10808 = DecideZeroRows(h_variable_10806,h_variable_58);
IsZeroMatrix(h_variable_10808);
nrows(h_variable_10807);
def h_variable_10809 = h_variable_9804[6,19];
h_variable_10809;
matrix h_variable_10810[1][1] = 0;
matrix h_variable_10811[1][3] = concat(h_variable_10810,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10811); matrix h_variable_10812 = h_variable_l[1]; matrix h_variable_10813 = h_variable_l[2];
ncols(h_variable_10812);
matrix h_variable_10814 = DecideZeroRows(h_variable_10812,h_variable_58);
IsZeroMatrix(h_variable_10814);
nrows(h_variable_10813);
def h_variable_10815 = h_variable_9804[1,19];
h_variable_10815;
matrix h_variable_10816[1][1] = 0;
matrix h_variable_10817[1][3] = concat(h_variable_10816,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10817); matrix h_variable_10818 = h_variable_l[1]; matrix h_variable_10819 = h_variable_l[2];
ncols(h_variable_10818);
matrix h_variable_10820 = DecideZeroRows(h_variable_10818,h_variable_58);
IsZeroMatrix(h_variable_10820);
nrows(h_variable_10819);
def h_variable_10821 = h_variable_9804[10,20];
h_variable_10821;
matrix h_variable_10822[1][1] = 3;
matrix h_variable_10823[1][3] = concat(h_variable_10822,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10823); matrix h_variable_10824 = h_variable_l[1]; matrix h_variable_10825 = h_variable_l[2];
ncols(h_variable_10824);
matrix h_variable_10826 = DecideZeroRows(h_variable_10824,h_variable_58);
IsZeroMatrix(h_variable_10826);
ZeroRows(h_variable_10826);
nrows(h_variable_10825);
matrix h_variable_10828 = submat(h_variable_10824,1..1,intvec( 1 ));
matrix h_variable_10827 = DecideZeroRows(h_variable_10828,h_variable_58);
IsZeroMatrix(h_variable_10827);
IsIdentityMatrix(h_variable_10827);
matrix h_variable_10829[1][3] = concat(h_variable_10827,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10829); matrix h_variable_10830 = h_variable_l[1]; matrix h_variable_10831 = h_variable_l[2];
IsZeroMatrix(h_variable_10830);
matrix h_variable_10832 = DecideZeroRows(h_variable_10830,h_variable_58);
IsZeroMatrix(h_variable_10832);
def h_variable_10833 = h_variable_9804[9,20];
h_variable_10833;
matrix h_variable_10834[1][1] = 0;
matrix h_variable_10835[1][3] = concat(h_variable_10834,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10835); matrix h_variable_10836 = h_variable_l[1]; matrix h_variable_10837 = h_variable_l[2];
ncols(h_variable_10836);
matrix h_variable_10838 = DecideZeroRows(h_variable_10836,h_variable_58);
IsZeroMatrix(h_variable_10838);
nrows(h_variable_10837);
def h_variable_10839 = h_variable_9804[8,20];
h_variable_10839;
matrix h_variable_10840[1][1] = 0;
matrix h_variable_10841[1][3] = concat(h_variable_10840,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10841); matrix h_variable_10842 = h_variable_l[1]; matrix h_variable_10843 = h_variable_l[2];
ncols(h_variable_10842);
matrix h_variable_10844 = DecideZeroRows(h_variable_10842,h_variable_58);
IsZeroMatrix(h_variable_10844);
nrows(h_variable_10843);
def h_variable_10845 = h_variable_9804[7,20];
h_variable_10845;
matrix h_variable_10846[1][1] = -3*x2;
matrix h_variable_10847[1][3] = concat(h_variable_10846,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10847); matrix h_variable_10848 = h_variable_l[1]; matrix h_variable_10849 = h_variable_l[2];
ncols(h_variable_10848);
matrix h_variable_10850 = DecideZeroRows(h_variable_10848,h_variable_58);
IsZeroMatrix(h_variable_10850);
ZeroRows(h_variable_10850);
nrows(h_variable_10849);
matrix h_variable_10852 = submat(h_variable_10848,1..1,intvec( 2 ));
matrix h_variable_10851 = DecideZeroRows(h_variable_10852,h_variable_58);
IsZeroMatrix(h_variable_10851);
IsIdentityMatrix(h_variable_10851);
matrix h_variable_10853[1][3] = concat(h_variable_10851,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10853); matrix h_variable_10854 = h_variable_l[1]; matrix h_variable_10855 = h_variable_l[2];
IsZeroMatrix(h_variable_10854);
matrix h_variable_10856 = DecideZeroRows(h_variable_10854,h_variable_58);
IsZeroMatrix(h_variable_10856);
def h_variable_10857 = h_variable_9804[6,20];
h_variable_10857;
matrix h_variable_10858[1][1] = 3*x2*x3;
matrix h_variable_10859[1][3] = concat(h_variable_10858,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10859); matrix h_variable_10860 = h_variable_l[1]; matrix h_variable_10861 = h_variable_l[2];
ncols(h_variable_10860);
matrix h_variable_10862 = DecideZeroRows(h_variable_10860,h_variable_58);
IsZeroMatrix(h_variable_10862);
ZeroRows(h_variable_10862);
nrows(h_variable_10861);
matrix h_variable_10864 = submat(h_variable_10860,1..1,intvec( 2 ));
matrix h_variable_10863 = DecideZeroRows(h_variable_10864,h_variable_58);
IsZeroMatrix(h_variable_10863);
IsIdentityMatrix(h_variable_10863);
matrix h_variable_10865[1][3] = concat(h_variable_10863,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10865); matrix h_variable_10866 = h_variable_l[1]; matrix h_variable_10867 = h_variable_l[2];
IsZeroMatrix(h_variable_10866);
matrix h_variable_10868 = DecideZeroRows(h_variable_10866,h_variable_58);
IsZeroMatrix(h_variable_10868);
def h_variable_10869 = h_variable_9804[1,20];
h_variable_10869;
matrix h_variable_10870[1][1] = 0;
matrix h_variable_10871[1][3] = concat(h_variable_10870,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10871); matrix h_variable_10872 = h_variable_l[1]; matrix h_variable_10873 = h_variable_l[2];
ncols(h_variable_10872);
matrix h_variable_10874 = DecideZeroRows(h_variable_10872,h_variable_58);
IsZeroMatrix(h_variable_10874);
nrows(h_variable_10873);
def h_variable_10875 = h_variable_9804[10,21];
h_variable_10875;
matrix h_variable_10876[1][1] = 3*x1+3*x2;
matrix h_variable_10877[1][3] = concat(h_variable_10876,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10877); matrix h_variable_10878 = h_variable_l[1]; matrix h_variable_10879 = h_variable_l[2];
ncols(h_variable_10878);
matrix h_variable_10880 = DecideZeroRows(h_variable_10878,h_variable_58);
IsZeroMatrix(h_variable_10880);
ZeroRows(h_variable_10880);
nrows(h_variable_10879);
matrix h_variable_10882 = submat(h_variable_10878,1..1,intvec( 2 ));
matrix h_variable_10881 = DecideZeroRows(h_variable_10882,h_variable_58);
IsZeroMatrix(h_variable_10881);
IsIdentityMatrix(h_variable_10881);
matrix h_variable_10883[1][3] = concat(h_variable_10881,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10883); matrix h_variable_10884 = h_variable_l[1]; matrix h_variable_10885 = h_variable_l[2];
IsZeroMatrix(h_variable_10884);
matrix h_variable_10886 = DecideZeroRows(h_variable_10884,h_variable_58);
IsZeroMatrix(h_variable_10886);
def h_variable_10887 = h_variable_9804[9,21];
h_variable_10887;
matrix h_variable_10888[1][1] = 3*x3;
matrix h_variable_10889[1][3] = concat(h_variable_10888,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10889); matrix h_variable_10890 = h_variable_l[1]; matrix h_variable_10891 = h_variable_l[2];
ncols(h_variable_10890);
matrix h_variable_10892 = DecideZeroRows(h_variable_10890,h_variable_58);
IsZeroMatrix(h_variable_10892);
ZeroRows(h_variable_10892);
nrows(h_variable_10891);
matrix h_variable_10894 = submat(h_variable_10890,1..1,intvec( 2 ));
matrix h_variable_10893 = DecideZeroRows(h_variable_10894,h_variable_58);
IsZeroMatrix(h_variable_10893);
IsIdentityMatrix(h_variable_10893);
matrix h_variable_10895[1][3] = concat(h_variable_10893,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10895); matrix h_variable_10896 = h_variable_l[1]; matrix h_variable_10897 = h_variable_l[2];
IsZeroMatrix(h_variable_10896);
matrix h_variable_10898 = DecideZeroRows(h_variable_10896,h_variable_58);
IsZeroMatrix(h_variable_10898);
def h_variable_10899 = h_variable_9804[8,21];
h_variable_10899;
matrix h_variable_10900[1][1] = 0;
matrix h_variable_10901[1][3] = concat(h_variable_10900,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10901); matrix h_variable_10902 = h_variable_l[1]; matrix h_variable_10903 = h_variable_l[2];
ncols(h_variable_10902);
matrix h_variable_10904 = DecideZeroRows(h_variable_10902,h_variable_58);
IsZeroMatrix(h_variable_10904);
nrows(h_variable_10903);
def h_variable_10905 = h_variable_9804[7,21];
h_variable_10905;
matrix h_variable_10906[1][1] = 3*x1*x2+3*x2^2-3*x1*x3+3*x2*x3+3*x3^2;
matrix h_variable_10907[1][3] = concat(h_variable_10906,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10907); matrix h_variable_10908 = h_variable_l[1]; matrix h_variable_10909 = h_variable_l[2];
ncols(h_variable_10908);
matrix h_variable_10910 = DecideZeroRows(h_variable_10908,h_variable_58);
IsZeroMatrix(h_variable_10910);
ZeroRows(h_variable_10910);
nrows(h_variable_10909);
matrix h_variable_10912 = submat(h_variable_10908,1..1,intvec( 2 ));
matrix h_variable_10911 = DecideZeroRows(h_variable_10912,h_variable_58);
IsZeroMatrix(h_variable_10911);
IsIdentityMatrix(h_variable_10911);
matrix h_variable_10913[1][3] = concat(h_variable_10911,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10913); matrix h_variable_10914 = h_variable_l[1]; matrix h_variable_10915 = h_variable_l[2];
IsZeroMatrix(h_variable_10914);
matrix h_variable_10916 = DecideZeroRows(h_variable_10914,h_variable_58);
IsZeroMatrix(h_variable_10916);
def h_variable_10917 = h_variable_9804[6,21];
h_variable_10917;
matrix h_variable_10918[1][1] = 3*x2*x3^2;
matrix h_variable_10919[1][3] = concat(h_variable_10918,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10919); matrix h_variable_10920 = h_variable_l[1]; matrix h_variable_10921 = h_variable_l[2];
ncols(h_variable_10920);
matrix h_variable_10922 = DecideZeroRows(h_variable_10920,h_variable_58);
IsZeroMatrix(h_variable_10922);
ZeroRows(h_variable_10922);
nrows(h_variable_10921);
matrix h_variable_10924 = submat(h_variable_10920,1..1,intvec( 3 ));
matrix h_variable_10923 = DecideZeroRows(h_variable_10924,h_variable_58);
IsZeroMatrix(h_variable_10923);
IsIdentityMatrix(h_variable_10923);
matrix h_variable_10925[1][3] = concat(h_variable_10923,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10925); matrix h_variable_10926 = h_variable_l[1]; matrix h_variable_10927 = h_variable_l[2];
IsZeroMatrix(h_variable_10926);
matrix h_variable_10928 = DecideZeroRows(h_variable_10926,h_variable_58);
IsZeroMatrix(h_variable_10928);
def h_variable_10929 = h_variable_9804[1,21];
h_variable_10929;
matrix h_variable_10930[1][1] = 0;
matrix h_variable_10931[1][3] = concat(h_variable_10930,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10931); matrix h_variable_10932 = h_variable_l[1]; matrix h_variable_10933 = h_variable_l[2];
ncols(h_variable_10932);
matrix h_variable_10934 = DecideZeroRows(h_variable_10932,h_variable_58);
IsZeroMatrix(h_variable_10934);
nrows(h_variable_10933);
def h_variable_10935 = h_variable_9804[10,22];
h_variable_10935;
matrix h_variable_10936[1][1] = 0;
matrix h_variable_10937[1][3] = concat(h_variable_10936,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10937); matrix h_variable_10938 = h_variable_l[1]; matrix h_variable_10939 = h_variable_l[2];
ncols(h_variable_10938);
matrix h_variable_10940 = DecideZeroRows(h_variable_10938,h_variable_58);
IsZeroMatrix(h_variable_10940);
nrows(h_variable_10939);
def h_variable_10941 = h_variable_9804[9,22];
h_variable_10941;
matrix h_variable_10942[1][1] = 5;
matrix h_variable_10943[1][3] = concat(h_variable_10942,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10943); matrix h_variable_10944 = h_variable_l[1]; matrix h_variable_10945 = h_variable_l[2];
ncols(h_variable_10944);
matrix h_variable_10946 = DecideZeroRows(h_variable_10944,h_variable_58);
IsZeroMatrix(h_variable_10946);
nrows(h_variable_10945);
IsIdentityMatrix(h_variable_10946);
def h_variable_10947 = h_variable_9804[1,22];
h_variable_10947;
matrix h_variable_10948[1][1] = 0;
matrix h_variable_10949 = DecideZeroRows(h_variable_10948,h_variable_58);
IsZeroMatrix(h_variable_10949);
def h_variable_10950 = h_variable_10949[1,1];
h_variable_10950==0;
def h_variable_10951 = h_variable_9804[6,22];
h_variable_10951;
matrix h_variable_10952[1][1] = -x1*x2-4*x2^2-x1*x3-3*x2*x3+2*x3^2;
matrix h_variable_10953 = DecideZeroRows(h_variable_10952,h_variable_58);
IsZeroMatrix(h_variable_10953);
def h_variable_10954 = h_variable_10953[1,1];
h_variable_10954==0;
def h_variable_10955 = h_variable_9804[7,22];
h_variable_10955;
matrix h_variable_10956[1][1] = -3*x3;
matrix h_variable_10957 = DecideZeroRows(h_variable_10956,h_variable_58);
IsZeroMatrix(h_variable_10957);
def h_variable_10958 = h_variable_10957[1,1];
h_variable_10958==0;
def h_variable_10959 = h_variable_9804[8,22];
h_variable_10959;
matrix h_variable_10960[1][1] = 0;
matrix h_variable_10961 = DecideZeroRows(h_variable_10960,h_variable_58);
IsZeroMatrix(h_variable_10961);
def h_variable_10962 = h_variable_10961[1,1];
h_variable_10962==0;
def h_variable_10963 = h_variable_9804[9,22];
h_variable_10963;
matrix h_variable_10964[1][1] = 5;
matrix h_variable_10965 = DecideZeroRows(h_variable_10964,h_variable_58);
IsZeroMatrix(h_variable_10965);
def h_variable_10966 = h_variable_10965[1,1];
h_variable_10966==0;
def h_variable_10967 = h_variable_9804[10,22];
h_variable_10967;
matrix h_variable_10968[1][1] = 0;
matrix h_variable_10969 = DecideZeroRows(h_variable_10968,h_variable_58);
IsZeroMatrix(h_variable_10969);
def h_variable_10970 = h_variable_10969[1,1];
h_variable_10970==0;
def h_variable_10971 = h_variable_9804[10,23];
h_variable_10971;
matrix h_variable_10972[1][1] = 4;
matrix h_variable_10973[1][3] = concat(h_variable_10972,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10973); matrix h_variable_10974 = h_variable_l[1]; matrix h_variable_10975 = h_variable_l[2];
ncols(h_variable_10974);
matrix h_variable_10976 = DecideZeroRows(h_variable_10974,h_variable_58);
IsZeroMatrix(h_variable_10976);
ZeroRows(h_variable_10976);
nrows(h_variable_10975);
matrix h_variable_10978 = submat(h_variable_10974,1..1,intvec( 1 ));
matrix h_variable_10977 = DecideZeroRows(h_variable_10978,h_variable_58);
IsZeroMatrix(h_variable_10977);
IsIdentityMatrix(h_variable_10977);
matrix h_variable_10979[1][3] = concat(h_variable_10977,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10979); matrix h_variable_10980 = h_variable_l[1]; matrix h_variable_10981 = h_variable_l[2];
IsZeroMatrix(h_variable_10980);
matrix h_variable_10982 = DecideZeroRows(h_variable_10980,h_variable_58);
IsZeroMatrix(h_variable_10982);
def h_variable_10983 = h_variable_9804[8,23];
h_variable_10983;
matrix h_variable_10984[1][1] = 2*x3;
matrix h_variable_10985[1][3] = concat(h_variable_10984,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10985); matrix h_variable_10986 = h_variable_l[1]; matrix h_variable_10987 = h_variable_l[2];
ncols(h_variable_10986);
matrix h_variable_10988 = DecideZeroRows(h_variable_10986,h_variable_58);
IsZeroMatrix(h_variable_10988);
ZeroRows(h_variable_10988);
nrows(h_variable_10987);
matrix h_variable_10990 = submat(h_variable_10986,1..1,intvec( 2 ));
matrix h_variable_10989 = DecideZeroRows(h_variable_10990,h_variable_58);
IsZeroMatrix(h_variable_10989);
IsIdentityMatrix(h_variable_10989);
matrix h_variable_10991[1][3] = concat(h_variable_10989,h_variable_48);
list h_variable_l=DecideZeroRowsEffectively(h_variable_1002,h_variable_10991); matrix h_variable_10992 = h_variable_l[1]; matrix h_variable_10993 = h_variable_l[2];
IsZeroMatrix(h_variable_10992);
matrix h_variable_10994 = DecideZeroRows(h_variable_10992,h_variable_58);
IsZeroMatrix(h_variable_10994);
def h_variable_10995 = h_variable_9804[1,23];
h_variable_10995;
matrix h_variable_10996[1][1] = 0;
matrix h_variable_10997[1][3] = concat(h_variable_10996,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_10997); matrix h_variable_10998 = h_variable_l[1]; matrix h_variable_10999 = h_variable_l[2];
ncols(h_variable_10998);
matrix h_variable_11000 = DecideZeroRows(h_variable_10998,h_variable_58);
IsZeroMatrix(h_variable_11000);
nrows(h_variable_10999);
kill h_variable_10396;kill h_variable_10398;kill h_variable_10402;kill h_variable_10404;kill h_variable_10405;kill h_variable_10406;kill h_variable_10407;kill h_variable_10408;kill h_variable_10410;kill h_variable_10411;kill h_variable_10412;kill h_variable_10413;kill h_variable_10414;kill h_variable_10415;kill h_variable_10416;kill h_variable_10417;kill h_variable_10418;kill h_variable_10419;kill h_variable_10420;kill h_variable_10421;kill h_variable_10422;kill h_variable_10423;kill h_variable_10424;kill h_variable_10425;kill h_variable_10426;kill h_variable_10427;kill h_variable_10428;kill h_variable_10429;kill h_variable_10430;kill h_variable_10431;kill h_variable_10432;kill h_variable_10433;kill h_variable_10434;kill h_variable_10435;kill h_variable_10436;kill h_variable_10437;kill h_variable_10438;kill h_variable_10439;kill h_variable_10440;kill h_variable_10441;kill h_variable_10442;kill h_variable_10443;kill h_variable_10444;kill h_variable_10445;kill h_variable_10446;kill h_variable_10447;kill h_variable_10448;kill h_variable_10449;kill h_variable_10450;kill h_variable_10451;kill h_variable_10452;kill h_variable_10453;kill h_variable_10454;kill h_variable_10455;kill h_variable_10456;kill h_variable_10457;kill h_variable_10458;kill h_variable_10459;kill h_variable_10460;kill h_variable_10461;kill h_variable_10462;kill h_variable_10463;kill h_variable_10464;kill h_variable_10465;kill h_variable_10466;kill h_variable_10467;kill h_variable_10468;kill h_variable_10469;kill h_variable_10470;kill h_variable_10471;kill h_variable_10472;kill h_variable_10473;kill h_variable_10474;kill h_variable_10475;kill h_variable_10476;kill h_variable_10477;kill h_variable_10478;kill h_variable_10479;kill h_variable_10480;kill h_variable_10481;kill h_variable_10482;kill h_variable_10483;kill h_variable_10484;kill h_variable_10485;kill h_variable_10486;kill h_variable_10487;kill h_variable_10488;kill h_variable_10489;kill h_variable_10490;kill h_variable_10491;kill h_variable_10492;kill h_variable_10493;kill h_variable_10494;kill h_variable_10495;kill h_variable_10496;kill h_variable_10497;kill h_variable_10498;kill h_variable_10499;kill h_variable_10500;kill h_variable_10501;kill h_variable_10502;kill h_variable_10503;kill h_variable_10504;kill h_variable_10510;kill h_variable_10512;kill h_variable_10513;kill h_variable_10514;kill h_variable_10515;kill h_variable_10516;kill h_variable_10518;kill h_variable_10519;kill h_variable_10520;kill h_variable_10521;kill h_variable_10522;kill h_variable_10523;kill h_variable_10524;kill h_variable_10525;kill h_variable_10526;kill h_variable_10527;kill h_variable_10528;kill h_variable_10529;kill h_variable_10530;kill h_variable_10531;kill h_variable_10532;kill h_variable_10533;kill h_variable_10534;kill h_variable_10535;kill h_variable_10536;kill h_variable_10537;kill h_variable_10538;kill h_variable_10539;kill h_variable_10540;kill h_variable_10541;kill h_variable_10542;kill h_variable_10543;kill h_variable_10544;kill h_variable_10545;kill h_variable_10546;kill h_variable_10547;kill h_variable_10548;kill h_variable_10549;kill h_variable_10550;kill h_variable_10551;kill h_variable_10552;kill h_variable_10553;kill h_variable_10554;kill h_variable_10555;kill h_variable_10556;kill h_variable_10557;kill h_variable_10558;kill h_variable_10559;kill h_variable_10560;kill h_variable_10561;kill h_variable_10562;kill h_variable_10563;kill h_variable_10564;kill h_variable_10565;kill h_variable_10566;kill h_variable_10567;kill h_variable_10568;kill h_variable_10569;kill h_variable_10570;kill h_variable_10571;kill h_variable_10572;kill h_variable_10573;kill h_variable_10574;kill h_variable_10575;kill h_variable_10576;kill h_variable_10577;kill h_variable_10578;kill h_variable_10579;kill h_variable_10580;kill h_variable_10581;kill h_variable_10582;kill h_variable_10583;kill h_variable_10584;kill h_variable_10585;kill h_variable_10586;kill h_variable_10587;kill h_variable_10588;kill h_variable_10589;kill h_variable_10590;kill h_variable_10591;kill h_variable_10592;kill h_variable_10593;kill h_variable_10594;kill h_variable_10595;kill h_variable_10596;kill h_variable_10597;kill h_variable_10598;kill h_variable_10599;kill h_variable_10600;kill h_variable_10601;kill h_variable_10602;kill h_variable_10603;kill h_variable_10604;kill h_variable_10605;kill h_variable_10606;kill h_variable_10607;kill h_variable_10608;kill h_variable_10609;kill h_variable_10610;kill h_variable_10611;kill h_variable_10612;kill h_variable_10613;kill h_variable_10614;kill h_variable_10615;kill h_variable_10616;kill h_variable_10617;kill h_variable_10618;kill h_variable_10619;kill h_variable_10620;kill h_variable_10621;kill h_variable_10622;kill h_variable_10623;kill h_variable_10624;kill h_variable_10625;kill h_variable_10626;kill h_variable_10627;kill h_variable_10628;kill h_variable_10629;kill h_variable_10630;kill h_variable_10631;kill h_variable_10632;kill h_variable_10633;kill h_variable_10634;kill h_variable_10635;kill h_variable_10636;kill h_variable_10637;kill h_variable_10638;kill h_variable_10639;kill h_variable_10640;kill h_variable_10641;kill h_variable_10642;kill h_variable_10643;kill h_variable_10644;kill h_variable_10645;kill h_variable_10646;kill h_variable_10647;kill h_variable_10648;kill h_variable_10649;kill h_variable_10650;kill h_variable_10651;kill h_variable_10652;kill h_variable_10653;kill h_variable_10654;kill h_variable_10655;kill h_variable_10656;kill h_variable_10657;kill h_variable_10658;kill h_variable_10659;kill h_variable_10660;kill h_variable_10661;kill h_variable_10662;kill h_variable_10663;kill h_variable_10664;kill h_variable_10665;kill h_variable_10666;kill h_variable_10667;kill h_variable_10668;kill h_variable_10669;kill h_variable_10670;kill h_variable_10671;kill h_variable_10672;kill h_variable_10673;kill h_variable_10674;kill h_variable_10675;kill h_variable_10676;kill h_variable_10677;kill h_variable_10678;kill h_variable_10681;kill h_variable_10684;kill h_variable_10686;kill h_variable_10690;kill h_variable_10692;kill h_variable_10693;kill h_variable_10694;kill h_variable_10695;kill h_variable_10696;kill h_variable_10698;kill h_variable_10699;kill h_variable_10700;kill h_variable_10701;kill h_variable_10702;kill h_variable_10703;kill h_variable_10704;kill h_variable_10705;kill h_variable_10706;kill h_variable_10707;kill h_variable_10708;kill h_variable_10709;kill h_variable_10710;kill h_variable_10711;kill h_variable_10712;kill h_variable_10713;kill h_variable_10714;kill h_variable_10715;kill h_variable_10716;kill h_variable_10717;kill h_variable_10718;kill h_variable_10719;kill h_variable_10720;kill h_variable_10721;kill h_variable_10722;kill h_variable_10723;kill h_variable_10724;kill h_variable_10725;kill h_variable_10726;kill h_variable_10727;kill h_variable_10728;kill h_variable_10729;kill h_variable_10730;kill h_variable_10731;kill h_variable_10732;kill h_variable_10733;kill h_variable_10734;kill h_variable_10735;kill h_variable_10736;kill h_variable_10737;kill h_variable_10738;kill h_variable_10739;kill h_variable_10740;kill h_variable_10741;kill h_variable_10742;kill h_variable_10743;kill h_variable_10744;kill h_variable_10745;kill h_variable_10746;kill h_variable_10747;kill h_variable_10748;kill h_variable_10749;kill h_variable_10750;kill h_variable_10751;kill h_variable_10752;kill h_variable_10753;kill h_variable_10754;kill h_variable_10755;kill h_variable_10756;kill h_variable_10757;kill h_variable_10758;kill h_variable_10759;kill h_variable_10760;kill h_variable_10761;kill h_variable_10762;kill h_variable_10763;kill h_variable_10764;kill h_variable_10765;kill h_variable_10766;kill h_variable_10767;kill h_variable_10768;kill h_variable_10769;kill h_variable_10770;kill h_variable_10771;kill h_variable_10772;kill h_variable_10773;kill h_variable_10774;kill h_variable_10775;kill h_variable_10776;kill h_variable_10777;kill h_variable_10778;kill h_variable_10779;kill h_variable_10780;kill h_variable_10781;kill h_variable_10782;kill h_variable_10783;kill h_variable_10784;kill h_variable_10785;kill h_variable_10786;kill h_variable_10787;kill h_variable_10788;kill h_variable_10789;kill h_variable_10790;kill h_variable_10791;kill h_variable_10792;kill h_variable_10793;kill h_variable_10794;kill h_variable_10795;kill h_variable_10796;kill h_variable_10797;kill h_variable_10798;kill h_variable_10799;kill h_variable_10800;kill h_variable_10801;kill h_variable_10802;kill h_variable_10803;kill h_variable_10804;kill h_variable_10805;kill h_variable_10806;kill h_variable_10807;kill h_variable_10808;kill h_variable_10809;kill h_variable_10810;kill h_variable_10811;kill h_variable_10812;kill h_variable_10813;kill h_variable_10814;kill h_variable_10815;kill h_variable_10816;kill h_variable_10817;kill h_variable_10818;kill h_variable_10819;kill h_variable_10820;kill h_variable_10821;kill h_variable_10822;kill h_variable_10823;kill h_variable_10824;kill h_variable_10825;kill h_variable_10826;kill h_variable_10827;kill h_variable_10828;kill h_variable_10829;kill h_variable_10830;kill h_variable_10831;kill h_variable_10832;kill h_variable_10833;kill h_variable_10834;kill h_variable_10835;kill h_variable_10836;kill h_variable_10837;kill h_variable_10838;
def h_variable_11001 = h_variable_9804[10,24];
h_variable_11001;
matrix h_variable_11002[1][1] = 5;
matrix h_variable_11003[1][3] = concat(h_variable_11002,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11003); matrix h_variable_11004 = h_variable_l[1]; matrix h_variable_11005 = h_variable_l[2];
ncols(h_variable_11004);
matrix h_variable_11006 = DecideZeroRows(h_variable_11004,h_variable_58);
IsZeroMatrix(h_variable_11006);
nrows(h_variable_11005);
IsIdentityMatrix(h_variable_11006);
def h_variable_11007 = h_variable_9804[1,24];
h_variable_11007;
matrix h_variable_11008[1][1] = 0;
matrix h_variable_11009 = DecideZeroRows(h_variable_11008,h_variable_58);
IsZeroMatrix(h_variable_11009);
def h_variable_11010 = h_variable_11009[1,1];
h_variable_11010==0;
def h_variable_11011 = h_variable_9804[8,24];
h_variable_11011;
matrix h_variable_11012[1][1] = 4*a7*x3+2*x2;
matrix h_variable_11013 = DecideZeroRows(h_variable_11012,h_variable_58);
IsZeroMatrix(h_variable_11013);
def h_variable_11014 = h_variable_11013[1,1];
h_variable_11014==0;
def h_variable_11015 = h_variable_9804[10,24];
h_variable_11015;
matrix h_variable_11016[1][1] = 5;
matrix h_variable_11017 = DecideZeroRows(h_variable_11016,h_variable_58);
IsZeroMatrix(h_variable_11017);
def h_variable_11018 = h_variable_11017[1,1];
h_variable_11018==0;
def h_variable_11019 = h_variable_9804[1,25];
h_variable_11019;
matrix h_variable_11020[1][1] = 0;
matrix h_variable_11021[1][3] = concat(h_variable_11020,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11021); matrix h_variable_11022 = h_variable_l[1]; matrix h_variable_11023 = h_variable_l[2];
ncols(h_variable_11022);
matrix h_variable_11024 = DecideZeroRows(h_variable_11022,h_variable_58);
IsZeroMatrix(h_variable_11024);
nrows(h_variable_11023);
def h_variable_11025 = h_variable_9804[1,26];
h_variable_11025;
matrix h_variable_11026[1][1] = 0;
matrix h_variable_11027[1][3] = concat(h_variable_11026,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11027); matrix h_variable_11028 = h_variable_l[1]; matrix h_variable_11029 = h_variable_l[2];
ncols(h_variable_11028);
matrix h_variable_11030 = DecideZeroRows(h_variable_11028,h_variable_58);
IsZeroMatrix(h_variable_11030);
nrows(h_variable_11029);
def h_variable_11031 = h_variable_9804[1,27];
h_variable_11031;
matrix h_variable_11032[1][1] = 0;
matrix h_variable_11033[1][3] = concat(h_variable_11032,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11033); matrix h_variable_11034 = h_variable_l[1]; matrix h_variable_11035 = h_variable_l[2];
ncols(h_variable_11034);
matrix h_variable_11036 = DecideZeroRows(h_variable_11034,h_variable_58);
IsZeroMatrix(h_variable_11036);
nrows(h_variable_11035);
def h_variable_11037 = h_variable_9804[1,28];
h_variable_11037;
matrix h_variable_11038[1][1] = 0;
matrix h_variable_11039[1][3] = concat(h_variable_11038,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11039); matrix h_variable_11040 = h_variable_l[1]; matrix h_variable_11041 = h_variable_l[2];
ncols(h_variable_11040);
matrix h_variable_11042 = DecideZeroRows(h_variable_11040,h_variable_58);
IsZeroMatrix(h_variable_11042);
nrows(h_variable_11041);
def h_variable_11043 = h_variable_9804[1,29];
h_variable_11043;
matrix h_variable_11044[1][1] = 0;
matrix h_variable_11045[1][3] = concat(h_variable_11044,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11045); matrix h_variable_11046 = h_variable_l[1]; matrix h_variable_11047 = h_variable_l[2];
ncols(h_variable_11046);
matrix h_variable_11048 = DecideZeroRows(h_variable_11046,h_variable_58);
IsZeroMatrix(h_variable_11048);
nrows(h_variable_11047);
def h_variable_11049 = h_variable_9804[1,30];
h_variable_11049;
matrix h_variable_11050[1][1] = 0;
matrix h_variable_11051[1][3] = concat(h_variable_11050,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11051); matrix h_variable_11052 = h_variable_l[1]; matrix h_variable_11053 = h_variable_l[2];
ncols(h_variable_11052);
matrix h_variable_11054 = DecideZeroRows(h_variable_11052,h_variable_58);
IsZeroMatrix(h_variable_11054);
nrows(h_variable_11053);
def h_variable_11055 = h_variable_9804[1,31];
h_variable_11055;
matrix h_variable_11056[1][1] = 0;
matrix h_variable_11057[1][3] = concat(h_variable_11056,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11057); matrix h_variable_11058 = h_variable_l[1]; matrix h_variable_11059 = h_variable_l[2];
ncols(h_variable_11058);
matrix h_variable_11060 = DecideZeroRows(h_variable_11058,h_variable_58);
IsZeroMatrix(h_variable_11060);
nrows(h_variable_11059);
def h_variable_11061 = h_variable_9804[1,32];
h_variable_11061;
matrix h_variable_11062[1][1] = 0;
matrix h_variable_11063[1][3] = concat(h_variable_11062,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11063); matrix h_variable_11064 = h_variable_l[1]; matrix h_variable_11065 = h_variable_l[2];
ncols(h_variable_11064);
matrix h_variable_11066 = DecideZeroRows(h_variable_11064,h_variable_58);
IsZeroMatrix(h_variable_11066);
nrows(h_variable_11065);
def h_variable_11067 = h_variable_9804[1,33];
h_variable_11067;
matrix h_variable_11068[1][1] = 0;
matrix h_variable_11069[1][3] = concat(h_variable_11068,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11069); matrix h_variable_11070 = h_variable_l[1]; matrix h_variable_11071 = h_variable_l[2];
ncols(h_variable_11070);
matrix h_variable_11072 = DecideZeroRows(h_variable_11070,h_variable_58);
IsZeroMatrix(h_variable_11072);
nrows(h_variable_11071);
def h_variable_11073 = h_variable_9804[1,34];
h_variable_11073;
matrix h_variable_11074[1][1] = 0;
matrix h_variable_11075[1][3] = concat(h_variable_11074,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11075); matrix h_variable_11076 = h_variable_l[1]; matrix h_variable_11077 = h_variable_l[2];
ncols(h_variable_11076);
matrix h_variable_11078 = DecideZeroRows(h_variable_11076,h_variable_58);
IsZeroMatrix(h_variable_11078);
nrows(h_variable_11077);
def h_variable_11079 = h_variable_9804[1,35];
h_variable_11079;
matrix h_variable_11080[1][1] = 0;
matrix h_variable_11081[1][3] = concat(h_variable_11080,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11081); matrix h_variable_11082 = h_variable_l[1]; matrix h_variable_11083 = h_variable_l[2];
ncols(h_variable_11082);
matrix h_variable_11084 = DecideZeroRows(h_variable_11082,h_variable_58);
IsZeroMatrix(h_variable_11084);
nrows(h_variable_11083);
def h_variable_11085 = h_variable_9804[1,36];
h_variable_11085;
matrix h_variable_11086[1][1] = 0;
matrix h_variable_11087[1][3] = concat(h_variable_11086,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11087); matrix h_variable_11088 = h_variable_l[1]; matrix h_variable_11089 = h_variable_l[2];
ncols(h_variable_11088);
matrix h_variable_11090 = DecideZeroRows(h_variable_11088,h_variable_58);
IsZeroMatrix(h_variable_11090);
nrows(h_variable_11089);
def h_variable_11091 = h_variable_9804[1,37];
h_variable_11091;
matrix h_variable_11092[1][1] = 0;
matrix h_variable_11093[1][3] = concat(h_variable_11092,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11093); matrix h_variable_11094 = h_variable_l[1]; matrix h_variable_11095 = h_variable_l[2];
ncols(h_variable_11094);
matrix h_variable_11096 = DecideZeroRows(h_variable_11094,h_variable_58);
IsZeroMatrix(h_variable_11096);
nrows(h_variable_11095);
def h_variable_11097 = h_variable_9804[1,38];
h_variable_11097;
matrix h_variable_11098[1][1] = 0;
matrix h_variable_11099[1][3] = concat(h_variable_11098,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11099); matrix h_variable_11100 = h_variable_l[1]; matrix h_variable_11101 = h_variable_l[2];
ncols(h_variable_11100);
matrix h_variable_11102 = DecideZeroRows(h_variable_11100,h_variable_58);
IsZeroMatrix(h_variable_11102);
nrows(h_variable_11101);
def h_variable_11103 = h_variable_9804[1,39];
h_variable_11103;
matrix h_variable_11104[1][1] = 0;
matrix h_variable_11105[1][3] = concat(h_variable_11104,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11105); matrix h_variable_11106 = h_variable_l[1]; matrix h_variable_11107 = h_variable_l[2];
ncols(h_variable_11106);
matrix h_variable_11108 = DecideZeroRows(h_variable_11106,h_variable_58);
IsZeroMatrix(h_variable_11108);
nrows(h_variable_11107);
def h_variable_11109 = h_variable_9804[1,40];
h_variable_11109;
matrix h_variable_11110[1][1] = 0;
matrix h_variable_11111[1][3] = concat(h_variable_11110,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11111); matrix h_variable_11112 = h_variable_l[1]; matrix h_variable_11113 = h_variable_l[2];
ncols(h_variable_11112);
matrix h_variable_11114 = DecideZeroRows(h_variable_11112,h_variable_58);
IsZeroMatrix(h_variable_11114);
nrows(h_variable_11113);
def h_variable_11115 = h_variable_9804[1,41];
h_variable_11115;
matrix h_variable_11116[1][1] = 0;
matrix h_variable_11117[1][3] = concat(h_variable_11116,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11117); matrix h_variable_11118 = h_variable_l[1]; matrix h_variable_11119 = h_variable_l[2];
ncols(h_variable_11118);
matrix h_variable_11120 = DecideZeroRows(h_variable_11118,h_variable_58);
IsZeroMatrix(h_variable_11120);
nrows(h_variable_11119);
def h_variable_11121 = h_variable_9804[1,42];
h_variable_11121;
matrix h_variable_11122[1][1] = 0;
matrix h_variable_11123[1][3] = concat(h_variable_11122,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11123); matrix h_variable_11124 = h_variable_l[1]; matrix h_variable_11125 = h_variable_l[2];
ncols(h_variable_11124);
matrix h_variable_11126 = DecideZeroRows(h_variable_11124,h_variable_58);
IsZeroMatrix(h_variable_11126);
nrows(h_variable_11125);
def h_variable_11127 = h_variable_9804[1,43];
h_variable_11127;
matrix h_variable_11128[1][1] = 0;
matrix h_variable_11129[1][3] = concat(h_variable_11128,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11129); matrix h_variable_11130 = h_variable_l[1]; matrix h_variable_11131 = h_variable_l[2];
ncols(h_variable_11130);
matrix h_variable_11132 = DecideZeroRows(h_variable_11130,h_variable_58);
IsZeroMatrix(h_variable_11132);
nrows(h_variable_11131);
def h_variable_11133 = h_variable_9804[1,44];
h_variable_11133;
matrix h_variable_11134[1][1] = 0;
matrix h_variable_11135[1][3] = concat(h_variable_11134,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11135); matrix h_variable_11136 = h_variable_l[1]; matrix h_variable_11137 = h_variable_l[2];
ncols(h_variable_11136);
matrix h_variable_11138 = DecideZeroRows(h_variable_11136,h_variable_58);
IsZeroMatrix(h_variable_11138);
nrows(h_variable_11137);
def h_variable_11139 = h_variable_9804[1,45];
h_variable_11139;
matrix h_variable_11140[1][1] = 0;
matrix h_variable_11141[1][3] = concat(h_variable_11140,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11141); matrix h_variable_11142 = h_variable_l[1]; matrix h_variable_11143 = h_variable_l[2];
ncols(h_variable_11142);
matrix h_variable_11144 = DecideZeroRows(h_variable_11142,h_variable_58);
IsZeroMatrix(h_variable_11144);
nrows(h_variable_11143);
def h_variable_11145 = h_variable_9804[1,46];
h_variable_11145;
matrix h_variable_11146[1][1] = 0;
matrix h_variable_11147[1][3] = concat(h_variable_11146,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11147); matrix h_variable_11148 = h_variable_l[1]; matrix h_variable_11149 = h_variable_l[2];
ncols(h_variable_11148);
matrix h_variable_11150 = DecideZeroRows(h_variable_11148,h_variable_58);
IsZeroMatrix(h_variable_11150);
nrows(h_variable_11149);
def h_variable_11151 = h_variable_9804[1,47];
h_variable_11151;
matrix h_variable_11152[1][1] = 0;
matrix h_variable_11153[1][3] = concat(h_variable_11152,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11153); matrix h_variable_11154 = h_variable_l[1]; matrix h_variable_11155 = h_variable_l[2];
ncols(h_variable_11154);
matrix h_variable_11156 = DecideZeroRows(h_variable_11154,h_variable_58);
IsZeroMatrix(h_variable_11156);
nrows(h_variable_11155);
def h_variable_11157 = h_variable_9804[1,48];
h_variable_11157;
matrix h_variable_11158[1][1] = 0;
matrix h_variable_11159[1][3] = concat(h_variable_11158,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11159); matrix h_variable_11160 = h_variable_l[1]; matrix h_variable_11161 = h_variable_l[2];
ncols(h_variable_11160);
matrix h_variable_11162 = DecideZeroRows(h_variable_11160,h_variable_58);
IsZeroMatrix(h_variable_11162);
nrows(h_variable_11161);
def h_variable_11163 = h_variable_9804[1,49];
h_variable_11163;
matrix h_variable_11164[1][1] = 0;
matrix h_variable_11165[1][3] = concat(h_variable_11164,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11165); matrix h_variable_11166 = h_variable_l[1]; matrix h_variable_11167 = h_variable_l[2];
ncols(h_variable_11166);
matrix h_variable_11168 = DecideZeroRows(h_variable_11166,h_variable_58);
IsZeroMatrix(h_variable_11168);
nrows(h_variable_11167);
def h_variable_11169 = h_variable_9804[1,50];
h_variable_11169;
matrix h_variable_11170[1][1] = 0;
matrix h_variable_11171[1][3] = concat(h_variable_11170,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11171); matrix h_variable_11172 = h_variable_l[1]; matrix h_variable_11173 = h_variable_l[2];
ncols(h_variable_11172);
matrix h_variable_11174 = DecideZeroRows(h_variable_11172,h_variable_58);
IsZeroMatrix(h_variable_11174);
nrows(h_variable_11173);
def h_variable_11175 = h_variable_9804[1,51];
h_variable_11175;
matrix h_variable_11176[1][1] = 0;
matrix h_variable_11177[1][3] = concat(h_variable_11176,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11177); matrix h_variable_11178 = h_variable_l[1]; matrix h_variable_11179 = h_variable_l[2];
ncols(h_variable_11178);
matrix h_variable_11180 = DecideZeroRows(h_variable_11178,h_variable_58);
IsZeroMatrix(h_variable_11180);
nrows(h_variable_11179);
def h_variable_11181 = h_variable_9804[1,52];
h_variable_11181;
matrix h_variable_11182[1][1] = 0;
matrix h_variable_11183[1][3] = concat(h_variable_11182,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11183); matrix h_variable_11184 = h_variable_l[1]; matrix h_variable_11185 = h_variable_l[2];
ncols(h_variable_11184);
matrix h_variable_11186 = DecideZeroRows(h_variable_11184,h_variable_58);
IsZeroMatrix(h_variable_11186);
nrows(h_variable_11185);
def h_variable_11187 = h_variable_9804[1,53];
h_variable_11187;
matrix h_variable_11188[1][1] = 0;
matrix h_variable_11189[1][3] = concat(h_variable_11188,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11189); matrix h_variable_11190 = h_variable_l[1]; matrix h_variable_11191 = h_variable_l[2];
ncols(h_variable_11190);
matrix h_variable_11192 = DecideZeroRows(h_variable_11190,h_variable_58);
IsZeroMatrix(h_variable_11192);
nrows(h_variable_11191);
def h_variable_11193 = h_variable_9804[1,54];
h_variable_11193;
matrix h_variable_11194[1][1] = 0;
matrix h_variable_11195[1][3] = concat(h_variable_11194,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11195); matrix h_variable_11196 = h_variable_l[1]; matrix h_variable_11197 = h_variable_l[2];
ncols(h_variable_11196);
matrix h_variable_11198 = DecideZeroRows(h_variable_11196,h_variable_58);
IsZeroMatrix(h_variable_11198);
nrows(h_variable_11197);
def h_variable_11199 = h_variable_9804[1,55];
h_variable_11199;
matrix h_variable_11200[1][1] = 0;
matrix h_variable_11201[1][3] = concat(h_variable_11200,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11201); matrix h_variable_11202 = h_variable_l[1]; matrix h_variable_11203 = h_variable_l[2];
ncols(h_variable_11202);
matrix h_variable_11204 = DecideZeroRows(h_variable_11202,h_variable_58);
IsZeroMatrix(h_variable_11204);
nrows(h_variable_11203);
def h_variable_11205 = h_variable_9804[1,56];
h_variable_11205;
matrix h_variable_11206[1][1] = 0;
matrix h_variable_11207[1][3] = concat(h_variable_11206,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11207); matrix h_variable_11208 = h_variable_l[1]; matrix h_variable_11209 = h_variable_l[2];
ncols(h_variable_11208);
matrix h_variable_11210 = DecideZeroRows(h_variable_11208,h_variable_58);
IsZeroMatrix(h_variable_11210);
nrows(h_variable_11209);
def h_variable_11211 = h_variable_9804[1,57];
h_variable_11211;
matrix h_variable_11212[1][1] = 0;
matrix h_variable_11213[1][3] = concat(h_variable_11212,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11213); matrix h_variable_11214 = h_variable_l[1]; matrix h_variable_11215 = h_variable_l[2];
ncols(h_variable_11214);
matrix h_variable_11216 = DecideZeroRows(h_variable_11214,h_variable_58);
IsZeroMatrix(h_variable_11216);
nrows(h_variable_11215);
def h_variable_11217 = h_variable_9804[1,58];
h_variable_11217;
matrix h_variable_11218[1][1] = 0;
matrix h_variable_11219[1][3] = concat(h_variable_11218,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11219); matrix h_variable_11220 = h_variable_l[1]; matrix h_variable_11221 = h_variable_l[2];
ncols(h_variable_11220);
matrix h_variable_11222 = DecideZeroRows(h_variable_11220,h_variable_58);
IsZeroMatrix(h_variable_11222);
nrows(h_variable_11221);
def h_variable_11223 = h_variable_9804[1,59];
h_variable_11223;
matrix h_variable_11224[1][1] = 0;
matrix h_variable_11225[1][3] = concat(h_variable_11224,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11225); matrix h_variable_11226 = h_variable_l[1]; matrix h_variable_11227 = h_variable_l[2];
ncols(h_variable_11226);
matrix h_variable_11228 = DecideZeroRows(h_variable_11226,h_variable_58);
IsZeroMatrix(h_variable_11228);
nrows(h_variable_11227);
def h_variable_11229 = h_variable_9804[1,60];
h_variable_11229;
matrix h_variable_11230[1][1] = 0;
matrix h_variable_11231[1][3] = concat(h_variable_11230,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11231); matrix h_variable_11232 = h_variable_l[1]; matrix h_variable_11233 = h_variable_l[2];
ncols(h_variable_11232);
matrix h_variable_11234 = DecideZeroRows(h_variable_11232,h_variable_58);
IsZeroMatrix(h_variable_11234);
nrows(h_variable_11233);
def h_variable_11235 = h_variable_9804[1,61];
h_variable_11235;
matrix h_variable_11236[1][1] = 0;
matrix h_variable_11237[1][3] = concat(h_variable_11236,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11237); matrix h_variable_11238 = h_variable_l[1]; matrix h_variable_11239 = h_variable_l[2];
ncols(h_variable_11238);
matrix h_variable_11240 = DecideZeroRows(h_variable_11238,h_variable_58);
IsZeroMatrix(h_variable_11240);
nrows(h_variable_11239);
def h_variable_11241 = h_variable_9804[1,62];
h_variable_11241;
matrix h_variable_11242[1][1] = 0;
matrix h_variable_11243[1][3] = concat(h_variable_11242,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11243); matrix h_variable_11244 = h_variable_l[1]; matrix h_variable_11245 = h_variable_l[2];
ncols(h_variable_11244);
matrix h_variable_11246 = DecideZeroRows(h_variable_11244,h_variable_58);
IsZeroMatrix(h_variable_11246);
nrows(h_variable_11245);
def h_variable_11247 = h_variable_9804[1,63];
h_variable_11247;
matrix h_variable_11248[1][1] = 0;
matrix h_variable_11249[1][3] = concat(h_variable_11248,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11249); matrix h_variable_11250 = h_variable_l[1]; matrix h_variable_11251 = h_variable_l[2];
ncols(h_variable_11250);
matrix h_variable_11252 = DecideZeroRows(h_variable_11250,h_variable_58);
IsZeroMatrix(h_variable_11252);
nrows(h_variable_11251);
def h_variable_11253 = h_variable_9804[1,64];
h_variable_11253;
matrix h_variable_11254[1][1] = 0;
matrix h_variable_11255[1][3] = concat(h_variable_11254,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11255); matrix h_variable_11256 = h_variable_l[1]; matrix h_variable_11257 = h_variable_l[2];
ncols(h_variable_11256);
matrix h_variable_11258 = DecideZeroRows(h_variable_11256,h_variable_58);
IsZeroMatrix(h_variable_11258);
nrows(h_variable_11257);
def h_variable_11259 = h_variable_9804[1,65];
h_variable_11259;
matrix h_variable_11260[1][1] = 0;
matrix h_variable_11261[1][3] = concat(h_variable_11260,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11261); matrix h_variable_11262 = h_variable_l[1]; matrix h_variable_11263 = h_variable_l[2];
ncols(h_variable_11262);
matrix h_variable_11264 = DecideZeroRows(h_variable_11262,h_variable_58);
IsZeroMatrix(h_variable_11264);
nrows(h_variable_11263);
def h_variable_11265 = h_variable_9804[1,66];
h_variable_11265;
matrix h_variable_11266[1][1] = 0;
matrix h_variable_11267[1][3] = concat(h_variable_11266,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11267); matrix h_variable_11268 = h_variable_l[1]; matrix h_variable_11269 = h_variable_l[2];
ncols(h_variable_11268);
matrix h_variable_11270 = DecideZeroRows(h_variable_11268,h_variable_58);
IsZeroMatrix(h_variable_11270);
nrows(h_variable_11269);
def h_variable_11271 = h_variable_9804[1,67];
h_variable_11271;
matrix h_variable_11272[1][1] = 0;
matrix h_variable_11273[1][3] = concat(h_variable_11272,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11273); matrix h_variable_11274 = h_variable_l[1]; matrix h_variable_11275 = h_variable_l[2];
ncols(h_variable_11274);
matrix h_variable_11276 = DecideZeroRows(h_variable_11274,h_variable_58);
IsZeroMatrix(h_variable_11276);
nrows(h_variable_11275);
def h_variable_11277 = h_variable_9804[1,68];
h_variable_11277;
matrix h_variable_11278[1][1] = 0;
matrix h_variable_11279[1][3] = concat(h_variable_11278,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11279); matrix h_variable_11280 = h_variable_l[1]; matrix h_variable_11281 = h_variable_l[2];
ncols(h_variable_11280);
matrix h_variable_11282 = DecideZeroRows(h_variable_11280,h_variable_58);
IsZeroMatrix(h_variable_11282);
nrows(h_variable_11281);
def h_variable_11283 = h_variable_9804[1,69];
h_variable_11283;
matrix h_variable_11284[1][1] = 0;
matrix h_variable_11285[1][3] = concat(h_variable_11284,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11285); matrix h_variable_11286 = h_variable_l[1]; matrix h_variable_11287 = h_variable_l[2];
ncols(h_variable_11286);
matrix h_variable_11288 = DecideZeroRows(h_variable_11286,h_variable_58);
IsZeroMatrix(h_variable_11288);
nrows(h_variable_11287);
def h_variable_11289 = h_variable_9804[1,70];
h_variable_11289;
matrix h_variable_11290[1][1] = 0;
matrix h_variable_11291[1][3] = concat(h_variable_11290,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11291); matrix h_variable_11292 = h_variable_l[1]; matrix h_variable_11293 = h_variable_l[2];
ncols(h_variable_11292);
matrix h_variable_11294 = DecideZeroRows(h_variable_11292,h_variable_58);
IsZeroMatrix(h_variable_11294);
nrows(h_variable_11293);
def h_variable_11295 = h_variable_9804[1,71];
h_variable_11295;
matrix h_variable_11296[1][1] = 0;
matrix h_variable_11297[1][3] = concat(h_variable_11296,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11297); matrix h_variable_11298 = h_variable_l[1]; matrix h_variable_11299 = h_variable_l[2];
ncols(h_variable_11298);
matrix h_variable_11300 = DecideZeroRows(h_variable_11298,h_variable_58);
IsZeroMatrix(h_variable_11300);
nrows(h_variable_11299);
def h_variable_11301 = h_variable_9804[1,72];
h_variable_11301;
matrix h_variable_11302[1][1] = 0;
matrix h_variable_11303[1][3] = concat(h_variable_11302,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11303); matrix h_variable_11304 = h_variable_l[1]; matrix h_variable_11305 = h_variable_l[2];
ncols(h_variable_11304);
matrix h_variable_11306 = DecideZeroRows(h_variable_11304,h_variable_58);
IsZeroMatrix(h_variable_11306);
nrows(h_variable_11305);
def h_variable_11307 = h_variable_9804[1,73];
h_variable_11307;
matrix h_variable_11308[1][1] = 0;
matrix h_variable_11309[1][3] = concat(h_variable_11308,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11309); matrix h_variable_11310 = h_variable_l[1]; matrix h_variable_11311 = h_variable_l[2];
ncols(h_variable_11310);
matrix h_variable_11312 = DecideZeroRows(h_variable_11310,h_variable_58);
IsZeroMatrix(h_variable_11312);
nrows(h_variable_11311);
def h_variable_11313 = h_variable_9804[1,74];
h_variable_11313;
matrix h_variable_11314[1][1] = 0;
matrix h_variable_11315[1][3] = concat(h_variable_11314,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11315); matrix h_variable_11316 = h_variable_l[1]; matrix h_variable_11317 = h_variable_l[2];
ncols(h_variable_11316);
matrix h_variable_11318 = DecideZeroRows(h_variable_11316,h_variable_58);
IsZeroMatrix(h_variable_11318);
nrows(h_variable_11317);
def h_variable_11319 = h_variable_9804[1,75];
h_variable_11319;
matrix h_variable_11320[1][1] = 0;
matrix h_variable_11321[1][3] = concat(h_variable_11320,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11321); matrix h_variable_11322 = h_variable_l[1]; matrix h_variable_11323 = h_variable_l[2];
ncols(h_variable_11322);
matrix h_variable_11324 = DecideZeroRows(h_variable_11322,h_variable_58);
IsZeroMatrix(h_variable_11324);
nrows(h_variable_11323);
def h_variable_11325 = h_variable_9804[1,76];
h_variable_11325;
matrix h_variable_11326[1][1] = 0;
matrix h_variable_11327[1][3] = concat(h_variable_11326,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11327); matrix h_variable_11328 = h_variable_l[1]; matrix h_variable_11329 = h_variable_l[2];
ncols(h_variable_11328);
matrix h_variable_11330 = DecideZeroRows(h_variable_11328,h_variable_58);
IsZeroMatrix(h_variable_11330);
nrows(h_variable_11329);
def h_variable_11331 = h_variable_9804[1,77];
h_variable_11331;
matrix h_variable_11332[1][1] = 0;
matrix h_variable_11333[1][3] = concat(h_variable_11332,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11333); matrix h_variable_11334 = h_variable_l[1]; matrix h_variable_11335 = h_variable_l[2];
ncols(h_variable_11334);
matrix h_variable_11336 = DecideZeroRows(h_variable_11334,h_variable_58);
IsZeroMatrix(h_variable_11336);
nrows(h_variable_11335);
def h_variable_11337 = h_variable_9804[1,78];
h_variable_11337;
matrix h_variable_11338[1][1] = 0;
matrix h_variable_11339[1][3] = concat(h_variable_11338,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11339); matrix h_variable_11340 = h_variable_l[1]; matrix h_variable_11341 = h_variable_l[2];
ncols(h_variable_11340);
matrix h_variable_11342 = DecideZeroRows(h_variable_11340,h_variable_58);
IsZeroMatrix(h_variable_11342);
nrows(h_variable_11341);
def h_variable_11343 = h_variable_9804[1,79];
h_variable_11343;
matrix h_variable_11344[1][1] = 0;
matrix h_variable_11345[1][3] = concat(h_variable_11344,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11345); matrix h_variable_11346 = h_variable_l[1]; matrix h_variable_11347 = h_variable_l[2];
ncols(h_variable_11346);
matrix h_variable_11348 = DecideZeroRows(h_variable_11346,h_variable_58);
IsZeroMatrix(h_variable_11348);
nrows(h_variable_11347);
def h_variable_11349 = h_variable_9804[1,80];
h_variable_11349;
matrix h_variable_11350[1][1] = 0;
matrix h_variable_11351[1][3] = concat(h_variable_11350,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11351); matrix h_variable_11352 = h_variable_l[1]; matrix h_variable_11353 = h_variable_l[2];
ncols(h_variable_11352);
matrix h_variable_11354 = DecideZeroRows(h_variable_11352,h_variable_58);
IsZeroMatrix(h_variable_11354);
nrows(h_variable_11353);
def h_variable_11355 = h_variable_9804[1,81];
h_variable_11355;
matrix h_variable_11356[1][1] = 0;
matrix h_variable_11357[1][3] = concat(h_variable_11356,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11357); matrix h_variable_11358 = h_variable_l[1]; matrix h_variable_11359 = h_variable_l[2];
ncols(h_variable_11358);
matrix h_variable_11360 = DecideZeroRows(h_variable_11358,h_variable_58);
IsZeroMatrix(h_variable_11360);
nrows(h_variable_11359);
def h_variable_11361 = h_variable_9804[1,82];
h_variable_11361;
matrix h_variable_11362[1][1] = 0;
matrix h_variable_11363[1][3] = concat(h_variable_11362,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11363); matrix h_variable_11364 = h_variable_l[1]; matrix h_variable_11365 = h_variable_l[2];
ncols(h_variable_11364);
matrix h_variable_11366 = DecideZeroRows(h_variable_11364,h_variable_58);
IsZeroMatrix(h_variable_11366);
nrows(h_variable_11365);
def h_variable_11367 = h_variable_9804[1,83];
h_variable_11367;
matrix h_variable_11368[1][1] = 0;
matrix h_variable_11369[1][3] = concat(h_variable_11368,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11369); matrix h_variable_11370 = h_variable_l[1]; matrix h_variable_11371 = h_variable_l[2];
ncols(h_variable_11370);
matrix h_variable_11372 = DecideZeroRows(h_variable_11370,h_variable_58);
IsZeroMatrix(h_variable_11372);
nrows(h_variable_11371);
def h_variable_11373 = h_variable_9804[1,84];
h_variable_11373;
matrix h_variable_11374[1][1] = 0;
matrix h_variable_11375[1][3] = concat(h_variable_11374,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11375); matrix h_variable_11376 = h_variable_l[1]; matrix h_variable_11377 = h_variable_l[2];
ncols(h_variable_11376);
matrix h_variable_11378 = DecideZeroRows(h_variable_11376,h_variable_58);
IsZeroMatrix(h_variable_11378);
nrows(h_variable_11377);
def h_variable_11379 = h_variable_9804[1,85];
h_variable_11379;
matrix h_variable_11380[1][1] = 0;
matrix h_variable_11381[1][3] = concat(h_variable_11380,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11381); matrix h_variable_11382 = h_variable_l[1]; matrix h_variable_11383 = h_variable_l[2];
ncols(h_variable_11382);
matrix h_variable_11384 = DecideZeroRows(h_variable_11382,h_variable_58);
IsZeroMatrix(h_variable_11384);
nrows(h_variable_11383);
def h_variable_11385 = h_variable_9804[1,86];
h_variable_11385;
matrix h_variable_11386[1][1] = 0;
matrix h_variable_11387[1][3] = concat(h_variable_11386,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11387); matrix h_variable_11388 = h_variable_l[1]; matrix h_variable_11389 = h_variable_l[2];
ncols(h_variable_11388);
matrix h_variable_11390 = DecideZeroRows(h_variable_11388,h_variable_58);
IsZeroMatrix(h_variable_11390);
nrows(h_variable_11389);
def h_variable_11391 = h_variable_9804[1,87];
h_variable_11391;
matrix h_variable_11392[1][1] = 0;
matrix h_variable_11393[1][3] = concat(h_variable_11392,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11393); matrix h_variable_11394 = h_variable_l[1]; matrix h_variable_11395 = h_variable_l[2];
ncols(h_variable_11394);
matrix h_variable_11396 = DecideZeroRows(h_variable_11394,h_variable_58);
IsZeroMatrix(h_variable_11396);
nrows(h_variable_11395);
def h_variable_11397 = h_variable_9804[1,88];
h_variable_11397;
matrix h_variable_11398[1][1] = 0;
matrix h_variable_11399[1][3] = concat(h_variable_11398,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11399); matrix h_variable_11400 = h_variable_l[1]; matrix h_variable_11401 = h_variable_l[2];
ncols(h_variable_11400);
matrix h_variable_11402 = DecideZeroRows(h_variable_11400,h_variable_58);
IsZeroMatrix(h_variable_11402);
nrows(h_variable_11401);
def h_variable_11403 = h_variable_9804[1,89];
h_variable_11403;
matrix h_variable_11404[1][1] = 0;
matrix h_variable_11405[1][3] = concat(h_variable_11404,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11405); matrix h_variable_11406 = h_variable_l[1]; matrix h_variable_11407 = h_variable_l[2];
ncols(h_variable_11406);
matrix h_variable_11408 = DecideZeroRows(h_variable_11406,h_variable_58);
IsZeroMatrix(h_variable_11408);
nrows(h_variable_11407);
def h_variable_11409 = h_variable_9804[1,90];
h_variable_11409;
matrix h_variable_11410[1][1] = 0;
matrix h_variable_11411[1][3] = concat(h_variable_11410,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11411); matrix h_variable_11412 = h_variable_l[1]; matrix h_variable_11413 = h_variable_l[2];
ncols(h_variable_11412);
matrix h_variable_11414 = DecideZeroRows(h_variable_11412,h_variable_58);
IsZeroMatrix(h_variable_11414);
nrows(h_variable_11413);
def h_variable_11415 = h_variable_9804[1,91];
h_variable_11415;
matrix h_variable_11416[1][1] = 0;
matrix h_variable_11417[1][3] = concat(h_variable_11416,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11417); matrix h_variable_11418 = h_variable_l[1]; matrix h_variable_11419 = h_variable_l[2];
ncols(h_variable_11418);
matrix h_variable_11420 = DecideZeroRows(h_variable_11418,h_variable_58);
IsZeroMatrix(h_variable_11420);
nrows(h_variable_11419);
def h_variable_11421 = h_variable_9804[1,92];
h_variable_11421;
matrix h_variable_11422[1][1] = 0;
matrix h_variable_11423[1][3] = concat(h_variable_11422,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11423); matrix h_variable_11424 = h_variable_l[1]; matrix h_variable_11425 = h_variable_l[2];
ncols(h_variable_11424);
matrix h_variable_11426 = DecideZeroRows(h_variable_11424,h_variable_58);
IsZeroMatrix(h_variable_11426);
nrows(h_variable_11425);
def h_variable_11427 = h_variable_9804[1,93];
h_variable_11427;
matrix h_variable_11428[1][1] = 0;
matrix h_variable_11429[1][3] = concat(h_variable_11428,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11429); matrix h_variable_11430 = h_variable_l[1]; matrix h_variable_11431 = h_variable_l[2];
ncols(h_variable_11430);
matrix h_variable_11432 = DecideZeroRows(h_variable_11430,h_variable_58);
IsZeroMatrix(h_variable_11432);
nrows(h_variable_11431);
def h_variable_11433 = h_variable_9804[1,94];
h_variable_11433;
matrix h_variable_11434[1][1] = 0;
matrix h_variable_11435[1][3] = concat(h_variable_11434,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11435); matrix h_variable_11436 = h_variable_l[1]; matrix h_variable_11437 = h_variable_l[2];
ncols(h_variable_11436);
matrix h_variable_11438 = DecideZeroRows(h_variable_11436,h_variable_58);
IsZeroMatrix(h_variable_11438);
nrows(h_variable_11437);
def h_variable_11439 = h_variable_9804[1,95];
h_variable_11439;
matrix h_variable_11440[1][1] = 0;
matrix h_variable_11441[1][3] = concat(h_variable_11440,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11441); matrix h_variable_11442 = h_variable_l[1]; matrix h_variable_11443 = h_variable_l[2];
ncols(h_variable_11442);
matrix h_variable_11444 = DecideZeroRows(h_variable_11442,h_variable_58);
IsZeroMatrix(h_variable_11444);
nrows(h_variable_11443);
def h_variable_11445 = h_variable_9804[1,96];
h_variable_11445;
matrix h_variable_11446[1][1] = 0;
matrix h_variable_11447[1][3] = concat(h_variable_11446,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11447); matrix h_variable_11448 = h_variable_l[1]; matrix h_variable_11449 = h_variable_l[2];
ncols(h_variable_11448);
matrix h_variable_11450 = DecideZeroRows(h_variable_11448,h_variable_58);
IsZeroMatrix(h_variable_11450);
nrows(h_variable_11449);
def h_variable_11451 = h_variable_9804[1,97];
h_variable_11451;
matrix h_variable_11452[1][1] = 0;
matrix h_variable_11453[1][3] = concat(h_variable_11452,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11453); matrix h_variable_11454 = h_variable_l[1]; matrix h_variable_11455 = h_variable_l[2];
ncols(h_variable_11454);
matrix h_variable_11456 = DecideZeroRows(h_variable_11454,h_variable_58);
IsZeroMatrix(h_variable_11456);
nrows(h_variable_11455);
def h_variable_11457 = h_variable_9804[1,98];
h_variable_11457;
matrix h_variable_11458[1][1] = 0;
matrix h_variable_11459[1][3] = concat(h_variable_11458,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11459); matrix h_variable_11460 = h_variable_l[1]; matrix h_variable_11461 = h_variable_l[2];
ncols(h_variable_11460);
matrix h_variable_11462 = DecideZeroRows(h_variable_11460,h_variable_58);
IsZeroMatrix(h_variable_11462);
nrows(h_variable_11461);
def h_variable_11463 = h_variable_9804[1,99];
h_variable_11463;
matrix h_variable_11464[1][1] = 0;
matrix h_variable_11465[1][3] = concat(h_variable_11464,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11465); matrix h_variable_11466 = h_variable_l[1]; matrix h_variable_11467 = h_variable_l[2];
ncols(h_variable_11466);
matrix h_variable_11468 = DecideZeroRows(h_variable_11466,h_variable_58);
IsZeroMatrix(h_variable_11468);
nrows(h_variable_11467);
def h_variable_11469 = h_variable_9804[1,100];
h_variable_11469;
matrix h_variable_11470[1][1] = 0;
matrix h_variable_11471[1][3] = concat(h_variable_11470,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11471); matrix h_variable_11472 = h_variable_l[1]; matrix h_variable_11473 = h_variable_l[2];
ncols(h_variable_11472);
matrix h_variable_11474 = DecideZeroRows(h_variable_11472,h_variable_58);
IsZeroMatrix(h_variable_11474);
nrows(h_variable_11473);
def h_variable_11475 = h_variable_9804[1,101];
h_variable_11475;
matrix h_variable_11476[1][1] = 0;
matrix h_variable_11477[1][3] = concat(h_variable_11476,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11477); matrix h_variable_11478 = h_variable_l[1]; matrix h_variable_11479 = h_variable_l[2];
ncols(h_variable_11478);
matrix h_variable_11480 = DecideZeroRows(h_variable_11478,h_variable_58);
IsZeroMatrix(h_variable_11480);
nrows(h_variable_11479);
def h_variable_11481 = h_variable_9804[1,102];
h_variable_11481;
matrix h_variable_11482[1][1] = 0;
matrix h_variable_11483[1][3] = concat(h_variable_11482,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11483); matrix h_variable_11484 = h_variable_l[1]; matrix h_variable_11485 = h_variable_l[2];
ncols(h_variable_11484);
matrix h_variable_11486 = DecideZeroRows(h_variable_11484,h_variable_58);
IsZeroMatrix(h_variable_11486);
nrows(h_variable_11485);
def h_variable_11487 = h_variable_9804[1,103];
h_variable_11487;
matrix h_variable_11488[1][1] = 0;
matrix h_variable_11489[1][3] = concat(h_variable_11488,h_variable_48);
list h_variable_l=BasisOfRowsCoeff(h_variable_11489); matrix h_variable_11490 = h_variable_l[1]; matrix h_variable_11491 = h_variable_l[2];
ncols(h_variable_11490);
matrix h_variable_11492 = DecideZeroRows(h_variable_11490,h_variable_58);
IsZeroMatrix(h_variable_11492);
nrows(h_variable_11491);
matrix h_variable_11494 = submat(h_variable_9797,1..3,intvec( 1, 2, 3, 4, 6, 7, 8 ));
matrix h_variable_11495[3][6] = dsum(h_variable_58,h_variable_58,h_variable_58);
matrix h_variable_11493 = DecideZeroRows(h_variable_11494,h_variable_11495);
IsZeroMatrix(h_variable_11493);
matrix h_variable_11497[3][6] = dsum(h_variable_48,h_variable_48,h_variable_48);
matrix h_variable_11496 = RelativeSyzygiesGeneratorsOfRows(h_variable_11493,h_variable_11497);
tst_status(1);$
